/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/common/htmlContent","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ae=function(me){for(var e=[],S=0,M=me.length;S<M;S++)e[S]=Re[me[S]];return e};define(Re[67],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=void 0;function S(L){return(m,h,E)=>{let A=null,D=null;if(typeof E.value=="function"?(A="value",D=E.value):typeof E.get=="function"&&(A="get",D=E.get),!D)throw new Error("not supported");E[A]=L(D,h)}}function M(L,m,h){let E=null,A=null;if(typeof h.value=="function"?(E="value",A=h.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(E="get",A=h.get),!A)throw new Error("not supported");const D=`$memoize$${m}`;h[E]=function(...l){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,l)}),this[D]}}e.$zh=M;function I(L,m,h){return S((E,A)=>{const D=`$debounce$${A}`,l=`$debounce$result$${A}`;return function(...$){this[l]||(this[l]=h?h():void 0),clearTimeout(this[D]),m&&(this[l]=m(this[l],...$),$=[this[l]]),this[D]=setTimeout(()=>{E.apply(this,$),this[l]=h?h():void 0},L)}})}e.$Ah=I;function R(L,m,h){return S((E,A)=>{const D=`$throttle$timer$${A}`,l=`$throttle$result$${A}`,$=`$throttle$lastRun$${A}`,p=`$throttle$pending$${A}`;return function(...r){if(this[l]||(this[l]=h?h():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),m&&(this[l]=m(this[l],...r)),this[p])return;const c=this[$]+L;c<=Date.now()?(this[$]=Date.now(),E.apply(this,[this[l]]),this[l]=h?h():void 0):(this[p]=!0,this[D]=setTimeout(()=>{this[p]=!1,this[$]=Date.now(),E.apply(this,[this[l]]),this[l]=h?h():void 0},c-Date.now()))}})}e.$Bh=R}),define(Re[88],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=e.$AN=void 0;class S{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$AN=S,e.$BN=new S("id#")}),define(Re[119],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function L(t,f=!1){let n=0;const w=t.length;let y="",d=0,b=16,P=0;function g(U){let C=0,N=0;for(;C<U;){const W=t.charCodeAt(n);if(W>=48&&W<=57)N=N*16+W-48;else if(W>=65&&W<=70)N=N*16+W-65+10;else if(W>=97&&W<=102)N=N*16+W-97+10;else break;n++,C++}return C<U&&(N=-1),N}function v(U){n=U,y="",d=0,b=16,P=0}function k(){const U=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&E(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&E(t.charCodeAt(n)))for(n++;n<t.length&&E(t.charCodeAt(n));)n++;else return P=3,t.substring(U,n);let C=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&E(t.charCodeAt(n))){for(n++;n<t.length&&E(t.charCodeAt(n));)n++;C=n}else P=3;return t.substring(U,C)}function F(){let U="",C=n;for(;;){if(n>=w){U+=t.substring(C,n),P=2;break}const N=t.charCodeAt(n);if(N===34){U+=t.substring(C,n),n++;break}if(N===92){if(U+=t.substring(C,n),n++,n>=w){P=2;break}switch(t.charCodeAt(n++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const se=g(4);se>=0?U+=String.fromCharCode(se):P=4;break}default:P=5}C=n;continue}if(N>=0&&N<=31)if(h(N)){U+=t.substring(C,n),P=2;break}else P=6;n++}return U}function O(){if(y="",P=0,d=n,n>=w)return d=w,b=17;let U=t.charCodeAt(n);if(m(U)){do n++,y+=String.fromCharCode(U),U=t.charCodeAt(n);while(m(U));return b=15}if(h(U))return n++,y+=String.fromCharCode(U),U===13&&t.charCodeAt(n)===10&&(n++,y+=`
`),b=14;switch(U){case 123:return n++,b=1;case 125:return n++,b=2;case 91:return n++,b=3;case 93:return n++,b=4;case 58:return n++,b=6;case 44:return n++,b=5;case 34:return n++,y=F(),b=10;case 47:{const C=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<w&&!h(t.charCodeAt(n));)n++;return y=t.substring(C,n),b=12}if(t.charCodeAt(n+1)===42){n+=2;const N=w-1;let W=!1;for(;n<N;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,W=!0;break}n++}return W||(n++,P=1),y=t.substring(C,n),b=13}return y+=String.fromCharCode(U),n++,b=16}case 45:if(y+=String.fromCharCode(U),n++,n===w||!E(t.charCodeAt(n)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return y+=k(),b=11;default:for(;n<w&&G(U);)n++,U=t.charCodeAt(n);if(d!==n){switch(y=t.substring(d,n),y){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return y+=String.fromCharCode(U),n++,b=16}}function G(U){if(m(U)||h(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let U;do U=O();while(U>=12&&U<=15);return U}return{setPosition:v,getPosition:()=>n,scan:f?q:O,getToken:()=>b,getTokenValue:()=>y,getTokenOffset:()=>d,getTokenLength:()=>n-d,getTokenError:()=>P}}e.$dn=L;function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function D(t,f){const n=[],w=new Object;let y;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function P(g,v,k,F){d.value=g,d.offset=v,d.length=k,d.type=F,d.colonOffset=void 0,y=d}try{o(t,{onObjectBegin:(g,v)=>{if(f<=g)throw w;y=void 0,b=f>g,n.push("")},onObjectProperty:(g,v,k)=>{if(f<v||(P(g,v,k,"property"),n[n.length-1]=g,f<=v+k))throw w},onObjectEnd:(g,v)=>{if(f<=g)throw w;y=void 0,n.pop()},onArrayBegin:(g,v)=>{if(f<=g)throw w;y=void 0,n.push(0)},onArrayEnd:(g,v)=>{if(f<=g)throw w;y=void 0,n.pop()},onLiteralValue:(g,v,k)=>{if(f<v||(P(g,v,k,u(g)),f<=v+k))throw w},onSeparator:(g,v,k)=>{if(f<=v)throw w;if(g===":"&&y&&y.type==="property")y.colonOffset=v,b=!1,y=void 0;else if(g===","){const F=n[n.length-1];typeof F=="number"?n[n.length-1]=F+1:(b=!0,n[n.length-1]=""),y=void 0}}})}catch(g){if(g!==w)throw g}return{path:n,previousNode:y,isAtPropertyKey:b,matches:g=>{let v=0;for(let k=0;v<g.length&&k<n.length;k++)if(g[v]===n[k]||g[v]==="*")v++;else if(g[v]!=="**")return!1;return v===g.length}}}e.$en=D;function l(t,f=[],n=R.DEFAULT){let w=null,y=[];const d=[];function b(g){Array.isArray(y)?y.push(g):w!==null&&(y[w]=g)}return o(t,{onObjectBegin:()=>{const g={};b(g),d.push(y),y=g,w=null},onObjectProperty:g=>{w=g},onObjectEnd:()=>{y=d.pop()},onArrayBegin:()=>{const g=[];b(g),d.push(y),y=g,w=null},onArrayEnd:()=>{y=d.pop()},onLiteralValue:b,onError:(g,v,k)=>{f.push({error:g,offset:v,length:k})}},n),y[0]}e.$fn=l;function $(t,f=[],n=R.DEFAULT){let w={type:"array",offset:-1,length:-1,children:[],parent:void 0};function y(g){w.type==="property"&&(w.length=g-w.offset,w=w.parent)}function d(g){return w.children.push(g),g}o(t,{onObjectBegin:g=>{w=d({type:"object",offset:g,length:-1,parent:w,children:[]})},onObjectProperty:(g,v,k)=>{w=d({type:"property",offset:v,length:-1,parent:w,children:[]}),w.children.push({type:"string",value:g,offset:v,length:k,parent:w})},onObjectEnd:(g,v)=>{w.length=g+v-w.offset,w=w.parent,y(g+v)},onArrayBegin:(g,v)=>{w=d({type:"array",offset:g,length:-1,parent:w,children:[]})},onArrayEnd:(g,v)=>{w.length=g+v-w.offset,w=w.parent,y(g+v)},onLiteralValue:(g,v,k)=>{d({type:u(g),offset:v,length:k,parent:w,value:g}),y(v+k)},onSeparator:(g,v,k)=>{w.type==="property"&&(g===":"?w.colonOffset=v:g===","&&y(v))},onError:(g,v,k)=>{f.push({error:g,offset:v,length:k})}},n);const P=w.children[0];return P&&delete P.parent,P}e.$gn=$;function p(t,f){if(!t)return;let n=t;for(const w of f)if(typeof w=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let y=!1;for(const d of n.children)if(Array.isArray(d.children)&&d.children[0].value===w){n=d.children[1],y=!0;break}if(!y)return}else{const y=w;if(n.type!=="array"||y<0||!Array.isArray(n.children)||y>=n.children.length)return;n=n.children[y]}return n}e.$hn=p;function r(t){if(!t.parent||!t.parent.children)return[];const f=r(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;f.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&f.push(n)}return f}e.$in=r;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const f=Object.create(null);for(const n of t.children){const w=n.children[1];w&&(f[n.children[0].value]=c(w))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$jn=c;function s(t,f,n=!1){return f>=t.offset&&f<t.offset+t.length||n&&f===t.offset+t.length}e.$kn=s;function i(t,f,n=!1){if(s(t,f,n)){const w=t.children;if(Array.isArray(w))for(let y=0;y<w.length&&w[y].offset<=f;y++){const d=i(w[y],f,n);if(d)return d}return t}}e.$ln=i;function o(t,f,n=R.DEFAULT){const w=L(t,!1);function y(oe){return oe?()=>oe(w.getTokenOffset(),w.getTokenLength()):()=>!0}function d(oe){return oe?$e=>oe($e,w.getTokenOffset(),w.getTokenLength()):()=>!0}const b=y(f.onObjectBegin),P=d(f.onObjectProperty),g=y(f.onObjectEnd),v=y(f.onArrayBegin),k=y(f.onArrayEnd),F=d(f.onLiteralValue),O=d(f.onSeparator),G=y(f.onComment),q=d(f.onError),U=n&&n.disallowComments,C=n&&n.allowTrailingComma;function N(){for(;;){const oe=w.scan();switch(w.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:U||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(oe){case 12:case 13:U?W(10):G();break;case 16:W(1);break;case 15:case 14:break;default:return oe}}}function W(oe,$e=[],ie=[]){if(q(oe),$e.length+ie.length>0){let x=w.getToken();for(;x!==17;){if($e.indexOf(x)!==-1){N();break}else if(ie.indexOf(x)!==-1)break;x=N()}}}function se(oe){const $e=w.getTokenValue();return oe?F($e):P($e),N(),!0}function le(){switch(w.getToken()){case 11:{let oe=0;try{oe=JSON.parse(w.getTokenValue()),typeof oe!="number"&&(W(2),oe=0)}catch{W(2)}F(oe);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return N(),!0}function Ee(){return w.getToken()!==10?(W(3,[],[2,5]),!1):(se(!1),w.getToken()===6?(O(":"),N(),pe()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function De(){b(),N();let oe=!1;for(;w.getToken()!==2&&w.getToken()!==17;){if(w.getToken()===5){if(oe||W(4,[],[]),O(","),N(),w.getToken()===2&&C)break}else oe&&W(6,[],[]);Ee()||W(4,[],[2,5]),oe=!0}return g(),w.getToken()!==2?W(7,[2],[]):N(),!0}function ce(){v(),N();let oe=!1;for(;w.getToken()!==4&&w.getToken()!==17;){if(w.getToken()===5){if(oe||W(4,[],[]),O(","),N(),w.getToken()===4&&C)break}else oe&&W(6,[],[]);pe()||W(4,[],[4,5]),oe=!0}return k(),w.getToken()!==4?W(8,[4],[]):N(),!0}function pe(){switch(w.getToken()){case 3:return ce();case 1:return De();case 10:return se(!0);default:return le()}}return N(),w.getToken()===17?n.allowEmptyContent?!0:(W(4,[],[]),!1):pe()?(w.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.$mn=o;function a(t,f){const n=L(t),w=[];let y,d=0,b;do switch(b=n.getPosition(),y=n.scan(),y){case 12:case 13:case 17:d!==b&&w.push(t.substring(d,b)),f!==void 0&&w.push(n.getTokenValue().replace(/[^\r\n]/g,f)),d=n.getPosition();break}while(y!==17);return w.join("")}e.$nn=a;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$on=u}),function(me,e){typeof define=="function"&&define.amd?define(Re[120],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(Le,we){for(var ge=0;ge<we.length;ge++){var K=we[ge];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(Le,K.key,K)}}function S(Le,we,ge){return we&&e(Le.prototype,we),ge&&e(Le,ge),Object.defineProperty(Le,"prototype",{writable:!1}),Le}function M(Le,we){if(Le){if(typeof Le=="string")return I(Le,we);var ge=Object.prototype.toString.call(Le).slice(8,-1);if(ge==="Object"&&Le.constructor&&(ge=Le.constructor.name),ge==="Map"||ge==="Set")return Array.from(Le);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return I(Le,we)}}function I(Le,we){(we==null||we>Le.length)&&(we=Le.length);for(var ge=0,K=new Array(we);ge<we;ge++)K[ge]=Le[ge];return K}function R(Le,we){var ge=typeof Symbol<"u"&&Le[Symbol.iterator]||Le["@@iterator"];if(ge)return(ge=ge.call(Le)).next.bind(ge);if(Array.isArray(Le)||(ge=M(Le))||we&&Le&&typeof Le.length=="number"){ge&&(Le=ge);var K=0;return function(){return K>=Le.length?{done:!0}:{done:!1,value:Le[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=L();function m(Le){me.defaults=Le}var h=/[&<>"']/,E=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},$=function(we){return l[we]};function p(Le,we){if(we){if(h.test(Le))return Le.replace(E,$)}else if(A.test(Le))return Le.replace(D,$);return Le}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(Le){return Le.replace(r,function(we,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var s=/(^|[^\[])\^/g;function i(Le,we){Le=typeof Le=="string"?Le:Le.source,we=we||"";var ge={replace:function(ee,he){return he=he.source||he,he=he.replace(s,"$1"),Le=Le.replace(ee,he),ge},getRegex:function(){return new RegExp(Le,we)}};return ge}var o=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(Le,we,ge){if(Le){var K;try{K=decodeURIComponent(c(ge)).replace(o,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}we&&!a.test(ge)&&(ge=y(we,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var t={},f=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,w=/^([^:]+:\/*[^/]*)[\s\S]*$/;function y(Le,we){t[" "+Le]||(f.test(Le)?t[" "+Le]=Le+"/":t[" "+Le]=g(Le,"/",!0)),Le=t[" "+Le];var ge=Le.indexOf(":")===-1;return we.substring(0,2)==="//"?ge?we:Le.replace(n,"$1")+we:we.charAt(0)==="/"?ge?we:Le.replace(w,"$1")+we:Le+we}var d={exec:function(){}};function b(Le){for(var we=1,ge,K;we<arguments.length;we++){ge=arguments[we];for(K in ge)Object.prototype.hasOwnProperty.call(ge,K)&&(Le[K]=ge[K])}return Le}function P(Le,we){var ge=Le.replace(/\|/g,function(he,fe,Ce){for(var de=!1,ye=fe;--ye>=0&&Ce[ye]==="\\";)de=!de;return de?"|":" |"}),K=ge.split(/ \|/),ee=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>we)K.splice(we);else for(;K.length<we;)K.push("");for(;ee<K.length;ee++)K[ee]=K[ee].trim().replace(/\\\|/g,"|");return K}function g(Le,we,ge){var K=Le.length;if(K===0)return"";for(var ee=0;ee<K;){var he=Le.charAt(K-ee-1);if(he===we&&!ge)ee++;else if(he!==we&&ge)ee++;else break}return Le.slice(0,K-ee)}function v(Le,we){if(Le.indexOf(we[1])===-1)return-1;for(var ge=Le.length,K=0,ee=0;ee<ge;ee++)if(Le[ee]==="\\")ee++;else if(Le[ee]===we[0])K++;else if(Le[ee]===we[1]&&(K--,K<0))return ee;return-1}function k(Le){Le&&Le.sanitize&&!Le.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(Le,we){if(we<1)return"";for(var ge="";we>1;)we&1&&(ge+=Le),we>>=1,Le+=Le;return ge+Le}function O(Le,we,ge,K){var ee=we.href,he=we.title?p(we.title):null,fe=Le[1].replace(/\\([\[\]])/g,"$1");if(Le[0].charAt(0)!=="!"){K.state.inLink=!0;var Ce={type:"link",raw:ge,href:ee,title:he,text:fe,tokens:K.inlineTokens(fe)};return K.state.inLink=!1,Ce}return{type:"image",raw:ge,href:ee,title:he,text:p(fe)}}function G(Le,we){var ge=Le.match(/^(\s+)(?:```)/);if(ge===null)return we;var K=ge[1];return we.split(`
`).map(function(ee){var he=ee.match(/^\s+/);if(he===null)return ee;var fe=he[0];return fe.length>=K.length?ee.slice(K.length):ee}).join(`
`)}var q=function(){function Le(ge){this.options=ge||me.defaults}var we=Le.prototype;return we.space=function(K){var ee=this.rules.block.newline.exec(K);if(ee&&ee[0].length>0)return{type:"space",raw:ee[0]}},we.code=function(K){var ee=this.rules.block.code.exec(K);if(ee){var he=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?he:g(he,`
`)}}},we.fences=function(K){var ee=this.rules.block.fences.exec(K);if(ee){var he=ee[0],fe=G(he,ee[3]||"");return{type:"code",raw:he,lang:ee[2]?ee[2].trim():ee[2],text:fe}}},we.heading=function(K){var ee=this.rules.block.heading.exec(K);if(ee){var he=ee[2].trim();if(/#$/.test(he)){var fe=g(he,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(he=fe.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:he,tokens:this.lexer.inline(he)}}},we.hr=function(K){var ee=this.rules.block.hr.exec(K);if(ee)return{type:"hr",raw:ee[0]}},we.blockquote=function(K){var ee=this.rules.block.blockquote.exec(K);if(ee){var he=ee[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ee[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},we.list=function(K){var ee=this.rules.block.list.exec(K);if(ee){var he,fe,Ce,de,ye,T,H,J,B,Z,_,ke,Ne=ee[1].trim(),We=Ne.length>1,He={type:"list",raw:"",ordered:We,start:We?+Ne.slice(0,-1):"",loose:!1,items:[]};Ne=We?"\\d{1,9}\\"+Ne.slice(-1):"\\"+Ne,this.options.pedantic&&(Ne=We?Ne:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+Ne+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(ke=!1,!(!(ee=Ye.exec(K))||this.rules.block.hr.test(K)));){if(he=ee[0],K=K.substring(he.length),J=ee[2].split(`
`,1)[0],B=K.split(`
`,1)[0],this.options.pedantic?(de=2,_=J.trimLeft()):(de=ee[2].search(/[^ ]/),de=de>4?1:de,_=J.slice(de),de+=ee[1].length),T=!1,!J&&/^ *$/.test(B)&&(he+=B+`
`,K=K.substring(B.length+1),ke=!0),!ke)for(var nt=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");K&&(Z=K.split(`
`,1)[0],J=Z,this.options.pedantic&&(J=J.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(J)||st.test(J)||nt.test(J)||it.test(K)));){if(J.search(/[^ ]/)>=de||!J.trim())_+=`
`+J.slice(de);else if(!T)_+=`
`+J;else break;!T&&!J.trim()&&(T=!0),he+=Z+`
`,K=K.substring(Z.length+1)}He.loose||(H?He.loose=!0:/\n *\n *$/.test(he)&&(H=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(_),fe&&(Ce=fe[0]!=="[ ] ",_=_.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:he,task:!!fe,checked:Ce,loose:!1,text:_}),He.raw+=he}He.items[He.items.length-1].raw=he.trimRight(),He.items[He.items.length-1].text=_.trimRight(),He.raw=He.raw.trimRight();var ct=He.items.length;for(ye=0;ye<ct;ye++){this.lexer.state.top=!1,He.items[ye].tokens=this.lexer.blockTokens(He.items[ye].text,[]);var Ue=He.items[ye].tokens.filter(function(Y){return Y.type==="space"}),$t=Ue.every(function(Y){for(var X=Y.raw.split(""),ve=0,Be=R(X),Qe;!(Qe=Be()).done;){var tt=Qe.value;if(tt===`
`&&(ve+=1),ve>1)return!0}return!1});!He.loose&&Ue.length&&$t&&(He.loose=!0,He.items[ye].loose=!0)}return He}},we.html=function(K){var ee=this.rules.block.html.exec(K);if(ee){var he={type:"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:ee[0]};if(this.options.sanitize){var fe=this.options.sanitizer?this.options.sanitizer(ee[0]):p(ee[0]);he.type="paragraph",he.text=fe,he.tokens=this.lexer.inline(fe)}return he}},we.def=function(K){var ee=this.rules.block.def.exec(K);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var he=ee[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:ee[0],href:ee[2],title:ee[3]}}},we.table=function(K){var ee=this.rules.block.table.exec(K);if(ee){var he={type:"table",header:P(ee[1]).map(function(H){return{text:H}}),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ee[3]&&ee[3].trim()?ee[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=ee[0];var fe=he.align.length,Ce,de,ye,T;for(Ce=0;Ce<fe;Ce++)/^ *-+: *$/.test(he.align[Ce])?he.align[Ce]="right":/^ *:-+: *$/.test(he.align[Ce])?he.align[Ce]="center":/^ *:-+ *$/.test(he.align[Ce])?he.align[Ce]="left":he.align[Ce]=null;for(fe=he.rows.length,Ce=0;Ce<fe;Ce++)he.rows[Ce]=P(he.rows[Ce],he.header.length).map(function(H){return{text:H}});for(fe=he.header.length,de=0;de<fe;de++)he.header[de].tokens=this.lexer.inline(he.header[de].text);for(fe=he.rows.length,de=0;de<fe;de++)for(T=he.rows[de],ye=0;ye<T.length;ye++)T[ye].tokens=this.lexer.inline(T[ye].text);return he}}},we.lheading=function(K){var ee=this.rules.block.lheading.exec(K);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1],tokens:this.lexer.inline(ee[1])}},we.paragraph=function(K){var ee=this.rules.block.paragraph.exec(K);if(ee){var he=ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1];return{type:"paragraph",raw:ee[0],text:he,tokens:this.lexer.inline(he)}}},we.text=function(K){var ee=this.rules.block.text.exec(K);if(ee)return{type:"text",raw:ee[0],text:ee[0],tokens:this.lexer.inline(ee[0])}},we.escape=function(K){var ee=this.rules.inline.escape.exec(K);if(ee)return{type:"escape",raw:ee[0],text:p(ee[1])}},we.tag=function(K){var ee=this.rules.inline.tag.exec(K);if(ee)return!this.lexer.state.inLink&&/^<a /i.test(ee[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ee[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):p(ee[0]):ee[0]}},we.link=function(K){var ee=this.rules.inline.link.exec(K);if(ee){var he=ee[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var fe=g(he.slice(0,-1),"\\");if((he.length-fe.length)%2===0)return}else{var Ce=v(ee[2],"()");if(Ce>-1){var de=ee[0].indexOf("!")===0?5:4,ye=de+ee[1].length+Ce;ee[2]=ee[2].substring(0,Ce),ee[0]=ee[0].substring(0,ye).trim(),ee[3]=""}}var T=ee[2],H="";if(this.options.pedantic){var J=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(T);J&&(T=J[1],H=J[3])}else H=ee[3]?ee[3].slice(1,-1):"";return T=T.trim(),/^</.test(T)&&(this.options.pedantic&&!/>$/.test(he)?T=T.slice(1):T=T.slice(1,-1)),O(ee,{href:T&&T.replace(this.rules.inline._escapes,"$1"),title:H&&H.replace(this.rules.inline._escapes,"$1")},ee[0],this.lexer)}},we.reflink=function(K,ee){var he;if((he=this.rules.inline.reflink.exec(K))||(he=this.rules.inline.nolink.exec(K))){var fe=(he[2]||he[1]).replace(/\s+/g," ");if(fe=ee[fe.toLowerCase()],!fe||!fe.href){var Ce=he[0].charAt(0);return{type:"text",raw:Ce,text:Ce}}return O(he,fe,he[0],this.lexer)}},we.emStrong=function(K,ee,he){he===void 0&&(he="");var fe=this.rules.inline.emStrong.lDelim.exec(K);if(fe&&!(fe[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ce=fe[1]||fe[2]||"";if(!Ce||Ce&&(he===""||this.rules.inline.punctuation.exec(he))){var de=fe[0].length-1,ye,T,H=de,J=0,B=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(B.lastIndex=0,ee=ee.slice(-1*K.length+de);(fe=B.exec(ee))!=null;)if(ye=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!ye){if(T=ye.length,fe[3]||fe[4]){H+=T;continue}else if((fe[5]||fe[6])&&de%3&&!((de+T)%3)){J+=T;continue}if(H-=T,!(H>0)){if(T=Math.min(T,T+H+J),Math.min(de,T)%2){var Z=K.slice(1,de+fe.index+T);return{type:"em",raw:K.slice(0,de+fe.index+T+1),text:Z,tokens:this.lexer.inlineTokens(Z)}}var _=K.slice(2,de+fe.index+T-1);return{type:"strong",raw:K.slice(0,de+fe.index+T+1),text:_,tokens:this.lexer.inlineTokens(_)}}}}}},we.codespan=function(K){var ee=this.rules.inline.code.exec(K);if(ee){var he=ee[2].replace(/\n/g," "),fe=/[^ ]/.test(he),Ce=/^ /.test(he)&&/ $/.test(he);return fe&&Ce&&(he=he.substring(1,he.length-1)),he=p(he,!0),{type:"codespan",raw:ee[0],text:he}}},we.br=function(K){var ee=this.rules.inline.br.exec(K);if(ee)return{type:"br",raw:ee[0]}},we.del=function(K){var ee=this.rules.inline.del.exec(K);if(ee)return{type:"del",raw:ee[0],text:ee[2],tokens:this.lexer.inlineTokens(ee[2])}},we.autolink=function(K,ee){var he=this.rules.inline.autolink.exec(K);if(he){var fe,Ce;return he[2]==="@"?(fe=p(this.options.mangle?ee(he[1]):he[1]),Ce="mailto:"+fe):(fe=p(he[1]),Ce=fe),{type:"link",raw:he[0],text:fe,href:Ce,tokens:[{type:"text",raw:fe,text:fe}]}}},we.url=function(K,ee){var he;if(he=this.rules.inline.url.exec(K)){var fe,Ce;if(he[2]==="@")fe=p(this.options.mangle?ee(he[0]):he[0]),Ce="mailto:"+fe;else{var de;do de=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(de!==he[0]);fe=p(he[0]),he[1]==="www."?Ce="http://"+fe:Ce=fe}return{type:"link",raw:he[0],text:fe,href:Ce,tokens:[{type:"text",raw:fe,text:fe}]}}},we.inlineText=function(K,ee){var he=this.rules.inline.text.exec(K);if(he){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):p(he[0]):he[0]:fe=p(this.options.smartypants?ee(he[0]):he[0]),{type:"text",raw:he[0],text:fe}}},Le}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=i(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=i(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=i(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=i(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=i(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=i(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=b({},U),U.gfm=b({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=i(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=i(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=b({},U.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:i(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var C={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};C._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",C.punctuation=i(C.punctuation).replace(/punctuation/g,C._punctuation).getRegex(),C.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,C.escapedEmSt=/\\\*|\\_/g,C._comment=i(U._comment).replace("(?:-->|$)","-->").getRegex(),C.emStrong.lDelim=i(C.emStrong.lDelim).replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimAst=i(C.emStrong.rDelimAst,"g").replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimUnd=i(C.emStrong.rDelimUnd,"g").replace(/punct/g,C._punctuation).getRegex(),C._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,C._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,C._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,C.autolink=i(C.autolink).replace("scheme",C._scheme).replace("email",C._email).getRegex(),C._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,C.tag=i(C.tag).replace("comment",C._comment).replace("attribute",C._attribute).getRegex(),C._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,C._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,C._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,C.link=i(C.link).replace("label",C._label).replace("href",C._href).replace("title",C._title).getRegex(),C.reflink=i(C.reflink).replace("label",C._label).replace("ref",U._label).getRegex(),C.nolink=i(C.nolink).replace("ref",U._label).getRegex(),C.reflinkSearch=i(C.reflinkSearch,"g").replace("reflink",C.reflink).replace("nolink",C.nolink).getRegex(),C.normal=b({},C),C.pedantic=b({},C.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",C._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",C._label).getRegex()}),C.gfm=b({},C.normal,{escape:i(C.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),C.gfm.url=i(C.gfm.url,"i").replace("email",C.gfm._extended_email).getRegex(),C.breaks=b({},C.gfm,{br:i(C.br).replace("{2,}","*").getRegex(),text:i(C.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(Le){return Le.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(Le){var we="",ge,K,ee=Le.length;for(ge=0;ge<ee;ge++)K=Le.charCodeAt(ge),Math.random()>.5&&(K="x"+K.toString(16)),we+="&#"+K+";";return we}var se=function(){function Le(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||me.defaults,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:U.normal,inline:C.normal};this.options.pedantic?(K.block=U.pedantic,K.inline=C.pedantic):this.options.gfm&&(K.block=U.gfm,this.options.breaks?K.inline=C.breaks:K.inline=C.gfm),this.tokenizer.rules=K}Le.lex=function(K,ee){var he=new Le(ee);return he.lex(K)},Le.lexInline=function(K,ee){var he=new Le(ee);return he.inlineTokens(K)};var we=Le.prototype;return we.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var ee;ee=this.inlineQueue.shift();)this.inlineTokens(ee.src,ee.tokens);return this.tokens},we.blockTokens=function(K,ee){var he=this;ee===void 0&&(ee=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(H,J,B){return J+"    ".repeat(B.length)});for(var fe,Ce,de,ye;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(H){return(fe=H.call({lexer:he},K,ee))?(K=K.substring(fe.raw.length),ee.push(fe),!0):!1}))){if(fe=this.tokenizer.space(K)){K=K.substring(fe.raw.length),fe.raw.length===1&&ee.length>0?ee[ee.length-1].raw+=`
`:ee.push(fe);continue}if(fe=this.tokenizer.code(K)){K=K.substring(fe.raw.length),Ce=ee[ee.length-1],Ce&&(Ce.type==="paragraph"||Ce.type==="text")?(Ce.raw+=`
`+fe.raw,Ce.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ce.text):ee.push(fe);continue}if(fe=this.tokenizer.fences(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.heading(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.hr(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.blockquote(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.list(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.html(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.def(K)){K=K.substring(fe.raw.length),Ce=ee[ee.length-1],Ce&&(Ce.type==="paragraph"||Ce.type==="text")?(Ce.raw+=`
`+fe.raw,Ce.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ce.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.lheading(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(de=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var H=1/0,J=K.slice(1),B=void 0;he.options.extensions.startBlock.forEach(function(Z){B=Z.call({lexer:this},J),typeof B=="number"&&B>=0&&(H=Math.min(H,B))}),H<1/0&&H>=0&&(de=K.substring(0,H+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(de))){Ce=ee[ee.length-1],ye&&Ce.type==="paragraph"?(Ce.raw+=`
`+fe.raw,Ce.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ce.text):ee.push(fe),ye=de.length!==K.length,K=K.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(K)){K=K.substring(fe.raw.length),Ce=ee[ee.length-1],Ce&&Ce.type==="text"?(Ce.raw+=`
`+fe.raw,Ce.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ce.text):ee.push(fe);continue}if(K){var T="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(T);break}else throw new Error(T)}}return this.state.top=!0,ee},we.inline=function(K,ee){return ee===void 0&&(ee=[]),this.inlineQueue.push({src:K,tokens:ee}),ee},we.inlineTokens=function(K,ee){var he=this;ee===void 0&&(ee=[]);var fe,Ce,de,ye=K,T,H,J;if(this.tokens.links){var B=Object.keys(this.tokens.links);if(B.length>0)for(;(T=this.tokenizer.rules.inline.reflinkSearch.exec(ye))!=null;)B.includes(T[0].slice(T[0].lastIndexOf("[")+1,-1))&&(ye=ye.slice(0,T.index)+"["+F("a",T[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(T=this.tokenizer.rules.inline.blockSkip.exec(ye))!=null;)ye=ye.slice(0,T.index)+"["+F("a",T[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(T=this.tokenizer.rules.inline.escapedEmSt.exec(ye))!=null;)ye=ye.slice(0,T.index)+"++"+ye.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(H||(J=""),H=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(_){return(fe=_.call({lexer:he},K,ee))?(K=K.substring(fe.raw.length),ee.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.tag(K)){K=K.substring(fe.raw.length),Ce=ee[ee.length-1],Ce&&fe.type==="text"&&Ce.type==="text"?(Ce.raw+=fe.raw,Ce.text+=fe.text):ee.push(fe);continue}if(fe=this.tokenizer.link(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(fe.raw.length),Ce=ee[ee.length-1],Ce&&fe.type==="text"&&Ce.type==="text"?(Ce.raw+=fe.raw,Ce.text+=fe.text):ee.push(fe);continue}if(fe=this.tokenizer.emStrong(K,ye,J)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.codespan(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.br(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.del(K)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(fe=this.tokenizer.autolink(K,W)){K=K.substring(fe.raw.length),ee.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(K,W))){K=K.substring(fe.raw.length),ee.push(fe);continue}if(de=K,this.options.extensions&&this.options.extensions.startInline&&function(){var _=1/0,ke=K.slice(1),Ne=void 0;he.options.extensions.startInline.forEach(function(We){Ne=We.call({lexer:this},ke),typeof Ne=="number"&&Ne>=0&&(_=Math.min(_,Ne))}),_<1/0&&_>=0&&(de=K.substring(0,_+1))}(),fe=this.tokenizer.inlineText(de,N)){K=K.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(J=fe.raw.slice(-1)),H=!0,Ce=ee[ee.length-1],Ce&&Ce.type==="text"?(Ce.raw+=fe.raw,Ce.text+=fe.text):ee.push(fe);continue}if(K){var Z="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return ee},S(Le,null,[{key:"rules",get:function(){return{block:U,inline:C}}}]),Le}(),le=function(){function Le(ge){this.options=ge||me.defaults}var we=Le.prototype;return we.code=function(K,ee,he){var fe=(ee||"").match(/\S*/)[0];if(this.options.highlight){var Ce=this.options.highlight(K,fe);Ce!=null&&Ce!==K&&(he=!0,K=Ce)}return K=K.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+p(fe,!0)+'">'+(he?K:p(K,!0))+`</code></pre>
`:"<pre><code>"+(he?K:p(K,!0))+`</code></pre>
`},we.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},we.html=function(K){return K},we.heading=function(K,ee,he,fe){if(this.options.headerIds){var Ce=this.options.headerPrefix+fe.slug(he);return"<h"+ee+' id="'+Ce+'">'+K+"</h"+ee+`>
`}return"<h"+ee+">"+K+"</h"+ee+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(K,ee,he){var fe=ee?"ol":"ul",Ce=ee&&he!==1?' start="'+he+'"':"";return"<"+fe+Ce+`>
`+K+"</"+fe+`>
`},we.listitem=function(K){return"<li>"+K+`</li>
`},we.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(K){return"<p>"+K+`</p>
`},we.table=function(K,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+ee+`</table>
`},we.tablerow=function(K){return`<tr>
`+K+`</tr>
`},we.tablecell=function(K,ee){var he=ee.header?"th":"td",fe=ee.align?"<"+he+' align="'+ee.align+'">':"<"+he+">";return fe+K+("</"+he+`>
`)},we.strong=function(K){return"<strong>"+K+"</strong>"},we.em=function(K){return"<em>"+K+"</em>"},we.codespan=function(K){return"<code>"+K+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(K){return"<del>"+K+"</del>"},we.link=function(K,ee,he){if(K=u(this.options.sanitize,this.options.baseUrl,K),K===null)return he;var fe='<a href="'+p(K)+'"';return ee&&(fe+=' title="'+ee+'"'),fe+=">"+he+"</a>",fe},we.image=function(K,ee,he){if(K=u(this.options.sanitize,this.options.baseUrl,K),K===null)return he;var fe='<img src="'+K+'" alt="'+he+'"';return ee&&(fe+=' title="'+ee+'"'),fe+=this.options.xhtml?"/>":">",fe},we.text=function(K){return K},Le}(),Ee=function(){function Le(){}var we=Le.prototype;return we.strong=function(K){return K},we.em=function(K){return K},we.codespan=function(K){return K},we.del=function(K){return K},we.html=function(K){return K},we.text=function(K){return K},we.link=function(K,ee,he){return""+he},we.image=function(K,ee,he){return""+he},we.br=function(){return""},Le}(),De=function(){function Le(){this.seen={}}var we=Le.prototype;return we.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(K,ee){var he=K,fe=0;if(this.seen.hasOwnProperty(he)){fe=this.seen[K];do fe++,he=K+"-"+fe;while(this.seen.hasOwnProperty(he))}return ee||(this.seen[K]=fe,this.seen[he]=0),he},we.slug=function(K,ee){ee===void 0&&(ee={});var he=this.serialize(K);return this.getNextSafeSlug(he,ee.dryrun)},Le}(),ce=function(){function Le(ge){this.options=ge||me.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ee,this.slugger=new De}Le.parse=function(K,ee){var he=new Le(ee);return he.parse(K)},Le.parseInline=function(K,ee){var he=new Le(ee);return he.parseInline(K)};var we=Le.prototype;return we.parse=function(K,ee){ee===void 0&&(ee=!0);var he="",fe,Ce,de,ye,T,H,J,B,Z,_,ke,Ne,We,He,Ye,nt,it,et,st,ct=K.length;for(fe=0;fe<ct;fe++){if(_=K[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_.type]&&(st=this.options.extensions.renderers[_.type].call({parser:this},_),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(_.type))){he+=st||"";continue}switch(_.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(_.tokens),_.depth,c(this.parseInline(_.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(_.text,_.lang,_.escaped);continue}case"table":{for(B="",J="",ye=_.header.length,Ce=0;Ce<ye;Ce++)J+=this.renderer.tablecell(this.parseInline(_.header[Ce].tokens),{header:!0,align:_.align[Ce]});for(B+=this.renderer.tablerow(J),Z="",ye=_.rows.length,Ce=0;Ce<ye;Ce++){for(H=_.rows[Ce],J="",T=H.length,de=0;de<T;de++)J+=this.renderer.tablecell(this.parseInline(H[de].tokens),{header:!1,align:_.align[de]});Z+=this.renderer.tablerow(J)}he+=this.renderer.table(B,Z);continue}case"blockquote":{Z=this.parse(_.tokens),he+=this.renderer.blockquote(Z);continue}case"list":{for(ke=_.ordered,Ne=_.start,We=_.loose,ye=_.items.length,Z="",Ce=0;Ce<ye;Ce++)Ye=_.items[Ce],nt=Ye.checked,it=Ye.task,He="",Ye.task&&(et=this.renderer.checkbox(nt),We?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=et+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=et+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:et}):He+=et),He+=this.parse(Ye.tokens,We),Z+=this.renderer.listitem(He,it,nt);he+=this.renderer.list(Z,ke,Ne);continue}case"html":{he+=this.renderer.html(_.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(_.tokens));continue}case"text":{for(Z=_.tokens?this.parseInline(_.tokens):_.text;fe+1<ct&&K[fe+1].type==="text";)_=K[++fe],Z+=`
`+(_.tokens?this.parseInline(_.tokens):_.text);he+=ee?this.renderer.paragraph(Z):Z;continue}default:{var Ue='Token with "'+_.type+'" type was not found.';if(this.options.silent){console.error(Ue);return}else throw new Error(Ue)}}}return he},we.parseInline=function(K,ee){ee=ee||this.renderer;var he="",fe,Ce,de,ye=K.length;for(fe=0;fe<ye;fe++){if(Ce=K[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ce.type]&&(de=this.options.extensions.renderers[Ce.type].call({parser:this},Ce),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ce.type))){he+=de||"";continue}switch(Ce.type){case"escape":{he+=ee.text(Ce.text);break}case"html":{he+=ee.html(Ce.text);break}case"link":{he+=ee.link(Ce.href,Ce.title,this.parseInline(Ce.tokens,ee));break}case"image":{he+=ee.image(Ce.href,Ce.title,Ce.text);break}case"strong":{he+=ee.strong(this.parseInline(Ce.tokens,ee));break}case"em":{he+=ee.em(this.parseInline(Ce.tokens,ee));break}case"codespan":{he+=ee.codespan(Ce.text);break}case"br":{he+=ee.br();break}case"del":{he+=ee.del(this.parseInline(Ce.tokens,ee));break}case"text":{he+=ee.text(Ce.text);break}default:{var T='Token with "'+Ce.type+'" type was not found.';if(this.options.silent){console.error(T);return}else throw new Error(T)}}}return he},Le}();function pe(Le,we,ge){if(typeof Le>"u"||Le===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Le!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Le)+", string expected");if(typeof we=="function"&&(ge=we,we=null),we=b({},pe.defaults,we||{}),k(we),ge){var K=we.highlight,ee;try{ee=se.lex(Le,we)}catch(ye){return ge(ye)}var he=function(T){var H;if(!T)try{we.walkTokens&&pe.walkTokens(ee,we.walkTokens),H=ce.parse(ee,we)}catch(J){T=J}return we.highlight=K,T?ge(T):ge(null,H)};if(!K||K.length<3||(delete we.highlight,!ee.length))return he();var fe=0;pe.walkTokens(ee,function(ye){ye.type==="code"&&(fe++,setTimeout(function(){K(ye.text,ye.lang,function(T,H){if(T)return he(T);H!=null&&H!==ye.text&&(ye.text=H,ye.escaped=!0),fe--,fe===0&&he()})},0))}),fe===0&&he();return}function Ce(ye){if(ye.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+p(ye.message+"",!0)+"</pre>";throw ye}try{var de=se.lex(Le,we);if(we.walkTokens){if(we.async)return Promise.all(pe.walkTokens(de,we.walkTokens)).then(function(){return ce.parse(de,we)}).catch(Ce);pe.walkTokens(de,we.walkTokens)}return ce.parse(de,we)}catch(ye){Ce(ye)}}pe.options=pe.setOptions=function(Le){return b(pe.defaults,Le),m(pe.defaults),pe},pe.getDefaults=L,pe.defaults=me.defaults,pe.use=function(){for(var Le=arguments.length,we=new Array(Le),ge=0;ge<Le;ge++)we[ge]=arguments[ge];var K=b.apply(void 0,[{}].concat(we)),ee=pe.defaults.extensions||{renderers:{},childTokens:{}},he;we.forEach(function(fe){if(fe.extensions&&(he=!0,fe.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var ye=ee.renderers?ee.renderers[de.name]:null;ye?ee.renderers[de.name]=function(){for(var T=arguments.length,H=new Array(T),J=0;J<T;J++)H[J]=arguments[J];var B=de.renderer.apply(this,H);return B===!1&&(B=ye.apply(this,H)),B}:ee.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ee[de.level]?ee[de.level].unshift(de.tokenizer):ee[de.level]=[de.tokenizer],de.start&&(de.level==="block"?ee.startBlock?ee.startBlock.push(de.start):ee.startBlock=[de.start]:de.level==="inline"&&(ee.startInline?ee.startInline.push(de.start):ee.startInline=[de.start]))}de.childTokens&&(ee.childTokens[de.name]=de.childTokens)})),fe.renderer&&function(){var de=pe.defaults.renderer||new le,ye=function(J){var B=de[J];de[J]=function(){for(var Z=arguments.length,_=new Array(Z),ke=0;ke<Z;ke++)_[ke]=arguments[ke];var Ne=fe.renderer[J].apply(de,_);return Ne===!1&&(Ne=B.apply(de,_)),Ne}};for(var T in fe.renderer)ye(T);K.renderer=de}(),fe.tokenizer&&function(){var de=pe.defaults.tokenizer||new q,ye=function(J){var B=de[J];de[J]=function(){for(var Z=arguments.length,_=new Array(Z),ke=0;ke<Z;ke++)_[ke]=arguments[ke];var Ne=fe.tokenizer[J].apply(de,_);return Ne===!1&&(Ne=B.apply(de,_)),Ne}};for(var T in fe.tokenizer)ye(T);K.tokenizer=de}(),fe.walkTokens){var Ce=pe.defaults.walkTokens;K.walkTokens=function(de){var ye=[];return ye.push(fe.walkTokens.call(this,de)),Ce&&(ye=ye.concat(Ce.call(this,de))),ye}}he&&(K.extensions=ee),pe.setOptions(K)})},pe.walkTokens=function(Le,we){for(var ge=[],K=function(){var Ce=he.value;switch(ge=ge.concat(we.call(pe,Ce)),Ce.type){case"table":{for(var de=R(Ce.header),ye;!(ye=de()).done;){var T=ye.value;ge=ge.concat(pe.walkTokens(T.tokens,we))}for(var H=R(Ce.rows),J;!(J=H()).done;)for(var B=J.value,Z=R(B),_;!(_=Z()).done;){var ke=_.value;ge=ge.concat(pe.walkTokens(ke.tokens,we))}break}case"list":{ge=ge.concat(pe.walkTokens(Ce.items,we));break}default:pe.defaults.extensions&&pe.defaults.extensions.childTokens&&pe.defaults.extensions.childTokens[Ce.type]?pe.defaults.extensions.childTokens[Ce.type].forEach(function(Ne){ge=ge.concat(pe.walkTokens(Ce[Ne],we))}):Ce.tokens&&(ge=ge.concat(pe.walkTokens(Ce.tokens,we)))}},ee=R(Le),he;!(he=ee()).done;)K();return ge},pe.parseInline=function(Le,we){if(typeof Le>"u"||Le===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Le!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Le)+", string expected");we=b({},pe.defaults,we||{}),k(we);try{var ge=se.lexInline(Le,we);return we.walkTokens&&pe.walkTokens(ge,we.walkTokens),ce.parseInline(ge,we)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+p(K.message+"",!0)+"</pre>";throw K}},pe.Parser=ce,pe.parser=ce.parse,pe.Renderer=le,pe.TextRenderer=Ee,pe.Lexer=se,pe.lexer=se.lex,pe.Tokenizer=q,pe.Slugger=De,pe.parse=pe;var oe=pe.options,$e=pe.setOptions,ie=pe.use,x=pe.walkTokens,V=pe.parseInline,ne=pe,Ie=ce.parse,Me=se.lex;me.Lexer=se,me.Parser=ce,me.Renderer=le,me.Slugger=De,me.TextRenderer=Ee,me.Tokenizer=q,me.getDefaults=L,me.lexer=Me,me.marked=pe,me.options=oe,me.parse=ne,me.parseInline=V,me.parser=Ie,me.setOptions=$e,me.use=ie,me.walkTokens=x,Object.defineProperty(me,"__esModule",{value:!0})}),define(Re[121],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tj=void 0;function S(r){const c=R(r);if(c&&c.length>0)return new Uint32Array(c)}e.$Tj=S;let M=0;const I=new Uint32Array(10);function R(r){if(M=0,L(r,D,4352),M>0||(L(r,l,4449),M>0)||(L(r,$,4520),M>0)||(L(r,p,12593),M))return I.subarray(0,M);if(r>=44032&&r<=55203){const c=r-44032,s=c%588,i=Math.floor(c/588),o=Math.floor(s/28),a=s%28-1;if(i<D.length?L(i,D,0):4352+i-12593<p.length&&L(4352+i,p,12593),o<l.length?L(o,l,0):4449+o-12593<p.length&&L(4449+o-12593,p,12593),a>=0&&(a<$.length?L(a,$,0):4520+a-12593<p.length&&L(4520+a-12593,p,12593)),M>0)return I.subarray(0,M)}}function L(r,c,s){r>=s&&r<s+c.length&&m(c[r-s])}function m(r){r!==0&&(I[M++]=r&255,r>>8&&(I[M++]=r>>8&255),r>>16&&(I[M++]=r>>16&255))}var h;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(h||(h={}));var E;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(E||(E={}));var A;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(A||(A={}));const D=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),$=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),p=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Re[122],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.rot=e.$9l=void 0;function S(m,h,E){return Math.min(Math.max(m,h),E)}e.$9l=S;function M(m,h){return(h+m%h)%h}e.rot=M;class I{constructor(){this.a=0}getNext(){return this.a++}}e.$$l=I;class R{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$_l=R;class L{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const E=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$am=L}),function(){function me(I){const R=[];typeof I=="number"&&R.push("code/timeOrigin",I);function L(h){R.push(h,Date.now())}function m(){const h=[];for(let E=0;E<R.length;E+=2)h.push({name:R[E],startTime:R[E+1]});return h}return{mark:L,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(I+L.startTime)});return R}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function S(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=S(M))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var M in S)(typeof exports=="object"?exports:me)[M]=S[M]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function S(M){if(e[M])return e[M].exports;var I=e[M]={i:M,l:!1,exports:{}};return me[M].call(I.exports,I,I.exports,S),I.l=!0,I.exports}return S.m=me,S.c=e,S.d=function(M,I,R){S.o(M,I)||Object.defineProperty(M,I,{enumerable:!0,get:R})},S.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},S.t=function(M,I){if(1&I&&(M=S(M)),8&I||4&I&&typeof M=="object"&&M&&M.__esModule)return M;var R=Object.create(null);if(S.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:M}),2&I&&typeof M!="string")for(var L in M)S.d(R,L,function(m){return M[m]}.bind(null,L));return R},S.n=function(M){var I=M&&M.__esModule?function(){return M.default}:function(){return M};return S.d(I,"a",I),I},S.o=function(M,I){return Object.prototype.hasOwnProperty.call(M,I)},S.p="",S(S.s=0)}([function(me,e,S){(function(M){var I;e=me.exports=ie,I=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],h=e.src=[],E=0,A=E++;h[A]="0|[1-9]\\d*";var D=E++;h[D]="[0-9]+";var l=E++;h[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=E++;h[$]="("+h[A]+")\\.("+h[A]+")\\.("+h[A]+")";var p=E++;h[p]="("+h[D]+")\\.("+h[D]+")\\.("+h[D]+")";var r=E++;h[r]="(?:"+h[A]+"|"+h[l]+")";var c=E++;h[c]="(?:"+h[D]+"|"+h[l]+")";var s=E++;h[s]="(?:-("+h[r]+"(?:\\."+h[r]+")*))";var i=E++;h[i]="(?:-?("+h[c]+"(?:\\."+h[c]+")*))";var o=E++;h[o]="[0-9A-Za-z-]+";var a=E++;h[a]="(?:\\+("+h[o]+"(?:\\."+h[o]+")*))";var u=E++,t="v?"+h[$]+h[s]+"?"+h[a]+"?";h[u]="^"+t+"$";var f="[v=\\s]*"+h[p]+h[i]+"?"+h[a]+"?",n=E++;h[n]="^"+f+"$";var w=E++;h[w]="((?:<|>)?=?)";var y=E++;h[y]=h[D]+"|x|X|\\*";var d=E++;h[d]=h[A]+"|x|X|\\*";var b=E++;h[b]="[v=\\s]*("+h[d]+")(?:\\.("+h[d]+")(?:\\.("+h[d]+")(?:"+h[s]+")?"+h[a]+"?)?)?";var P=E++;h[P]="[v=\\s]*("+h[y]+")(?:\\.("+h[y]+")(?:\\.("+h[y]+")(?:"+h[i]+")?"+h[a]+"?)?)?";var g=E++;h[g]="^"+h[w]+"\\s*"+h[b]+"$";var v=E++;h[v]="^"+h[w]+"\\s*"+h[P]+"$";var k=E++;h[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=E++;h[F]="(?:~>?)";var O=E++;h[O]="(\\s*)"+h[F]+"\\s+",m[O]=new RegExp(h[O],"g");var G=E++;h[G]="^"+h[F]+h[b]+"$";var q=E++;h[q]="^"+h[F]+h[P]+"$";var U=E++;h[U]="(?:\\^)";var C=E++;h[C]="(\\s*)"+h[U]+"\\s+",m[C]=new RegExp(h[C],"g");var N=E++;h[N]="^"+h[U]+h[b]+"$";var W=E++;h[W]="^"+h[U]+h[P]+"$";var se=E++;h[se]="^"+h[w]+"\\s*("+f+")$|^$";var le=E++;h[le]="^"+h[w]+"\\s*("+t+")$|^$";var Ee=E++;h[Ee]="(\\s*)"+h[w]+"\\s*("+f+"|"+h[b]+")",m[Ee]=new RegExp(h[Ee],"g");var De=E++;h[De]="^\\s*("+h[b]+")\\s+-\\s+("+h[b]+")\\s*$";var ce=E++;h[ce]="^\\s*("+h[P]+")\\s+-\\s+("+h[P]+")\\s*$";var pe=E++;h[pe]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)I(oe,h[oe]),m[oe]||(m[oe]=new RegExp(h[oe]));function $e(B,Z){if(B instanceof ie)return B;if(typeof B!="string"||B.length>R||!(Z?m[n]:m[u]).test(B))return null;try{return new ie(B,Z)}catch{return null}}function ie(B,Z){if(B instanceof ie){if(B.loose===Z)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof ie))return new ie(B,Z);I("SemVer",B,Z),this.loose=Z;var _=B.trim().match(Z?m[n]:m[u]);if(!_)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function(ke){if(/^[0-9]+$/.test(ke)){var Ne=+ke;if(Ne>=0&&Ne<L)return Ne}return ke}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}e.parse=$e,e.valid=function(B,Z){var _=$e(B,Z);return _?_.version:null},e.clean=function(B,Z){var _=$e(B.trim().replace(/^[=v]+/,""),Z);return _?_.version:null},e.SemVer=ie,ie.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ie.prototype.toString=function(){return this.version},ie.prototype.compare=function(B){return I("SemVer.compare",this.version,this.loose,B),B instanceof ie||(B=new ie(B,this.loose)),this.compareMain(B)||this.comparePre(B)},ie.prototype.compareMain=function(B){return B instanceof ie||(B=new ie(B,this.loose)),V(this.major,B.major)||V(this.minor,B.minor)||V(this.patch,B.patch)},ie.prototype.comparePre=function(B){if(B instanceof ie||(B=new ie(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var Z=0;do{var _=this.prerelease[Z],ke=B.prerelease[Z];if(I("prerelease compare",Z,_,ke),_===void 0&&ke===void 0)return 0;if(ke===void 0)return 1;if(_===void 0)return-1;if(_!==ke)return V(_,ke)}while(++Z)},ie.prototype.inc=function(B,Z){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Z),this.inc("pre",Z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Z),this.inc("pre",Z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}Z&&(this.prerelease[0]===Z?isNaN(this.prerelease[1])&&(this.prerelease=[Z,0]):this.prerelease=[Z,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,Z,_,ke){typeof _=="string"&&(ke=_,_=void 0);try{return new ie(B,_).inc(Z,ke).version}catch{return null}},e.diff=function(B,Z){if(Le(B,Z))return null;var _=$e(B),ke=$e(Z);if(_.prerelease.length||ke.prerelease.length){for(var Ne in _)if((Ne==="major"||Ne==="minor"||Ne==="patch")&&_[Ne]!==ke[Ne])return"pre"+Ne;return"prerelease"}for(var Ne in _)if((Ne==="major"||Ne==="minor"||Ne==="patch")&&_[Ne]!==ke[Ne])return Ne},e.compareIdentifiers=V;var x=/^[0-9]+$/;function V(B,Z){var _=x.test(B),ke=x.test(Z);return _&&ke&&(B=+B,Z=+Z),_&&!ke?-1:ke&&!_?1:B<Z?-1:B>Z?1:0}function ne(B,Z,_){return new ie(B,_).compare(new ie(Z,_))}function Ie(B,Z,_){return ne(B,Z,_)>0}function Me(B,Z,_){return ne(B,Z,_)<0}function Le(B,Z,_){return ne(B,Z,_)===0}function we(B,Z,_){return ne(B,Z,_)!==0}function ge(B,Z,_){return ne(B,Z,_)>=0}function K(B,Z,_){return ne(B,Z,_)<=0}function ee(B,Z,_,ke){var Ne;switch(Z){case"===":typeof B=="object"&&(B=B.version),typeof _=="object"&&(_=_.version),Ne=B===_;break;case"!==":typeof B=="object"&&(B=B.version),typeof _=="object"&&(_=_.version),Ne=B!==_;break;case"":case"=":case"==":Ne=Le(B,_,ke);break;case"!=":Ne=we(B,_,ke);break;case">":Ne=Ie(B,_,ke);break;case">=":Ne=ge(B,_,ke);break;case"<":Ne=Me(B,_,ke);break;case"<=":Ne=K(B,_,ke);break;default:throw new TypeError("Invalid operator: "+Z)}return Ne}function he(B,Z){if(B instanceof he){if(B.loose===Z)return B;B=B.value}if(!(this instanceof he))return new he(B,Z);I("comparator",B,Z),this.loose=Z,this.parse(B),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(B,Z){return V(Z,B)},e.major=function(B,Z){return new ie(B,Z).major},e.minor=function(B,Z){return new ie(B,Z).minor},e.patch=function(B,Z){return new ie(B,Z).patch},e.compare=ne,e.compareLoose=function(B,Z){return ne(B,Z,!0)},e.rcompare=function(B,Z,_){return ne(Z,B,_)},e.sort=function(B,Z){return B.sort(function(_,ke){return e.compare(_,ke,Z)})},e.rsort=function(B,Z){return B.sort(function(_,ke){return e.rcompare(_,ke,Z)})},e.gt=Ie,e.lt=Me,e.eq=Le,e.neq=we,e.gte=ge,e.lte=K,e.cmp=ee,e.Comparator=he;var fe={};function Ce(B,Z){if(B instanceof Ce)return B.loose===Z?B:new Ce(B.raw,Z);if(B instanceof he)return new Ce(B.value,Z);if(!(this instanceof Ce))return new Ce(B,Z);if(this.loose=Z,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function de(B){return!B||B.toLowerCase()==="x"||B==="*"}function ye(B,Z,_,ke,Ne,We,He,Ye,nt,it,et,st,ct){return((Z=de(_)?"":de(ke)?">="+_+".0.0":de(Ne)?">="+_+"."+ke+".0":">="+Z)+" "+(Ye=de(nt)?"":de(it)?"<"+(+nt+1)+".0.0":de(et)?"<"+nt+"."+(+it+1)+".0":st?"<="+nt+"."+it+"."+et+"-"+st:"<="+Ye)).trim()}function T(B,Z){for(var _=0;_<B.length;_++)if(!B[_].test(Z))return!1;if(Z.prerelease.length){for(_=0;_<B.length;_++)if(I(B[_].semver),B[_].semver!==fe&&B[_].semver.prerelease.length>0){var ke=B[_].semver;if(ke.major===Z.major&&ke.minor===Z.minor&&ke.patch===Z.patch)return!0}return!1}return!0}function H(B,Z,_){try{Z=new Ce(Z,_)}catch{return!1}return Z.test(B)}function J(B,Z,_,ke){var Ne,We,He,Ye,nt;switch(B=new ie(B,ke),Z=new Ce(Z,ke),_){case">":Ne=Ie,We=K,He=Me,Ye=">",nt=">=";break;case"<":Ne=Me,We=ge,He=Ie,Ye="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(H(B,Z,ke))return!1;for(var it=0;it<Z.set.length;++it){var et=Z.set[it],st=null,ct=null;if(et.forEach(function(Ue){Ue.semver===fe&&(Ue=new he(">=0.0.0")),st=st||Ue,ct=ct||Ue,Ne(Ue.semver,st.semver,ke)?st=Ue:He(Ue.semver,ct.semver,ke)&&(ct=Ue)}),st.operator===Ye||st.operator===nt||(!ct.operator||ct.operator===Ye)&&We(B,ct.semver)||ct.operator===nt&&He(B,ct.semver))return!1}return!0}he.prototype.parse=function(B){var Z=this.loose?m[se]:m[le],_=B.match(Z);if(!_)throw new TypeError("Invalid comparator: "+B);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new ie(_[2],this.loose):this.semver=fe},he.prototype.toString=function(){return this.value},he.prototype.test=function(B){return I("Comparator.test",B,this.loose),this.semver===fe||(typeof B=="string"&&(B=new ie(B,this.loose)),ee(B,this.operator,this.semver,this.loose))},he.prototype.intersects=function(B,Z){if(!(B instanceof he))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new Ce(B.value,Z),H(this.value,_,Z);if(B.operator==="")return _=new Ce(this.value,Z),H(B.semver,_,Z);var ke=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),Ne=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),We=this.semver.version===B.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Ye=ee(this.semver,"<",B.semver,Z)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),nt=ee(this.semver,">",B.semver,Z)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return ke||Ne||We&&He||Ye||nt},e.Range=Ce,Ce.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},Ce.prototype.toString=function(){return this.range},Ce.prototype.parseRange=function(B){var Z=this.loose;B=B.trim(),I("range",B,Z);var _=Z?m[ce]:m[De];B=B.replace(_,ye),I("hyphen replace",B),B=B.replace(m[Ee],"$1$2$3"),I("comparator trim",B,m[Ee]),B=(B=(B=B.replace(m[O],"$1~")).replace(m[C],"$1^")).split(/\s+/).join(" ");var ke=Z?m[se]:m[le],Ne=B.split(" ").map(function(We){return function(He,Ye){return I("comp",He),He=function(nt,it){return nt.trim().split(/\s+/).map(function(et){return function(st,ct){I("caret",st,ct);var Ue=ct?m[W]:m[N];return st.replace(Ue,function($t,Y,X,ve,Be){var Qe;return I("caret",st,$t,Y,X,ve,Be),de(Y)?Qe="":de(X)?Qe=">="+Y+".0.0 <"+(+Y+1)+".0.0":de(ve)?Qe=Y==="0"?">="+Y+"."+X+".0 <"+Y+"."+(+X+1)+".0":">="+Y+"."+X+".0 <"+(+Y+1)+".0.0":Be?(I("replaceCaret pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=Y==="0"?X==="0"?">="+Y+"."+X+"."+ve+Be+" <"+Y+"."+X+"."+(+ve+1):">="+Y+"."+X+"."+ve+Be+" <"+Y+"."+(+X+1)+".0":">="+Y+"."+X+"."+ve+Be+" <"+(+Y+1)+".0.0"):(I("no pr"),Qe=Y==="0"?X==="0"?">="+Y+"."+X+"."+ve+" <"+Y+"."+X+"."+(+ve+1):">="+Y+"."+X+"."+ve+" <"+Y+"."+(+X+1)+".0":">="+Y+"."+X+"."+ve+" <"+(+Y+1)+".0.0"),I("caret return",Qe),Qe})}(et,it)}).join(" ")}(He,Ye),I("caret",He),He=function(nt,it){return nt.trim().split(/\s+/).map(function(et){return function(st,ct){var Ue=ct?m[q]:m[G];return st.replace(Ue,function($t,Y,X,ve,Be){var Qe;return I("tilde",st,$t,Y,X,ve,Be),de(Y)?Qe="":de(X)?Qe=">="+Y+".0.0 <"+(+Y+1)+".0.0":de(ve)?Qe=">="+Y+"."+X+".0 <"+Y+"."+(+X+1)+".0":Be?(I("replaceTilde pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=">="+Y+"."+X+"."+ve+Be+" <"+Y+"."+(+X+1)+".0"):Qe=">="+Y+"."+X+"."+ve+" <"+Y+"."+(+X+1)+".0",I("tilde return",Qe),Qe})}(et,it)}).join(" ")}(He,Ye),I("tildes",He),He=function(nt,it){return I("replaceXRanges",nt,it),nt.split(/\s+/).map(function(et){return function(st,ct){st=st.trim();var Ue=ct?m[v]:m[g];return st.replace(Ue,function($t,Y,X,ve,Be,Qe){I("xRange",st,$t,Y,X,ve,Be,Qe);var tt=de(X),ot=tt||de(ve),Fe=ot||de(Be);return Y==="="&&Fe&&(Y=""),tt?$t=Y===">"||Y==="<"?"<0.0.0":"*":Y&&Fe?(ot&&(ve=0),Fe&&(Be=0),Y===">"?(Y=">=",ot?(X=+X+1,ve=0,Be=0):Fe&&(ve=+ve+1,Be=0)):Y==="<="&&(Y="<",ot?X=+X+1:ve=+ve+1),$t=Y+X+"."+ve+"."+Be):ot?$t=">="+X+".0.0 <"+(+X+1)+".0.0":Fe&&($t=">="+X+"."+ve+".0 <"+X+"."+(+ve+1)+".0"),I("xRange return",$t),$t})}(et,it)}).join(" ")}(He,Ye),I("xrange",He),He=function(nt,it){return I("replaceStars",nt,it),nt.trim().replace(m[pe],"")}(He,Ye),I("stars",He),He}(We,Z)}).join(" ").split(/\s+/);return this.loose&&(Ne=Ne.filter(function(We){return!!We.match(ke)})),Ne=Ne.map(function(We){return new he(We,Z)})},Ce.prototype.intersects=function(B,Z){if(!(B instanceof Ce))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function(ke){return B.set.some(function(Ne){return Ne.every(function(We){return ke.intersects(We,Z)})})})})},e.toComparators=function(B,Z){return new Ce(B,Z).set.map(function(_){return _.map(function(ke){return ke.value}).join(" ").trim().split(" ")})},Ce.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new ie(B,this.loose));for(var Z=0;Z<this.set.length;Z++)if(T(this.set[Z],B))return!0;return!1},e.satisfies=H,e.maxSatisfying=function(B,Z,_){var ke=null,Ne=null;try{var We=new Ce(Z,_)}catch{return null}return B.forEach(function(He){We.test(He)&&(ke&&Ne.compare(He)!==-1||(Ne=new ie(ke=He,_)))}),ke},e.minSatisfying=function(B,Z,_){var ke=null,Ne=null;try{var We=new Ce(Z,_)}catch{return null}return B.forEach(function(He){We.test(He)&&(ke&&Ne.compare(He)!==1||(Ne=new ie(ke=He,_)))}),ke},e.validRange=function(B,Z){try{return new Ce(B,Z).range||"*"}catch{return null}},e.ltr=function(B,Z,_){return J(B,Z,"<",_)},e.gtr=function(B,Z,_){return J(B,Z,">",_)},e.outside=J,e.prerelease=function(B,Z){var _=$e(B,Z);return _&&_.prerelease.length?_.prerelease:null},e.intersects=function(B,Z,_){return B=new Ce(B,_),Z=new Ce(Z,_),B.intersects(Z)},e.coerce=function(B){if(B instanceof ie)return B;if(typeof B!="string")return null;var Z=B.match(m[k]);return Z==null?null:$e((Z[1]||"0")+"."+(Z[2]||"0")+"."+(Z[3]||"0"))}}).call(this,S(1))},function(me,e){var S,M,I=me.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function m(c){if(S===setTimeout)return setTimeout(c,0);if((S===R||!S)&&setTimeout)return S=setTimeout,setTimeout(c,0);try{return S(c,0)}catch{try{return S.call(null,c,0)}catch{return S.call(this,c,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:R}catch{S=R}try{M=typeof clearTimeout=="function"?clearTimeout:L}catch{M=L}})();var h,E=[],A=!1,D=-1;function l(){A&&h&&(A=!1,h.length?E=h.concat(E):D=-1,E.length&&$())}function $(){if(!A){var c=m(l);A=!0;for(var s=E.length;s;){for(h=E,E=[];++D<s;)h&&h[D].run();D=-1,s=E.length}h=null,A=!1,function(i){if(M===clearTimeout)return clearTimeout(i);if((M===L||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(i);try{M(i)}catch{try{return M.call(null,i)}catch{return M.call(this,i)}}}(c)}}function p(c,s){this.fun=c,this.array=s}function r(){}I.nextTick=function(c){var s=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)s[i-1]=arguments[i];E.push(new p(c,s)),E.length!==1||A||m($)},p.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=r,I.addListener=r,I.once=r,I.off=r,I.removeListener=r,I.removeAllListeners=r,I.emit=r,I.prependListener=r,I.prependOnceListener=r,I.listeners=function(c){return[]},I.binding=function(c){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(c){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Re[123],Ae([1,0,15,6]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function I(a){const u=a;return u?typeof u.read=="function":!1}e.$8d=I;function R(a){const u=a;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}e.$9d=R;function L(a){const u=a;return u?R(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.$0d=L;function m(a,u){return new h(a,u)}e.$$d=m;class h{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,S.$1)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let f;switch(u){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const n=f.indexOf(t);n>=0&&f.splice(n,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(a,u){const t=[];let f;for(;(f=a.read())!==null;)t.push(f);return u(t)}e.$_d=E;function A(a,u,t){const f=[];let n;for(;(n=a.read())!==null&&f.length<t;)f.push(n);return n===null&&f.length>0?u(f):{read:()=>{if(f.length>0)return f.shift();if(typeof n<"u"){const w=n;return n=void 0,w}return a.read()}}}e.$ae=A;function D(a,u){return new Promise((t,f)=>{const n=[];l(a,{onData:w=>{u&&n.push(w)},onError:w=>{u?f(w):t(void 0)},onEnd:()=>{t(u?u(n):void 0)}})})}e.$be=D;function l(a,u,t){a.on("error",f=>{t?.isCancellationRequested||u.onError(f)}),a.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),a.on("data",f=>{t?.isCancellationRequested||u.onData(f)})}e.$ce=l;function $(a,u){return new Promise((t,f)=>{const n=new M.$Sc,w=[],y=P=>{if(w.push(P),w.length>u)return n.dispose(),a.pause(),t({stream:a,buffer:w,ended:!1})},d=P=>(n.dispose(),f(P)),b=()=>(n.dispose(),t({stream:a,buffer:w,ended:!0}));n.add((0,M.$Rc)(()=>a.removeListener("error",d))),a.on("error",d),n.add((0,M.$Rc)(()=>a.removeListener("end",b))),a.on("end",b),n.add((0,M.$Rc)(()=>a.removeListener("data",y))),a.on("data",y)})}e.$de=$;function p(a,u){const t=m(u);return t.end(a),t}e.$ee=p;function r(){const a=m(()=>{throw new Error("not supported")});return a.end(),a}e.$fe=r;function c(a){let u=!1;return{read:()=>u?null:(u=!0,a)}}e.$ge=c;function s(a,u,t){const f=m(t);return l(a,{onData:n=>f.write(u.data(n)),onError:n=>f.error(u.error?u.error(n):n),onEnd:()=>f.end()}),f}e.$he=s;function i(a,u,t){let f=!1;return{read:()=>{const n=u.read();return f?n:(f=!0,n!==null?t([a,n]):a)}}}e.$ie=i;function o(a,u,t){let f=!1;const n=m(t);return l(u,{onData:w=>f?n.write(w):(f=!0,n.write(t([a,w]))),onError:w=>n.error(w),onEnd:()=>{f||(f=!0,n.write(a)),n.end()}}),n}e.$je=o}),define(Re[23],Ae([1,0,39,123]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const I=typeof Buffer<"u",R=new S.$V(()=>new Uint8Array(256));let L,m;class h{static alloc(k){return I?new h(Buffer.allocUnsafe(k)):new h(new Uint8Array(k))}static wrap(k){return I&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new h(k)}static fromString(k,F){return!(F?.dontUseNodeBuffer||!1)&&I?new h(Buffer.from(k)):(L||(L=new TextEncoder),new h(L.encode(k)))}static fromByteArray(k){const F=h.alloc(k.length);for(let O=0,G=k.length;O<G;O++)F.buffer[O]=k[O];return F}static concat(k,F){if(typeof F>"u"){F=0;for(let q=0,U=k.length;q<U;q++)F+=k[q].byteLength}const O=h.alloc(F);let G=0;for(let q=0,U=k.length;q<U;q++){const C=k[q];O.set(C,G),G+=C.byteLength}return O}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=h.alloc(this.byteLength);return k.set(this),k}toString(){return I?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(k,F){return new h(this.buffer.subarray(k,F))}set(k,F){if(k instanceof h)this.buffer.set(k.buffer,F);else if(k instanceof Uint8Array)this.buffer.set(k,F);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),F);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),F);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return l(this.buffer,k)}writeUInt32BE(k,F){$(this.buffer,k,F)}readUInt32LE(k){return p(this.buffer,k)}writeUInt32LE(k,F){r(this.buffer,k,F)}readUInt8(k){return c(this.buffer,k)}writeUInt8(k,F){s(this.buffer,k,F)}indexOf(k,F=0){return E(this.buffer,k instanceof h?k.buffer:k,F)}}e.$ke=h;function E(v,k,F=0){const O=k.byteLength,G=v.byteLength;if(O===0)return 0;if(O===1)return v.indexOf(k[0]);if(O>G-F)return-1;const q=R.value;q.fill(k.length);for(let W=0;W<k.length;W++)q[k[W]]=k.length-W-1;let U=F+k.length-1,C=U,N=-1;for(;U<G;)if(v[U]===k[C]){if(C===0){N=U;break}U--,C--}else U+=Math.max(k.length-C,q[v[U]]),C=k.length-1;return N}e.$le=E;function A(v,k){return v[k+0]<<0>>>0|v[k+1]<<8>>>0}e.$me=A;function D(v,k,F){v[F+0]=k&255,k=k>>>8,v[F+1]=k&255}e.$ne=D;function l(v,k){return v[k]*2**24+v[k+1]*2**16+v[k+2]*2**8+v[k+3]}e.$oe=l;function $(v,k,F){v[F+3]=k,k=k>>>8,v[F+2]=k,k=k>>>8,v[F+1]=k,k=k>>>8,v[F]=k}e.$pe=$;function p(v,k){return v[k+0]<<0>>>0|v[k+1]<<8>>>0|v[k+2]<<16>>>0|v[k+3]<<24>>>0}e.$qe=p;function r(v,k,F){v[F+0]=k&255,k=k>>>8,v[F+1]=k&255,k=k>>>8,v[F+2]=k&255,k=k>>>8,v[F+3]=k&255}e.$re=r;function c(v,k){return v[k]}e.$se=c;function s(v,k,F){v[F]=k}e.$te=s;function i(v){return M.$_d(v,k=>h.concat(k))}e.$ue=i;function o(v){return M.$ge(v)}e.$ve=o;function a(v){return M.$be(v,k=>h.concat(k))}e.$we=a;async function u(v){return v.ended?h.concat(v.buffer):h.concat([...v.buffer,await a(v.stream)])}e.$xe=u;function t(v){return M.$ee(v,k=>h.concat(k))}e.$ye=t;function f(v){return M.$he(v,{data:k=>typeof k=="string"?h.fromString(k):h.wrap(k)},k=>h.concat(k))}e.$ze=f;function n(v){return M.$$d(k=>h.concat(k),v)}e.$Ae=n;function w(v,k){return M.$ie(v,k,F=>h.concat(F))}e.$Be=w;function y(v,k){return M.$je(v,k,F=>h.concat(F))}e.$Ce=y;function d(v){let k=0,F=0,O=0;const G=new Uint8Array(Math.floor(v.length/4*3)),q=C=>{switch(F){case 3:G[O++]=k|C,F=0;break;case 2:G[O++]=k|C>>>2,k=C<<6,F=3;break;case 1:G[O++]=k|C>>>4,k=C<<4,F=2;break;default:k=C<<2,F=1}};for(let C=0;C<v.length;C++){const N=v.charCodeAt(C);if(N>=65&&N<=90)q(N-65);else if(N>=97&&N<=122)q(N-97+26);else if(N>=48&&N<=57)q(N-48+52);else if(N===43||N===45)q(62);else if(N===47||N===95)q(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${v[C]}`)}}const U=O;for(;F>0;)q(0);return h.wrap(G).slice(0,U)}e.$De=d;const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:v},k=!0,F=!1){const O=F?P:b;let G="";const q=v.byteLength%3;let U=0;for(;U<v.byteLength-q;U+=3){const C=v[U+0],N=v[U+1],W=v[U+2];G+=O[C>>>2],G+=O[(C<<4|N>>>4)&63],G+=O[(N<<2|W>>>6)&63],G+=O[W&63]}if(q===1){const C=v[U+0];G+=O[C>>>2],G+=O[C<<4&63],k&&(G+="==")}else if(q===2){const C=v[U+0],N=v[U+1];G+=O[C>>>2],G+=O[(C<<4|N>>>4)&63],G+=O[N<<2&63],k&&(G+="=")}return G}e.$Ee=g}),define(Re[124],Ae([1,0,28,121,14]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=e.$9j=e.$8j=e.FuzzyScore=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.or=void 0;function R(...de){return function(ye,T){for(let H=0,J=de.length;H<J;H++){const B=de[H](ye,T);if(B)return B}return null}}e.or=R,e.$Vj=L.bind(void 0,!1),e.$Wj=L.bind(void 0,!0);function L(de,ye,T){if(!T||T.length<ye.length)return null;let H;return de?H=I.$bf(T,ye):H=T.indexOf(ye)===0,H?ye.length>0?[{start:0,end:ye.length}]:[]:null}function m(de,ye){const T=ye.toLowerCase().indexOf(de.toLowerCase());return T===-1?null:[{start:T,end:T+de.length}]}e.$Xj=m;function h(de,ye){return E(de.toLowerCase(),ye.toLowerCase(),0,0)}e.$Yj=h;function E(de,ye,T,H){if(T===de.length)return[];if(H===ye.length)return null;if(de[T]===ye[H]){let J=null;return(J=E(de,ye,T+1,H+1))?a({start:H,end:H+1},J):null}return E(de,ye,T,H+1)}function A(de){return 97<=de&&de<=122}function D(de){return 65<=de&&de<=90}e.$Zj=D;function l(de){return 48<=de&&de<=57}function $(de){return de===32||de===9||de===10||de===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>p.add(de.charCodeAt(0)));function r(de){return $(de)||p.has(de)}function c(de,ye){return de===ye||r(de)&&r(ye)}const s=new Map;function i(de){if(s.has(de))return s.get(de);let ye;const T=(0,M.$Tj)(de);return T&&(ye=T),s.set(de,ye),ye}function o(de){return A(de)||D(de)||l(de)}function a(de,ye){return ye.length===0?ye=[de]:de.end===ye[0].start?ye[0].start=de.start:ye.unshift(de),ye}function u(de,ye){for(let T=ye;T<de.length;T++){const H=de.charCodeAt(T);if(D(H)||l(H)||T>0&&!o(de.charCodeAt(T-1)))return T}return de.length}function t(de,ye,T,H){if(T===de.length)return[];if(H===ye.length)return null;if(de[T]!==ye[H].toLowerCase())return null;{let J=null,B=H+1;for(J=t(de,ye,T+1,H+1);!J&&(B=u(ye,B))<ye.length;)J=t(de,ye,T+1,B),B++;return J===null?null:a({start:H,end:H+1},J)}}function f(de){let ye=0,T=0,H=0,J=0,B=0;for(let We=0;We<de.length;We++)B=de.charCodeAt(We),D(B)&&ye++,A(B)&&T++,o(B)&&H++,l(B)&&J++;const Z=ye/de.length,_=T/de.length,ke=H/de.length,Ne=J/de.length;return{upperPercent:Z,lowerPercent:_,alphaPercent:ke,numericPercent:Ne}}function n(de){const{upperPercent:ye,lowerPercent:T}=de;return T===0&&ye>.6}function w(de){const{upperPercent:ye,lowerPercent:T,alphaPercent:H,numericPercent:J}=de;return T>.2&&ye<.8&&H>.6&&J<.2}function y(de){let ye=0,T=0,H=0,J=0;for(let B=0;B<de.length;B++)H=de.charCodeAt(B),D(H)&&ye++,A(H)&&T++,$(H)&&J++;return(ye===0||T===0)&&J===0?de.length<=30:ye<=5}function d(de,ye){if(!ye||(ye=ye.trim(),ye.length===0)||!y(de)||ye.length>60)return null;const T=f(ye);if(!w(T)){if(!n(T))return null;ye=ye.toLowerCase()}let H=null,J=0;for(de=de.toLowerCase();J<ye.length&&(H=t(de,ye,0,J))===null;)J=u(ye,J+1);return H}e.$1j=d;function b(de,ye,T=!1){if(!ye||ye.length===0)return null;let H=null,J=0;for(de=de.toLowerCase(),ye=ye.toLowerCase();J<ye.length&&(H=P(de,ye,0,J,T),H===null);)J=g(ye,J+1);return H}e.$2j=b;function P(de,ye,T,H,J){let B=0;if(T===de.length)return[];if(H===ye.length)return null;if(!c(de.charCodeAt(T),ye.charCodeAt(H))){const ke=i(de.charCodeAt(T));if(!ke)return null;for(let Ne=0;Ne<ke.length;Ne++)if(!c(ke[Ne],ye.charCodeAt(H+Ne)))return null;B+=ke.length-1}let Z=null,_=H+B+1;if(Z=P(de,ye,T+1,_,J),!J)for(;!Z&&(_=g(ye,_))<ye.length;)Z=P(de,ye,T+1,_,J),_++;if(!Z)return null;if(de.charCodeAt(T)!==ye.charCodeAt(H)){const ke=i(de.charCodeAt(T));if(!ke)return Z;for(let Ne=0;Ne<ke.length;Ne++)if(ke[Ne]!==ye.charCodeAt(H+Ne))return Z}return a({start:H,end:H+B+1},Z)}function g(de,ye){for(let T=ye;T<de.length;T++)if(r(de.charCodeAt(T))||T>0&&r(de.charCodeAt(T-1)))return T;return de.length}const v=R(e.$Wj,d,m),k=R(e.$Wj,d,h),F=new S.$Dc(1e4);function O(de,ye,T=!1){if(typeof de!="string"||typeof ye!="string")return null;let H=F.get(de);H||(H=new RegExp(I.$We(de),"i"),F.set(de,H));const J=H.exec(ye);return J?[{start:J.index,end:J.index+J[0].length}]:T?k(de,ye):v(de,ye)}e.$3j=O;function G(de,ye){const T=we(de,de.toLowerCase(),0,ye,ye.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return T?U(T):null}e.$4j=G;function q(de,ye,T,H,J,B){const Z=Math.min(13,de.length);for(;T<Z;T++){const _=we(de,ye,T,H,J,B,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(_)return _}return[0,B]}e.$5j=q;function U(de){if(typeof de>"u")return[];const ye=[],T=de[1];for(let H=de.length-1;H>1;H--){const J=de[H]+T,B=ye[ye.length-1];B&&B.end===J?B.end=J+1:ye.push({start:J,end:J+1})}return ye}e.$6j=U;const C=128;function N(){const de=[],ye=[];for(let T=0;T<=C;T++)ye[T]=0;for(let T=0;T<=C;T++)de.push(ye.slice(0));return de}function W(de){const ye=[];for(let T=0;T<=de;T++)ye[T]=0;return ye}const se=W(2*C),le=W(2*C),Ee=N(),De=N(),ce=N(),pe=!1;function oe(de,ye,T,H,J){function B(_,ke,Ne=" "){for(;_.length<ke;)_=Ne+_;return _}let Z=` |   |${H.split("").map(_=>B(_,3)).join("|")}
`;for(let _=0;_<=T;_++)_===0?Z+=" |":Z+=`${ye[_-1]}|`,Z+=de[_].slice(0,J+1).map(ke=>B(ke.toString(),3)).join("|")+`
`;return Z}function $e(de,ye,T,H){de=de.substr(ye),T=T.substr(H),console.log(oe(De,de,de.length,T,T.length)),console.log(oe(ce,de,de.length,T,T.length)),console.log(oe(Ee,de,de.length,T,T.length))}function ie(de,ye){if(ye<0||ye>=de.length)return!1;const T=de.codePointAt(ye);switch(T){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.$tf(T)}}function x(de,ye){if(ye<0||ye>=de.length)return!1;switch(de.charCodeAt(ye)){case 32:case 9:return!0;default:return!1}}function V(de,ye,T){return ye[de]!==T[de]}function ne(de,ye,T,H,J,B,Z=!1){for(;ye<T&&J<B;)de[ye]===H[J]&&(Z&&(se[ye]=J),ye+=1),J+=1;return ye===T}e.$7j=ne;var Ie;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Me;(function(de){de.Default=[-100,0];function ye(T){return!T||T.length===2&&T[0]===-100&&T[1]===0}de.isDefault=ye})(Me||(e.FuzzyScore=Me={}));class Le{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ye,T){this.firstMatchCanBeWeak=ye,this.boostFullMatch=T}}e.$8j=Le;function we(de,ye,T,H,J,B,Z=Le.default){const _=de.length>C?C:de.length,ke=H.length>C?C:H.length;if(T>=_||B>=ke||_-T>ke-B||!ne(ye,T,_,J,B,ke,!0))return;ge(_,ke,T,B,ye,J);let Ne=1,We=1,He=T,Ye=B;const nt=[!1];for(Ne=1,He=T;He<_;Ne++,He++){const Ue=se[He],$t=le[He],Y=He+1<_?le[He+1]:ke;for(We=Ue-B+1,Ye=Ue;Ye<Y;We++,Ye++){let X=Number.MIN_SAFE_INTEGER,ve=!1;Ye<=$t&&(X=K(de,ye,He,T,H,J,Ye,ke,B,Ee[Ne-1][We-1]===0,nt));let Be=0;X!==Number.MAX_SAFE_INTEGER&&(ve=!0,Be=X+De[Ne-1][We-1]);const Qe=Ye>Ue,tt=Qe?De[Ne][We-1]+(Ee[Ne][We-1]>0?-5:0):0,ot=Ye>Ue+1&&Ee[Ne][We-1]>0,Fe=ot?De[Ne][We-2]+(Ee[Ne][We-2]>0?-5:0):0;if(ot&&(!Qe||Fe>=tt)&&(!ve||Fe>=Be))De[Ne][We]=Fe,ce[Ne][We]=3,Ee[Ne][We]=0;else if(Qe&&(!ve||tt>=Be))De[Ne][We]=tt,ce[Ne][We]=2,Ee[Ne][We]=0;else if(ve)De[Ne][We]=Be,ce[Ne][We]=1,Ee[Ne][We]=Ee[Ne-1][We-1]+1;else throw new Error("not possible")}}if(pe&&$e(de,T,H,B),!nt[0]&&!Z.firstMatchCanBeWeak)return;Ne--,We--;const it=[De[Ne][We],B];let et=0,st=0;for(;Ne>=1;){let Ue=We;do{const $t=ce[Ne][Ue];if($t===3)Ue=Ue-2;else if($t===2)Ue=Ue-1;else break}while(Ue>=1);et>1&&ye[T+Ne-1]===J[B+We-1]&&!V(Ue+B-1,H,J)&&et+1>Ee[Ne][Ue]&&(Ue=We),Ue===We?et++:et=1,st||(st=Ue),Ne--,We=Ue-1,it.push(We)}ke===_&&Z.boostFullMatch&&(it[0]+=2);const ct=st-_;return it[0]-=ct,it}e.$9j=we;function ge(de,ye,T,H,J,B){let Z=de-1,_=ye-1;for(;Z>=T&&_>=H;)J[Z]===B[_]&&(le[Z]=_,Z--),_--}function K(de,ye,T,H,J,B,Z,_,ke,Ne,We){if(ye[T]!==B[Z])return Number.MIN_SAFE_INTEGER;let He=1,Ye=!1;return Z===T-H?He=de[T]===J[Z]?7:5:V(Z,J,B)&&(Z===0||!V(Z-1,J,B))?(He=de[T]===J[Z]?7:5,Ye=!0):ie(B,Z)&&(Z===0||!ie(B,Z-1))?He=5:(ie(B,Z-1)||x(B,Z-1))&&(He=5,Ye=!0),He>1&&T===H&&(We[0]=!0),Ye||(Ye=V(Z,J,B)||ie(B,Z-1)||x(B,Z-1)),T===H?Z>ke&&(He-=Ye?3:5):Ne?He+=Ye?2:0:He+=Ye?0:1,Z+1===_&&(He-=Ye?3:5),He}function ee(de,ye,T,H,J,B,Z){return fe(de,ye,T,H,J,B,!0,Z)}e.$0j=ee;function he(de,ye,T,H,J,B,Z){return fe(de,ye,T,H,J,B,!1,Z)}e.$$j=he;function fe(de,ye,T,H,J,B,Z,_){let ke=we(de,ye,T,H,J,B,_);if(ke&&!Z)return ke;if(de.length>=3){const Ne=Math.min(7,de.length-1);for(let We=T+1;We<Ne;We++){const He=Ce(de,We);if(He){const Ye=we(He,He.toLowerCase(),T,H,J,B,_);Ye&&(Ye[0]-=3,(!ke||Ye[0]>ke[0])&&(ke=Ye))}}}return ke}function Ce(de,ye){if(ye+1>=de.length)return;const T=de[ye],H=de[ye+1];if(T!==H)return de.slice(0,ye)+H+T+de.slice(ye+2)}}),define(Re[32],Ae([1,0,14]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(M||(M={})),function(I){const R="error",L="warning",m="warn",h="info",E="ignore";function A(l){return l?S.$af(R,l)?I.Error:S.$af(L,l)||S.$af(m,l)?I.Warning:S.$af(h,l)?I.Info:I.Ignore:I.Ignore}I.fromValue=A;function D(l){switch(l){case I.Error:return R;case I.Warning:return L;case I.Info:return h;default:return E}}I.toString=D}(M||(M={})),e.default=M}),define(Re[125],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=void 0,e.$Td=Symbol("MicrotaskDelay")}),define(Re[51],Ae([1,0,18,14]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=void 0;class I{constructor(){this.b="",this.c=0}reset($){return this.b=$,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp($){const p=$.charCodeAt(0),r=this.b.charCodeAt(this.c);return p-r}value(){return this.b[this.c]}}e.$0h=I;class R{constructor($=!0){this.e=$}reset($){return this.b=$,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let $=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if($)this.c++;else break;else $=!1;return this}cmp($){return this.e?(0,M.$7e)($,this.b,0,$.length,this.c,this.d):(0,M.$9e)($,this.b,0,$.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$$h=R;class L{constructor($=!0,p=!0){this.f=$,this.g=p}reset($){this.d=0,this.e=0,this.b=$,this.c=$.length;for(let p=$.length-1;p>=0;p--,this.c--){const r=this.b.charCodeAt(p);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let $=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if($)this.d++;else break;else $=!1}return this}cmp($){return this.g?(0,M.$7e)($,this.b,0,$.length,this.d,this.e):(0,M.$9e)($,this.b,0,$.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$_h=L;var m;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(m||(m={}));class h{constructor($,p){this.f=$,this.g=p,this.d=[],this.e=0}reset($){return this.c=$,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f($)),this.b.reset($.path),this.b.value()&&this.d.push(3)),this.g($)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp($){if(this.d[this.e]===1)return(0,M.$8e)($,this.c.scheme);if(this.d[this.e]===2)return(0,M.$8e)($,this.c.authority);if(this.d[this.e]===3)return this.b.cmp($);if(this.d[this.e]===4)return(0,M.$6e)($,this.c.query);if(this.d[this.e]===5)return(0,M.$6e)($,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ai=h;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const $=this.right;return this.right=$.left,$.left=this,this.updateHeight(),$.updateHeight(),$}rotateRight(){const $=this.left;return this.left=$.right,$.right=this,this.updateHeight(),$.updateHeight(),$}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(A||(A={}));class D{static forUris($=()=>!1,p=()=>!1){return new D(new h($,p))}static forPaths($=!1){return new D(new L(void 0,!$))}static forStrings(){return new D(new I)}static forConfigKeys(){return new D(new R)}constructor($){this.b=$}clear(){this.c=void 0}fill($,p){if(p){const r=p.slice(0);(0,S.$Xb)(r);for(const c of r)this.set(c,$)}else{const r=$.slice(0);(0,S.$Xb)(r);for(const c of r)this.set(c[0],c[1])}}set($,p){const r=this.b.reset($);let c;this.c||(this.c=new E,this.c.segment=r.value());const s=[];for(c=this.c;;){const o=r.cmp(c.segment);if(o>0)c.left||(c.left=new E,c.left.segment=r.value()),s.push([-1,c]),c=c.left;else if(o<0)c.right||(c.right=new E,c.right.segment=r.value()),s.push([1,c]),c=c.right;else if(r.hasNext())r.next(),c.mid||(c.mid=new E,c.mid.segment=r.value()),s.push([0,c]),c=c.mid;else break}const i=c.value;c.value=p,c.key=$;for(let o=s.length-1;o>=0;o--){const a=s[o][1];a.updateHeight();const u=a.balanceFactor();if(u<-1||u>1){const t=s[o][0],f=s[o+1][0];if(t===1&&f===1)s[o][1]=a.rotateLeft();else if(t===-1&&f===-1)s[o][1]=a.rotateRight();else if(t===1&&f===-1)a.right=s[o+1][1]=s[o+1][1].rotateRight(),s[o][1]=a.rotateLeft();else if(t===-1&&f===1)a.left=s[o+1][1]=s[o+1][1].rotateLeft(),s[o][1]=a.rotateRight();else throw new Error;if(o>0)switch(s[o-1][0]){case-1:s[o-1][1].left=s[o][1];break;case 1:s[o-1][1].right=s[o][1];break;case 0:s[o-1][1].mid=s[o][1];break}else this.c=s[0][1]}}return i}get($){return this.d($)?.value}d($){const p=this.b.reset($);let r=this.c;for(;r;){const c=p.cmp(r.segment);if(c>0)r=r.left;else if(c<0)r=r.right;else if(p.hasNext())p.next(),r=r.mid;else break}return r}has($){const p=this.d($);return!(p?.value===void 0&&p?.mid===void 0)}delete($){return this.e($,!1)}deleteSuperstr($){return this.e($,!0)}e($,p){const r=this.b.reset($),c=[];let s=this.c;for(;s;){const i=r.cmp(s.segment);if(i>0)c.push([-1,s]),s=s.left;else if(i<0)c.push([1,s]),s=s.right;else if(r.hasNext())r.next(),c.push([0,s]),s=s.mid;else break}if(s){if(p?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const i=this.f(s.right);if(i.key){const{key:o,value:a,segment:u}=i;this.e(i.key,!1),s.key=o,s.value=a,s.segment=u}}else{const i=s.left??s.right;if(c.length>0){const[o,a]=c[c.length-1];switch(o){case-1:a.left=i;break;case 0:a.mid=i;break;case 1:a.right=i;break}}else this.c=i}for(let i=c.length-1;i>=0;i--){const o=c[i][1];o.updateHeight();const a=o.balanceFactor();if(a>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),c[i][1]=o.rotateLeft()):a<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),c[i][1]=o.rotateRight()),i>0)switch(c[i-1][0]){case-1:c[i-1][1].left=c[i][1];break;case 1:c[i-1][1].right=c[i][1];break;case 0:c[i-1][1].mid=c[i][1];break}else this.c=c[0][1]}}}f($){for(;$.left;)$=$.left;return $}findSubstr($){const p=this.b.reset($);let r=this.c,c;for(;r;){const s=p.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(p.hasNext())p.next(),c=r.value||c,r=r.mid;else break}return r&&r.value||c}findSuperstr($){return this.g($,!1)}g($,p){const r=this.b.reset($);let c=this.c;for(;c;){const s=r.cmp(c.segment);if(s>0)c=c.left;else if(s<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else return c.mid?this.h(c.mid):p?c.value:void 0}}hasElementOrSubtree($){return this.g($,!0)!==void 0}forEach($){for(const[p,r]of this)$(r,p)}*[Symbol.iterator](){yield*this.h(this.c)}h($){const p=[];return this.j($,p),p[Symbol.iterator]()}j($,p){$&&($.left&&this.j($.left,p),$.value&&p.push([$.key,$.value]),$.mid&&this.j($.mid,p),$.right&&this.j($.right,p))}_isBalanced(){const $=p=>{if(!p)return!0;const r=p.balanceFactor();return r<-1||r>1?!1:$(p.left)&&$(p.right)};return $(this.c)}}e.$bi=D}),define(Re[40],Ae([1,0,89]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$ck=e.ThemeColor=void 0;var M;(function(L){function m(h){return h&&typeof h=="object"&&typeof h.id=="string"}L.isThemeColor=m})(M||(e.ThemeColor=M={}));function I(L){return{id:L}}e.$ck=I;var R;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function h(i){const o=m.exec(i.id);if(!o)return h(S.$bk.error);const[,a,u]=o,t=["codicon","codicon-"+a];return u&&t.push("codicon-modifier-"+u.substring(1)),t}L.asClassNameArray=h;function E(i){return h(i).join(" ")}L.asClassName=E;function A(i){return"."+h(i).join(".")}L.asCSSSelector=A;function D(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||M.isThemeColor(i.color))}L.isThemeIcon=D;const l=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function $(i){const o=l.exec(i);if(!o)return;const[,a]=o;return{id:a}}L.fromString=$;function p(i){return{id:i}}L.fromId=p;function r(i,o){let a=i.id;const u=a.lastIndexOf("~");return u!==-1&&(a=a.substring(0,u)),o&&(a=`${a}~${o}`),{id:a}}L.modify=r;function c(i){const o=i.id.lastIndexOf("~");if(o!==-1)return i.id.substring(o+1)}L.getModifier=c;function s(i,o){return i.id===o.id&&i.color?.id===o.color?.id}L.isEqual=s})(R||(e.ThemeIcon=R={}))}),define(Re[126],Ae([1,0,124,14,40]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=void 0;const R="$(",L=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${L.source}`,"g");function h(s){return s.replace(m,(i,o)=>o?i:`\\${i}`)}e.$dk=h;const E=new RegExp(`\\\\${L.source}`,"g");function A(s){return s.replace(E,i=>`\\${i}`)}e.$ek=A;const D=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function l(s){return s.indexOf(R)===-1?s:s.replace(D,(i,o,a,u)=>a?i:o||u||"")}e.$fk=l;function $(s){return s?s.replace(/\$\((.*?)\)/g,(i,o)=>` ${o} `).trim():""}e.$gk=$;const p=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(s){p.lastIndex=0;let i="";const o=[];let a=0;for(;;){const u=p.lastIndex,t=p.exec(s),f=s.substring(u,t?.index);if(f.length>0){i+=f;for(let n=0;n<f.length;n++)o.push(a)}if(!t)break;a+=t[0].length}return{text:i,iconOffsets:o}}e.$hk=r;function c(s,i,o=!1){const{text:a,iconOffsets:u}=i;if(!u||u.length===0)return(0,S.$3j)(s,a,o);const t=(0,M.$Ue)(a," "),f=a.length-t.length,n=(0,S.$3j)(s,t,o);if(n)for(const w of n){const y=u[w.start+f]+f;w.start+=y,w.end+=y}return n}e.$ik=c}),define(Re[33],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.$qg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(I){return S.test(I)}e.$qg=M,e.$rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(m){for(let h=0;h<m.length;h++)m[h]=Math.floor(Math.random()*256);return m};const R=new Uint8Array(16),L=[];for(let m=0;m<256;m++)L.push(m.toString(16).padStart(2,"0"));return function(){I(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let h=0,E="";return E+=L[R[h++]],E+=L[R[h++]],E+=L[R[h++]],E+=L[R[h++]],E+="-",E+=L[R[h++]],E+=L[R[h++]],E+="-",E+=L[R[h++]],E+=L[R[h++]],E+="-",E+=L[R[h++]],E+=L[R[h++]],E+="-",E+=L[R[h++]],E+=L[R[h++]],E+=L[R[h++]],E+=L[R[h++]],E+=L[R[h++]],E+=L[R[h++]],E}}()}),define(Re[127],Ae([1,0,18,68,33]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$st=e.$rt=e.$qt=e.$pt=void 0;function R(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$pt=R;function L(D,l,$){const p={id:(0,I.$rg)(),name:D,uri:l,data:$};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.$qt=L;class m{constructor(){this.a=new Map}get size(){let l=0;for(const $ of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const $=[...this.a.keys()];return M.Iterable.some(this,([p,r])=>r.asFile())&&$.push("files"),A(h(l),$)}get(l){return this.a.get(this.b(l))?.[0]}append(l,$){const p=this.a.get(l);p?p.push($):this.a.set(this.b(l),[$])}replace(l,$){this.a.set(this.b(l),[$])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,$]of this.a)for(const p of $)yield[l,p]}b(l){return h(l)}}e.$rt=m;function h(D){return D.toLowerCase()}function E(D,l){return A(h(D),l.map(h))}e.$st=E;function A(D,l){if(D==="*/*")return l.length>0;if(l.includes(D))return!0;const $=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!$)return!1;const[p,r,c]=$;return c==="*"?l.some(s=>s.startsWith(r+"/")):!1}e.$tt=Object.freeze({create:D=>(0,S.$Mb)(D.map(l=>l.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$tt.split(D).filter(l=>!l.startsWith("#"))})}),define(Re[128],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.StringEOL=void 0;var S;(function(I){I[I.Unknown=0]="Unknown",I[I.Invalid=3]="Invalid",I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})(S||(e.StringEOL=S={}));function M(I){let R=0,L=0,m=0,h=0;for(let E=0,A=I.length;E<A;E++){const D=I.charCodeAt(E);D===13?(R===0&&(L=E),R++,E+1<A&&I.charCodeAt(E+1)===10?(h|=2,E++):h|=3,m=E+1):D===10&&(h|=1,R===0&&(L=E),R++,m=E+1)}return R===0&&(L=I.length),[R,L,I.length-m,h]}e.$wt=M}),define(Re[129],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=void 0,e.$us={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[130],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.$Tt=e.IndentAction=void 0;var S;(function(L){L[L.None=0]="None",L[L.Indent=1]="Indent",L[L.IndentOutdent=2]="IndentOutdent",L[L.Outdent=3]="Outdent"})(S||(e.IndentAction=S={}));class M{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let h=0,E=m.notIn.length;h<E;h++)switch(m.notIn[h]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,h){if(m.getTokenCount()===0)return!0;const E=m.findTokenIndexAtOffset(h-2),A=m.getStandardTokenType(E);return this.isOK(A)}g(m,h){for(let E=m;E<=h;E++){const A=String.fromCharCode(E);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Tt=M;class I{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const h of m)R(this.autoClosingPairsOpenByStart,h.open.charAt(0),h),R(this.autoClosingPairsOpenByEnd,h.open.charAt(h.open.length-1),h),R(this.autoClosingPairsCloseByStart,h.close.charAt(0),h),R(this.autoClosingPairsCloseByEnd,h.close.charAt(h.close.length-1),h),h.close.length===1&&h.open.length===1&&R(this.autoClosingPairsCloseSingleChar,h.close,h)}}e.$Ut=I;function R(L,m,h){L.has(m)?L.get(m).push(h):L.set(m,[h])}}),define(Re[131],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4B=e.$3B=e.$2B=e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.NodeColor=e.$UB=void 0;class S{constructor(c,s){this.piece=c,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$VB)return I(this.right);let c=this;for(;c.parent!==e.$VB&&c.parent.left!==c;)c=c.parent;return c.parent===e.$VB?e.$VB:c.parent}prev(){if(this.left!==e.$VB)return R(this.left);let c=this;for(;c.parent!==e.$VB&&c.parent.right!==c;)c=c.parent;return c.parent===e.$VB?e.$VB:c.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$UB=S;var M;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(M||(e.NodeColor=M={})),e.$VB=new S(null,0),e.$VB.parent=e.$VB,e.$VB.left=e.$VB,e.$VB.right=e.$VB,e.$VB.color=0;function I(r){for(;r.left!==e.$VB;)r=r.left;return r}e.$WB=I;function R(r){for(;r.right!==e.$VB;)r=r.right;return r}e.$XB=R;function L(r){return r===e.$VB?0:r.size_left+r.piece.length+L(r.right)}function m(r){return r===e.$VB?0:r.lf_left+r.piece.lineFeedCnt+m(r.right)}function h(){e.$VB.parent=e.$VB}function E(r,c){const s=c.right;s.size_left+=c.size_left+(c.piece?c.piece.length:0),s.lf_left+=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),c.right=s.left,s.left!==e.$VB&&(s.left.parent=c),s.parent=c.parent,c.parent===e.$VB?r.root=s:c.parent.left===c?c.parent.left=s:c.parent.right=s,s.left=c,c.parent=s}e.$YB=E;function A(r,c){const s=c.left;c.left=s.right,s.right!==e.$VB&&(s.right.parent=c),s.parent=c.parent,c.size_left-=s.size_left+(s.piece?s.piece.length:0),c.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),c.parent===e.$VB?r.root=s:c===c.parent.right?c.parent.right=s:c.parent.left=s,s.right=c,c.parent=s}e.$ZB=A;function D(r,c){let s,i;if(c.left===e.$VB?(i=c,s=i.right):c.right===e.$VB?(i=c,s=i.left):(i=I(c.right),s=i.right),i===r.root){r.root=s,s.color=0,c.detach(),h(),r.root.parent=e.$VB;return}const o=i.color===1;if(i===i.parent.left?i.parent.left=s:i.parent.right=s,i===c?(s.parent=i.parent,p(r,s)):(i.parent===c?s.parent=i:s.parent=i.parent,p(r,s),i.left=c.left,i.right=c.right,i.parent=c.parent,i.color=c.color,c===r.root?r.root=i:c===c.parent.left?c.parent.left=i:c.parent.right=i,i.left!==e.$VB&&(i.left.parent=i),i.right!==e.$VB&&(i.right.parent=i),i.size_left=c.size_left,i.lf_left=c.lf_left,p(r,i)),c.detach(),s.parent.left===s){const u=L(s),t=m(s);if(u!==s.parent.size_left||t!==s.parent.lf_left){const f=u-s.parent.size_left,n=t-s.parent.lf_left;s.parent.size_left=u,s.parent.lf_left=t,$(r,s.parent,f,n)}}if(p(r,s.parent),o){h();return}let a;for(;s!==r.root&&s.color===0;)s===s.parent.left?(a=s.parent.right,a.color===1&&(a.color=0,s.parent.color=1,E(r,s.parent),a=s.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.right.color===0&&(a.left.color=0,a.color=1,A(r,a),a=s.parent.right),a.color=s.parent.color,s.parent.color=0,a.right.color=0,E(r,s.parent),s=r.root)):(a=s.parent.left,a.color===1&&(a.color=0,s.parent.color=1,A(r,s.parent),a=s.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.left.color===0&&(a.right.color=0,a.color=1,E(r,a),a=s.parent.left),a.color=s.parent.color,s.parent.color=0,a.left.color=0,A(r,s.parent),s=r.root));s.color=0,h()}e.$1B=D;function l(r,c){for(p(r,c);c!==r.root&&c.parent.color===1;)if(c.parent===c.parent.parent.left){const s=c.parent.parent.right;s.color===1?(c.parent.color=0,s.color=0,c.parent.parent.color=1,c=c.parent.parent):(c===c.parent.right&&(c=c.parent,E(r,c)),c.parent.color=0,c.parent.parent.color=1,A(r,c.parent.parent))}else{const s=c.parent.parent.left;s.color===1?(c.parent.color=0,s.color=0,c.parent.parent.color=1,c=c.parent.parent):(c===c.parent.left&&(c=c.parent,A(r,c)),c.parent.color=0,c.parent.parent.color=1,E(r,c.parent.parent))}r.root.color=0}e.$2B=l;function $(r,c,s,i){for(;c!==r.root&&c!==e.$VB;)c.parent.left===c&&(c.parent.size_left+=s,c.parent.lf_left+=i),c=c.parent}e.$3B=$;function p(r,c){let s=0,i=0;if(c!==r.root){for(;c!==r.root&&c===c.parent.right;)c=c.parent;if(c!==r.root)for(c=c.parent,s=L(c.left)-c.size_left,i=m(c.left)-c.lf_left,c.size_left+=s,c.lf_left+=i;c!==r.root&&(s!==0||i!==0);)c.parent.left===c&&(c.parent.size_left+=s,c.parent.lf_left+=i),c=c.parent}}e.$4B=p}),define(Re[90],Ae([1,0,91,29,92,131,93]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=e.$bC=e.$aC=e.$_B=e.$$B=void 0;const m=65535;function h(s){let i;return s[s.length-1]<65536?i=new Uint16Array(s.length):i=new Uint32Array(s.length),i.set(s,0),i}class E{constructor(i,o,a,u,t){this.lineStarts=i,this.cr=o,this.lf=a,this.crlf=u,this.isBasicASCII=t}}function A(s,i=!0){const o=[0];let a=1;for(let u=0,t=s.length;u<t;u++){const f=s.charCodeAt(u);f===13?u+1<t&&s.charCodeAt(u+1)===10?(o[a++]=u+2,u++):o[a++]=u+1:f===10&&(o[a++]=u+1)}return i?h(o):o}e.$$B=A;function D(s,i){s.length=0,s[0]=0;let o=1,a=0,u=0,t=0,f=!0;for(let w=0,y=i.length;w<y;w++){const d=i.charCodeAt(w);d===13?w+1<y&&i.charCodeAt(w+1)===10?(t++,s[o++]=w+2,w++):(a++,s[o++]=w+1):d===10?(u++,s[o++]=w+1):f&&d!==9&&(d<32||d>126)&&(f=!1)}const n=new E(h(s),a,u,t,f);return s.length=0,n}e.$_B=D;class l{constructor(i,o,a,u,t){this.bufferIndex=i,this.start=o,this.end=a,this.lineFeedCnt=u,this.length=t}}e.$aC=l;class ${constructor(i,o){this.buffer=i,this.lineStarts=o}}e.$bC=$;class p{constructor(i,o){this.a=[],this.c=i,this.d=o,this.b=0,i.root!==R.$VB&&i.iterate(i.root,a=>(a!==R.$VB&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(i){this.a=i,this.b=[]}get(i){for(let o=this.b.length-1;o>=0;o--){const a=this.b[o];if(a.nodeStartOffset<=i&&a.nodeStartOffset+a.node.piece.length>=i)return a}return null}get2(i){for(let o=this.b.length-1;o>=0;o--){const a=this.b[o];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<i&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=i)return a}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let o=!1;const a=this.b;for(let u=0;u<a.length;u++){const t=a[u];if(t.node.parent===null||t.nodeStartOffset>=i){a[u]=null,o=!0;continue}}if(o){const u=[];for(const t of a)t!==null&&u.push(t);this.b=u}}}class c{constructor(i,o,a){this.create(i,o,a)}create(i,o,a){this.a=[new $("",[0])],this.g={line:0,column:0},this.root=R.$VB,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=a;let u=null;for(let t=0,f=i.length;t<f;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=A(i[t].buffer));const n=new l(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),u=this.S(u,n)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const o=m,a=o-Math.floor(o/3),u=a*2;let t="",f=0;const n=[];if(this.iterate(this.root,w=>{const y=this.R(w),d=y.length;if(f<=a||f+d<u)return t+=y,f+=d,!0;const b=t.replace(/\r\n|\r|\n/g,i);return n.push(new $(b,A(b))),t=y,f=d,!0}),f>0){const w=t.replace(/\r\n|\r|\n/g,i);n.push(new $(w,A(w)))}this.create(n,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new p(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let o=0;return this.iterate(this.root,u=>{if(u===R.$VB)return!0;const t=this.R(u),f=t.length,n=i.G(o),w=i.G(o+f),y=i.getValueInRange2(n,w);return o+=f,t===y})}getOffsetAt(i,o){let a=0,u=this.root;for(;u!==R.$VB;)if(u.left!==R.$VB&&u.lf_left+1>=i)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt+1>=i){a+=u.size_left;const t=this.B(u,i-u.lf_left-2);return a+=t+o-1}else i-=u.lf_left+u.piece.lineFeedCnt,a+=u.size_left+u.piece.length,u=u.right;return a}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let o=this.root,a=0;const u=i;for(;o!==R.$VB;)if(o.size_left!==0&&o.size_left>=i)o=o.left;else if(o.size_left+o.piece.length>=i){const t=this.A(o,i-o.size_left);if(a+=o.lf_left+t.index,t.index===0){const f=this.getOffsetAt(a+1,1),n=u-f;return new S.$Vs(a+1,n+1)}return new S.$Vs(a+1,t.remainder+1)}else if(i-=o.size_left+o.piece.length,a+=o.lf_left+o.piece.lineFeedCnt,o.right===R.$VB){const t=this.getOffsetAt(a+1,1),f=u-i-t;return new S.$Vs(a+1,f+1)}else o=o.right;return new S.$Vs(1,1)}getValueInRange(i,o){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const a=this.H(i.startLineNumber,i.startColumn),u=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(a,u);return o?o!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,o):t}getValueInRange2(i,o){if(i.node===o.node){const n=i.node,w=this.a[n.piece.bufferIndex].buffer,y=this.u(n.piece.bufferIndex,n.piece.start);return w.substring(y+i.remainder,y+o.remainder)}let a=i.node;const u=this.a[a.piece.bufferIndex].buffer,t=this.u(a.piece.bufferIndex,a.piece.start);let f=u.substring(t+i.remainder,t+a.piece.length);for(a=a.next();a!==R.$VB;){const n=this.a[a.piece.bufferIndex].buffer,w=this.u(a.piece.bufferIndex,a.piece.start);if(a===o.node){f+=n.substring(w,w+o.remainder);break}else f+=n.substr(w,a.piece.length);a=a.next()}return f}getLinesContent(){const i=[];let o=0,a="",u=!1;return this.iterate(this.root,t=>{if(t===R.$VB)return!0;const f=t.piece;let n=f.length;if(n===0)return!0;const w=this.a[f.bufferIndex].buffer,y=this.a[f.bufferIndex].lineStarts,d=f.start.line,b=f.end.line;let P=y[d]+f.start.column;if(u&&(w.charCodeAt(P)===10&&(P++,n--),i[o++]=a,a="",u=!1,n===0))return!0;if(d===b)return!this.f&&w.charCodeAt(P+n-1)===13?(u=!0,a+=w.substr(P,n-1)):a+=w.substr(P,n),!0;a+=this.f?w.substring(P,Math.max(P,y[d+1]-this.e)):w.substring(P,y[d+1]).replace(/(\r\n|\r|\n)$/,""),i[o++]=a;for(let g=d+1;g<b;g++)a=this.f?w.substring(y[g],y[g+1]-this.e):w.substring(y[g],y[g+1]).replace(/(\r\n|\r|\n)$/,""),i[o++]=a;return!this.f&&w.charCodeAt(y[b]+f.end.column-1)===13?(u=!0,f.end.column===0?o--:a=w.substr(y[b],f.end.column-1)):a=w.substr(y[b],f.end.column),!0}),u&&(i[o++]=a,a=""),i[o++]=a,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const o=i.node.next();if(!o)return 0;const a=this.a[o.piece.bufferIndex],u=this.u(o.piece.bufferIndex,o.piece.start);return a.buffer.charCodeAt(u)}else{const o=this.a[i.node.piece.bufferIndex],u=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return o.buffer.charCodeAt(u)}}getLineCharCode(i,o){const a=this.H(i,o+1);return this.l(a)}getLineLength(i){if(i===this.getLineCount()){const o=this.getOffsetAt(i,1);return this.getLength()-o}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const o=this.G(i);return this.l(o)}findMatchesInNode(i,o,a,u,t,f,n,w,y,d,b){const P=this.a[i.piece.bufferIndex],g=this.u(i.piece.bufferIndex,i.piece.start),v=this.u(i.piece.bufferIndex,t),k=this.u(i.piece.bufferIndex,f);let F;const O={line:0,column:0};let G,q;o._wordSeparators?(G=P.buffer.substring(v,k),q=U=>U+v,o.reset(0)):(G=P.buffer,q=U=>U,o.reset(v));do if(F=o.next(G),F){if(q(F.index)>=k)return d;this.s(i,q(F.index)-g,O);const U=this.t(i.piece.bufferIndex,t,O),C=O.line===t.line?O.column-t.column+u:O.column+1,N=C+F[0].length;if(b[d++]=(0,L.$7B)(new M.$Ws(a+U,C,a+U,N),F,w),q(F.index)+F[0].length>=k||d>=y)return d}while(F);return d}findMatchesLineByLine(i,o,a,u){const t=[];let f=0;const n=new L.$0B(o.wordSeparators,o.regex);let w=this.H(i.startLineNumber,i.startColumn);if(w===null)return[];const y=this.H(i.endLineNumber,i.endColumn);if(y===null)return[];let d=this.s(w.node,w.remainder);const b=this.s(y.node,y.remainder);if(w.node===y.node)return this.findMatchesInNode(w.node,n,i.startLineNumber,i.startColumn,d,b,o,a,u,f,t),t;let P=i.startLineNumber,g=w.node;for(;g!==y.node;){const k=this.t(g.piece.bufferIndex,d,g.piece.end);if(k>=1){const O=this.a[g.piece.bufferIndex].lineStarts,G=this.u(g.piece.bufferIndex,g.piece.start),q=O[d.line+k],U=P===i.startLineNumber?i.startColumn:1;if(f=this.findMatchesInNode(g,n,P,U,d,this.s(g,q-G),o,a,u,f,t),f>=u)return t;P+=k}const F=P===i.startLineNumber?i.startColumn-1:0;if(P===i.endLineNumber){const O=this.getLineContent(P).substring(F,i.endColumn-1);return f=this.n(o,n,O,i.endLineNumber,F,f,t,a,u),t}if(f=this.n(o,n,this.getLineContent(P).substr(F),P,F,f,t,a,u),f>=u)return t;P++,w=this.H(P,1),g=w.node,d=this.s(w.node,w.remainder)}if(P===i.endLineNumber){const k=P===i.startLineNumber?i.startColumn-1:0,F=this.getLineContent(P).substring(k,i.endColumn-1);return f=this.n(o,n,F,i.endLineNumber,k,f,t,a,u),t}const v=P===i.startLineNumber?i.startColumn:1;return f=this.findMatchesInNode(y.node,n,P,v,d,b,o,a,u,f,t),t}n(i,o,a,u,t,f,n,w,y){const d=i.wordSeparators;if(!w&&i.simpleSearch){const P=i.simpleSearch,g=P.length,v=a.length;let k=-g;for(;(k=a.indexOf(P,k+g))!==-1;)if((!d||(0,L.$9B)(d,a,v,k,g))&&(n[f++]=new I.$cv(new M.$Ws(u,k+1+t,u,k+1+g+t),null),f>=y))return f;return f}let b;o.reset(0);do if(b=o.next(a),b&&(n[f++]=(0,L.$7B)(new M.$Ws(u,b.index+1+t,u,b.index+1+b[0].length+t),b,w),f>=y))return f;while(b);return f}insert(i,o,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==R.$VB){const{node:u,remainder:t,nodeStartOffset:f}=this.G(i),n=u.piece,w=n.bufferIndex,y=this.s(u,t);if(u.piece.bufferIndex===0&&n.end.line===this.g.line&&n.end.column===this.g.column&&f+n.length===i&&o.length<m){this.F(u,o),this.y();return}if(f===i)this.o(o,u),this.h.validate(i);else if(f+u.piece.length>i){const d=[];let b=new l(n.bufferIndex,y,n.end,this.t(n.bufferIndex,y,n.end),this.u(w,n.end)-this.u(w,y));if(this.K()&&this.M(o)&&this.I(u,t)===10){const k={line:b.start.line+1,column:0};b=new l(b.bufferIndex,k,b.end,this.t(b.bufferIndex,k,b.end),b.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(u,t-1)===13){const k=this.s(u,t-1);this.C(u,k),o="\r"+o,u.piece.length===0&&d.push(u)}else this.C(u,y);else this.C(u,y);const P=this.w(o);b.length>0&&this.S(u,b);let g=u;for(let v=0;v<P.length;v++)g=this.S(g,P[v]);this.v(d)}else this.q(o,u)}else{const u=this.w(o);let t=this.T(null,u[0]);for(let f=1;f<u.length;f++)t=this.S(t,u[f])}this.y()}delete(i,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===R.$VB)return;const a=this.G(i),u=this.G(i+o),t=a.node,f=u.node;if(t===f){const P=this.s(t,a.remainder),g=this.s(t,u.remainder);if(a.nodeStartOffset===i){if(o===t.piece.length){const v=t.next();(0,R.$1B)(this,t),this.N(v),this.y();return}this.D(t,g),this.h.validate(i),this.N(t),this.y();return}if(a.nodeStartOffset+t.piece.length===i+o){this.C(t,P),this.O(t),this.y();return}this.E(t,P,g),this.y();return}const n=[],w=this.s(t,a.remainder);this.C(t,w),this.h.validate(i),t.piece.length===0&&n.push(t);const y=this.s(f,u.remainder);this.D(f,y),f.piece.length===0&&n.push(f);const d=t.next();for(let P=d;P!==R.$VB&&P!==f;P=P.next())n.push(P);const b=t.piece.length===0?t.prev():t;this.v(n),this.O(b),this.y()}o(i,o){const a=[];if(this.K()&&this.M(i)&&this.L(o)){const f=o.piece,n={line:f.start.line+1,column:0},w=new l(f.bufferIndex,n,f.end,this.t(f.bufferIndex,n,f.end),f.length-1);o.piece=w,i+=`
`,(0,R.$3B)(this,o,-1,-1),o.piece.length===0&&a.push(o)}const u=this.w(i);let t=this.T(o,u[u.length-1]);for(let f=u.length-2;f>=0;f--)t=this.T(t,u[f]);this.N(t),this.v(a)}q(i,o){this.Q(i,o)&&(i+=`
`);const a=this.w(i),u=this.S(o,a[0]);let t=u;for(let f=1;f<a.length;f++)t=this.S(t,a[f]);this.N(u)}s(i,o,a){const u=i.piece,t=i.piece.bufferIndex,f=this.a[t].lineStarts,w=f[u.start.line]+u.start.column+o;let y=u.start.line,d=u.end.line,b=0,P=0,g=0;for(;y<=d&&(b=y+(d-y)/2|0,g=f[b],b!==d);)if(P=f[b+1],w<g)d=b-1;else if(w>=P)y=b+1;else break;return a?(a.line=b,a.column=w-g,null):{line:b,column:w-g}}t(i,o,a){if(a.column===0)return a.line-o.line;const u=this.a[i].lineStarts;if(a.line===u.length-1)return a.line-o.line;const t=u[a.line+1],f=u[a.line]+a.column;if(t>f+1)return a.line-o.line;const n=f-1;return this.a[i].buffer.charCodeAt(n)===13?a.line-o.line+1:a.line-o.line}u(i,o){return this.a[i].lineStarts[o.line]+o.column}v(i){for(let o=0;o<i.length;o++)(0,R.$1B)(this,i[o])}w(i){if(i.length>m){const d=[];for(;i.length>m;){const P=i.charCodeAt(m-1);let g;P===13||P>=55296&&P<=56319?(g=i.substring(0,m-1),i=i.substring(m-1)):(g=i.substring(0,m),i=i.substring(m));const v=A(g);d.push(new l(this.a.length,{line:0,column:0},{line:v.length-1,column:g.length-v[v.length-1]},v.length-1,g.length)),this.a.push(new $(g,v))}const b=A(i);return d.push(new l(this.a.length,{line:0,column:0},{line:b.length-1,column:i.length-b[b.length-1]},b.length-1,i.length)),this.a.push(new $(i,b)),d}let o=this.a[0].buffer.length;const a=A(i,!1);let u=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},u=this.g;for(let d=0;d<a.length;d++)a[d]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+i,o+=1}else{if(o!==0)for(let d=0;d<a.length;d++)a[d]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,n=t-this.a[0].lineStarts[f],w={line:f,column:n},y=new l(0,u,w,this.t(0,u,w),t-o);return this.g=w,[y]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,o=0){let a=this.root,u="";const t=this.h.get2(i);if(t){a=t.node;const f=this.B(a,i-t.nodeStartLineNumber-1),n=this.a[a.piece.bufferIndex].buffer,w=this.u(a.piece.bufferIndex,a.piece.start);if(t.nodeStartLineNumber+a.piece.lineFeedCnt===i)u=n.substring(w+f,w+a.piece.length);else{const y=this.B(a,i-t.nodeStartLineNumber);return n.substring(w+f,w+y-o)}}else{let f=0;const n=i;for(;a!==R.$VB;)if(a.left!==R.$VB&&a.lf_left>=i-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>i-1){const w=this.B(a,i-a.lf_left-2),y=this.B(a,i-a.lf_left-1),d=this.a[a.piece.bufferIndex].buffer,b=this.u(a.piece.bufferIndex,a.piece.start);return f+=a.size_left,this.h.set({node:a,nodeStartOffset:f,nodeStartLineNumber:n-(i-1-a.lf_left)}),d.substring(b+w,b+y-o)}else if(a.lf_left+a.piece.lineFeedCnt===i-1){const w=this.B(a,i-a.lf_left-2),y=this.a[a.piece.bufferIndex].buffer,d=this.u(a.piece.bufferIndex,a.piece.start);u=y.substring(d+w,d+a.piece.length);break}else i-=a.lf_left+a.piece.lineFeedCnt,f+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==R.$VB;){const f=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const n=this.B(a,0),w=this.u(a.piece.bufferIndex,a.piece.start);return u+=f.substring(w,w+n-o),u}else{const n=this.u(a.piece.bufferIndex,a.piece.start);u+=f.substr(n,a.piece.length)}a=a.next()}return u}y(){let i=this.root,o=1,a=0;for(;i!==R.$VB;)o+=i.lf_left+i.piece.lineFeedCnt,a+=i.size_left+i.piece.length,i=i.right;this.b=o,this.c=a,this.h.validate(this.c)}A(i,o){const a=i.piece,u=this.s(i,o),t=u.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===o){const f=this.t(i.piece.bufferIndex,a.start,u);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:u.column}}B(i,o){if(o<0)return 0;const a=i.piece,u=this.a[a.bufferIndex].lineStarts,t=a.start.line+o+1;return t>a.end.line?u[a.end.line]+a.end.column-u[a.start.line]-a.start.column:u[t]-u[a.start.line]-a.start.column}C(i,o){const a=i.piece,u=a.lineFeedCnt,t=this.u(a.bufferIndex,a.end),f=o,n=this.u(a.bufferIndex,f),w=this.t(a.bufferIndex,a.start,f),y=w-u,d=n-t,b=a.length+d;i.piece=new l(a.bufferIndex,a.start,f,w,b),(0,R.$3B)(this,i,d,y)}D(i,o){const a=i.piece,u=a.lineFeedCnt,t=this.u(a.bufferIndex,a.start),f=o,n=this.t(a.bufferIndex,f,a.end),w=this.u(a.bufferIndex,f),y=n-u,d=t-w,b=a.length+d;i.piece=new l(a.bufferIndex,f,a.end,n,b),(0,R.$3B)(this,i,d,y)}E(i,o,a){const u=i.piece,t=u.start,f=u.end,n=u.length,w=u.lineFeedCnt,y=o,d=this.t(u.bufferIndex,u.start,y),b=this.u(u.bufferIndex,o)-this.u(u.bufferIndex,t);i.piece=new l(u.bufferIndex,u.start,y,d,b),(0,R.$3B)(this,i,b-n,d-w);const P=new l(u.bufferIndex,a,f,this.t(u.bufferIndex,a,f),this.u(u.bufferIndex,f)-this.u(u.bufferIndex,a)),g=this.S(i,P);this.N(g)}F(i,o){this.Q(o,i)&&(o+=`
`);const a=this.K()&&this.L(o)&&this.M(i),u=this.a[0].buffer.length;this.a[0].buffer+=o;const t=A(o,!1);for(let g=0;g<t.length;g++)t[g]+=u;if(a){const g=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:u-g}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const f=this.a[0].lineStarts.length-1,n=this.a[0].buffer.length-this.a[0].lineStarts[f],w={line:f,column:n},y=i.piece.length+o.length,d=i.piece.lineFeedCnt,b=this.t(0,i.piece.start,w),P=b-d;i.piece=new l(i.piece.bufferIndex,i.piece.start,w,b,y),this.g=w,(0,R.$3B)(this,i,o.length,P)}G(i){let o=this.root;const a=this.h.get(i);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:i-a.nodeStartOffset};let u=0;for(;o!==R.$VB;)if(o.size_left>i)o=o.left;else if(o.size_left+o.piece.length>=i){u+=o.size_left;const t={node:o,remainder:i-o.size_left,nodeStartOffset:u};return this.h.set(t),t}else i-=o.size_left+o.piece.length,u+=o.size_left+o.piece.length,o=o.right;return null}H(i,o){let a=this.root,u=0;for(;a!==R.$VB;)if(a.left!==R.$VB&&a.lf_left>=i-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>i-1){const t=this.B(a,i-a.lf_left-2),f=this.B(a,i-a.lf_left-1);return u+=a.size_left,{node:a,remainder:Math.min(t+o-1,f),nodeStartOffset:u}}else if(a.lf_left+a.piece.lineFeedCnt===i-1){const t=this.B(a,i-a.lf_left-2);if(t+o-1<=a.piece.length)return{node:a,remainder:t+o-1,nodeStartOffset:u};o-=a.piece.length-t;break}else i-=a.lf_left+a.piece.lineFeedCnt,u+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==R.$VB;){if(a.piece.lineFeedCnt>0){const t=this.B(a,0),f=this.J(a);return{node:a,remainder:Math.min(o-1,t),nodeStartOffset:f}}else if(a.piece.length>=o-1){const t=this.J(a);return{node:a,remainder:o-1,nodeStartOffset:t}}else o-=a.piece.length;a=a.next()}return null}I(i,o){if(i.piece.lineFeedCnt<1)return-1;const a=this.a[i.piece.bufferIndex],u=this.u(i.piece.bufferIndex,i.piece.start)+o;return a.buffer.charCodeAt(u)}J(i){if(!i)return 0;let o=i.size_left;for(;i!==this.root;)i.parent.right===i&&(o+=i.parent.size_left+i.parent.piece.length),i=i.parent;return o}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===R.$VB||i.piece.lineFeedCnt===0)return!1;const o=i.piece,a=this.a[o.bufferIndex].lineStarts,u=o.start.line,t=a[u]+o.start.column;return u===a.length-1||a[u+1]>t+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===R.$VB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const o=i.prev();this.M(o)&&this.P(o,i)}}O(i){if(this.K()&&this.M(i)){const o=i.next();this.L(o)&&this.P(i,o)}}P(i,o){const a=[],u=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:u[i.piece.end.line]-u[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const f=i.piece.length-1,n=i.piece.lineFeedCnt-1;i.piece=new l(i.piece.bufferIndex,i.piece.start,t,n,f),(0,R.$3B)(this,i,-1,-1),i.piece.length===0&&a.push(i);const w={line:o.piece.start.line+1,column:0},y=o.piece.length-1,d=this.t(o.piece.bufferIndex,w,o.piece.end);o.piece=new l(o.piece.bufferIndex,w,o.piece.end,d,y),(0,R.$3B)(this,o,-1,-1),o.piece.length===0&&a.push(o);const b=this.w(`\r
`);this.S(i,b[0]);for(let P=0;P<a.length;P++)(0,R.$1B)(this,a[P])}Q(i,o){if(this.K()&&this.M(i)){const a=o.next();if(this.L(a)){if(i+=`
`,a.piece.length===1)(0,R.$1B)(this,a);else{const u=a.piece,t={line:u.start.line+1,column:0},f=u.length-1,n=this.t(u.bufferIndex,t,u.end);a.piece=new l(u.bufferIndex,t,u.end,n,f),(0,R.$3B)(this,a,-1,-1)}return!0}}return!1}iterate(i,o){if(i===R.$VB)return o(R.$VB);const a=this.iterate(i.left,o);return a&&o(i)&&this.iterate(i.right,o)}R(i){if(i===R.$VB)return"";const o=this.a[i.piece.bufferIndex],a=i.piece,u=this.u(a.bufferIndex,a.start),t=this.u(a.bufferIndex,a.end);return o.buffer.substring(u,t)}getPieceContent(i){const o=this.a[i.bufferIndex],a=this.u(i.bufferIndex,i.start),u=this.u(i.bufferIndex,i.end);return o.buffer.substring(a,u)}S(i,o){const a=new R.$UB(o,1);if(a.left=R.$VB,a.right=R.$VB,a.parent=R.$VB,a.size_left=0,a.lf_left=0,this.root===R.$VB)this.root=a,a.color=0;else if(i.right===R.$VB)i.right=a,a.parent=i;else{const t=(0,R.$WB)(i.right);t.left=a,a.parent=t}return(0,R.$2B)(this,a),a}T(i,o){const a=new R.$UB(o,1);if(a.left=R.$VB,a.right=R.$VB,a.parent=R.$VB,a.size_left=0,a.lf_left=0,this.root===R.$VB)this.root=a,a.color=0;else if(i.left===R.$VB)i.left=a,a.parent=i;else{const u=(0,R.$XB)(i.left);u.right=a,a.parent=u}return(0,R.$2B)(this,a),a}U(i){let o="";return this.iterate(i,a=>(o+=this.R(a),!0)),o}}e.$cC=c}),define(Re[132],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M8=e.$L8=void 0;class S{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const L=this.a.get(R);return this.a.delete(R),L}}addDragOperationTransfer(R,L){this.a.set(R,L)}}e.$L8=S;class M{constructor(R){this.identifier=R}}e.$M8=M}),define(Re[133],Ae([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Re[134],Ae([1,0,5,6,133]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=void 0;class R extends M.$Tc{constructor(l,$="",p="",r=!0,c){super(),this.h=this.B(new S.$Wd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=$,this.u=p,this.w=r,this.C=c}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,$){this.C&&await this.C(l)}}e.$Mi=R;class L extends M.$Tc{constructor(){super(...arguments),this.f=this.B(new S.$Wd),this.onWillRun=this.f.event,this.m=this.B(new S.$Wd),this.onDidRun=this.m.event}async run(l,$){if(!l.enabled)return;this.f.fire({action:l});let p;try{await this.u(l,$)}catch(r){p=r}this.m.fire({action:l,error:p})}async u(l,$){await l.run($)}}e.$Ni=L;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let $=[];for(const p of l)p.length&&($.length?$=[...$,new m,...p]:$=p);return $}static{this.ID="vs.actions.separator"}async run(){}}e.$Oi=m;class h{get actions(){return this.a}constructor(l,$,p,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=$,this.class=r,this.a=p}async run(){}}e.$Pi=h;class E extends R{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,I.localize(0,null),void 0,!1)}}e.$Qi=E;function A(D){return{id:D.id,label:D.label,class:D.class,enabled:D.enabled??!0,checked:D.checked,run:async(...l)=>D.run(...l),tooltip:D.label}}e.$Ri=A}),define(Re[135],Ae([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(Re[136],Ae([1,0,135]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0;const M=60,I=M*60,R=I*24,L=R*7,m=R*30,h=R*365;function E(l,$,p,r){typeof l!="number"&&(l=l.getTime());const c=Math.round((new Date().getTime()-l)/1e3);if(c<-30)return(0,S.localize)(0,null,E(new Date().getTime()+c*1e3,!1));if(!r&&c<30)return(0,S.localize)(1,null);let s;return c<M?(s=c,$?s===1?p?(0,S.localize)(2,null,s):(0,S.localize)(3,null,s):p?(0,S.localize)(4,null,s):(0,S.localize)(5,null,s):s===1?p?(0,S.localize)(6,null,s):(0,S.localize)(7,null,s):p?(0,S.localize)(8,null,s):(0,S.localize)(9,null,s)):c<I?(s=Math.floor(c/M),$?s===1?p?(0,S.localize)(10,null,s):(0,S.localize)(11,null,s):p?(0,S.localize)(12,null,s):(0,S.localize)(13,null,s):s===1?p?(0,S.localize)(14,null,s):(0,S.localize)(15,null,s):p?(0,S.localize)(16,null,s):(0,S.localize)(17,null,s)):c<R?(s=Math.floor(c/I),$?s===1?p?(0,S.localize)(18,null,s):(0,S.localize)(19,null,s):p?(0,S.localize)(20,null,s):(0,S.localize)(21,null,s):s===1?p?(0,S.localize)(22,null,s):(0,S.localize)(23,null,s):p?(0,S.localize)(24,null,s):(0,S.localize)(25,null,s)):c<L?(s=Math.floor(c/R),$?s===1?(0,S.localize)(26,null,s):(0,S.localize)(27,null,s):s===1?(0,S.localize)(28,null,s):(0,S.localize)(29,null,s)):c<m?(s=Math.floor(c/L),$?s===1?p?(0,S.localize)(30,null,s):(0,S.localize)(31,null,s):p?(0,S.localize)(32,null,s):(0,S.localize)(33,null,s):s===1?p?(0,S.localize)(34,null,s):(0,S.localize)(35,null,s):p?(0,S.localize)(36,null,s):(0,S.localize)(37,null,s)):c<h?(s=Math.floor(c/m),$?s===1?p?(0,S.localize)(38,null,s):(0,S.localize)(39,null,s):p?(0,S.localize)(40,null,s):(0,S.localize)(41,null,s):s===1?p?(0,S.localize)(42,null,s):(0,S.localize)(43,null,s):p?(0,S.localize)(44,null,s):(0,S.localize)(45,null,s)):(s=Math.floor(c/h),$?s===1?p?(0,S.localize)(46,null,s):(0,S.localize)(47,null,s):p?(0,S.localize)(48,null,s):(0,S.localize)(49,null,s):s===1?p?(0,S.localize)(50,null,s):(0,S.localize)(51,null,s):p?(0,S.localize)(52,null,s):(0,S.localize)(53,null,s))}e.$xm=E;function A(l,$){const p=Math.abs(l/1e3);return p<1?$?(0,S.localize)(54,null,l):(0,S.localize)(55,null,l):p<M?$?(0,S.localize)(56,null,Math.round(l)/1e3):(0,S.localize)(57,null,Math.round(l)/1e3):p<I?$?(0,S.localize)(58,null,Math.round(l/(1e3*M))):(0,S.localize)(59,null,Math.round(l/(1e3*M))):p<R?$?(0,S.localize)(60,null,Math.round(l/(1e3*I))):(0,S.localize)(61,null,Math.round(l/(1e3*I))):(0,S.localize)(62,null,Math.round(l/(1e3*R)))}e.$ym=A;function D(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$zm=D}),define(Re[137],Ae([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Re[41],Ae([1,0,18,16,137]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=void 0;function R(D,l){return l&&(D.stack||D.stacktrace)?I.localize(0,null,m(D),L(D.stack)||L(D.stacktrace)):m(D)}function L(D){return Array.isArray(D)?D.join(`
`):D}function m(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?I.localize(1,null,D.message):D.message||I.localize(2,null)}function h(D=null,l=!1){if(!D)return I.localize(3,null);if(Array.isArray(D)){const $=S.$Hb(D),p=h($[0],l);return $.length>1?I.localize(4,null,p,$.length):p}if(M.$Jf(D))return D;if(D.detail){const $=D.detail;if($.error)return R($.error,l);if($.exception)return R($.exception,l)}return D.stack?R(D,l):D.message?D.message:I.localize(5,null)}e.$Si=h;function E(D){const l=D;return l instanceof Error&&Array.isArray(l.actions)}e.$Ti=E;function A(D,l){let $;return typeof D=="string"?$=new Error(D):$=D,$.actions=l,$}e.$Ui=A}),define(Re[138],Ae([1,0,39,19]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=void 0;const I=new S.$V(()=>{const P=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:P,collatorIsNumeric:P.resolvedOptions().numeric}}),R=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(P,g,v=!1){const k=P||"",F=g||"",O=I.value.collator.compare(k,F);return I.value.collatorIsNumeric&&O===0&&k!==F?k<F?-1:1:O}e.$Kq=m;function h(P,g){const v=R.value.collator;return P=P||"",g=g||"",a(v,P,g)}e.$Lq=h;function E(P,g){const v=R.value.collator;return P=P||"",g=g||"",n(P,g)||a(v,P,g)}e.$Mq=E;function A(P,g){const v=R.value.collator;return P=P||"",g=g||"",f(P,g)||a(v,P,g)}e.$Nq=A;function D(P,g){return P=P||"",g=g||"",P===g?0:P<g?-1:1}e.$Oq=D;function l(P,g){const[v,k]=i(P),[F,O]=i(g);let G=I.value.collator.compare(k,O);if(G===0){if(I.value.collatorIsNumeric&&k!==O)return k<O?-1:1;if(G=I.value.collator.compare(v,F),I.value.collatorIsNumeric&&G===0&&v!==F)return v<F?-1:1}return G}e.$Pq=l;function $(P,g){P=P||"",g=g||"";const v=o(P),k=o(g),F=R.value.collator,O=L.value.collator;return a(O,v,k)||a(F,P,g)}e.$Qq=$;function p(P,g){P=P||"",g=g||"";const v=o(P),k=o(g),F=R.value.collator,O=L.value.collator;return a(O,v,k)||n(P,g)||a(F,P,g)}e.$Rq=p;function r(P,g){P=P||"",g=g||"";const v=o(P),k=o(g),F=R.value.collator,O=L.value.collator;return a(O,v,k)||f(P,g)||a(F,P,g)}e.$Sq=r;function c(P,g){P=P||"",g=g||"";const v=o(P).toLowerCase(),k=o(g).toLowerCase();return v!==k?v<k?-1:1:P!==g?P<g?-1:1:0}e.$Tq=c;const s=/^(.*?)(\.([^.]*))?$/;function i(P,g=!1){const v=P?s.exec(P):[];let k=[v&&v[1]||"",v&&v[3]||""];return g&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function o(P){const g=P?s.exec(P):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function a(P,g,v){const k=P.compare(g,v);return k!==0?k:g.length!==v.length?g.length<v.length?-1:1:0}function u(P){const g=P.charAt(0);return g.toLocaleUpperCase()!==g}function t(P){const g=P.charAt(0);return g.toLocaleLowerCase()!==g}function f(P,g){return u(P)&&t(g)?-1:t(P)&&u(g)?1:0}function n(P,g){return t(P)&&u(g)?-1:u(P)&&t(g)?1:0}function w(P,g,v=!1){return v||(P=P&&P.toLowerCase(),g=g&&g.toLowerCase()),P===g?0:P<g?-1:1}function y(P,g,v=!1){const k=P.split(M.sep),F=g.split(M.sep),O=k.length-1,G=F.length-1;let q,U;for(let C=0;;C++){if(q=O===C,U=G===C,q&&U)return m(k[C],F[C],v);if(q)return-1;if(U)return 1;const N=w(k[C],F[C],v);if(N!==0)return N}}e.$Uq=y;function d(P,g,v){const k=P.toLowerCase(),F=g.toLowerCase(),O=b(P,g,v);if(O)return O;const G=k.endsWith(v),q=F.endsWith(v);if(G!==q)return G?-1:1;const U=m(k,F);return U!==0?U:k.localeCompare(F)}e.$Vq=d;function b(P,g,v){const k=P.toLowerCase(),F=g.toLowerCase(),O=k.startsWith(v),G=F.startsWith(v);if(O!==G)return O?-1:1;if(O&&G){if(k.length<F.length)return-1;if(k.length>F.length)return 1}return 0}e.$Wq=b}),define(Re[45],Ae([1,0,19,20,14,16]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=void 0;function L(d){return d===47||d===92}e.$2f=L;function m(d){return d.replace(/[\\/]/g,S.$gc.sep)}e.$3f=m;function h(d){return d.indexOf("/")===-1&&(d=m(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$4f=h;function E(d,b=S.$gc.sep){if(!d)return"";const P=d.length,g=d.charCodeAt(0);if(L(g)){if(L(d.charCodeAt(1))&&!L(d.charCodeAt(2))){let k=3;const F=k;for(;k<P&&!L(d.charCodeAt(k));k++);if(F!==k&&!L(d.charCodeAt(k+1))){for(k+=1;k<P;k++)if(L(d.charCodeAt(k)))return d.slice(0,k+1).replace(/[\\/]/g,b)}}return b}else if(s(g)&&d.charCodeAt(1)===58)return L(d.charCodeAt(2))?d.slice(0,2)+b:d.slice(0,2);let v=d.indexOf("://");if(v!==-1){for(v+=3;v<P;v++)if(L(d.charCodeAt(v)))return d.slice(0,v+1)}return""}e.$5f=E;function A(d){if(!M.$i||!d||d.length<5)return!1;let b=d.charCodeAt(0);if(b!==92||(b=d.charCodeAt(1),b!==92))return!1;let P=2;const g=P;for(;P<d.length&&(b=d.charCodeAt(P),b!==92);P++);return!(g===P||(b=d.charCodeAt(P+1),isNaN(b)||b===92))}e.$6f=A;const D=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,$=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(d,b=M.$i){const P=b?D:l;return!(!d||d.length===0||/^\s+$/.test(d)||(P.lastIndex=0,P.test(d))||b&&$.test(d)||d==="."||d===".."||b&&d[d.length-1]==="."||b&&d.length!==d.trim().length||d.length>255)}e.$7f=p;function r(d,b,P){const g=d===b;return!P||g?g:!d||!b?!1:(0,I.$af)(d,b)}e.$8f=r;function c(d,b,P,g=S.sep){if(d===b)return!0;if(!d||!b||b.length>d.length)return!1;if(P){if(!(0,I.$bf)(d,b))return!1;if(b.length===d.length)return!0;let k=b.length;return b.charAt(b.length-1)===g&&k--,d.charAt(k)===g}return b.charAt(b.length-1)!==g&&(b+=g),d.indexOf(b)===0}e.$9f=c;function s(d){return d>=65&&d<=90||d>=97&&d<=122}e.$0f=s;function i(d,b){return M.$i&&d.endsWith(":")&&(d+=S.sep),(0,S.$ic)(d)||(d=(0,S.$jc)(b,d)),d=(0,S.$hc)(d),M.$i?(d=(0,I.$Ve)(d,S.sep),d.endsWith(":")&&(d+=S.sep)):(d=(0,I.$Ve)(d,S.sep),d||(d=S.sep)),d}e.$$f=i;function o(d){const b=(0,S.$hc)(d);return M.$i?d.length>3?!1:a(b)&&(d.length===2||b.charCodeAt(2)===92):b===S.$gc.sep}e.$_f=o;function a(d,b=M.$i){return b?s(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$ag=a;function u(d,b=M.$i){return a(d,b)?d[0]:void 0}e.$bg=u;function t(d,b,P){return b.length>d.length?-1:d===b?0:(P&&(d=d.toLowerCase(),b=b.toLowerCase()),d.indexOf(b))}e.$cg=t;function f(d){const b=d.split(":");let P,g,v;for(const k of b){const F=Number(k);(0,R.$Nf)(F)?g===void 0?g=F:v===void 0&&(v=F):P=P?[P,k].join(":"):k}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:g!==void 0?g:void 0,column:v!==void 0?v:g!==void 0?1:void 0}}e.$dg=f;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",w="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function y(d,b,P=8){let g="";for(let k=0;k<P;k++){let F;k===0&&M.$i&&!b&&(P===3||P===4)?F=w:F=n,g+=F.charAt(Math.floor(Math.random()*F.length))}let v;return b?v=`${b}-${g}`:v=g,d?(0,S.$jc)(d,v):v}e.$eg=y}),define(Re[69],Ae([1,0,19]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=e.$js=e.$is=e.$hs=void 0,e.$hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(A){const D=(0,S.$oc)(A),l=M[D.toLowerCase()];return l!==void 0?l:L(A)}e.$is=R;function L(A){const D=(0,S.$oc)(A);return I[D.toLowerCase()]}e.$js=L;function m(A){for(const D in I)if(I[D]===A)return D}e.$ks=m;const h=/^(.+)\/(.+?)(;.+)?$/;function E(A,D){const l=h.exec(A);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:D?void 0:A}e.$ls=E}),define(Re[52],Ae([1,0,23,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=void 0;function I(h){return JSON.stringify(h,L)}e.$Ch=I;function R(h){let E=JSON.parse(h);return E=m(E),E}e.$Dh=R;function L(h,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function m(h,E=0){if(!h||E>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return M.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof S.$ke||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let A=0;A<h.length;++A)h[A]=m(h[A],E+1);else for(const A in h)Object.hasOwnProperty.call(h,A)&&(h[A]=m(h[A],E+1))}return h}e.$Eh=m}),define(Re[12],Ae([1,0,15,20,14,2]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.Schemas=void 0;var L;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={}));function m(l,$){return R.URI.isUri(l)?(0,I.$af)(l.scheme,$):(0,I.$bf)(l,$+":")}e.$fg=m;function h(l,...$){return $.some(p=>m(l,p))}e.$gg=h,e.$hg="vscode-tkn",e.$ig="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema($){this.d=$}setDelegate($){this.e=$}setServerRootPath($){this.f=`${$}/${L.vscodeRemoteResource}`}set($,p,r){this.a[$]=p,this.b[$]=r}setConnectionToken($,p){this.c[$]=p}getPreferredWebSchema(){return this.d}rewrite($){if(this.e)try{return this.e($)}catch(o){return S.$1(o),$}const p=$.authority;let r=this.a[p];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const c=this.b[p],s=this.c[p];let i=`path=${encodeURIComponent($.path)}`;return typeof s=="string"&&(i+=`&${e.$ig}=${encodeURIComponent(s)}`),R.URI.from({scheme:M.$o?this.d:L.vscodeRemoteResource,authority:`${r}:${c}`,path:this.f,query:i})}}e.$jg=new E,e.$kg="vs/../../extensions",e.$lg="vs/../../node_modules",e.$mg="vs/../../node_modules.asar",e.$ng="vs/../../node_modules.asar.unpacked",e.$og="vscode-app";class A{static{this.a=e.$og}asBrowserUri($){const p=this.b($,me);return this.uriToBrowserUri(p)}uriToBrowserUri($){return $.scheme===L.vscodeRemote?e.$jg.rewrite($):$.scheme===L.file&&(M.$m||M.$q===`${L.vscodeFileResource}://${A.a}`)?$.with({scheme:L.vscodeFileResource,authority:$.authority||A.a,query:null,fragment:null}):$}asFileUri($){const p=this.b($,me);return this.uriToFileUri(p)}uriToFileUri($){return $.scheme===L.vscodeFileResource?$.with({scheme:L.file,authority:$.authority!==A.a?$.authority:null,query:null,fragment:null}):$}b($,p){return R.URI.isUri($)?$:R.URI.parse(p.toUrl($))}}e.$pg=new A;var D;(function(l){const $=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze($.get("3"));const p="vscode-coi";function r(s){let i;typeof s=="string"?i=new URL(s).searchParams:s instanceof URL?i=s.searchParams:R.URI.isUri(s)&&(i=new URL(s.toString(!0)).searchParams);const o=i?.get(p);if(o)return $.get(o)}l.getHeadersFromQuery=r;function c(s,i,o){if(!globalThis.crossOriginIsolated)return;const a=i&&o?"3":o?"2":"1";s instanceof URLSearchParams?s.set(p,a):s[p]=a}l.addSearchParam=c})(D||(e.COI=D={}))}),define(Re[25],Ae([1,0,45,12,19,20,14,2]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.DataUri=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=void 0;function h($){return(0,m.$wc)($,!0)}e.$wg=h;class E{constructor(p){this.a=p}compare(p,r,c=!1){return p===r?0:(0,L.$6e)(this.getComparisonKey(p,c),this.getComparisonKey(r,c))}isEqual(p,r,c=!1){return p===r?!0:!p||!r?!1:this.getComparisonKey(p,c)===this.getComparisonKey(r,c)}getComparisonKey(p,r=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,r,c=!1){if(p.scheme===r.scheme){if(p.scheme===M.Schemas.file)return S.$9f(h(p),h(r),this.a(p))&&p.query===r.query&&(c||p.fragment===r.fragment);if((0,e.$Ng)(p.authority,r.authority))return S.$9f(p.path,r.path,this.a(p),"/")&&p.query===r.query&&(c||p.fragment===r.fragment)}return!1}joinPath(p,...r){return m.URI.joinPath(p,...r)}basenameOrAuthority(p){return(0,e.$Fg)(p)||p.authority}basename(p){return I.$gc.basename(p.path)}extname(p){return I.$gc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let r;return p.scheme===M.Schemas.file?r=m.URI.file(I.$mc(h(p))).path:(r=I.$gc.dirname(p.path),p.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),r="/")),p.with({path:r})}normalizePath(p){if(!p.path.length)return p;let r;return p.scheme===M.Schemas.file?r=m.URI.file(I.$hc(h(p))).path:r=I.$gc.normalize(p.path),p.with({path:r})}relativePath(p,r){if(p.scheme!==r.scheme||!(0,e.$Ng)(p.authority,r.authority))return;if(p.scheme===M.Schemas.file){const i=I.$lc(h(p),h(r));return R.$i?S.$3f(i):i}let c=p.path||"/";const s=r.path||"/";if(this.a(p)){let i=0;for(const o=Math.min(c.length,s.length);i<o&&!(c.charCodeAt(i)!==s.charCodeAt(i)&&c.charAt(i).toLowerCase()!==s.charAt(i).toLowerCase());i++);c=s.substr(0,i)+c.substr(i)}return I.$gc.relative(c,s)}resolvePath(p,r){if(p.scheme===M.Schemas.file){const c=m.URI.file(I.$kc(h(p),r));return p.with({authority:c.authority,path:c.path})}return r=S.$4f(r),p.with({path:I.$gc.resolve(p.path,r)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,r){return p===r||p!==void 0&&r!==void 0&&(0,L.$af)(p,r)}hasTrailingPathSeparator(p,r=I.sep){if(p.scheme===M.Schemas.file){const c=h(p);return c.length>S.$5f(c).length&&c[c.length-1]===r}else{const c=p.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,r=I.sep){return(0,e.$Og)(p,r)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,r=I.sep){let c=!1;if(p.scheme===M.Schemas.file){const s=h(p);c=s!==void 0&&s.length===S.$5f(s).length&&s[s.length-1]===r}else{r="/";const s=p.path;c=s.length===1&&s.charCodeAt(s.length-1)===47}return!c&&!(0,e.$Og)(p,r)?p.with({path:p.path+"/"}):p}}e.$xg=E,e.$yg=new E(()=>!1),e.$zg=new E($=>$.scheme===M.Schemas.file?!R.$k:!0),e.$Ag=new E($=>!0),e.$Bg=e.$yg.isEqual.bind(e.$yg),e.$Cg=e.$yg.isEqualOrParent.bind(e.$yg),e.$Dg=e.$yg.getComparisonKey.bind(e.$yg),e.$Eg=e.$yg.basenameOrAuthority.bind(e.$yg),e.$Fg=e.$yg.basename.bind(e.$yg),e.$Gg=e.$yg.extname.bind(e.$yg),e.$Hg=e.$yg.dirname.bind(e.$yg),e.$Ig=e.$yg.joinPath.bind(e.$yg),e.$Jg=e.$yg.normalizePath.bind(e.$yg),e.$Kg=e.$yg.relativePath.bind(e.$yg),e.$Lg=e.$yg.resolvePath.bind(e.$yg),e.$Mg=e.$yg.isAbsolutePath.bind(e.$yg),e.$Ng=e.$yg.isEqualAuthority.bind(e.$yg),e.$Og=e.$yg.hasTrailingPathSeparator.bind(e.$yg),e.$Pg=e.$yg.removeTrailingPathSeparator.bind(e.$yg),e.$Qg=e.$yg.addTrailingPathSeparator.bind(e.$yg);function A($,p){const r=[];for(let c=0;c<$.length;c++){const s=p($[c]);$.some((i,o)=>o===c?!1:(0,e.$Cg)(s,p(i)))||r.push($[c])}return r}e.$Rg=A;var D;(function($){$.META_DATA_LABEL="label",$.META_DATA_DESCRIPTION="description",$.META_DATA_SIZE="size",$.META_DATA_MIME="mime";function p(r){const c=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(o=>{const[a,u]=o.split(":");a&&u&&c.set(a,u)});const i=r.path.substring(0,r.path.indexOf(";"));return i&&c.set($.META_DATA_MIME,i),c}$.parseMetaData=p})(D||(e.DataUri=D={}));function l($,p,r){if(p){let c=$.path;return c&&c[0]!==I.$gc.sep&&(c=I.$gc.sep+c),$.with({scheme:r,authority:p,path:c})}return $.with({scheme:r})}e.$Sg=l}),define(Re[11],Ae([1,0,21,15,5,6,25,20,125,39]),function(me,e,S,M,I,R,L,m,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.Promises=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0;function A(ge){return!!ge&&typeof ge.then=="function"}e.$Tg=A;function D(ge){const K=new S.$7d,ee=ge(K.token),he=new Promise((fe,Ce)=>{const de=K.token.onCancellationRequested(()=>{de.dispose(),Ce(new M.$5)});Promise.resolve(ee).then(ye=>{de.dispose(),K.dispose(),fe(ye)},ye=>{de.dispose(),K.dispose(),Ce(ye)})});return new class{cancel(){K.cancel(),K.dispose()}then(fe,Ce){return he.then(fe,Ce)}catch(fe){return this.then(void 0,fe)}finally(fe){return he.finally(fe)}}}e.$Ug=D;function l(ge,K,ee){return new Promise((he,fe)=>{const Ce=K.onCancellationRequested(()=>{Ce.dispose(),he(ee)});ge.then(he,fe).finally(()=>Ce.dispose())})}e.$Vg=l;function $(ge,K){return new Promise((ee,he)=>{const fe=K.onCancellationRequested(()=>{fe.dispose(),he(new M.$5)});ge.then(ee,he).finally(()=>fe.dispose())})}e.$Wg=$;async function p(ge){let K=-1;const ee=ge.map((he,fe)=>he.then(Ce=>(K=fe,Ce)));try{return await Promise.race(ee)}finally{ge.forEach((he,fe)=>{fe!==K&&he.cancel()})}}e.$Xg=p;function r(ge,K,ee){let he;const fe=setTimeout(()=>{he?.(void 0),ee?.()},K);return Promise.race([ge.finally(()=>clearTimeout(fe)),new Promise(Ce=>he=Ce)])}e.$Yg=r;function c(ge){return new Promise((K,ee)=>{const he=ge();A(he)?he.then(K,ee):K(he)})}e.$Zg=c;function s(){let ge,K;return{promise:new Promise((he,fe)=>{ge=he,K=fe}),resolve:ge,reject:K}}e.$1g=s;class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const ee=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(ee,ee).then(he)})}return new Promise((ee,he)=>{this.b.then(ee,he)})}return this.a=K(),new Promise((ee,he)=>{this.a.then(fe=>{this.a=null,ee(fe)},fe=>{this.a=null,he(fe)})})}dispose(){this.f=!0}}e.$2g=i;class o{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$3g=o;class a{constructor(){this.a=new Map}queue(K,ee){const fe=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.a.get(K)===fe&&this.a.delete(K)});return this.a.set(K,fe),fe}}e.$4g=a;const u=(ge,K)=>{let ee=!0;const he=setTimeout(()=>{ee=!1,K()},ge);return{isTriggered:()=>ee,dispose:()=>{clearTimeout(he),ee=!1}}},t=ge=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,ge())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class f{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,ee=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((fe,Ce)=>{this.d=fe,this.f=Ce}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=ee===h.$Td?t(he):u(ee,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$5g=f;class n{constructor(K){this.a=new f(K),this.b=new i}trigger(K,ee){return this.a.trigger(()=>this.b.queue(K),ee)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$6g=n;class w{constructor(){this.a=!1,this.b=new Promise((K,ee)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$7g=w;class y extends w{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$8g=y;function d(ge,K){return K?new Promise((ee,he)=>{const fe=setTimeout(()=>{Ce.dispose(),ee()},ge),Ce=K.onCancellationRequested(()=>{clearTimeout(fe),Ce.dispose(),he(new M.$5)})}):D(ee=>d(ge,ee))}e.$9g=d;function b(ge,K=0,ee){const he=setTimeout(()=>{ge(),ee&&fe.dispose()},K),fe=(0,R.$Rc)(()=>{clearTimeout(he),ee?.deleteAndLeak(fe)});return ee?.add(fe),fe}e.$0g=b;function P(ge){const K=[];let ee=0;const he=ge.length;function fe(){return ee<he?ge[ee++]():null}function Ce(de){de!=null&&K.push(de);const ye=fe();return ye?ye.then(Ce):Promise.resolve(K)}return Promise.resolve(null).then(Ce)}e.$$g=P;function g(ge,K=he=>!!he,ee=null){let he=0;const fe=ge.length,Ce=()=>{if(he>=fe)return Promise.resolve(ee);const de=ge[he++];return Promise.resolve(de()).then(T=>K(T)?Promise.resolve(T):Ce())};return Ce()}e.$_g=g;function v(ge,K=he=>!!he,ee=null){if(ge.length===0)return Promise.resolve(ee);let he=ge.length;const fe=()=>{he=-1;for(const Ce of ge)Ce.cancel?.()};return new Promise((Ce,de)=>{for(const ye of ge)ye.then(T=>{--he>=0&&K(T)?(fe(),Ce(T)):he===0&&Ce(ee)}).catch(T=>{--he>=0&&(fe(),de(T))})})}e.$ah=v;class k{constructor(K){this.a=0,this.b=!1,this.f=K,this.g=[],this.d=0,this.h=new I.$Wd}whenIdle(){return this.size>0?I.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(K){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ee,he)=>{this.g.push({factory:K,c:ee,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const K=this.g.shift();this.d++;const ee=K.factory();ee.then(K.c,K.e),ee.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$bh=k;class F extends k{constructor(){super(1)}}e.$ch=F;class O{constructor(){this.a=new ce,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$dh=O;class G{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new $e;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueSize(K,ee=L.$yg){const he=ee.getComparisonKey(K);return this.a.get(he)?.size??0}queueFor(K,ee,he=L.$yg){const fe=he.getComparisonKey(K);let Ce=this.a.get(fe);if(!Ce){Ce=new F;const de=this.f++,ye=I.Event.once(Ce.onDrained)(()=>{Ce?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(de),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$3c),this.d.set(de,ye),this.a.set(fe,Ce)}return Ce.queue(ee)}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$eh=G;class q{constructor(K,ee){this.a=-1,typeof K=="function"&&typeof ee=="number"&&this.setIfNotSet(K,ee)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,ee){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},ee)}setIfNotSet(K,ee){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},ee))}}e.$fh=q;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(K,ee,he=globalThis){this.cancel();const fe=he.setInterval(()=>{K()},ee);this.d=(0,R.$Rc)(()=>{he.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$gh=U;class C{constructor(K,ee){this.b=-1,this.a=K,this.d=ee,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$hh=C;class N{constructor(K,ee){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.a=K,this.b=ee,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ih=N;class W extends C{constructor(K,ee){super(K,ee),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$jh=W;class se extends R.$Tc{constructor(K,ee){super(),this.g=K,this.h=ee,this.a=[],this.b=this.B(new R.$Uc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ee of K)this.a.push(ee);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new C(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$kh=se,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$mh=(ge,K)=>{(0,m.$B)(()=>{if(ee)return;const he=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.$mh=(ge,K,ee)=>{const he=ge.requestIdleCallback(K,typeof ee=="number"?{timeout:ee}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,ge.cancelIdleCallback(he))}}},e.$lh=ge=>(0,e.$mh)(globalThis,ge)}();class le{constructor(K,ee){this.g=!1,this.d=()=>{try{this.j=ee()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$mh)(K,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$nh=le;class Ee extends le{constructor(K){super(globalThis,K)}}e.$oh=Ee;async function De(ge,K,ee){let he;for(let fe=0;fe<ee;fe++)try{return await ge()}catch(Ce){he=Ce,await d(K)}throw he}e.$ph=De;class ce{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,ee,he){return this.a={taskId:K,cancel:()=>he?.(),promise:ee},ee.then(()=>this.d(K),()=>this.d(K)),ee}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{const{promise:ee,resolve:he,reject:fe}=s();this.b={run:K,promise:ee,promiseResolve:he,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$qh=ce;class pe{constructor(K,ee=()=>Date.now()){this.d=K,this.f=ee,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$rh=pe;var oe;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(oe||(oe={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,ee)=>{this.a=K,this.b=ee})}complete(K){return new Promise(ee=>{this.a(K),this.d={outcome:0,value:K},ee()})}error(K){return new Promise(ee=>{this.b(K),this.d={outcome:1,value:K},ee()})}cancel(){return this.error(new M.$5)}}e.$sh=$e;var ie;(function(ge){async function K(he){let fe;const Ce=await Promise.all(he.map(de=>de.then(ye=>ye,ye=>{fe||(fe=ye)})));if(typeof fe<"u")throw fe;return Ce}ge.settled=K;function ee(he){return new Promise(async(fe,Ce)=>{try{await he(fe,Ce)}catch(de){Ce(de)}})}ge.withAsyncBody=ee})(ie||(e.Promises=ie={}));class x{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(K){this.a=void 0,this.b=void 0,this.d=!1,this.promise=K.then(ee=>(this.a=ee,this.d=!0,ee),ee=>{throw this.b=ee,this.d=!0,ee})}requireValue(){if(!this.d)throw new M.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$th=x;class V{constructor(K){this.b=K,this.a=new E.$V(()=>new x(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$uh=V;var ne;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(ne||(ne={}));class Ie{static fromArray(K){return new Ie(ee=>{ee.emitMany(K)})}static fromPromise(K){return new Ie(async ee=>{ee.emitMany(await K)})}static fromPromises(K){return new Ie(async ee=>{await Promise.all(K.map(async he=>ee.emitOne(await he)))})}static merge(K){return new Ie(async ee=>{await Promise.all(K.map(async he=>{for await(const fe of he)ee.emitOne(fe)}))})}static{this.EMPTY=Ie.fromArray([])}constructor(K){this.a=0,this.b=[],this.d=null,this.f=new I.$Wd,queueMicrotask(async()=>{const ee={emitOne:he=>this.g(he),emitMany:he=>this.h(he),reject:he=>this.k(he)};try{await Promise.resolve(K(ee)),this.j()}catch(he){this.k(he)}finally{ee.emitOne=void 0,ee.emitMany=void 0,ee.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(K,ee){return new Ie(async he=>{for await(const fe of K)he.emitOne(ee(fe))})}map(K){return Ie.map(this,K)}static filter(K,ee){return new Ie(async he=>{for await(const fe of K)ee(fe)&&he.emitOne(fe)})}filter(K){return Ie.filter(this,K)}static coalesce(K){return Ie.filter(K,ee=>!!ee)}coalesce(){return Ie.coalesce(this)}static async toPromise(K){const ee=[];for await(const he of K)ee.push(he);return ee}toPromise(){return Ie.toPromise(this)}g(K){this.a===0&&(this.b.push(K),this.f.fire())}h(K){this.a===0&&(this.b=this.b.concat(K),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(K){this.a===0&&(this.a=2,this.d=K,this.f.fire())}}e.$vh=Ie;class Me extends Ie{constructor(K,ee){super(ee),this.l=K}cancel(){this.l.cancel()}}e.$wh=Me;function Le(ge){const K=new S.$7d,ee=ge(K.token);return new Me(K,async he=>{const fe=K.token.onCancellationRequested(()=>{fe.dispose(),K.dispose(),he.reject(new M.$5)});try{for await(const Ce of ee){if(K.token.isCancellationRequested)return;he.emitOne(Ce)}fe.dispose(),K.dispose()}catch(Ce){fe.dispose(),K.dispose(),he.reject(Ce)}})}e.$xh=Le;class we{constructor(){this.a=new $e,this.b=new Ie(he=>{if(K){he.reject(K);return}return ee&&he.emitMany(ee),this.d=fe=>he.reject(fe),this.f=fe=>he.emitOne(fe),this.a.p});let K,ee;this.f=he=>{ee||(ee=[]),ee.push(he)},this.d=he=>{K||(K=he)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(K){this.d(K),this.a.complete()}emitOne(K){this.f(K)}}e.$yh=we}),define(Re[34],Ae([1,0,18,11,45,28,19,20,14]),function(me,e,S,M,I,R,L,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=void 0;function E(){return Object.create(null)}e.$Jj=E,e.$Kj="**",e.$Lj="/";const A="[/\\\\]",D="[^/\\\\]",l=/\//g;function $(le,Ee){switch(le){case 0:return"";case 1:return`${D}*?`;default:return`(?:${A}|${D}+${A}${Ee?`|${A}${D}+`:""})*?`}}function p(le,Ee){if(!le)return[];const De=[];let ce=!1,pe=!1,oe="";for(const $e of le){switch($e){case Ee:if(!ce&&!pe){De.push(oe),oe="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}oe+=$e}return oe&&De.push(oe),De}e.$Mj=p;function r(le){if(!le)return"";let Ee="";const De=p(le,e.$Lj);if(De.every(ce=>ce===e.$Kj))Ee=".*";else{let ce=!1;De.forEach((pe,oe)=>{if(pe===e.$Kj){if(ce)return;Ee+=$(2,oe===De.length-1)}else{let $e=!1,ie="",x=!1,V="";for(const ne of pe){if(ne!=="}"&&$e){ie+=ne;continue}if(x&&(ne!=="]"||!V)){let Ie;ne==="-"?Ie=ne:(ne==="^"||ne==="!")&&!V?Ie="^":ne===e.$Lj?Ie="":Ie=(0,h.$Pe)(ne),V+=Ie;continue}switch(ne){case"{":$e=!0;continue;case"[":x=!0;continue;case"}":{const Me=`(?:${p(ie,",").map(Le=>r(Le)).join("|")})`;Ee+=Me,$e=!1,ie="";break}case"]":{Ee+="["+V+"]",x=!1,V="";break}case"?":Ee+=D;continue;case"*":Ee+=$(1);continue;default:Ee+=(0,h.$Pe)(ne)}}oe<De.length-1&&(De[oe+1]!==e.$Kj||oe+2<De.length)&&(Ee+=A)}ce=pe===e.$Kj})}return Ee}const c=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Dc(1e4),f=function(){return!1},n=function(){return null};function w(le,Ee){if(!le)return n;let De;typeof le!="string"?De=le.pattern:De=le,De=De.trim();const ce=`${De}_${!!Ee.trimForExclusions}`;let pe=t.get(ce);if(pe)return y(pe,le);let oe;return c.test(De)?pe=b(De.substr(4),De):(oe=s.exec(d(De,Ee)))?pe=P(oe[1],De):(Ee.trimForExclusions?o:i).test(De)?pe=g(De,Ee):(oe=a.exec(d(De,Ee)))?pe=v(oe[1].substr(1),De,!0):(oe=u.exec(d(De,Ee)))?pe=v(oe[1],De,!1):pe=k(De),t.set(ce,pe),y(pe,le)}function y(le,Ee){if(typeof Ee=="string")return le;const De=function(ce,pe){return(0,I.$9f)(ce,Ee.base,!m.$k)?le((0,h.$Ue)(ce.substr(Ee.base.length),L.sep),pe):null};return De.allBasenames=le.allBasenames,De.allPaths=le.allPaths,De.basenames=le.basenames,De.patterns=le.patterns,De}function d(le,Ee){return Ee.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function b(le,Ee){return function(De,ce){return typeof De=="string"&&De.endsWith(le)?Ee:null}}function P(le,Ee){const De=`/${le}`,ce=`\\${le}`,pe=function($e,ie){return typeof $e!="string"?null:ie?ie===le?Ee:null:$e===le||$e.endsWith(De)||$e.endsWith(ce)?Ee:null},oe=[le];return pe.basenames=oe,pe.patterns=[Ee],pe.allBasenames=oe,pe}function g(le,Ee){const De=W(le.slice(1,-1).split(",").map(ie=>w(ie,Ee)).filter(ie=>ie!==n),le),ce=De.length;if(!ce)return n;if(ce===1)return De[0];const pe=function(ie,x){for(let V=0,ne=De.length;V<ne;V++)if(De[V](ie,x))return le;return null},oe=De.find(ie=>!!ie.allBasenames);oe&&(pe.allBasenames=oe.allBasenames);const $e=De.reduce((ie,x)=>x.allPaths?ie.concat(x.allPaths):ie,[]);return $e.length&&(pe.allPaths=$e),pe}function v(le,Ee,De){const ce=L.sep===L.$gc.sep,pe=ce?le:le.replace(l,L.sep),oe=L.sep+pe,$e=L.$gc.sep+le;let ie;return De?ie=function(x,V){return typeof x=="string"&&(x===pe||x.endsWith(oe)||!ce&&(x===le||x.endsWith($e)))?Ee:null}:ie=function(x,V){return typeof x=="string"&&(x===pe||!ce&&x===le)?Ee:null},ie.allPaths=[(De?"*/":"./")+le],ie}function k(le){try{const Ee=new RegExp(`^${r(le)}$`);return function(De){return Ee.lastIndex=0,typeof De=="string"&&Ee.test(De)?le:null}}catch{return n}}function F(le,Ee,De){return!le||typeof Ee!="string"?!1:O(le)(Ee,void 0,De)}e.$Nj=F;function O(le,Ee={}){if(!le)return f;if(typeof le=="string"||G(le)){const De=w(le,Ee);if(De===n)return f;const ce=function(pe,oe){return!!De(pe,oe)};return De.allBasenames&&(ce.allBasenames=De.allBasenames),De.allPaths&&(ce.allPaths=De.allPaths),ce}return C(le,Ee)}e.$Oj=O;function G(le){const Ee=le;return Ee?typeof Ee.base=="string"&&typeof Ee.pattern=="string":!1}e.$Pj=G;function q(le){return le.allBasenames||[]}e.$Qj=q;function U(le){return le.allPaths||[]}e.$Rj=U;function C(le,Ee){const De=W(Object.getOwnPropertyNames(le).map(ie=>N(ie,le[ie],Ee)).filter(ie=>ie!==n)),ce=De.length;if(!ce)return n;if(!De.some(ie=>!!ie.requiresSiblings)){if(ce===1)return De[0];const ie=function(ne,Ie){let Me;for(let Le=0,we=De.length;Le<we;Le++){const ge=De[Le](ne,Ie);if(typeof ge=="string")return ge;(0,M.$Tg)(ge)&&(Me||(Me=[]),Me.push(ge))}return Me?(async()=>{for(const Le of Me){const we=await Le;if(typeof we=="string")return we}return null})():null},x=De.find(ne=>!!ne.allBasenames);x&&(ie.allBasenames=x.allBasenames);const V=De.reduce((ne,Ie)=>Ie.allPaths?ne.concat(Ie.allPaths):ne,[]);return V.length&&(ie.allPaths=V),ie}const pe=function(ie,x,V){let ne,Ie;for(let Me=0,Le=De.length;Me<Le;Me++){const we=De[Me];we.requiresSiblings&&V&&(x||(x=(0,L.$nc)(ie)),ne||(ne=x.substr(0,x.length-(0,L.$oc)(ie).length)));const ge=we(ie,x,ne,V);if(typeof ge=="string")return ge;(0,M.$Tg)(ge)&&(Ie||(Ie=[]),Ie.push(ge))}return Ie?(async()=>{for(const Me of Ie){const Le=await Me;if(typeof Le=="string")return Le}return null})():null},oe=De.find(ie=>!!ie.allBasenames);oe&&(pe.allBasenames=oe.allBasenames);const $e=De.reduce((ie,x)=>x.allPaths?ie.concat(x.allPaths):ie,[]);return $e.length&&(pe.allPaths=$e),pe}function N(le,Ee,De){if(Ee===!1)return n;const ce=w(le,De);if(ce===n)return n;if(typeof Ee=="boolean")return ce;if(Ee){const pe=Ee.when;if(typeof pe=="string"){const oe=($e,ie,x,V)=>{if(!V||!ce($e,ie))return null;const ne=pe.replace("$(basename)",()=>x),Ie=V(ne);return(0,M.$Tg)(Ie)?Ie.then(Me=>Me?le:null):Ie?le:null};return oe.requiresSiblings=!0,oe}}return ce}function W(le,Ee){const De=le.filter(ie=>!!ie.basenames);if(De.length<2)return le;const ce=De.reduce((ie,x)=>{const V=x.basenames;return V?ie.concat(V):ie},[]);let pe;if(Ee){pe=[];for(let ie=0,x=ce.length;ie<x;ie++)pe.push(Ee)}else pe=De.reduce((ie,x)=>{const V=x.patterns;return V?ie.concat(V):ie},[]);const oe=function(ie,x){if(typeof ie!="string")return null;if(!x){let ne;for(ne=ie.length;ne>0;ne--){const Ie=ie.charCodeAt(ne-1);if(Ie===47||Ie===92)break}x=ie.substr(ne)}const V=ce.indexOf(x);return V!==-1?pe[V]:null};oe.basenames=ce,oe.patterns=pe,oe.allBasenames=ce;const $e=le.filter(ie=>!ie.basenames);return $e.push(oe),$e}function se(le,Ee){return(0,S.$ub)(le,Ee,(De,ce)=>typeof De=="string"&&typeof ce=="string"?De===ce:typeof De!="string"&&typeof ce!="string"?De.base===ce.base&&De.pattern===ce.pattern:!1)}e.$Sj=se}),define(Re[46],Ae([1,0,15,126,25,14,2]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class h{constructor(i="",o=!1){if(this.value=i,typeof this.value!="string")throw(0,S.$7)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(i,o=0){return this.value+=l(this.supportThemeIcons?(0,M.$dk)(i):i).replace(/([ \t]+)/g,(a,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,o){return this.value+=`
${$(o,i)}
`,this}appendLink(i,o,a){return this.value+="[",this.value+=this.c(o,"]"),this.value+="](",this.value+=this.c(String(i),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(i,o){const a=new RegExp((0,R.$Pe)(o),"g");return i.replace(a,(u,t)=>i.charAt(t-1)!=="\\"?`\\${u}`:u)}}e.$jk=h;function E(s){return A(s)?!s.value:Array.isArray(s)?s.every(E):!0}e.$kk=E;function A(s){return s instanceof h?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.$lk=A;function D(s,i){return s===i?!0:!s||!i?!1:s.value===i.value&&s.isTrusted===i.isTrusted&&s.supportThemeIcons===i.supportThemeIcons&&s.supportHtml===i.supportHtml&&(s.baseUri===i.baseUri||!!s.baseUri&&!!i.baseUri&&(0,I.$Bg)(L.URI.from(s.baseUri),L.URI.from(i.baseUri)))}e.$mk=D;function l(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$nk=l;function $(s,i){const o=s.match(/^`+/gm)?.reduce((u,t)=>u.length>t.length?u:t).length??0,a=o>=3?o+1:3;return[`${"`".repeat(a)}${i}`,s,`${"`".repeat(a)}`].join(`
`)}e.$ok=$;function p(s){return s.replace(/"/g,"&quot;")}e.$pk=p;function r(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$qk=r;function c(s){const i=[],o=s.split("|").map(u=>u.trim());s=o[0];const a=o[1];if(a){const u=/height=(\d+)/.exec(a),t=/width=(\d+)/.exec(a),f=u?u[1]:"",n=t?t[1]:"",w=isFinite(parseInt(n)),y=isFinite(parseInt(f));w&&i.push(`width="${n}"`),y&&i.push(`height="${f}"`)}return{href:s,dimensions:i}}e.$rk=c}),define(Re[94],Ae([1,0,18,45,19,20,25,14]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=void 0;function h(w,y){const{os:d,tildify:b,relative:P}=y;if(P){const k=E(w,P,d);if(typeof k=="string")return k}let g=w.fsPath;if(d===1&&!R.$i?g=g.replace(/\//g,"\\"):d!==1&&R.$i&&(g=g.replace(/\\/g,"/")),d!==1&&b?.userHome){const k=b.userHome.fsPath;let F;w.scheme!==b.userHome.scheme&&w.path[0]===I.$gc.sep&&w.path[1]!==I.$gc.sep?F=b.userHome.with({path:w.path}).fsPath:F=g,g=l(F,k,d)}return(d===1?I.$fc:I.$gc).normalize(A(g,d===1))}e.$Xv=h;function E(w,y,d){const b=d===1?I.$fc:I.$gc,P=d===3?L.$yg:L.$Ag,g=y.getWorkspace(),v=(0,S.$Ob)(g.folders);if(!v)return;w.scheme!==v.uri.scheme&&w.path[0]===I.$gc.sep&&w.path[1]!==I.$gc.sep&&(w=v.uri.with({path:w.path}));const k=y.getWorkspaceFolder(w);if(!k)return;let F;if(P.isEqual(k.uri,w)?F="":F=P.relativePath(k.uri,w)??"",F&&(F=b.normalize(F)),g.folders.length>1&&!y.noPrefix){const O=k.name?k.name:P.basenameOrAuthority(k.uri);F=F?`${O} \u2022 ${F}`:O}return F}function A(w,y=R.$i){return(0,M.$ag)(w,y)?w.charAt(0).toUpperCase()+w.slice(1):w}e.$Yv=A;let D=Object.create(null);function l(w,y,d=R.OS){if(d===1||!w||!y)return w;let b=D.original===y?D.normalized:void 0;b||(b=y,R.$i&&(b=(0,M.$3f)(b)),b=`${(0,m.$Ve)(b,I.$gc.sep)}${I.$gc.sep}`,D={original:y,normalized:b});let P=w;return R.$i&&(P=(0,M.$3f)(P)),(d===3?P.startsWith(b):(0,m.$bf)(P,b))?`~/${P.substr(b.length)}`:w}e.$Zv=l;function $(w,y){return w.replace(/^~($|\/|\\)/,`${y}$1`)}e.$1v=$;const p="\u2026",r="\\\\",c="~";function s(w,y=I.sep){const d=new Array(w.length);let b=!1;for(let P=0;P<w.length;P++){const g=w[P];if(g===""){d[P]=`.${y}`;continue}if(!g){d[P]=g;continue}b=!0;let v="",k=g;k.indexOf(r)===0?(v=k.substr(0,k.indexOf(r)+r.length),k=k.substr(k.indexOf(r)+r.length)):k.indexOf(y)===0?(v=k.substr(0,k.indexOf(y)+y.length),k=k.substr(k.indexOf(y)+y.length)):k.indexOf(c)===0&&(v=k.substr(0,k.indexOf(c)+c.length),k=k.substr(k.indexOf(c)+c.length));const F=k.split(y);for(let O=1;b&&O<=F.length;O++)for(let G=F.length-O;b&&G>=0;G--){b=!1;let q=F.slice(G,G+O).join(y);for(let U=0;!b&&U<w.length;U++)if(U!==P&&w[U]&&w[U].indexOf(q)>-1){const C=G+O===F.length,N=G>0&&w[U].indexOf(y)>-1?y+q:q,W=w[U].endsWith(N);b=!C||W}if(!b){let U="";(F[0].endsWith(":")||v!=="")&&(G===1&&(G=0,O++,q=F[0]+y+q),G>0&&(U=F[0]+y),U=v+U),G>0&&(U=U+p+y),U=U+q,G+O<F.length&&(U=U+y+p),d[P]=U}}b&&(d[P]=g)}return d}e.$2v=s;var i;(function(w){w[w.TEXT=0]="TEXT",w[w.VARIABLE=1]="VARIABLE",w[w.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function o(w,y=Object.create(null)){const d=[];let b=!1,P="";for(const g of w)if(g==="$"||b&&g==="{")P&&d.push({value:P,type:i.TEXT}),P="",b=!0;else if(g==="}"&&b){const v=y[P];if(typeof v=="string")v.length&&d.push({value:v,type:i.VARIABLE});else if(v){const k=d[d.length-1];(!k||k.type!==i.SEPARATOR)&&d.push({value:v.label,type:i.SEPARATOR})}P="",b=!1}else P+=g;return P&&!b&&d.push({value:P,type:i.TEXT}),d.filter((g,v)=>{if(g.type===i.SEPARATOR){const k=d[v-1],F=d[v+1];return[k,F].every(O=>O&&(O.type===i.VARIABLE||O.type===i.TEXT)&&O.value.length>0)}return!0}).map(g=>g.value).join("")}e.$3v=o;function a(w,y){return R.$j||y?w.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):w.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$4v=a;function u(w,y){return R.$j||y?w.replace(/\(&&\w\)|&&/g,""):R.$i?w.replace(/&&|&/g,d=>d==="&"?"&&":"&"):w.replace(/&&/g,"_")}e.$5v=u;function t(w){return w.replace(/&/g,"&&")}e.$6v=t;function f(w){if(w.endsWith("]")){const y=w.lastIndexOf(" [",w.length-2);if(y!==-1){const d=n(w.substring(0,y)),b=w.substring(y);return{name:d.name+b,parentPath:d.parentPath}}}return n(w)}e.$7v=f;function n(w){const y=w.indexOf("/")!==-1?I.$gc:I.$fc,d=y.basename(w),b=y.dirname(w);return d.length?{name:d,parentPath:b}:{name:b,parentPath:""}}}),define(Re[139],Ae([1,0,23,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function I(D){return D.toJSON()}class R{constructor(l){this.a=l}transformIncoming(l){const $=this.a.transformIncoming(l);return $===l?l:I(M.URI.from($))}transformOutgoing(l){const $=this.a.transformOutgoing(l);return $===l?l:I(M.URI.from($))}transformOutgoingURI(l){const $=this.a.transformOutgoing(l);return $===l?l:M.URI.from($)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$7m=R,e.$8m=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function L(D,l,$){if(!D||$>200)return null;if(typeof D=="object"){if(D instanceof M.URI)return l.transformOutgoing(D);for(const p in D)if(Object.hasOwnProperty.call(D,p)){const r=L(D[p],l,$+1);r!==null&&(D[p]=r)}}return null}function m(D,l){const $=L(D,l,0);return $===null?D:$}e.$9m=m;function h(D,l,$,p){if(!D||p>200)return null;if(typeof D=="object"){if(D.$mid===1)return $?M.URI.revive(l.transformIncoming(D)):l.transformIncoming(D);if(D instanceof S.$ke)return null;for(const r in D)if(Object.hasOwnProperty.call(D,r)){const c=h(D[r],l,$,p+1);c!==null&&(D[r]=c)}}return null}function E(D,l){const $=h(D,l,!1,0);return $===null?D:$}e.$0m=E;function A(D,l){const $=h(D,l,!0,0);return $===null?D:$}e.$$m=A}),define(Re[140],Ae([1,0,14,20,23]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.$ct=void 0;let R;function L(){return R||(R=new TextDecoder("UTF-16LE")),R}let m;function h(){return m||(m=new TextDecoder("UTF-16BE")),m}let E;function A(){return E||(E=M.$D()?L():h()),E}e.$ct=A;function D(p,r,c){const s=new Uint16Array(p.buffer,r,c);return c>0&&(s[0]===65279||s[0]===65534)?l(p,r,c):L().decode(s)}e.$dt=D;function l(p,r,c){const s=[];let i=0;for(let o=0;o<c;o++){const a=I.$me(p,r);r+=2,s[i++]=String.fromCharCode(a)}return s.join("")}class ${constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return A().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const c=this.a-this.d;c<=1&&(c===0||S.$ef(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const c=r.length;if(this.d+c>=this.a){this.f(),this.c[this.c.length]=r;return}for(let s=0;s<c;s++)this.b[this.d++]=r.charCodeAt(s)}}e.$et=$}),define(Re[141],Ae([1,0,23,140]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.$ft=void 0;function I(h){return h.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,A,D,l){this.oldPosition=E,this.oldText=A,this.newPosition=D,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,A,D){const l=A.length;S.$pe(E,l,D),D+=4;for(let $=0;$<l;$++)S.$ne(E,A.charCodeAt($),D),D+=2;return D}static d(E,A){const D=S.$oe(E,A);return A+=4,(0,M.$dt)(E,A,D)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(E,A){return S.$pe(E,this.oldPosition,A),A+=4,S.$pe(E,this.newPosition,A),A+=4,A=R.c(E,this.oldText,A),A=R.c(E,this.newText,A),A}static read(E,A,D){const l=S.$oe(E,A);A+=4;const $=S.$oe(E,A);A+=4;const p=R.d(E,A);A+=R.a(p);const r=R.d(E,A);return A+=R.a(r),D.push(new R(l,p,$,r)),A}}e.$ft=R;function L(h,E){return h===null||h.length===0?E:new m(h,E).compress()}e.$gt=L;class m{constructor(E,A){this.a=E,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,A=0,D=this.n(E),l=this.l(A);for(;E<this.f||A<this.h;){if(D===null){this.k(l),l=this.l(++A);continue}if(l===null){this.m(D),D=this.n(++E);continue}if(l.oldEnd<=D.newPosition){this.k(l),l=this.l(++A);continue}if(D.newEnd<=l.oldPosition){this.m(D),D=this.n(++E);continue}if(l.oldPosition<D.newPosition){const[s,i]=m.r(l,D.newPosition-l.oldPosition);this.k(s),l=i;continue}if(D.newPosition<l.oldPosition){const[s,i]=m.q(D,l.oldPosition-D.newPosition);this.m(s),D=i;continue}let r,c;if(l.oldEnd===D.newEnd)r=D,c=l,D=this.n(++E),l=this.l(++A);else if(l.oldEnd<D.newEnd){const[s,i]=m.q(D,l.oldLength);r=s,c=l,D=i,l=this.l(++A)}else{const[s,i]=m.r(l,D.newLength);r=D,c=s,D=this.n(++E),l=i}this.d[this.e++]=new R(r.oldPosition,r.oldText,c.newPosition,c.newText),this.g+=r.newLength-r.oldLength,this.j+=c.newLength-c.oldLength}const $=m.s(this.d);return m.t($)}k(E){this.d[this.e++]=m.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=m.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,A){return new R(A.oldPosition-E,A.oldText,A.newPosition,A.newText)}static p(E,A){return new R(A.oldPosition,A.oldText,A.newPosition+E,A.newText)}static q(E,A){const D=E.newText.substr(0,A),l=E.newText.substr(A);return[new R(E.oldPosition,E.oldText,E.newPosition,D),new R(E.oldEnd,"",E.newPosition+A,l)]}static r(E,A){const D=E.oldText.substr(0,A),l=E.oldText.substr(A);return[new R(E.oldPosition,D,E.newPosition,E.newText),new R(E.oldPosition+A,l,E.newEnd,"")]}static s(E){if(E.length===0)return E;const A=[];let D=0,l=E[0];for(let $=1;$<E.length;$++){const p=E[$];l.oldEnd===p.oldPosition?l=new R(l.oldPosition,l.oldText+p.oldText,l.newPosition,l.newText+p.newText):(A[D++]=l,l=p)}return A[D++]=l,A}static t(E){if(E.length===0)return E;const A=[];let D=0;for(let l=0;l<E.length;l++){const $=E[l];$.oldText!==$.newText&&(A[D++]=$)}return A}}}),define(Re[142],Ae([1,0,34,19]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=void 0;function I(R,L,m,h,E,A){if(Array.isArray(R)){let D=0;for(const l of R){const $=I(l,L,m,h,E,A);if($===10)return $;$>D&&(D=$)}return D}else{if(typeof R=="string")return h?R==="*"?5:R===m?10:0:0;if(R){const{language:D,pattern:l,scheme:$,hasAccessToAllModels:p,notebookType:r}=R;if(!h&&!p)return 0;r&&E&&(L=E);let c=0;if($)if($===L.scheme)c=10;else if($==="*")c=5;else return 0;if(D)if(D===m)c=10;else if(D==="*")c=Math.max(c,5);else return 0;if(r)if(r===A)c=10;else if(r==="*"&&A!==void 0)c=Math.max(c,5);else return 0;if(l){let s;if(typeof l=="string"?s=l:s={...l,base:(0,M.$hc)(l.base)},s===L.fsPath||(0,S.$Nj)(s,L.fsPath))c=10;else return 0}return c}else return 0}}e.$Dt=I}),define(Re[143],Ae([1,0,5,14,29,92,90,128,141,6]),function(me,e,S,M,I,R,L,m,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=void 0;class A extends E.$Tc{constructor(l,$,p,r,c,s,i){super(),this.m=this.B(new S.$Wd),this.onDidChangeContent=this.m.event,this.f=$,this.j=!s,this.g=r,this.h=c,this.c=new L.$cC(l,p,i)}equals(l){return!(l instanceof A)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,$){return this.c.getOffsetAt(l,$)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,$){const p=l+$,r=this.getPositionAt(l),c=this.getPositionAt(p);return new I.$Ws(r.lineNumber,r.column,c.lineNumber,c.column)}getValueInRange(l,$=0){if(l.isEmpty())return"";const p=this.n($);return this.c.getValueInRange(l,p)}getValueLengthInRange(l,$=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const p=this.getOffsetAt(l.startLineNumber,l.startColumn),r=this.getOffsetAt(l.endLineNumber,l.endColumn);let c=0;const s=this.n($),i=this.getEOL();if(s.length!==i.length){const o=s.length-i.length,a=l.endLineNumber-l.startLineNumber;c=o*a}return r-p+c}getCharacterCountInRange(l,$=0){if(this.j){let p=0;const r=l.startLineNumber,c=l.endLineNumber;for(let s=r;s<=c;s++){const i=this.getLineContent(s),o=s===r?l.startColumn-1:0,a=s===c?l.endColumn-1:i.length;for(let u=o;u<a;u++)M.$ef(i.charCodeAt(u))?(p=p+1,u=u+1):p=p+1}return p+=this.n($).length*(c-r),p}return this.getValueLengthInRange(l,$)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,$){return this.c.getLineCharCode(l,$)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const $=M.$2e(this.getLineContent(l));return $===-1?0:$+1}getLineLastNonWhitespaceColumn(l){const $=M.$4e(this.getLineContent(l));return $===-1?0:$+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,$,p){let r=this.g,c=this.h,s=this.j,i=!0,o=[];for(let y=0;y<l.length;y++){const d=l[y];i&&d._isTracked&&(i=!1);const b=d.range;if(d.text){let F=!0;s||(F=!M.$pf(d.text),s=F),!r&&F&&(r=M.$of(d.text)),!c&&F&&(c=M.$rf(d.text))}let P="",g=0,v=0,k=0;if(d.text){let F;[g,v,k,F]=(0,m.$wt)(d.text);const O=this.getEOL();F===0||F===(O===`\r
`?2:1)?P=d.text:P=d.text.replace(/\r\n|\r|\n/g,O)}o[y]={sortIndex:y,identifier:d.identifier||null,range:b,rangeOffset:this.getOffsetAt(b.startLineNumber,b.startColumn),rangeLength:this.getValueLengthInRange(b),text:P,eolCount:g,firstLineLength:v,lastLineLength:k,forceMoveMarkers:!!d.forceMoveMarkers,isAutoWhitespaceEdit:d.isAutoWhitespaceEdit||!1}}o.sort(A.u);let a=!1;for(let y=0,d=o.length-1;y<d;y++){const b=o[y].range.getEndPosition(),P=o[y+1].range.getStartPosition();if(P.isBeforeOrEqual(b)){if(P.isBefore(b))throw new Error("Overlapping ranges are not allowed!");a=!0}}i&&(o=this.s(o));const u=p||$?A._getInverseEditRanges(o):[],t=[];if($)for(let y=0;y<o.length;y++){const d=o[y],b=u[y];if(d.isAutoWhitespaceEdit&&d.range.isEmpty())for(let P=b.startLineNumber;P<=b.endLineNumber;P++){let g="";P===b.startLineNumber&&(g=this.getLineContent(d.range.startLineNumber),M.$2e(g)!==-1)||t.push({lineNumber:P,oldContent:g})}}let f=null;if(p){let y=0;f=[];for(let d=0;d<o.length;d++){const b=o[d],P=u[d],g=this.getValueInRange(b.range),v=b.rangeOffset+y;y+=b.text.length-g.length,f[d]={sortIndex:b.sortIndex,identifier:b.identifier,range:P,text:g,textChange:new h.$ft(b.rangeOffset,g,v,b.text)}}a||f.sort((d,b)=>d.sortIndex-b.sortIndex)}this.g=r,this.h=c,this.j=s;const n=this.t(o);let w=null;if($&&t.length>0){t.sort((y,d)=>d.lineNumber-y.lineNumber),w=[];for(let y=0,d=t.length;y<d;y++){const b=t[y].lineNumber;if(y>0&&t[y-1].lineNumber===b)continue;const P=t[y].oldContent,g=this.getLineContent(b);g.length===0||g===P||M.$2e(g)!==-1||w.push(b)}}return this.m.fire(),new R.$gv(f,n,w)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let $=!1;const p=l[0].range,r=l[l.length-1].range,c=new I.$Ws(p.startLineNumber,p.startColumn,r.endLineNumber,r.endColumn);let s=p.startLineNumber,i=p.startColumn;const o=[];for(let n=0,w=l.length;n<w;n++){const y=l[n],d=y.range;$=$||y.forceMoveMarkers,o.push(this.getValueInRange(new I.$Ws(s,i,d.startLineNumber,d.startColumn))),y.text.length>0&&o.push(y.text),s=d.endLineNumber,i=d.endColumn}const a=o.join(""),[u,t,f]=(0,m.$wt)(a);return{sortIndex:0,identifier:l[0].identifier,range:c,rangeOffset:this.getOffsetAt(c.startLineNumber,c.startColumn),rangeLength:this.getValueLengthInRange(c,0),text:a,eolCount:u,firstLineLength:t,lastLineLength:f,forceMoveMarkers:$,isAutoWhitespaceEdit:!1}}t(l){l.sort(A.w);const $=[];for(let p=0;p<l.length;p++){const r=l[p],c=r.range.startLineNumber,s=r.range.startColumn,i=r.range.endLineNumber,o=r.range.endColumn;if(c===i&&s===o&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const a=new I.$Ws(c,s,i,o);$.push({range:a,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return $}findMatchesLineByLine(l,$,p,r){return this.c.findMatchesLineByLine(l,$,p,r)}getPieceTree(){return this.c}static _getInverseEditRange(l,$){const p=l.startLineNumber,r=l.startColumn,[c,s,i]=(0,m.$wt)($);let o;if($.length>0){const a=c+1;a===1?o=new I.$Ws(p,r,p,r+s):o=new I.$Ws(p,r,p+a-1,i+1)}else o=new I.$Ws(p,r,p,r);return o}static _getInverseEditRanges(l){const $=[];let p=0,r=0,c=null;for(let s=0,i=l.length;s<i;s++){const o=l[s];let a,u;c?c.range.endLineNumber===o.range.startLineNumber?(a=p,u=r+(o.range.startColumn-c.range.endColumn)):(a=p+(o.range.startLineNumber-c.range.endLineNumber),u=o.range.startColumn):(a=o.range.startLineNumber,u=o.range.startColumn);let t;if(o.text.length>0){const f=o.eolCount+1;f===1?t=new I.$Ws(a,u,a,u+o.firstLineLength):t=new I.$Ws(a,u,a+f-1,o.lastLineLength+1)}else t=new I.$Ws(a,u,a,u);p=t.endLineNumber,r=t.endColumn,$.push(t),c=o}return $}static u(l,$){const p=I.$Ws.compareRangesUsingEnds(l.range,$.range);return p===0?l.sortIndex-$.sortIndex:p}static w(l,$){const p=I.$Ws.compareRangesUsingEnds(l.range,$.range);return p===0?$.sortIndex-l.sortIndex:-p}}e.$dC=A}),define(Re[144],Ae([1,0,14,90,143]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=void 0;class R{constructor(h,E,A,D,l,$,p,r,c){this.a=h,this.b=E,this.c=A,this.d=D,this.e=l,this.f=$,this.g=p,this.h=r,this.j=c}k(h){const E=this.c+this.d+this.e,A=this.c+this.e;return E===0?h===1?`
`:`\r
`:A>E/2?`\r
`:`
`}create(h){const E=this.k(h),A=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let l=0,$=A.length;l<$;l++){const p=A[l].buffer.replace(/\r\n|\r|\n/g,E),r=(0,M.$$B)(p);A[l]=new M.$bC(p,r)}const D=new I.$dC(A,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText(h){return this.a[0].buffer.substr(0,h).split(/\r\n|\r|\n/)[0]}}class L{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(h){if(h.length===0)return;this.a.length===0&&S.$xf(h)&&(this.b=S.$wf,h=h.substr(1));const E=h.charCodeAt(h.length-1);E===13||E>=55296&&E<=56319?(this.m(h.substr(0,h.length-1),!1),this.c=!0,this.d=E):(this.m(h,!1),this.c=!1,this.d=E)}m(h,E){!E&&h.length===0||(this.c?this.n(String.fromCharCode(this.d)+h):this.n(h))}n(h){const E=(0,M.$_B)(this.e,h);this.a.push(new M.$bC(h,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=S.$of(h)),this.k||(this.k=S.$rf(h)))}finish(h=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,h)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const h=this.a[this.a.length-1];h.buffer+=String.fromCharCode(this.d);const E=(0,M.$$B)(h.buffer);h.lineStarts=E,this.d===13&&this.f++}}}e.$eC=L}),define(Re[95],Ae([1,0,23,20]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V$=e.$U$=void 0;var I;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(I||(I={}));function R(D){for(let l=0,$=D.length;l<$;l+=4){const p=D[l+0],r=D[l+1],c=D[l+2],s=D[l+3];D[l+0]=s,D[l+1]=c,D[l+2]=r,D[l+3]=p}}function L(D){const l=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return M.$D()||R(l),S.$ke.wrap(l)}function m(D){const l=D.buffer;if(M.$D()||R(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const $=new Uint8Array(l.byteLength);return $.set(l),new Uint32Array($.buffer,$.byteOffset,$.length/4)}}function h(D){const l=new Uint32Array(E(D));let $=0;if(l[$++]=D.id,D.type==="full")l[$++]=1,l[$++]=D.data.length,l.set(D.data,$),$+=D.data.length;else{l[$++]=2,l[$++]=D.deltas.length;for(const p of D.deltas)l[$++]=p.start,l[$++]=p.deleteCount,p.data?(l[$++]=p.data.length,l.set(p.data,$),$+=p.data.length):l[$++]=0}return L(l)}e.$U$=h;function E(D){let l=0;if(l+=2,D.type==="full")l+=1+D.data.length;else{l+=1,l+=3*D.deltas.length;for(const $ of D.deltas)$.data&&(l+=$.data.length)}return l}function A(D){const l=m(D);let $=0;const p=l[$++];if(l[$++]===1){const i=l[$++],o=l.subarray($,$+i);return $+=i,{id:p,type:"full",data:o}}const c=l[$++],s=[];for(let i=0;i<c;i++){const o=l[$++],a=l[$++],u=l[$++];let t;u>0&&(t=l.subarray($,$+u),$+=u),s[i]={start:o,deleteCount:a,data:t}}return{id:p,type:"delta",deltas:s}}e.$V$=A}),define(Re[145],Ae([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Re[146],Ae([1,0,18,26,20,129,147,145]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var h;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(h||(e.EditorAutoIndentStrategy=h={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=E;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class D{constructor(X,ve,Be,Qe){this.id=X,this.name=ve,this.defaultValue=Be,this.schema=Qe}applyUpdate(X,ve){return $(X,ve)}compute(X,ve,Be){return Be}}class l{constructor(X,ve){this.newValue=X,this.didChange=ve}}e.ApplyUpdateResult=l;function $(Y,X){if(typeof Y!="object"||typeof X!="object"||!Y||!X)return new l(X,Y!==X);if(Array.isArray(Y)||Array.isArray(X)){const Be=Array.isArray(Y)&&Array.isArray(X)&&S.$ub(Y,X);return new l(X,!Be)}let ve=!1;for(const Be in X)if(X.hasOwnProperty(Be)){const Qe=$(Y[Be],X[Be]);Qe.didChange&&(Y[Be]=Qe.newValue,ve=!0)}return new l(Y,ve)}class p{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,ve){return $(X,ve)}validate(X){return this.defaultValue}}class r{constructor(X,ve,Be,Qe){this.id=X,this.name=ve,this.defaultValue=Be,this.schema=Qe}applyUpdate(X,ve){return $(X,ve)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,ve,Be){return Be}}function c(Y,X){return typeof Y>"u"?X:Y==="false"?!1:!!Y}e.boolean=c;class s extends r{constructor(X,ve,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=Be),super(X,ve,Be,Qe)}validate(X){return c(X,this.defaultValue)}}function i(Y,X,ve,Be){if(typeof Y>"u")return X;let Qe=parseInt(Y,10);return isNaN(Qe)?X:(Qe=Math.max(ve,Qe),Qe=Math.min(Be,Qe),Qe|0)}e.clampedInt=i;class o extends r{static clampedInt(X,ve,Be,Qe){return i(X,ve,Be,Qe)}constructor(X,ve,Be,Qe,tt,ot=void 0){typeof ot<"u"&&(ot.type="integer",ot.default=Be,ot.minimum=Qe,ot.maximum=tt),super(X,ve,Be,ot),this.minimum=Qe,this.maximum=tt}validate(X){return o.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function a(Y,X,ve,Be){if(typeof Y>"u")return X;const Qe=u.float(Y,X);return u.clamp(Qe,ve,Be)}e.clampedFloat=a;class u extends r{static clamp(X,ve,Be){return X<ve?ve:X>Be?Be:X}static float(X,ve){if(typeof X=="number")return X;if(typeof X>"u")return ve;const Be=parseFloat(X);return isNaN(Be)?ve:Be}constructor(X,ve,Be,Qe,tt){typeof tt<"u"&&(tt.type="number",tt.default=Be),super(X,ve,Be,tt),this.validationFn=Qe}validate(X){return this.validationFn(u.float(X,this.defaultValue))}}class t extends r{static string(X,ve){return typeof X!="string"?ve:X}constructor(X,ve,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=Be),super(X,ve,Be,Qe)}validate(X){return t.string(X,this.defaultValue)}}function f(Y,X,ve,Be){return typeof Y!="string"?X:Be&&Y in Be?Be[Y]:ve.indexOf(Y)===-1?X:Y}e.stringSet=f;class n extends r{constructor(X,ve,Be,Qe,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.enum=Qe,tt.default=Be),super(X,ve,Be,tt),this.c=Qe}validate(X){return f(X,this.defaultValue,this.c)}}class w extends D{constructor(X,ve,Be,Qe,tt,ot,Fe=void 0){typeof Fe<"u"&&(Fe.type="string",Fe.enum=tt,Fe.default=Qe),super(X,ve,Be,Fe),this.c=tt,this.d=ot}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function y(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,ve,Be){return Be===0?X.accessibilitySupport:Be}}class b extends D{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:m.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{insertSpace:c(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var P;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(P||(e.TextEditorCursorBlinkingStyle=P={}));function g(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(v||(e.TextEditorCursorStyle=v={}));function k(Y){switch(Y){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function F(Y){switch(Y){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class O extends p{constructor(){super(140)}compute(X,ve,Be){const Qe=["monaco-editor"];return ve.get(39)&&Qe.push(ve.get(39)),X.extraEditorClassName&&Qe.push(X.extraEditorClassName),ve.get(73)==="default"?Qe.push("mouse-default"):ve.get(73)==="copy"&&Qe.push("mouse-copy"),ve.get(110)&&Qe.push("showUnused"),ve.get(138)&&Qe.push("showDeprecated"),Qe.join(" ")}}class G extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(X,ve,Be){return Be&&X.emptySelectionClipboard}}class q extends D{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:m.localize(16,null),included:I.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:m.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{cursorMoveOnType:c(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":f(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":f(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(ve.loop,this.defaultValue.loop)}}}class U extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"||X.length===0?U.OFF:X==="true"?U.ON:X:X?U.ON:U.OFF}}e.EditorFontLigatures=U;class C extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",C.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?C.OFF:X==="true"?C.TRANSLATE:X:X?C.TRANSLATE:C.OFF}compute(X,ve,Be){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=C;class N extends p{constructor(){super(50)}compute(X,ve,Be){return X.fontInfo}}class W extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(X){const ve=u.float(X,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(ve,6,100)}compute(X,ve,Be){return X.fontInfo.fontSize}}class se extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:se.d,maximum:se.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:se.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(o.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,se.d,se.e))}}class le extends D{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...ve},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...ve},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Be,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Be,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Be,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Be,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Be,description:m.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{multiple:f(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??f(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??f(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??f(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??f(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??f(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Ee extends D{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:m.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:c(ve.enabled,this.defaultValue.enabled),delay:o.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:c(ve.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(ve.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:c(ve.above,this.defaultValue.above)}}}var De;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(De||(e.RenderMinimap=De={}));class ce extends p{constructor(){super(143)}compute(X,ve,Be){return ce.computeLayout(ve,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const ve=X.height/X.lineHeight,Be=Math.floor(X.paddingTop/X.lineHeight);let Qe=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Qe=Math.max(Qe,ve-1));const tt=(Be+X.viewLineCount+Qe)/(X.pixelRatio*X.height),ot=Math.floor(X.viewLineCount/tt);return{typicalViewportLineCount:ve,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Qe,desiredRatio:tt,minimapLineCount:ot}}static c(X,ve){const Be=X.outerWidth,Qe=X.outerHeight,tt=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const ot=ve.stableMinimapLayoutInput,Fe=ot&&X.outerHeight===ot.outerHeight&&X.lineHeight===ot.lineHeight&&X.typicalHalfwidthCharacterWidth===ot.typicalHalfwidthCharacterWidth&&X.pixelRatio===ot.pixelRatio&&X.scrollBeyondLastLine===ot.scrollBeyondLastLine&&X.paddingTop===ot.paddingTop&&X.paddingBottom===ot.paddingBottom&&X.minimap.enabled===ot.minimap.enabled&&X.minimap.side===ot.minimap.side&&X.minimap.size===ot.minimap.size&&X.minimap.showSlider===ot.minimap.showSlider&&X.minimap.renderCharacters===ot.minimap.renderCharacters&&X.minimap.maxColumn===ot.minimap.maxColumn&&X.minimap.scale===ot.minimap.scale&&X.verticalScrollbarWidth===ot.verticalScrollbarWidth&&X.isViewportWrapping===ot.isViewportWrapping,Wt=X.lineHeight,Mt=X.typicalHalfwidthCharacterWidth,xt=X.scrollBeyondLastLine,Nt=X.minimap.renderCharacters;let Et=tt>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Yt=X.minimap.maxColumn,Ot=X.minimap.size,ii=X.minimap.side,Qt=X.verticalScrollbarWidth,Vt=X.viewLineCount,Xe=X.remainingWidth,Xt=X.isViewportWrapping,_t=Nt?2:3;let lt=Math.floor(tt*Qe);const pt=lt/tt;let qt=!1,ei=!1,kt=_t*Et,dt=Et/tt,Pt=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:ft,extraLinesBeforeFirstLine:Rt,extraLinesBeyondLastLine:Ct,desiredRatio:Ut,minimapLineCount:Ht}=ce.computeContainedMinimapLineCount({viewLineCount:Vt,scrollBeyondLastLine:xt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Qe,lineHeight:Wt,pixelRatio:tt});if(Vt/Ht>1)qt=!0,ei=!0,Et=1,kt=1,dt=Et/tt;else{let It=!1,Kt=Et+1;if(Ot==="fit"){const yt=Math.ceil((Rt+Vt+Ct)*kt);Xt&&Fe&&Xe<=ve.stableFitRemainingWidth?(It=!0,Kt=ve.stableFitMaxMinimapScale):It=yt>lt}if(Ot==="fill"||It){qt=!0;const yt=Et;kt=Math.min(Wt*tt,Math.max(1,Math.floor(1/Ut))),Xt&&Fe&&Xe<=ve.stableFitRemainingWidth&&(Kt=ve.stableFitMaxMinimapScale),Et=Math.min(Kt,Math.max(1,Math.floor(kt/_t))),Et>yt&&(Pt=Math.min(2,Et/yt)),dt=Et/tt/Pt,lt=Math.ceil(Math.max(ft,Rt+Vt+Ct)*kt),Xt?(ve.stableMinimapLayoutInput=X,ve.stableFitRemainingWidth=Xe,ve.stableFitMaxMinimapScale=Et):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const si=Math.floor(Yt*dt),Lt=Math.min(si,Math.max(0,Math.floor((Xe-Qt-2)*dt/(Mt+dt)))+e.MINIMAP_GUTTER_WIDTH);let qe=Math.floor(tt*Lt);const Tt=qe/tt;qe=Math.floor(qe*Pt);const zt=Nt?1:2,ti=ii==="left"?0:Be-Lt-Qt;return{renderMinimap:zt,minimapLeft:ti,minimapWidth:Lt,minimapHeightIsEditorHeight:qt,minimapIsSampling:ei,minimapScale:Et,minimapLineHeight:kt,minimapCanvasInnerWidth:qe,minimapCanvasInnerHeight:lt,minimapCanvasOuterWidth:Tt,minimapCanvasOuterHeight:pt}}static computeLayout(X,ve){const Be=ve.outerWidth|0,Qe=ve.outerHeight|0,tt=ve.lineHeight|0,ot=ve.lineNumbersDigitCount|0,Fe=ve.typicalHalfwidthCharacterWidth,Wt=ve.maxDigitWidth,Mt=ve.pixelRatio,xt=ve.viewLineCount,Nt=X.get(135),Et=Nt==="inherit"?X.get(134):Nt,Yt=Et==="inherit"?X.get(130):Et,Ot=X.get(133),ii=ve.isDominatedByLongLines,Qt=X.get(57),Vt=X.get(67).renderType!==0,Xe=X.get(68),Xt=X.get(104),_t=X.get(83),lt=X.get(72),pt=X.get(102),qt=pt.verticalScrollbarSize,ei=pt.verticalHasArrows,kt=pt.arrowSize,dt=pt.horizontalScrollbarSize,Pt=X.get(43),si=X.get(109)!=="never";let Lt=X.get(65);Pt&&si&&(Lt+=16);let qe=0;if(Vt){const Dt=Math.max(ot,Xe);qe=Math.round(Dt*Wt)}let Tt=0;Qt&&(Tt=tt*ve.glyphMarginDecorationLaneCount);let zt=0,ti=zt+Tt,ft=ti+qe,Rt=ft+Lt;const Ct=Be-Tt-qe-Lt;let Ut=!1,Ht=!1,jt=-1;Et==="inherit"&&ii?(Ut=!0,Ht=!0):Yt==="on"||Yt==="bounded"?Ht=!0:Yt==="wordWrapColumn"&&(jt=Ot);const It=ce.c({outerWidth:Be,outerHeight:Qe,lineHeight:tt,typicalHalfwidthCharacterWidth:Fe,pixelRatio:Mt,scrollBeyondLastLine:Xt,paddingTop:_t.top,paddingBottom:_t.bottom,minimap:lt,verticalScrollbarWidth:qt,viewLineCount:xt,remainingWidth:Ct,isViewportWrapping:Ht},ve.memory||new A);It.renderMinimap!==0&&It.minimapLeft===0&&(zt+=It.minimapWidth,ti+=It.minimapWidth,ft+=It.minimapWidth,Rt+=It.minimapWidth);const Kt=Ct-It.minimapWidth,yt=Math.max(1,Math.floor((Kt-qt-2)/Fe)),wt=ei?kt:0;return Ht&&(jt=Math.max(1,yt),Yt==="bounded"&&(jt=Math.min(jt,Ot))),{width:Be,height:Qe,glyphMarginLeft:zt,glyphMarginWidth:Tt,glyphMarginDecorationLaneCount:ve.glyphMarginDecorationLaneCount,lineNumbersLeft:ti,lineNumbersWidth:qe,decorationsLeft:ft,decorationsWidth:Lt,contentLeft:Rt,contentWidth:Kt,minimap:It,viewportColumn:yt,isWordWrapMinified:Ut,isViewportWrapping:Ht,wrappingColumn:jt,verticalScrollbarWidth:qt,horizontalScrollbarHeight:dt,overviewRuler:{top:wt,width:qt,height:Qe-2*wt,right:0}}}}e.EditorLayoutInfoComputer=ce;class pe extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(X){return f(X,"simple",["simple","advanced"])}compute(X,ve,Be){return ve.get(2)===2?"advanced":Be}}var oe;(function(Y){Y.Off="off",Y.OnCode="onCode",Y.On="on"})(oe||(e.ShowLightbulbIconMode=oe={}));class $e extends D{constructor(){const X={enabled:oe.OnCode};super(64,"lightbulb",X,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[oe.Off,oe.OnCode,oe.On],default:X.enabled,enumDescriptions:[m.localize(50,null),m.localize(51,null),m.localize(52,null)],description:m.localize(53,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:f(X.enabled,this.defaultValue.enabled,[oe.Off,oe.OnCode,oe.On])}}}class ie extends D{constructor(){const X={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:m.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:m.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:m.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:m.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:c(ve.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(ve.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:f(ve.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:c(ve.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class x extends D{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:m.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(59,null),m.localize(60,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(61,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:m.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:m.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:m.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return typeof ve.enabled=="boolean"&&(ve.enabled=ve.enabled?"on":"off"),{enabled:f(ve.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(ve.fontFamily,this.defaultValue.fontFamily),padding:c(ve.padding,this.defaultValue.padding)}}}class V extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):o.clampedInt(X,this.defaultValue,0,1e3)}compute(X,ve,Be){return Be<0?o.clampedInt(-Be*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class ne extends u{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>u.clamp(X,0,150),{markdownDescription:m.localize(66,null)})}compute(X,ve,Be){return X.fontInfo.lineHeight}}class Ie extends D{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:m.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:m.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(69,null),m.localize(70,null),m.localize(71,null)],default:X.size,description:m.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:m.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:m.localize(74,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:m.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:m.localize(77,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:c(ve.enabled,this.defaultValue.enabled),autohide:c(ve.autohide,this.defaultValue.autohide),size:f(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(ve.side,this.defaultValue.side,["right","left"]),showSlider:f(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(ve.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(ve.scale,1,1,3),maxColumn:o.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Me(Y){return Y==="ctrlCmd"?I.$j?"metaKey":"ctrlKey":"altKey"}class Le extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(79,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{top:o.clampedInt(ve.top,0,0,1e3),bottom:o.clampedInt(ve.bottom,0,0,1e3)}}}class we extends D{constructor(){const X={enabled:!0,cycle:!0};super(85,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:m.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:m.localize(81,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:c(ve.enabled,this.defaultValue.enabled),cycle:c(ve.cycle,this.defaultValue.cycle)}}}class ge extends p{constructor(){super(141)}compute(X,ve,Be){return X.pixelRatio}}class K extends D{constructor(){const X={other:"on",comments:"off",strings:"off"},ve=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(82,null),m.localize(83,null),m.localize(84,null)]}];super(88,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ve,default:X.strings,description:m.localize(85,null)},comments:{anyOf:ve,default:X.comments,description:m.localize(86,null)},other:{anyOf:ve,default:X.other,description:m.localize(87,null)}},default:X,markdownDescription:m.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Mt=X?"on":"off";return{comments:Mt,strings:Mt,other:Mt}}if(!X||typeof X!="object")return this.defaultValue;const{other:ve,comments:Be,strings:Qe}=X,tt=["on","inline","off"];let ot,Fe,Wt;return typeof ve=="boolean"?ot=ve?"on":"off":ot=f(ve,this.defaultValue.other,tt),typeof Be=="boolean"?Fe=Be?"on":"off":Fe=f(Be,this.defaultValue.comments,tt),typeof Qe=="boolean"?Wt=Qe?"on":"off":Wt=f(Qe,this.defaultValue.strings,tt),{other:ot,comments:Fe,strings:Wt}}}var ee;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class he extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(89,null),m.localize(90,null),m.localize(91,null),m.localize(92,null)],default:"on",description:m.localize(93,null)})}validate(X){let ve=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(ve=4,Be=X):X==="interval"?ve=3:X==="relative"?ve=2:X==="on"?ve=1:ve=0),{renderType:ve,renderFn:Be}}}function fe(Y){const X=Y.get(97);return X==="editable"?Y.get(90):X!=="on"}e.filterValidationDecorations=fe;class Ce extends D{constructor(){const X=[],ve={type:"number",description:m.localize(94,null)};super(101,"rulers",X,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:m.localize(95,null),format:"color-hex"}}}]},default:X,description:m.localize(96,null)})}validate(X){if(Array.isArray(X)){const ve=[];for(const Be of X)if(typeof Be=="number")ve.push({column:o.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Qe=Be;ve.push({column:o.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return ve.sort((Be,Qe)=>Be.column-Qe.column),ve}return this.defaultValue}}class de extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function ye(Y,X){if(typeof Y!="string")return X;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class T extends D{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(97,null),m.localize(98,null),m.localize(99,null)],default:"auto",description:m.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(101,null),m.localize(102,null),m.localize(103,null)],default:"auto",description:m.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:m.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:m.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:m.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:X.ignoreHorizontalScrollbarInContentHeight,description:m.localize(108,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X,Be=o.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=o.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ye(ve.vertical,this.defaultValue.vertical),horizontal:ye(ve.horizontal,this.defaultValue.horizontal),useShadows:c(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:o.clampedInt(ve.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:o.clampedInt(ve.verticalSliderSize,Qe,0,1e3),scrollByPage:c(ve.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:c(ve.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends D{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:m.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:m.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:m.localize(115,null)}})}applyUpdate(X,ve){let Be=!1;ve.allowedCharacters&&X&&(M.$Cn(X.allowedCharacters,ve.allowedCharacters)||(X={...X,allowedCharacters:ve.allowedCharacters},Be=!0)),ve.allowedLocales&&X&&(M.$Cn(X.allowedLocales,ve.allowedLocales)||(X={...X,allowedLocales:ve.allowedLocales},Be=!0));const Qe=super.applyUpdate(X,ve);return Be?new l(Qe.newValue,!0):Qe}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{nonBasicASCII:_(ve.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:c(ve.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:c(ve.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:_(ve.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:_(ve.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,ve){if(typeof X!="object"||!X)return ve;const Be={};for(const[Qe,tt]of Object.entries(X))tt===!0&&(Be[Qe]=!0);return Be}}class J extends D{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:m.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(117,null),m.localize(118,null),m.localize(119,null)],description:m.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:m.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:X.fontFamily,description:m.localize(122,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:c(ve.enabled,this.defaultValue.enabled),mode:f(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(ve.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:c(ve.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:c(ve.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class B extends D{constructor(){const X={enabled:R.$us.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$us.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:m.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:m.localize(124,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:c(ve.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:c(ve.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Z extends D{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(125,null),m.localize(126,null),m.localize(127,null)],default:X.bracketPairs,description:m.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(129,null),m.localize(130,null),m.localize(131,null)],default:X.bracketPairsHorizontal,description:m.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:m.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:m.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(135,null),m.localize(136,null),m.localize(137,null)],default:X.highlightActiveIndentation,description:m.localize(138,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{bracketPairs:_(ve.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:_(ve.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:c(ve.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:c(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:_(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function _(Y,X,ve){const Be=ve.indexOf(Y);return Be===-1?X:ve[Be]}class ke extends D{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(139,null),m.localize(140,null)],default:X.insertMode,description:m.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:m.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:m.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:m.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(145,null),m.localize(146,null),m.localize(147,null),m.localize(148,null)],default:X.selectionMode,markdownDescription:m.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:m.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:m.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:m.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:m.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:m.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{insertMode:f(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(ve.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:c(ve.showIcons,this.defaultValue.showIcons),showStatusBar:c(ve.showStatusBar,this.defaultValue.showStatusBar),preview:c(ve.preview,this.defaultValue.preview),previewMode:f(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(ve.showMethods,this.defaultValue.showMethods),showFunctions:c(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:c(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(ve.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:c(ve.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:c(ve.showFields,this.defaultValue.showFields),showVariables:c(ve.showVariables,this.defaultValue.showVariables),showClasses:c(ve.showClasses,this.defaultValue.showClasses),showStructs:c(ve.showStructs,this.defaultValue.showStructs),showInterfaces:c(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:c(ve.showModules,this.defaultValue.showModules),showProperties:c(ve.showProperties,this.defaultValue.showProperties),showEvents:c(ve.showEvents,this.defaultValue.showEvents),showOperators:c(ve.showOperators,this.defaultValue.showOperators),showUnits:c(ve.showUnits,this.defaultValue.showUnits),showValues:c(ve.showValues,this.defaultValue.showValues),showConstants:c(ve.showConstants,this.defaultValue.showConstants),showEnums:c(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:c(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(ve.showKeywords,this.defaultValue.showKeywords),showWords:c(ve.showWords,this.defaultValue.showWords),showColors:c(ve.showColors,this.defaultValue.showColors),showFiles:c(ve.showFiles,this.defaultValue.showFiles),showReferences:c(ve.showReferences,this.defaultValue.showReferences),showFolders:c(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:c(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(ve.showSnippets,this.defaultValue.showSnippets),showUsers:c(ve.showUsers,this.defaultValue.showUsers),showIssues:c(ve.showIssues,this.defaultValue.showIssues)}}}class Ne extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(188,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:c(X.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class He extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(189,null),m.localize(190,null),m.localize(191,null),m.localize(192,null)],description:m.localize(193,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,ve,Be){return ve.get(2)===2?0:Be}}class Ye extends p{constructor(){super(144)}compute(X,ve,Be){const Qe=ve.get(143);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class nt extends D{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:m.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(196,null),m.localize(197,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:c(ve.enabled,this.defaultValue.enabled),showDropSelector:f(ve.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends D{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:m.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(200,null),m.localize(201,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:c(ve.enabled,this.defaultValue.enabled),showPasteSelector:f(ve.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const et="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$j?st:I.$k?ct:et,fontWeight:"normal",fontSize:I.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var $t;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.letterSpacing=63]="letterSpacing",Y[Y.lightbulb=64]="lightbulb",Y[Y.lineDecorationsWidth=65]="lineDecorationsWidth",Y[Y.lineHeight=66]="lineHeight",Y[Y.lineNumbers=67]="lineNumbers",Y[Y.lineNumbersMinChars=68]="lineNumbersMinChars",Y[Y.linkedEditing=69]="linkedEditing",Y[Y.links=70]="links",Y[Y.matchBrackets=71]="matchBrackets",Y[Y.minimap=72]="minimap",Y[Y.mouseStyle=73]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=75]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=77]="multiCursorModifier",Y[Y.multiCursorPaste=78]="multiCursorPaste",Y[Y.multiCursorLimit=79]="multiCursorLimit",Y[Y.occurrencesHighlight=80]="occurrencesHighlight",Y[Y.overviewRulerBorder=81]="overviewRulerBorder",Y[Y.overviewRulerLanes=82]="overviewRulerLanes",Y[Y.padding=83]="padding",Y[Y.pasteAs=84]="pasteAs",Y[Y.parameterHints=85]="parameterHints",Y[Y.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=88]="quickSuggestions",Y[Y.quickSuggestionsDelay=89]="quickSuggestionsDelay",Y[Y.readOnly=90]="readOnly",Y[Y.readOnlyMessage=91]="readOnlyMessage",Y[Y.renameOnType=92]="renameOnType",Y[Y.renderControlCharacters=93]="renderControlCharacters",Y[Y.renderFinalNewline=94]="renderFinalNewline",Y[Y.renderLineHighlight=95]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=97]="renderValidationDecorations",Y[Y.renderWhitespace=98]="renderWhitespace",Y[Y.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Y[Y.roundedSelection=100]="roundedSelection",Y[Y.rulers=101]="rulers",Y[Y.scrollbar=102]="scrollbar",Y[Y.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=104]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=105]="scrollPredominantAxis",Y[Y.selectionClipboard=106]="selectionClipboard",Y[Y.selectionHighlight=107]="selectionHighlight",Y[Y.selectOnLineNumbers=108]="selectOnLineNumbers",Y[Y.showFoldingControls=109]="showFoldingControls",Y[Y.showUnused=110]="showUnused",Y[Y.snippetSuggestions=111]="snippetSuggestions",Y[Y.smartSelect=112]="smartSelect",Y[Y.smoothScrolling=113]="smoothScrolling",Y[Y.stickyScroll=114]="stickyScroll",Y[Y.stickyTabStops=115]="stickyTabStops",Y[Y.stopRenderingLineAfter=116]="stopRenderingLineAfter",Y[Y.suggest=117]="suggest",Y[Y.suggestFontSize=118]="suggestFontSize",Y[Y.suggestLineHeight=119]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Y[Y.suggestSelection=121]="suggestSelection",Y[Y.tabCompletion=122]="tabCompletion",Y[Y.tabIndex=123]="tabIndex",Y[Y.unicodeHighlighting=124]="unicodeHighlighting",Y[Y.unusualLineTerminators=125]="unusualLineTerminators",Y[Y.useShadowDOM=126]="useShadowDOM",Y[Y.useTabStops=127]="useTabStops",Y[Y.wordBreak=128]="wordBreak",Y[Y.wordSeparators=129]="wordSeparators",Y[Y.wordWrap=130]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=133]="wordWrapColumn",Y[Y.wordWrapOverride1=134]="wordWrapOverride1",Y[Y.wordWrapOverride2=135]="wordWrapOverride2",Y[Y.wrappingIndent=136]="wrappingIndent",Y[Y.wrappingStrategy=137]="wrappingStrategy",Y[Y.showDeprecated=138]="showDeprecated",Y[Y.inlayHints=139]="inlayHints",Y[Y.editorClassName=140]="editorClassName",Y[Y.pixelRatio=141]="pixelRatio",Y[Y.tabFocusMode=142]="tabFocusMode",Y[Y.layoutInfo=143]="layoutInfo",Y[Y.wrappingInfo=144]="wrappingInfo",Y[Y.defaultColorDecorators=145]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})($t||(e.EditorOption=$t={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(202,null)})),acceptSuggestionOnEnter:Ue(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(203,null),""],markdownDescription:m.localize(204,null)})),accessibilitySupport:Ue(new d),accessibilityPageSize:Ue(new o(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(205,null),tags:["accessibility"]})),ariaLabel:Ue(new t(4,"ariaLabel",m.localize(206,null))),ariaRequired:Ue(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new n(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(208,null),m.localize(209,null),""],description:m.localize(210,null)})),autoClosingComments:Ue(new n(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(211,null),m.localize(212,null),""],description:m.localize(213,null)})),autoClosingDelete:Ue(new n(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(214,null),""],description:m.localize(215,null)})),autoClosingOvertype:Ue(new n(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(216,null),""],description:m.localize(217,null)})),autoClosingQuotes:Ue(new n(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(218,null),m.localize(219,null),""],description:m.localize(220,null)})),autoIndent:Ue(new w(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[m.localize(221,null),m.localize(222,null),m.localize(223,null),m.localize(224,null),m.localize(225,null)],description:m.localize(226,null)})),automaticLayout:Ue(new s(13,"automaticLayout",!1)),autoSurround:Ue(new n(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(227,null),m.localize(228,null),m.localize(229,null),""],description:m.localize(230,null)})),bracketPairColorization:Ue(new B),bracketPairGuides:Ue(new Z),stickyTabStops:Ue(new s(115,"stickyTabStops",!1,{description:m.localize(231,null)})),codeLens:Ue(new s(17,"codeLens",!0,{description:m.localize(232,null)})),codeLensFontFamily:Ue(new t(18,"codeLensFontFamily","",{description:m.localize(233,null)})),codeLensFontSize:Ue(new o(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(234,null)})),colorDecorators:Ue(new s(20,"colorDecorators",!0,{description:m.localize(235,null)})),colorDecoratorActivatedOn:Ue(new n(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(236,null),m.localize(237,null),m.localize(238,null)],description:m.localize(239,null)})),colorDecoratorsLimit:Ue(new o(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(240,null)})),columnSelection:Ue(new s(22,"columnSelection",!1,{description:m.localize(241,null)})),comments:Ue(new b),contextmenu:Ue(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new s(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(242,null)})),cursorBlinking:Ue(new w(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:m.localize(243,null)})),cursorSmoothCaretAnimation:Ue(new n(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(244,null),m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),cursorStyle:Ue(new w(28,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:m.localize(248,null)})),cursorSurroundingLines:Ue(new o(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(249,null)})),cursorSurroundingLinesStyle:Ue(new n(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(250,null),m.localize(251,null)],markdownDescription:m.localize(252,null)})),cursorWidth:Ue(new o(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(253,null)})),disableLayerHinting:Ue(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new s(34,"domReadOnly",!1)),dragAndDrop:Ue(new s(35,"dragAndDrop",!0,{description:m.localize(254,null)})),emptySelectionClipboard:Ue(new G),dropIntoEditor:Ue(new nt),stickyScroll:Ue(new ie),experimentalWhitespaceRendering:Ue(new n(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(255,null),m.localize(256,null),m.localize(257,null)],description:m.localize(258,null)})),extraEditorClassName:Ue(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new u(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:m.localize(259,null)})),find:Ue(new q),fixedOverflowWidgets:Ue(new s(42,"fixedOverflowWidgets",!1)),folding:Ue(new s(43,"folding",!0,{description:m.localize(260,null)})),foldingStrategy:Ue(new n(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(261,null),m.localize(262,null)],description:m.localize(263,null)})),foldingHighlight:Ue(new s(45,"foldingHighlight",!0,{description:m.localize(264,null)})),foldingImportsByDefault:Ue(new s(46,"foldingImportsByDefault",!1,{description:m.localize(265,null)})),foldingMaximumRegions:Ue(new o(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(266,null)})),unfoldOnClickAfterEndOfLine:Ue(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(267,null)})),fontFamily:Ue(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(268,null)})),fontInfo:Ue(new N),fontLigatures2:Ue(new U),fontSize:Ue(new W),fontWeight:Ue(new se),fontVariations:Ue(new C),formatOnPaste:Ue(new s(55,"formatOnPaste",!1,{description:m.localize(269,null)})),formatOnType:Ue(new s(56,"formatOnType",!1,{description:m.localize(270,null)})),glyphMargin:Ue(new s(57,"glyphMargin",!0,{description:m.localize(271,null)})),gotoLocation:Ue(new le),hideCursorInOverviewRuler:Ue(new s(59,"hideCursorInOverviewRuler",!1,{description:m.localize(272,null)})),hover:Ue(new Ee),inDiffEditor:Ue(new s(61,"inDiffEditor",!1)),letterSpacing:Ue(new u(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>u.clamp(Y,-5,20),{description:m.localize(273,null)})),lightbulb:Ue(new $e),lineDecorationsWidth:Ue(new V),lineHeight:Ue(new ne),lineNumbers:Ue(new he),lineNumbersMinChars:Ue(new o(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new s(69,"linkedEditing",!1,{description:m.localize(274,null)})),links:Ue(new s(70,"links",!0,{description:m.localize(275,null)})),matchBrackets:Ue(new n(71,"matchBrackets","always",["always","near","never"],{description:m.localize(276,null)})),minimap:Ue(new Ie),mouseStyle:Ue(new n(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new u(74,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:m.localize(277,null)})),mouseWheelZoom:Ue(new s(75,"mouseWheelZoom",!1,{markdownDescription:I.$j?m.localize(278,null):m.localize(279,null)})),multiCursorMergeOverlapping:Ue(new s(76,"multiCursorMergeOverlapping",!0,{description:m.localize(280,null)})),multiCursorModifier:Ue(new w(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Me,{markdownEnumDescriptions:[m.localize(281,null),m.localize(282,null)],markdownDescription:m.localize(283,null)})),multiCursorPaste:Ue(new n(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(284,null),m.localize(285,null)],markdownDescription:m.localize(286,null)})),multiCursorLimit:Ue(new o(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(287,null)})),occurrencesHighlight:Ue(new n(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(288,null),m.localize(289,null),m.localize(290,null)],markdownDescription:m.localize(291,null)})),overviewRulerBorder:Ue(new s(81,"overviewRulerBorder",!0,{description:m.localize(292,null)})),overviewRulerLanes:Ue(new o(82,"overviewRulerLanes",3,0,3)),padding:Ue(new Le),pasteAs:Ue(new it),parameterHints:Ue(new we),peekWidgetDefaultFocus:Ue(new n(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(293,null),m.localize(294,null)],description:m.localize(295,null)})),definitionLinkOpensInPeek:Ue(new s(87,"definitionLinkOpensInPeek",!1,{description:m.localize(296,null)})),quickSuggestions:Ue(new K),quickSuggestionsDelay:Ue(new o(89,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(297,null)})),readOnly:Ue(new s(90,"readOnly",!1)),readOnlyMessage:Ue(new de),renameOnType:Ue(new s(92,"renameOnType",!1,{description:m.localize(298,null),markdownDeprecationMessage:m.localize(299,null)})),renderControlCharacters:Ue(new s(93,"renderControlCharacters",!0,{description:m.localize(300,null),restricted:!0})),renderFinalNewline:Ue(new n(94,"renderFinalNewline",I.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(301,null)})),renderLineHighlight:Ue(new n(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(302,null)],description:m.localize(303,null)})),renderLineHighlightOnlyWhenFocus:Ue(new s(96,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(304,null)})),renderValidationDecorations:Ue(new n(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new n(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(305,null),m.localize(306,null),m.localize(307,null),""],description:m.localize(308,null)})),revealHorizontalRightPadding:Ue(new o(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new s(100,"roundedSelection",!0,{description:m.localize(309,null)})),rulers:Ue(new Ce),scrollbar:Ue(new T),scrollBeyondLastColumn:Ue(new o(103,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(310,null)})),scrollBeyondLastLine:Ue(new s(104,"scrollBeyondLastLine",!0,{description:m.localize(311,null)})),scrollPredominantAxis:Ue(new s(105,"scrollPredominantAxis",!0,{description:m.localize(312,null)})),selectionClipboard:Ue(new s(106,"selectionClipboard",!0,{description:m.localize(313,null),included:I.$k})),selectionHighlight:Ue(new s(107,"selectionHighlight",!0,{description:m.localize(314,null)})),selectOnLineNumbers:Ue(new s(108,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new n(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(315,null),m.localize(316,null),m.localize(317,null)],description:m.localize(318,null)})),showUnused:Ue(new s(110,"showUnused",!0,{description:m.localize(319,null)})),showDeprecated:Ue(new s(138,"showDeprecated",!0,{description:m.localize(320,null)})),inlayHints:Ue(new x),snippetSuggestions:Ue(new n(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(321,null),m.localize(322,null),m.localize(323,null),m.localize(324,null)],description:m.localize(325,null)})),smartSelect:Ue(new Ne),smoothScrolling:Ue(new s(113,"smoothScrolling",!1,{description:m.localize(326,null)})),stopRenderingLineAfter:Ue(new o(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new ke),inlineSuggest:Ue(new J),inlineCompletionsAccessibilityVerbose:Ue(new s(147,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(327,null)})),suggestFontSize:Ue(new o(118,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(328,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new o(119,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(329,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new s(120,"suggestOnTriggerCharacters",!0,{description:m.localize(330,null)})),suggestSelection:Ue(new n(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(331,null),m.localize(332,null),m.localize(333,null)],description:m.localize(334,null)})),tabCompletion:Ue(new n(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(335,null),m.localize(336,null),m.localize(337,null)],description:m.localize(338,null)})),tabIndex:Ue(new o(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new H),unusualLineTerminators:Ue(new n(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(339,null),m.localize(340,null),m.localize(341,null)],description:m.localize(342,null)})),useShadowDOM:Ue(new s(126,"useShadowDOM",!0)),useTabStops:Ue(new s(127,"useTabStops",!0,{description:m.localize(343,null)})),wordBreak:Ue(new n(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(344,null),m.localize(345,null)],description:m.localize(346,null)})),wordSeparators:Ue(new t(129,"wordSeparators",L.$vs,{description:m.localize(347,null)})),wordWrap:Ue(new n(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(348,null),m.localize(349,null),m.localize(350,null),m.localize(351,null)],description:m.localize(352,null)})),wordWrapBreakAfterCharacters:Ue(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new o(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(353,null)})),wordWrapOverride1:Ue(new n(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new n(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new O),defaultColorDecorators:Ue(new s(145,"defaultColorDecorators",!1,{markdownDescription:m.localize(354,null)})),pixelRatio:Ue(new ge),tabFocusMode:Ue(new s(142,"tabFocusMode",!1,{markdownDescription:m.localize(355,null)})),layoutInfo:Ue(new ce),wrappingInfo:Ue(new Ye),wrappingIndent:Ue(new He),wrappingStrategy:Ue(new pe)}}),define(Re[148],Ae([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Re[149],Ae([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Re[150],Ae([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Re[151],Ae([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Re[152],Ae([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Re[153],Ae([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Re[154],Ae([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Re[155],Ae([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Re[156],Ae([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Re[157],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Re[158],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Re[159],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Re[160],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Re[161],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Re[162],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Re[163],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Re[164],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Re[165],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Re[166],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Re[167],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Re[168],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Re[169],Ae([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(Re[170],Ae([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Re[171],Ae([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Re[172],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Re[173],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Re[174],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Re[175],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Re[176],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Re[177],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Re[178],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Re[179],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Re[180],Ae([1,0,15,150]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.TokenType=void 0;var I;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(I||(e.TokenType=I={}));function R(...E){switch(E.length){case 1:return(0,M.localize)(0,null,E[0]);case 2:return(0,M.localize)(1,null,E[0],E[1]);case 3:return(0,M.localize)(2,null,E[0],E[1],E[2]);default:return}}const L=(0,M.localize)(3,null),m=(0,M.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const D=this.d,l=this.c.substring(this.d,this.e),$={type:19,offset:this.d,lexeme:l};this.g.push({offset:D,lexeme:l,additionalInfo:A}),this.f.push($)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const D=this.c.substring(this.d,this.e),l=h.b.get(D);l?this.k(l):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,D=!1,l=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(m);return}const p=this.c.charCodeAt(A);if(D)D=!1;else if(p===47&&!l){A++;break}else p===91?l=!0:p===92?D=!0:p===93&&(l=!1);A++}for(;A<this.c.length&&h.a.has(this.c.charCodeAt(A));)A++;this.e=A;const $=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$3i=h}),define(Re[181],Ae([1,0,25,32,152,295]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function h(s){return s=s.trim(),s==="*"||L.test(s)}e.$cp=h;function E(s){if(!h(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=s.match(L);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$dp=E;function A(s){if(!s)return null;const i=s.majorBase,o=s.majorMustEqual,a=s.minorBase;let u=s.minorMustEqual;const t=s.patchBase;let f=s.patchMustEqual;s.hasCaret&&(i===0||(u=!1),f=!1);let n=0;if(s.preRelease){const w=m.exec(s.preRelease);if(w){const[,y,d,b]=w;n=Date.UTC(Number(y),Number(d)-1,Number(b))}}return{majorBase:i,majorMustEqual:o,minorBase:a,minorMustEqual:u,patchBase:t,patchMustEqual:f,isMinimum:s.hasGreaterEquals,notBefore:n}}e.$ep=A;function D(s,i,o){let a;typeof s=="string"?a=A(E(s)):a=s;let u;i instanceof Date?u=i.getTime():typeof i=="string"&&(u=new Date(i).getTime());let t;if(typeof o=="string"?t=A(E(o)):t=o,!a||!t)return!1;const f=a.majorBase,n=a.minorBase,w=a.patchBase;let y=t.majorBase,d=t.minorBase,b=t.patchBase;const P=t.notBefore;let g=t.majorMustEqual,v=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?f>y?!0:f<y?!1:n>d?!0:n<d||u&&u<P?!1:w>=b:(f===1&&y===0&&(!g||!v||!k)&&(y=1,d=0,b=0,g=!0,v=!1,k=!1),f<y?!1:f>y?!g:n<d?!1:n>d?!v:w<b?!1:w>b?!k:!(u&&u<P))}e.$fp=D;function l(s,i,o,a,u){const t=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return t.push([M.default.Error,I.localize(0,null)]),t;if(typeof a.name!="string")return t.push([M.default.Error,I.localize(1,null,"name")]),t;if(typeof a.version!="string")return t.push([M.default.Error,I.localize(2,null,"version")]),t;if(!a.engines)return t.push([M.default.Error,I.localize(3,null,"engines")]),t;if(typeof a.engines.vscode!="string")return t.push([M.default.Error,I.localize(4,null,"engines.vscode")]),t;if(typeof a.extensionDependencies<"u"&&!c(a.extensionDependencies))return t.push([M.default.Error,I.localize(5,null,"extensionDependencies")]),t;if(typeof a.activationEvents<"u"){if(!c(a.activationEvents))return t.push([M.default.Error,I.localize(6,null,"activationEvents")]),t;if(typeof a.main>"u"&&typeof a.browser>"u")return t.push([M.default.Error,I.localize(7,null,"activationEvents","main","browser")]),t}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&t.push([M.default.Warning,I.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return t.push([M.default.Error,I.localize(9,null,"main")]),t;{const w=(0,S.$Ig)(o,a.main);(0,S.$Cg)(w,o)||t.push([M.default.Warning,I.localize(10,null,w.path,o.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return t.push([M.default.Error,I.localize(11,null,"browser")]),t;{const w=(0,S.$Ig)(o,a.browser);(0,S.$Cg)(w,o)||t.push([M.default.Warning,I.localize(12,null,w.path,o.path)])}}if(!R.valid(a.version))return t.push([M.default.Error,I.localize(13,null)]),t;const f=[];if(!$(s,i,a,u,f))for(const w of f)t.push([M.default.Error,w]);return t}e.$gp=l;function $(s,i,o,a,u){return a||typeof o.main>"u"&&typeof o.browser>"u"?!0:r(s,i,o.engines.vscode,u)}e.$hp=$;function p(s,i,o){return s==="*"||r(i,o,s)}e.$ip=p;function r(s,i,o,a=[]){const u=A(E(o));if(!u)return a.push(I.localize(14,null,o)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return a.push(I.localize(15,null,o)),!1}else if(!u.majorMustEqual)return a.push(I.localize(16,null,o)),!1;return D(s,i,u)?!0:(a.push(I.localize(17,null,s,o)),!1)}function c(s){if(!Array.isArray(s))return!1;for(let i=0,o=s.length;i<o;i++)if(typeof s[i]!="string")return!1;return!0}}),define(Re[70],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=void 0;class S{constructor(I,R=[],L=!1){this.ctor=I,this.staticArguments=R,this.supportsDelayedInstantiation=L}}e.$5h=S}),define(Re[53],Ae([1,0,70]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.InstantiationType=void 0;const M=[];var I;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function R(m,h,E){h instanceof S.$5h||(h=new S.$5h(h,[],!!E)),M.push([m,h])}e.$1r=R;function L(){return M}e.$2r=L}),define(Re[182],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;class S{constructor(R,L){this.key=R,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$Eq=S;class M{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const L of this.a.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const m=this.lookupOrInsertNode(R),h=this.lookupOrInsertNode(L);m.outgoing.set(h.key,h),h.incoming.set(m.key,m)}removeNode(R){const L=this.b(R);this.a.delete(L);for(const m of this.a.values())m.outgoing.delete(L),m.incoming.delete(L)}lookupOrInsertNode(R){const L=this.b(R);let m=this.a.get(L);return m||(m=new S(L,R),this.a.set(L,m)),m}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[L,m]of this.a)R.push(`${L}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,L]of this.a){const m=new Set([R]),h=this.c(L,m);if(h)return h}}c(R,L){for(const[m,h]of R.outgoing){if(L.has(m))return[...L,m].join(" -> ");L.add(m);const E=this.c(h,L);if(E)return E;L.delete(m)}}}e.$Fq=M}),define(Re[4],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e._util=void 0;var S;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function m(h){return h[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=m})(S||(e._util=S={})),e.$7h=I("instantiationService");function M(L,m,h){m[S.DI_TARGET]===m?m[S.DI_DEPENDENCIES].push({id:L,index:h}):(m[S.DI_DEPENDENCIES]=[{id:L,index:h}],m[S.DI_TARGET]=m)}function I(L){if(S.serviceIds.has(L))return S.serviceIds.get(L);const m=function(h,E,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(m,h,A)};return m.toString=()=>L,S.serviceIds.set(L,m),m}e.$8h=I;function R(L){return L}e.$9h=R}),define(Re[47],Ae([1,0,16,2,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.ConfigurationTarget=e.$Di=e.$Ci=e.$Bi=void 0,e.$Bi=(0,I.$8h)("configurationService");function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof M.URI)}e.$Ci=R;function L(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof M.URI)}e.$Di=L;var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function h(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ei=h;function E(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$Fi=E;function A(s,i){const o=Object.create(null);for(const a in s)D(o,a,s[a],i);return o}e.$Gi=A;function D(s,i,o,a){const u=i.split("."),t=u.pop();let f=s;for(let n=0;n<u.length;n++){const w=u[n];let y=f[w];switch(typeof y){case"undefined":y=f[w]=Object.create(null);break;case"object":break;default:a(`Ignoring ${i} as ${u.slice(0,n+1).join(".")} is ${JSON.stringify(y)}`);return}f=y}if(typeof f=="object"&&f!==null)try{f[t]=o}catch{a(`Ignoring ${i} as ${u.join(".")} is ${JSON.stringify(f)}`)}else a(`Ignoring ${i} as ${u.join(".")} is ${JSON.stringify(f)}`)}e.$Hi=D;function l(s,i){const o=i.split(".");$(s,o)}e.$Ii=l;function $(s,i){const o=i.shift();if(i.length===0){delete s[o];return}if(Object.keys(s).indexOf(o)!==-1){const a=s[o];typeof a=="object"&&!Array.isArray(a)&&($(a,i),Object.keys(a).length===0&&delete s[o])}}function p(s,i,o){function a(f,n){let w=f;for(const y of n){if(typeof w!="object"||w===null)return;w=w[y]}return w}const u=i.split("."),t=a(s,u);return typeof t>"u"?o:t}e.$Ji=p;function r(s,i,o){Object.keys(i).forEach(a=>{a!=="__proto__"&&(a in s?S.$Lf(s[a])&&S.$Lf(i[a])?r(s[a],i[a],o):o&&(s[a]=i[a]):s[a]=i[a])})}e.$Ki=r;function c(s){return s.replace(/[\[\]]/g,"")}e.$Li=c}),define(Re[35],Ae([1,0,20,14,180,4,149,15]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.ContextKeyExprType=e.$4i=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",S.$j),h.set("isLinux",S.$k),h.set("isWindows",S.$i),h.set("isWeb",S.$o),h.set("isMacNative",S.$j&&!S.$o),h.set("isEdge",S.$H),h.set("isFirefox",S.$F),h.set("isChrome",S.$E),h.set("isSafari",S.$G);function E(x,V){if(h.get(x)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(x,V)}e.$4i=E;const A=Object.prototype.hasOwnProperty;var D;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const l={regexParsingWithErrorRecovery:!0},$=(0,L.localize)(0,null),p=(0,L.localize)(1,null),r=(0,L.localize)(2,null),c=(0,L.localize)(3,null),s=(0,L.localize)(4,null),i=(0,L.localize)(5,null),o=(0,L.localize)(6,null),a=(0,L.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=l){this.k=V,this.d=new I.$3i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const Ie=this.D(),Me=Ie.type===17?i:void 0;throw this.h.push({message:s,offset:Ie.offset,lexeme:I.$3i.getLexeme(Ie),additionalInfo:Me}),u.c}return ne}catch(ne){if(ne!==u.c)throw ne;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const ne=this.o();V.push(ne)}return V.length===1?V[0]:t.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const ne=this.s();V.push(ne)}return V.length===1?V[0]:t.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),y.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,c),ne?.negate()}case 17:return this.z(),F.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ne=this.l();return this.A(1,c),ne}case 17:{const ne=V.lexeme;if(this.z(),this.y(9)){const Me=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Me.type!==10)throw this.B("REGEX",Me);const Le=Me.lexeme,we=Le.lastIndexOf("/"),ge=we===Le.length-1?void 0:this.w(Le.substring(we+1));let K;try{K=new RegExp(Le.substring(1,we),ge)}catch{throw this.B("REGEX",Me)}return N.create(ne,K)}switch(Me.type){case 10:case 19:{const Le=[Me.lexeme];this.z();let we=this.D(),ge=0;for(let Ce=0;Ce<Me.lexeme.length;Ce++)Me.lexeme.charCodeAt(Ce)===40?ge++:Me.lexeme.charCodeAt(Ce)===41&&ge--;for(;!this.E()&&we.type!==15&&we.type!==16;){switch(we.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Ce=0;Ce<we.lexeme.length;Ce++)we.lexeme.charCodeAt(Ce)===40?ge++:Me.lexeme.charCodeAt(Ce)===41&&ge--}if(ge<0)break;Le.push(I.$3i.getLexeme(we)),this.z(),we=this.D()}const K=Le.join(""),ee=K.lastIndexOf("/"),he=ee===K.length-1?void 0:this.w(K.substring(ee+1));let fe;try{fe=new RegExp(K.substring(1,ee),he)}catch{throw this.B("REGEX",Me)}return t.regex(ne,fe)}case 18:{const Le=Me.lexeme;this.z();let we=null;if(!(0,M.$Ke)(Le)){const ge=Le.indexOf("/"),K=Le.lastIndexOf("/");if(ge!==K&&ge>=0){const ee=Le.slice(ge+1,K),he=Le[K+1]==="i"?"i":"";try{we=new RegExp(ee,he)}catch{throw this.B("REGEX",Me)}}}if(we===null)throw this.B("REGEX",Me);return N.create(ne,we)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Me=this.u();return t.notIn(ne,Me)}switch(this.D().type){case 3:{this.z();const Me=this.u();if(this.x().type===18)return t.equals(ne,Me);switch(Me){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,Me)}}case 4:{this.z();const Me=this.u();if(this.x().type===18)return t.notEquals(ne,Me);switch(Me){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,Me)}}case 5:return this.z(),U.create(ne,this.u());case 6:return this.z(),C.create(ne,this.u());case 7:return this.z(),G.create(ne,this.u());case 8:return this.z(),q.create(ne,this.u());case 13:return this.z(),t.in(ne,this.u());default:return t.has(ne)}}case 20:throw this.h.push({message:o,offset:V.offset,lexeme:"",additionalInfo:a}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,ne){if(this.C(V))return this.z();throw this.B(ne,this.D())}B(V,ne,Ie){const Me=(0,L.localize)(8,null,V,I.$3i.getLexeme(ne)),Le=ne.offset,we=I.$3i.getLexeme(ne);return this.h.push({message:Me,offset:Le,lexeme:we,additionalInfo:Ie}),u.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$5i=u;class t{static false(){return y.INSTANCE}static true(){return d.INSTANCE}static has(V){return b.create(V)}static equals(V,ne){return P.create(V,ne)}static notEquals(V,ne){return k.create(V,ne)}static regex(V,ne){return N.create(V,ne)}static in(V,ne){return g.create(V,ne)}static notIn(V,ne){return v.create(V,ne)}static not(V){return F.create(V)}static and(...V){return le.create(V,null,!0)}static or(...V){return Ee.create(V,null,!0)}static greater(V,ne){return G.create(V,ne)}static greaterEquals(V,ne){return q.create(V,ne)}static smaller(V,ne){return U.create(V,ne)}static smallerEquals(V,ne){return C.create(V,ne)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$6i=t;function f(x){const V=new u({regexParsingWithErrorRecovery:!1});return x.map(ne=>(V.parse(ne),V.lexingErrors.length>0?V.lexingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?(0,L.localize)(9,null,Ie.additionalInfo):(0,L.localize)(10,null),offset:Ie.offset,length:Ie.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?`${Ie.message}. ${Ie.additionalInfo}`:Ie.message,offset:Ie.offset,length:Ie.lexeme.length})):[]))}e.$7i=f;function n(x,V){const ne=x?x.substituteConstants():void 0,Ie=V?V.substituteConstants():void 0;return!ne&&!Ie?!0:!ne||!Ie?!1:ne.equals(Ie)}e.$8i=n;function w(x,V){return x.cmp(V)}class y{static{this.INSTANCE=new y}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return d.INSTANCE}}e.$9i=y;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return y.INSTANCE}}e.$0i=d;class b{static create(V,ne=null){const Ie=h.get(V);return typeof Ie=="boolean"?Ie?d.INSTANCE:y.INSTANCE:new b(V,ne)}constructor(V,ne){this.key=V,this.c=ne,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:ce(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=h.get(this.key);return typeof V=="boolean"?V?d.INSTANCE:y.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$$i=b;class P{static create(V,ne,Ie=null){if(typeof ne=="boolean")return ne?b.create(V,Ie):F.create(V,Ie);const Me=h.get(V);return typeof Me=="boolean"?ne===(Me?"true":"false")?d.INSTANCE:y.INSTANCE:new P(V,ne,Ie)}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=h.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?d.INSTANCE:y.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$_i=P;class g{static create(V,ne){return new g(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.f),Ie=V.getValue(this.d);return Array.isArray(ne)?ne.includes(Ie):typeof Ie=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,Ie):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$aj=g;class v{static create(V,ne){return new v(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=11,this.c=g.create(V,ne)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$bj=v;class k{static create(V,ne,Ie=null){if(typeof ne=="boolean")return ne?F.create(V,Ie):b.create(V,Ie);const Me=h.get(V);return typeof Me=="boolean"?ne===(Me?"true":"false")?y.INSTANCE:d.INSTANCE:new k(V,ne,Ie)}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=h.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?y.INSTANCE:d.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$cj=k;class F{static create(V,ne=null){const Ie=h.get(V);return typeof Ie=="boolean"?Ie?y.INSTANCE:d.INSTANCE:new F(V,ne)}constructor(V,ne){this.c=V,this.d=ne,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:ce(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=h.get(this.c);return typeof V=="boolean"?V?y.INSTANCE:d.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$dj=F;function O(x,V){if(typeof x=="string"){const ne=parseFloat(x);isNaN(ne)||(x=ne)}return typeof x=="string"||typeof x=="number"?V(x):y.INSTANCE}class G{static create(V,ne,Ie=null){return O(ne,Me=>new G(V,Me,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$ej=G;class q{static create(V,ne,Ie=null){return O(ne,Me=>new q(V,Me,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$fj=q;class U{static create(V,ne,Ie=null){return O(ne,Me=>new U(V,Me,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$gj=U;class C{static create(V,ne,Ie=null){return O(ne,Me=>new C(V,Me,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:pe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$hj=C;class N{static create(V,ne){return new N(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const ne=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return ne<Ie?-1:ne>Ie?1:0}equals(V){if(V.type===this.type){const ne=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return this.d===V.d&&ne===Ie}return!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$ij=N;class W{static create(V){return new W(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new W(this.c.map(V))}negate(){return this.c}}e.$jj=W;function se(x){let V=null;for(let ne=0,Ie=x.length;ne<Ie;ne++){const Me=x[ne].substituteConstants();if(x[ne]!==Me&&V===null){V=[];for(let Le=0;Le<ne;Le++)V[Le]=x[Le]}V!==null&&(V[ne]=Me)}return V===null?x:V}class le{static create(V,ne,Ie){return le.d(V,ne,Ie)}constructor(V,ne){this.expr=V,this.c=ne,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Me=w(this.expr[ne],V.expr[ne]);if(Me!==0)return Me}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=se(this.expr);return V===this.expr?this:le.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].evaluate(V))return!1;return!0}static d(V,ne,Ie){const Me=[];let Le=!1;for(const we of V)if(we){if(we.type===1){Le=!0;continue}if(we.type===0)return y.INSTANCE;if(we.type===6){Me.push(...we.expr);continue}Me.push(we)}if(Me.length===0&&Le)return d.INSTANCE;if(Me.length!==0){if(Me.length===1)return Me[0];Me.sort(w);for(let we=1;we<Me.length;we++)Me[we-1].equals(Me[we])&&(Me.splice(we,1),we--);if(Me.length===1)return Me[0];for(;Me.length>1;){const we=Me[Me.length-1];if(we.type!==9)break;Me.pop();const ge=Me.pop(),K=Me.length===0,ee=Ee.create(we.expr.map(he=>le.create([he,ge],null,Ie)),null,K);ee&&(Me.push(ee),Me.sort(w))}if(Me.length===1)return Me[0];if(Ie){for(let we=0;we<Me.length;we++)for(let ge=we+1;ge<Me.length;ge++)if(Me[we].negate().equals(Me[ge]))return y.INSTANCE;if(Me.length===1)return Me[0]}return new le(Me,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new le(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());this.c=Ee.create(V,this,!0)}return this.c}}e.$kj=le;class Ee{static create(V,ne,Ie){return Ee.d(V,ne,Ie)}constructor(V,ne){this.expr=V,this.c=ne,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Me=w(this.expr[ne],V.expr[ne]);if(Me!==0)return Me}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=se(this.expr);return V===this.expr?this:Ee.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(this.expr[ne].evaluate(V))return!0;return!1}static d(V,ne,Ie){let Me=[],Le=!1;if(V){for(let we=0,ge=V.length;we<ge;we++){const K=V[we];if(K){if(K.type===0){Le=!0;continue}if(K.type===1)return d.INSTANCE;if(K.type===9){Me=Me.concat(K.expr);continue}Me.push(K)}}if(Me.length===0&&Le)return y.INSTANCE;Me.sort(w)}if(Me.length!==0){if(Me.length===1)return Me[0];for(let we=1;we<Me.length;we++)Me[we-1].equals(Me[we])&&(Me.splice(we,1),we--);if(Me.length===1)return Me[0];if(Ie){for(let we=0;we<Me.length;we++)for(let ge=we+1;ge<Me.length;ge++)if(Me[we].negate().equals(Me[ge]))return d.INSTANCE;if(Me.length===1)return Me[0]}return new Ee(Me,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new Ee(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());for(;V.length>1;){const ne=V.shift(),Ie=V.shift(),Me=[];for(const Le of ie(ne))for(const we of ie(Ie))Me.push(le.create([Le,we],null,!1));V.unshift(Ee.create(Me,null,!1))}this.c=Ee.create(V,this,!0)}return this.c}}e.$lj=Ee;class De extends b{static{this.d=[]}static all(){return De.d.values()}constructor(V,ne,Ie){super(V,null),this.f=ne,typeof Ie=="object"?De.d.push({...Ie,key:V}):Ie!==!0&&De.d.push({key:V,description:Ie,type:ne!=null?typeof ne:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return P.create(this.key,V)}notEqualsTo(V){return k.create(this.key,V)}}e.$mj=De,e.$nj=(0,R.$8h)("contextKeyService");function ce(x,V){return x<V?-1:x>V?1:0}function pe(x,V,ne,Ie){return x<ne?-1:x>ne?1:V<Ie?-1:V>Ie?1:0}function oe(x,V){if(x.type===0||V.type===1)return!0;if(x.type===9)return V.type===9?$e(x.expr,V.expr):!1;if(V.type===9){for(const ne of V.expr)if(oe(x,ne))return!0;return!1}if(x.type===6){if(V.type===6)return $e(V.expr,x.expr);for(const ne of x.expr)if(oe(ne,V))return!0;return!1}return x.equals(V)}e.$oj=oe;function $e(x,V){let ne=0,Ie=0;for(;ne<x.length&&Ie<V.length;){const Me=x[ne].cmp(V[Ie]);if(Me<0)return!1;Me===0&&ne++,Ie++}return ne===x.length}function ie(x){return x.type===9?x.expr:[x]}}),define(Re[183],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=void 0,e.$ci=(0,S.$8h)("environmentService"),e.$di=(0,S.$9h)(e.$ci)}),define(Re[96],Ae([1,0,151,4]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.ExtensionGalleryErrorCode=e.$Co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0,e.$po="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$qo=new RegExp(e.$po),e.$ro="__web_extension",e.$so="skipWalkthrough",e.$to="extensionsSync",e.$uo="dependecyOrPackExtensionInstall";function I(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$vo=I;function R(o){switch(o){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$wo=R;function L(o,a){switch(o){case 3:return a==="x64"?"win32-x64":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$xo=L;function m(o,a){return a==="web"&&!o.includes("web")}e.$yo=m;function h(o,a,u){return m(a,u)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===u}e.$zo=h;function E(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$Ao=E;var A;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var D;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var l;(function(o){o.Install="install",o.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var $;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$Bo=(0,M.$8h)("extensionGalleryService");var p;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.DownloadSignature="DownloadSignature",o.UpdateMetadata="UpdateMetadata",o.Extract="Extract",o.Scanning="Scanning",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.NotAllowed="NotAllowed",o.Gallery="Gallery",o.Unknown="Unknown",o.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var r;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class c extends Error{constructor(a,u){super(a),this.code=u,this.name=u}}e.$Co=c;var s;(function(o){o.Timeout="Timeout",o.Cancelled="Cancelled",o.Failed="Failed"})(s||(e.ExtensionGalleryErrorCode=s={}));class i extends Error{constructor(a,u){super(a),this.code=u,this.name=u}}e.$Do=i,e.$Eo=(0,M.$8h)("extensionManagementService"),e.$Fo="extensionsIdentifiers/disabled",e.$Go="extensionsIdentifiers/enabled",e.$Ho=(0,M.$8h)("IGlobalExtensionEnablementService"),e.$Io=(0,M.$8h)("IExtensionTipsService"),e.$Jo=(0,S.localize2)(0,"Extensions"),e.$Ko=(0,S.localize2)(1,"Preferences")}),define(Re[42],Ae([1,0,51,19,14,16,2,153,4,20,12,39]),function(me,e,S,M,I,R,L,m,h,E,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.FileKind=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.FileOperationResult=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.FileChangeType=e.$Kk=e.FileOperation=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileSystemProviderErrorCode=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileSystemProviderCapabilities=e.$uk=e.FilePermission=e.FileType=e.$tk=e.$sk=void 0,e.$sk=(0,h.$8h)("fileService");function l(oe){return oe.create===!0}e.$tk=l;var $;(function(oe){oe[oe.Unknown=0]="Unknown",oe[oe.File=1]="File",oe[oe.Directory=2]="Directory",oe[oe.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var p;(function(oe){oe[oe.Readonly=1]="Readonly",oe[oe.Locked=2]="Locked"})(p||(e.FilePermission=p={}));function r(oe){const $e=oe;return!!$e&&typeof $e.onDidChange=="function"}e.$uk=r;var c;(function(oe){oe[oe.None=0]="None",oe[oe.FileReadWrite=2]="FileReadWrite",oe[oe.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",oe[oe.FileReadStream=16]="FileReadStream",oe[oe.FileFolderCopy=8]="FileFolderCopy",oe[oe.PathCaseSensitive=1024]="PathCaseSensitive",oe[oe.Readonly=2048]="Readonly",oe[oe.Trash=4096]="Trash",oe[oe.FileWriteUnlock=8192]="FileWriteUnlock",oe[oe.FileAtomicRead=16384]="FileAtomicRead",oe[oe.FileAtomicWrite=32768]="FileAtomicWrite",oe[oe.FileAtomicDelete=65536]="FileAtomicDelete",oe[oe.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function s(oe){return!!(oe.capabilities&2)}e.$vk=s;function i(oe){return!!(oe.capabilities&8)}e.$wk=i;function o(oe){return!!(oe.capabilities&131072)}e.$xk=o;function a(oe){return!!(oe.capabilities&4)}e.$yk=a;function u(oe){return!!(oe.capabilities&16)}e.$zk=u;function t(oe){return s(oe)?!!(oe.capabilities&16384):!1}e.$Ak=t;function f(oe){return s(oe)?!!(oe.capabilities&32768):!1}e.$Bk=f;function n(oe){return!!(oe.capabilities&65536)}e.$Ck=n;function w(oe){return!!(oe.capabilities&2048)}e.$Dk=w;var y;(function(oe){oe.FileExists="EntryExists",oe.FileNotFound="EntryNotFound",oe.FileNotADirectory="EntryNotADirectory",oe.FileIsADirectory="EntryIsADirectory",oe.FileExceedsStorageQuota="EntryExceedsStorageQuota",oe.FileTooLarge="EntryTooLarge",oe.FileWriteLocked="EntryWriteLocked",oe.NoPermissions="NoPermissions",oe.Unavailable="Unavailable",oe.Unknown="Unknown"})(y||(e.FileSystemProviderErrorCode=y={}));class d extends Error{static create($e,ie){const x=new d($e.toString(),ie);return g(x,ie),x}constructor($e,ie){super($e),this.code=ie}}e.$Ek=d;function b(oe,$e){return d.create(oe,$e)}e.$Fk=b;function P(oe){return oe||b((0,m.localize)(0,null),y.Unknown)}e.$Gk=P;function g(oe,$e){return oe.name=$e?`${$e} (FileSystemError)`:"FileSystemError",oe}e.$Hk=g;function v(oe){if(!oe)return y.Unknown;if(oe instanceof d)return oe.code;const $e=/^(.+) \(FileSystemError\)$/.exec(oe.name);if(!$e)return y.Unknown;switch($e[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}e.$Ik=v;function k(oe){if(oe instanceof C)return oe.fileOperationResult;switch(v(oe)){case y.FileNotFound:return 1;case y.FileIsADirectory:return 0;case y.FileNotADirectory:return 9;case y.FileWriteLocked:return 5;case y.NoPermissions:return 6;case y.FileExists:return 4;case y.FileTooLarge:return 7;default:return 10}}e.$Jk=k;var F;(function(oe){oe[oe.CREATE=0]="CREATE",oe[oe.DELETE=1]="DELETE",oe[oe.MOVE=2]="MOVE",oe[oe.COPY=3]="COPY",oe[oe.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class O{constructor($e,ie,x){this.resource=$e,this.operation=ie,this.target=x}isOperation($e){return this.operation===$e}}e.$Kk=O;var G;(function(oe){oe[oe.UPDATED=0]="UPDATED",oe[oe.ADDED=1]="ADDED",oe[oe.DELETED=2]="DELETED"})(G||(e.FileChangeType=G={}));class q{static{this.a=null}constructor($e,ie){this.c=ie,this.b=void 0,this.d=new D.$V(()=>{const x=S.$bi.forUris(()=>this.c);return x.fill(this.rawAdded.map(V=>[V,!0])),x}),this.f=new D.$V(()=>{const x=S.$bi.forUris(()=>this.c);return x.fill(this.rawUpdated.map(V=>[V,!0])),x}),this.g=new D.$V(()=>{const x=S.$bi.forUris(()=>this.c);return x.fill(this.rawDeleted.map(V=>[V,!0])),x}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const x of $e){switch(x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}this.b!==q.a&&(typeof x.cId=="number"?this.b===void 0?this.b=x.cId:this.b!==x.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains($e,...ie){return this.h($e,{includeChildren:!1},...ie)}affects($e,...ie){return this.h($e,{includeChildren:!0},...ie)}h($e,ie,...x){if(!$e)return!1;const V=x.length>0;return!!((!V||x.includes(1))&&(this.d.value.get($e)||ie.includeChildren&&this.d.value.findSuperstr($e))||(!V||x.includes(0))&&(this.f.value.get($e)||ie.includeChildren&&this.f.value.findSuperstr($e))||(!V||x.includes(2))&&(this.g.value.findSubstr($e)||ie.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$Lk=q;function U(oe,$e,ie){return!oe||!$e||oe===$e||$e.length>oe.length?!1:($e.charAt($e.length-1)!==M.sep&&($e+=M.sep),ie?(0,I.$bf)(oe,$e):oe.indexOf($e)===0)}e.$Mk=U;class C extends Error{constructor($e,ie,x){super($e),this.fileOperationResult=ie,this.options=x}}e.$Nk=C;class N extends C{constructor($e,ie,x,V){super($e,ie,V),this.fileOperationResult=ie,this.size=x}}e.$Ok=N;class W extends C{constructor($e,ie,x){super($e,2,x),this.stat=ie}}e.$Pk=W;var se;(function(oe){oe[oe.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",oe[oe.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",oe[oe.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",oe[oe.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",oe[oe.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",oe[oe.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",oe[oe.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",oe[oe.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",oe[oe.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",oe[oe.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",oe[oe.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(se||(e.FileOperationResult=se={})),e.$Qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Sk="files.associations",e.$Tk="files.exclude",e.$Uk="files.readonlyInclude",e.$Vk="files.readonlyExclude",e.$Wk="files.readonlyFromPermissions";var le;(function(oe){oe[oe.FILE=0]="FILE",oe[oe.FOLDER=1]="FOLDER",oe[oe.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(e.FileKind=le={})),e.$Xk="";function Ee(oe){if(!(typeof oe.size!="number"||typeof oe.mtime!="number"))return oe.mtime.toString(29)+oe.size.toString(31)}e.$Yk=Ee;async function De(oe,$e){if(!$e.hasProvider(L.URI.from({scheme:oe.scheme})))return new Promise(ie=>{const x=$e.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===oe.scheme&&V.added&&(x.dispose(),ie())})})}e.$Zk=De;class ce{static{this.KB=1024}static{this.MB=ce.KB*ce.KB}static{this.GB=ce.MB*ce.KB}static{this.TB=ce.GB*ce.KB}static formatSize($e){return(0,R.$Nf)($e)||($e=0),$e<ce.KB?(0,m.localize)(1,null,$e.toFixed(0)):$e<ce.MB?(0,m.localize)(2,null,($e/ce.KB).toFixed(2)):$e<ce.GB?(0,m.localize)(3,null,($e/ce.MB).toFixed(2)):$e<ce.TB?(0,m.localize)(4,null,($e/ce.GB).toFixed(2)):(0,m.localize)(5,null,($e/ce.TB).toFixed(2))}}e.$1k=ce;function pe(oe){const $e=typeof oe=="string"||oe?.scheme===A.Schemas.vscodeRemote;return typeof oe!="string"&&oe?.scheme===A.Schemas.file?1024*ce.MB:$e?10*ce.MB:E.$o?50*ce.MB:1024*ce.MB}e.$2k=pe}),define(Re[71],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=void 0;class S{constructor(...I){this.a=new Map;for(const[R,L]of I)this.set(R,L)}set(I,R){const L=this.a.get(I);return this.a.set(I,R),L}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$6h=S}),define(Re[184],Ae([1,0,11,15,6,70,182,4,71,185]),function(me,e,S,M,I,R,L,m,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;const A=!1;class D extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class l{constructor(c=new h.$6h,s=!1,i,o=A){this.f=c,this.g=s,this.h=i,this.i=o,this.o=new Set,this.f.set(m.$7h,this),this._globalGraph=o?i?._globalGraph??new L.$Fq(a=>a):void 0}createChild(c){return new l(c,this.g,this,this.i)}invokeFunction(c,...s){const i=p.traceInvocation(this.i,c);let o=!1;try{return c({get:u=>{if(o)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(u,i);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...s)}finally{o=!0,i.stop()}}createInstance(c,...s){let i,o;return c instanceof R.$5h?(i=p.traceCreation(this.i,c.ctor),o=this.j(c.ctor,c.staticArguments.concat(s),i)):(i=p.traceCreation(this.i,c),o=this.j(c,s,i)),i.stop(),o}j(c,s=[],i){const o=m._util.getServiceDependencies(c).sort((t,f)=>t.index-f.index),a=[];for(const t of o){const f=this.m(t.id,i);f||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),a.push(f)}const u=o.length>0?o[0].index:s.length;if(s.length!==u){console.trace(`[createInstance] First service dependency of ${c.name} at position ${u+1} conflicts with ${s.length} static arguments`);const t=u-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,u)}return Reflect.construct(c,s.concat(a))}k(c,s){if(this.f.get(c)instanceof R.$5h)this.f.set(c,s);else if(this.h)this.h.k(c,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const s=this.f.get(c);return!s&&this.h?this.h.l(c):s}m(c,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const i=this.l(c);return i instanceof R.$5h?this.q(c,i,s.branch(c,!0)):(s.branch(c,!1),i)}q(c,s,i){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,s,i)}finally{this.o.delete(c)}}r(c,s,i){const o=new L.$Fq(t=>t.id.toString());let a=0;const u=[{id:c,desc:s,_trace:i}];for(;u.length;){const t=u.pop();if(o.lookupOrInsertNode(t),a++>1e3)throw new D(o);for(const f of m._util.getServiceDependencies(t.desc.ctor)){const n=this.l(f.id);if(n||this.u(`[createInstance] ${c} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),n instanceof R.$5h){const w={id:f.id,desc:n,_trace:t._trace.branch(f.id,!0)};o.insertEdge(t,w),u.push(w)}}}for(;;){const t=o.roots();if(t.length===0){if(!o.isEmpty())throw new D(o);break}for(const{data:f}of t){if(this.l(f.id)instanceof R.$5h){const w=this.s(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this.k(f.id,w)}o.removeNode(f)}}return this.l(c)}s(c,s,i=[],o,a){if(this.f.get(c)instanceof R.$5h)return this.t(c,s,i,o,a);if(this.h)return this.h.s(c,s,i,o,a);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(c,s,i=[],o,a){if(o){const u=new l(void 0,this.g,this,this.i);u.c=String(c);const t=new Map,f=new S.$oh(()=>{const n=u.j(s,i,a);for(const[w,y]of t){const d=n[w];if(typeof d=="function")for(const b of y)b.disposable=d.apply(n,b.listener)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,w){if(!f.isInitialized&&typeof w=="string"&&(w.startsWith("onDid")||w.startsWith("onWill"))){let b=t.get(w);return b||(b=new E.$4c,t.set(w,b)),(g,v,k)=>{if(f.isInitialized)return f.value[w](g,v,k);{const F={listener:[g,v,k],disposable:void 0},O=b.push(F);return(0,I.$Rc)(()=>{O(),F.disposable?.dispose()})}}}if(w in n)return n[w];const y=f.value;let d=y[w];return typeof d!="function"||(d=d.bind(y),n[w]=d),d},set(n,w,y){return f.value[w]=y,!0},getPrototypeOf(n){return s.prototype}})}else return this.j(s,i,a)}u(c,s){if(s&&console.warn(c),this.g)throw new Error(c)}}e.$Gq=l;var $;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})($||($={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(c,s){return c?new p(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(c,s){return c?new p(1,s.name):p.c}static{this.f=0}constructor(c,s){this.type=c,this.name=s,this.g=Date.now(),this.h=[]}branch(c,s){const i=new p(3,c.toString());return this.h.push([c,s,i]),i}stop(){const c=Date.now()-this.g;p.f+=c;let s=!1;function i(a,u){const t=[],f=new Array(a+1).join("	");for(const[n,w,y]of u.h)if(w&&y){s=!0,t.push(`${f}CREATES -> ${n}`);const d=i(a+1,y);d&&t.push(d)}else t.push(`${f}uses -> ${n}`);return t.join(`
`)}const o=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(c>2||s)&&p.all.add(o.join(`
`))}}e.$Hq=p}),define(Re[13],Ae([1,0,41,5,97,6,28,20,25,16,2,35,4]),function(me,e,S,M,I,R,L,m,h,E,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.log=e.$sj=e.LogLevel=e.$rj=e.$qj=e.$pj=void 0,e.$pj=(0,l.$8h)("logService"),e.$qj=(0,l.$8h)("loggerService");function $(){return new Date().toISOString()}function p(g){return(0,E.$Nf)(g)}e.$rj=p;var r;(function(g){g[g.Off=0]="Off",g[g.Trace=1]="Trace",g[g.Debug=2]="Debug",g[g.Info=3]="Info",g[g.Warning=4]="Warning",g[g.Error=5]="Error"})(r||(e.LogLevel=r={})),e.$sj=r.Info;function c(g,v,k){switch(v){case r.Trace:g.trace(k);break;case r.Debug:g.debug(k);break;case r.Info:g.info(k);break;case r.Warning:g.warn(k);break;case r.Error:g.error(k);break;case r.Off:break;default:throw new Error(`Invalid log level ${v}`)}}e.log=c;function s(g,v=!1){let k="";for(let F=0;F<g.length;F++){let O=g[F];if(O instanceof Error&&(O=(0,S.$Si)(O,v)),typeof O=="object")try{O=JSON.stringify(O)}catch{}k+=(F>0?" ":"")+O}return k}class i extends R.$Tc{constructor(){super(...arguments),this.b=e.$sj,this.c=this.B(new M.$Wd),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==r.Off&&this.b<=v}}e.$uj=i;class o extends i{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...k){this.f(r.Trace)&&this.g(r.Trace,s([v,...k],!0))}debug(v,...k){this.f(r.Debug)&&this.g(r.Debug,s([v,...k]))}info(v,...k){this.f(r.Info)&&this.g(r.Info,s([v,...k]))}warn(v,...k){this.f(r.Warning)&&this.g(r.Warning,s([v,...k]))}error(v,...k){if(this.f(r.Error))if(v instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=v.stack,this.g(r.Error,s(F))}else this.g(r.Error,s([v,...k]))}flush(){}}e.$vj=o;class a extends i{constructor(v=e.$sj){super(),this.setLevel(v),this.g=!m.$i}trace(v,...k){this.f(r.Trace)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,v,...k):console.log(`[main ${$()}]`,v,...k))}debug(v,...k){this.f(r.Debug)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,v,...k):console.log(`[main ${$()}]`,v,...k))}info(v,...k){this.f(r.Info)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,v,...k):console.log(`[main ${$()}]`,v,...k))}warn(v,...k){this.f(r.Warning)&&(this.g?console.warn(`\x1B[93m[main ${$()}]\x1B[0m`,v,...k):console.warn(`[main ${$()}]`,v,...k))}error(v,...k){this.f(r.Error)&&(this.g?console.error(`\x1B[91m[main ${$()}]\x1B[0m`,v,...k):console.error(`[main ${$()}]`,v,...k))}flush(){}}e.$wj=a;class u extends i{constructor(v=e.$sj,k=!0){super(),this.g=k,this.setLevel(v)}trace(v,...k){this.f(r.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...k):console.log(v,...k))}debug(v,...k){this.f(r.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...k):console.log(v,...k))}info(v,...k){this.f(r.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...k):console.log(v,...k))}warn(v,...k){this.f(r.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...k):console.log(v,...k))}error(v,...k){this.f(r.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...k):console.error(v,...k))}flush(){}}e.$xj=u;class t extends i{constructor(v,k=e.$sj){super(),this.g=v,this.setLevel(k)}trace(v,...k){this.f(r.Trace)&&this.g.log(r.Trace,[this.h(v),...k])}debug(v,...k){this.f(r.Debug)&&this.g.log(r.Debug,[this.h(v),...k])}info(v,...k){this.f(r.Info)&&this.g.log(r.Info,[this.h(v),...k])}warn(v,...k){this.f(r.Warning)&&this.g.log(r.Warning,[this.h(v),...k])}error(v,...k){this.f(r.Error)&&this.g.log(r.Error,[this.h(v),...k])}h(v){return typeof v=="string"?v:(0,S.$Si)(v,this.f(r.Trace))}flush(){}}e.$yj=t;class f extends i{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const k of this.g)k.setLevel(v);super.setLevel(v)}trace(v,...k){for(const F of this.g)F.trace(v,...k)}debug(v,...k){for(const F of this.g)F.debug(v,...k)}info(v,...k){for(const F of this.g)F.info(v,...k)}warn(v,...k){for(const F of this.g)F.warn(v,...k)}error(v,...k){for(const F of this.g)F.error(v,...k)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$zj=f;class n extends R.$Tc{constructor(v,k,F){if(super(),this.h=v,this.j=k,this.b=new L.$Ac,this.c=this.B(new M.$Wd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Wd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Wd),this.onDidChangeVisibility=this.g.event,F)for(const O of F)this.b.set(O.resource,{logger:void 0,info:O})}m(v){return(0,E.$Jf)(v)?[...this.b.values()].find(k=>k.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,k){const F=this.n(v),O=(0,E.$Jf)(v)?v:k?.id??(0,I.$Vi)(F.toString()).toString(16);let G=this.b.get(F)?.logger;const q=k?.logLevel==="always"?r.Trace:k?.logLevel;G||(G=this.s(F,q??this.getLogLevel(F)??this.h,{...k,id:O}));const U={logger:G,info:{resource:F,id:O,logLevel:q,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(U.info),this.b.set(F,U),G}n(v){return(0,E.$Jf)(v)?(0,h.$Ig)(this.j,`${v}.log`):v}setLogLevel(v,k){if(A.URI.isUri(v)){const F=v,O=k,G=this.b.get(F);G&&O!==G.info.logLevel&&(G.info.logLevel=O===this.h?void 0:O,G.logger?.setLevel(O),this.b.set(G.info.resource,G),this.f.fire([F,O]))}else{this.h=v;for(const[F,O]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,k){const F=this.m(v);F&&k!==!F.info.hidden&&(F.info.hidden=!k,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,k]))}getLogLevel(v){let k;return v&&(k=this.b.get(v)?.info.logLevel),k??this.h}registerLogger(v){const k=this.b.get(v.resource);k?k.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const k=this.b.get(v);k&&(k.logger&&k.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Aj=n;class w{constructor(){this.onDidChangeLogLevel=new M.$Wd().event}setLevel(v){}getLevel(){return r.Info}trace(v,...k){}debug(v,...k){}info(v,...k){}warn(v,...k){}error(v,...k){}critical(v,...k){}dispose(){}flush(){}}e.$Bj=w;class y extends w{}e.$Cj=y;function d(g){if(g.verbose)return r.Trace;if(typeof g.logLevel=="string"){const v=P(g.logLevel.toLowerCase());if(v!==void 0)return v}return e.$sj}e.$Dj=d;function b(g){switch(g){case r.Trace:return"trace";case r.Debug:return"debug";case r.Info:return"info";case r.Warning:return"warn";case r.Error:return"error";case r.Off:return"off"}}e.$Ej=b;function P(g){switch(g){case"trace":return r.Trace;case"debug":return r.Debug;case"info":return r.Info;case"warn":return r.Warning;case"error":return r.Error;case"critical":return r.Error;case"off":return r.Off}}e.$Fj=P,e.$Gj=new D.$mj("logLevel",b(r.Info))}),define(Re[186],Ae([1,0,6,13]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SO=void 0;class I extends S.$Tc{constructor(L,m=[]){super(),this.a=new M.$zj([L,...m]),this.B(L.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...m){this.a.trace(L,...m)}debug(L,...m){this.a.debug(L,...m)}info(L,...m){this.a.info(L,...m)}warn(L,...m){this.a.warn(L,...m)}error(L,...m){this.a.error(L,...m)}flush(){this.a.flush()}}e.$SO=I}),define(Re[98],Ae([1,0,32,154,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(h){h[h.Unnecessary=1]="Unnecessary",h[h.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var L;(function(h){h[h.Hint=1]="Hint",h[h.Info=2]="Info",h[h.Warning=4]="Warning",h[h.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(h){function E(p,r){return r-p}h.compare=E;const A=Object.create(null);A[h.Error]=(0,M.localize)(0,null),A[h.Warning]=(0,M.localize)(1,null),A[h.Info]=(0,M.localize)(2,null);function D(p){return A[p]||""}h.toString=D;function l(p){switch(p){case S.default.Error:return h.Error;case S.default.Warning:return h.Warning;case S.default.Info:return h.Info;case S.default.Ignore:return h.Hint}}h.fromSeverity=l;function $(p){switch(p){case h.Error:return S.default.Error;case h.Warning:return S.default.Warning;case h.Info:return S.default.Info;case h.Hint:return S.default.Ignore}}h.toSeverity=$}(L||(e.MarkerSeverity=L={}));var m;(function(h){const E="";function A(l){return D(l,!0)}h.makeKey=A;function D(l,$){const p=[E];return l.source?p.push(l.source.replace("\xA6","\\\xA6")):p.push(E),l.code?typeof l.code=="string"?p.push(l.code.replace("\xA6","\\\xA6")):p.push(l.code.value.replace("\xA6","\\\xA6")):p.push(E),l.severity!==void 0&&l.severity!==null?p.push(L.toString(l.severity)):p.push(E),l.message&&$?p.push(l.message.replace("\xA6","\\\xA6")):p.push(E),l.startLineNumber!==void 0&&l.startLineNumber!==null?p.push(l.startLineNumber.toString()):p.push(E),l.startColumn!==void 0&&l.startColumn!==null?p.push(l.startColumn.toString()):p.push(E),l.endLineNumber!==void 0&&l.endLineNumber!==null?p.push(l.endLineNumber.toString()):p.push(E),l.endColumn!==void 0&&l.endColumn!==null?p.push(l.endColumn.toString()):p.push(E),p.push(E),p.join("\xA6")}h.makeKeyOptionalMessage=D})(m||(e.IMarkerData=m={})),e.$Ct=(0,I.$8h)("markerService")}),define(Re[187],Ae([1,0,5,32,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.NotificationsFilter=e.$sv=e.NeverShowAgainScope=e.NotificationPriority=e.$rv=e.Severity=void 0,e.Severity=M.default,e.$rv=(0,I.$8h)("notificationService");var R;(function(D){D[D.DEFAULT=0]="DEFAULT",D[D.SILENT=1]="SILENT",D[D.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var L;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));function m(D){if(D){const l=D;return typeof l.id=="string"&&typeof l.label=="string"}return!1}e.$sv=m;var h;(function(D){D[D.OFF=0]="OFF",D[D.ERROR=1]="ERROR"})(h||(e.NotificationsFilter=h={}));class E{constructor(){this.progress=new A,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$tv=E;class A{infinite(){}done(){}total(l){}worked(l){}}e.$uv=A}),define(Re[188],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=void 0,e.$Hj=(0,S.$8h)("productService"),e.$Ij="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(me,e,S,M){var I=arguments.length,R=I<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,S):M,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(me,e,S,M);else for(var m=me.length-1;m>=0;m--)(L=me[m])&&(R=(I<3?L(R):I>3?L(e,S,R):L(e,S))||R);return I>3&&R&&Object.defineProperty(e,S,R),R},Ve=this&&this.__param||function(me,e){return function(S,M){e(S,M,me)}};define(Re[99],Ae([1,0,11,21,6,4]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.ProgressLocation=e.$vv=void 0,e.$vv=(0,R.$8h)("progressService");var L;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$wv=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$xv=m;class h{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const $=this.d;this.d=()=>{$?.(),l()}}):Promise.resolve()}}e.$yv=h;let E=class extends I.$Tc{constructor(l,$){super(),this.a=new S.$sh,$.withProgress(l,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,I.$Rc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$zv=E,e.$zv=E=Ke([Ve(1,e.$vv)],E);class A extends I.$Tc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new I.$Sc)}start(l){this.stop();const $=++this.a,p=new M.$7d;return this.f=setTimeout(()=>{$===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,I.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Rc)(()=>p.cancel())),this.b.add((0,I.$Rc)(()=>this.c?this.c.done():void 0)),{id:$,token:p.token,stop:()=>this.h($),isCurrent:()=>this.a===$}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$Av=A,e.$Bv=(0,R.$8h)("editorProgressService")}),define(Re[30],Ae([1,0,54,16]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0;class I{constructor(){this.a=new Map}add(L,m){S.ok(M.$Jf(L)),S.ok(M.$Lf(m)),S.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,m)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$Kn=new I}),define(Re[72],Ae([1,0,5,30]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=void 0,e.$Ln={JSONContribution:"base.contributions.json"};function I(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class R{constructor(){this.b=new S.$Wd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,E){this.a[I(h)]=E,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const L=new R;M.$Kn.add(e.$Ln.JSONContribution,L)}),define(Re[55],Ae([1,0,18,5,16,148,47,72,30]),function(me,e,S,M,I,R,L,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.ConfigurationScope=e.$Pn=e.EditPresentationTypes=void 0;var E;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$Pn={Configuration:"base.contributions.configuration"};var A;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn={properties:{},patternProperties:{}},e.$Un={properties:{},patternProperties:{}},e.$Vn={properties:{},patternProperties:{}},e.$Wn="vscode://schemas/settings/resourceLanguage",e.$Xn="vscode://schemas/settings/configurationDefaults";const D=h.$Kn.as(m.$Ln.JSONContribution);class l{constructor(){this.h=new Set,this.i=new M.$Wd,this.onDidSchemaChange=this.i.event,this.j=new M.$Wd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$Wn,this.g),this.v()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const n=new Set;this.n(t,f,n),D.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const f=new Set;this.o(t,f),D.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:f})}updateConfigurations({add:t,remove:f}){const n=new Set;this.o(f,n),this.n(t,!1,n),D.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const f=new Set;this.k(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}k(t,f){const n=[];for(const{overrides:w,source:y}of t)for(const d in w)if(f.add(d),e.$Zn.test(d)){const b=this.a.get(d),P=b?.valuesSources??new Map;if(y)for(const F of Object.keys(w[d]))P.set(F,y);const g={...b?.value||{},...w[d]};this.a.set(d,{source:y,value:g,valuesSources:P});const v=(0,L.$Li)(d),k={type:"object",default:g,description:R.localize(1,null,v),$ref:e.$Wn,defaultDefaultValue:g,source:I.$Jf(y)?void 0:y,defaultValueSource:y};n.push(...r(d)),this.d[d]=k,this.b.properties[d]=k}else{this.a.set(d,{value:w[d],source:y});const b=this.d[d];b&&(this.w(d,b),this.r(d,b))}this.m(n)}deregisterDefaultConfigurations(t){const f=new Set;this.l(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}l(t,f){for(const{overrides:n,source:w}of t)for(const y in n){const d=this.a.get(y),b=I.$Jf(w)?w:w?.id,P=I.$Jf(d?.source)?d?.source:d?.source?.id;if(b===P)if(f.add(y),this.a.delete(y),e.$Zn.test(y))delete this.d[y],delete this.b.properties[y];else{const g=this.d[y];g&&(this.w(y,g),this.r(y,g))}}this.u()}deltaConfiguration(t){let f=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),f=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),f=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const f of t)this.h.add(f);this.u()}n(t,f,n){t.forEach(w=>{this.p(w,f,w.extensionInfo,w.restrictedProperties,void 0,n),this.c.push(w),this.q(w)})}o(t,f){const n=w=>{if(w.properties)for(const y in w.properties){f.add(y);const d=this.d[y];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[y],this.s(y,w.properties[y])}w.allOf?.forEach(y=>n(y))};for(const w of t){n(w);const y=this.c.indexOf(w);y!==-1&&this.c.splice(y,1)}}p(t,f=!0,n,w,y=3,d){y=I.$Sf(t.scope)?y:t.scope;const b=t.properties;if(b)for(const g in b){const v=b[g];if(f&&o(g,v)){delete b[g];continue}if(v.source=n,v.defaultDefaultValue=b[g].default,this.w(g,v),e.$Zn.test(g)?v.scope=void 0:(v.scope=I.$Sf(v.scope)?y:v.scope,v.restricted=I.$Sf(v.restricted)?!!w?.includes(g):v.restricted),b[g].hasOwnProperty("included")&&!b[g].included){this.f[g]=b[g],delete b[g];continue}else this.d[g]=b[g],b[g].policy?.name&&this.e.set(b[g].policy.name,g);!b[g].deprecationMessage&&b[g].markdownDeprecationMessage&&(b[g].deprecationMessage=b[g].markdownDeprecationMessage),d.add(g)}const P=t.allOf;if(P)for(const g of P)this.p(g,f,n,w,y,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const f=n=>{const w=n.properties;if(w)for(const d in w)this.r(d,w[d]);n.allOf?.forEach(f)};f(t)}r(t,f){switch(e.$Qn.properties[t]=f,f.scope){case 1:e.$Rn.properties[t]=f;break;case 2:e.$Sn.properties[t]=f;break;case 6:e.$Tn.properties[t]=f;break;case 3:e.$Un.properties[t]=f;break;case 4:e.$Vn.properties[t]=f;break;case 5:e.$Vn.properties[t]=f,this.g.properties[t]=f;break}}s(t,f){switch(delete e.$Qn.properties[t],f.scope){case 1:delete e.$Rn.properties[t];break;case 2:delete e.$Sn.properties[t];break;case 6:delete e.$Tn.properties[t];break;case 3:delete e.$Un.properties[t];break;case 4:case 5:delete e.$Vn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const f=`[${t}]`,n={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$Wn};this.w(f,n),e.$Qn.properties[f]=n,e.$Rn.properties[f]=n,e.$Sn.properties[f]=n,e.$Tn.properties[f]=n,e.$Un.properties[f]=n,e.$Vn.properties[f]=n}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$Wn};e.$Qn.patternProperties[e.$Yn]=t,e.$Rn.patternProperties[e.$Yn]=t,e.$Sn.patternProperties[e.$Yn]=t,e.$Tn.patternProperties[e.$Yn]=t,e.$Un.patternProperties[e.$Yn]=t,e.$Vn.patternProperties[e.$Yn]=t,this.i.fire()}w(t,f){const n=this.a.get(t);let w=n?.value,y=n?.source;I.$Qf(w)&&(w=f.defaultDefaultValue,y=void 0),I.$Qf(w)&&(w=s(f.type)),f.default=w,f.defaultValueSource=y}}const $="\\[([^\\]]+)\\]",p=new RegExp($,"g");e.$Yn=`^(${$})+$`,e.$Zn=new RegExp(e.$Yn);function r(u){const t=[];if(e.$Zn.test(u)){let f=p.exec(u);for(;f?.length;){const n=f[1].trim();n&&t.push(n),f=p.exec(u)}}return(0,S.$Mb)(t)}e.$1n=r;function c(u){return u.reduce((t,f)=>`${t}[${f}]`,"")}e.$2n=c;function s(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$3n=s;const i=new l;h.$Kn.add(e.$Pn.Configuration,i);function o(u,t){return u.trim()?e.$Zn.test(u)?R.localize(7,null,u):i.getConfigurationProperties()[u]!==void 0?R.localize(8,null,u):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,u,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.$4n=o;function a(){const u=[],t=i.getConfigurationProperties();for(const f of Object.keys(t))u.push([f,t[f].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.$5n=a}),define(Re[189],Ae([1,0,18,5,119,6,28,26,16,2,47,55,30]),function(me,e,S,M,I,R,L,m,h,E,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=void 0;function $(f){return Object.isFrozen(f)?f:m.$zn(f)}class p{constructor(n={},w=[],y=[],d){this.b=n,this.c=w,this.d=y,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(w=>{if(w instanceof p)return w;const y=new r("");return y.parseRaw(w),y.configurationModel});this.f=n.reduce((w,y)=>y===w?y:w.merge(y),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,A.$Ji)(this.contents,n):this.contents}inspect(n,w){const y=this;return{get value(){return $(y.rawConfiguration.getValue(n))},get override(){return w?$(y.rawConfiguration.getOverrideValue(n,w)):void 0},get merged(){return $(w?y.rawConfiguration.override(w).getValue(n):y.rawConfiguration.getValue(n))},get overrides(){const d=[];for(const{contents:b,identifiers:P,keys:g}of y.rawConfiguration.overrides){const v=new p(b,g).getValue(n);v!==void 0&&d.push({identifiers:P,value:v})}return d.length?$(d):void 0}}}getOverrideValue(n,w){const y=this.i(w);return y?n?(0,A.$Ji)(y,n):y:void 0}getKeysForOverrideIdentifier(n){const w=[];for(const y of this.overrides)y.identifiers.includes(n)&&w.push(...y.keys);return S.$Mb(w)}getAllOverrideIdentifiers(){const n=[];for(const w of this.overrides)n.push(...w.identifiers);return S.$Mb(n)}override(n){let w=this.a.get(n);return w||(w=this.g(n),this.a.set(n,w)),w}merge(...n){const w=m.$yn(this.contents),y=m.$yn(this.overrides),d=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const P of n)if(b.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(w,P.contents);for(const g of P.overrides){const[v]=y.filter(k=>S.$ub(k.identifiers,g.identifiers));v?(this.h(v.contents,g.contents),v.keys.push(...g.keys),v.keys=S.$Mb(v.keys)):y.push(m.$yn(g))}for(const g of P.keys)d.indexOf(g)===-1&&d.push(g)}return new p(w,d,y,b.every(P=>P instanceof p)?void 0:b)}g(n){const w=this.i(n);if(!w||typeof w!="object"||!Object.keys(w).length)return this;const y={};for(const d of S.$Mb([...Object.keys(this.contents),...Object.keys(w)])){let b=this.contents[d];const P=w[d];P&&(typeof b=="object"&&typeof P=="object"?(b=m.$yn(b),this.h(b,P)):b=P),y[d]=b}return new p(y,this.keys,this.overrides)}h(n,w){for(const y of Object.keys(w)){if(y in n&&h.$Lf(n[y])&&h.$Lf(w[y])){this.h(n[y],w[y]);continue}n[y]=m.$yn(w[y])}}i(n){let w=null,y=null;const d=b=>{b&&(y?this.h(y,b):y=m.$yn(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===n?w=b.contents:b.identifiers.includes(n)&&d(b.contents);return d(w),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,w){this.j(n,w,!0)}setValue(n,w){this.j(n,w,!1)}removeValue(n){const w=this.keys.indexOf(n);w!==-1&&(this.keys.splice(w,1),(0,A.$Ii)(this.contents,n),D.$Zn.test(n)&&this.overrides.splice(this.overrides.findIndex(y=>S.$ub(y.identifiers,(0,D.$1n)(n))),1))}j(n,w,y){(0,A.$Hi)(this.contents,n,w,d=>console.error(d)),y=y||this.keys.indexOf(n)===-1,y&&this.keys.push(n),D.$Zn.test(n)&&this.overrides.push({identifiers:(0,D.$1n)(n),keys:Object.keys(this.contents[n]),contents:(0,A.$Gi)(this.contents[n],d=>console.error(d))})}}e.$6n=p;class r{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,w){if(!h.$Sf(n)){const y=this.g(n);this.parseRaw(y,w)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,w){this.a=n;const{contents:y,keys:d,overrides:b,restricted:P,hasExcludedProperties:g}=this.h(n,w);this.b=new p(y,d,b,g?[n]:void 0),this.c=P||[]}g(n){let w={},y=null,d=[];const b=[],P=[];function g(k){Array.isArray(d)?d.push(k):y!==null&&(d[y]=k)}const v={onObjectBegin:()=>{const k={};g(k),b.push(d),d=k,y=null},onObjectProperty:k=>{y=k},onObjectEnd:()=>{d=b.pop()},onArrayBegin:()=>{const k=[];g(k),b.push(d),d=k,y=null},onArrayEnd:()=>{d=b.pop()},onLiteralValue:g,onError:(k,F,O)=>{P.push({error:k,offset:F,length:O})}};if(n)try{I.$mn(n,v),w=d[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return w}h(n,w){const y=l.$Kn.as(D.$Pn.Configuration).getConfigurationProperties(),d=this.i(n,y,!0,w);n=d.raw;const b=(0,A.$Gi)(n,v=>console.error(`Conflict in settings file ${this.f}: ${v}`)),P=Object.keys(n),g=this.j(n,v=>console.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:b,keys:P,overrides:g,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(n,w,y,d){let b=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:b};const P={},g=[];for(const v in n)if(D.$Zn.test(v)&&y){const k=this.i(n[v],w,!1,d);P[v]=k.raw,b=b||k.hasExcludedProperties,g.push(...k.restricted)}else{const k=w[v],F=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&g.push(v),!d.exclude?.includes(v)&&(d.include?.includes(v)||(F===void 0||d.scopes===void 0||d.scopes.includes(F))&&!(d.skipRestricted&&k?.restricted))?P[v]=n[v]:b=!0}return{raw:P,restricted:g,hasExcludedProperties:b}}j(n,w){const y=[];for(const d of Object.keys(n))if(D.$Zn.test(d)){const b={};for(const P in n[d])b[P]=n[d][P];y.push({identifiers:(0,D.$1n)(d),keys:Object.keys(b),contents:(0,A.$Gi)(b,w)})}return y}}e.$7n=r;class c extends R.$Tc{constructor(n,w,y,d){super(),this.c=n,this.f=w,this.g=d,this.b=this.B(new M.$Wd),this.onDidChange=this.b.event,this.a=new r(this.c.toString()),this.B(this.g.watch(y.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&y.isEqual(b.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new p}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$8n=c;class s{constructor(n,w,y,d,b,P,g,v,k,F,O,G,q){this.a=n,this.b=w,this.c=y,this.overrideIdentifiers=d,this.d=b,this.f=P,this.g=g,this.h=v,this.i=k,this.j=F,this.k=O,this.l=G,this.m=q}get value(){return $(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(n,w,y,d,b=new p,P=new p,g=new L.$Ac,v=new p,k=new L.$Ac){this.c=n,this.d=w,this.f=y,this.g=d,this.h=b,this.i=P,this.j=g,this.l=v,this.m=k,this.a=null,this.b=new L.$Ac,this.n=null}getValue(n,w,y){return this.p(n,w,y).getValue(n)}updateValue(n,w,y={}){let d;y.resource?(d=this.m.get(y.resource),d||(d=new p,this.m.set(y.resource,d))):d=this.l,w===void 0?d.removeValue(n):d.setValue(n,w),y.resource||(this.a=null)}inspect(n,w,y){const d=this.p(n,w,y),b=this.t(w.resource,y),P=w.resource?this.m.get(w.resource)||this.l:this.l,g=new Set;for(const v of d.overrides)for(const k of v.identifiers)d.getOverrideValue(n,k)!==void 0&&g.add(k);return new s(n,w,d.getValue(n),g.size?[...g]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this.i:void 0,b||void 0,P)}keys(n){const w=this.t(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:w?w.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,w){this.j.set(n,w),this.b.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,w){const y=[];if(!w){const{added:d,updated:b,removed:P}=u(this.c,n);w=[...d,...b,...P]}for(const d of w)for(const b of(0,D.$1n)(d)){const P=this.c.getKeysForOverrideIdentifier(b),g=n.getKeysForOverrideIdentifier(b),v=[...g.filter(k=>P.indexOf(k)===-1),...P.filter(k=>g.indexOf(k)===-1),...P.filter(k=>!m.$Cn(this.c.override(b).getValue(k),n.override(b).getValue(k)))];y.push([b,v])}return this.updateDefaultConfiguration(n),{keys:w,overrides:y}}compareAndUpdatePolicyConfiguration(n){const{added:w,updated:y,removed:d}=u(this.d,n),b=[...w,...y,...d];return b.length&&this.updatePolicyConfiguration(n),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:w,updated:y,removed:d,overrides:b}=u(this.applicationConfiguration,n),P=[...w,...y,...d];return P.length&&this.updateApplicationConfiguration(n),{keys:P,overrides:b}}compareAndUpdateLocalUserConfiguration(n){const{added:w,updated:y,removed:d,overrides:b}=u(this.localUserConfiguration,n),P=[...w,...y,...d];return P.length&&this.updateLocalUserConfiguration(n),{keys:P,overrides:b}}compareAndUpdateRemoteUserConfiguration(n){const{added:w,updated:y,removed:d,overrides:b}=u(this.remoteUserConfiguration,n),P=[...w,...y,...d];return P.length&&this.updateRemoteUserConfiguration(n),{keys:P,overrides:b}}compareAndUpdateWorkspaceConfiguration(n){const{added:w,updated:y,removed:d,overrides:b}=u(this.workspaceConfiguration,n),P=[...w,...y,...d];return P.length&&this.updateWorkspaceConfiguration(n),{keys:P,overrides:b}}compareAndUpdateFolderConfiguration(n,w){const y=this.folderConfigurations.get(n),{added:d,updated:b,removed:P,overrides:g}=u(y,w),v=[...d,...b,...P];return(v.length||!y)&&this.updateFolderConfiguration(n,w),{keys:v,overrides:g}}compareAndDeleteFolderConfiguration(n){const w=this.folderConfigurations.get(n);if(!w)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:y,updated:d,removed:b,overrides:P}=u(w,void 0);return{keys:[...y,...d,...b],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(n,w,y){let d=this.q(w,y);return w.overrideIdentifier&&(d=d.override(w.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(d=d.merge(this.d)),d}q({resource:n},w){let y=this.r();if(w&&n){const d=w.getFolder(n);d&&(y=this.s(d.uri)||y);const b=this.m.get(n);b&&(y=y.merge(b))}return y}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(n){let w=this.b.get(n);if(!w){const y=this.r(),d=this.j.get(n);d?(w=y.merge(d),this.b.set(n,w)):w=y}return w}t(n,w){if(w&&n){const y=w.getFolder(n);if(y)return this.j.get(y.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,w)=>{const{contents:y,overrides:d,keys:b}=this.j.get(w);return n.push([w,{contents:y,overrides:d,keys:b}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(w=>n.add(w)),this.userConfiguration.keys.forEach(w=>n.add(w)),this.i.keys.forEach(w=>n.add(w)),this.j.forEach(w=>w.keys.forEach(y=>n.add(y))),[...n.values()]}u(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(w=>n.add(w)),this.userConfiguration.getAllOverrideIdentifiers().forEach(w=>n.add(w)),this.i.getAllOverrideIdentifiers().forEach(w=>n.add(w)),this.j.forEach(w=>w.getAllOverrideIdentifiers().forEach(y=>n.add(y))),[...n.values()]}v(n){const w=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(y=>w.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(y=>w.add(y)),this.i.getKeysForOverrideIdentifier(n).forEach(y=>w.add(y)),this.j.forEach(y=>y.getKeysForOverrideIdentifier(n).forEach(d=>w.add(d))),[...w.values()]}static parse(n){const w=this.w(n.defaults),y=this.w(n.policy),d=this.w(n.application),b=this.w(n.user),P=this.w(n.workspace),g=n.folders.reduce((v,k)=>(v.set(E.URI.revive(k[0]),this.w(k[1])),v),new L.$Ac);return new i(w,y,d,b,new p,P,g,new p,new L.$Ac)}static w(n){return new p(n.contents,n.keys,n.overrides)}}e.$9n=i;function o(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const n=new Set,w=new Map;for(const d of f)d.keys.forEach(b=>n.add(b)),d.overrides.forEach(([b,P])=>{const g=(0,L.$xc)(w,b,new Set);P.forEach(v=>g.add(v))});const y=[];return w.forEach((d,b)=>y.push([b,[...d.values()]])),{keys:[...n.values()],overrides:y}}e.$0n=o;class a{constructor(n,w,y,d){this.change=n,this.f=w,this.g=y,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const b of n.keys)this.affectedKeys.add(b);for(const[,b]of n.overrides)for(const P of b)this.affectedKeys.add(P);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(n,w){const y=this.a+n,d=this.d.indexOf(y);if(d<0)return!1;const b=d+y.length;if(b>=this.d.length)return!1;const P=this.d.charCodeAt(b);if(P!==this.b&&P!==this.c)return!1;if(w){const g=this.previousConfiguration?this.previousConfiguration.getValue(n,w,this.f?.workspace):void 0,v=this.g.getValue(n,w,this.h);return!m.$Cn(g,v)}return!0}}e.$$n=a;function u(f,n){const{added:w,removed:y,updated:d}=t(n?.rawConfiguration,f?.rawConfiguration),b=[],P=f?.getAllOverrideIdentifiers()||[],g=n?.getAllOverrideIdentifiers()||[];if(n){const v=g.filter(k=>!P.includes(k));for(const k of v)b.push([k,n.getKeysForOverrideIdentifier(k)])}if(f){const v=P.filter(k=>!g.includes(k));for(const k of v)b.push([k,f.getKeysForOverrideIdentifier(k)])}if(n&&f){for(const v of P)if(g.includes(v)){const k=t({contents:f.getOverrideValue(void 0,v)||{},keys:f.getKeysForOverrideIdentifier(v)},{contents:n.getOverrideValue(void 0,v)||{},keys:n.getKeysForOverrideIdentifier(v)});b.push([v,[...k.added,...k.removed,...k.updated]])}}return{added:w,removed:y,updated:d,overrides:b}}function t(f,n){const w=f?n?f.keys.filter(b=>n.keys.indexOf(b)===-1):[...f.keys]:[],y=n?f?n.keys.filter(b=>f.keys.indexOf(b)===-1):[...n.keys]:[],d=[];if(f&&n){for(const b of n.keys)if(f.keys.indexOf(b)!==-1){const P=(0,A.$Ji)(n.contents,b),g=(0,A.$Ji)(f.contents,b);m.$Cn(P,g)||d.push(b)}}return{added:w,removed:y,updated:d}}}),define(Re[100],Ae([1,0,15,4]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.RemoteAuthorityResolverErrorCode=e.$_k=e.$$k=e.RemoteConnectionType=e.$0k=void 0,e.$0k=(0,M.$8h)("remoteAuthorityResolverService");var I;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class R{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$$k=R;class L{constructor(D,l){this.host=D,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$_k=L;var m;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class h extends S.$bb{static isNotAvailable(D){return D instanceof h&&D._code===m.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof h&&D._code===m.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof h&&D._code===m.NoResolverFound}static isInvalidAuthority(D){return D instanceof h&&D._code===m.InvalidAuthority}static isHandled(D){return D instanceof h&&D.isHandled}constructor(D,l=m.Unknown,$){super(D),this._message=D,this._code=l,this._detail=$,this.isHandled=l===m.NotAvailable&&$===!0,Object.setPrototypeOf(this,h.prototype)}}e.$al=h;function E(A){const D=A.indexOf("+");return D===-1?A:A.substring(0,D)}e.$bl=E}),define(Re[56],Ae([1,0,12]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0;function M(E){return E.scheme===S.Schemas.vscodeRemote?E.authority:void 0}e.$cl=M;function I(E){if(!E)return;const A=E.indexOf("+");return A<0?E:E.substr(0,A)}e.$dl=I;function R(E){return`/${E.quality??"oss"}-${E.commit??"dev"}`}e.$el=R;function L(E){const{host:A,port:D}=h(E);if(typeof D>"u")throw new Error(`Invalid remote authority: ${E}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:A,port:D}}e.$fl=L;function m(E,A){let{host:D,port:l}=h(E);return typeof l>"u"&&(l=A),{host:D,port:l}}e.$gl=m;function h(E){const A=E.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const D=E.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const l=E.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:E,port:void 0}}}),define(Re[22],Ae([1,0,14,4,56]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.TargetPlatform=e.ExtensionType=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=void 0,e.$hm="extensions.user.cache",e.$im="extensions.builtin.cache",e.$jm="undefined_publisher",e.$km=["ui","workspace","web"];function R(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$lm=R,e.$mm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(L||(e.ExtensionType=L={}));var m;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class h{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,s){if(typeof c>"u"||c===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof c=="string"||typeof s=="string"){const i=typeof c=="string"?c:c.value,o=typeof s=="string"?s:s.value;return S.$af(i,o)}return c._lower===s._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.$nm=h;class E{get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const s of c)this.add(s)}add(c){this.c.add(h.toKey(c))}delete(c){return this.c.delete(h.toKey(c))}has(c){return this.c.has(h.toKey(c))}}e.$om=E;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(h.toKey(c))}get(c){return this.c.get(h.toKey(c))}has(c){return this.c.has(h.toKey(c))}set(c,s){this.c.set(h.toKey(c),s)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pm=A;function D(r){return l(r)}e.$qm=D;function l(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}e.$rm=l;function $(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}e.$sm=$;function p(r,c){if(c){const s=`onResolveRemoteAuthority:${(0,I.$dl)(c)}`;return!!r.activationEvents?.includes(s)}return!1}e.$tm=p,e.$um=(0,M.$8h)("IBuiltinExtensionsScannerService")}),define(Re[101],Ae([1,0,15,22]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(L,m){this.a.set(L,m)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const m=Object.create(null);for(const h of L){const E=this.readActivationEvents(h);E.length>0&&(m[M.$nm.toKey(h.identifier)]=E)}return m}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const m=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let h=0;h<m.length;h++)m[h]==="onUri"&&(m[h]=`onUri:${M.$nm.toKey(L.identifier)}`);if(!L.contributes)return m;for(const h in L.contributes){const E=this.a.get(h);if(!E)continue;const A=L.contributes[h],D=Array.isArray(A)?A:[A];try{E(D,m)}catch(l){(0,S.$1)(l)}}return m}}e.$pF=I,e.$qF=new I}),define(Re[190],Ae([1,0,20,73,33]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=void 0;function R(h){if(S.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function L(h,E,A,D,l,$,p,r,c){const s=Object.create(null);s["common.machineId"]=$,s["common.sqmId"]=p,s.sessionID=(0,I.$rg)()+Date.now(),s.commitHash=D,s.version=l,s["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,S.$h)(S.$u),s["common.nodePlatform"]=M.$dc,s["common.nodeArch"]=A,s["common.product"]=c||"desktop",r&&(s["common.msftInternal"]=r);let i=0;const o=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),S.$l&&(s["common.snap"]="true");const a=R(E);return a&&(s["common.platformDetail"]=a),s}e.$Lo=L;function m(h){const E=M.env.USERDNSDOMAIN;if(!E)return!1;const A=E.toLowerCase();return h.some(D=>A===D)}e.$Mo=m}),define(Re[191],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=void 0,e.$wl=(0,S.$8h)("telemetryService"),e.$xl=(0,S.$8h)("customEndpointTelemetryService"),e.$yl="telemetry.currentSessionDate",e.$zl="telemetry.firstSessionDate",e.$Al="telemetry.lastSessionDate",e.$Bl="telemetry.machineId",e.$Cl="telemetry.sqmId",e.$Dl="telemetry",e.$El="telemetry.telemetryLevel",e.$Fl="telemetry.enableCrashReporter",e.$Gl="telemetry.enableTelemetry";var M;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var I;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Re[57],Ae([1,0,26,16,56,190,191]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;class m{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.$No=m;class h{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Oo=h,e.$Po=new h;class E{async publicLog(f,n,w){}async publicLogError(f,n,w){}}e.$Qo=E,e.$Ro="telemetry",e.$So="extensionTelemetryLog",e.$To={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}e.$Uo=A;function D(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$Vo=D;function l(t){const f=t.getValue(L.$El),n=t.getValue(L.$Fl);if(t.getValue(L.$Gl)===!1||n===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Wo=l;function $(t){const f={},n={},w={};c(t,w);for(let y in w){y=y.length>150?y.substr(y.length-149):y;const d=w[y];typeof d=="number"?n[y]=d:typeof d=="boolean"?n[y]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${y} has been trimmed to 8192, the original length is ${d.length}`),f[y]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(f[y]=d)}return{properties:f,measurements:n}}e.$Xo=$;const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const f=(0,I.$dl)(t);return p.has(f)?f:"other"}e.$Yo=r;function c(t,f,n=0,w){if(t)for(const y of Object.getOwnPropertyNames(t)){const d=t[y],b=w?w+y:y;Array.isArray(d)?f[b]=(0,S.$Dn)(d):d instanceof Date?f[b]=d.toISOString():(0,M.$Lf)(d)?n<2?c(d,f,n+1,b+"."):f[b]=(0,S.$Dn)(d):f[b]=d}}function s(t,f){const n=t.msftInternalDomains||[],w=f.getValue("telemetry.internalTesting");return(0,R.$Mo)(n)||w}e.$Zo=s;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$1o=i;function o(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let n=t;const w=[];for(const P of f)for(;;){const g=P.exec(t);if(!g)break;w.push([g.index,P.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(n="";;){const P=d.exec(t);if(!P)break;const g=w.some(([v,k])=>P.index<k&&v<d.lastIndex);!y.test(P[0])&&!g&&(n+=t.substring(b,P.index)+"<REDACTED: user-file-path>",b=d.lastIndex)}return b<t.length&&(n+=t.substr(b)),n}function a(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of f)if(n.regex.test(t))return`<REDACTED: ${n.label}>`;return t}function u(t,f){return(0,S.$An)(t,n=>{if(n instanceof m||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let w=n.replaceAll("%20"," ");w=o(w,f);for(const y of f)w=w.replace(y,"");return w=a(w),w}})}e.$2o=u}),define(Re[192],Ae([1,0,14,96,22,20,2,15,73,57]),function(me,e,S,M,I,R,L,m,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0;function A(n,w){return n.uuid&&w.uuid?n.uuid===w.uuid:n.id===w.id?!0:(0,S.$8e)(n.id,w.id)===0}e.$3o=A;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(w){const y=w.manifest?w.manifest.version:w.version,d=w.manifest?w.targetPlatform:w.properties.targetPlatform;return new l(w.identifier,y,d)}static parse(w){const y=D.exec(w);return y&&y[1]&&y[2]?new l({id:y[1]},y[2],y[4]||void 0):null}constructor(w,y,d="undefined"){this.version=y,this.targetPlatform=d,this.id=w.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(w){return w instanceof l?A(this,w)&&this.version===w.version&&this.targetPlatform===w.targetPlatform:!1}}e.$4o=l;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(n){const w=$.exec(n);return w&&w[1]?[c(w[1]),w[2]]:[c(n),void 0]}e.$5o=p;function r(n,w){return`${n}.${w}`}e.$6o=r;function c(n){return n.toLowerCase()}e.$7o=c;function s(n,w){return c(r(n??I.$jm,w))}e.$8o=s;function i(n,w){const y=[],d=b=>{for(const P of y)if(P.some(g=>A(w(g),w(b))))return P;return null};for(const b of n){const P=d(b);P?P.push(b):y.push([b])}return y}e.$9o=i;function o(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$0o=o;function a(n){return{id:new E.$No(n.identifier.id),name:new E.$No(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$$o=a,e.$_o=new I.$nm("pprice.better-merge");function u(n,w){const y=[],d=w.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const b=d.shift();if(b&&y.every(P=>!A(P.identifier,{id:b}))){const P=n.filter(g=>A(g.identifier,{id:b}));P.length===1&&(y.push(P[0]),d.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.$ap=u;async function t(n,w){if(!R.$k)return!1;let y;try{y=(await n.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{y=(await n.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){w.debug("Error while getting the os-release file.",(0,m.$0)(b))}}return!!y&&(y.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(n,w){const y=await t(n,w),d=(0,M.$xo)(y?"alpine":R.$u,h.$ec);return w.debug("ComputeTargetPlatform:",d),d}e.$bp=f}),define(Re[193],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.$Qr=e.$Pr=e.$Or=void 0;function S(h){return[...h.entries()]}e.$Or=S;function M(h){return h?[...h.entries()]:[]}e.$Pr=M;function I(h){return new Map(h)}e.$Qr=I;function R(h){return new Map(h??[])}e.$Rr=R;function L(h){return Array.from(h.entries()).map(E=>[E[0],S(E[1].map),M(E[1].descriptionMap)])}e.$Sr=L;function m(h){return new Map(h.map(E=>[E[0],{map:I(E[1]),descriptionMap:R(E[2])}]))}e.$Tr=m}),define(Re[194],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hsb=void 0;class S{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,R,L=5){const m=R(h=>{const E=typeof h=="string"?h:h.data;let A=this.a.get(I);if(A){A.data.push(E);return}const D=setTimeout(()=>this.flushBuffer(I),L);A={data:[E],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(I),m.dispose()}},this.a.set(I,A)});return m}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const R=this.a.get(I);R&&(this.a.delete(I),this.b(I,R.data.join("")))}}e.$Hsb=S}),define(Re[195],Ae([1,0,11,89,40,5,16,2,155,72,30]),function(me,e,S,M,I,R,L,m,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gw=e.$Fw=e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.IconFontDefinition=e.IconContribution=e.$yw=void 0,e.$yw={IconContribution:"base.contributions.icons"};var D;(function(a){function u(t,f){let n=t.defaults;for(;I.ThemeIcon.isThemeIcon(n);){const w=p.getIcon(n.id);if(!w)return;n=w.defaults}return n}a.getDefinition=u})(D||(e.IconContribution=D={}));var l;(function(a){function u(f){return{weight:f.weight,style:f.style,src:f.src.map(n=>({format:n.format,location:n.location.toString()}))}}a.toJSONObject=u;function t(f){const n=w=>(0,L.$Jf)(w)?w:void 0;if(f&&Array.isArray(f.src)&&f.src.every(w=>(0,L.$Jf)(w.format)&&(0,L.$Jf)(w.location)))return{weight:n(f.weight),style:n(f.style),src:f.src.map(w=>({format:w.format,location:m.URI.parse(w.location)}))}}a.fromJSONObject=t})(l||(e.IconFontDefinition=l={}));class ${constructor(){this.a=new R.$Wd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,h.localize)(0,null)},fontCharacter:{type:"string",description:(0,h.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(u,t,f,n){const w=this.b[u];if(w){if(f&&!w.description){w.description=f,this.d.properties[u].markdownDescription=`${f} $(${u})`;const b=this.e.enum.indexOf(u);b!==-1&&(this.e.enumDescriptions[b]=f),this.a.fire()}return w}const y={id:u,description:f,defaults:t,deprecationMessage:n};this.b[u]=y;const d={$ref:"#/definitions/icons"};return n&&(d.deprecationMessage=n),f&&(d.markdownDescription=`${f}: $(${u})`),this.d.properties[u]=d,this.e.enum.push(u),this.e.enumDescriptions.push(f||""),this.a.fire(),{id:u}}deregisterIcon(u){delete this.b[u],delete this.d.properties[u];const t=this.e.enum.indexOf(u);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(u=>this.b[u])}getIcon(u){return this.b[u]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(u,t){const f=this.f[u];return f||(this.f[u]=t,this.a.fire(),t)}deregisterIconFont(u){delete this.f[u]}getIconFont(u){return this.f[u]}toString(){const u=(w,y)=>w.id.localeCompare(y.id),t=w=>{for(;I.ThemeIcon.isThemeIcon(w.defaults);)w=this.b[w.defaults.id];return`codicon codicon-${w?w.id:""}`},f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.b).map(w=>this.b[w]);for(const w of n.filter(y=>!!y.description).sort(u))f.push(`|<i class="${t(w)}"></i>|${w.id}|${I.ThemeIcon.isThemeIcon(w.defaults)?w.defaults.id:w.id}|${w.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const w of n.filter(y=>!I.ThemeIcon.isThemeIcon(y.defaults)).sort(u))f.push(`|<i class="${t(w)}"></i>|${w.id}|`);return f.join(`
`)}}const p=new $;A.$Kn.add(e.$yw.IconContribution,p);function r(a,u,t,f){return p.registerIcon(a,u,t,f)}e.$zw=r;function c(){return p}e.$Aw=c;function s(){const a=(0,M.$_j)();for(const u in a){const t="\\"+a[u].toString(16);p.registerIcon(u,{fontCharacter:t})}}s(),e.$Bw="vscode://schemas/icons";const i=A.$Kn.as(E.$Ln.JSONContribution);i.registerSchema(e.$Bw,p.getIconSchema());const o=new S.$hh(()=>i.notifySchemaChanged(e.$Bw),200);p.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$Cw=r("widget-close",M.$bk.close,(0,h.localize)(2,null)),e.$Dw=r("goto-previous-location",M.$bk.arrowUp,(0,h.localize)(3,null)),e.$Ew=r("goto-next-location",M.$bk.arrowDown,(0,h.localize)(4,null)),e.$Fw=I.ThemeIcon.modify(M.$bk.sync,"spin"),e.$Gw=I.ThemeIcon.modify(M.$bk.loading,"spin")}),define(Re[196],Ae([1,0,5,2,47,4,13]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.ProvidedOnAutoForward=e.$Ev=e.TunnelPrivacyId=e.TunnelProtocol=e.$Dv=e.$Cv=void 0,e.$Cv=(0,R.$8h)("tunnelService"),e.$Dv=(0,R.$8h)("sharedTunnelsService");var m;(function(s){s.Http="http",s.Https="https"})(m||(e.TunnelProtocol=m={}));var h;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(h||(e.TunnelPrivacyId=h={}));function E(s){return!!s.forwardPort}e.$Ev=E;var A;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function D(s,{checkQuery:i=!0}={}){if(s.scheme!=="http"&&s.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(o)return{address:o[1],port:+o[2]};if(!s.query||!i)return;const a=s.query.split("&");for(const u of a){const t=u.split("=")[1];if(/^https?:/.exec(t)){const f=D(M.URI.parse(t));if(f)return f}}}e.$Fv=D,e.$Gv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function l(s){return e.$Gv.indexOf(s)>=0}e.$Hv=l,e.$Iv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(s){return e.$Iv.indexOf(s)>=0}e.$Jv=$;function p(s,i,o,a){if(o===1)return!1;if(o===2&&$(i)){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(u?.length===4&&parseInt(u[1])>=18)return!1}return s<1024}e.$Kv=p;class r{constructor(i,o,a){this.remoteAddress=i,this.localAddress=o,this.b=a,this.a=new S.$Wd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lv=r;let c=class{constructor(i,o){this.k=i,this.l=o,this.a=new S.$Wd,this.onTunnelOpened=this.a.event,this.b=new S.$Wd,this.onTunnelClosed=this.b.event,this.c=new S.$Wd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],o=Array.from(this.e.values());for(const a of o){const u=Array.from(a.values());for(const t of u){const f=await t.value;f&&typeof f!="string"&&i.push(f)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:o}of i.values())await o.then(a=>typeof a!="string"?a?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,o,a,u,t){this.q(i,o,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:o,localAddress:a,privacy:u,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,o){($(i)||l(i))&&(i=e.$Gv[0]);const a=this.s(i,o);if(a)return++a.refcount,a.value}openTunnel(i,o,a,u,t,f=!1,n,w){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${a} on local port ${t}.`);const y=this.f??i;if(!y)return;if(o||(o="localhost"),u||(u=this.m),this.f&&this.j.has(a)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const d=this.t(y,o,a,u,t,f,n,w);return d?d.then(b=>{if(b){if(typeof b=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(o,a),b}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(o,a);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const P=this.o(b);return(b.tunnelRemoteHost!==o||b.tunnelRemotePort!==a)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&b.privacy!==n&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(P),P}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),d)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const o=this.e.get(i.tunnelRemoteHost);if(o){const a=o.get(i.tunnelRemotePort);a&&(a.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,a))}}}}async p(i,o,a){if(a.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${o}.`);const u=a.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this.b.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(o),u}}async closeTunnel(i,o){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${o} `);const a=this.e.get(i);if(a&&a.has(o)){const u=a.get(o);u.refcount=0,await this.p(i,o,u)}}q(i,o,a){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(o,{refcount:1,value:a})}async r(i,o){const a=this.e.get(i);if(a){const u=a.get(o),t=u?await u.value:void 0;(!t||typeof t=="string")&&a.delete(o),a.size===0&&this.e.delete(i)}}s(i,o){const a=[i];l(i)?(a.push(...e.$Gv),a.push(...e.$Iv)):$(i)&&a.push(...e.$Iv);const u=a.map(t=>this.e.get(t));for(const t of u){const f=t?.get(o);if(f)return f}}canTunnel(i){return!!D(i)}u(i,o,a,u,t,f,n){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${a} on local port ${u}.`);const w=a;this.j.add(w);const y=u===void 0?a:u,d={elevationRequired:t?this.isPortPrivileged(y):!1},b={remoteAddress:{host:o,port:a},localAddressPort:u,privacy:f,public:f?f!==h.Private:void 0,protocol:n},P=i.forwardPort(b,d);return P?(this.q(o,a,P),P.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(w)})):this.j.delete(w),P}};e.$Mv=c,e.$Mv=c=Ke([Ve(0,L.$pj),Ve(1,I.$Bi)],c)}),define(Re[197],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Nv=void 0,e.$Nv=(0,S.$8h)("editSessionIdentityService");var M;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Re[198],Ae([1,0,12]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=void 0;function M(h){return h.scheme!==S.Schemas.file&&h.scheme!==S.Schemas.vscodeRemote}e.$TK=M;function I(h){if(h.folders.length)return h.folders.every(E=>M(E.uri))?h.folders[0].uri:void 0;if(h.configuration&&M(h.configuration))return h.configuration}e.$UK=I;function R(h){return I(h)?.scheme}e.$VK=R;function L(h){return I(h)?.authority}e.$WK=L;function m(h){return I(h)!==void 0}e.$XK=m}),define(Re[48],Ae([1,0,156,19,51,25,2,4,12]),function(me,e,S,M,I,R,L,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.WorkbenchState=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=void 0,e.$ei=(0,m.$8h)("contextService");function E(w){const y=w;return typeof y?.id=="string"&&L.URI.isUri(y.uri)}e.$fi=E;function A(w){return typeof w?.id=="string"&&!E(w)&&!l(w)}e.$gi=A,e.$hi={id:"ext-dev"},e.$ii={id:"empty-window"};function D(w,y){if(typeof w=="string"||typeof w>"u")return typeof w=="string"?{id:(0,M.$nc)(w)}:y?e.$hi:e.$ii;const d=w;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$ji=D;function l(w){const y=w;return typeof y?.id=="string"&&L.URI.isUri(y.configPath)}e.$ki=l;function $(w){const y=w;if(y?.uri)return{id:y.id,uri:L.URI.revive(y.uri)};const d=w;if(d?.configPath)return{id:d.id,configPath:L.URI.revive(d.configPath)};if(w?.id)return{id:w.id}}e.$li=$;var p;(function(w){w[w.EMPTY=1]="EMPTY",w[w.FOLDER=2]="FOLDER",w[w.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function r(w){const y=w;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.$mi=r;function c(w){const y=w;return!!(y&&typeof y=="object"&&L.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.$ni=c;class s{constructor(y,d,b,P,g){this.h=y,this.j=b,this.k=P,this.l=g,this.c=I.$bi.forUris(this.l,()=>!0),this.folders=d}update(y){this.h=y.id,this.k=y.configuration,this.j=y.transient,this.l=y.l,this.folders=y.folders}get folders(){return this.g}set folders(y){this.g=y,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(y){this.k=y}getFolder(y){return y&&this.c.findSubstr(y)||null}n(){this.c=I.$bi.forUris(this.l,()=>!0);for(const y of this.folders)this.c.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$oi=s;class i{constructor(y,d){this.raw=d,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,R.$Ig)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$pi=i;function o(w){return new i({uri:w,index:0,name:(0,R.$Eg)(w)},{uri:w.toString()})}e.$qi=o,e.$ri="code-workspace",e.$si=`.${e.$ri}`,e.$ti=[{name:(0,S.localize)(0,null),extensions:[e.$ri]}],e.$ui="workspace.json";function a(w,y){return R.$zg.isEqualOrParent(w,y.untitledWorkspacesHome)}e.$vi=a;function u(w){let y;return L.URI.isUri(w)?y=w:y=w.configuration,y?.scheme===h.Schemas.tmp}e.$wi=u,e.$xi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(w){return w.id===e.$xi}e.$yi=t;function f(w,y){return!a(w,y)&&!u(w)}e.$zi=f;function n(w){return(typeof w=="string"?(0,M.$oc)(w):(0,R.$Gg)(w))===e.$si}e.$Ai=n}),define(Re[74],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0;class S{static{this.a=!1}constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const R=this.c++;return this.b.set(R,I),this.e(),R}get(I,R){return this.b.has(I)?this.b.get(I)[R]:void 0}delete(I){this.b.delete(I),this.e()}e(){S.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$agc=S}),define(Re[43],Ae([1,0,12,25,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=e.$dgc=void 0;class R{constructor(){this.a=new Set(Object.keys(S.Schemas)),this.b=new Map,this.extUri=new M.$xg(m=>{const h=this.b.get(m.scheme);return!(h===void 0||h&1024)})}$acceptProviderInfos(m,h){h===null?this.b.delete(m.scheme):this.b.set(m.scheme,h)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$dgc=R,e.$egc=(0,I.$8h)("IExtHostFileSystemInfo")}),define(Re[27],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=void 0,e.$LN=(0,S.$8h)("IExtHostInitDataService")}),define(Re[199],Ae([1,0,161,13,186,27]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=void 0;let L=class extends I.$SO{constructor(h,E,A){const D=A.remote.isRemote?"remoteexthost":h?"workerexthost":"exthost",l=A.remote.isRemote?(0,S.localize)(0,null):h?(0,S.localize)(1,null):(0,S.localize)(2,null);super(E.createLogger(D,{name:l}))}};e.$kic=L,e.$kic=L=Ke([Ve(1,M.$qj),Ve(2,R.$LN)],L)}),define(Re[200],Ae([1,0,11]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=e.$Ygc=void 0;class M{constructor(L,m,h){this.h=new Map,this.a=L,this.b=m,this.c=h,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new S.$hh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of E.values())A.complete()}catch(A){for(const D of E.values())D.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,m){let h=this.f[L];return typeof h>"u"&&(h=m),h}update(L,m){this.f[L]=m;const h=this.h.get(L);if(h!==void 0)return h.p;const E=new S.$sh;return this.h.set(L,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$Ygc=M;class I extends M{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,m){super(L.identifier.value,!0,m),this.j=L}}e.$Zgc=I}),define(Re[201],Ae([1,0,5,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;class I{constructor(L){this.c=L,this.a=new S.$Wd,this.onDidSaveNotebookDocument=this.a.event,this.b=new S.$Wd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,m,h,E){const D=this.c.getNotebookDocument(M.URI.revive(L)).acceptModelChanged(m.value,h,E);this.b.fire(D)}$acceptDirtyStateChanged(L,m){this.c.getNotebookDocument(M.URI.revive(L)).acceptDirty(m)}$acceptModelSaved(L){const m=this.c.getNotebookDocument(M.URI.revive(L));this.a.fire(m.apiNotebook)}}e.$Mhc=I}),define(Re[17],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=void 0,e.$vN=(0,S.$8h)("IExtHostRpcService");class M{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$wN=M}),define(Re[202],Ae([1,0,22,5]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=void 0;class I{#e;constructor(L,m){this.b=new M.$Wd,this.onDidChange=this.b.event,this.a=S.$nm.toKey(L.identifier),this.#e=m,this.#e.onDidChangePassword(h=>{h.extensionId===this.a&&this.b.fire({key:h.key})})}get(L){return this.#e.get(this.a,L)}store(L,m){return this.#e.store(this.a,L,m)}delete(L){return this.#e.delete(this.a,L)}}e.$7gc=I}),define(Re[58],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=e.$wgc=void 0,e.$wgc=(0,S.$8h)("IURITransformerService");class M{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$xgc=M}),define(Re[203],Ae([1,0,23]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Plb=e.$Olb=void 0;class M{constructor(){this.buffers=[]}add(h){let E=this.buffers.indexOf(h);return E<0&&(E=this.buffers.length,this.buffers.push(h)),E}}function I(m,h){if(h.serializeBuffersForPostMessage){const E=new M,D=JSON.stringify(m,($,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(p)};if(ArrayBuffer.isView(p)){const r=R(p);if(r)return{$$vscode_array_buffer_reference$$:!0,index:E.add(p.buffer),view:{type:r,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),l=E.buffers.map($=>{const p=new Uint8Array($);return S.$ke.wrap(p)});return{message:D,buffers:l}}else return{message:JSON.stringify(m),buffers:[]}}e.$Olb=I;function R(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function L(m,h){const E=h.map(l=>{const $=new ArrayBuffer(l.byteLength);return new Uint8Array($).set(l.buffer),$}),A=h.length?(l,$)=>{if($&&typeof $=="object"&&$.$$vscode_array_buffer_reference$$){const p=$,{index:r}=p,c=E[r];if(p.view)switch(p.view.type){case 1:return new Int8Array(c,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(c,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(c,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(c,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(c,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(c,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(c,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(c,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(c,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(c,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(c,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return $}:void 0;return{message:JSON.parse(m,A),arrayBuffers:E}}e.$Plb=L}),define(Re[102],Ae([1,0,170,16,2,6,4,30,42,12,41,134,32]),function(me,e,S,M,I,R,L,m,h,E,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9E=e.$8E=e.$7E=e.EditorsOrder=e.$6E=e.CloseDirection=e.$5E=e.$4E=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=e.EditorInputCapabilities=e.$UE=e.SaveReason=e.Verbosity=e.$TE=e.$SE=e.$RE=e.$QE=e.$PE=e.$OE=e.$NE=e.$ME=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=void 0,e.$HE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$IE={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.$JE="workbench.editor.sidebysideEditor",e.$KE="workbench.editors.textDiffEditor",e.$LE="workbench.editors.binaryResourceDiffEditor";var $;(function(ie){ie[ie.PROGRAMMATIC=1]="PROGRAMMATIC",ie[ie.USER=2]="USER",ie[ie.EDIT=3]="EDIT",ie[ie.NAVIGATION=4]="NAVIGATION",ie[ie.JUMP=5]="JUMP"})($||(e.EditorPaneSelectionChangeReason=$={}));var p;(function(ie){ie[ie.IDENTICAL=1]="IDENTICAL",ie[ie.SIMILAR=2]="SIMILAR",ie[ie.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function r(ie){const x=ie;return!!x&&typeof x.getSelection=="function"&&!!x.onDidChangeSelection}e.$ME=r;function c(ie,x,V){for(const ne of V.visibleEditorPanes)if(ne.group.id===x&&ie.matches(ne.input))return ne.getViewState()}e.$NE=c;function s(ie){if(b(ie))return!1;const x=ie;return I.URI.isUri(x?.resource)}e.$OE=s;function i(ie){if(b(ie))return!1;const x=ie;return x?.original!==void 0&&x.modified!==void 0}e.$PE=i;function o(ie){if(b(ie))return!1;const x=ie;return!x||x.resources&&!Array.isArray(x.resources)?!1:!!x.resources||!!x.multiDiffSource}e.$QE=o;function a(ie){if(b(ie)||i(ie))return!1;const x=ie;return x?.primary!==void 0&&x.secondary!==void 0}e.$RE=a;function u(ie){if(b(ie))return!1;const x=ie;return x?x.resource===void 0||x.resource.scheme===E.Schemas.untitled||x.forceUntitled===!0:!1}e.$SE=u;function t(ie){if(b(ie))return!1;const x=ie;return I.URI.isUri(x?.base?.resource)&&I.URI.isUri(x?.input1?.resource)&&I.URI.isUri(x?.input2?.resource)&&I.URI.isUri(x?.result?.resource)}e.$TE=t;var f;(function(ie){ie[ie.SHORT=0]="SHORT",ie[ie.MEDIUM=1]="MEDIUM",ie[ie.LONG=2]="LONG"})(f||(e.Verbosity=f={}));var n;(function(ie){ie[ie.EXPLICIT=1]="EXPLICIT",ie[ie.AUTO=2]="AUTO",ie[ie.FOCUS_CHANGE=3]="FOCUS_CHANGE",ie[ie.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n||(e.SaveReason=n={}));class w{constructor(){this.a=new Map}registerSource(x,V){let ne=this.a.get(x);return ne||(ne={source:x,label:V},this.a.set(x,ne)),ne.source}getSourceLabel(x){return this.a.get(x)?.label??x}}e.$UE=new w;var y;(function(ie){ie[ie.None=0]="None",ie[ie.Readonly=2]="Readonly",ie[ie.Untitled=4]="Untitled",ie[ie.Singleton=8]="Singleton",ie[ie.RequiresTrust=16]="RequiresTrust",ie[ie.CanSplitInGroup=32]="CanSplitInGroup",ie[ie.ForceDescription=64]="ForceDescription",ie[ie.CanDropIntoEditor=128]="CanDropIntoEditor",ie[ie.MultipleEditors=256]="MultipleEditors",ie[ie.Scratchpad=512]="Scratchpad",ie[ie.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(y||(e.EditorInputCapabilities=y={}));class d extends R.$Tc{}e.$VE=d;function b(ie){return ie instanceof d}e.$WE=b;function P(ie){const x=ie;return I.URI.isUri(x?.preferredResource)}function g(ie){const x=ie;return b(x?.primary)&&b(x?.secondary)}e.$XE=g;function v(ie){const x=ie;return b(x?.modified)&&b(x?.original)}e.$YE=v;function k(ie,x,V,ne,Ie){return $e(ne,[(0,D.$Ri)({id:"workbench.action.openLargeFile",label:(0,S.localize)(2,null),run:()=>{const Me={...V,limits:{size:Number.MAX_VALUE}};ie.openEditor(x,Me)}}),(0,D.$Ri)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(3,null),run:()=>Ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$ZE=k;function F(ie){return b(ie?.editor)}e.$1E=F;function O(ie){const x=ie;return F(ie)&&x?.group!==void 0}e.$2E=O;function G(ie){const x=ie;return typeof x?.groupId=="number"&&b(x.editor)}e.$3E=G;var q;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.REPLACE=1]="REPLACE",ie[ie.MOVE=2]="MOVE",ie[ie.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var U;(function(ie){ie[ie.GROUP_ACTIVE=0]="GROUP_ACTIVE",ie[ie.GROUP_INDEX=1]="GROUP_INDEX",ie[ie.GROUP_LABEL=2]="GROUP_LABEL",ie[ie.GROUP_LOCKED=3]="GROUP_LOCKED",ie[ie.EDITOR_OPEN=4]="EDITOR_OPEN",ie[ie.EDITOR_CLOSE=5]="EDITOR_CLOSE",ie[ie.EDITOR_MOVE=6]="EDITOR_MOVE",ie[ie.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ie[ie.EDITOR_LABEL=8]="EDITOR_LABEL",ie[ie.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ie[ie.EDITOR_PIN=10]="EDITOR_PIN",ie[ie.EDITOR_STICKY=11]="EDITOR_STICKY",ie[ie.EDITOR_DIRTY=12]="EDITOR_DIRTY",ie[ie.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var C;(function(ie){ie[ie.PRIMARY=1]="PRIMARY",ie[ie.SECONDARY=2]="SECONDARY",ie[ie.BOTH=3]="BOTH",ie[ie.ANY=4]="ANY"})(C||(e.SideBySideEditor=C={}));class N{getOriginalUri(x,V){if(!x)return;if(t(x))return e.$5E.getOriginalUri(x.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Me}=this.a(x);if(Ie&&Me){if(V?.supportSideBySide===C.BOTH)return{primary:this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Me,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Me,{filterByScheme:V.filterByScheme});x=V.supportSideBySide===C.PRIMARY?Ie:Me}}if(i(x)||o(x)||a(x)||t(x))return;const ne=P(x)?x.preferredResource:x.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}a(x){return g(x)||a(x)?{primary:x.primary,secondary:x.secondary}:v(x)||i(x)?{primary:x.modified,secondary:x.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(x,V){if(!x)return;if(t(x))return e.$5E.getCanonicalUri(x.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Me}=this.a(x);if(Ie&&Me){if(V?.supportSideBySide===C.BOTH)return{primary:this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Me,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Me,{filterByScheme:V.filterByScheme});x=V.supportSideBySide===C.PRIMARY?Ie:Me}}if(i(x)||o(x)||a(x)||t(x))return;const ne=x.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}b(x,V){if(Array.isArray(V)){if(V.some(ne=>x.scheme===ne))return x}else if(V===x.scheme)return x}}var W;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.KEYBOARD=1]="KEYBOARD",ie[ie.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function se(ie,x,V,ne){if(!ie.isSticky(x))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return V===W.MOUSE||V===W.KEYBOARD;case"mouse":return V===W.MOUSE;case"keyboard":return V===W.KEYBOARD}return!1}e.$4E=se,e.$5E=new N;var le;(function(ie){ie[ie.LEFT=0]="LEFT",ie[ie.RIGHT=1]="RIGHT"})(le||(e.CloseDirection=le={}));class Ee{constructor(){this.c=new Map,this.d=new Map}start(x){const V=this.a=x.get(L.$7h);for(const[ne,Ie]of this.c)this.e(ne,Ie,V);this.c.clear()}e(x,V,ne){const Ie=ne.createInstance(V);this.d.set(x,Ie)}registerFileEditorFactory(x){if(this.b)throw new Error("Can only register one file editor factory.");this.b=x}getFileEditorFactory(){return(0,M.$Uf)(this.b)}registerEditorSerializer(x,V){if(this.c.has(x)||this.d.has(x))throw new Error(`A editor serializer with type ID '${x}' was already registered.`);return this.a?this.e(x,V,this.a):this.c.set(x,V),(0,R.$Rc)(()=>{this.c.delete(x),this.d.delete(x)})}getEditorSerializer(x){return this.d.get(typeof x=="string"?x:x.typeId)}}m.$Kn.add(e.$HE.EditorFactory,new Ee);async function De(ie,x,V){return!ie||!ie.length?[]:await Promise.all(ie.map(async ne=>{const Ie=I.URI.revive(ne.fileUri);if(!Ie){V.info("Cannot resolve the path because it is not valid.",ne);return}if(!await x.canHandleResource(Ie)){V.info("Cannot resolve the path because it cannot be handled",ne);return}let Le=ne.exists,we=ne.type;if(typeof Le!="boolean"||typeof we!="number")try{we=(await x.stat(Ie)).isDirectory?h.FileType.Directory:h.FileType.Unknown,Le=!0}catch(K){V.error(K),Le=!1}if(!Le&&ne.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",ne);return}if(we===h.FileType.Directory){V.info("Cannot resolve the path because it is a directory",ne);return}const ge={...ne.options,pinned:!0};return Le?{resource:Ie,options:ge}:{resource:Ie,options:ge,forceUntitled:!0}}))}e.$6E=De;var ce;(function(ie){ie[ie.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ie[ie.SEQUENTIAL=1]="SEQUENTIAL"})(ce||(e.EditorsOrder=ce={}));function pe(ie){const x=ie;if(!x)return!1;const V=x;if(V.modified)return pe(V.modified);const ne=x;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$7E=pe;function oe(ie){return(0,A.$Ti)(ie)}e.$8E=oe;function $e(ie,x,V){const ne=(0,A.$Ui)(ie,x);return ne.forceMessage=V?.forceMessage,ne.forceSeverity=V?.forceSeverity,ne.allowDialog=V?.allowDialog,ne}e.$9E=$e}),define(Re[204],Ae([1,0,5,171,4,6,28,30,18,26,89,195]),function(me,e,S,M,I,R,L,m,h,E,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eF=e.$dF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$cF=e.ViewContentGroups=e.$bF=e.$aF=e.ViewContainerLocation=e.Extensions=e.$_E=e.$$E=e.$0E=void 0,e.$0E="views",e.$$E=(0,M.localize)(0,null),e.$_E=(0,D.$zw)("default-view-icon",A.$bk.window,(0,M.localize)(1,null));var l;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var $;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel",f[f.AuxiliaryBar=2]="AuxiliaryBar"})($||(e.ViewContainerLocation=$={})),e.$aF=[0,1,2];function p(f){switch(f){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$bF=p;class r extends R.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$Wd),this.onDidRegister=this.c.event,this.f=this.B(new S.$Wd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,h.$Rb)([...this.g.values()])}registerViewContainer(n,w,y){const d=this.get(n.id);if(d)return d;const b=n;return b.openCommandActionDescriptor=y?.doNotRegisterOpenCommand?void 0:b.openCommandActionDescriptor??{id:b.id},(0,L.$xc)(this.g,w,[]).push(b),y?.isDefault&&this.h.push(b),this.c.fire({viewContainer:b,viewContainerLocation:w}),b}deregisterViewContainer(n){for(const w of this.g.keys()){const y=this.g.get(w),d=y?.indexOf(n);if(d!==-1){y?.splice(d,1),y.length===0&&this.g.delete(w),this.f.fire({viewContainer:n,viewContainerLocation:w});return}}}get(n){return this.all.filter(w=>w.id===n)[0]}getViewContainers(n){return[...this.g.get(n)||[]]}getViewContainerLocation(n){return[...this.g.keys()].filter(w=>this.getViewContainers(w).filter(y=>y?.id===n.id).length>0)[0]}getDefaultViewContainer(n){return this.h.find(w=>this.getViewContainerLocation(w)===n)}}m.$Kn.add(l.ViewContainersRegistry,new r);var c;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(c||(e.ViewContentGroups=c={}));function s(f,n){const w=f.group??c.More,y=n.group??c.More;return w!==y?w.localeCompare(y):(f.order??5)-(n.order??5)}class i extends R.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$Wd),this.onViewsRegistered=this.c.event,this.f=this.B(new S.$Wd),this.onViewsDeregistered=this.f.event,this.g=this.B(new S.$Wd),this.onDidChangeContainer=this.g.event,this.h=this.B(new S.$Wd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Gc}registerViews(n,w){this.registerViews2([{views:n,viewContainer:w}])}registerViews2(n){n.forEach(({views:w,viewContainer:y})=>this.r(w,y)),this.c.fire(n)}deregisterViews(n,w){const y=this.s(n,w);y.length&&this.f.fire({views:y,viewContainer:w})}moveViews(n,w){for(const y of this.m.keys())if(y!==w){const d=this.s(n,y);d.length&&(this.r(d,w),this.g.fire({views:d,from:y,to:w}))}}getViews(n){return this.m.get(n)||[]}getView(n){for(const w of this.j){const y=(this.m.get(w)||[]).filter(d=>d.id===n)[0];if(y)return y}return null}getViewContainer(n){for(const w of this.j)if((this.m.get(w)||[]).filter(d=>d.id===n)[0])return w;return null}registerViewWelcomeContent(n,w){return this.n.add(n,w),this.h.fire(n),(0,R.$Rc)(()=>{this.n.delete(n,w),this.h.fire(n)})}registerViewWelcomeContent2(n,w){const y=new Map;for(const[d,b]of w)this.n.add(n,b),y.set(d,(0,R.$Rc)(()=>{this.n.delete(n,b),this.h.fire(n)}));return this.h.fire(n),y}getViewWelcomeContent(n){const w=[];return this.n.forEach(n,y=>w.push(y)),w.sort(s)}r(n,w){let y=this.m.get(w);y||(y=[],this.m.set(w,y),this.j.push(w));for(const d of n){if(this.getView(d.id)!==null)throw new Error((0,M.localize)(2,null,d.id));y.push(d)}}s(n,w){const y=this.m.get(w);if(!y)return[];const d=[],b=[];for(const P of y)n.includes(P)?d.push(P):b.push(P);return d.length&&(b.length?this.m.set(w,b):(this.m.delete(w),this.j.splice(this.j.indexOf(w),1))),d}}m.$Kn.add(l.ViewsRegistry,new i),e.$cF=(0,I.$8h)("viewDescriptorService");var o;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(o||(e.ViewVisibilityState=o={}));var a;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class u{constructor(n,w){this.c=!1,this.d=!1,(0,E.$Bn)(this,n),this.d=!!w,this.resolve=async y=>{if(w&&!this.c){const d=await w(y);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}y.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$dF=u;class t extends Error{constructor(n){super((0,M.localize)(3,null,n)),this.name="NoTreeViewError"}static is(n){return n.name==="NoTreeViewError"}}e.$eF=t}),define(Re[205],Ae([1,0,2,29,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oF=e.$nF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$mF=e.$lF=void 0;function R(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof S.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(M.$Ws.isIRange)}e.$lF=R;function L(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(R)}e.$mF=L;var m;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var h;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(h||(e.ChatAgentCopyKind=h={})),e.$nF=(0,I.$8h)("IChatService"),e.$oF="accessibility.voice.keywordActivation"}),define(Re[206],Ae([1,0,5,11,172]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imb=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new S.$Wd,this.n=new S.$Wd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,h,E,A){const D={command:m};if(h&&Object.keys(h).length>0&&(D.arguments=h),this.s("request",D),typeof A=="number"){const l=setTimeout(()=>{clearTimeout(l);const $=this.f.get(D.seq);if($){this.f.delete(D.seq);const p={type:"response",seq:0,request_seq:D.seq,success:!1,command:m,message:(0,I.localize)(0,null,A,m)};$(p)}},A)}return E&&this.f.set(D.seq,E),D.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,h){return m.type!=="event"||h.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,M.$9g)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const h=m,E=this.f.get(h.request_seq);E&&(this.f.delete(h.request_seq),E(h));break}}}}s(m,h){h.type=m,h.seq=this.d++,this.sendMessage(h)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((h,E)=>m.set(E,h)),await(0,M.$9g)(500),m.forEach((h,E)=>{h({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$imb=R}),define(Re[207],Ae([1,0,2,173,35,4]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$VH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$UH=e.MemoryRangeType=e.$TH=e.State=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=void 0,e.$NG="workbench.view.debug",e.$OG="workbench.debug.variablesView",e.$PG="workbench.debug.watchExpressionsView",e.$QG="workbench.debug.callStackView",e.$RG="workbench.debug.loadedScriptsView",e.$SG="workbench.debug.breakPointsView",e.$TG="workbench.debug.disassemblyView",e.$UG="workbench.panel.repl",e.$VG="workbench.panel.repl.view",e.$WG=new I.$mj("debugType",void 0,{type:"string",description:M.localize(0,null)}),e.$XG=new I.$mj("debugConfigurationType",void 0,{type:"string",description:M.localize(1,null)}),e.$YG=new I.$mj("debugState","inactive",{type:"string",description:M.localize(2,null)}),e.$ZG="debugUx",e.$1G=new I.$mj(e.$ZG,"default",{type:"string",description:M.localize(3,null)}),e.$2G=new I.$mj("hasDebugged",!1,{type:"boolean",description:M.localize(4,null)}),e.$3G=new I.$mj("inDebugMode",!1,{type:"boolean",description:M.localize(5,null)}),e.$4G=new I.$mj("inDebugRepl",!1,{type:"boolean",description:M.localize(6,null)}),e.$5G=new I.$mj("breakpointWidgetVisible",!1,{type:"boolean",description:M.localize(7,null)}),e.$6G=new I.$mj("inBreakpointWidget",!1,{type:"boolean",description:M.localize(8,null)}),e.$7G=new I.$mj("breakpointsFocused",!0,{type:"boolean",description:M.localize(9,null)}),e.$8G=new I.$mj("watchExpressionsFocused",!0,{type:"boolean",description:M.localize(10,null)}),e.$9G=new I.$mj("watchExpressionsExist",!1,{type:"boolean",description:M.localize(11,null)}),e.$0G=new I.$mj("variablesFocused",!0,{type:"boolean",description:M.localize(12,null)}),e.$$G=new I.$mj("expressionSelected",!1,{type:"boolean",description:M.localize(13,null)}),e.$_G=new I.$mj("breakpointInputFocused",!1,{type:"boolean",description:M.localize(14,null)}),e.$aH=new I.$mj("callStackItemType",void 0,{type:"string",description:M.localize(15,null)}),e.$bH=new I.$mj("callStackSessionIsAttach",!1,{type:"boolean",description:M.localize(16,null)}),e.$cH=new I.$mj("callStackItemStopped",!1,{type:"boolean",description:M.localize(17,null)}),e.$dH=new I.$mj("callStackSessionHasOneThread",!1,{type:"boolean",description:M.localize(18,null)}),e.$eH=new I.$mj("watchItemType",void 0,{type:"string",description:M.localize(19,null)}),e.$fH=new I.$mj("canViewMemory",void 0,{type:"boolean",description:M.localize(20,null)}),e.$gH=new I.$mj("breakpointItemType",void 0,{type:"string",description:M.localize(21,null)}),e.$hH=new I.$mj("breakpointSupportsCondition",!1,{type:"boolean",description:M.localize(22,null)}),e.$iH=new I.$mj("loadedScriptsSupported",!1,{type:"boolean",description:M.localize(23,null)}),e.$jH=new I.$mj("loadedScriptsItemType",void 0,{type:"string",description:M.localize(24,null)}),e.$kH=new I.$mj("focusedSessionIsAttach",!1,{type:"boolean",description:M.localize(25,null)}),e.$lH=new I.$mj("focusedSessionIsNoDebug",!1,{type:"boolean",description:M.localize(26,null)}),e.$mH=new I.$mj("stepBackSupported",!1,{type:"boolean",description:M.localize(27,null)}),e.$nH=new I.$mj("restartFrameSupported",!1,{type:"boolean",description:M.localize(28,null)}),e.$oH=new I.$mj("stackFrameSupportsRestart",!1,{type:"boolean",description:M.localize(29,null)}),e.$pH=new I.$mj("jumpToCursorSupported",!1,{type:"boolean",description:M.localize(30,null)}),e.$qH=new I.$mj("stepIntoTargetsSupported",!1,{type:"boolean",description:M.localize(31,null)}),e.$rH=new I.$mj("breakpointsExist",!1,{type:"boolean",description:M.localize(32,null)}),e.$sH=new I.$mj("debuggersAvailable",!1,{type:"boolean",description:M.localize(33,null)}),e.$tH=new I.$mj("debugExtensionAvailable",!0,{type:"boolean",description:M.localize(34,null)}),e.$uH=new I.$mj("debugProtocolVariableMenuContext",void 0,{type:"string",description:M.localize(35,null)}),e.$vH=new I.$mj("debugSetVariableSupported",!1,{type:"boolean",description:M.localize(36,null)}),e.$wH=new I.$mj("debugSetExpressionSupported",!1,{type:"boolean",description:M.localize(37,null)}),e.$xH=new I.$mj("breakWhenValueChangesSupported",!1,{type:"boolean",description:M.localize(38,null)}),e.$yH=new I.$mj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:M.localize(39,null)}),e.$zH=new I.$mj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:M.localize(40,null)}),e.$AH=new I.$mj("terminateDebuggeeSupported",!1,{type:"boolean",description:M.localize(41,null)}),e.$BH=new I.$mj("suspendDebuggeeSupported",!1,{type:"boolean",description:M.localize(42,null)}),e.$CH=new I.$mj("variableEvaluateNamePresent",!1,{type:"boolean",description:M.localize(43,null)}),e.$DH=new I.$mj("variableIsReadonly",!1,{type:"boolean",description:M.localize(44,null)}),e.$EH=new I.$mj("variableValue",!1,{type:"string",description:M.localize(45,null)}),e.$FH=new I.$mj("variableType",!1,{type:"string",description:M.localize(46,null)}),e.$GH=new I.$mj("variableName",!1,{type:"string",description:M.localize(47,null)}),e.$HH=new I.$mj("exceptionWidgetVisible",!1,{type:"boolean",description:M.localize(48,null)}),e.$IH=new I.$mj("multiSessionRepl",!1,{type:"boolean",description:M.localize(49,null)}),e.$JH=new I.$mj("multiSessionDebug",!1,{type:"boolean",description:M.localize(50,null)}),e.$KH=new I.$mj("disassembleRequestSupported",!1,{type:"boolean",description:M.localize(51,null)}),e.$LH=new I.$mj("disassemblyViewFocus",!1,{type:"boolean",description:M.localize(52,null)}),e.$MH=new I.$mj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:M.localize(53,null)}),e.$NH=new I.$mj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:M.localize(54,null)});const L=r=>M.localize(55,null,r);e.$OH=L,e.$PH="editor.contrib.debug",e.$QH="editor.contrib.breakpoint",e.$RH="debug",e.$SH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:M.localize(56,null)};var m;(function(r){r[r.Inactive=0]="Inactive",r[r.Initializing=1]="Initializing",r[r.Stopped=2]="Stopped",r[r.Running=3]="Running"})(m||(e.State=m={}));function h(r){switch(r){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$TH=h;var E;(function(r){r[r.Valid=0]="Valid",r[r.Unreadable=1]="Unreadable",r[r.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$UH="vscode-debug-memory";var A;(function(r){r[r.Initial=1]="Initial",r[r.Dynamic=2]="Dynamic"})(A||(e.DebugConfigurationProviderTriggerKind=A={}));var D;(function(r){r.UnverifiedBreakpoints="unverifiedBreakpoints"})(D||(e.DebuggerString=D={})),e.$VH=(0,R.$8h)("debugService");var l;(function(r){r[r.CONDITION=0]="CONDITION",r[r.HIT_COUNT=1]="HIT_COUNT",r[r.LOG_MESSAGE=2]="LOG_MESSAGE",r[r.TRIGGER_POINT=3]="TRIGGER_POINT"})(l||(e.BreakpointWidgetContext=l={}));var $;(function(r){r[r.Command=0]="Command",r[r.Tree=1]="Tree"})($||(e.DebugVisualizationType=$={}));var p;(function(r){r.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:S.URI.revive(c.iconPath.light),dark:S.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),r.serialize=c=>c})(p||(e.IDebugVisualization=p={}))}),define(Re[208],Ae([1,0,14,2,19,26,12,29,21,18]),function(me,e,S,M,I,R,L,m,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=void 0;const A=/{([^}]+)}/g;function D(P,g,v){return P.replace(A,function(k,F){return g&&F.length>0&&F[0]!=="_"?k:v&&v.hasOwnProperty(F)?v[F]:k})}e.$cG=D;function l(P){const g={};for(const v of Object.keys(P))v.startsWith("!")||(g[v]=P[v]);return g}e.$dG=l;function $(P){return P.configuration.request==="attach"&&!p(P)&&(!P.parentSession||$(P.parentSession))}e.$eG=$;function p(P){let g=P.configuration.type;if(g)return g==="vslsShare"&&(g=P.configuration.adapterProxy.configuration.type),(0,S.$af)(g,"extensionhost")||(0,S.$af)(g,"pwa-extensionhost")?P:P.parentSession?p(P.parentSession):void 0}e.$fG=p;function r(P){return P.type&&(P.label||P.program||P.runtime)}e.$gG=r;function c(P,g,v){let k,F=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let G=null;for(;G=O.exec(P);){const q=G.index+1,U=q+G[0].length;if(q<=g&&U>=v){k=G[0],F=q;break}}if(k){const q=/\w+/g;let U=null;for(;(U=q.exec(k))&&!(U.index+1+F+U[0].length>=v););U&&(k=k.substring(0,q.lastIndex))}return k?{start:F,end:F+k.length-1}:{start:0,end:0}}e.$hG=c;async function s(P,g,v,k){if(P.evaluatableExpressionProvider.has(g)){const F=P.evaluatableExpressionProvider.ordered(g),O=(0,E.$Hb)(await Promise.all(F.map(async G=>{try{return await G.provideEvaluatableExpression(g,v,k??h.CancellationToken.None)}catch{return}})));if(O.length>0){let G=O[0].expression;const q=O[0].range;return G||(G=g.getLineContent(v.lineNumber).substring(q.startColumn-1,q.endColumn-1)),{range:q,matchingExpression:G}}}else{const F=g.getLineContent(v.lineNumber),{start:O,end:G}=c(F,v.column,v.column),q=F.substring(O-1,G);return{matchingExpression:q,range:new m.$Ws(v.lineNumber,O,v.lineNumber,O+q.length)}}return null}e.$iG=s;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(P){return!!(P&&P.match(i))}e.$jG=o;function a(P){if(typeof P.path=="string"&&!(typeof P.sourceReference=="number"&&P.sourceReference>0)){if(o(P.path))return M.URI.parse(P.path);if((0,I.$ic)(P.path))return M.URI.file(P.path)}return P.path}function u(P){if(typeof P.path=="object"){const g=M.URI.revive(P.path);if(g)return g.scheme===L.Schemas.file?g.fsPath:g.toString()}return P.path}function t(P,g){const v=g?a:u,k=(0,R.$yn)(P);return n(k,(F,O)=>{F&&O&&(O.path=v(O))}),k}e.$kG=t;function f(P,g){const v=g?a:u,k=(0,R.$yn)(P);return n(k,(F,O)=>{!F&&O&&(O.path=v(O))}),k}e.$lG=f;function n(P,g){switch(P.type){case"event":{const v=P;switch(v.event){case"output":g(!1,v.body.source);break;case"loadedSource":g(!1,v.body.source);break;case"breakpoint":g(!1,v.body.breakpoint.source);break;default:break}break}case"request":{const v=P;switch(v.command){case"setBreakpoints":g(!0,v.arguments.source);break;case"breakpointLocations":g(!0,v.arguments.source);break;case"source":g(!0,v.arguments.source);break;case"gotoTargets":g(!0,v.arguments.source);break;case"launchVSCode":v.arguments.args.forEach(k=>g(!1,k));break;default:break}break}case"response":{const v=P;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(k=>g(!1,k.source));break;case"loadedSources":v.body.sources.forEach(k=>g(!1,k));break;case"scopes":v.body.scopes.forEach(k=>g(!1,k.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(k=>g(!1,k.source));break;case"setBreakpoints":v.body.breakpoints.forEach(k=>g(!1,k.source));break;case"disassemble":v.body?.instructions.forEach(F=>g(!1,F.location));break;default:break}break}}}function w(P){return P.filter(g=>!g.presentation?.hidden).sort((g,v)=>g.presentation?v.presentation?g.presentation.group?v.presentation.group?g.presentation.group!==v.presentation.group?g.presentation.group.localeCompare(v.presentation.group):y(g.presentation.order,v.presentation.order):-1:v.presentation.group?1:y(g.presentation.order,v.presentation.order):-1:v.presentation?1:0)}e.$mG=w;function y(P,g){return typeof P!="number"?typeof g!="number"?0:1:typeof g!="number"?-1:P-g}async function d(P,g){const v=P.getValue("debug.saveBeforeStart",{overrideIdentifier:g.activeTextEditorLanguageId});if(v!=="none"&&(await g.saveAll(),v==="allEditorsInActiveGroup")){const k=g.activeEditorPane;k&&k.input.resource?.scheme===L.Schemas.untitled&&await g.save({editor:k.input,groupId:k.group.id})}await P.reloadConfiguration()}e.$nG=d;const b=(P,g)=>!P||!g?P===g:P.name===g.name&&P.path===g.path&&P.sourceReference===g.sourceReference;e.$oG=b}),define(Re[209],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=e.CellExecutionUpdateType=void 0;var M;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$rJ=(0,S.$8h)("INotebookExecutionService")}),define(Re[210],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfb=e.$Kfb=e.ProxyKernelState=e.$Jfb=void 0,e.$Jfb=100;var M;(function(I){I[I.Disconnected=1]="Disconnected",I[I.Connected=2]="Connected",I[I.Initializing=3]="Initializing"})(M||(e.ProxyKernelState=M={})),e.$Kfb=(0,S.$8h)("INotebookKernelService"),e.$Lfb=(0,S.$8h)("INotebookKernelHistoryService")}),define(Re[211],Ae([1,0,6,29,144,93]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PRb=void 0;class L extends S.$Tc{constructor(h,E,A){super(),this._source=h,this.b=E,this.c=A,this.a=void 0}f(h){const E=h.getLineCount();return new M.$Ws(1,1,E,this.g(h,E))}g(h,E){if(E<1||E>h.getLineCount())throw new Error("Illegal value for lineNumber");return h.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const h=new I.$eC;h.acceptChunk(this._source);const E=h.finish(!0),{textBuffer:A,disposable:D}=E.create(1);this.b=A,this.B(D)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(h=>{const E=new I.$eC;E.acceptChunk(h);const A=E.finish(!0),{textBuffer:D,disposable:l}=A.create(1);return this.B(l),D})),this.a}findInInputs(h){const A=new R.$5B(h,!1,!1,null).parseSearchRequest();if(!A)return[];const D=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,A,!0,5e3)}findInOutputs(h){const A=new R.$5B(h,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(D=>{const l=D.findMatchesLineByLine(this.f(D),A,!0,5e3);if(l.length!==0)return{textBuffer:D,matches:l}}).filter(D=>!!D):[]}}e.$PRb=L}),define(Re[49],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cK=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(R){R.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var M;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class I{static fromExtHostTestItem(L,m,h=L.parent){if(L._isRoot)return new I([m]);const E=[L.id];for(let A=h;A&&A.id!==m;A=A.parent)E.push(A.id);return E.push(m),new I(E.reverse())}static isRoot(L){return!L.includes("\0")}static root(L){const m=L.indexOf("\0");return m===-1?L:L.slice(0,m)}static fromString(L){return new I(L.split("\0"))}static join(L,m){return new I([...L.path,m])}static joinToString(L,m){return L.toString()+"\0"+m}static parentId(L){const m=L.lastIndexOf("\0");return m===-1?void 0:L.slice(0,m)}static localId(L){const m=L.lastIndexOf("\0");return m===-1?L:L.slice(m+1)}static isChild(L,m){return m.startsWith(L)&&m[L.length]==="\0"}static compare(L,m){return L===m?0:I.isChild(L,m)?2:I.isChild(m,L)?3:1}constructor(L,m=L.length){if(this.path=L,this.d=m,L.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new I(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new I(this.path,L)}compare(L){if(typeof L=="string")return I.compare(this.toString(),L);for(let m=0;m<L.d&&m<this.d;m++)if(L.path[m]!==this.path[m])return 1;return L.d>this.d?2:L.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+="\0",this.c+=this.path[L]}return this.c}}e.$cK=I}),define(Re[59],Ae([1,0,2,91,29,49]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$jK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$iK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$hK=e.$gK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$fK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$eK=e.$dK=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var m;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var h;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(h||(e.TestRunProfileBitset=h={})),e.$dK=[2,4,8,16,32,64];const E=C=>"runId"in C;e.$eK=E;var A;(function(C){C.serialize=N=>({range:N.range.toJSON(),uri:N.uri.toJSON()}),C.deserialize=(N,W)=>({range:I.$Ws.lift(W.range),uri:N.asCanonicalUri(S.URI.revive(W.uri))})})(A||(e.IRichLocation=A={}));var D;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(D||(e.TestMessageType=D={}));var l;(function(C){C.serialize=N=>({message:N.message,type:0,expected:N.expected,actual:N.actual,contextValue:N.contextValue,location:N.location&&A.serialize(N.location)}),C.deserialize=(N,W)=>({message:W.message,type:0,expected:W.expected,actual:W.actual,contextValue:W.contextValue,location:W.location&&A.deserialize(N,W.location)})})(l||(e.ITestErrorMessage=l={}));const $=(C,N)=>`${N?"s":"e"}${C}`;e.$fK=$;var p;(function(C){C.serialize=N=>({message:N.message,type:1,offset:N.offset,length:N.length,location:N.location&&A.serialize(N.location)}),C.deserialize=(N,W)=>({message:W.message,type:1,offset:W.offset,length:W.length,location:W.location&&A.deserialize(N,W.location)})})(p||(e.ITestOutputMessage=p={}));var r;(function(C){C.serialize=N=>N.type===0?l.serialize(N):p.serialize(N),C.deserialize=(N,W)=>W.type===0?l.deserialize(N,W):p.deserialize(N,W)})(r||(e.ITestMessage=r={}));var c;(function(C){C.serializeWithoutMessages=N=>({state:N.state,duration:N.duration,messages:[]}),C.serialize=N=>({state:N.state,duration:N.duration,messages:N.messages.map(r.serialize)}),C.deserialize=(N,W)=>({state:W.state,duration:W.duration,messages:W.messages.map(se=>r.deserialize(N,se))})})(c||(e.ITestTaskState=c={}));const s="\0",i=(C,N)=>C+s+N;e.$gK=i;const o=C=>{const N=C.indexOf(s);return{ctrlId:C.slice(0,N),tagId:C.slice(N+1)}};e.$hK=o;var a;(function(C){C.serialize=N=>({extId:N.extId,label:N.label,tags:N.tags,busy:N.busy,children:void 0,uri:N.uri?.toJSON(),range:N.range?.toJSON()||null,description:N.description,error:N.error,sortText:N.sortText}),C.deserialize=(N,W)=>({extId:W.extId,label:W.label,tags:W.tags,busy:W.busy,children:void 0,uri:W.uri?N.asCanonicalUri(S.URI.revive(W.uri)):void 0,range:W.range?I.$Ws.lift(W.range):null,description:W.description,error:W.error,sortText:W.sortText})})(a||(e.ITestItem=a={}));var u;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(u||(e.TestItemExpandState=u={}));var t;(function(C){C.serialize=N=>({expand:N.expand,item:a.serialize(N.item)}),C.deserialize=(N,W)=>({controllerId:R.$cK.root(W.item.extId),expand:W.expand,item:a.deserialize(N,W.item)})})(t||(e.InternalTestItem=t={}));var f;(function(C){C.serialize=N=>{let W;return N.item&&(W={},N.item.label!==void 0&&(W.label=N.item.label),N.item.tags!==void 0&&(W.tags=N.item.tags),N.item.busy!==void 0&&(W.busy=N.item.busy),N.item.uri!==void 0&&(W.uri=N.item.uri?.toJSON()),N.item.range!==void 0&&(W.range=N.item.range?.toJSON()),N.item.description!==void 0&&(W.description=N.item.description),N.item.error!==void 0&&(W.error=N.item.error),N.item.sortText!==void 0&&(W.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:W}},C.deserialize=N=>{let W;return N.item&&(W={},N.item.label!==void 0&&(W.label=N.item.label),N.item.tags!==void 0&&(W.tags=N.item.tags),N.item.busy!==void 0&&(W.busy=N.item.busy),N.item.range!==void 0&&(W.range=N.item.range?I.$Ws.lift(N.item.range):null),N.item.description!==void 0&&(W.description=N.item.description),N.item.error!==void 0&&(W.error=N.item.error),N.item.sortText!==void 0&&(W.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:W}}})(f||(e.ITestItemUpdate=f={}));const n=(C,N)=>{N.expand!==void 0&&(C.expand=N.expand),N.item!==void 0&&(C.item=C.item?Object.assign(C.item,N.item):N.item)};e.$iK=n;var w;(function(C){C.serializeWithoutMessages=N=>({...t.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(c.serializeWithoutMessages)}),C.serialize=N=>({...t.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(c.serialize)}),C.deserialize=(N,W)=>({...t.deserialize(N,W),ownComputedState:W.ownComputedState,computedState:W.computedState,tasks:W.tasks.map(se=>c.deserialize(N,se)),retired:!0})})(w||(e.TestResultItem=w={}));var y;(function(C){C.empty=()=>({covered:0,total:0}),C.sum=(N,W)=>{N.covered+=W.covered,N.total+=W.total}})(y||(e.ICoveredCount=y={}));var d;(function(C){C.serialize=N=>({statement:N.statement,branch:N.branch,function:N.function,details:N.details?.map(v.serialize),uri:N.uri.toJSON()}),C.deserialize=(N,W)=>({statement:W.statement,branch:W.branch,function:W.function,details:W.details?.map(v.deserialize),uri:N.asCanonicalUri(S.URI.revive(W.uri))})})(d||(e.IFileCoverage=d={}));function b(C){return{...C,location:C.location?.toJSON()}}function P(C){return C.location=C.location?M.$Vs.isIPosition(C.location)?M.$Vs.lift(C.location):I.$Ws.lift(C.location):void 0,C}e.$jK=3;var g;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement",C[C.Branch=2]="Branch"})(g||(e.DetailType=g={}));var v;(function(C){C.serialize=N=>N.type===0?F.serialize(N):O.serialize(N),C.deserialize=N=>N.type===0?F.deserialize(N):O.deserialize(N)})(v||(e.CoverageDetails=v={}));var k;(function(C){C.serialize=b,C.deserialize=P})(k||(e.IBranchCoverage=k={}));var F;(function(C){C.serialize=b,C.deserialize=P})(F||(e.IFunctionCoverage=F={}));var O;(function(C){C.serialize=N=>({...b(N),branches:N.branches?.map(k.serialize)}),C.deserialize=N=>({...P(N),branches:N.branches?.map(k.deserialize)})})(O||(e.IStatementCoverage=O={}));var G;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(G||(e.TestDiffOpType=G={}));var q;(function(C){C.deserialize=(N,W)=>W.op===0?{op:W.op,item:t.deserialize(N,W.item)}:W.op===1?{op:W.op,item:f.deserialize(W.item)}:W.op===2?{op:W.op,uri:N.asCanonicalUri(S.URI.revive(W.uri)),docv:W.docv}:W,C.serialize=N=>N.op===0?{op:N.op,item:t.serialize(N.item)}:N.op===1?{op:N.op,item:f.serialize(N.item)}:N})(q||(e.TestsDiffOp=q={}));class U{constructor(N){this.k=N,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(N){const W=this.v();for(const se of N)switch(se.op){case 0:this.l(t.deserialize(this.k,se.item),W);break;case 1:this.o(f.deserialize(se.item),W);break;case 3:this.p(se.itemId,W);break;case 5:this.q(se.itemId);break;case 4:this.updatePendingRoots(se.amount);break;case 6:this.c.set(se.tag.id,se.tag);break;case 7:this.c.delete(se.id);break}W.complete?.()}l(N,W){const se=R.$cK.parentId(N.item.extId)?.toString();let le;if(!se)le=this.w(N),this.g.add(le),this.f.set(N.item.extId,le);else if(this.f.has(se)){const Ee=this.f.get(se);Ee.children.add(N.item.extId),le=this.w(N,Ee),this.f.set(N.item.extId,le)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(N)}`);return}return W.add?.(le),N.expand===2&&this.h++,le}o(N,W){const se=this.f.get(N.extId);if(se)return N.expand!==void 0&&(se.expand===2&&this.h--,N.expand===2&&this.h++),(0,e.$iK)(se,N),W.update?.(se),se}p(N,W){const se=this.f.get(N);if(!se)return;const le=R.$cK.parentId(se.item.extId)?.toString();le?this.f.get(le).children.delete(se.item.extId):this.g.delete(se);const Ee=[[N]];for(;Ee.length;)for(const De of Ee.pop()){const ce=this.f.get(De);ce&&(Ee.push(ce.children),this.f.delete(De),W.remove?.(ce,ce!==se),ce.expand===2&&this.h--)}}q(N){}updatePendingRoots(N){this.j+=N}v(){return{}}}e.$kK=U}),define(Re[75],Ae([1,0,11,5,6,54,59,49]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.TestItemEventOp=void 0;var h;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(h||(e.TestItemEventOp=h={}));const E=(i,o)=>i===o,D=Object.entries({range:(i,o)=>i===o?!0:!i||!o?!1:i.equalsRange(o),busy:E,label:E,description:E,error:E,sortText:E,tags:(i,o)=>!(i.length!==o.length||i.some(a=>!o.includes(a)))}),l=(i,o)=>{let a;for(const[u,t]of D)t(i[u],o[u])||(a?a[u]=o[u]:a={[u]:o[u]});return a};class $ extends I.$Tc{get root(){return this.s.root}constructor(o){super(),this.s=o,this.f=this.B(new S.$hh(()=>this.flushDiff(),200)),this.g=this.B(new M.$Wd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(o){this.h=o;for(const a of this.tree.values())this.J(a)}get resolveHandler(){return this.h}collectDiff(){const o=this.m;return this.m=[],o}pushDiff(o){switch(o.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===o.uri){a.docv=o.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===o.item.extId){(0,L.$iK)(a.item,o.item);return}if(a.op===0&&a.item.item.extId===o.item.extId){(0,L.$iK)(a.item,o.item);return}}break}}this.m.push(o),this.f.isScheduled()||this.f.schedule()}expand(o,a){const u=this.tree.get(o);if(u){if((u.expandLevels===void 0||a>u.expandLevels)&&(u.expandLevels=a),u.expand===1){const t=this.M(u);return t.isOpen()?this.L(u,a-1):t.wait().then(()=>this.L(u,a-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.L(u,a-1)):this.L(u,a-1)}}dispose(){for(const o of this.tree.values())this.s.getApiFor(o.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(o,a){switch(a.op){case 3:this.O(m.$cK.joinToString(o.fullId,a.id));break;case 0:this.z(a.item,o);break;case 5:for(const u of a.ops)this.w(o,u);break;case 1:this.C(a.new,a.old,o.fullId.toString());break;case 2:this.J(o);break;case 4:this.pushDiff({op:1,item:{extId:o.fullId.toString(),item:a.update}});break;case 6:this.y(o.actual.uri);break;default:(0,R.$6c)(a)}}y(o){o&&this.pushDiff({op:2,uri:o,docv:this.s.getDocumentVersion(o)})}z(o,a){const u=m.$cK.fromExtHostTestItem(o,this.root.id,a?.actual),t=this.s.getApiFor(o);t.parent&&t.parent!==a?.actual&&this.s.getChildren(t.parent).delete(o.id);let f=this.tree.get(u.toString());if(!f){f={fullId:u,actual:o,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},o.tags.forEach(this.D,this),this.tree.set(f.fullId.toString(),f),this.G(o,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:f.expand,item:this.s.toITestItem(o)}}),this.I(o,f,a);return}if(f.actual===o){this.H(o,f,a);return}if(f.actual.uri?.toString()!==o.uri?.toString())return this.O(u.toString()),this.z(o,a);const n=this.s.getChildren(f.actual),w=f.actual,y=l(this.s.toITestItem(w),this.s.toITestItem(o));this.s.getApiFor(w).listener=void 0,f.actual=o,f.expand=0,y&&(y.hasOwnProperty("tags")&&(this.C(o.tags,w.tags,u.toString()),delete y.tags),this.w(f,{op:4,update:y})),this.I(o,f,a);for(const[d,b]of n)this.s.getChildren(o).get(b.id)||this.O(m.$cK.joinToString(u,b.id));this.y(f.actual.uri)}C(o,a,u){const t=new Set(a.map(f=>f.id));for(const f of o)t.delete(f.id)||this.D(f);this.pushDiff({op:1,item:{extId:u,item:{tags:o.map(f=>(0,L.$gK)(this.s.controllerId,f.id))}}}),t.forEach(this.F,this)}D(o){const a=this.j.get(o.id);a?a.refCount++:(this.j.set(o.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,L.$gK)(this.s.controllerId,o.id)}}))}F(o){const a=this.j.get(o);a&&!--a.refCount&&(this.j.delete(o),this.pushDiff({op:7,id:(0,L.$gK)(this.s.controllerId,o)}))}G(o,a){this.s.getApiFor(o).parent=a&&a.actual!==this.root?a.actual:void 0}H(o,a,u){this.G(o,u);const t=this.s.getApiFor(o);t.parent=u?.actual,t.listener=f=>this.w(a,f),this.J(a)}I(o,a,u){this.H(o,a,u);for(const[t,f]of this.s.getChildren(o))this.z(f,a)}J(o){let a;this.h?o.resolveBarrier?a=o.resolveBarrier.isOpen()?3:2:a=o.actual.canResolveChildren?1:0:a=0,a!==o.expand&&(o.expand=a,this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:a}}),a===1&&o.expandLevels!==void 0&&this.M(o))}L(o,a){if(a<0)return;const u=[];for(const[t,f]of this.s.getChildren(o.actual)){const n=this.expand(m.$cK.joinToString(o.fullId,f.id),a);(0,S.$Tg)(n)&&u.push(n)}if(u.length)return Promise.all(u).then(()=>{})}M(o){if(o.resolveBarrier)return o.resolveBarrier;if(!this.h){const f=new S.$7g;return f.open(),f}o.expand=2,this.N(o);const a=o.resolveBarrier=new S.$7g,u=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,f)};let t;try{t=this.h(o.actual===this.root?void 0:o.actual)}catch(f){u(f)}return(0,S.$Tg)(t)?t.catch(u).then(()=>{a.open(),this.J(o)}):(a.open(),this.J(o)),o.resolveBarrier}N(o){this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:o.expand}})}O(o){const a=this.tree.get(o);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:o});const u=[a];for(;u.length;){const t=u.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.F(f.id);this.tree.delete(t.fullId.toString());for(const[f,n]of this.s.getChildren(t.actual))u.push(this.tree.get(m.$cK.joinToString(t.fullId,n.id)))}}}flushDiff(){const o=this.collectDiff();o.length&&this.g.fire(o)}}e.$lN=$;class p extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.$mN=p;class r extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$nN=r;class c extends Error{constructor(o,a,u){super(`TestItem with ID "${o}" is from controller "${a}" and cannot be added as a child of an item from controller "${u}".`)}}e.$oN=c;const s=(i,o,a)=>{let u=new Map;return{get size(){return u.size},forEach(t,f){for(const n of u.values())t.call(f,n,this)},[Symbol.iterator](){return u.entries()},replace(t){const f=new Map,n=new Set(u.keys()),w={op:5,ops:[]};for(const y of t){if(!(y instanceof a))throw new r(y.id);const d=o(y).controllerId;if(d!==i.controllerId)throw new c(y.id,d,i.controllerId);if(f.has(y.id))throw new p(y.id);f.set(y.id,y),n.delete(y.id),w.ops.push({op:0,item:y})}for(const y of n.keys())w.ops.push({op:3,id:y});i.listener?.(w),u=f},add(t){if(!(t instanceof a))throw new r(t.id);u.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){u.delete(t)&&i.listener?.({op:3,id:t})},get(t){return u.get(t)},toJSON(){return Array.from(u.values())}}};e.$pN=s}),define(Re[103],Ae([1,0,75]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=e.$qN=void 0;const M=new WeakMap,I=(L,m)=>{const h={controllerId:m};return M.set(L,h),h};e.$qN=I;const R=L=>{const m=M.get(L);if(!m)throw new S.$nN(L?.id||"<unknown>");return m};e.$rN=R}),define(Re[76],Ae([1,0,12,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ywb=e.$xwb=e.$wwb=e.$vwb=e.$uwb=void 0,e.$uwb="vscode-cdn.net",e.$vwb=`vscode-resource.${e.$uwb}`,e.$wwb=`'self' https://*.${e.$uwb}`;function I(m,h){return m.scheme===S.Schemas.http||m.scheme===S.Schemas.https?m:(h&&h.authority&&h.isRemote&&m.scheme===S.Schemas.file&&(m=M.URI.from({scheme:S.Schemas.vscodeRemote,authority:h.authority,path:m.path})),M.URI.from({scheme:S.Schemas.https,authority:`${m.scheme}+${R(m.authority)}.${e.$vwb}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$xwb=I;function R(m){return m.replace(/./g,h=>{const E=h.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?h:"-"+E.toString(16).padStart(4,"0")})}function L(m){return m.replace(/-([0-9a-f]{4})/g,(h,E)=>String.fromCharCode(parseInt(E,16)))}e.$ywb=L}),define(Re[212],Ae([1,0,5,6,76]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;class R{constructor(m,h,E){this.d=m,this.e=h,this.f=E,this.a=0,this.b=new M.$Sc,this.c=new Map,this.b.add(h.onDidChangeVisibleTextEditors(()=>{const A=h.getVisibleTextEditors();for(const D of this.c.values())A.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,h,E,A,D){let l;for(const o of this.e.getVisibleTextEditors(!0))if(o.value===m){l=o;break}if(!l)throw new Error("not a visible editor");const $=this,p=this.a++,r=new S.$Wd,c=new S.$Wd,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(o){return(0,I.$xwb)(o,$.f)}get cspSource(){return I.$wwb}set options(o){this.b=o,$.d.$setOptions(p,o)}get options(){return this.b}set html(o){this.a=o,$.d.$setHtml(p,o)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(o){return $.d.$postMessage(p,o)}},i=new class{constructor(){this.editor=m,this.line=h,this.height=E,this.webview=s,this.onDidDispose=c.event}dispose(){$.c.has(p)&&($.c.delete(p),$.d.$disposeEditorInset(p),c.fire(),c.dispose(),r.dispose())}};return this.d.$createEditorInset(p,l.id,l.value.document.uri,h+1,E,A||{},D.identifier,D.extensionLocation),this.c.set(p,{editor:m,inset:i,onDidReceiveMessage:r}),i}$onDidDispose(m){const h=this.c.get(m);h&&h.inset.dispose()}$onDidReceiveMessage(m,h){this.c.get(m)?.onDidReceiveMessage.fire(h)}}e.$ugc=R}),define(Re[213],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iO=e.VariableKind=e.$hO=void 0,e.$hO=(0,S.$8h)("configurationResolverService");var M;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(M||(e.VariableKind=M={}));class I extends Error{constructor(L,m){super(m),this.variable=L}}e.$iO=I}),define(Re[214],Ae([1,0,19,73,16,26,20,94,176,213,14]),function(me,e,S,M,I,R,L,m,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wO=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor($,p,r,c){this.h=new Map,this.a=$,this.b=p,this.g=r,c&&(this.c=c.then(s=>this.i(s)))}i($){if(L.$i){const p=Object.create(null);return Object.keys($).forEach(r=>{p[r.toLowerCase()]=$[r]}),p}return $}resolveWithEnvironment($,p,r){return this.l({env:this.i($),userHome:void 0},p?p.uri:void 0,r)}async resolveAsync($,p){const r={env:await this.c,userHome:await this.g};return this.l(r,$?$.uri:void 0,p)}async j($,p,r,c){const s=R.$yn(p);L.$i&&s.windows?Object.keys(s.windows).forEach(o=>s[o]=s.windows[o]):L.$j&&s.osx?Object.keys(s.osx).forEach(o=>s[o]=s.osx[o]):L.$k&&s.linux&&Object.keys(s.linux).forEach(o=>s[o]=s.linux[o]),delete s.windows,delete s.osx,delete s.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,$?$.uri:void 0,s,r,c)}async resolveAnyAsync($,p,r){return this.j($,p,r)}async resolveAnyMap($,p,r){const c=new Map;return{newConfig:await this.j($,p,r,c),resolvedVariables:c}}resolveWithInteractionReplace($,p,r,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction($,p,r,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable($,p){if(this.h.has($))throw new Error("Variable "+$+" is contributed twice.");this.h.set($,p)}async l($,p,r,c,s){if(I.$Jf(r))return this.m($,p,r,c,s);if(Array.isArray(r))return Promise.all(r.map(i=>this.l($,p,i,c,s)));if(I.$Lf(r)){const i=Object.create(null),o=await Promise.all(Object.keys(r).map(async a=>[await this.m($,p,a,c,s),await this.l($,p,r[a],c,s)]));for(const[a,u]of o)i[a]=u;return i}return r}m($,p,r,c,s){return(0,A.$5e)(r,D.VARIABLE_REGEXP,async(i,o)=>{if(o.includes(D.VARIABLE_LHS))return i;let a=await this.o($,i,o,p,c);return s?.set(o,a),a!==i&&I.$Jf(a)&&a.match(D.VARIABLE_REGEXP)&&(a=await this.m($,p,a,c,s)),a})}n($){return this.b?this.b.getUriLabel($,{noPrefix:!0}):$.fsPath}async o($,p,r,c,s){let i;const o=r.split(":");o.length>1&&(r=o[0],i=o[1]);const a=f=>{const n=this.a.getFilePath();if(n)return(0,m.$Yv)(n);throw new E.$iO(f,(0,h.localize)(0,null,p))},u=f=>{const n=a(f);if(this.a.getWorkspaceFolderPathForFile){const w=this.a.getWorkspaceFolderPathForFile();if(w)return(0,m.$Yv)(w)}throw new E.$iO(f,(0,h.localize)(1,null,p,S.$nc(n)))},t=f=>{if(i){const n=this.a.getFolderUri(i);if(n)return n;throw new E.$iO(f,(0,h.localize)(2,null,p,i))}if(c)return c;throw this.a.getWorkspaceFolderCount()>1?new E.$iO(f,(0,h.localize)(3,null,p)):new E.$iO(f,(0,h.localize)(4,null,p))};switch(r){case"env":if(i){if($.env){const f=$.env[L.$i?i.toLowerCase():i];if(I.$Jf(f))return f}return""}throw new E.$iO(E.VariableKind.Env,(0,h.localize)(5,null,p));case"config":if(i){const f=this.a.getConfigurationValue(c,i);if(I.$Sf(f))throw new E.$iO(E.VariableKind.Config,(0,h.localize)(6,null,p,i));if(I.$Lf(f))throw new E.$iO(E.VariableKind.Config,(0,h.localize)(7,null,p,i));return f}throw new E.$iO(E.VariableKind.Config,(0,h.localize)(8,null,p));case"command":return this.p(E.VariableKind.Command,p,i,s,"command");case"input":return this.p(E.VariableKind.Input,p,i,s,"input");case"extensionInstallFolder":if(i){const f=await this.a.getExtension(i);if(!f)throw new E.$iO(E.VariableKind.ExtensionInstallFolder,(0,h.localize)(9,null,p,i));return this.n(f.extensionLocation)}throw new E.$iO(E.VariableKind.ExtensionInstallFolder,(0,h.localize)(10,null,p));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,m.$Yv)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return c||i?(0,m.$Yv)(this.n(t(E.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$Yv)(S.$nc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if($.userHome)return $.userHome;throw new E.$iO(E.VariableKind.UserHome,(0,h.localize)(11,null,p))}case"lineNumber":{const f=this.a.getLineNumber();if(f)return f;throw new E.$iO(E.VariableKind.LineNumber,(0,h.localize)(12,null,p))}case"selectedText":{const f=this.a.getSelectedText();if(f)return f;throw new E.$iO(E.VariableKind.SelectedText,(0,h.localize)(13,null,p))}case"file":return a(E.VariableKind.File);case"fileWorkspaceFolder":return u(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return S.$nc(u(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return c||i?S.$lc(this.n(t(E.VariableKind.RelativeFile)),a(E.VariableKind.RelativeFile)):a(E.VariableKind.RelativeFile);case"relativeFileDirname":{const f=S.$mc(a(E.VariableKind.RelativeFileDirname));if(c||i){const n=S.$lc(this.n(t(E.VariableKind.RelativeFileDirname)),f);return n.length===0?".":n}return f}case"fileDirname":return S.$mc(a(E.VariableKind.FileDirname));case"fileExtname":return S.$oc(a(E.VariableKind.FileExtname));case"fileBasename":return S.$nc(a(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=S.$nc(a(E.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-S.$oc(f).length)}case"fileDirnameBasename":return S.$nc(S.$mc(a(E.VariableKind.FileDirnameBasename)));case"execPath":{const f=this.a.getExecPath();return f||p}case"execInstallFolder":{const f=this.a.getAppRoot();return f||p}case"pathSeparator":case"/":return S.sep;default:try{const f=i?`${r}:${i}`:r;return this.p(E.VariableKind.Unknown,p,f,s,void 0)}catch{return p}}}}p($,p,r,c,s){if(r&&c){const i=s===void 0?c[r]:c[s+":"+r];if(typeof i=="string")return i;throw new E.$iO($,(0,h.localize)(14,null,p))}return p}}e.$wO=D}),define(Re[104],Ae([1,0,4,102]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dD=e.$cD=e.OpenEditorContext=e.GroupsOrder=e.$bD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$aD=void 0,e.$aD=(0,S.$8h)("editorGroupsService");var I;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var R;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var L;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var m;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var h;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(h||(e.MergeGroupMode=h={}));function E(p){const r=p;return(0,M.$WE)(r?.editor)&&(0,M.$WE)(r?.replacement)}e.$bD=E;var A;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var D;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function l(p){const r=p;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}e.$cD=l;function $(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$dD=$}),define(Re[215],Ae([1,0,4,104]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=e.$hD=e.$gD=e.$fD=e.$eD=void 0,e.$eD=(0,S.$8h)("editorService"),e.$fD=-1,e.$gD=-2,e.$hD=-3;function I(R){const L=R;return typeof R=="number"||(0,M.$cD)(L)}e.$iD=I}),define(Re[216],Ae([1,0,4,183]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HK=void 0,e.$HK=(0,S.$9h)(M.$ci)}),define(Re[105],Ae([1,0,22,5,19,6,11]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i8b=e.$h8b=e.$g8b=e.$f8b=e.$e8b=void 0;class m{constructor(i,o){this.versionId=i,this.removedDueToLooping=o}}e.$e8b=m;class h{static isHostExtension(i,o,a){if(o.getExtensionDescription(i))return!1;const u=a.getExtensionDescription(i);return u?!!((u.main||u.browser)&&u.api==="none"):!1}constructor(i,o){this.j=i,this.c=new M.$Wd,this.onDidChange=this.c.event,this.d=0,this.e=o,this.k()}k(){this.e.sort(r),this.f=new S.$pm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const o=this.j.readActivationEvents(i);for(const a of o)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,o){this.e=c(this.e,o),this.e=this.e.concat(i);const a=h.l(this.e);return this.e=c(this.e,a.map(u=>u.identifier)),this.k(),this.d++,this.c.fire(void 0),new m(this.d,a)}static l(i){const o=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(n){this.d.has(n)||(this.d.add(n),this.e.push(n))}addArc(n,w){this.addNode(n),this.addNode(w),this.c.has(n)?this.c.get(n).push(w):this.c.set(n,[w])}getArcs(n){return this.c.has(n)?this.c.get(n):[]}hasOnlyGoodArcs(n,w){const y=o.getArcs(n);for(let d=0;d<y.length;d++)if(!w.has(y[d]))return!1;return!0}getNodes(){return this.e}},a=new S.$pm;for(const n of i)if(a.set(n.identifier,n),n.extensionDependencies)for(const w of n.extensionDependencies)o.addArc(S.$nm.toKey(n.identifier),S.$nm.toKey(w));const u=new Set;o.getNodes().filter(n=>o.getArcs(n).length===0).forEach(n=>u.add(n));const t=o.getNodes().filter(n=>!u.has(n));let f;do{f=!1;for(let n=0;n<t.length;n++){const w=t[n];o.hasOnlyGoodArcs(w,u)&&(t.splice(n,1),n--,u.add(w),f=!0)}}while(f);return t.map(n=>a.get(n))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const o=this.h.get(i);return o?o.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const o=this.f.get(i);return o||void 0}getExtensionDescriptionByUUID(i){for(const o of this.g)if(o.uuid===i)return o}getExtensionDescriptionByIdOrUUID(i,o){return this.getExtensionDescription(i)??(o?this.getExtensionDescriptionByUUID(o):void 0)}}e.$f8b=h;class E{constructor(i,o){this.versionId=i,this.extensions=o}}e.$g8b=E;class A{constructor(i){this.d=new $,this.c=new h(i,[])}async acquireLock(i){const o=await this.d.acquire(i);return new D(this,o)}deltaExtensions(i,o,a){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(o,a)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,o){return this.c.getExtensionDescriptionByIdOrUUID(i,o)}}e.$h8b=A;class D extends R.$Tc{constructor(i,o){super(),this.f=i,this.c=!1,this.B(o)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$i8b=D;class l{constructor(i){this.name=i;const o=(0,L.$1g)();this.promise=o.promise,this.c=o.resolve}resolve(i){this.c(i)}}class ${constructor(){this.c=[],this.d=!1}async acquire(i){const o=new l(i);return this.c.push(o),this.e(),o.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let o=!0;const a=setTimeout(()=>{o&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),u=()=>{o&&(clearTimeout(a),o=!1,this.d=!1,this.e())};i.resolve((0,R.$Rc)(u))}}var p;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(p||(p={}));function r(s,i){const o=s.isBuiltin?0:s.isUnderDevelopment?2:1,a=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(o!==a)return o-a;const u=I.$gc.basename(s.extensionLocation.path),t=I.$gc.basename(i.extensionLocation.path);return u<t?-1:u>t?1:0}function c(s,i){const o=new S.$om(i);return s.filter(a=>!o.has(a.identifier))}}),define(Re[77],Ae([1,0,23]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$wm=e.$vm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(M||(e.UIKind=M={}));var I;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var R;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function L(E){const A=S.$ke.alloc(1);switch(E){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$vm=L;function m(E,A){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$wm=m;var h;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(h||(e.NativeLogMarkers=h={}))}),define(Re[60],Ae([1,0,4,5,13,27,77,56,57,26,2,6,164]),function(me,e,S,M,I,R,L,m,h,E,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PN=e.$ON=e.$NN=e.$MN=void 0;let $=class extends D.$Tc{constructor(s,i){super(),this.s=s,this.t=i,this.a=this.B(new M.$Wd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Wd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:h.$So,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(o=>{(0,I.$rj)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,i,o){const a=this.getTelemetryDetails(),u=new p(i,o,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,u]),u.apiTelemetryLogger}$initializeTelemetryLevel(s,i,o){this.f=s,this.g=i,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const i=Object.create(null);switch(i["common.extname"]=`${s.publisher}.${s.name}`,i["common.extversion"]=s.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case L.UIKind.Web:i["common.uikind"]="web";break;case L.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,m.$dl)((0,h.$Yo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const i=this.getTelemetryDetails();this.r.forEach((o,a)=>{const u=o.filter(t=>!t.isDisposed);u.length===0?this.r.delete(a):this.r.set(a,u)}),this.r.forEach(o=>{for(const a of o)a.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,i){const a=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!a)return this.r.delete(s.value),!1;let u=!1;for(const t of a)t.ignoreUnhandledExtHostErrors||(t.logError(i),u=!0);return u}};e.$MN=$,e.$MN=$=Ke([Ve(0,R.$LN),Ve(1,I.$qj)],$);class p{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,i,o,a,u,t,f){this.g=o,this.h=a,this.i=u,this.j=t,this.a=new M.$Wd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(s,i){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let i="properties"in s?s.properties??{}:s;return i=(0,h.$2o)(i,[]),this.c&&(i=(0,E.$Bn)(i,this.c)),this.b||(i=(0,E.$Bn)(i,this.j)),"properties"in s?s.properties=i:s=i,s}k(s,i){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(s,i),this.h.trace(s,i))}logUsage(s,i){this.d.isUsageEnabled&&this.k(s,i)}logError(s,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,i);else{const o={name:s.name,message:s.message,stack:s.stack,cause:s.cause},a=(0,h.$2o)(o,[]),u=new Error(a.message,{cause:a.cause});u.stack=a.stack,u.name=a.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(u,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const s=this,i={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$NN=p;function r(c){const s=Date.now()-new Date(c).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$ON=r,e.$PN=(0,S.$8h)("IExtHostTelemetry")}),define(Re[24],Ae([1,0,5,2,192,101,22,4]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QF=e.$PF=e.$OF=e.ActivationKind=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.ExtensionHostStartup=e.$IF=e.$HF=e.$GF=e.$FF=void 0,e.$FF=Object.freeze({identifier:new L.$nm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$GF="extensions.webWorker",e.$HF=(0,m.$8h)("extensionService");class h{constructor(u){this.dependency=u}}e.$IF=h;var E;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(u,t,f){this.c=u,this.d=t.slice(0),this.e=f.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$qF.createActivationEventsMap(this.d)}}set(u,t,f){if(this.c>u)throw new Error(`ExtensionHostExtensions: invalid versionId ${u} (current: ${this.c})`);const n=[],w=[],y=[],d=[],b=D(this.d),P=D(t),g=(G,q)=>G.extensionLocation.toString()===q.extensionLocation.toString()||G.isBuiltin===q.isBuiltin||G.isUserBuiltin===q.isUserBuiltin||G.isUnderDevelopment===q.isUnderDevelopment;for(const G of this.d){const q=P.get(G.identifier);if(!q){n.push(G.identifier),b.delete(G.identifier);continue}if(!g(G,q)){n.push(G.identifier),b.delete(G.identifier);continue}}for(const G of t){const q=b.get(G.identifier);if(!q){w.push(G);continue}if(!g(q,G)){n.push(q.identifier),b.delete(q.identifier);continue}}const v=new L.$om(this.e),k=new L.$om(f);for(const G of this.e)k.has(G)||y.push(G);for(const G of f)v.has(G)||d.push(G);const F=R.$qF.createActivationEventsMap(w),O={versionId:u,toRemove:n,toAdd:w,addActivationEvents:F,myToRemove:y,myToAdd:d};return this.delta(O),O}delta(u){if(this.c>=u.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:n,myToAdd:w}=u,y=new L.$om(t),d=new L.$om(n);for(let b=0;b<this.d.length;b++)y.has(this.d[b].identifier)&&(this.d.splice(b,1),b--);for(let b=0;b<this.e.length;b++)d.has(this.e[b])&&(this.e.splice(b,1),b--);for(const b of f)this.d.push(b);for(const b of w)this.e.push(b);return this.f=null,u}containsExtension(u){for(const t of this.e)if(L.$nm.equals(t,u))return!0;return!1}containsActivationEvent(u){return this.f||(this.f=this.g()),this.f.has(u)}g(){const u=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const f=R.$qF.readActivationEvents(t);for(const n of f)u.add(n)}return u}}e.$JF=A;function D(a){const u=new L.$pm;for(const t of a)u.set(t.identifier,t);return u}function l(a,u){return a.enabledApiProposals?a.enabledApiProposals.includes(u):!1}e.$KF=l;function $(a,u){if(!l(a,u))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.$LF=$;class p{constructor(u,t,f,n){this.codeLoadingTime=u,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=n}}e.$MF=p;class r{constructor(u,t){this.description=u,this.value=t}}e.$NF=r;var c;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(c||(e.ActivationKind=c={}));function s(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,I.$8o)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.$OF=s;function i(a,u){return{identifier:new L.$nm((0,I.$6o)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!u,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform}}e.$PF=i;class o{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activateById(u,t){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(u,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$QF=o}),define(Re[217],Ae([1,0,15,105,22,24,13,11]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=e.$Tgc=e.$Sgc=e.$Rgc=e.$Qgc=void 0;class h{static{this.NONE=new h(!1,-1,-1,-1)}constructor(s,i,o,a){this.startup=s,this.codeLoadingTime=i,this.activateCallTime=o,this.activateResolvedTime=a}}e.$Qgc=h;class E{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,i){return s===-1||i===-1?-1:i-s}build(){return new h(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Rgc=E;class A{constructor(s,i,o,a,u,t){this.activationFailed=s,this.activationFailedError=i,this.activationTimes=o,this.module=a,this.exports=u,this.subscriptions=t}}e.$Sgc=A;class D extends A{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Tgc=D;class l extends A{constructor(){super(!1,null,h.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Ugc=l;class $ extends A{constructor(s){super(!0,s,h.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(s,i,o,a){this.g=a,this.a=s,this.b=i,this.c=o,this.d=new I.$pm,this.f=Object.create(null)}dispose(){for(const[s,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const s=[];for(const[i,o]of this.d)s.push(o.wait());await Promise.all(s)}isActivated(s){const i=this.d.get(s);return!!(i&&i.value)}getActivatedExtension(s){const i=this.d.get(s);if(!i||!i.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return i.value}async activateByEvent(s,i){if(this.f[s])return;const o=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(o.map(a=>({id:a.identifier,reason:{startup:i,extensionId:a.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,i){const o=this.a.getExtensionDescription(s);if(!o)throw new Error(`Extension '${s}' is not known`);return this.h([{id:o.identifier,reason:i}])}async h(s){const i=s.filter(o=>!this.isActivated(o.id)).map(o=>this.j(o));await Promise.all(i.map(o=>o.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const i=this.a.getExtensionDescription(s.id);if(!i){const u=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new $(u));return this.c.onExtensionActivationError(s.id,u,new R.$IF(s.id.value)),t}const o=[],a=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const u of a){if(this.m(u))continue;const t=this.d.get(u);if(t){o.push(t);continue}if(this.l(u)){o.push(this.j({id:this.b.getExtensionDescription(u).identifier,reason:s.reason}));continue}const f=this.a.getExtensionDescription(u);if(f){if(!f.main&&!f.browser)continue;o.push(this.j({id:f.identifier,reason:s.reason}));continue}const n=i.displayName||i.identifier.value,w=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${u}'`),y=this.k(s,i.displayName,[],new $(w));return this.c.onExtensionActivationError(i.identifier,w,new R.$IF(u)),y}return this.k(s,i.displayName,o,null)}k(s,i,o,a){const u=new r(s.id,i,s.reason,o,a,this.c,this.g);return this.d.set(s.id,u),u}l(s){return M.$f8b.isHostExtension(s,this.a,this.b)}m(s){const i=this.b.getExtensionDescription(s);return i?!i.main&&!i.browser:!1}};e.$Vgc=p,e.$Vgc=p=Ke([Ve(3,L.$pj)],p);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,i,o,a,u,t,f){this.c=s,this.d=i,this.f=o,this.g=a,this.h=u,this.j=t,this.k=f,this.a=new m.$7g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const i=this.g[s];if(i.value&&!i.value.activationFailed){this.g.splice(s,1),s--;continue}if(i.value&&i.value.activationFailed){const o=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);o.detail=i.value.activationFailedError,this.h=new $(o),this.j.onExtensionActivationError(this.c,o,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const i=new Error;if(s&&s.name&&(i.name=s.name),s&&s.message?i.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(i.stack=s.stack),this.h=new $(i),this.b&&S.$4(s))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};r=Ke([Ve(6,L.$pj)],r)}),define(Re[218],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Re[219],Ae([1,0,178,15,32,96,72,30,22,218,188,101]),function(me,e,S,M,I,R,L,m,h,E,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=void 0;const l=m.$Kn.as(L.$Ln.JSONContribution);class ${constructor(u,t,f){this.a=u,this.b=t,this.c=f}d(u,t){this.a({type:u,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(u){this.d(I.default.Error,u)}warn(u){this.d(I.default.Warning,u)}info(u){this.d(I.default.Info,u)}}e.$zF=$;class p{static a(u){const t=new h.$om;for(let f=0,n=u.length;f<n;f++)t.add(u[f].description.identifier);return t}static compute(u,t){if(!u||!u.length)return new p(t,[]);if(!t||!t.length)return new p([],u);const f=this.a(u),n=this.a(t),w=t.filter(d=>!f.has(d.description.identifier)),y=u.filter(d=>!n.has(d.description.identifier));return new p(w,y)}constructor(u,t){this.added=u,this.removed=t}}e.$AF=p;class r{constructor(u,t){this.name=u,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(u){if(this.a!==null)throw new Error("Handler already set!");this.a=u,this.d()}acceptUsers(u){this.c=p.compute(this.b,u),this.b=u,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(u){(0,M.$1)(u)}}}e.$BF=r;const c={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(0,null),S.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$CF={properties:{engines:{type:"object",description:S.localize(2,null),properties:{vscode:{type:"string",description:S.localize(3,null),default:"^1.22.0"}}},publisher:{description:S.localize(4,null),type:"string"},displayName:{description:S.localize(5,null),type:"string"},categories:{description:S.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:h.$mm},{type:"string",const:"Languages",deprecationMessage:S.localize(7,null)}]}},galleryBanner:{type:"object",description:S.localize(8,null),properties:{color:{description:S.localize(9,null),type:"string"},theme:{description:S.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(13,null)},enabledApiProposals:{markdownDescription:S.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:S.localize(15,null),type:"string",enum:["none"],enumDescriptions:[S.localize(16,null)]},activationEvents:{description:S.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(32,null)},{label:"onUri",body:"onUri",description:S.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(37,null)},{label:"onRenderer",description:S.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:S.localize(42,null)},{label:"*",description:S.localize(43,null),body:"*"}]}},badges:{type:"array",description:S.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(45,null)},href:{type:"string",description:S.localize(46,null)},description:{type:"string",description:S.localize(47,null)}}}},markdown:{type:"string",description:S.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$po}},extensionPack:{description:S.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$po}},extensionKind:{description:S.localize(52,null),type:"array",items:c,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(53,null)},{body:["workspace"],description:S.localize(54,null)},{body:["ui","workspace"],description:S.localize(55,null)},{body:["workspace","ui"],description:S.localize(56,null)},{body:[],description:S.localize(57,null)}]},capabilities:{description:S.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(61,null),S.localize(62,null),S.localize(63,null)]},description:{type:"string",markdownDescription:S.localize(64,null)}}},untrustedWorkspaces:{description:S.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(67,null),S.localize(68,null),S.localize(69,null)]},restrictedConfigurations:{description:S.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(71,null)}}}}},sponsor:{description:S.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(74,null),type:"string"},"vscode:uninstall":{description:S.localize(75,null),type:"string"}}},icon:{type:"string",description:S.localize(76,null)},l10n:{type:"string",description:S.localize(77,null)},pricing:{type:"string",markdownDescription:S.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(u){if(this.a.has(u.extensionPoint))throw new Error("Duplicate extension point: "+u.extensionPoint);const t=new r(u.extensionPoint,u.defaultExtensionKind);return this.a.set(u.extensionPoint,t),u.activationEventsGenerator&&D.$qF.register(u.extensionPoint,u.activationEventsGenerator),e.$CF.properties.contributes.properties[u.extensionPoint]=u.jsonSchema,l.registerSchema(s,e.$CF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$DF=i;const o={ExtensionsRegistry:"ExtensionsRegistry"};m.$Kn.add(o.ExtensionsRegistry,new i),e.$EF=m.$Kn.as(o.ExtensionsRegistry),l.registerSchema(s,e.$CF),l.registerSchema(A.$Ij,{properties:{extensionEnabledApiProposals:{description:S.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Re[220],Ae([1,0,174,16,26,219,35,5]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CG=void 0;const h={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(2,null),default:""}}};var E;(function(l){function $(p,r,c){if(!p)return;const s=M.$Jf(p.type)?p.type:void 0;if(!s||s.length===0){c.error(S.localize(3,null));return}const i=[];if(Array.isArray(p.required))for(const o of p.required)M.$Jf(o)&&i.push(o);return{extensionId:r.value,taskType:s,required:i,properties:p.properties?I.$yn(p.properties):{},when:p.when?L.$6i.deserialize(p.when):void 0}}l.from=$})(E||(E={}));const A=R.$EF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,$)=>{for(const p of l)p.type&&$.push(`onTaskType:${p.type}`)},jsonSchema:{description:S.localize(4,null),type:"array",items:h}});class D{constructor(){this.d=new m.$Wd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise(($,p)=>{A.setHandler((r,c)=>{this.c=void 0;try{for(const s of c.removed){const i=s.value;for(const o of i)this.a&&o.type&&this.a[o.type]&&delete this.a[o.type]}for(const s of c.added){const i=s.value;for(const o of i){const a=E.from(o,s.description.identifier,s.collector);a&&(this.a[a.taskType]=a)}}(c.removed.length>0||c.added.length>0)&&this.d.fire()}catch{}$(void 0)})})}onReady(){return this.b}get($){return this.a[$]}all(){return Object.keys(this.a).map($=>this.a[$])}getJsonSchema(){if(this.c===void 0){const $=[];for(const p of this.all()){const r={type:"object",additionalProperties:!1};p.required.length>0&&(r.required=p.required.slice(0)),p.properties!==void 0?r.properties=I.$yn(p.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[p.taskType]},$.push(r)}this.c={oneOf:$}}return this.c}}e.$CG=new D}),define(Re[221],Ae([1,0,175,16,25,26,35,220]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$MG=e.JsonSchemaVersion=e.ExecutionEngine=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$GG=e.ShellQuoting=e.$FG=e.$EG=e.$DG=void 0,e.$DG="settings",e.$EG=new L.$mj("taskRunning",!1,S.localize(0,null)),e.$FG=S.localize2(2,"Tasks");var h;(function(C){C[C.Escape=1]="Escape",C[C.Strong=2]="Strong",C[C.Weak=3]="Weak"})(h||(e.ShellQuoting=h={})),e.$GG="$customized",function(C){function N(W){if(!W)return C.Strong;switch(W.toLowerCase()){case"escape":return C.Escape;case"strong":return C.Strong;case"weak":return C.Weak;default:return C.Strong}}C.from=N}(h||(e.ShellQuoting=h={}));var E;(function(C){C.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var A;(function(C){C[C.Always=1]="Always",C[C.Silent=2]="Silent",C[C.Never=3]="Never"})(A||(e.RevealKind=A={})),function(C){function N(W){switch(W.toLowerCase()){case"always":return C.Always;case"silent":return C.Silent;case"never":return C.Never;default:return C.Always}}C.fromString=N}(A||(e.RevealKind=A={}));var D;(function(C){C[C.Never=1]="Never",C[C.OnProblem=2]="OnProblem",C[C.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(C){function N(W){switch(W.toLowerCase()){case"always":return C.Always;case"never":return C.Never;case"onproblem":return C.OnProblem;default:return C.OnProblem}}C.fromString=N}(D||(e.RevealProblemKind=D={}));var l;(function(C){C[C.Shared=1]="Shared",C[C.Dedicated=2]="Dedicated",C[C.New=3]="New"})(l||(e.PanelKind=l={})),function(C){function N(W){switch(W.toLowerCase()){case"shared":return C.Shared;case"dedicated":return C.Dedicated;case"new":return C.New;default:return C.Shared}}C.fromString=N}(l||(e.PanelKind=l={}));var $;(function(C){C.defaults={echo:!0,reveal:A.Always,revealProblems:D.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})($||(e.PresentationOptions=$={}));var p;(function(C){C[C.Shell=1]="Shell",C[C.Process=2]="Process",C[C.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(C){function N(se){switch(se.toLowerCase()){case"shell":return C.Shell;case"process":return C.Process;case"customExecution":return C.CustomExecution;default:return C.Process}}C.fromString=N;function W(se){switch(se){case C.Shell:return"shell";case C.Process:return"process";case C.CustomExecution:return"customExecution";default:return"process"}}C.toString=W}(p||(e.RuntimeType=p={}));var r;(function(C){function N(W){return M.$Jf(W)?W:W.value}C.value=N})(r||(e.CommandString=r={}));var c;(function(C){C.Clean={_id:"clean",isDefault:!1},C.Build={_id:"build",isDefault:!1},C.Rebuild={_id:"rebuild",isDefault:!1},C.Test={_id:"test",isDefault:!1};function N(se){return se===C.Clean._id||se===C.Build._id||se===C.Rebuild._id||se===C.Test._id}C.is=N;function W(se){if(se!==void 0)return M.$Jf(se)?N(se)?{_id:se,isDefault:!1}:void 0:se}C.from=W})(c||(e.TaskGroup=c={}));var s;(function(C){C[C.Global=1]="Global",C[C.Workspace=2]="Workspace",C[C.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var i;(function(C){C.Workspace="workspace",C.Extension="extension",C.InMemory="inMemory",C.WorkspaceFile="workspaceFile",C.User="user";function N(W){switch(W){case C.User:return 2;case C.WorkspaceFile:return 5;default:return 6}}C.toConfigurationTarget=N})(i||(e.TaskSourceKind=i={}));var o;(function(C){C.parallel="parallel",C.sequence="sequence"})(o||(e.DependsOrder=o={}));var a;(function(C){C[C.default=1]="default",C[C.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var u;(function(C){C.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(u||(e.RunOptions=u={}));class t{constructor(N,W,se,le,Ee,De){this._label="",this._id=N,W&&(this._label=W),se&&(this.type=se),this.runOptions=le,this.configurationProperties=Ee,this._source=De}getDefinition(N){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,W=!1){if(N===void 0)return!1;if(M.$Jf(N))return N===this._label||N===this.configurationProperties.identifier||W&&N===this._id;const se=this.getDefinition(!0);return se!==void 0&&se._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$HG=t;class f extends t{constructor(N,W,se,le,Ee,De,ce,pe){super(N,se,void 0,ce,pe,W),this.command={},this._source=W,this.hasDefinedMatchers=De,Ee&&(this.command=Ee)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case p.Shell:W="shell";break;case p.Process:W="process";break;case p.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(N){return N instanceof f}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$DG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const N=this.d();if(!N)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const se={type:e.$GG,folder:N,id:W};return JSON.stringify(se)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Fg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new f(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$IG=f;class n extends t{constructor(N,W,se,le,Ee,De,ce){super(N,se,le,De,ce,W),this._source=W,this.configures=Ee}static is(N){return N instanceof n}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Fg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$DG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const N=this.d();if(!N)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const se={type:e.$GG,folder:N,id:W};return JSON.stringify(se)}}e.$JG=n;class w extends t{constructor(N,W,se,le,Ee,De,ce,pe,oe){super(N,se,le,pe,oe,W),this.defines=Ee,this.hasDefinedMatchers=ce,this.command=De,this.icon=oe.icon,this.hide=oe.hide}clone(){return new w(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof w}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new w(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$KG=w;class y extends t{constructor(N,W,se,le,Ee,De){super(N,se,le,Ee,De,W),this._source=W}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new y(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$LG=y;var d;(function(C){C[C.Process=1]="Process",C[C.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(C){C._default=C.Terminal}(d||(e.ExecutionEngine=d={}));var b;(function(C){C[C.V0_1_0=1]="V0_1_0",C[C.V2_0_0=2]="V2_0_0"})(b||(e.JsonSchemaVersion=b={}));class P{constructor(N){this.c=new Map;for(let W=0;W<N.length;W++)this.c.set(N[W].uri.toString(),W)}compare(N,W){const se=N.getWorkspaceFolder(),le=W.getWorkspaceFolder();if(se&&le){let Ee=this.c.get(se.uri.toString());Ee=Ee===void 0?0:Ee+1;let De=this.c.get(le.uri.toString());return De=De===void 0?0:De+1,Ee===De?N._label.localeCompare(W._label):Ee-De}else return!se&&le?-1:se&&!le?1:0}}e.$MG=P;var g;(function(C){C.DependsOnStarted="dependsOnStarted",C.AcquiredInput="acquiredInput",C.Start="start",C.ProcessStarted="processStarted",C.Active="active",C.Inactive="inactive",C.Changed="changed",C.Terminated="terminated",C.ProcessEnded="processEnded",C.End="end"})(g||(e.TaskEventKind=g={}));var v;(function(C){C.SingleRun="singleRun",C.Background="background"})(v||(e.TaskRunType=v={}));var k;(function(C){C[C.System=0]="System",C[C.User=1]="User",C[C.FolderOpen=2]="FolderOpen",C[C.ConfigurationChange=3]="ConfigurationChange",C[C.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var F;(function(C){function N(pe){return{taskId:pe._id,taskName:pe.configurationProperties.name,runType:pe.configurationProperties.isBackground?"background":"singleRun",group:pe.configurationProperties.group,__task:pe}}function W(pe,oe,$e){return{...N(pe),kind:"start",terminalId:oe,resolvedVariables:$e}}C.start=W;function se(pe,oe,$e){return{...N(pe),kind:"processStarted",terminalId:oe,processId:$e}}C.processStarted=se;function le(pe,oe,$e){return{...N(pe),kind:"processEnded",terminalId:oe,exitCode:$e}}C.processEnded=le;function Ee(pe,oe,$e){return{...N(pe),kind:"terminated",exitReason:$e,terminalId:oe}}C.terminated=Ee;function De(pe,oe,$e){return{...N(oe),kind:pe,terminalId:$e}}C.general=De;function ce(){return{kind:"changed"}}C.changed=ce})(F||(e.TaskEvent=F={}));var O;(function(C){function N(se){const le=Object.keys(se).sort();let Ee="";for(const De of le){let ce=se[De];ce instanceof Object?ce=N(ce):typeof ce=="string"&&(ce=ce.replace(/,/g,",,")),Ee+=De+","+ce+","}return Ee}function W(se){const Ee={_key:N(se),type:se.taskType};return Object.assign(Ee,se),Ee}C.create=W})(O||(e.KeyedTaskIdentifier=O={}));var G;(function(C){C.AutoDetect="task.autoDetect",C.SaveBeforeRun="task.saveBeforeRun",C.ShowDecorations="task.showDecorations",C.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",C.SlowProviderWarning="task.slowProviderWarning",C.QuickOpenHistory="task.quickOpen.history",C.QuickOpenDetail="task.quickOpen.detail",C.QuickOpenSkip="task.quickOpen.skip",C.QuickOpenShowAll="task.quickOpen.showAll",C.AllowAutomaticTasks="task.allowAutomaticTasks",C.Reconnection="task.reconnection",C.VerboseLogging="task.verboseLogging"})(G||(e.TaskSettingId=G={}));var q;(function(C){C.Tasks="tasks",C.SuppressTaskName="tasks.suppressTaskName",C.Windows="tasks.windows",C.Osx="tasks.osx",C.Linux="tasks.linux",C.ShowOutput="tasks.showOutput",C.IsShellCommand="tasks.isShellCommand",C.ServiceTestSetting="tasks.service.testSetting"})(q||(e.TasksSchemaProperties=q={}));var U;(function(C){function N(W,se){const le=m.$CG.get(W.type);if(le===void 0){const pe=R.$yn(W);return delete pe._key,O.create(pe)}const Ee=Object.create(null);Ee.type=le.taskType;const De=new Set;le.required.forEach(pe=>De.add(pe));const ce=le.properties;for(const pe of Object.keys(ce)){const oe=W[pe];if(oe!=null)Ee[pe]=oe;else if(De.has(pe)){const $e=ce[pe];if($e.default!==void 0)Ee[pe]=R.$yn($e.default);else switch($e.type){case"boolean":Ee[pe]=!1;break;case"number":case"integer":Ee[pe]=0;break;case"string":Ee[pe]="";break;default:se.error(S.localize(1,null,JSON.stringify(W,void 0,0),pe));return}}}return O.create(Ee)}C.createTaskIdentifier=N})(U||(e.TaskDefinition=U={}))}),define(Re[222],Ae([1,0,15]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k8b=e.$j8b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,m)=>{this.b=L,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,S.$1)(L))}then(L,m){return this.j().then(L,m)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$j8b=M;class I extends M{constructor(){super(),this.h=!0,this.i=new S.$5}}e.$k8b=I}),define(Re[50],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vv=e.$Uv=e.$Tv=e.$Sv=void 0;class S{static{this.count=0}constructor(h){this._proxyIdentifierBrand=void 0,this.sid=h,this.nid=++S.count}}e.$Sv=S;const M=[];function I(m){const h=new S(m);return M[h.nid]=h,h}e.$Tv=I;function R(m){return M[m].sid}e.$Uv=R;class L{constructor(h){this.value=h}}e.$Vv=L}),define(Re[3],Ae([1,0,50]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lL=e.$kL=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$jL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var I;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput"})(I||(e.TabInputKind=I={}));var R;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var L;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var m;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var h;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(h||(e.CellOutputKind=h={}));var E;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var A;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class D{static{this.a=0}static mixin(c){return c._id=D.a++,c}}e.$jL=D;var l;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var $;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})($||(e.ISuggestResultDtoField=$={}));var p;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$kL={MainThreadAuthentication:(0,S.$Tv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.$Tv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,S.$Tv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,S.$Tv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,S.$Tv)("MainThreadChatVariables"),MainThreadClipboard:(0,S.$Tv)("MainThreadClipboard"),MainThreadCommands:(0,S.$Tv)("MainThreadCommands"),MainThreadComments:(0,S.$Tv)("MainThreadComments"),MainThreadConfiguration:(0,S.$Tv)("MainThreadConfiguration"),MainThreadConsole:(0,S.$Tv)("MainThreadConsole"),MainThreadDebugService:(0,S.$Tv)("MainThreadDebugService"),MainThreadDecorations:(0,S.$Tv)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.$Tv)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.$Tv)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.$Tv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.$Tv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.$Tv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.$Tv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.$Tv)("MainThreadEditorTabs"),MainThreadErrors:(0,S.$Tv)("MainThreadErrors"),MainThreadTreeViews:(0,S.$Tv)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.$Tv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,S.$Tv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.$Tv)("MainThreadLanguages"),MainThreadLogger:(0,S.$Tv)("MainThreadLogger"),MainThreadMessageService:(0,S.$Tv)("MainThreadMessageService"),MainThreadOutputService:(0,S.$Tv)("MainThreadOutputService"),MainThreadProgress:(0,S.$Tv)("MainThreadProgress"),MainThreadQuickDiff:(0,S.$Tv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.$Tv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.$Tv)("MainThreadStatusBar"),MainThreadSecretState:(0,S.$Tv)("MainThreadSecretState"),MainThreadStorage:(0,S.$Tv)("MainThreadStorage"),MainThreadSpeech:(0,S.$Tv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,S.$Tv)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.$Tv)("MainThreadTerminalService"),MainThreadWebviews:(0,S.$Tv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.$Tv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.$Tv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.$Tv)("MainThreadCustomEditors"),MainThreadUrls:(0,S.$Tv)("MainThreadUrls"),MainThreadUriOpeners:(0,S.$Tv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.$Tv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.$Tv)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.$Tv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,S.$Tv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,S.$Tv)("MainThreadExtensionService"),MainThreadSCM:(0,S.$Tv)("MainThreadSCM"),MainThreadSearch:(0,S.$Tv)("MainThreadSearch"),MainThreadShare:(0,S.$Tv)("MainThreadShare"),MainThreadTask:(0,S.$Tv)("MainThreadTask"),MainThreadWindow:(0,S.$Tv)("MainThreadWindow"),MainThreadLabelService:(0,S.$Tv)("MainThreadLabelService"),MainThreadNotebook:(0,S.$Tv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.$Tv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.$Tv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.$Tv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.$Tv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.$Tv)("MainThreadInteractive"),MainThreadChat:(0,S.$Tv)("MainThreadChat"),MainThreadInlineChat:(0,S.$Tv)("MainThreadInlineChatShape"),MainThreadTheming:(0,S.$Tv)("MainThreadTheming"),MainThreadTunnelService:(0,S.$Tv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.$Tv)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.$Tv)("MainThreadTimeline"),MainThreadTesting:(0,S.$Tv)("MainThreadTesting"),MainThreadLocalization:(0,S.$Tv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.$Tv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.$Tv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,S.$Tv)("MainThreadIssueReporter")},e.$lL={ExtHostCommands:(0,S.$Tv)("ExtHostCommands"),ExtHostConfiguration:(0,S.$Tv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.$Tv)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.$Tv)("ExtHostDebugService"),ExtHostDecorations:(0,S.$Tv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.$Tv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.$Tv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.$Tv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.$Tv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.$Tv)("ExtHostEditors"),ExtHostTreeViews:(0,S.$Tv)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.$Tv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.$Tv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.$Tv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.$Tv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.$Tv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.$Tv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.$Tv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.$Tv)("ExtHostStatusBar"),ExtHostShare:(0,S.$Tv)("ExtHostShare"),ExtHostExtensionService:(0,S.$Tv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.$Tv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.$Tv)("ExtHostTerminalService"),ExtHostSCM:(0,S.$Tv)("ExtHostSCM"),ExtHostSearch:(0,S.$Tv)("ExtHostSearch"),ExtHostTask:(0,S.$Tv)("ExtHostTask"),ExtHostWorkspace:(0,S.$Tv)("ExtHostWorkspace"),ExtHostWindow:(0,S.$Tv)("ExtHostWindow"),ExtHostWebviews:(0,S.$Tv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.$Tv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.$Tv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.$Tv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.$Tv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.$Tv)("ExtHostEditorTabs"),ExtHostProgress:(0,S.$Tv)("ExtHostProgress"),ExtHostComments:(0,S.$Tv)("ExtHostComments"),ExtHostSecretState:(0,S.$Tv)("ExtHostSecretState"),ExtHostStorage:(0,S.$Tv)("ExtHostStorage"),ExtHostUrls:(0,S.$Tv)("ExtHostUrls"),ExtHostUriOpeners:(0,S.$Tv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.$Tv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.$Tv)("ExtHostOutputService"),ExtHostLabelService:(0,S.$Tv)("ExtHostLabelService"),ExtHostNotebook:(0,S.$Tv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.$Tv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.$Tv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.$Tv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.$Tv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.$Tv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.$Tv)("ExtHostInteractive"),ExtHostInlineChat:(0,S.$Tv)("ExtHostInlineChatShape"),ExtHostChat:(0,S.$Tv)("ExtHostChat"),ExtHostChatAgents2:(0,S.$Tv)("ExtHostChatAgents"),ExtHostChatVariables:(0,S.$Tv)("ExtHostChatVariables"),ExtHostChatProvider:(0,S.$Tv)("ExtHostChatProvider"),ExtHostSpeech:(0,S.$Tv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,S.$Tv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.$Tv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.$Tv)("ExtHostTheming"),ExtHostTunnelService:(0,S.$Tv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.$Tv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.$Tv)("ExtHostAuthentication"),ExtHostTimeline:(0,S.$Tv)("ExtHostTimeline"),ExtHostTesting:(0,S.$Tv)("ExtHostTesting"),ExtHostTelemetry:(0,S.$Tv)("ExtHostTelemetry"),ExtHostLocalization:(0,S.$Tv)("ExtHostLocalization"),ExtHostIssueReporter:(0,S.$Tv)("ExtHostIssueReporter")}}),define(Re[78],Ae([1,0,4,13,3,17]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=e.$igc=e.$hgc=void 0,e.$hgc=(0,S.$8h)("IExtHostApiDeprecationService");let L=class{constructor(h,E){this.c=E,this.a=new Set,this.b=h.getProxy(I.$kL.MainThreadTelemetry)}report(h,E,A){const D=this.d(h,E);this.a.has(D)||(this.a.add(D),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${h}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:h}))}d(h,E){return`${h}-${E.identifier.value}`}};e.$igc=L,e.$igc=L=Ke([Ve(0,R.$vN),Ve(1,M.$pj)],L),e.$jgc=Object.freeze(new class{report(m,h,E){}})}),define(Re[223],Ae([1,0,68,6,3]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=void 0;class R{static{this.a=0}constructor(h,E){this.extension=h,this.provider=E,this.handle=R.a++}}class L{static{this.a=0}constructor(h){this.b=new Map,this.c=new Map,this.d=h.getProxy(I.$kL.MainThreadChat)}registerChatProvider(h,E,A){const D=new R(h,A);return this.b.set(D.handle,D),this.d.$registerChatProvider(D.handle,E),(0,M.$Rc)(()=>{this.d.$unregisterChatProvider(D.handle),this.b.delete(D.handle)})}transferChatSession(h,E){const A=S.Iterable.find(this.c.keys(),D=>this.c.get(D)===h)??0;typeof A=="number"&&this.d.$transferChatSession(A,E)}sendInteractiveRequestToProvider(h,E){this.d.$sendRequestToProvider(h,E)}async $prepareChat(h,E){const A=this.b.get(h);if(!A)return;const D=await A.provider.prepareSession(E);if(!D)return;const l=L.a++;return this.c.set(l,D),{id:l,requesterUsername:D.requester?.name,requesterAvatarIconUri:D.requester?.icon,responderUsername:D.responder?.name,responderAvatarIconUri:D.responder?.icon,inputPlaceholder:D.inputPlaceholder}}$releaseSession(h){this.c.delete(h)}}e.$ogc=L}),define(Re[224],Ae([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;class M{constructor(R){const L=R.getProxy(S.$kL.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(m){return L.$writeText(m)}})}}e.$sgc=M}),define(Re[225],Ae([1,0,26,3,27,17]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=void 0;let L=class{constructor(A,D){this.a=A.getProxy(M.$kL.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,D){const l=this,$=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){l.e(A,D,$,arguments)}})}e(A,D,l,$){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:h($,this.b)}),this.c&&this.f(A,l,$)}};e.$jic=L,e.$jic=L=Ke([Ve(0,R.$vN),Ve(1,I.$LN)],L);const m=1e5;function h(E,A){const D=[];if(E.length)for(let l=0;l<E.length;l++){let $=E[l];if(typeof $>"u")$="undefined";else if($ instanceof Error){const p=$;p.stack?$=p.stack:$=p.toString()}D.push($)}if(A){const l=new Error().stack;l&&D.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,S.$Dn)(D);return l.length>m?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Re[226],Ae([1,0,2,3,24]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=void 0;class R{constructor(m){this.a=m.getProxy(M.$kL.MainThreadDialogs)}showOpenDialog(m,h){return h?.allowUIResources&&(0,I.$LF)(m,"showLocal"),this.a.$showOpenDialog(h).then(E=>E?E.map(A=>S.URI.revive(A)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(h=>h?S.URI.revive(h):void 0)}}e.$nhc=R}),define(Re[227],Ae([1,0,6,3]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=void 0;class I{constructor(L){this.b=0,this.a=L.getProxy(M.$kL.MainThreadLabelService)}$registerResourceLabelFormatter(L){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,L),(0,S.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$Ihc=I}),define(Re[79],Ae([1,0,20,14,2,4,13,3,27,17]),function(me,e,S,M,I,R,L,m,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=e.$8gc=void 0;let A=class{constructor(l,$,p){this.f=p,this.d=new Map,this.a=$.getProxy(m.$kL.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===S.$g}getMessage(l,$){const{message:p,args:r,comment:c}=$;if(this.c)return(0,M.$Me)(p,r??{});let s=p;c&&c.length>0&&(s+=`/${Array.isArray(c)?c.join(""):c}`);const i=this.d.get(l)?.contents[s];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,M.$Me)(i??p,r??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let $;const p=await this.g(l);if(!p){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(p),c=JSON.parse(r);$=l.isBuiltin?c.contents?.bundle:c}catch(r){this.f.error(`Failed to load translations for ${l.identifier.value} from ${p}: ${r.message}`);return}$&&this.d.set(l.identifier.value,{contents:$,uri:p})}async g(l){if(l.isBuiltin){const $=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return I.URI.revive($)}return l.l10n?I.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$8gc=A,e.$8gc=A=Ke([Ve(0,h.$LN),Ve(1,E.$vN),Ve(2,L.$pj)],A),e.$9gc=(0,R.$8h)("IExtHostLocalizationService")}),define(Re[228],Ae([1,0,13,3,27,17,2,52]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iic=void 0;let h=class extends S.$Aj{constructor(D,l){super(l.logLevel,l.logsLocation,l.loggers.map($=>(0,m.$Eh)($))),this.r=D.getProxy(M.$kL.MainThreadLogger)}$setLogLevel(D,l){l?this.setLogLevel(L.URI.revive(l),D):this.setLogLevel(D)}setVisibility(D,l){super.setVisibility(D,l),this.r.$setVisibility(D,l)}s(D,l,$){return new E(this.r,D,l,$)}};e.$iic=h,e.$iic=h=Ke([Ve(0,R.$vN),Ve(1,I.$LN)],h);class E extends S.$vj{constructor(D,l,$,p){super(p?.logLevel==="always"),this.r=D,this.s=l,this.m=!1,this.n=[],this.setLevel($),this.r.$createLogger(l,p).then(()=>{this.u(this.n),this.m=!0})}g(D,l){const $=[[D,l]];this.m?this.u($):this.n.push(...$)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Re[80],Ae([1,0,3,4,6,17,23]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=e.$0gc=void 0,e.$0gc=(0,M.$8h)("IExtHostManagedSockets");let m=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(S.$kL.MainThreadManagedSockets)}setFactory(D,l){for(const $ of this.d.values())$.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new h(D,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const l=++this.b,$=await this.c.makeConnection(),p=new I.$Sc;return this.d.set(l,new E(l,$,p)),p.add((0,I.$Rc)(()=>this.d.delete(l))),p.add($.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),p.dispose()})),p.add($.onDidClose(r=>{this.a.$onDidManagedSocketClose(l,r?.stack??r?.message),p.dispose()})),p.add($.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(l,L.$ke.wrap(r)))),l}$remoteSocketWrite(D,l){this.d.get(D)?.actual.send(l.buffer)}$remoteSocketEnd(D){const l=this.d.get(D);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$$gc=m,e.$$gc=m=Ke([Ve(0,R.$vN)],m);class h{constructor(D,l){this.socketFactoryId=D,this.makeConnection=l}}class E extends I.$Tc{constructor(D,l,$){super(),this.socketId=D,this.actual=l,this.B($)}}}),define(Re[229],Ae([1,0,3,13,24]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=void 0;function R(m){return m&&m.title}let L=class{constructor(h,E){this.b=E,this.a=h.getProxy(S.$kL.MainThreadMessageService)}showMessage(h,E,A,D,l){const $={source:{identifier:h.identifier,label:h.displayName||h.name}};let p;typeof D=="string"||R(D)?p=[D,...l]:($.modal=D?.modal,$.useCustom=D?.useCustom,$.detail=D?.detail,p=l),$.useCustom&&(0,I.$LF)(h,"resolvers");const r=[];let c=!1;for(let s=0;s<p.length;s++){const i=p[s];if(typeof i=="string")r.push({title:i,handle:s,isCloseAffordance:!1});else if(typeof i=="object"){const{title:o,isCloseAffordance:a}=i;r.push({title:o,isCloseAffordance:!!a,handle:s}),a&&(c?this.b.warn(`[${h.identifier}] Only one message item can have 'isCloseAffordance':`,i):c=!0)}else this.b.warn(`[${h.identifier}] Invalid message item:`,i)}return this.a.$showMessage(E,A,$,r).then(s=>{if(typeof s=="number")return p[s]})}};e.$Khc=L,e.$Khc=L=Ke([Ve(1,M.$pj)],L)}),define(Re[230],Ae([1,0,6,16,2,24,3]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=void 0;class m{constructor(E){this.b=new Map,this.a=E.getProxy(L.$kL.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,A,D){if((0,R.$LF)(E,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,D),this.a.$registerProfileContentHandler(A,D.name,D.description,E.identifier.value),(0,S.$Rc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(E,A,D,l){const $=this.b.get(E);if(!$)throw new Error(`Unknown handler with id: ${E}`);return $.saveProfile(A,D,l)}async $readProfile(E,A,D){const l=this.b.get(E);if(!l)throw new Error(`Unknown handler with id: ${E}`);return l.readProfile((0,M.$Jf)(A)?A:I.URI.revive(A),D)}}e.$Thc=m}),define(Re[81],Ae([1,0,3,5,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=e.$5gc=void 0;class R{constructor(m){this.b=new M.$Wd,this.onDidChangePassword=this.b.event,this.a=m.getProxy(S.$kL.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,h){return this.a.$getPassword(m,h)}store(m,h,E){return this.a.$setPassword(m,h,E)}delete(m,h){return this.a.$deletePassword(m,h)}}e.$5gc=R,e.$6gc=(0,I.$8h)("IExtHostSecretState")}),define(Re[231],Ae([1,0,21,6,3]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=void 0;class R{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(I.$kL.MainThreadSpeech)}async $createSpeechToTextSession(m,h){const E=this.c.get(m);if(!E)return;const A=new M.$Sc,D=new S.$7d;this.d.set(h,D);const l=A.add(E.provideSpeechToTextSession(D.token));A.add(l.onDidChange($=>{D.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(h,$)})),A.add(D.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}async $createKeywordRecognitionSession(m,h){const E=this.c.get(m);if(!E)return;const A=new M.$Sc,D=new S.$7d;this.d.set(h,D);const l=A.add(E.provideKeywordRecognitionSession(D.token));A.add(l.onDidChange($=>{D.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(h,$)})),A.add(D.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,h,E){const A=R.a++;return this.c.set(A,E),this.b.$registerProvider(A,h,{extension:m,displayName:m.value}),(0,M.$Rc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$1hc=R}),define(Re[82],Ae([1,0,3,5,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=e.$Wgc=void 0;class R{constructor(m,h){this.c=h,this.b=new M.$Wd,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(S.$kL.MainThreadStorage)}registerExtensionStorageKeysToSync(m,h){this.a.$registerExtensionStorageKeysToSync(m,h)}async initializeExtensionStorage(m,h,E){const A=await this.a.$initializeExtensionStorage(m,h);let D;return A&&(D=this.d(m,h,A)),D||E}setValue(m,h,E){return this.a.$setValue(m,h,E)}$acceptValue(m,h,E){const A=this.d(m,h,E);A&&this.b.fire({shared:m,key:h,value:A})}d(m,h,E){try{return JSON.parse(E)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${m}): ${A}`)}}}e.$Wgc=R,e.$Xgc=(0,I.$8h)("IExtHostStorage")}),define(Re[232],Ae([1,0,6,12,2,3]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=void 0;class L{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(h){this.c=new Map,this.b=h.getProxy(R.$kL.MainThreadUriOpeners)}registerExternalUriOpener(h,E,A,D){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const l=D.schemes.find($=>!L.a.has($));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(E,A),this.b.$registerUriOpener(E,D.schemes,h,D.label),(0,S.$Rc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(h,E,A){const D=this.c.get(h);if(!D)throw new Error(`Unknown opener with id: ${h}`);const l=I.URI.revive(E);return D.canOpenExternalUri(l,A)}async $openUri(h,E,A){const D=this.c.get(h);if(!D)throw new Error(`Unknown opener id: '${h}'`);return D.openExternalUri(I.URI.revive(E.resolvedUri),{sourceUri:I.URI.revive(E.sourceUri)},A)}}e.$cic=L}),define(Re[233],Ae([1,0,3,2,6,15,22]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=void 0;class m{static{this.a=0}constructor(E){this.c=new L.$om,this.d=new Map,this.b=E.getProxy(S.$kL.MainThreadUrls)}registerUriHandler(E,A){const D=E.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const l=m.a++;return this.c.add(D),this.d.set(l,A),this.b.$registerUriHandler(l,D,E.displayName||E.name),(0,I.$Rc)(()=>{this.c.delete(D),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(E,A){const D=this.d.get(E);if(!D)return Promise.resolve(void 0);try{D.handleUri(M.URI.revive(A))}catch(l){(0,R.$1)(l)}return Promise.resolve(void 0)}async createAppUri(E){return M.URI.revive(await this.b.$createAppUri(E))}}e.$dic=m}),define(Re[61],Ae([1,0,5,6,12,26,2,181,203,76,3]),function(me,e,S,M,I,R,L,m,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=e.$Kgc=e.$Jgc=e.$Igc=e.$Hgc=void 0;class D{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(a,u,t,f,n,w,y){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new S.$Wd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new S.$Wd,this._onDidDispose=this.#h.event,this.#e=a,this.#t=u,this.#o=t,this.#n=f,this.#s=n,this.#r=w,this.#l=l(w),this.#d=$(w),this.#i=y}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#u=!0,(0,E.$xwb)(a,this.#n)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===I.Schemas.https||a.scheme===I.Schemas.http){let u=a.toString();return u.endsWith("/")||(u+="/"),u+" "+E.$wwb}return E.$wwb}get html(){return this.a(),this.#a}set html(a){this.a(),this.#a!==a&&(this.#a=a,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#o}set options(a){this.a(),R.$Cn(this.#o,a)||this.#t.$setOptions(this.#e,c(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#c)return!1;const u=(0,h.$Olb)(a,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,u.message,...u.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const u=this.#r.extensionLocation?.scheme===I.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===I.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,n,w,y,d,b)=>{const P=L.URI.from({scheme:y||"file",path:decodeURIComponent(d)}),g=(0,E.$xwb)(P,{isRemote:u,authority:t}).toString();return`${n}${g}${b}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,n,w,y,d,b)=>{const P=L.URI.from({scheme:y||"file",path:decodeURIComponent(d)}),g=(0,E.$xwb)(P,{isRemote:u,authority:t}).toString();return`${n}${g}${b}`})}}e.$Hgc=D;function l(o){try{const a=(0,m.$ep)((0,m.$dp)(o.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}e.$Igc=l;function $(o){try{const a=(0,m.$ep)((0,m.$dp)(o.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class p extends M.$Tc{constructor(a,u,t,f,n){super(),this.c=u,this.f=t,this.g=f,this.h=n,this.b=new Map,this.a=a.getProxy(A.$kL.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,u,t){const f=this.j(a);if(f){const{message:n}=(0,h.$Plb)(u,t.value);f._onMessageEmitter.fire(n)}}$onMissingCsp(a,u){this.g.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,u,t){const f=new D(a,this.a,s(u),this.c,this.f,t,this.h);this.b.set(a,f);const n=f._onDidDispose(()=>{n.dispose(),this.deleteWebview(a)});return f}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$Jgc=p;function r(o){return{id:o.identifier,location:o.extensionLocation}}e.$Kgc=r;function c(o,a,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||i(o,a)}}e.$Lgc=c;function s(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(a=>L.URI.from(a))}}function i(o,a){return[...(a?.getWorkspaceFolders()||[]).map(u=>u.uri),o.extensionLocation]}}),define(Re[106],Ae([1,0,5,3,2,12,14,4,17,24]),function(me,e,S,M,I,R,L,m,h,E){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$gic=e.$fic=void 0;let D=class{static{A=this}static{this.a={focused:!0,active:!0}}getState($){const p=this.d;return{get focused(){return p.focused},get active(){return(0,E.$LF)($,"windowActivity"),p.active}}}constructor($){this.c=new S.$Wd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=$.getProxy(M.$kL.MainThreadWindow),this.b.$getInitialState().then(({isFocused:p,isActive:r})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",r)})}$onDidChangeWindowFocus($){this.onDidChangeWindowProperty("focused",$)}$onDidChangeWindowActive($){this.onDidChangeWindowProperty("active",$)}onDidChangeWindowProperty($,p){p!==this.d[$]&&(this.d={...this.d,[$]:p},this.c.fire(this.d))}openUri($,p){let r;if(typeof $=="string"){r=$;try{$=I.URI.parse($)}catch{return Promise.reject(`Invalid uri - '${$}'`)}}return(0,L.$Ke)($.scheme)?Promise.reject("Invalid scheme - cannot be empty"):$.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${$.scheme}'`):this.b.$openUri($,r,p)}async asExternalUri($,p){if((0,L.$Ke)($.scheme))return Promise.reject("Invalid scheme - cannot be empty");const r=await this.b.$asExternalUri($,p);return I.URI.from(r)}};e.$fic=D,e.$fic=D=A=Ke([Ve(0,h.$vN)],D),e.$gic=(0,m.$8h)("IExtHostWindow")}),define(Re[234],Ae([1,0,225,27,17]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=void 0;let R=class extends S.$jic{constructor(m,h){super(m,h)}f(m,h,E){h.apply(console,E)}};e.$skc=R,e.$skc=R=Ke([Ve(0,I.$vN),Ve(1,M.$LN)],R)}),define(Re[235],Ae([1,0,11,23,21,15,5,6,139,222,50]),function(me,e,S,M,I,R,L,m,h,E,A){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$n8b=e.ResponsiveState=e.RequestInitiator=e.$m8b=e.$l8b=void 0;function l(k,F){try{return JSON.stringify(k,F)}catch{return"null"}}const $="$$ref$$",p={[$]:-1};class r{constructor(F,O){this.jsonString=F,this.referencedBuffers=O}}function c(k,F=null,O=!1){const G=[];return{jsonString:(O?l:JSON.stringify)(k,(U,C)=>{if(typeof C>"u")return p;if(typeof C=="object"){if(C instanceof M.$ke){const N=G.push(C)-1;return{[$]:N}}if(F)return F(U,C)}return C}),referencedBuffers:G}}e.$l8b=c;function s(k,F,O){return JSON.parse(k,(G,q)=>{if(q){const U=q[$];if(typeof U=="number")return F[U];if(O&&q.$mid===1)return O.transformIncoming(q)}return q})}e.$m8b=s;function i(k,F){return JSON.stringify(k,F)}function o(k){return k?(F,O)=>O&&O.$mid===1?k.transformOutgoing(O):O:null}var a;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var u;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const t=()=>{},f=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class w extends m.$Tc{static{D=f}static{this.a=3*1e3}constructor(F,O=null,G=null){super(),this[D]=!0,this.b=this.B(new L.$Wd),this.onDidChangeResponsiveState=this.b.event,this.c=F,this.f=O,this.g=G,this.h=o(this.g),this.j=!1,this.m=[],this.s=[];for(let q=0,U=A.$Sv.count;q<U;q++)this.m[q]=null,this.s[q]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new S.$hh(()=>this.H(),1e3)),this.c.onMessage(q=>this.L(q))}dispose(){this.j=!0,Object.keys(this.w).forEach(F=>{const O=this.w[F];delete this.w[F],O.resolveErr(R.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(F){this.z===0&&(this.C=Date.now()+w.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(F){this.C=Date.now()+w.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(F){this.y!==F&&(this.y=F,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(F){return this.g?(0,h.$0m)(F,this.g):F}getProxy(F){const{nid:O,sid:G}=F;return this.s[O]||(this.s[O]=this.J(O,G)),this.s[O]}J(F,O){const G={get:(q,U)=>(typeof U=="string"&&!q[U]&&U.charCodeAt(0)===36&&(q[U]=(...C)=>this.U(F,U,C)),U===n?O:q[U])};return new Proxy(Object.create(null),G)}set(F,O){return this.m[F.nid]=O,O}assertRegistered(F){for(let O=0,G=F.length;O<G;O++){const q=F[O];if(!this.m[q.nid])throw new Error(`Missing proxy instance ${q.sid}`)}}L(F){if(this.j)return;const O=F.byteLength,G=d.read(F,0),q=G.readUInt8(),U=G.readUInt32();switch(q){case 1:case 2:{let{rpcId:C,method:N,args:W}=P.deserializeRequestJSONArgs(G);this.g&&(W=(0,h.$0m)(W,this.g)),this.M(O,U,C,N,W,q===2);break}case 3:case 4:{let{rpcId:C,method:N,args:W}=P.deserializeRequestMixedArgs(G);this.g&&(W=(0,h.$0m)(W,this.g)),this.M(O,U,C,N,W,q===4);break}case 5:{this.f?.logIncoming(O,U,0,"ack"),this.G(U);break}case 6:{this.N(O,U);break}case 7:{this.O(O,U,void 0);break}case 9:{let C=P.deserializeReplyOKJSON(G);this.g&&(C=(0,h.$0m)(C,this.g)),this.O(O,U,C);break}case 10:{const C=P.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(O,U,C);break}case 8:{const C=P.deserializeReplyOKVSBuffer(G);this.O(O,U,C);break}case 11:{let C=P.deserializeReplyErrError(G);this.g&&(C=(0,h.$0m)(C,this.g)),this.P(O,U,C);break}case 12:{this.P(O,U,void 0);break}default:console.error("received unexpected message"),console.error(F)}}M(F,O,G,q,U,C){this.f?.logIncoming(F,O,1,`receiveRequest ${(0,A.$Uv)(G)}.${q}(`,U);const N=String(O);let W,se;if(C){const Ee=new I.$7d;U.push(Ee.token),W=this.Q(G,q,U),se=()=>Ee.cancel()}else W=this.Q(G,q,U),se=t;this.u[N]=se;const le=P.serializeAcknowledged(O);this.f?.logOutgoing(le.byteLength,O,1,"ack"),this.c.send(le),W.then(Ee=>{delete this.u[N];const De=P.serializeReplyOK(O,Ee,this.h);this.f?.logOutgoing(De.byteLength,O,1,"reply:",Ee),this.c.send(De)},Ee=>{delete this.u[N];const De=P.serializeReplyErr(O,Ee);this.f?.logOutgoing(De.byteLength,O,1,"replyErr:",Ee),this.c.send(De)})}N(F,O){this.f?.logIncoming(F,O,1,"receiveCancel");const G=String(O);this.u[G]?.()}O(F,O,G){this.f?.logIncoming(F,O,0,"receiveReply:",G);const q=String(O);if(!this.w.hasOwnProperty(q))return;const U=this.w[q];delete this.w[q],U.resolveOk(G)}P(F,O,G){this.f?.logIncoming(F,O,0,"receiveReplyErr:",G);const q=String(O);if(!this.w.hasOwnProperty(q))return;const U=this.w[q];delete this.w[q];let C;G&&(G.$isError?(C=new Error,C.name=G.name,C.message=G.message,C.stack=G.stack):C=G),U.resolveErr(C)}Q(F,O,G){try{return Promise.resolve(this.S(F,O,G))}catch(q){return Promise.reject(q)}}S(F,O,G){const q=this.m[F];if(!q)throw new Error("Unknown actor "+(0,A.$Uv)(F));const U=q[O];if(typeof U!="function")throw new Error("Unknown method "+O+" on actor "+(0,A.$Uv)(F));return U.apply(q,G)}U(F,O,G){if(this.j)return new E.$k8b;let q=null;if(G.length>0&&I.CancellationToken.isCancellationToken(G[G.length-1])&&(q=G.pop()),q&&q.isCancellationRequested)return Promise.reject(R.$6());const U=P.serializeRequestArguments(G,this.h),C=++this.t,N=String(C),W=new E.$j8b,se=new m.$Sc;q&&se.add(q.onCancellationRequested(()=>{const Ee=P.serializeCancel(C);this.f?.logOutgoing(Ee.byteLength,C,0,"cancel"),this.c.send(P.serializeCancel(C))})),this.w[N]=new y(W,se),this.F(C);const le=P.serializeRequest(C,F,O,U,!!q);return this.f?.logOutgoing(le.byteLength,C,0,`request: ${(0,A.$Uv)(F)}.${O}(`,G),this.c.send(le),W}}e.$n8b=w;class y{constructor(F,O){this.a=F,this.b=O}resolveOk(F){this.a.resolveOk(F),this.b.dispose()}resolveErr(F){this.a.resolveErr(F),this.b.dispose()}}class d{static alloc(F,O,G){const q=new d(M.$ke.alloc(G+1+4),0);return q.writeUInt8(F),q.writeUInt32(O),q}static read(F,O){return new d(F,O)}get buffer(){return this.a}constructor(F,O){this.a=F,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(F){this.a.writeUInt8(F,this.b),this.b+=1}readUInt8(){const F=this.a.readUInt8(this.b);return this.b+=1,F}writeUInt32(F){this.a.writeUInt32BE(F,this.b),this.b+=4}readUInt32(){const F=this.a.readUInt32BE(this.b);return this.b+=4,F}static sizeShortString(F){return 1+F.byteLength}writeShortString(F){this.a.writeUInt8(F.byteLength,this.b),this.b+=1,this.a.set(F,this.b),this.b+=F.byteLength}readShortString(){const F=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+F).toString();return this.b+=F,G}static sizeLongString(F){return 4+F.byteLength}writeLongString(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}readLongString(){const F=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+F).toString();return this.b+=F,G}writeBuffer(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}static sizeVSBuffer(F){return 4+F.byteLength}writeVSBuffer(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}readVSBuffer(){const F=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+F);return this.b+=F,O}static sizeMixedArray(F){let O=0;O+=1;for(let G=0,q=F.length;G<q;G++){const U=F[G];switch(O+=1,U.type){case 1:O+=this.sizeLongString(U.value);break;case 2:O+=this.sizeVSBuffer(U.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(U.value);for(let C=0;C<U.buffers.length;++C)O+=this.sizeVSBuffer(U.buffers[C]);break;case 4:break}}return O}writeMixedArray(F){this.a.writeUInt8(F.length,this.b),this.b+=1;for(let O=0,G=F.length;O<G;O++){const q=F[O];switch(q.type){case 1:this.writeUInt8(1),this.writeLongString(q.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(q.value);break;case 3:this.writeUInt8(3),this.writeUInt32(q.buffers.length),this.writeLongString(q.value);for(let U=0;U<q.buffers.length;++U)this.writeBuffer(q.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const F=this.a.readUInt8(this.b);this.b+=1;const O=new Array(F);for(let G=0;G<F;G++)switch(this.readUInt8()){case 1:O[G]=this.readLongString();break;case 2:O[G]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),C=this.readLongString(),N=[];for(let W=0;W<U;++W)N.push(this.readVSBuffer());O[G]=new A.$Vv(s(C,N,null));break}case 4:O[G]=void 0;break}return O}}var b;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(b||(b={}));class P{static a(F){for(let O=0,G=F.length;O<G;O++)if(F[O]instanceof M.$ke||F[O]instanceof A.$Vv||typeof F[O]>"u")return!0;return!1}static serializeRequestArguments(F,O){if(this.a(F)){const G=[];for(let q=0,U=F.length;q<U;q++){const C=F[q];if(C instanceof M.$ke)G[q]={type:2,value:C};else if(typeof C>"u")G[q]={type:4};else if(C instanceof A.$Vv){const{jsonString:N,referencedBuffers:W}=c(C.value,O);G[q]={type:3,value:M.$ke.fromString(N),buffers:W}}else G[q]={type:1,value:M.$ke.fromString(i(C,O))}}return{type:1,args:G}}return{type:0,args:i(F,O)}}static serializeRequest(F,O,G,q,U){switch(q.type){case 0:return this.b(F,O,G,q.args,U);case 1:return this.c(F,O,G,q.args,U)}}static b(F,O,G,q,U){const C=M.$ke.fromString(G),N=M.$ke.fromString(q);let W=0;W+=d.sizeUInt8(),W+=d.sizeShortString(C),W+=d.sizeLongString(N);const se=d.alloc(U?2:1,F,W);return se.writeUInt8(O),se.writeShortString(C),se.writeLongString(N),se.buffer}static deserializeRequestJSONArgs(F){const O=F.readUInt8(),G=F.readShortString(),q=F.readLongString();return{rpcId:O,method:G,args:JSON.parse(q)}}static c(F,O,G,q,U){const C=M.$ke.fromString(G);let N=0;N+=d.sizeUInt8(),N+=d.sizeShortString(C),N+=d.sizeMixedArray(q);const W=d.alloc(U?4:3,F,N);return W.writeUInt8(O),W.writeShortString(C),W.writeMixedArray(q),W.buffer}static deserializeRequestMixedArgs(F){const O=F.readUInt8(),G=F.readShortString(),q=F.readMixedArray(),U=new Array(q.length);for(let C=0,N=q.length;C<N;C++){const W=q[C];typeof W=="string"?U[C]=JSON.parse(W):U[C]=W}return{rpcId:O,method:G,args:U}}static serializeAcknowledged(F){return d.alloc(5,F,0).buffer}static serializeCancel(F){return d.alloc(6,F,0).buffer}static serializeReplyOK(F,O,G){if(typeof O>"u")return this.d(F);if(O instanceof M.$ke)return this.e(F,O);if(O instanceof A.$Vv){const{jsonString:q,referencedBuffers:U}=c(O.value,G,!0);return this.g(F,q,U)}else return this.f(F,l(O,G))}static d(F){return d.alloc(7,F,0).buffer}static e(F,O){let G=0;G+=d.sizeVSBuffer(O);const q=d.alloc(8,F,G);return q.writeVSBuffer(O),q.buffer}static deserializeReplyOKVSBuffer(F){return F.readVSBuffer()}static f(F,O){const G=M.$ke.fromString(O);let q=0;q+=d.sizeLongString(G);const U=d.alloc(9,F,q);return U.writeLongString(G),U.buffer}static g(F,O,G){const q=M.$ke.fromString(O);let U=0;U+=d.sizeUInt32,U+=d.sizeLongString(q);for(const N of G)U+=d.sizeVSBuffer(N);const C=d.alloc(10,F,U);C.writeUInt32(G.length),C.writeLongString(q);for(const N of G)C.writeBuffer(N);return C.buffer}static deserializeReplyOKJSON(F){const O=F.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(F,O){const G=F.readUInt32(),q=F.readLongString(),U=[];for(let C=0;C<G;++C)U.push(F.readVSBuffer());return new A.$Vv(s(q,U,O))}static serializeReplyErr(F,O){const G=O?l(R.$3(O),null):void 0;if(typeof G!="string")return this.h(F);const q=M.$ke.fromString(G);let U=0;U+=d.sizeLongString(q);const C=d.alloc(11,F,U);return C.writeLongString(q),C.buffer}static deserializeReplyErrError(F){const O=F.readLongString();return JSON.parse(O)}static h(F){return d.alloc(12,F,0).buffer}}var g;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var v;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(v||(v={}))}),define(Re[236],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ukc=void 0;const S=function(R){const L=m=>{globalThis.removeEventListener("message",L);const h=m.data;Object.defineProperties(globalThis,{postMessage:{value(E,A){h.postMessage(E,A)}},onmessage:{get(){return h.onmessage},set(E){h.onmessage=E}}}),h.addEventListener("message",E=>{globalThis.dispatchEvent(new MessageEvent("message",{data:E.data,ports:E.ports?[...E.ports]:void 0}))}),h.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(R)};globalThis.addEventListener("message",L)}.toString();class M extends EventTarget{constructor(R,L,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const h=`((${S})('${L}'))`,E=new Blob([h],{type:"application/javascript"}),A=URL.createObjectURL(E),D=new MessageChannel,l=A,$={type:"_newWorker",id:l,port:D.port2,url:A,options:m};R($,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{R({type:"_terminateWorker",id:l}),URL.revokeObjectURL(A),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(p){D.port1.onmessage=p}},onmessageerror:{get(){return D.port1.onmessageerror},set(p){D.port1.onmessageerror=p}}}),D.port1.addEventListener("messageerror",p=>{const r=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(r)}),D.port1.addEventListener("message",p=>{const r=new MessageEvent("message",{data:p.data});this.dispatchEvent(r)}),D.port1.start()}}e.$ukc=M}),define(Re[237],Ae([1,0,23,28,12,53,4]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0I=e.$9I=e.$8I=e.$7I=void 0,e.$7I=(0,L.$8h)("notebookDocumentService");const m=["W","X","Y","Z","a","b","c","d","e","f"],h=new RegExp(`^[${m.join("")}]+`),E=7;function A($){if($.scheme!==I.Schemas.vscodeNotebookCell)return;const p=$.fragment.indexOf("s");if(p<0)return;const r=parseInt($.fragment.substring(0,p).replace(h,""),E),c=(0,S.$De)($.fragment.substring(p+1)).toString();if(!isNaN(r))return{handle:r,notebook:$.with({scheme:c,fragment:null})}}e.$8I=A;function D($,p){const r=p.toString(E),s=`${r.length<m.length?m[r.length-1]:"z"}${r}s${(0,S.$Ee)(S.$ke.fromString($.scheme),!0,!0)}`;return $.with({scheme:I.Schemas.vscodeNotebookCell,fragment:s})}e.$9I=D;class l{constructor(){this.a=new M.$Ac}getNotebook(p){if(p.scheme===I.Schemas.vscodeNotebookCell){const r=A(p);if(r){const c=this.a.get(r.notebook);if(c)return c}}return this.a.get(p)}addNotebookDocument(p){this.a.set(p.uri,p)}removeNotebookDocument(p){this.a.delete(p.uri)}}e.$0I=l,(0,R.$1r)(e.$7I,l,1)}),define(Re[83],Ae([1,0,23,34,68,69,12,19,20,35,237]),function(me,e,S,M,I,R,L,m,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.CellStatusbarAlignment=e.$lJ=e.$kJ=e.$jJ=e.NotebookEditorPriority=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.CellKind=e.$aJ=e.$_I=e.$$I=void 0,e.$$I="workbench.editor.notebook",e.$_I="workbench.editor.notebookTextDiffEditor",e.$aJ="workbench.editor.interactive";var D;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(D||(e.CellKind=D={})),e.$bJ=["application/json","application/javascript","text/html","image/svg+xml",R.$hs.latex,R.$hs.markdown,"image/png","image/jpeg",R.$hs.text],e.$cJ=[R.$hs.latex,R.$hs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$hs.text],e.$dJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$eJ="_notAvailable";var l;(function(W){W[W.Running=1]="Running",W[W.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var $;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})($||(e.NotebookCellExecutionState=$={}));var p;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var r;(function(W){W[W.WithHardKernelDependency=0]="WithHardKernelDependency",W[W.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",W[W.Pure=2]="Pure",W[W.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var c;(function(W){W.Always="always",W.Never="never",W.Optional="optional"})(c||(e.RendererMessagingSpec=c={}));var s;(function(W){W[W.ModelChange=1]="ModelChange",W[W.Move=2]="Move",W[W.ChangeCellLanguage=5]="ChangeCellLanguage",W[W.Initialize=6]="Initialize",W[W.ChangeCellMetadata=7]="ChangeCellMetadata",W[W.Output=8]="Output",W[W.OutputItem=9]="OutputItem",W[W.ChangeCellContent=10]="ChangeCellContent",W[W.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",W[W.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",W[W.ChangeCellMime=13]="ChangeCellMime",W[W.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var i;(function(W){W[W.Handle=0]="Handle",W[W.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var o;(function(W){W[W.Replace=1]="Replace",W[W.Output=2]="Output",W[W.Metadata=3]="Metadata",W[W.CellLanguage=4]="CellLanguage",W[W.DocumentMetadata=5]="DocumentMetadata",W[W.Move=6]="Move",W[W.OutputItems=7]="OutputItems",W[W.PartialMetadata=8]="PartialMetadata",W[W.PartialInternalMetadata=9]="PartialInternalMetadata"})(o||(e.CellEditType=o={}));var a;(function(W){W.scheme=L.Schemas.vscodeNotebookCell;function se(oe,$e){return(0,A.$9I)(oe,$e)}W.generate=se;function le(oe){return(0,A.$8I)(oe)}W.parse=le;function Ee(oe,$e){return oe.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${oe.scheme!==L.Schemas.file?oe.scheme:""}`})}W.generateCellOutputUri=Ee;function De(oe){if(oe.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!$e)return;const ie=$e[1]&&$e[1]!==""?$e[1]:void 0,x=$e[2];return{outputId:ie,notebook:oe.with({scheme:x||L.Schemas.file,fragment:null})}}W.parseCellOutputUri=De;function ce(oe,$e,ie){return W.generate(oe,$e).with({scheme:ie})}W.generateCellPropertyUri=ce;function pe(oe,$e){if(oe.scheme===$e)return W.parse(oe.with({scheme:W.scheme}))}W.parseCellPropertyUri=pe})(a||(e.CellUri=a={}));const u=W=>h.$i?W.replace(/\//g,"\\"):W;class t{constructor(se=[],le=e.$bJ){this.e=le,this.d=[...new Set(se)].map(Ee=>({pattern:Ee,matches:M.$Oj(u(Ee))}))}sort(se){const le=new Map(I.Iterable.map(se,De=>[De,u(De)]));let Ee=[];for(const{matches:De}of this.d)for(const[ce,pe]of le)if(De(pe)){Ee.push(ce),le.delete(ce);break}return le.size&&(Ee=Ee.concat([...le.keys()].sort((De,ce)=>this.e.indexOf(De)-this.e.indexOf(ce)))),Ee}prioritize(se,le){const Ee=this.f(se);if(Ee===-1){this.d.unshift({pattern:se,matches:M.$Oj(u(se))});return}const De=new Set(le.map(pe=>this.f(pe,Ee)));De.delete(-1);const ce=Array.from(De).sort();this.d.splice(Ee+1,0,...ce.map(pe=>this.d[pe]));for(let pe=ce.length-1;pe>=0;pe--)this.d.splice(ce[pe],1)}toArray(){return this.d.map(se=>se.pattern)}f(se,le=this.d.length){const Ee=u(se);for(let De=0;De<le;De++)if(this.d[De].matches(Ee))return De;return-1}}e.$fJ=t;function f(W,se,le,Ee=(De,ce)=>De===ce){const De=[];function ce($e,ie,x){if(ie===0&&x.length===0)return;const V=De[De.length-1];V&&V.start+V.deleteCount===$e?(V.deleteCount+=ie,V.toInsert.push(...x)):De.push({start:$e,deleteCount:ie,toInsert:x})}let pe=0,oe=0;for(;;){if(pe===W.length){ce(pe,0,se.slice(oe));break}if(oe===se.length){ce(pe,W.length-pe,[]);break}const $e=W[pe],ie=se[oe];if(Ee($e,ie)){pe+=1,oe+=1;continue}le(ie)?(ce(pe,1,[]),pe+=1):(ce(pe,0,[ie]),oe+=1)}return De}e.$gJ=f,e.$hJ=new E.$mj("notebookEditorCursorAtBoundary","none"),e.$iJ=new E.$mj("notebookEditorCursorAtLineBoundary","none");var n;(function(W){W.default="default",W.option="option"})(n||(e.NotebookEditorPriority=n={}));function w(W){const se=W;return!!((typeof se.include=="string"||M.$Pj(se.include))&&(typeof se.exclude=="string"||M.$Pj(se.exclude)))}e.$jJ=w;function y(W,se,le){if(Array.isArray(W.viewType)&&W.viewType.indexOf(se)>=0||W.viewType===se)return!0;if(W.filenamePattern){const Ee=w(W.filenamePattern)?W.filenamePattern.include:W.filenamePattern,De=w(W.filenamePattern)?W.filenamePattern.exclude:void 0;if(M.$Nj(Ee,(0,m.$nc)(le.fsPath).toLowerCase()))return!(De&&M.$Nj(De,(0,m.$nc)(le.fsPath).toLowerCase()))}return!1}e.$kJ=y,e.$lJ={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var d;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(d||(e.CellStatusbarAlignment=d={}));class b{static{this.d="notebook/"}static create(se){return`${b.d}${se}`}static parse(se){if(se.startsWith(b.d))return se.substring(b.d.length)}}e.$mJ=b;function P(W){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(W)}e.$nJ=P;const g=new TextDecoder;function v(W){const se=[];let le=!1;for(const pe of W)(se.length===0||le)&&(se.push(pe),le=!0);let Ee=O(se);const De=S.$ke.concat(se.map(pe=>S.$ke.wrap(pe))),ce=N(De);return Ee=Ee||ce.byteLength!==De.byteLength,{data:ce,didCompression:Ee}}e.$oJ=v,e.$pJ="\x1B[A";const k=e.$pJ.split("").map(W=>W.charCodeAt(0)),F=10;function O(W){let se=!1;return W.forEach((le,Ee)=>{if(Ee===0||le.length<e.$pJ.length)return;const De=W[Ee-1],ce=le.subarray(0,e.$pJ.length);if(ce[0]===k[0]&&ce[1]===k[1]&&ce[2]===k[2]){const pe=De.lastIndexOf(F);if(pe===-1)return;se=!0,W[Ee-1]=De.subarray(0,pe),W[Ee]=le.subarray(e.$pJ.length)}}),se}function G(W){let se=W;do W=se,se=W.replace(/[^\n]\x08/gm,"");while(se.length<W.length);return W}function q(W){for(W=W.replace(/\r+\n/gm,`
`);W.search(/\r[^$]/g)>-1;){const se=W.match(/^(.*)\r+/m)[1];let le=W.match(/\r+(.*)$/m)[1];le=le+se.slice(le.length,se.length),W=W.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,le)}return W}const U=8,C=13;function N(W){return!W.buffer.includes(U)&&!W.buffer.includes(C)?W:S.$ke.fromString(q(G(g.decode(W.buffer))))}}),define(Re[7],Ae([1,0,18,15,46,28,69,14,16,2,33,22,42,100,83]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p){"use strict";var r,c,s,i,o,a,u,t,f,n,w,y,d,b,P,g,v;Object.defineProperty(e,"__esModule",{value:!0}),e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$kN=e.$jN=e.$iN=e.$hN=e.$gN=e.$fN=e.ChatAgentResultFeedbackKind=e.$eN=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$dN=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$cN=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.TestRunProfileKind=e.TestResultState=e.$VM=e.$UM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$TM=e.NotebookVariablesRequestKind=e.$SM=e.$RM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$QM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=e.ColorThemeKind=e.$KM=e.$JM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$IM=e.$HM=e.DebugConsoleMode=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$BM=e.$AM=e.FileChangeType=e.$zM=e.$yM=e.$xM=e.$wM=e.InlineCompletionTriggerKind=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.ConfigurationTarget=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$_L=e.ViewBadge=e.ProgressLocation=e.$$L=e.$0L=e.TaskScope=e.ShellQuoting=e.$9L=e.$8L=e.$7L=e.TaskPanelKind=e.TaskRevealKind=e.$6L=e.TerminalLocation=e.$5L=e.$4L=e.$3L=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$2L=e.$1L=e.$ZL=e.$YL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$XL=e.StatusBarAlignment=e.ViewColumn=e.$WL=e.$VL=e.$UL=e.$TL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$SL=e.$RL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.LanguageStatusSeverity=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.CodeActionTriggerKind=e.$FL=e.$EL=e.SymbolTag=e.SymbolKind=e.$DL=e.$CL=e.DocumentHighlightKind=e.$BL=e.$AL=e.$zL=e.$yL=e.DiagnosticSeverity=e.DiagnosticTag=e.$xL=e.$wL=e.FileEditType=e.$vL=e.$uL=e.$tL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function k(j){return Object.assign(j,{apply:function(...re){if(re.length===0)return Reflect.construct(j,[]);{const Se=re.length===1?[]:re[1];return Reflect.construct(j,Se,re[0].constructor)}},call:function(...re){if(re.length===0)return Reflect.construct(j,[]);{const[Se,...Ge]=re;return Reflect.construct(j,Ge,Se.constructor)}}})}var F;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(F||(e.TerminalOutputAnchor=F={}));var O;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let G=r=class{static from(...z){let re=z;return new r(function(){if(re){for(const Se of re)Se&&typeof Se.dispose=="function"&&Se.dispose();re=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$mL=G,e.$mL=G=r=Ke([k],G);let q=c=class{static Min(...z){if(z.length===0)throw new TypeError;let re=z[0];for(let Se=1;Se<z.length;Se++){const Ge=z[Se];Ge.isBefore(re)&&(re=Ge)}return re}static Max(...z){if(z.length===0)throw new TypeError;let re=z[0];for(let Se=1;Se<z.length;Se++){const Ge=z[Se];Ge.isAfter(re)&&(re=Ge)}return re}static isPosition(z){if(!z)return!1;if(z instanceof c)return!0;const{line:re,character:Se}=z;return typeof re=="number"&&typeof Se=="number"}static of(z){if(z instanceof c)return z;if(this.isPosition(z))return new c(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,re){if(z<0)throw(0,M.$7)("line must be non-negative");if(re<0)throw(0,M.$7)("character must be non-negative");this.c=z,this.e=re}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,re=0){if(z===null||re===null)throw(0,M.$7)();let Se;return typeof z>"u"?Se=0:typeof z=="number"?Se=z:(Se=typeof z.lineDelta=="number"?z.lineDelta:0,re=typeof z.characterDelta=="number"?z.characterDelta:0),Se===0&&re===0?this:new c(this.line+Se,this.character+re)}with(z,re=this.character){if(z===null||re===null)throw(0,M.$7)();let Se;return typeof z>"u"?Se=this.line:typeof z=="number"?Se=z:(Se=typeof z.line=="number"?z.line:this.line,re=typeof z.character=="number"?z.character:this.character),Se===this.line&&re===this.character?this:new c(Se,re)}toJSON(){return{line:this.line,character:this.character}}};e.$nL=q,e.$nL=q=c=Ke([k],q);let U=s=class{static isRange(z){return z instanceof s?!0:z?q.isPosition(z.start)&&q.isPosition(z.end):!1}static of(z){if(z instanceof s)return z;if(this.isRange(z))return new s(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,re,Se,Ge){let xe,ut;if(typeof z=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Ge=="number"?(xe=new q(z,re),ut=new q(Se,Ge)):q.isPosition(z)&&q.isPosition(re)&&(xe=q.of(z),ut=q.of(re)),!xe||!ut)throw new Error("Invalid arguments");xe.isBefore(ut)?(this.c=xe,this.e=ut):(this.c=ut,this.e=xe)}contains(z){return s.isRange(z)?this.contains(z.start)&&this.contains(z.end):q.isPosition(z)?!(q.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const re=q.Max(z.start,this.c),Se=q.Min(z.end,this.e);if(!re.isAfter(Se))return new s(re,Se)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const re=q.Min(z.start,this.c),Se=q.Max(z.end,this.end);return new s(re,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,re=this.end){if(z===null||re===null)throw(0,M.$7)();let Se;return z?q.isPosition(z)?Se=z:(Se=z.start||this.start,re=z.end||this.end):Se=this.start,Se.isEqual(this.c)&&re.isEqual(this.end)?this:new s(Se,re)}toJSON(){return[this.start,this.end]}};e.$oL=U,e.$oL=U=s=Ke([k],U);let C=i=class extends U{static isSelection(z){return z instanceof i?!0:z?U.isRange(z)&&q.isPosition(z.anchor)&&q.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,re,Se,Ge){let xe,ut;if(typeof z=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Ge=="number"?(xe=new q(z,re),ut=new q(Se,Ge)):q.isPosition(z)&&q.isPosition(re)&&(xe=q.of(z),ut=q.of(re)),!xe||!ut)throw new Error("Invalid arguments");super(xe,ut),this.f=xe,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$pL=C,e.$pL=C=i=Ke([k],C);const N=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,M.$7)("connectionToken")};class W{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,re,Se){if(typeof z!="string"||z.length===0)throw(0,M.$7)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,M.$7)("port");typeof Se<"u"&&N(Se),this.host=z,this.port=Math.round(re),this.connectionToken=Se}}e.$qL=W;class se{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,re){this.makeConnection=z,this.connectionToken=re,typeof re<"u"&&N(re)}}e.$rL=se;class le extends Error{static NotAvailable(z,re){return new le(z,$.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(z){return new le(z,$.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,re=$.RemoteAuthorityResolverErrorCode.Unknown,Se){super(z),this._message=z,this._code=re,this._detail=Se,Object.setPrototypeOf(this,le.prototype)}}e.$sL=le;var Ee;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Ee||(e.EndOfLine=Ee={}));var De;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(De||(e.EnvironmentVariableMutatorType=De={}));let ce=o=class{static isTextEdit(z){return z instanceof o?!0:z?U.isRange(z)&&typeof z.newText=="string":!1}static replace(z,re){return new o(z,re)}static insert(z,re){return o.replace(new U(z,z),re)}static delete(z){return o.replace(z,"")}static setEndOfLine(z){const re=new o(new U(new q(0,0),new q(0,0)),"");return re.newEol=z,re}get range(){return this.c}set range(z){if(z&&!U.isRange(z))throw(0,M.$7)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,M.$7)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,M.$7)("newEol");this.f=z}constructor(z,re){this.c=z,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$tL=ce,e.$tL=ce=o=Ke([k],ce);let pe=a=class{static isNotebookCellEdit(z){return z instanceof a?!0:z?ui.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,re){return new a(z,re)}static insertCells(z,re){return new a(new ui(z,z),re)}static deleteCells(z){return new a(z,[])}static updateCellMetadata(z,re){const Se=new a(new ui(z,z),[]);return Se.newCellMetadata=re,Se}static updateNotebookMetadata(z){const re=new a(new ui(0,0),[]);return re.newNotebookMetadata=z,re}constructor(z,re){this.range=z,this.newCells=re}};e.$uL=pe,e.$uL=pe=a=Ke([k],pe);class oe{static isSnippetTextEdit(z){return z instanceof oe?!0:z?U.isRange(z.range)&&x.isSnippetString(z.snippet):!1}static replace(z,re){return new oe(z,re)}static insert(z,re){return oe.replace(new U(z,z),re)}constructor(z,re){this.range=z,this.snippet=re}}e.$vL=oe;var $e;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,re,Se,Ge){this.c.push({_type:1,from:z,to:re,options:Se,metadata:Ge})}createFile(z,re,Se){this.c.push({_type:1,from:void 0,to:z,options:re,metadata:Se})}deleteFile(z,re,Se){this.c.push({_type:1,from:z,to:void 0,options:re,metadata:Se})}e(z,re,Se){this.c.push({_type:3,metadata:Se,uri:z,edit:{editType:5,metadata:re},notebookMetadata:re})}f(z,re,Se,Ge){const xe=re.start,ut=re.end;(xe!==ut||Se.length>0)&&this.c.push({_type:5,uri:z,index:xe,count:ut-xe,cells:Se,metadata:Ge})}g(z,re,Se,Ge){this.c.push({_type:3,metadata:Ge,uri:z,edit:{editType:3,index:re,metadata:Se}})}replace(z,re,Se,Ge){this.c.push({_type:2,uri:z,edit:new ce(re,Se),metadata:Ge})}insert(z,re,Se,Ge){this.replace(z,new U(re,re),Se,Ge)}delete(z,re,Se){this.replace(z,re,"",Se)}has(z){return this.c.some(re=>re._type===2&&re.uri.toString()===z.toString())}set(z,re){if(re)for(const Se of re){if(!Se)continue;let Ge,xe;Array.isArray(Se)?(Ge=Se[0],xe=Se[1]):Ge=Se,pe.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(z,Ge.range.start,Ge.newCellMetadata,xe):Ge.newNotebookMetadata?this.e(z,Ge.newNotebookMetadata,xe):this.f(z,Ge.range,Ge.newCells,xe):oe.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:z,range:Ge.range,edit:Ge.snippet,metadata:xe}):this.c.push({_type:2,uri:z,edit:Ge,metadata:xe})}else{for(let Se=0;Se<this.c.length;Se++){const Ge=this.c[Se];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===z.toString()&&(this.c[Se]=void 0);break}}(0,S.$Ib)(this.c)}}get(z){const re=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===z.toString()&&re.push(Se.edit);return re}entries(){const z=new R.$Ac;for(const re of this.c)if(re._type===2){let Se=z.get(re.uri);Se||(Se=[re.uri,[]],z.set(re.uri,Se)),Se[1].push(re.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$wL=ie,e.$wL=ie=Ke([k],ie);let x=u=class{static isSnippetString(z){return z instanceof u?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=u.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,re=this.e++){if(typeof z=="function"){const Se=new u;Se.e=this.e,z(Se),this.e=Se.e,z=Se.value}else z=u.c(z);return this.value+="${",this.value+=re,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,re=this.e++){const Se=z.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(z,re){if(typeof re=="function"){const Se=new u;Se.e=this.e,re(Se),this.e=Se.e,re=Se.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.$xL=x,e.$xL=x=u=Ke([k],x);var V;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ne;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let Ie=t=class{static isLocation(z){return z instanceof t?!0:z?U.isRange(z.range)&&E.URI.isUri(z.uri):!1}constructor(z,re){if(this.uri=z,re)if(U.isRange(re))this.range=U.of(re);else if(q.isPosition(re))this.range=new U(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$yL=Ie,e.$yL=Ie=t=Ke([k],Ie);let Me=class{static is(z){return z?typeof z.message=="string"&&z.location&&U.isRange(z.location.range)&&E.URI.isUri(z.location.uri):!1}constructor(z,re){this.location=z,this.message=re}static isEqual(z,re){return z===re?!0:!z||!re?!1:z.message===re.message&&z.location.range.isEqual(re.location.range)&&z.location.uri.toString()===re.location.uri.toString()}};e.$zL=Me,e.$zL=Me=Ke([k],Me);let Le=class{constructor(z,re,Se=ne.Error){if(!U.isRange(z))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=z,this.message=re,this.severity=Se}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,re){return z===re?!0:!z||!re?!1:z.message===re.message&&z.severity===re.severity&&z.code===re.code&&z.severity===re.severity&&z.source===re.source&&z.range.isEqual(re.range)&&(0,S.$ub)(z.tags,re.tags)&&(0,S.$ub)(z.relatedInformation,re.relatedInformation,Me.isEqual)}};e.$AL=Le,e.$AL=Le=Ke([k],Le);let we=class{constructor(z,re){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=re}};e.$BL=we,e.$BL=we=Ke([k],we);var ge;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(ge||(e.DocumentHighlightKind=ge={}));let K=class{constructor(z,re=ge.Text){this.range=z,this.kind=re}toJSON(){return{range:this.range,kind:ge[this.kind]}}};e.$CL=K,e.$CL=K=Ke([k],K);let ee=class{constructor(z,re){this.uri=z,this.highlights=re}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$DL=ee,e.$DL=ee=Ke([k],ee);var he;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(he||(e.SymbolKind=he={}));var fe;(function(j){j[j.Deprecated=1]="Deprecated"})(fe||(e.SymbolTag=fe={}));let Ce=f=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,re,Se,Ge,xe){this.name=z,this.kind=re,this.containerName=xe,typeof Se=="string"&&(this.containerName=Se),Ge instanceof Ie?this.location=Ge:Se instanceof U&&(this.location=new Ie(Ge,Se)),f.validate(this)}toJSON(){return{name:this.name,kind:he[this.kind],location:this.location,containerName:this.containerName}}};e.$EL=Ce,e.$EL=Ce=f=Ke([k],Ce);let de=n=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(n.validate)}constructor(z,re,Se,Ge,xe){this.name=z,this.detail=re,this.kind=Se,this.range=Ge,this.selectionRange=xe,this.children=[],n.validate(this)}};e.$FL=de,e.$FL=de=n=Ke([k],de);var ye;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(ye||(e.CodeActionTriggerKind=ye={}));let T=class{constructor(z,re){this.title=z,this.kind=re}};e.$GL=T,e.$GL=T=Ke([k],T);let H=class{static{w=this}static{this.c="."}constructor(z){this.value=z}append(z){return new w(this.value?this.value+w.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+w.c)}};e.$HL=H,e.$HL=H=w=Ke([k],H),H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorMove=H.Refactor.append("move"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll"),H.Notebook=H.Empty.append("notebook");let J=class{constructor(z,re){if(this.range=z,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$IL=J,e.$IL=J=Ke([k],J);class B{constructor(z,re,Se,Ge,xe,ut){this.kind=z,this.name=re,this.detail=Se,this.uri=Ge,this.range=xe,this.selectionRange=ut}}e.$JL=B;class Z{constructor(z,re){this.fromRanges=re,this.from=z}}e.$KL=Z;class _{constructor(z,re){this.fromRanges=re,this.to=z}}e.$LL=_;var ke;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(ke||(e.LanguageStatusSeverity=ke={}));let Ne=class{constructor(z,re){this.range=z,this.command=re}get isResolved(){return!!this.command}};e.$ML=Ne,e.$ML=Ne=Ke([k],Ne);let We=y=class{#e;static isMarkdownString(z){return z instanceof y?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,re=!1){this.#e=new I.$jk(z,{supportThemeIcons:re})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,re){return this.#e.appendCodeblock(re??"",z),this}};e.$NL=We,e.$NL=We=y=Ke([k],We);let He=class{constructor(z,re){this.label=z,this.documentation=re}};e.$OL=He,e.$OL=He=Ke([k],He);let Ye=class{constructor(z,re){this.label=z,this.documentation=re,this.parameters=[]}};e.$PL=Ye,e.$PL=Ye=Ke([k],Ye);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$QL=nt,e.$QL=nt=Ke([k],nt);var it;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var et;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(et||(e.InlayHintKind=et={}));let st=class{constructor(z){this.value=z}};e.$RL=st,e.$RL=st=Ke([k],st);let ct=class{constructor(z,re,Se){this.position=z,this.label=re,this.kind=Se}};e.$SL=ct,e.$SL=ct=Ke([k],ct);var Ue;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue||(e.CompletionTriggerKind=Ue={}));var $t;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})($t||(e.CompletionItemKind=$t={}));var Y;(function(j){j[j.Deprecated=1]="Deprecated"})(Y||(e.CompletionItemTag=Y={}));let X=class{constructor(z,re){this.label=z,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&$t[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$TL=X,e.$TL=X=Ke([k],X);let ve=class{constructor(z=[],re=!1){this.items=z,this.isIncomplete=re}};e.$UL=ve,e.$UL=ve=Ke([k],ve);let Be=class{constructor(z,re,Se){this.insertText=z,this.range=re,this.command=Se}};e.$VL=Be,e.$VL=Be=Ke([k],Be);let Qe=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$WL=Qe,e.$WL=Qe=Ke([k],Qe);var tt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(tt||(e.ViewColumn=tt={}));var ot;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function Fe(j,z){return`${D.$nm.toKey(j)}.${z}`}e.$XL=Fe;var Wt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval"})(Wt||(e.TextEditorLineNumbersStyle=Wt={}));var Mt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Mt||(e.TextDocumentSaveReason=Mt={}));var xt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(xt||(e.TextEditorRevealType=xt={}));var Nt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Nt||(e.TextEditorSelectionChangeKind=Nt={}));var Et;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Et||(e.TextDocumentChangeReason=Et={}));var Yt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Yt||(e.DecorationRangeBehavior=Yt={})),function(j){function z(re){switch(re){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=z}(Nt||(e.TextEditorSelectionChangeKind=Nt={}));var Ot;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Ot||(e.SyntaxTokenType=Ot={})),function(j){function z(re){switch(re){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=z}(Ot||(e.SyntaxTokenType=Ot={}));let ii=class{constructor(z,re){if(re&&!E.URI.isUri(re))throw(0,M.$7)("target");if(!U.isRange(z)||z.isEmpty)throw(0,M.$7)("range");this.range=z,this.target=re}};e.$YL=ii,e.$YL=ii=Ke([k],ii);let Qt=class{constructor(z,re,Se,Ge){this.red=z,this.green=re,this.blue=Se,this.alpha=Ge}};e.$ZL=Qt,e.$ZL=Qt=Ke([k],Qt);let Vt=class{constructor(z,re){if(re&&!(re instanceof Qt))throw(0,M.$7)("color");if(!U.isRange(z)||z.isEmpty)throw(0,M.$7)("range");this.range=z,this.color=re}};e.$1L=Vt,e.$1L=Vt=Ke([k],Vt);let Xe=class{constructor(z){if(!z||typeof z!="string")throw(0,M.$7)("label");this.label=z}};e.$2L=Xe,e.$2L=Xe=Ke([k],Xe);var Xt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Xt||(e.ColorFormat=Xt={}));var _t;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(_t||(e.SourceControlInputBoxValidationType=_t={}));var lt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(lt||(e.TerminalExitReason=lt={}));class pt{constructor(z,re,Se){if(this.startIndex=z,this.length=re,this.tooltip=Se,typeof z!="number"||z<0)throw(0,M.$7)("startIndex");if(typeof re!="number"||re<1)throw(0,M.$7)("length");if(Se!==void 0&&typeof Se!="string")throw(0,M.$7)("tooltip")}}e.$3L=pt;class qt{constructor(z){this.uri=z}}e.$4L=qt;class ei{constructor(z){this.terminalCommand=z}}e.$5L=ei;var kt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class dt{constructor(z){if(this.options=z,typeof z!="object")throw(0,M.$7)("options")}}e.$6L=dt;var Pt;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(Pt||(e.TaskRevealKind=Pt={}));var si;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(si||(e.TaskPanelKind=si={}));let Lt=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(z){switch(z){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(z,re){if(this.label=re,typeof z!="string"||typeof re!="string")throw(0,M.$7)("name");this.c=z}get id(){return this.c}};e.$7L=Lt,e.$7L=Lt=d=Ke([k],Lt);function qe(j){let z="";for(let re=0;re<j.length;re++)z+=j[re].replace(/,/g,",,")+",";return z}let Tt=class{constructor(z,re,Se){if(typeof z!="string")throw(0,M.$7)("process");this.e=[],this.c=z,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=Se):this.f=re)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,M.$7)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const re of this.e)z.push(re);return qe(z)}};e.$8L=Tt,e.$8L=Tt=Ke([k],Tt);let zt=class{constructor(z,re,Se){if(this.f=[],Array.isArray(re)){if(!z)throw(0,M.$7)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,M.$7)("command");this.e=z,this.f=re,this.g=Se}else{if(typeof z!="string")throw(0,M.$7)("commandLine");this.c=z,this.g=re}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,M.$7)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,M.$7)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)z.push(typeof re=="string"?re:re.value);return qe(z)}};e.$9L=zt,e.$9L=zt=Ke([k],zt);var ti;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(ti||(e.ShellQuoting=ti={}));var ft;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class Rt{constructor(z){this.c=z}computeId(){return"customExecution"+(0,A.$rg)()}set callback(z){this.c=z}get callback(){return this.c}}e.$0L=Rt;let Ct=class{static{b=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,re,Se,Ge,xe,ut){this.k=!1,this.l=this.definition=z;let gt;typeof re=="string"?(this.o=this.name=re,this.w=this.source=Se,this.execution=Ge,gt=xe,this.k=!0):re===ft.Global||re===ft.Workspace?(this.target=re,this.o=this.name=Se,this.w=this.source=Ge,this.execution=xe,gt=ut):(this.target=re,this.o=this.name=Se,this.w=this.source=Ge,this.execution=xe,gt=ut),typeof gt=="string"?(this.r=[gt],this.t=!0):Array.isArray(gt)?(this.r=gt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Tt?this.l={type:b.e,id:this.q.computeId()}:this.q instanceof zt?this.l={type:b.f,id:this.q.computeId()}:this.q instanceof Rt?this.l={type:b.c,id:this.q.computeId()}:this.l={type:b.g,id:(0,A.$rg)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,M.$7)("Kind can't be undefined or null");this.B(),this.l=z}get scope(){return this.m}set target(z){this.B(),this.m=z}get name(){return this.o}set name(z){if(typeof z!="string")throw(0,M.$7)("name");this.B(),this.o=z}get execution(){return this.q}set execution(z){z===null&&(z=void 0),this.B(),this.q=z;const re=this.l.type;(b.g===re||b.e===re||b.f===re||b.c===re)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(z){if(Array.isArray(z))this.B(),this.r=z,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.B(),this.u=z}get source(){return this.w}set source(z){if(typeof z!="string"||z.length===0)throw(0,M.$7)("source must be a string of length > 0");this.B(),this.w=z}get group(){return this.x}set group(z){z===null&&(z=void 0),this.B(),this.x=z}get detail(){return this.A}set detail(z){z===null&&(z=void 0),this.A=z}get presentationOptions(){return this.y}set presentationOptions(z){z==null&&(z=Object.create(null)),this.B(),this.y=z}get runOptions(){return this.z}set runOptions(z){z==null&&(z=Object.create(null)),this.B(),this.z=z}};e.$$L=Ct,e.$$L=Ct=b=Ke([k],Ct);var Ut;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Ut||(e.ProgressLocation=Ut={}));var Ht;(function(j){function z(re){const Se=re;return(0,h.$Nf)(Se.value)?Se.tooltip&&!(0,h.$Jf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}j.isViewBadge=z})(Ht||(e.ViewBadge=Ht={}));let jt=P=class{static isTreeItem(z,re){const Se=z;if(Se.checkboxState!==void 0){const Ge=(0,h.$Nf)(Se.checkboxState)?Se.checkboxState:(0,h.$Lf)(Se.checkboxState)&&(0,h.$Nf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,xe=!(0,h.$Nf)(Se.checkboxState)&&(0,h.$Lf)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Kt.Checked&&Ge!==Kt.Unchecked||xe!==void 0&&!(0,h.$Jf)(xe))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(z instanceof P)return!0;if(Se.label!==void 0&&!(0,h.$Jf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,h.$Jf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,h.$Jf)(Se.iconPath)&&!E.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,h.$Jf)(Se.iconPath.id))){const Ge=Se.iconPath;if(!Ge||!(0,h.$Jf)(Ge.light)&&!E.URI.isUri(Ge.light)&&!(0,h.$Jf)(Ge.dark)&&!E.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,h.$Jf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!E.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,h.$Jf)(Se.tooltip)&&!(Se.tooltip instanceof We)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<It.None&&Se.collapsibleState>It.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,h.$Jf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(z,re=It.None){this.collapsibleState=re,E.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$_L=jt,e.$_L=jt=P=Ke([k],jt);var It;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(It||(e.TreeItemCollapsibleState=It={}));var Kt;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(Kt||(e.TreeItemCheckboxState=Kt={}));let yt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$aM=yt,e.$aM=yt=Ke([k],yt);class wt extends yt{}e.$bM=wt;class Dt extends wt{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$cM=Dt;class be{constructor(z,re,Se,Ge){this.name=z,this.uri=re,this._itemId=Se,this.c=Ge}data(){return this.c()}}e.$dM=be;let Te=class{#e=new Map;constructor(z){for(const[re,Se]of z??[]){const Ge=this.#e.get(this.#t(re));Ge?Ge.push(Se):this.#e.set(this.#t(re),[Se])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,re){this.#e.set(this.#t(z),[re])}forEach(z,re){for(const[Se,Ge]of this.#e)for(const xe of Ge)z.call(re,xe,Se,this)}*[Symbol.iterator](){for(const[z,re]of this.#e)for(const Se of re)yield[z,Se]}#t(z){return z.toLowerCase()}};e.$eM=Te,e.$eM=Te=Ke([k],Te);let ae=class{constructor(z){this.insertText=z}};e.$fM=ae,e.$fM=ae=Ke([k],ae);let Q=class{constructor(z,re){this.label=re,this.insertText=z}};e.$gM=Q,e.$gM=Q=Ke([k],Q);let Pe=class{constructor(z,re){this.id=z,this.color=re}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$hM=Pe,e.$hM=Pe=Ke([k],Pe),Pe.File=new Pe("file"),Pe.Folder=new Pe("folder");let je=class{constructor(z){this.id=z}};e.$iM=je,e.$iM=je=Ke([k],je);var Ze;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Ze||(e.ConfigurationTarget=Ze={}));let Je=class{get base(){return this.c}set base(z){this.c=z,this.e=E.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,re){if(typeof z!="string"&&(!z||!E.URI.isUri(z)&&!E.URI.isUri(z.uri)))throw(0,M.$7)("base");if(typeof re!="string")throw(0,M.$7)("pattern");typeof z=="string"?this.baseUri=E.URI.file(z):E.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$jM=Je,e.$jM=Je=Ke([k],Je);const at=new WeakMap;function mt(j,z){at.set(j,z)}e.$kM=mt;let Ft=class{constructor(z,re,Se,Ge){this.enabled=typeof z=="boolean"?z:!0,typeof re=="string"&&(this.condition=re),typeof Se=="string"&&(this.hitCondition=Se),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=at.get(this)??(0,A.$rg)()),this.c}};e.$lM=Ft,e.$lM=Ft=Ke([k],Ft);let Gt=class extends Ft{constructor(z,re,Se,Ge,xe){if(super(re,Se,Ge,xe),z===null)throw(0,M.$7)("location");this.location=z}};e.$mM=Gt,e.$mM=Gt=Ke([k],Gt);let St=class extends Ft{constructor(z,re,Se,Ge,xe){super(re,Se,Ge,xe),this.functionName=z}};e.$nM=St,e.$nM=St=Ke([k],St);let Jt=class extends Ft{constructor(z,re,Se,Ge,xe,ut,gt){if(super(Ge,xe,ut,gt),!re)throw(0,M.$7)("dataId");this.label=z,this.dataId=re,this.canPersist=Se}};e.$oM=Jt,e.$oM=Jt=Ke([k],Jt);let Ci=class{constructor(z,re,Se){this.command=z,this.args=re||[],this.options=Se}};e.$pM=Ci,e.$pM=Ci=Ke([k],Ci);let Bt=class{constructor(z,re){this.port=z,this.host=re}};e.$qM=Bt,e.$qM=Bt=Ke([k],Bt);let bi=class{constructor(z){this.path=z}};e.$rM=bi,e.$rM=bi=Ke([k],bi);let Pi=class{constructor(z){this.implementation=z}};e.$sM=Pi,e.$sM=Pi=Ke([k],Pi);let gi=class{constructor(z,re,Se){this.session=z,this.threadId=re,this.frameId=Se}};e.$tM=gi,e.$tM=gi=Ke([k],gi);let mi=class{constructor(z,re){this.session=z,this.threadId=re}};e.$uM=mi,e.$uM=mi=Ke([k],mi);let ht=class{constructor(z,re){this.range=z,this.expression=re}};e.$vM=ht,e.$vM=ht=Ke([k],ht);var Qi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Qi||(e.InlineCompletionTriggerKind=Qi={}));let oi=class{constructor(z,re){this.range=z,this.text=re}};e.$wM=oi,e.$wM=oi=Ke([k],oi);let hi=class{constructor(z,re,Se=!0){this.range=z,this.variableName=re,this.caseSensitiveLookup=Se}};e.$xM=hi,e.$xM=hi=Ke([k],hi);let wi=class{constructor(z,re){this.range=z,this.expression=re}};e.$yM=wi,e.$yM=wi=Ke([k],wi);let Li=class{constructor(z,re){this.frameId=z,this.stoppedLocation=re}};e.$zM=Li,e.$zM=Li=Ke([k],Li);var Zi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Zi||(e.FileChangeType=Zi={}));let Ri=g=class extends Error{static FileExists(z){return new g(z,l.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(z){return new g(z,l.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(z){return new g(z,l.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(z){return new g(z,l.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(z){return new g(z,l.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(z){return new g(z,l.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}constructor(z,re=l.FileSystemProviderErrorCode.Unknown,Se){super(E.URI.isUri(z)?z.toString(!0):z),this.code=Se?.name??"Unknown",(0,l.$Hk)(this,re),Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$AM=Ri,e.$AM=Ri=g=Ke([k],Ri);let yi=class{constructor(z,re,Se){this.start=z,this.end=re,this.kind=Se}};e.$BM=yi,e.$BM=yi=Ke([k],yi);var Yi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Yi||(e.FoldingRangeKind=Yi={}));var Ai;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var $i;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})($i||(e.CommentMode=$i={}));var Xi;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Xi||(e.CommentState=Xi={}));var Ei;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Ei||(e.CommentThreadState=Ei={}));class Mi{constructor(z,re=[]){this.tokenTypes=z,this.tokenModifiers=re}}e.$CM=Mi;function ln(j){return typeof j>"u"||(0,h.$Kf)(j)}class Ti{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let re=0,Se=z.tokenTypes.length;re<Se;re++)this.k.set(z.tokenTypes[re],re);for(let re=0,Se=z.tokenModifiers.length;re<Se;re++)this.l.set(z.tokenModifiers[re],re)}}push(z,re,Se,Ge,xe){if(typeof z=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Ge=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.q(z,re,Se,Ge,xe);if(U.isRange(z)&&typeof re=="string"&&ln(Se))return this.o(z,re,Se);throw(0,M.$7)()}o(z,re,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(re))throw new Error("`tokenType` is not in the provided legend");const Ge=z.start.line,xe=z.start.character,ut=z.end.character-z.start.character,gt=this.k.get(re);let Zt=0;if(Se)for(const ri of Se){if(!this.l.has(ri))throw new Error("`tokenModifier` is not in the provided legend");const ci=this.l.get(ri);Zt|=1<<ci>>>0}this.q(Ge,xe,ut,gt,Zt)}q(z,re,Se,Ge,xe){if(this.f&&(z<this.c||z===this.c&&re<this.e)){this.f=!1;const Zt=this.g.length/5|0;let ri=0,ci=0;for(let li=0;li<Zt;li++){let fi=this.g[5*li],Gi=this.g[5*li+1];fi===0?(fi=ri,Gi+=ci):fi+=ri,this.g[5*li]=fi,this.g[5*li+1]=Gi,ri=fi,ci=Gi}}let ut=z,gt=re;this.f&&this.j>0&&(ut-=this.c,ut===0&&(gt-=this.e)),this.g[this.j++]=ut,this.g[this.j++]=gt,this.g[this.j++]=Se,this.g[this.j++]=Ge,this.g[this.j++]=xe,this.c=z,this.e=re}static r(z){const re=[],Se=z.length/5|0;for(let gt=0;gt<Se;gt++)re[gt]=gt;re.sort((gt,Zt)=>{const ri=z[5*gt],ci=z[5*Zt];if(ri===ci){const li=z[5*gt+1],fi=z[5*Zt+1];return li-fi}return ri-ci});const Ge=new Uint32Array(z.length);let xe=0,ut=0;for(let gt=0;gt<Se;gt++){const Zt=5*re[gt],ri=z[Zt+0],ci=z[Zt+1],li=z[Zt+2],fi=z[Zt+3],Gi=z[Zt+4],Cn=ri-xe,Kn=Cn===0?ci-ut:ci,Ji=5*gt;Ge[Ji+0]=Cn,Ge[Ji+1]=Kn,Ge[Ji+2]=li,Ge[Ji+3]=fi,Ge[Ji+4]=Gi,xe=ri,ut=ci}return Ge}build(z){return this.f?new di(new Uint32Array(this.g),z):new di(Ti.r(this.g),z)}}e.$DM=Ti;class di{constructor(z,re){this.resultId=re,this.data=z}}e.$EM=di;class hn{constructor(z,re,Se){this.start=z,this.deleteCount=re,this.data=Se}}e.$FM=hn;class dn{constructor(z,re){this.resultId=re,this.edits=z}}e.$GM=dn;var xi;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(xi||(e.DebugConsoleMode=xi={}));class Fi{constructor(z){this.name=z}}e.$HM=Fi;let Ni=class{static{this.Back={iconPath:new Pe("arrow-left")}}constructor(){}};e.$IM=Ni,e.$IM=Ni=Ke([k],Ni);var _i;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(_i||(e.QuickPickItemKind=_i={}));var ki;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(ki||(e.InputBoxValidationSeverity=ki={}));var Oi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Oi||(e.ExtensionKind=Oi={}));class fn{static validate(z){if(typeof z.badge=="string"){let re=(0,m.$kf)(z.badge,0);if(re<z.badge.length&&(re+=(0,m.$kf)(z.badge,re)),z.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!Pe.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,re,Se){this.badge=z,this.tooltip=re,this.color=Se}}e.$JM=fn;let Di=class{constructor(z){this.kind=z}};e.$KM=Di,e.$KM=Di=Ke([k],Di);var zi;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(zi||(e.ColorThemeKind=zi={}));class ui{static isNotebookRange(z){return z instanceof ui?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,re){if(z<0)throw(0,M.$7)("start must be positive");if(re<0)throw(0,M.$7)("end must be positive");z<=re?(this.c=z,this.e=re):(this.c=re,this.e=z)}with(z){let re=this.c,Se=this.e;return z.start!==void 0&&(re=z.start),z.end!==void 0&&(Se=z.end),re===this.c&&Se===this.e?this:new ui(re,Se)}}e.$LM=ui;class Si{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(re=>Si.isNotebookCellData(re))}static isNotebookCellData(z){return!0}constructor(z,re,Se,Ge,xe,ut,gt){this.kind=z,this.value=re,this.languageId=Se,this.mime=Ge,this.outputs=xe??[],this.metadata=ut,this.executionSummary=gt,Si.validate(this)}}e.$MM=Si;class gn{constructor(z){this.cells=z}}e.$NM=gn;class ni{static isNotebookCellOutputItem(z){return z instanceof ni?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const re={name:z.name,message:z.message,stack:z.stack};return ni.json(re,"application/vnd.code.notebook.error")}static stdout(z){return ni.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return ni.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,re="application/octet-stream"){return new ni(z,re)}static#e=new TextEncoder;static text(z,re=L.$hs.text){const Se=ni.#e.encode(String(z));return new ni(Se,re)}static json(z,re="text/x-json"){const Se=JSON.stringify(z,void 0,"	");return ni.text(Se,re)}constructor(z,re){this.data=z,this.mime=re;const Se=(0,L.$ls)(re,!0);if(!Se)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$OM=ni;class pi{static isNotebookCellOutput(z){return z instanceof pi?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,re=!1){const Se=new Set,Ge=new Set;for(let xe=0;xe<z.length;xe++){const ut=z[xe],gt=(0,L.$ls)(ut.mime);if(!Se.has(gt)||(0,p.$nJ)(gt)){Se.add(gt);continue}Ge.add(xe),re&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Ge.size===0?z:z.filter((xe,ut)=>!Ge.has(ut))}constructor(z,re,Se){this.items=pi.ensureUniqueMimeTypes(z,!0),typeof re=="string"?(this.id=re,this.metadata=Se):(this.id=(0,A.$rg)(),this.metadata=re??Se)}}e.$PM=pi;var Ui;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Ui||(e.NotebookCellKind=Ui={}));var ze;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(ze||(e.NotebookCellExecutionState=ze={}));var ai;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(ai||(e.NotebookCellStatusBarAlignment=ai={}));var ji;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(ji||(e.NotebookEditorRevealType=ji={}));class _e{constructor(z,re){this.text=z,this.alignment=re}}e.$QM=_e;var vt;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(vt||(e.NotebookControllerAffinity=vt={}));var en;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(en||(e.NotebookControllerAffinity2=en={}));class mn{constructor(z,re=[]){this.uri=z,this.provides=(0,S.$3b)(re)}}e.$RM=mn;class tn{constructor(z){this.label=z}}e.$SM=tn;var nn;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let vi=class{constructor(z,re){this.label=z,this.timestamp=re}};e.$TM=vi,e.$TM=vi=Ke([k],vi);var rn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class an{constructor(z,re){this.ranges=z,this.wordPattern=re}}e.$UM=an;class $n{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$VM=$n;var cn;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Bi=class{constructor(z=void 0,re=void 0,Se=void 0,Ge=!1){this.include=z,this.exclude=re,this.profile=Se,this.continuous=Ge}};e.$WM=Bi,e.$WM=Bi=Ke([k],Bi);let Wi=v=class{static diff(z,re,Se){const Ge=new v(z);return Ge.expectedOutput=re,Ge.actualOutput=Se,Ge}constructor(z){this.message=z}};e.$XM=Wi,e.$XM=Wi=v=Ke([k],Wi);let Vi=class{constructor(z){this.id=z}};e.$YM=Vi,e.$YM=Vi=Ke([k],Vi);class Ii{constructor(z,re){this.covered=z,this.total=re}}e.$ZM=Ii;const qi=j=>{if(j&&j.covered>j.total)throw new Error(`The total number of covered items (${j.covered}) cannot be greater than the total (${j.total})`)};class Hi{static fromDetails(z,re){const Se=new Ii(0,0),Ge=new Ii(0,0),xe=new Ii(0,0);for(const gt of re)if("branches"in gt){Se.total+=1,Se.covered+=gt.executed?1:0;for(const Zt of gt.branches)Ge.total+=1,Ge.covered+=Zt.executed?1:0}else xe.total+=1,xe.covered+=gt.executed?1:0;const ut=new Hi(z,Se,Ge.total>0?Ge:void 0,xe.total>0?xe:void 0);return ut.detailedCoverage=re,ut}constructor(z,re,Se,Ge){this.uri=z,this.statementCoverage=re,this.branchCoverage=Se,this.functionCoverage=Ge,qi(re),qi(Se),qi(Ge)}}e.$1M=Hi;class pn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,re,Se=[]){this.executed=z,this.location=re,this.branches=Se}}e.$2M=pn;class te{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,re,Se){this.executed=z,this.location=re,this.label=Se}}e.$3M=te;class ue{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,re,Se){this.name=z,this.executed=re,this.location=Se}}e.$4M=ue;var Oe;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Oe||(e.ExternalUriOpenerPriority=Oe={}));var rt;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(rt||(e.WorkspaceTrustState=rt={}));var bt;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(bt||(e.PortAutoForwardAction=bt={}));class At{constructor(z,re,Se,Ge,xe,ut){this.kind=z,this.name=re,this.detail=Se,this.uri=Ge,this.range=xe,this.selectionRange=ut}}e.$5M=At;class Ki{constructor(z){this.uri=z}}e.$6M=Ki;class Pn{constructor(z,re){this.original=z,this.modified=re}}e.$7M=Pn;class Ln{constructor(z,re,Se,Ge){this.base=z,this.input1=re,this.input2=Se,this.result=Ge}}e.$8M=Ln;class Rn{constructor(z,re){this.uri=z,this.viewType=re}}e.$9M=Rn;class An{constructor(z){this.viewType=z}}e.$0M=An;class Mn{constructor(z,re){this.uri=z,this.notebookType=re}}e.$$M=Mn;class Tn{constructor(z,re,Se){this.original=z,this.modified=re,this.notebookType=Se}}e.$_M=Tn;class Fn{constructor(){}}e.$aN=Fn;class Nn{constructor(z,re){this.uri=z,this.inputBoxUri=re}}e.$bN=Nn;class On{constructor(z){this.providerId=z}}e.$cN=On;var vn;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(vn||(e.InteractiveSessionVoteDirection=vn={}));var bn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(bn||(e.ChatAgentCopyKind=bn={}));var wn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class zn{constructor(z,re){this.label=z,this.values=re}}e.$dN=zn;var yn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));class Un{constructor(z,re){this.role=z,this.content=re}}e.$eN=Un;var kn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));class jn{constructor(z){this.value=z}}e.$fN=jn;class Bn{constructor(z){this.value=z}}e.$gN=Bn;class Wn{constructor(z){this.value=z}}e.$hN=Wn;class Vn{constructor(z,re){this.value=z,this.title=re}}e.$iN=Vn;class qn{constructor(z){this.value=z}}e.$jN=qn;class Hn{constructor(z){this.value=z}}e.$kN=Hn;var Dn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var Sn;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}));var In;(function(j){j[j.Recognized=1]="Recognized",j[j.Stopped=2]="Stopped"})(In||(e.KeywordRecognitionStatus=In={}))}),define(Re[238],Ae([1,0,3,7]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0;class I{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(S.$kL.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,m,h){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(L);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(m,h)??[]}getRelatedInformation(L,m,h){return this.c.$getAiRelatedInformation(m,h)}registerRelatedInformationProvider(L,m,h){const E=this.b;return this.b++,this.a.set(E,h),this.c.$registerAiRelatedInformationProvider(E,m),new M.$mL(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$bgc=I}),define(Re[239],Ae([1,0,5,3,7,22]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;class L{constructor(E){this.b=new Map,this.c=new S.$Wd,this.onDidChangeSessions=this.c.event,this.d=new m,this.f=new m,this.a=E.getProxy(M.$kL.MainThreadAuthentication)}async getSession(E,A,D,l={}){const $=R.$nm.toKey(E.identifier),p=[...D].sort().join(" ");return await this.d.getOrCreate(`${$} ${A} ${p}`,async()=>{await this.a.$ensureProvider(A);const r=E.displayName||E.name;return this.a.$getSession(A,D,$,r,l)})}async getSessions(E,A,D){const l=R.$nm.toKey(E.identifier),$=[...D].sort().join(" ");return await this.f.getOrCreate(`${l} ${$}`,async()=>{await this.a.$ensureProvider(A);const p=E.displayName||E.name;return this.a.$getSessions(A,D,l,p)})}async removeSession(E,A){const D=this.b.get(E);return D?D.provider.removeSession(A):this.a.$removeSession(E,A)}registerAuthenticationProvider(E,A,D,l){if(this.b.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this.b.set(E,{label:A,provider:D,options:l??{supportsMultipleAccounts:!1}});const $=D.onDidChangeSessions(p=>this.a.$sendDidChangeSessions(E,p));return this.a.$registerAuthenticationProvider(E,A,l?.supportsMultipleAccounts??!1),new I.$mL(()=>{$.dispose(),this.b.delete(E),this.a.$unregisterAuthenticationProvider(E)})}$createSession(E,A,D){const l=this.b.get(E);if(l)return Promise.resolve(l.provider.createSession(A,D));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,A){const D=this.b.get(E);if(D)return Promise.resolve(D.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,A){const D=this.b.get(E);if(D)return Promise.resolve(D.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,A){return this.c.fire({provider:{id:E,label:A}}),Promise.resolve()}}e.$mgc=L;class m{constructor(){this.a=new Map}getOrCreate(E,A){const D=this.a.get(E);if(D)return D;const l=A().finally(()=>this.a.delete(E));return this.a.set(E,l),l}}}),define(Re[107],Ae([1,0,2,3,7,4,17,13,18,14,19,24]),function(me,e,S,M,I,R,L,m,h,E,A,D){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=e.$lhc=void 0;let $=class{static{l=this}static{this.c=0}static{this.d=250}constructor(r,c){this.h=c,this.f=new Map,this.g=r.getProxy(M.$kL.MainThreadDecorations)}registerFileDecorationProvider(r,c){const s=l.c++;this.f.set(s,{provider:r,extensionDescription:c}),this.g.$registerDecorationProvider(s,c.identifier.value);const i=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(o=>{if(!o){this.g.$onDidChange(s,null);return}const a=(0,h.$3b)(o);if(a.length<=l.d){this.g.$onDidChange(s,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",c.identifier.value,a.length);const u=a.map(n=>({uri:n,rank:(0,E.$Qe)(n.path,"/")})),t=(0,h.$zb)(u,(n,w)=>n.rank-w.rank||(0,E.$6e)(n.uri.path,w.uri.path)),f=[];e:for(const n of t){let w;for(const y of n){const d=(0,A.$mc)(y.uri.path);if(w!==d&&(w=d,f.push(y.uri)>=l.d))break e}}this.g.$onDidChange(s,f)});return new I.$mL(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(r,c,s){if(!this.f.has(r))return Object.create(null);const i=Object.create(null),{provider:o,extensionDescription:a}=this.f.get(r);return await Promise.all(c.map(async u=>{try{const{uri:t,id:f}=u,n=await Promise.resolve(o.provideFileDecoration(S.URI.revive(t),s));if(!n)return;try{I.$JM.validate(n),n.badge&&typeof n.badge!="string"&&(0,D.$LF)(a,"codiconDecoration"),i[f]=[n.propagate,n.tooltip,n.badge,n.color]}catch(w){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${w}`)}}catch(t){this.h.error(t)}})),i}};e.$lhc=$,e.$lhc=$=l=Ke([Ve(0,L.$vN),Ve(1,m.$pj)],$),e.$mhc=(0,R.$8h)("IExtHostDecorations")}),define(Re[240],Ae([1,0,15,2,7,3,12,21,14]),function(me,e,S,M,I,R,L,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=void 0;class E{static{this.a=0}constructor(D,l,$){this.d=l,this.e=$,this.b=new Map,this.c=D.getProxy(R.$kL.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,l){if(Object.keys(L.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const $=E.a++;this.b.set($,l),this.c.$registerTextContentProvider($,D);let p;if(typeof l.onDidChange=="function"){let r;p=l.onDidChange(async c=>{if(c.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${c.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(c))return;r&&await r;const s=this.$provideTextDocumentContent($,c).then(async i=>{if(!i&&typeof i!="string")return;const o=this.d.getDocument(c);if(!o)return;const a=(0,h.$1e)(i);if(!o.equalLines(a))return this.c.$onVirtualDocumentChange(c,i)}).catch(S.$1).finally(()=>{r===s&&(r=void 0)});r=s})}return new I.$mL(()=>{this.b.delete($)&&this.c.$unregisterTextContentProvider($),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(D,l){const $=this.b.get(D);return $?Promise.resolve($.provideTextDocumentContent(M.URI.revive(l),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$ohc=E}),define(Re[108],Ae([1,0,54,12,14,296,147,7,18]),function(me,e,S,M,I,R,L,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zN=e.$yN=e.$xN=void 0;const E=new Map;function A(p,r){r?E.set(p,r):E.delete(p)}e.$xN=A;function D(p){return E.get(p)}class l extends R.$nv{constructor(r,c,s,i,o,a,u,t){super(c,s,i,o),this.c=r,this.m=a,this.q=u,this.notebook=t,this.b=!1}dispose(){(0,S.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,h.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===M.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(c){return c?r.s(c):r.getText()},get eol(){return r.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(c){return r.t(c)},offsetAt(c){return r.u(c)},positionAt(c){return r.v(c)},validateRange(c){return r.w(c)},validatePosition(c){return r.x(c)},getWordRangeAtPosition(c,s){return r.y(c,s)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,S.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,S.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const c=this.w(r);if(c.isEmpty)return"";if(c.isSingleLine)return this.f[c.start.line].substring(c.start.character,c.end.character);const s=this.g,i=c.start.line,o=c.end.line,a=[];a.push(this.f[i].substring(c.start.character));for(let u=i+1;u<o;u++)a.push(this.f[u]);return a.push(this.f[o].substring(0,c.end.character)),a.join(s)}t(r){let c;if(r instanceof m.$nL?c=r.line:typeof r=="number"&&(c=r),typeof c!="number"||c<0||c>=this.f.length||Math.floor(c)!==c)throw new Error("Illegal value for `line`");return new $(c,this.f[c],c===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const c=this.j.getIndexOf(r),s=this.f[c.index].length;return new m.$nL(c.index,Math.min(c.remainder,s))}w(r){if(!(r instanceof m.$oL))throw new Error("Invalid argument");const c=this.x(r.start),s=this.x(r.end);return c===r.start&&s===r.end?r:new m.$oL(c.line,c.character,s.line,s.character)}x(r){if(!(r instanceof m.$nL))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:c,character:s}=r,i=!1;if(c<0)c=0,s=0,i=!0;else if(c>=this.f.length)c=this.f.length-1,s=this.f[c].length,i=!0;else{const o=this.f[c].length;s<0?(s=0,i=!0):s>o&&(s=o,i=!0)}return i?new m.$nL(c,s):r}y(r,c){const s=this.x(r);if(!c)c=D(this.m);else if((0,I.$Ze)(c))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${c.source}' because it matches the empty string.`);const i=(0,L.$zs)(s.character+1,(0,L.$xs)(c),this.f[s.line],0);if(i)return new m.$oL(s.line,i.startColumn-1,s.line,i.endColumn-1)}}e.$yN=l;class ${constructor(r,c,s){this.a=r,this.b=c,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$oL(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$oL(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$zN=$}),define(Re[241],Ae([1,0,3,7]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=void 0;class I{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(S.$kL.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,m,h){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(L);if(!E)throw new Error("Embedding vector provider not found");const A=await E.provideEmbeddingVector(m,h);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(L,m,h){const E=this.b;return this.b++,this.a.set(E,h),this.c.$registerAiEmbeddingVectorProvider(m,E),new M.$mL(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$qhc=I}),define(Re[62],Ae([1,0,3,42,7,23,4,17,43,6,11,25,12]),function(me,e,S,M,I,R,L,m,h,E,A,D,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=e.$Dgc=void 0;let p=$=class{constructor(c,s){this.b=new Map,this.c=new A.$eh,this.a=c.getProxy(S.$kL.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(o){try{let a;const u=i.b.get(o.scheme);return u?(await i.a.$ensureActivation(o.scheme),a=await u.impl.stat(o)):a=await i.a.$stat(o),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===M.FilePermission.Readonly?1:void 0}}catch(a){$.e(a)}},async readDirectory(o){try{const a=i.b.get(o.scheme);return a?(await i.a.$ensureActivation(o.scheme),(await a.impl.readDirectory(o)).slice()):await i.a.$readdir(o)}catch(a){return $.e(a)}},async createDirectory(o){try{const a=i.b.get(o.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(o.scheme),await i.d(a.impl,a.extUri,o)):await i.a.$mkdir(o)}catch(a){return $.e(a)}},async readFile(o){try{const a=i.b.get(o.scheme);return a?(await i.a.$ensureActivation(o.scheme),(await a.impl.readFile(o)).slice()):(await i.a.$readFile(o)).buffer}catch(a){return $.e(a)}},async writeFile(o,a){try{const u=i.b.get(o.scheme);return u&&!u.isReadonly?(await i.a.$ensureActivation(o.scheme),await i.d(u.impl,u.extUri,u.extUri.dirname(o)),await i.c.queueFor(o,()=>Promise.resolve(u.impl.writeFile(o,a,{create:!0,overwrite:!0})))):await i.a.$writeFile(o,R.$ke.wrap(a))}catch(u){return $.e(u)}},async delete(o,a){try{const u=i.b.get(o.scheme);return u&&!u.isReadonly&&!a?.useTrash?(await i.a.$ensureActivation(o.scheme),await u.impl.delete(o,{recursive:!1,...a})):await i.a.$delete(o,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(u){return $.e(u)}},async rename(o,a,u){try{return await i.a.$rename(o,a,{overwrite:!1,...u})}catch(t){return $.e(t)}},async copy(o,a,u){try{return await i.a.$copy(o,a,{overwrite:!1,...u})}catch(t){return $.e(t)}},isWritableFileSystem(o){const a=s.getCapabilities(o);if(typeof a=="number")return!(a&2048)}})}async d(c,s,i){const o=[];for(;!s.isEqual(i,s.dirname(i));)try{if(!((await c.stat(i)).type&M.FileType.Directory))throw I.$AM.FileExists(`Unable to create folder '${i.scheme===l.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(M.$Ik(a)!==M.FileSystemProviderErrorCode.FileNotFound)throw a;o.push(s.basename(i)),i=s.dirname(i)}for(let a=o.length-1;a>=0;a--){i=s.joinPath(i,o[a]);try{await c.createDirectory(i)}catch(u){if(M.$Ik(u)!==M.FileSystemProviderErrorCode.FileExists)throw u}}}static e(c){if(c instanceof I.$AM)throw c;if(c instanceof M.$Ek)switch(c.code){case M.FileSystemProviderErrorCode.FileExists:throw I.$AM.FileExists(c.message);case M.FileSystemProviderErrorCode.FileNotFound:throw I.$AM.FileNotFound(c.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw I.$AM.FileNotADirectory(c.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw I.$AM.FileIsADirectory(c.message);case M.FileSystemProviderErrorCode.NoPermissions:throw I.$AM.NoPermissions(c.message);case M.FileSystemProviderErrorCode.Unavailable:throw I.$AM.Unavailable(c.message);default:throw new I.$AM(c.message,c.name)}if(!(c instanceof Error))throw new I.$AM(String(c));if(c.name==="ENOPRO"||c.message.includes("ENOPRO"))throw I.$AM.Unavailable(c.message);switch(c.name){case M.FileSystemProviderErrorCode.FileExists:throw I.$AM.FileExists(c.message);case M.FileSystemProviderErrorCode.FileNotFound:throw I.$AM.FileNotFound(c.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw I.$AM.FileNotADirectory(c.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw I.$AM.FileIsADirectory(c.message);case M.FileSystemProviderErrorCode.NoPermissions:throw I.$AM.NoPermissions(c.message);case M.FileSystemProviderErrorCode.Unavailable:throw I.$AM.Unavailable(c.message);default:throw new I.$AM(c.message,c.name)}}addFileSystemProvider(c,s,i){return this.b.set(c,{impl:s,extUri:i?.isCaseSensitive?D.$yg:D.$Ag,isReadonly:!!i?.isReadonly}),(0,E.$Rc)(()=>this.b.delete(c))}getFileSystemProviderExtUri(c){return this.b.get(c)?.extUri??D.$yg}};e.$Dgc=p,e.$Dgc=p=$=Ke([Ve(0,m.$vN),Ve(1,h.$egc)],p),e.$Egc=(0,L.$8h)("IExtHostConsumerFileSystem")}),define(Re[242],Ae([1,0,3,7]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0;class I{constructor(L){this.a=new Map,this.b=new Map,this.c=L.getProxy(S.$kL.MainThreadIssueReporter)}async $getIssueReporterUri(L,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const h=this.a.get(L);if(!h)throw new Error("Issue request handler not found");const E=await h.handleIssueUrlRequest();if(!E)throw new Error("Issue request handler returned no result");return E}async $getIssueReporterData(L,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const h=this.b.get(L);if(!h)throw new Error("Issue data provider not found");const E=await h.provideIssueData(m);if(!E)throw new Error("Issue data provider returned no result");return E}async $getIssueReporterTemplate(L,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const h=this.b.get(L);if(!h)throw new Error("Issue data provider not found");const E=await h.provideIssueTemplate(m);if(!E)throw new Error("Issue template provider returned no result");return E}registerIssueUriRequestHandler(L,m){const h=L.identifier.value;return this.a.set(h,m),this.c.$registerIssueUriRequestHandler(h),new M.$mL(()=>{this.c.$unregisterIssueUriRequestHandler(h),this.a.delete(h)})}registerIssueDataProvider(L,m){const h=L.identifier.value;return this.b.set(h,m),this.c.$registerIssueDataProvider(h),new M.$mL(()=>{this.c.$unregisterIssueDataProvider(h),this.b.delete(h)})}}e.$Hhc=I}),define(Re[84],Ae([1,0,4,27,13,62,2]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=e.$Fgc=void 0,e.$Fgc=(0,S.$8h)("IExtensionStoragePaths");let m=class{constructor(E,A,D){this.d=A,this.f=D,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(E){return L.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,A=await this.g(E);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(L.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(E){if(this.c)return L.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return L.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Ggc=m,e.$Ggc=m=Ke([Ve(0,M.$LN),Ve(1,I.$pj),Ve(2,R.$Egc)],m)}),define(Re[243],Ae([1,0,7,17,5]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;let R=class{constructor(m){this.a=new S.$KM(S.ColorThemeKind.Dark),this.b=new I.$Wd}get activeColorTheme(){return this.a}$onColorThemeChange(m){let h;switch(m){case"light":h=S.ColorThemeKind.Light;break;case"hcDark":h=S.ColorThemeKind.HighContrast;break;case"hcLight":h=S.ColorThemeKind.HighContrastLight;break;default:h=S.ColorThemeKind.Dark}this.a=new S.$KM(h),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$$hc=R,e.$$hc=R=Ke([Ve(0,M.$vN)],R)}),define(Re[85],Ae([1,0,21,5,6,167,4,13,196,3,27,17,7]),function(me,e,S,M,I,R,L,m,h,E,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rzb=e.$qzb=e.TunnelDtoConverter=void 0;class $ extends h.$Lv{}var p;(function(c){function s(o){return{remoteAddress:o.remoteAddress,localAddress:o.localAddress,public:!!o.public,privacy:o.privacy??(o.public?h.TunnelPrivacyId.Public:h.TunnelPrivacyId.Private),protocol:o.protocol}}c.fromApiTunnel=s;function i(o){return{remoteAddress:{host:o.tunnelRemoteHost,port:o.tunnelRemotePort},localAddress:o.localAddress,public:o.privacy!==h.TunnelPrivacyId.ConstantPrivate&&o.privacy!==h.TunnelPrivacyId.ConstantPrivate,privacy:o.privacy,protocol:o.protocol}}c.fromServiceTunnel=i})(p||(e.TunnelDtoConverter=p={})),e.$qzb=(0,L.$8h)("IExtHostTunnelService");let r=class extends I.$Tc{constructor(s,i,o){super(),this.s=o,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Wd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(E.$kL.MainThreadTunnelService)}async openTunnel(s,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const o=await this.a.$openTunnel(i,s.displayName);if(o){const a=new $(o.remoteAddress,o.localAddress,()=>this.a.$closeTunnel(o.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,i){const o=this.u();return this.r.set(o,{selector:s,provider:i}),this.a.$registerPortsAttributesProvider(s,o),new l.$mL(()=>{this.r.delete(o),this.a.$unregisterPortsAttributesProvider(o)})}async $providePortAttributes(s,i,o,a,u){const t=[];for(const n of s){const w=this.r.get(n);if(!w)return[];t.push(...await Promise.all(i.map(async y=>{let d;try{d=await w.provider.providePortAttributes({port:y,pid:o,commandLine:a},u)}catch{d=await w.provider.providePortAttributes(y,o,a,u)}return{providedAttributes:d,port:y}})))}const f=t.filter(n=>!!n.providedAttributes);return f.length>0?f.map(n=>({autoForwardAction:n.providedAttributes.autoForwardAction,port:n.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,u)=>await s.provideTunnel(a,u,new S.$7d().token)??void 0;const o=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(o),Promise.resolve((0,I.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,i){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const o=s.tunnelFactory??(i?this.w(i):void 0);if(o){this.b=o;let a=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const u=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this.a.$setTunnelProvider(u)}}else this.b=void 0;return(0,I.$Rc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,i){if(this.g.has(s.host)){const o=this.g.get(s.host);o.has(s.port)&&(i&&o.get(s.port).disposeListener.dispose(),await o.get(s.port).tunnel.dispose(),o.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const o=this.b(s,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),o!==void 0){const a=await o;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const u=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:a,disposeListener:u}),p.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(o){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),o instanceof Error)return o.message}}async $applyCandidateFilter(s){const i=await Promise.all(s.map(a=>this.f(a.host,a.port,a.detail??""))),o=s.filter((a,u)=>i[u]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(a=>a.port).join(", ")} to ${o.map(a=>a.port).join(", ")}`),o}};e.$rzb=r,e.$rzb=r=Ke([Ve(0,D.$vN),Ve(1,A.$LN),Ve(2,m.$pj)],r)}),define(Re[8],Ae([1,0,18,23,127,244,46,28,120,52,69,26,16,2,29,86,98,103,102,83,49,59,215,24,7]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r,c,s,i,o,a,u,t,f,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.ChatResponseTextPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$uN=e.$tN=e.MarkdownString=e.$sN=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var w;(function(be){function Te(Q){const{selectionStartLineNumber:Pe,selectionStartColumn:je,positionLineNumber:Ze,positionColumn:Je}=Q,at=new n.$nL(Pe-1,je-1),mt=new n.$nL(Ze-1,Je-1);return new n.$pL(at,mt)}be.to=Te;function ae(Q){const{anchor:Pe,active:je}=Q;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}be.from=ae})(w||(e.Selection=w={}));var y;(function(be){function Te(Q){if(!Q)return;const{start:Pe,end:je}=Q;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}be.from=Te;function ae(Q){if(!Q)return;const{startLineNumber:Pe,startColumn:je,endLineNumber:Ze,endColumn:Je}=Q;return new n.$oL(Pe-1,je-1,Ze-1,Je-1)}be.to=ae})(y||(e.Range=y={}));var d;(function(be){function Te(Q){return{uri:Q.uri,range:y.from(Q.range)}}be.from=Te;function ae(Q){return new n.$yL($.URI.revive(Q.uri),y.to(Q.range))}be.to=ae})(d||(e.Location=d={}));var b;(function(be){function Te(ae){switch(ae){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}be.to=Te})(b||(e.TokenType=b={}));var P;(function(be){function Te(Q){return new n.$nL(Q.lineNumber-1,Q.column-1)}be.to=Te;function ae(Q){return{lineNumber:Q.line+1,column:Q.character+1}}be.from=ae})(P||(e.Position=P={}));var g;(function(be){function Te(Pe,je,Ze){return(0,S.$Hb)((0,S.$3b)(Pe).map(Je=>ae(Je,je,Ze)))}be.from=Te;function ae(Pe,je,Ze){if(typeof Pe=="string")return{$serialized:!0,language:Pe,isBuiltin:Ze?.isBuiltin};if(Pe)return{$serialized:!0,language:Pe.language,scheme:Q(Pe.scheme,je),pattern:X.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType,isBuiltin:Ze?.isBuiltin}}function Q(Pe,je){return je&&typeof Pe=="string"?je.transformOutgoingScheme(Pe):Pe}})(g||(e.DocumentSelector=g={}));var v;(function(be){function Te(Q){switch(Q){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}be.from=Te;function ae(Q){switch(Q){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}be.to=ae})(v||(e.DiagnosticTag=v={}));var k;(function(be){function Te(Q){let Pe;return Q.code&&((0,l.$Jf)(Q.code)||(0,l.$Nf)(Q.code)?Pe=String(Q.code):Pe={value:String(Q.code.value),target:Q.code.target}),{...y.from(Q.range),message:Q.message,source:Q.source,code:Pe,severity:O.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(F.from),tags:Array.isArray(Q.tags)?(0,S.$Hb)(Q.tags.map(v.from)):void 0}}be.from=Te;function ae(Q){const Pe=new n.$AL(y.to(Q),Q.message,O.to(Q.severity));return Pe.source=Q.source,Pe.code=(0,l.$Jf)(Q.code)?Q.code:Q.code?.value,Pe.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(F.to),Pe.tags=Q.tags&&(0,S.$Hb)(Q.tags.map(v.to)),Pe}be.to=ae})(k||(e.Diagnostic=k={}));var F;(function(be){function Te(Q){return{...y.from(Q.location.range),message:Q.message,resource:Q.location.uri}}be.from=Te;function ae(Q){return new n.$zL(new n.$yL(Q.resource,y.to(Q)),Q.message)}be.to=ae})(F||(e.DiagnosticRelatedInformation=F={}));var O;(function(be){function Te(Q){switch(Q){case n.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}be.from=Te;function ae(Q){switch(Q){case c.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}be.to=ae})(O||(e.DiagnosticSeverity=O={}));var G;(function(be){function Te(Q){return typeof Q=="number"&&Q>=n.ViewColumn.One?Q-1:Q===n.ViewColumn.Beside?t.$gD:t.$fD}be.from=Te;function ae(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=ae})(G||(e.ViewColumn=G={}));function q(be){return typeof be.range<"u"}function U(be){return be.length===0?!0:!!q(be[0])}e.$sN=U;var C;(function(be){function Te(Je){return Je.map(be.from)}be.fromMany=Te;function ae(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function Q(Je){let at;if(ae(Je)){const{language:St,value:Jt}=Je;at={value:"```"+St+`
`+Jt+"\n```\n"}}else n.$NL.isMarkdownString(Je)?at={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?at={value:Je}:at={value:""};const mt=Object.create(null);at.uris=mt;const Ft=St=>{try{let Jt=$.URI.parse(St,!0);Jt=Jt.with({query:Pe(Jt.query,mt)}),mt[St]=Jt}catch{}return""},Gt=new h.marked.Renderer;return Gt.link=Ft,Gt.image=St=>typeof St=="string"?Ft(L.$rk(St).href):"",(0,h.marked)(at.value,{renderer:Gt}),at}be.from=Q;function Pe(Je,at){if(!Je)return Je;let mt;try{mt=(0,E.$Dh)(Je)}catch{}if(!mt)return Je;let Ft=!1;return mt=(0,D.$An)(mt,Gt=>{if($.URI.isUri(Gt)){const St=`__uri_${Math.random().toString(16).slice(2,8)}`;return at[St]=Gt,Ft=!0,St}else return}),Ft?JSON.stringify(mt):Je}function je(Je){const at=new n.$NL(Je.value,Je.supportThemeIcons);return at.isTrusted=Je.isTrusted,at.supportHtml=Je.supportHtml,at.baseUri=Je.baseUri?$.URI.from(Je.baseUri):void 0,at}be.to=je;function Ze(Je){if(Je)return typeof Je=="string"?Je:be.from(Je)}be.fromStrict=Ze})(C||(e.MarkdownString=C={}));function N(be){return U(be)?be.map(Te=>({range:y.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?C.fromMany(Te.hoverMessage):Te.hoverMessage?C.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):be.map(Te=>({range:y.from(Te)}))}e.$tN=N;function W(be){return typeof be>"u"?be:typeof be=="string"?$.URI.file(be):be}e.$uN=W;var se;(function(be){function Te(ae){return typeof ae>"u"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?W(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}be.from=Te})(se||(e.ThemableDecorationAttachmentRenderOptions=se={}));var le;(function(be){function Te(ae){return typeof ae>"u"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?W(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?se.from(ae.before):void 0,after:ae.after?se.from(ae.after):void 0}}be.from=Te})(le||(e.ThemableDecorationRenderOptions=le={}));var Ee;(function(be){function Te(ae){if(typeof ae>"u")return ae;switch(ae){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=Te})(Ee||(e.DecorationRangeBehavior=Ee={}));var De;(function(be){function Te(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?Ee.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?le.from(ae.light):void 0,dark:ae.dark?le.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?W(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?se.from(ae.before):void 0,after:ae.after?se.from(ae.after):void 0}}be.from=Te})(De||(e.DecorationRenderOptions=De={}));var ce;(function(be){function Te(Q){return{text:Q.newText,eol:Q.newEol&&st.from(Q.newEol),range:y.from(Q.range)}}be.from=Te;function ae(Q){const Pe=new n.$tL(y.to(Q.range),Q.text);return Pe.newEol=typeof Q.eol>"u"?void 0:st.to(Q.eol),Pe}be.to=ae})(ce||(e.TextEdit=ce={}));var pe;(function(be){function Te(Q,Pe){const je={edits:[]};if(Q instanceof n.$wL){const Ze=new m.$Bc;for(const Je of Q._allEntries())Je._type===1&&$.URI.isUri(Je.to)&&Je.from===void 0&&Ze.add(Je.to);for(const Je of Q._allEntries())if(Je._type===1){let at;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?at={type:"base64",value:(0,M.$Ee)(M.$ke.wrap(Je.options.contents))}:at={type:"dataTransferItem",id:Je.options.contents._itemId}),je.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:at},metadata:Je.metadata})}else Je._type===2?je.edits.push({resource:Je.uri,textEdit:ce.from(Je.edit),versionId:Ze.has(Je.uri)?void 0:Pe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?je.edits.push({resource:Je.uri,textEdit:{range:y.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:Ze.has(Je.uri)?void 0:Pe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?je.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&je.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(Mt.from)}})}return je}be.from=Te;function ae(Q){const Pe=new n.$wL,je=new m.$Ac;for(const Ze of Q.edits)if(Ze.textEdit){const Je=Ze,at=$.URI.revive(Je.resource),mt=y.to(Je.textEdit.range),Ft=Je.textEdit.text,Gt=Je.textEdit.insertAsSnippet;let St;Gt?St=n.$vL.replace(mt,new n.$xL(Ft)):St=n.$tL.replace(mt,Ft);const Jt=je.get(at);Jt?Jt.push(St):je.set(at,[St])}else Pe.renameFile($.URI.revive(Ze.oldResource),$.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Je]of je)Pe.set(Ze,Je);return Pe}be.to=ae})(pe||(e.WorkspaceEdit=pe={}));var oe;(function(be){const Te=Object.create(null);Te[n.SymbolKind.File]=0,Te[n.SymbolKind.Module]=1,Te[n.SymbolKind.Namespace]=2,Te[n.SymbolKind.Package]=3,Te[n.SymbolKind.Class]=4,Te[n.SymbolKind.Method]=5,Te[n.SymbolKind.Property]=6,Te[n.SymbolKind.Field]=7,Te[n.SymbolKind.Constructor]=8,Te[n.SymbolKind.Enum]=9,Te[n.SymbolKind.Interface]=10,Te[n.SymbolKind.Function]=11,Te[n.SymbolKind.Variable]=12,Te[n.SymbolKind.Constant]=13,Te[n.SymbolKind.String]=14,Te[n.SymbolKind.Number]=15,Te[n.SymbolKind.Boolean]=16,Te[n.SymbolKind.Array]=17,Te[n.SymbolKind.Object]=18,Te[n.SymbolKind.Key]=19,Te[n.SymbolKind.Null]=20,Te[n.SymbolKind.EnumMember]=21,Te[n.SymbolKind.Struct]=22,Te[n.SymbolKind.Event]=23,Te[n.SymbolKind.Operator]=24,Te[n.SymbolKind.TypeParameter]=25;function ae(Pe){return typeof Te[Pe]=="number"?Te[Pe]:6}be.from=ae;function Q(Pe){for(const je in Te)if(Te[je]===Pe)return Number(je);return n.SymbolKind.Property}be.to=Q})(oe||(e.SymbolKind=oe={}));var $e;(function(be){function Te(Q){switch(Q){case n.SymbolTag.Deprecated:return 1}}be.from=Te;function ae(Q){switch(Q){case 1:return n.SymbolTag.Deprecated}}be.to=ae})($e||(e.SymbolTag=$e={}));var ie;(function(be){function Te(Q){return{name:Q.name,kind:oe.from(Q.kind),tags:Q.tags&&Q.tags.map($e.from),containerName:Q.containerName,location:Me.from(Q.location)}}be.from=Te;function ae(Q){const Pe=new n.$EL(Q.name,oe.to(Q.kind),Q.containerName,Me.to(Q.location));return Pe.tags=Q.tags&&Q.tags.map($e.to),Pe}be.to=ae})(ie||(e.WorkspaceSymbol=ie={}));var x;(function(be){function Te(Q){const Pe={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:y.from(Q.range),selectionRange:y.from(Q.selectionRange),kind:oe.from(Q.kind),tags:Q.tags?.map($e.from)??[]};return Q.children&&(Pe.children=Q.children.map(Te)),Pe}be.from=Te;function ae(Q){const Pe=new n.$FL(Q.name,Q.detail,oe.to(Q.kind),y.to(Q.range),y.to(Q.selectionRange));return(0,S.$Lb)(Q.tags)&&(Pe.tags=Q.tags.map($e.to)),Q.children&&(Pe.children=Q.children.map(ae)),Pe}be.to=ae})(x||(e.DocumentSymbol=x={}));var V;(function(be){function Te(Q){const Pe=new n.$JL(oe.to(Q.kind),Q.name,Q.detail||"",$.URI.revive(Q.uri),y.to(Q.range),y.to(Q.selectionRange));return Pe._sessionId=Q._sessionId,Pe._itemId=Q._itemId,Pe}be.to=Te;function ae(Q,Pe,je){if(Pe=Pe??Q._sessionId,je=je??Q._itemId,Pe===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:je,name:Q.name,detail:Q.detail,kind:oe.from(Q.kind),uri:Q.uri,range:y.from(Q.range),selectionRange:y.from(Q.selectionRange),tags:Q.tags?.map($e.from)}}be.from=ae})(V||(e.CallHierarchyItem=V={}));var ne;(function(be){function Te(ae){return new n.$KL(V.to(ae.from),ae.fromRanges.map(Q=>y.to(Q)))}be.to=Te})(ne||(e.CallHierarchyIncomingCall=ne={}));var Ie;(function(be){function Te(ae){return new n.$LL(V.to(ae.to),ae.fromRanges.map(Q=>y.to(Q)))}be.to=Te})(Ie||(e.CallHierarchyOutgoingCall=Ie={}));var Me;(function(be){function Te(Q){return{range:Q.range&&y.from(Q.range),uri:Q.uri}}be.from=Te;function ae(Q){return new n.$yL($.URI.revive(Q.uri),y.to(Q.range))}be.to=ae})(Me||(e.location=Me={}));var Le;(function(be){function Te(Q){const Pe=Q,je=Q;return{originSelectionRange:Pe.originSelectionRange?y.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:je.uri,range:y.from(Pe.targetRange?Pe.targetRange:je.range),targetSelectionRange:Pe.targetSelectionRange?y.from(Pe.targetSelectionRange):void 0}}be.from=Te;function ae(Q){return{targetUri:$.URI.revive(Q.uri),targetRange:y.to(Q.range),targetSelectionRange:Q.targetSelectionRange?y.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?y.to(Q.originSelectionRange):void 0}}be.to=ae})(Le||(e.DefinitionLink=Le={}));var we;(function(be){function Te(Q){return{range:y.from(Q.range),contents:C.fromMany(Q.contents)}}be.from=Te;function ae(Q){return new n.$BL(Q.contents.map(C.to),y.to(Q.range))}be.to=ae})(we||(e.Hover=we={}));var ge;(function(be){function Te(Q){return{range:y.from(Q.range),expression:Q.expression}}be.from=Te;function ae(Q){return new n.$vM(y.to(Q.range),Q.expression)}be.to=ae})(ge||(e.EvaluatableExpression=ge={}));var K;(function(be){function Te(Q){if(Q instanceof n.$wM)return{type:"text",range:y.from(Q.range),text:Q.text};if(Q instanceof n.$xM)return{type:"variable",range:y.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof n.$yM)return{type:"expression",range:y.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}be.from=Te;function ae(Q){switch(Q.type){case"text":return{range:y.to(Q.range),text:Q.text};case"variable":return{range:y.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:y.to(Q.range),expression:Q.expression}}}be.to=ae})(K||(e.InlineValue=K={}));var ee;(function(be){function Te(Q){return{frameId:Q.frameId,stoppedLocation:y.from(Q.stoppedLocation)}}be.from=Te;function ae(Q){return new n.$zM(Q.frameId,y.to(Q.stoppedLocation))}be.to=ae})(ee||(e.InlineValueContext=ee={}));var he;(function(be){function Te(Q){return{range:y.from(Q.range),kind:Q.kind}}be.from=Te;function ae(Q){return new n.$CL(y.to(Q.range),Q.kind)}be.to=ae})(he||(e.DocumentHighlight=he={}));var fe;(function(be){function Te(Q){return{uri:Q.uri,highlights:Q.highlights.map(he.from)}}be.from=Te;function ae(Q){return new n.$DL($.URI.revive(Q.uri),Q.highlights.map(he.to))}be.to=ae})(fe||(e.MultiDocumentHighlight=fe={}));var Ce;(function(be){function Te(ae){switch(ae){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}be.to=Te})(Ce||(e.CompletionTriggerKind=Ce={}));var de;(function(be){function Te(ae){return{triggerKind:Ce.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}be.to=Te})(de||(e.CompletionContext=de={}));var ye;(function(be){function Te(Q){switch(Q){case n.CompletionItemTag.Deprecated:return 1}}be.from=Te;function ae(Q){switch(Q){case 1:return n.CompletionItemTag.Deprecated}}be.to=ae})(ye||(e.CompletionItemTag=ye={}));var T;(function(be){const Te=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function ae(je){return Te.get(je)??9}be.from=ae;const Q=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Pe(je){return Q.get(je)??n.CompletionItemKind.Property}be.to=Pe})(T||(e.CompletionItemKind=T={}));var H;(function(be){function Te(ae,Q){const Pe=new n.$TL(ae.label);return Pe.insertText=ae.insertText,Pe.kind=T.to(ae.kind),Pe.tags=ae.tags?.map(ye.to),Pe.detail=ae.detail,Pe.documentation=L.$lk(ae.documentation)?C.to(ae.documentation):ae.documentation,Pe.sortText=ae.sortText,Pe.filterText=ae.filterText,Pe.preselect=ae.preselect,Pe.commitCharacters=ae.commitCharacters,p.$Ws.isIRange(ae.range)?Pe.range=y.to(ae.range):typeof ae.range=="object"&&(Pe.range={inserting:y.to(ae.range.insert),replacing:y.to(ae.range.replace)}),Pe.keepWhitespace=typeof ae.insertTextRules>"u"?!1:!!(ae.insertTextRules&1),typeof ae.insertTextRules<"u"&&ae.insertTextRules&4?Pe.insertText=new n.$xL(ae.insertText):(Pe.insertText=ae.insertText,Pe.textEdit=Pe.range instanceof n.$oL?new n.$tL(Pe.range,Pe.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Pe.additionalTextEdits=ae.additionalTextEdits.map(je=>ce.to(je))),Pe.command=Q&&ae.command?Q.fromInternal(ae.command):void 0,Pe}be.to=Te})(H||(e.CompletionItem=H={}));var J;(function(be){function Te(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:C.fromStrict(Q.documentation)}}be.from=Te;function ae(Q){return{label:Q.label,documentation:L.$lk(Q.documentation)?C.to(Q.documentation):Q.documentation}}be.to=ae})(J||(e.ParameterInformation=J={}));var B;(function(be){function Te(Q){return{label:Q.label,documentation:C.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(J.from):[],activeParameter:Q.activeParameter}}be.from=Te;function ae(Q){return{label:Q.label,documentation:L.$lk(Q.documentation)?C.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(J.to):[],activeParameter:Q.activeParameter}}be.to=ae})(B||(e.SignatureInformation=B={}));var Z;(function(be){function Te(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(B.from):[]}}be.from=Te;function ae(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(B.to):[]}}be.to=ae})(Z||(e.SignatureHelp=Z={}));var _;(function(be){function Te(ae,Q){const Pe=new n.$SL(P.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(ke.to.bind(void 0,ae)),Q.kind&&Ne.to(Q.kind));return Pe.textEdits=Q.textEdits&&Q.textEdits.map(ce.to),Pe.tooltip=L.$lk(Q.tooltip)?C.to(Q.tooltip):Q.tooltip,Pe.paddingLeft=Q.paddingLeft,Pe.paddingRight=Q.paddingRight,Pe}be.to=Te})(_||(e.InlayHint=_={}));var ke;(function(be){function Te(ae,Q){const Pe=new n.$RL(Q.label);return Pe.tooltip=L.$lk(Q.tooltip)?C.to(Q.tooltip):Q.tooltip,r.Command.is(Q.command)&&(Pe.command=ae.fromInternal(Q.command)),Q.location&&(Pe.location=Me.to(Q.location)),Pe}be.to=Te})(ke||(e.InlayHintLabelPart=ke={}));var Ne;(function(be){function Te(Q){return Q}be.from=Te;function ae(Q){return Q}be.to=ae})(Ne||(e.InlayHintKind=Ne={}));var We;(function(be){function Te(Q){return{range:y.from(Q.range),url:Q.target,tooltip:Q.tooltip}}be.from=Te;function ae(Q){let Pe;if(Q.url)try{Pe=typeof Q.url=="string"?$.URI.parse(Q.url,!0):$.URI.revive(Q.url)}catch{}return new n.$YL(y.to(Q.range),Pe)}be.to=ae})(We||(e.DocumentLink=We={}));var He;(function(be){function Te(Q){const Pe=new n.$2L(Q.label);return Q.textEdit&&(Pe.textEdit=ce.to(Q.textEdit)),Q.additionalTextEdits&&(Pe.additionalTextEdits=Q.additionalTextEdits.map(je=>ce.to(je))),Pe}be.to=Te;function ae(Q){return{label:Q.label,textEdit:Q.textEdit?ce.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Pe=>ce.from(Pe)):void 0}}be.from=ae})(He||(e.ColorPresentation=He={}));var Ye;(function(be){function Te(Q){return new n.$ZL(Q[0],Q[1],Q[2],Q[3])}be.to=Te;function ae(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}be.from=ae})(Ye||(e.Color=Ye={}));var nt;(function(be){function Te(Q){return{range:y.from(Q.range)}}be.from=Te;function ae(Q){return new n.$IL(y.to(Q.range))}be.to=ae})(nt||(e.SelectionRange=nt={}));var it;(function(be){function Te(ae){switch(ae){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}be.to=Te})(it||(e.TextDocumentSaveReason=it={}));var et;(function(be){function Te(Q){switch(Q){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.Interval:return 3;case n.TextEditorLineNumbersStyle.On:default:return 1}}be.from=Te;function ae(Q){switch(Q){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 3:return n.TextEditorLineNumbersStyle.Interval;case 1:default:return n.TextEditorLineNumbersStyle.On}}be.to=ae})(et||(e.TextEditorLineNumbersStyle=et={}));var st;(function(be){function Te(Q){if(Q===n.EndOfLine.CRLF)return 1;if(Q===n.EndOfLine.LF)return 0}be.from=Te;function ae(Q){if(Q===1)return n.EndOfLine.CRLF;if(Q===0)return n.EndOfLine.LF}be.to=ae})(st||(e.EndOfLine=st={}));var ct;(function(be){function Te(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=Te})(ct||(e.ProgressLocation=ct={}));var Ue;(function(be){function Te(Q){const Pe={start:Q.start+1,end:Q.end+1};return Q.kind&&(Pe.kind=$t.from(Q.kind)),Pe}be.from=Te;function ae(Q){const Pe={start:Q.start-1,end:Q.end-1};return Q.kind&&(Pe.kind=$t.to(Q.kind)),Pe}be.to=ae})(Ue||(e.FoldingRange=Ue={}));var $t;(function(be){function Te(Q){if(Q)switch(Q){case n.FoldingRangeKind.Comment:return r.$Mt.Comment;case n.FoldingRangeKind.Imports:return r.$Mt.Imports;case n.FoldingRangeKind.Region:return r.$Mt.Region}}be.from=Te;function ae(Q){if(Q)switch(Q.value){case r.$Mt.Comment.value:return n.FoldingRangeKind.Comment;case r.$Mt.Imports.value:return n.FoldingRangeKind.Imports;case r.$Mt.Region.value:return n.FoldingRangeKind.Region}}be.to=ae})($t||(e.FoldingRangeKind=$t={}));var Y;(function(be){function Te(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?y.from(ae.selection):void 0,override:typeof ae.override=="boolean"?i.$IE.id:void 0}}be.from=Te})(Y||(e.TextEditorOpenOptions=Y={}));var X;(function(be){function Te(je){return je instanceof n.$jM?je.toJSON():typeof je=="string"?je:ae(je)||Q(je)?new n.$jM(je.baseUri??je.base,je.pattern).toJSON():je}be.from=Te;function ae(je){const Ze=je;return Ze?$.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function Q(je){const Ze=je;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Pe(je){return typeof je=="string"?je:new n.$jM($.URI.revive(je.baseUri),je.pattern)}be.to=Pe})(X||(e.GlobPattern=X={}));var ve;(function(be){function Te(ae){if(ae){if(Array.isArray(ae))return ae.map(Te);if(typeof ae=="string")return ae;{const Q=ae;return{language:Q.language,scheme:Q.scheme,pattern:X.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}be.from=Te})(ve||(e.LanguageSelector=ve={}));var Be;(function(be){function Te(Q){return!!Q&&typeof Q=="object"&&"documents"in Q&&Array.isArray(Q.documents)&&Q.documents.every(Pe=>Array.isArray(Pe)&&Pe.every(je=>je&&typeof je=="object"&&"uri"in je&&$.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(Ze=>Ze instanceof n.$oL)))}be.is=Te;function ae(Q){return{documents:Q.documents.map(Pe=>Pe.map(je=>({uri:$.URI.from(je.uri),version:je.version,ranges:je.ranges.map(Ze=>y.from(Ze))})))}}be.from=ae})(Be||(e.MappedEditsContext=Be={}));var Qe;(function(be){function Te(Q){return{start:Q.start,end:Q.end}}be.from=Te;function ae(Q){return new n.$LM(Q.start,Q.end)}be.to=ae})(Qe||(e.NotebookRange=Qe={}));var tt;(function(be){function Te(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}be.to=Te;function ae(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}be.from=ae})(tt||(e.NotebookCellExecutionSummary=tt={}));var ot;(function(be){function Te(ae){if(ae===o.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(ae===o.NotebookCellExecutionState.Pending)return;if(ae===o.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ae}`)}be.to=Te})(ot||(e.NotebookCellExecutionState=ot={}));var Fe;(function(be){function Te(Q){switch(Q){case n.NotebookCellKind.Markup:return o.CellKind.Markup;case n.NotebookCellKind.Code:default:return o.CellKind.Code}}be.from=Te;function ae(Q){switch(Q){case o.CellKind.Markup:return n.NotebookCellKind.Markup;case o.CellKind.Code:default:return n.NotebookCellKind.Code}}be.to=ae})(Fe||(e.NotebookCellKind=Fe={}));var Wt;(function(be){function Te(Q){const Pe={metadata:Q.metadata??Object.create(null),cells:[]};for(const je of Q.cells)n.$MM.validate(je),Pe.cells.push(Mt.from(je));return Pe}be.from=Te;function ae(Q){const Pe=new n.$NM(Q.cells.map(Mt.to));return(0,l.$Wf)(Q.metadata)||(Pe.metadata=Q.metadata),Pe}be.to=ae})(Wt||(e.NotebookData=Wt={}));var Mt;(function(be){function Te(Q){return{cellKind:Fe.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:tt.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(Nt.from):[]}}be.from=Te;function ae(Q){return new n.$MM(Fe.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(Nt.to):void 0,Q.metadata,Q.internalMetadata?tt.to(Q.internalMetadata):void 0)}be.to=ae})(Mt||(e.NotebookCellData=Mt={}));var xt;(function(be){function Te(Q){return{mime:Q.mime,valueBytes:M.$ke.wrap(Q.data)}}be.from=Te;function ae(Q){return new n.$OM(Q.valueBytes.buffer,Q.mime)}be.to=ae})(xt||(e.NotebookCellOutputItem=xt={}));var Nt;(function(be){function Te(Q){return{outputId:Q.id,items:Q.items.map(xt.from),metadata:Q.metadata}}be.from=Te;function ae(Q){const Pe=Q.items.map(xt.to);return new n.$PM(Pe,Q.outputId,Q.metadata)}be.to=ae})(Nt||(e.NotebookCellOutput=Nt={}));var Et;(function(be){function Te(Pe){return Q(Pe)?{include:X.from(Pe.include)??void 0,exclude:X.from(Pe.exclude)??void 0}:X.from(Pe)??void 0}be.from=Te;function ae(Pe){return Q(Pe)?{include:X.to(Pe.include),exclude:X.to(Pe.exclude)}:X.to(Pe)}be.to=ae;function Q(Pe){const je=Pe;return je?!(0,l.$Sf)(je.include)&&!(0,l.$Sf)(je.exclude):!1}})(Et||(e.NotebookExclusiveDocumentPattern=Et={}));var Yt;(function(be){function Te(ae,Q,Pe){const je=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(je,Pe),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}be.from=Te})(Yt||(e.NotebookStatusBarItem=Yt={}));var Ot;(function(be){function Te(ae,Q,Pe){const je=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{command:Q.toInternal(je,Pe),label:ae.label,description:ae.description,detail:ae.detail,documentation:ae.documentation}}be.from=Te})(Ot||(e.NotebookKernelSourceAction=Ot={}));var ii;(function(be){function Te(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{},cellContentMetadata:ae?.cellContentMetadata??{}}}be.from=Te})(ii||(e.NotebookDocumentContentOptions=ii={}));var Qt;(function(be){function Te(Q){return{uri:Q.uri,provides:Q.provides}}be.from=Te;function ae(Q){return new n.$RM($.URI.revive(Q.uri),Q.provides)}be.to=ae})(Qt||(e.NotebookRendererScript=Qt={}));var Vt;(function(be){function Te(Q){return{message:C.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,contextValue:Q.contextValue,location:Q.location&&{range:y.from(Q.location.range),uri:Q.location.uri}}}be.from=Te;function ae(Q){const Pe=new n.$XM(typeof Q.message=="string"?Q.message:C.to(Q.message));return Pe.actualOutput=Q.actual,Pe.expectedOutput=Q.expected,Pe.contextValue=Q.contextValue,Pe.location=Q.location?Me.to(Q.location):void 0,Pe}be.to=ae})(Vt||(e.TestMessage=Vt={}));var Xe;(function(be){be.namespace=u.$gK,be.denamespace=u.$hK})(Xe||(e.TestTag=Xe={}));var Xt;(function(be){function Te(Q){const Pe=(0,s.$rN)(Q).controllerId;return{extId:a.$cK.fromExtHostTestItem(Q,Pe).toString(),label:Q.label,uri:$.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(je=>Xe.namespace(Pe,je.id)),range:p.$Ws.lift(y.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&C.fromStrict(Q.error)||null}}be.from=Te;function ae(Q){return{parent:void 0,error:void 0,id:a.$cK.fromString(Q.extId).localId,label:Q.label,uri:$.URI.revive(Q.uri),tags:(Q.tags||[]).map(Pe=>{const{tagId:je}=Xe.denamespace(Pe);return new n.$YM(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:y.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}be.toPlain=ae})(Xt||(e.TestItem=Xt={})),function(be){function Te(Q){return{id:Q.id}}be.from=Te;function ae(Q){return new n.$YM(Q.id)}be.to=ae}(Xe||(e.TestTag=Xe={}));var _t;(function(be){const Te=(Q,Pe)=>{const je=[];for(const[Je,at]of Pe)a.$cK.compare(at.item.extId,Je)===2&&(Pe.delete(Je),je.push(at));const Ze={...Xt.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(at=>at.type===0).map(Vt.to)})),children:je.map(Je=>Te(Je,Pe))};for(const Je of Ze.children)Je.parent=Ze;return Ze};function ae(Q){const Pe=[],je=new Map;for(const Ze of Q.items){je.set(Ze.item.extId,Ze);const Je=a.$cK.root(Ze.item.extId);Q.request.targets.some(at=>at.controllerId===Je&&at.testIds.includes(Ze.item.extId))&&Pe.push(Ze)}return{completedAt:Q.completedAt,results:Pe.map(Ze=>Te(Ze,je))}}be.to=ae})(_t||(e.TestResults=_t={}));var lt;(function(be){function Te(je){return{covered:je.covered,total:je.total}}function ae(je){return"line"in je?P.from(je):y.from(je)}function Q(je){return"branches"in je?{count:je.executed,location:ae(je.location),type:1,branches:je.branches.length?je.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&ae(Ze.location),label:Ze.label})):void 0}:{type:0,name:je.name,count:je.executed,location:ae(je.location)}}be.fromDetailed=Q;function Pe(je){return{uri:je.uri,statement:Te(je.statementCoverage),branch:je.branchCoverage&&Te(je.branchCoverage),function:je.functionCoverage&&Te(je.functionCoverage),details:je.detailedCoverage?.map(Q)}}be.fromFile=Pe})(lt||(e.TestCoverage=lt={}));var pt;(function(be){function Te(ae){switch(ae){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}be.to=Te})(pt||(e.CodeActionTriggerKind=pt={}));var qt;(function(be){function Te(Q){const Pe=new n.$5M(oe.to(Q.kind),Q.name,Q.detail||"",$.URI.revive(Q.uri),y.to(Q.range),y.to(Q.selectionRange));return Pe._sessionId=Q._sessionId,Pe._itemId=Q._itemId,Pe}be.to=Te;function ae(Q,Pe,je){if(Pe=Pe??Q._sessionId,je=je??Q._itemId,Pe===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:je,kind:oe.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:y.from(Q.range),selectionRange:y.from(Q.selectionRange),tags:Q.tags?.map($e.from)}}be.from=ae})(qt||(e.TypeHierarchyItem=qt={}));var ei;(function(be){function Te(ae){if(ae)return{value:ae.value,tooltip:ae.tooltip}}be.from=Te})(ei||(e.ViewBadge=ei={}));var kt;(function(be){function Te(je,Ze,Je){const at=Ze.fileData;return at?new n.$cM(new n.$dM(at.name,$.URI.revive(at.uri),at.id,(0,R.$db)(()=>Je(at.id)))):je===A.$hs.uriList&&Ze.uriListData?new n.$bM(Pe(Ze.uriListData)):new n.$bM(Ze.asString)}be.to=Te;async function ae(je,Ze){const Je=await Ze.asString();if(je===A.$hs.uriList)return{asString:Je,fileData:void 0,uriListData:Q(Je)};const at=Ze.asFile();return{asString:Je,fileData:at?{name:at.name,uri:at.uri,id:at._itemId??at.id}:void 0}}be.from=ae;function Q(je){return I.$tt.split(je).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return $.URI.parse(Ze)}catch{}return Ze})}function Pe(je){return I.$tt.create(je.map(Ze=>typeof Ze=="string"?Ze:$.URI.revive(Ze)))}})(kt||(e.DataTransferItem=kt={}));var dt;(function(be){function Te(Q,Pe){const je=Q.items.map(([Ze,Je])=>[Ze,kt.to(Ze,Je,Pe)]);return new n.$eM(je)}be.toDataTransfer=Te;async function ae(Q){const Pe={items:[]},je=[];for(const[Ze,Je]of Q)je.push((async()=>{Pe.items.push([Ze,await kt.from(Ze,Je)])})());return await Promise.all(je),Pe}be.from=ae})(dt||(e.DataTransfer=dt={}));var Pt;(function(be){function Te(ae){return{kind:"reply",message:ae.message,title:ae.title,tooltip:ae.tooltip}}be.from=Te})(Pt||(e.ChatReplyFollowup=Pt={}));var si;(function(be){function Te(ae){return typeof ae=="string"?{title:ae,message:ae,kind:"reply"}:"commandId"in ae?{kind:"command",title:ae.title??"",commandId:ae.commandId??"",when:ae.when??"",args:ae.args}:Pt.from(ae)}be.from=Te})(si||(e.ChatFollowup=si={}));var Lt;(function(be){function Te(Q){const Pe=new n.$eN(qe.to(Q.role),Q.content);return Pe.name=Q.name,Pe}be.to=Te;function ae(Q){return{role:qe.from(Q.role),content:Q.content,name:Q.name}}be.from=ae})(Lt||(e.ChatMessage=Lt={}));var qe;(function(be){function Te(Q){switch(Q){case 0:return n.ChatMessageRole.System;case 1:return n.ChatMessageRole.User;case 2:return n.ChatMessageRole.Assistant;case 3:return n.ChatMessageRole.Function}}be.to=Te;function ae(Q){switch(Q){case n.ChatMessageRole.System:return 0;case n.ChatMessageRole.Assistant:return 2;case n.ChatMessageRole.Function:return 3;case n.ChatMessageRole.User:default:return 1}}be.from=ae})(qe||(e.ChatMessageRole=qe={}));var Tt;(function(be){function Te(Pe){const je={};for(const Ze of Object.keys(Pe))je[Ze]=Pe[Ze].map(be.to);return je}be.objectTo=Te;function ae(Pe){return{level:zt.to(Pe.level),kind:Pe.kind,value:(0,$.$vc)(Pe.value)?$.URI.revive(Pe.value):Pe.value,description:Pe.description}}be.to=ae;function Q(Pe){return{level:zt.from(Pe.level),kind:Pe.kind,value:Pe.value,description:Pe.description}}be.from=Q})(Tt||(e.ChatVariable=Tt={}));var zt;(function(be){function Te(Q){switch(Q){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}be.to=Te;function ae(Q){switch(Q){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}be.from=ae})(zt||(e.ChatVariableLevel=zt={}));var ti;(function(be){function Te(ae){switch(ae){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return n.InteractiveEditorResponseFeedbackKind.Bug}}be.to=Te})(ti||(e.InteractiveEditorResponseFeedbackKind=ti={}));var ft;(function(be){function Te(Q){return{kind:"markdownContent",content:C.from(new n.$NL().appendText(Q.value))}}be.to=Te;function ae(Q){return new n.$fN(Q.content.value)}be.from=ae})(ft||(e.ChatResponseTextPart=ft={}));var Rt;(function(be){function Te(Q){return{kind:"markdownContent",content:C.from(Q.value)}}be.to=Te;function ae(Q){return new n.$gN(C.to(Q.content))}be.from=ae})(Rt||(e.ChatResponseMarkdownPart=Rt={}));var Ct;(function(be){function Te(Q){return{kind:"treeData",treeData:Q.value}}be.to=Te;function ae(Q){const Pe=(0,E.$Eh)(Q.treeData);return new n.$hN(Pe.treeData)}be.from=ae})(Ct||(e.ChatResponseFilesPart=Ct={}));var Ut;(function(be){function Te(Q){return{kind:"inlineReference",name:Q.title,inlineReference:$.URI.isUri(Q.value)?Q.value:d.from(Q.value)}}be.to=Te;function ae(Q){const Pe=(0,E.$Eh)(Q);return new n.$iN($.URI.isUri(Pe.inlineReference)?Pe.inlineReference:d.to(Pe.inlineReference),Q.name)}be.from=ae})(Ut||(e.ChatResponseAnchorPart=Ut={}));var Ht;(function(be){function Te(Q){return{kind:"progressMessage",content:C.from(Q.value)}}be.to=Te;function ae(Q){return new n.$jN(Q.content.value)}be.from=ae})(Ht||(e.ChatResponseProgressPart=Ht={}));var jt;(function(be){function Te(Q){return{kind:"reference",reference:$.URI.isUri(Q.value)?Q.value:d.from(Q.value)}}be.to=Te;function ae(Q){const Pe=(0,E.$Eh)(Q);return new n.$kN($.URI.isUri(Pe.reference)?Pe.reference:d.to(Pe.reference))}be.from=ae})(jt||(e.ChatResponseReferencePart=jt={}));var It;(function(be){function Te(ae){switch(ae.kind){case"markdownContent":return Rt.from(ae);case"inlineReference":return Ut.from(ae);case"reference":return jt.from(ae);case"progressMessage":return Ht.from(ae);case"treeData":return Ct.from(ae)}return new n.$fN("")}be.to=Te})(It||(e.ChatResponsePart=It={}));var Kt;(function(be){function Te(Pe,je){return"markdownContent"in je?((0,f.$LF)(Pe,"chatAgents2Additions"),{content:C.from(je.markdownContent),kind:"markdownContent"}):"content"in je?"vulnerabilities"in je&&je.vulnerabilities?((0,f.$LF)(Pe,"chatAgents2Additions"),{content:je.content,vulnerabilities:je.vulnerabilities,kind:"vulnerability"}):typeof je.content=="string"?{content:je.content,kind:"content"}:((0,f.$LF)(Pe,"chatAgents2Additions"),{content:C.from(je.content),kind:"markdownContent"}):"documents"in je?{documents:je.documents.map(Ze=>({uri:Ze.uri,version:Ze.version,ranges:Ze.ranges.map(Je=>y.from(Je))})),kind:"usedContext"}:"reference"in je?{reference:"uri"in je.reference?{uri:je.reference.uri,range:y.from(je.reference.range)}:je.reference,kind:"reference"}:"inlineReference"in je?{inlineReference:"uri"in je.inlineReference?{uri:je.inlineReference.uri,range:y.from(je.inlineReference.range)}:je.inlineReference,name:je.title,kind:"inlineReference"}:"agentName"in je?((0,f.$LF)(Pe,"chatAgents2Additions"),{agentName:je.agentName,command:je.command,kind:"agentDetection"}):"treeData"in je?{treeData:je.treeData,kind:"treeData"}:"message"in je?{content:C.from(je.message),kind:"progressMessage"}:void 0}be.from=Te;function ae(Pe){switch(Pe.kind){case"markdownContent":case"inlineReference":case"treeData":return be.to(Pe);case"content":return{content:Pe.content};case"usedContext":return{documents:Pe.documents.map(je=>({uri:$.URI.revive(je.uri),version:je.version,ranges:je.ranges.map(Ze=>y.to(Ze))}))};case"reference":return{reference:(0,$.$vc)(Pe.reference)?$.URI.revive(Pe.reference):d.to(Pe.reference)};case"agentDetection":return;case"progressMessage":return{message:Pe.content.value};case"vulnerability":return{content:Pe.content,vulnerabilities:Pe.vulnerabilities};default:return}}be.to=ae;function Q(Pe){switch(Pe.kind){case"markdownContent":return{content:Pe.content.value};case"inlineReference":return{inlineReference:(0,$.$vc)(Pe.inlineReference)?$.URI.revive(Pe.inlineReference):d.to(Pe.inlineReference),title:Pe.name};case"treeData":return{treeData:(0,E.$Eh)(Pe.treeData)};default:return}}be.toProgressContent=Q})(Kt||(e.ChatResponseProgress=Kt={}));var yt;(function(be){function Te(ae){return{prompt:ae.message,variables:Tt.objectTo(ae.variables),subCommand:ae.command,agentId:ae.agentId}}be.to=Te})(yt||(e.ChatAgentRequest=yt={}));var wt;(function(be){function Te(ae){return{label:ae.label,values:ae.values.map(Tt.from),insertText:ae.insertText,detail:ae.detail,documentation:ae.documentation}}be.from=Te})(wt||(e.ChatAgentCompletionItem=wt={}));var Dt;(function(be){function Te(ae,Q,Pe){return"terminalCommand"in ae?{terminalCommand:ae.terminalCommand,shouldExecute:ae.shouldExecute}:"uri"in ae?{uri:ae.uri}:Q.toInternal(ae,Pe)}be.from=Te})(Dt||(e.TerminalQuickFix=Dt={}))}),define(Re[245],Ae([1,0,3,17,8]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;let R=class{constructor(m,h){this.a=m.getProxy(S.$kL.MainThreadBulkEdits),this.b={getTextDocumentVersion:E=>h.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,h,E){const A=I.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,E?.isRefactoring??!1)}};e.$ngc=R,e.$ngc=R=Ke([Ve(0,M.$vN)],R)}),define(Re[246],Ae([1,0,18,11,41,5,46,63,2,157,13,3,8,7,205,24]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;let c=class{constructor(a,u,t,f){this.i=a,this.j=u,this.k=t,this.l=f,this.a=m.$Sd.create(!1),this.b=!1}close(){this.b=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.a.elapsed()}}get apiObject(){if(!this.g){let u=function(f){if(a.b){const n=new Error("Response stream has been closed");throw Error.captureStackTrace(n,f),n}};const a=this;this.a.reset();const t=f=>{typeof this.d>"u"&&"content"in f&&(this.d=this.a.elapsed()),this.k.$handleProgressChunk(this.j.requestId,f)};this.g={text(f){return u(this.text),this.markdown(new L.$jk().appendText(f)),this},markdown(f){u(this.markdown);const n=new $.$gN(f),w=l.ChatResponseMarkdownPart.to(n);return t(w),this},files(f){u(this.files);const n=new $.$hN(f),w=l.ChatResponseFilesPart.to(n);return t(w),this},anchor(f,n){u(this.anchor);const w=new $.$iN(f,n),y=l.ChatResponseAnchorPart.to(w);return t(y),this},progress(f){u(this.progress);const n=new $.$jN(f),w=l.ChatResponseProgressPart.to(n);return t(w),this},reference(f){u(this.reference);const n=new $.$kN(f),w=l.ChatResponseReferencePart.to(n);return t(w),this},report(f){if(u(this.report),"placeholder"in f&&"resolvedContent"in f)return;const n=l.ChatResponseProgress.from(a.i,f);if(!n){a.l.error("Unknown progress type: "+JSON.stringify(f));return}return t(n),this}}}return this.g}};c=Ke([Ve(3,A.$pj)],c);class s{static{this.a=0}constructor(a,u,t){this.j=u,this.k=t,this.b=new Map,this.g=new Map,this.i=new Map,this.d=a.getProxy(D.$kL.MainThreadChatAgents2)}createChatAgent(a,u,t){const f=s.a++,n=new i(a,u,this.d,f,t);return this.b.set(f,n),this.d.$registerAgent(f,u,{}),n.apiAgent}async $invokeAgent(a,u,t,f){this.g.delete(u.sessionId);const n=this.b.get(a);if(!n)throw new Error(`[CHAT](${a}) CANNOT invoke agent because the agent is not registered`);this.j.$updateAllowlist([{extension:n.extension.identifier,allowed:!0}]);const w=new c(n.extension,u,this.d,this.k);try{const y=await this.l(n,u,t),d=n.invoke(l.ChatAgentRequest.to(u),{history:y},w.apiObject,f);return await(0,M.$Vg)(Promise.resolve(d).then(b=>{if(b){this.g.set(u.sessionId,b);let P=this.i.get(u.sessionId);return P||(P=new Map,this.i.set(u.sessionId,P)),P.set(u.requestId,b),{errorDetails:b.errorDetails,timings:w.timings}}else this.g.delete(u.sessionId)}),f)}catch(y){return this.k.error(y,n.extension),{errorDetails:{message:(0,E.localize)(0,null,(0,I.$Si)(y)),responseIsIncomplete:!0}}}finally{w.close(),this.j.$updateAllowlist([{extension:n.extension.identifier,allowed:!1}])}}async l(a,u,t){return(0,S.$Hb)(await Promise.all(t.history.map(async f=>{const n=u.agentId===f.request.agentId&&this.i.get(u.sessionId)?.get(f.request.requestId)||f.result;return{request:l.ChatAgentRequest.to(f.request),response:(0,S.$Hb)(f.response.map(w=>l.ChatResponseProgress.toProgressContent(w))),result:n}})))}$releaseSession(a){this.g.delete(a),this.i.delete(a)}async $provideSlashCommands(a,u){const t=this.b.get(a);return t?t.provideSlashCommands(u):[]}$provideFollowups(a,u,t){const f=this.b.get(a);if(!f)return Promise.resolve([]);const n=this.g.get(u);return n?f.provideFollowups(n,t):Promise.resolve([])}$acceptFeedback(a,u,t,f,n){const w=this.b.get(a);if(!w)return;const y=this.i.get(u)?.get(t);if(!y)return;let d;switch(f){case p.InteractiveSessionVoteDirection.Down:d=$.ChatAgentResultFeedbackKind.Unhelpful;break;case p.InteractiveSessionVoteDirection.Up:d=$.ChatAgentResultFeedbackKind.Helpful;break}w.acceptFeedback(Object.freeze(n?{result:y,kind:d,reportIssue:n}:{result:y,kind:d}))}$acceptAction(a,u,t,f){const n=this.b.get(a);if(!n)return;const w=this.i.get(u)?.get(t);w&&f.action.kind!=="vote"&&n.acceptAction(Object.freeze({action:f.action,result:w}))}async $invokeCompletionProvider(a,u,t){const f=this.b.get(a);return f?(await f.invokeCompletionProvider(u,t)).map(l.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(a,u){const t=this.b.get(a);if(t)return await t.provideWelcomeMessage(u)}async $provideSampleQuestions(a,u){const t=this.b.get(a);if(t)return await t.provideSampleQuestions(u)}}e.$qgc=s;class i{constructor(a,u,t,f,n){this.extension=a,this.id=u,this.u=t,this.w=f,this.x=n,this.o=new R.$Wd,this.p=new R.$Wd}acceptFeedback(a){this.o.fire(a)}acceptAction(a){this.p.fire(a)}async invokeCompletionProvider(a,u){return this.s?await this.s.provider.provideCompletionItems(a,u)??[]:[]}async provideSlashCommands(a){if(!this.a)return[];const u=await this.a.provideSubCommands(a);return u?u.map(t=>({name:t.name,description:t.description,followupPlaceholder:t.followupPlaceholder,shouldRepopulate:t.shouldRepopulate,sampleRequest:t.sampleRequest})):[]}async provideFollowups(a,u){if(!this.b)return[];const t=await this.b.provideFollowups(a,u);return t?t.map(f=>l.ChatFollowup.from(f)):[]}async provideWelcomeMessage(a){if(!this.t)return[];const u=await this.t.provideWelcomeMessage(a);return u?u.map(t=>typeof t=="string"?t:l.MarkdownString.from(t)):[]}async provideSampleQuestions(a){if(!this.t||!this.t.provideSampleQuestions)return[];const u=await this.t.provideSampleQuestions(a);return u?u?.map(t=>l.ChatReplyFollowup.from(t)):[]}get apiAgent(){let a=!1,u=!1;const t=()=>{a||u||(u=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.d??"",fullName:this.g,icon:this.i?this.i instanceof h.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof $.$hM?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.b!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:l.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:l.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q}),u=!1}))},f=this;return{get name(){return f.id},get description(){return f.d??""},set description(n){f.d=n,t()},get fullName(){return f.g??f.extension.displayName??f.extension.name},set fullName(n){f.g=n,t()},get iconPath(){return f.i},set iconPath(n){f.i=n,t()},get subCommandProvider(){return f.a},set subCommandProvider(n){f.a=n,t()},get followupProvider(){return f.b},set followupProvider(n){f.b=n,t()},get isDefault(){return(0,r.$LF)(f.extension,"defaultChatAgent"),f.j},set isDefault(n){(0,r.$LF)(f.extension,"defaultChatAgent"),f.j=n,t()},get helpTextPrefix(){return(0,r.$LF)(f.extension,"defaultChatAgent"),f.k},set helpTextPrefix(n){if((0,r.$LF)(f.extension,"defaultChatAgent"),!f.j)throw new Error("helpTextPrefix is only available on the default chat agent");f.k=n,t()},get helpTextPostfix(){return(0,r.$LF)(f.extension,"defaultChatAgent"),f.l},set helpTextPostfix(n){if((0,r.$LF)(f.extension,"defaultChatAgent"),!f.j)throw new Error("helpTextPostfix is only available on the default chat agent");f.l=n,t()},get isSecondary(){return(0,r.$LF)(f.extension,"defaultChatAgent"),f.n},set isSecondary(n){(0,r.$LF)(f.extension,"defaultChatAgent"),f.n=n,t()},get sampleRequest(){return f.m},set sampleRequest(n){f.m=n,t()},get supportIssueReporting(){return(0,r.$LF)(f.extension,"chatAgents2Additions"),f.q},set supportIssueReporting(n){(0,r.$LF)(f.extension,"chatAgents2Additions"),f.q=n,t()},get onDidReceiveFeedback(){return f.o.event},set agentVariableProvider(n){if(f.s=n,n){if(!n.triggerCharacters.length)throw new Error("triggerCharacters are required");f.u.$registerAgentCompletionsProvider(f.w,n.triggerCharacters)}else f.u.$unregisterAgentCompletionsProvider(f.w)},get agentVariableProvider(){return f.s},set welcomeMessageProvider(n){f.t=n,t()},get welcomeMessageProvider(){return f.t},onDidPerformAction:(0,r.$KF)(this.extension,"chatAgents2Additions")?this.p.event:void 0,dispose(){a=!0,f.a=void 0,f.b=void 0,f.o.dispose(),f.u.$unregisterAgent(f.w)}}}invoke(a,u,t,f){return this.x(a,u,t,f)}}}),define(Re[247],Ae([1,0,21,6,3,8,99,22,11,5]),function(me,e,S,M,I,R,L,m,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=void 0;class A{constructor(p,r){this.stream=new h.$yh,this.stream=r??new h.$yh;const c=this;this.apiObj={option:p,response:c.stream.asyncIterable}}}class D{constructor(p,r){this.a=new E.$Wd,this.b=new Map,this.c=new h.$yh,this.d=!1;const c=this;this.apiObject={result:p,response:c.c.asyncIterable,onDidStartResponseStream:c.a.event,cancel(){r.cancel()}},p.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,s]of this.b)s.stream.resolve();else this.c.resolve()})}handleFragment(p){if(this.d)return;let r=this.b.get(p.index);r||(this.b.size===0?r=new A(p.index,this.c):r=new A(p.index),this.b.set(p.index,r),this.a.fire(r.apiObj)),r.stream.emitOne(p.part)}}class l{static{this.a=1}constructor(p,r){this.f=r,this.c=new Map,this.d=new E.$Wd,this.e=new E.$Wd,this.g=new m.$pm,this.h=new Set,this.i=new Map,this.b=p.getProxy(I.$kL.MainThreadChatProvider)}dispose(){this.d.dispose(),this.e.dispose()}registerProvider(p,r,c,s){const i=l.a++;return this.c.set(i,{extension:p,provider:c}),this.b.$registerProvider(i,r,{extension:p,model:s.name??""}),(0,M.$Rc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(p,r,c,s,i){const o=this.c.get(p);if(!o)return;const a=new L.$xv(async u=>{if(i.isCancellationRequested){this.f.warn(`[CHAT](${o.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(r,{index:u.index,part:u.part})});return o.provider.provideChatResponse(c.map(R.ChatMessage.to),s,a,i)}$updateProviderList(p){const r=[],c=[];if(p.added)for(const s of p.added)this.h.add(s),r.push(s);if(p.removed)for(const s of p.removed)this.h.delete(s),c.push(s);this.e.fire({added:r,removed:c})}getProviderIds(){return Array.from(this.h)}$updateAllowlist(p){const r=new m.$om;for(const{extension:c,allowed:s}of p)this.g.get(c)!==s&&(this.g.set(c,s),r.add(c));this.d.fire(r)}async requestChatResponseProvider(p,r){if(!this.g.get(p))throw new Error("Extension is NOT allowed to make chat requests");const c=await this.b.$prepareChatAccess(r);if(!c)throw new Error(`ChatAccess '${r}' NOT found`);const s=this;return{get model(){return c.model},get isRevoked(){return!s.g.get(p)},get onDidChangeAccess(){return E.Event.signal(E.Event.filter(s.d.event,i=>i.has(p)))},makeRequest(i,o,a){if(!s.g.get(p))throw new Error("Access to chat has been revoked");const u=new S.$7d(a),t=Math.random()*1e6|0,f=s.b.$fetchResponse(p,r,t,i.map(R.ChatMessage.from),o??{},u.token),n=new D(f,u);return s.i.set(t,{res:n}),f.finally(()=>{s.i.delete(t)}),n.apiObject}}}async $handleResponseFragment(p,r){const c=this.i.get(p);c&&c.res.handleFragment(r)}}e.$pgc=l}),define(Re[248],Ae([1,0,6,3,15,8]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class L{static{this.a=0}constructor(h){this.b=new Map,this.c=h.getProxy(M.$kL.MainThreadChatVariables)}async $resolveVariable(h,E,A){const D=this.b.get(h);if(D)try{const l=await D.resolver.resolve(D.data.name,{prompt:E},A);if(l)return l.map(R.ChatVariable.from)}catch(l){(0,I.$2)(l)}}registerVariableResolver(h,E,A,D){const l=L.a++;return this.b.set(l,{extension:h.identifier,data:{name:E,description:A},resolver:D}),this.c.$registerVariable(l,{name:E,description:A}),(0,S.$Rc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$rgc=L}),define(Re[249],Ae([1,0,11,67,5,6,2,86,22,8,7,3,24]),function(me,e,S,M,I,R,L,m,h,E,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;function $(p,r,c){const s=p.getProxy(D.$kL.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new h.$pm,r.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const b=this.b.get(d.handle);return b?b.value:d}else if(d&&d.$mid===7){const b=this.b.get(d.commentControlHandle);if(!b)return d;const P=b.getCommentThread(d.commentThreadHandle);return P?P.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const b=this.b.get(d.thread.commentControlHandle);if(!b)return d;const P=b.getCommentThread(d.thread.commentThreadHandle);return P?d.$mid===8?P.value:{thread:P.value,text:d.text}:d}else if(d&&d.$mid===10){const b=this.b.get(d.thread.commentControlHandle);if(!b)return d;const P=b.getCommentThread(d.thread.commentThreadHandle);if(!P)return d;const g=d.commentUniqueId,v=P.getCommentByUniqueId(g);return v||d}else if(d&&d.$mid===11){const b=this.b.get(d.thread.commentControlHandle);if(!b)return d;const P=b.getCommentThread(d.thread.commentThreadHandle);if(!P)return d;const g=d.text,v=d.commentUniqueId,k=P.getCommentByUniqueId(v);return k?(typeof k.body=="string"?k.body=g:k.body=new A.$NL(g),k):d}return d}})}createCommentController(d,b,P){const g=i.a++,v=new a(d,g,b,P);this.b.set(v.handle,v);const k=this.c.get(d.identifier)||[];return k.push(v),this.c.set(d.identifier,k),v.value}async $createCommentThreadTemplate(d,b,P){const g=this.b.get(d);g&&g.$createCommentThreadTemplate(b,P)}async $updateCommentThreadTemplate(d,b,P){const g=this.b.get(d);g&&g.$updateCommentThreadTemplate(b,P)}$deleteCommentThread(d,b){this.b.get(d)?.$deleteCommentThread(b)}$provideCommentingRanges(d,b,P){const g=this.b.get(d);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const v=c.getDocument(L.URI.revive(b));return(0,S.$Zg)(async()=>{const k=await g.commentingRangeProvider.provideCommentingRanges(v,P);let F;return Array.isArray(k)?F={ranges:k,fileComments:!1}:k?F={ranges:k.ranges||[],fileComments:k.fileComments||!1}:F=k??void 0,F}).then(k=>{let F;return k&&(F={ranges:k.ranges.map(O=>E.Range.from(O)),fileComments:k.fileComments}),F})}$toggleReaction(d,b,P,g,v){const k=this.b.get(d);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,S.$Zg)(()=>{const F=k.getCommentThread(b);if(F){const O=F.getCommentByUniqueId(g.uniqueIdInThread);if(k!==void 0&&O&&k.reactionHandler)return k.reactionHandler(O,f(v))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,b,P,g,v,k,F,O){this.m=b,this.n=P,this.o=g,this.p=v,this.q=k,this.extensionDescription=F,this.r=O,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$Wd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Uc,this.l.value=new R.$Sc,this.n===void 0&&(this.n=`${d}.${this.handle}`),s.$createCommentThread(b,this.handle,this.n,this.o,E.Range.from(this.p),F.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this.i.push({dispose:()=>{s.$deleteCommentThread(b,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(q){G.range=q},get comments(){return G.comments},set comments(q){G.comments=q},get collapsibleState(){return G.collapsibleState},set collapsibleState(q){G.collapsibleState=q},get canReply(){return G.canReply},set canReply(q){G.canReply=q},get contextValue(){return G.contextValue},set contextValue(q){G.contextValue=q},get label(){return G.label},set label(q){G.label=q},get state(){return G.state},set state(q){G.state=q},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Sc);const d=P=>Object.prototype.hasOwnProperty.call(this.b,P),b={};d("range")&&(b.range=E.Range.from(this.p)),d("label")&&(b.label=this.label),d("contextValue")&&(b.contextValue=this.contextValue??null),d("comments")&&(b.comments=this.q.map(P=>u(this,P,this.k,this.extensionDescription))),d("collapsibleState")&&(b.collapseState=n(this.g)),d("canReply")&&(b.canReply=this.canReply),d("state")&&(b.state=w(this.h)),d("isTemplate")&&(b.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,b)}getCommentByUniqueId(d){for(const b of this.k){const P=b[0],g=b[1];if(d===g)return P}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Ke([(0,M.$Ah)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(d,b,P,g){this.f=d,this.g=b,this.h=P,this.i=g,this.a=new Map,s.$registerCommentController(this.handle,P,g,this.f.identifier.value);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(k){v.options=k},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(k){v.commentingRangeProvider=k},get reactionHandler(){return v.reactionHandler},set reactionHandler(k){v.reactionHandler=k},createCommentThread(k,F,O){return v.createCommentThread(k,F,O).value},dispose:()=>{v.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(d,b,P){b===void 0&&(0,l.$LF)(this.f,"fileComments");const g=new o(this.id,this.handle,void 0,d,b,P,this.f,!1);return this.a.set(g.handle,g),g}$createCommentThreadTemplate(d,b){const P=new o(this.id,this.handle,void 0,L.URI.revive(d),E.Range.to(b),[],this.f,!0);return P.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(P.handle,P),P}$updateCommentThreadTemplate(d,b){const P=this.a.get(d);P&&(P.range=E.Range.to(b))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.e.forEach(d=>d.dispose())}}function u(y,d,b,P){let g=b.get(d);return g||(g=++y.commentHandle,b.set(d,g)),d.state!==void 0&&(0,l.$LF)(P,"commentsDraftState"),d.reactions?.some(v=>v.reactors!==void 0)&&(0,l.$LF)(P,"commentReactor"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:g,body:typeof d.body=="string"?d.body:E.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(v=>t(v)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function t(y){return{label:y.label,iconPath:y.iconPath?E.$uN(y.iconPath):void 0,count:y.count,hasReacted:y.authorHasReacted,reactors:y.reactors&&y.reactors.length>0&&typeof y.reactors[0]!="string"?y.reactors.map(d=>d.name):y.reactors}}function f(y){return{label:y.label||"",count:y.count||0,iconPath:y.iconPath?L.URI.revive(y.iconPath):"",authorHasReacted:y.hasReacted||!1,reactors:y.reactors?.map(d=>({name:d}))}}function n(y){if(y!==void 0)switch(y){case A.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function w(y){if(y!==void 0)switch(y){case A.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new i}e.$vgc=$}),define(Re[250],Ae([1,0,21,97,6,12,25,2,8,61,74,3,7]),function(me,e,S,M,I,R,L,m,h,E,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=void 0;class ${constructor(f,n){this.document=f,this.b=n,this.a=1,this.c=new A.$agc("custom documents")}addEdit(f){return this.c.add([f])}async undo(f,n){await this.f(f).undo(),n||this.disposeBackup()}async redo(f,n){await this.f(f).redo(),n||this.disposeBackup()}disposeEdits(f){for(const n of f)this.c.delete(n)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const f=u(this.document.uri)+this.a++;return(0,L.$Ig)(this.b,f)}updateBackup(f){this.d?.delete(),this.d=f}disposeBackup(){this.d?.delete(),this.d=void 0}f(f){const n=this.c.get(f,0);if(!n)throw new Error("No edit found");return n}}class p{constructor(){this.a=new Map}get(f,n){return this.a.get(this.b(f,n))}add(f,n,w){const y=this.b(f,n.uri);if(this.a.has(y))throw new Error(`Document already exists for viewType:${f} resource:${n.uri}`);const d=new $(n,w);return this.a.set(y,d),d}delete(f,n){const w=this.b(f,n.uri);this.a.delete(w)}b(f,n){return`${f}@@@${n}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class c{constructor(){this.a=new Map}addTextProvider(f,n,w){return this.b(0,f,n,w)}addCustomProvider(f,n,w){return this.b(1,f,n,w)}get(f){return this.a.get(f)}b(f,n,w,y){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,{type:f,extension:w,provider:y}),new l.$mL(()=>this.a.delete(n))}}class s{constructor(f,n,w,y,d){this.d=n,this.f=w,this.g=y,this.h=d,this.b=new c,this.c=new p,this.a=f.getProxy(D.$kL.MainThreadCustomEditors)}registerCustomEditorProvider(f,n,w,y){const d=new I.$Sc;return o(w)?(d.add(this.b.addTextProvider(n,f,w)),this.a.$registerTextEditorProvider((0,E.$Kgc)(f),n,y.webviewOptions||{},{supportsMove:!!w.moveCustomTextEditor},(0,E.$Igc)(f))):(d.add(this.b.addCustomProvider(n,f,w)),i(w)&&d.add(w.onDidChangeCustomDocument(b=>{const P=this.i(n,b.document.uri);if(a(b)){const g=P.addEdit(b);this.a.$onDidEdit(b.document.uri,n,g,b.label)}else this.a.$onContentChange(b.document.uri,n)})),this.a.$registerCustomEditorProvider((0,E.$Kgc)(f),n,y.webviewOptions||{},!!y.supportsMultipleEditorsPerDocument,(0,E.$Igc)(f))),l.$mL.from(d,new l.$mL(()=>{this.a.$unregisterEditorProvider(n)}))}async $createCustomDocument(f,n,w,y,d){const b=this.b.get(n);if(!b)throw new Error(`No provider found for '${n}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${n}'`);const P=m.URI.revive(f),g=await b.provider.openCustomDocument(P,{backupId:w,untitledDocumentData:y?.buffer},d);let v;return i(b.provider)&&this.f&&(v=this.f.workspaceValue(b.extension)??this.f.globalValue(b.extension)),this.c.add(n,g,v),{editable:i(b.provider)}}async $disposeCustomDocument(f,n){const w=this.b.get(n);if(!w)throw new Error(`No provider found for '${n}'`);if(w.type!==1)throw new Error(`Invalid provider type for '${n}'`);const y=m.URI.revive(f),{document:d}=this.i(n,y);this.c.delete(n,d),d.dispose()}async $resolveCustomEditor(f,n,w,y,d,b){const P=this.b.get(w);if(!P)throw new Error(`No provider found for '${w}'`);const g=h.ViewColumn.to(d),v=this.g.createNewWebview(n,y.contentOptions,P.extension),k=this.h.createNewWebviewPanel(n,w,y.title,g,y.options,v,y.active),F=m.URI.revive(f);switch(P.type){case 1:{const{document:O}=this.i(w,F);return P.provider.resolveCustomEditor(O,k,b)}case 0:{const O=this.d.getDocument(F);return P.provider.resolveCustomTextEditor(O,k,b)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,n,w){this.i(n,f).disposeEdits(w)}async $onMoveCustomEditor(f,n,w){const y=this.b.get(w);if(!y)throw new Error(`No provider found for '${w}'`);if(!y.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${w}'`);const d=this.h.getWebviewPanel(f);if(!d)throw new Error("No webview found");const b=m.URI.revive(n),P=this.d.getDocument(b);await y.provider.moveCustomTextEditor(P,d,S.CancellationToken.None)}async $undo(f,n,w,y){return this.i(n,f).undo(w,y)}async $redo(f,n,w,y){return this.i(n,f).redo(w,y)}async $revert(f,n,w){const y=this.i(n,f);await this.j(n).revertCustomDocument(y.document,w),y.disposeBackup()}async $onSave(f,n,w){const y=this.i(n,f);await this.j(n).saveCustomDocument(y.document,w),y.disposeBackup()}async $onSaveAs(f,n,w,y){const d=this.i(n,f);return this.j(n).saveCustomDocumentAs(d.document,m.URI.revive(w),y)}async $backup(f,n,w){const y=this.i(n,f),b=await this.j(n).backupCustomDocument(y.document,{destination:y.getNewBackupUri()},w);return y.updateBackup(b),b.id}i(f,n){const w=this.c.get(f,m.URI.revive(n));if(!w)throw new Error("No custom document found");return w}j(f){const w=this.b.get(f)?.provider;if(!w||!i(w))throw new Error("Custom document is not editable");return w}}e.$Ngc=s;function i(t){return!!t.onDidChangeCustomDocument}function o(t){return typeof t.resolveCustomTextEditor=="function"}function a(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function u(t){const f=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,M.$Vi)(f)+""}}),define(Re[251],Ae([1,0,158,98,2,3,7,8,5,13,28,43]),function(me,e,S,M,I,R,L,m,h,E,A,D){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=e.$fgc=void 0;class ${#e;#t;#i;constructor(c,s,i,o,a,u,t,f){this.d=c,this.e=s,this.f=i,this.g=o,this.h=a,this.c=!1,this.f=Math.max(o,i),this.#i=new A.$Ac(n=>u.getComparisonKey(n)),this.#e=t,this.#t=f}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(c,s){if(!c){this.clear();return}this.j();let i=[];if(I.URI.isUri(c)){if(!s){this.delete(c);return}this.#i.set(c,s.slice()),i=[c]}else if(Array.isArray(c)){i=[];let u;c=[...c].sort($.k);for(const t of c){const[f,n]=t;if((!u||f.toString()!==u.toString())&&(u&&this.#i.get(u).length===0&&this.#i.delete(u),u=f,i.push(f),this.#i.set(f,[])),n)this.#i.get(f)?.push(...n);else{const w=this.#i.get(f);w&&(w.length=0)}}}if(this.#t.fire(i),!this.#e)return;const o=[];let a=0;for(const u of i){let t=[];const f=this.#i.get(u);if(f)if(f.length>this.g){t=[];const n=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let w=0;w<4;w++)for(const y of f)if(y.severity===n[w]&&t.push({...m.Diagnostic.from(y),modelVersionId:this.h(u)})===this.g)break e;t.push({severity:M.MarkerSeverity.Info,message:(0,S.localize)(0,null,f.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(n=>({...m.Diagnostic.from(n),modelVersionId:this.h(u)}));if(o.push([u,t]),a+=t.length,a>this.f)break}this.#e.$changeMany(this.e,o)}delete(c){this.j(),this.#t.fire([c]),this.#i.delete(c),this.#e?.$changeMany(this.e,[[c,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(c,s){this.j();for(const[i,o]of this)c.call(s,i,o,this)}*[Symbol.iterator](){this.j();for(const c of this.#i.keys())yield[c,this.get(c)]}get(c){this.j();const s=this.#i.get(c);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(c){return this.j(),Array.isArray(this.#i.get(c))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(c,s){return c[0].toString()<s[0].toString()?-1:c[0].toString()>s[0].toString()?1:0}}e.$fgc=$;let p=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(c){const s=new A.$Ac;for(const i of c)s.set(i,i);return{uris:Object.freeze(Array.from(s.values()))}}constructor(c,s,i,o){this.j=s,this.k=i,this.l=o,this.g=new Map,this.h=new h.$1d({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=h.Event.map(this.h.event,l._mapper),this.f=c.getProxy(R.$kL.MainThreadDiagnostics)}createDiagnosticCollection(c,s){const{g:i,f:o,h:a,j:u,k:t,l:f}=this,n=new class{$changeMany(d,b){o.$changeMany(d,b),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,d,b.length===0?"CLEARING":b)}$clear(d){o.$clear(d),u.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,d)}dispose(){o.dispose()}};let w;if(!s)s="_generated_diagnostic_collection_name_#"+l.c++,w=s;else if(!i.has(s))w=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do w=s+l.c++;while(i.has(w))}return new class extends ${constructor(){super(s,w,l.e,l.d,d=>f.getDocument(d)?.version,t.extUri,n,a),i.set(w,this)}dispose(){super.dispose(),i.delete(w)}}}getDiagnostics(c){if(c)return this.m(c);{const s=new Map,i=[];for(const o of this.g.values())o.forEach((a,u)=>{let t=s.get(a.toString());typeof t>"u"&&(t=i.length,s.set(a.toString(),t),i.push([a,[]])),i[t][1]=i[t][1].concat(...u)});return i}}m(c){let s=[];for(const i of this.g.values())i.has(c)&&(s=s.concat(i.get(c)));return s}$acceptMarkersChange(c){if(!this.n){const s="_generated_mirror",i=new $(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,o=>{},this.k.extUri,void 0,this.h);this.g.set(s,i),this.n=i}for(const[s,i]of c)this.n.set(I.URI.revive(s),i.map(m.Diagnostic.to))}};e.$ggc=p,e.$ggc=p=l=Ke([Ve(1,E.$pj),Ve(2,D.$egc)],p)}),define(Re[252],Ae([1,0,2,15,7,8,185]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=void 0;class m{constructor(E,A,D,l={timeout:1500,errors:3}){this.c=E,this.d=A,this.f=D,this.g=l,this.a=new L.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(E){return(A,D,l)=>{const p={dispose:this.a.push([A,D,E])};return Array.isArray(l)&&l.push(p),p}}async $participateInSave(E,A){const D=S.URI.revive(E);let l=!1;const $=setTimeout(()=>l=!0,this.g.timeout),p=[];try{for(const r of[...this.a]){if(l)break;const c=this.d.getDocument(D),s=await this.h(r,{document:c,reason:R.TextDocumentSaveReason.to(A)});p.push(s)}}finally{clearTimeout($)}return p}h([E,A,D],l){const $=this.b.get(E);return typeof $=="number"&&$>this.g.errors?Promise.resolve(!1):this.i(D,E,A,l).then(()=>!0,p=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const r=this.b.get(E);this.b.set(E,r?r+1:1),typeof r=="number"&&r>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(E,A,D,l){const $=[],p=Date.now(),{document:r,reason:c}=l,{version:s}=r,i=Object.freeze({document:r,reason:c,waitUntil(o){if(Object.isFrozen($))throw(0,M.$8)("waitUntil can not be called async");$.push(Promise.resolve(o))}});try{A.apply(D,[i])}catch(o){return Promise.reject(o)}return Object.freeze($),new Promise((o,a)=>{const u=setTimeout(()=>a(new Error("timeout")),this.g.timeout);return Promise.all($).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(u),o(t)}).catch(t=>{clearTimeout(u),a(t)})}).then(o=>{const a={edits:[]};for(const u of o)if(Array.isArray(u)&&u.every(t=>t instanceof I.$tL))for(const{newText:t,newEol:f,range:n}of u)a.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:n&&R.Range.from(n),text:t,eol:f&&R.EndOfLine.from(f)}});if(a.edits.length!==0)return s===r.version?this.f.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.$phc=m}),define(Re[253],Ae([1,0,5,6,2,3,108,8,16,26,7]),function(me,e,S,M,I,R,L,m,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0;class D{constructor($,p){this.a=new S.$Wd,this.b=new S.$Wd,this.c=new S.$Wd,this.d=new S.$Wd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Sc,this.h=new Map,this.f=$.getProxy(R.$kL.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(r=>{for(const c of r)this.b.fire(c.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const c of r)this.a.fire(c.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData($){if(!$)return;const p=this.g.getDocument($);if(p)return p}getDocument($){const p=this.getDocumentData($);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${$}'`);return p.document}ensureDocumentData($){const p=this.g.getDocument($);if(p)return Promise.resolve(p);let r=this.h.get($.toString());return r||(r=this.f.$tryOpenDocument($).then(c=>{this.h.delete($.toString());const s=I.URI.revive(c);return(0,h.$Uf)(this.g.getDocument(s))},c=>(this.h.delete($.toString()),Promise.reject(c))),this.h.set($.toString(),r)),r}createDocumentData($){return this.f.$tryCreateDocument($).then(p=>I.URI.revive(p))}$acceptModelLanguageChanged($,p){const r=I.URI.revive($),c=this.g.getDocument(r);if(!c)throw new Error("unknown document");this.b.fire(c.document),c._acceptLanguageId(p),this.a.fire(c.document)}$acceptModelSaved($){const p=I.URI.revive($),r=this.g.getDocument(p);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged($,!1),this.d.fire(r.document)}$acceptDirtyStateChanged($,p){const r=I.URI.revive($),c=this.g.getDocument(r);if(!c)throw new Error("unknown document");c._acceptIsDirty(p),this.c.fire({document:c.document,contentChanges:[],reason:void 0})}$acceptModelChanged($,p,r){const c=I.URI.revive($),s=this.g.getDocument(c);if(!s)throw new Error("unknown document");s._acceptIsDirty(r),s.onEvents(p);let i;p.isUndoing?i=A.TextDocumentChangeReason.Undo:p.isRedoing&&(i=A.TextDocumentChangeReason.Redo),this.c.fire((0,E.$zn)({document:s.document,contentChanges:p.changes.map(o=>({range:m.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:i}))}setWordDefinitionFor($,p){(0,L.$xN)($,p)}}e.$cgc=D}),define(Re[64],Ae([1,0,254,5,16,2,4,3,17,8,7]),function(me,e,S,M,I,R,L,m,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=e.$Ogc=void 0,e.$Ogc=(0,L.$8h)("IExtHostEditorTabs");class D{constructor(c,s,i){this.e=i,this.d=s,this.acceptDtoUpdate(c)}get apiObject(){if(!this.a){const c=this,s={get isActive(){return c.b.id===c.e()},get label(){return c.b.label},get input(){return c.c},get isDirty(){return c.b.isDirty},get isPinned(){return c.b.isPinned},get isPreview(){return c.b.isPreview},get group(){return c.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(c){this.b=c,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$6M(R.URI.revive(this.b.input.uri));case 2:return new A.$7M(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case 3:return new A.$8M(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case 6:return new A.$9M(R.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$0M(this.b.input.viewType);case 4:return new A.$$M(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$_M(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$aN;case 9:return new A.$bN(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$cN(this.b.input.providerId);default:return}}}class l{constructor(c,s){this.c=[],this.d="",this.b=c,this.e=s;for(const i of c.tabs)i.isActive&&(this.d=i.id),this.c.push(new D(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const c=this,s={get isActive(){return c.b.groupId===c.e()},get viewColumn(){return E.ViewColumn.to(c.b.viewColumn)},get activeTab(){return c.c.find(i=>i.tabId===c.d)?.apiObject},get tabs(){return Object.freeze(c.c.map(i=>i.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(c){this.b=c}acceptTabOperation(c){if(c.kind===0){const i=new D(c.tabDto,this,()=>this.activeTabId());return this.c.splice(c.index,0,i),c.tabDto.isActive&&(this.d=i.tabId),i}else if(c.kind===1){const i=this.c.splice(c.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${c.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(c.kind===3){if(c.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(c.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${c.oldIndex} which does not exist`);return this.c.splice(c.index,0,i),i}const s=this.c.find(i=>i.tabId===c.tabDto.id);if(!s)throw new Error("INVALID tab");return c.tabDto.isActive?this.d=c.tabDto.id:this.d===c.tabDto.id&&!c.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(c.tabDto),s}activeTabId(){return this.d}}let $=class{constructor(c){this.b=new M.$Wd,this.c=new M.$Wd,this.e=[],this.a=c.getProxy(m.$kL.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const c=this,s={onDidChangeTabGroups:c.c.event,onDidChangeTabs:c.b.event,get all(){return Object.freeze(c.e.map(i=>i.apiObject))},get activeTabGroup(){const i=c.d;return(0,I.$Uf)(c.e.find(a=>a.groupId===i)?.apiObject)},close:async(i,o)=>{const a=Array.isArray(i)?i:[i];return a.length?p(a[0])?this.j(a,o):this.i(a,o):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(c){const s=new Set(this.e.map(n=>n.groupId)),i=new Set(c.map(n=>n.groupId)),o=(0,S.$L)(s,i),a=this.e.filter(n=>o.removed.includes(n.groupId)).map(n=>n.apiObject),u=[],t=[];this.e=c.map(n=>{const w=new l(n,()=>this.d);return o.added.includes(w.groupId)?u.push(w.apiObject):t.push(w.apiObject),w});const f=(0,I.$Uf)(c.find(n=>n.isActive===!0)?.groupId);f!==void 0&&this.d!==f&&(this.d=f),this.c.fire(Object.freeze({opened:u,closed:a,changed:t}))}$acceptTabGroupUpdate(c){const s=this.e.find(i=>i.groupId===c.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(c),c.isActive&&(this.d=c.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(c){const s=this.e.find(o=>o.groupId===c.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const i=s.acceptTabOperation(c);switch(c.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(c){for(const s of this.e)for(const i of s.tabs)if(i.apiObject===c)return i}h(c){return this.e.find(s=>s.apiObject===c)}async i(c,s){const i=[];for(const o of c){const a=this.g(o);if(!a)throw new Error("Tab close: Invalid tab not found!");i.push(a.tabId)}return this.a.$closeTab(i,s)}async j(c,s){const i=[];for(const o of c){const a=this.h(o);if(!a)throw new Error("Group close: Invalid group not found!");i.push(a.groupId)}return this.a.$closeGroup(i,s)}};e.$Pgc=$,e.$Pgc=$=Ke([Ve(0,h.$vN)],$);function p(r){return r.tabs!==void 0}}),define(Re[255],Ae([1,0,2,3,6,7,8,297,14,23,24,46]),function(me,e,S,M,I,R,L,m,h,E,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=void 0;class l{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const c=this.a.indexOf(r);c>=0&&(this.a.splice(c,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),c=[];let s,i,o=14,a=14;for(const u of r){let t=s?(0,h.$cf)(s,u):0;for(t===0?i=1:i=a;t<u.length;t++)t+1===u.length?(o=a,a=9):a+=1,c.push([i,u.toUpperCase().charCodeAt(t),a]),c.push([i,u.toLowerCase().charCodeAt(t),a]),i=a;s=u,a=o}c.push([9,58,10]),c.push([10,47,12]),this.b=new m.$TZ(c)}}provideDocumentLinks(r){this.c();const c=[],s=m.$UZ.computeLinks({getLineContent(i){return r.lineAt(i-1).text},getLineCount(){return r.lineCount}},this.b);for(const i of s){const o=L.DocumentLink.to(i);o.target&&c.push(o)}return c}}class ${constructor(r,c){this.i=c,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(M.$kL.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,c,s,i={}){if($.j(s),this.d.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const o=this.h++;this.b.add(c),this.d.add(c),this.c.set(o,s);let a=2;i.isCaseSensitive&&(a+=1024),i.isReadonly&&(a+=2048),typeof s.copy=="function"&&(a+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,A.$LF)(r,"fsChunks"),a+=4);let u;i.isReadonly&&(0,D.$lk)(i.isReadonly)&&i.isReadonly.value!==""&&(u={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(o,c,a,u).catch(f=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${c}`),console.error(f)});const t=s.onDidChangeFile(f=>{const n=[];for(const w of f){const{uri:y,type:d}=w;if(y.scheme!==c)continue;let b;switch(d){case R.FileChangeType.Changed:b=0;break;case R.FileChangeType.Created:b=1;break;case R.FileChangeType.Deleted:b=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:y,type:b})}this.a.$onFileSystemChange(o,n)});return(0,I.$Rc)(()=>{t.dispose(),this.b.delete(c),this.d.delete(c),this.c.delete(o),this.a.$unregisterProvider(o)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:c,ctime:s,mtime:i,size:o,permissions:a}=r;return{type:c,ctime:s,mtime:i,size:o,permissions:a}}$stat(r,c){return Promise.resolve(this.l(r).stat(S.URI.revive(c))).then(s=>$.k(s))}$readdir(r,c){return Promise.resolve(this.l(r).readDirectory(S.URI.revive(c)))}$readFile(r,c){return Promise.resolve(this.l(r).readFile(S.URI.revive(c))).then(s=>E.$ke.wrap(s))}$writeFile(r,c,s,i){return Promise.resolve(this.l(r).writeFile(S.URI.revive(c),s.buffer,i))}$delete(r,c,s){return Promise.resolve(this.l(r).delete(S.URI.revive(c),s))}$rename(r,c,s,i){return Promise.resolve(this.l(r).rename(S.URI.revive(c),S.URI.revive(s),i))}$copy(r,c,s,i){const o=this.l(r);if(!o.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(o.copy(S.URI.revive(c),S.URI.revive(s),i))}$mkdir(r,c){return Promise.resolve(this.l(r).createDirectory(S.URI.revive(c)))}$watch(r,c,s,i){const o=this.l(r).watch(S.URI.revive(s),i);this.f.set(c,o)}$unwatch(r,c){const s=this.f.get(c);s&&(s.dispose(),this.f.delete(c))}$open(r,c,s){const i=this.l(r);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(S.URI.revive(c),s))}$close(r,c){const s=this.l(r);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(c))}$read(r,c,s,i){const o=this.l(r);if(!o.read)throw new Error('FileSystemProvider does not implement "read"');const a=E.$ke.alloc(i);return Promise.resolve(o.read(c,s,a.buffer,0,i)).then(u=>a.slice(0,u))}$write(r,c,s,i){const o=this.l(r);if(!o.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(o.write(c,s,i.buffer,0,i.byteLength))}l(r){const c=this.c.get(r);if(!c){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return c}}e.$rhc=$}),define(Re[256],Ae([1,0,5,34,2,3,8,7,39]),function(me,e,S,M,I,R,L,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor($,p,r,c,s,i){this.a=Math.random(),this.b=new S.$Wd,this.c=new S.$Wd,this.d=new S.$Wd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const o=(0,M.$Oj)(s),a=typeof s=="string",u=i?.correlate,t=c(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(u&&typeof f.session>"u")){if(!i?.ignoreCreateEvents)for(const n of f.created){const w=I.URI.revive(n);o(w.fsPath)&&(!a||p.getWorkspaceFolder(w))&&this.b.fire(w)}if(!i?.ignoreChangeEvents)for(const n of f.changed){const w=I.URI.revive(n);o(w.fsPath)&&(!a||p.getWorkspaceFolder(w))&&this.c.fire(w)}if(!i?.ignoreDeleteEvents)for(const n of f.deleted){const w=I.URI.revive(n);o(w.fsPath)&&(!a||p.getWorkspaceFolder(w))&&this.d.fire(w)}}});this.g=m.$mL.from(this.i($,r,s,i,i?.correlate),this.b,this.c,this.d,t)}i($,p,r,c,s){const i=m.$mL.from();if(typeof r=="string")return i;const o=$.getProxy(R.$kL.MainThreadFileSystemEventService);let a=!1;return(r.pattern.includes(M.$Kj)||r.pattern.includes(M.$Lj))&&(a=!0),o.$watch(p.identifier.value,this.a,r.baseUri,{recursive:a,excludes:c?.excludes??[]},!!s),m.$mL.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor($){this.a=$,this.session=this.a.session,this.b=new h.$V(()=>this.a.created.map(I.URI.revive)),this.c=new h.$V(()=>this.a.changed.map(I.URI.revive)),this.d=new h.$V(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor($,p,r){this.j=$,this.k=p,this.l=r,this.a=new S.$Wd,this.b=new S.$Wd,this.c=new S.$Wd,this.d=new S.$Wd,this.g=new S.$Yd,this.h=new S.$Yd,this.i=new S.$Yd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher($,p,r,c){return new E(this.j,$,p,this.a.event,L.GlobPattern.from(r),c)}$onFileEvent($){this.a.fire(new A($))}$onDidRunFileOperation($,p){switch($){case 2:this.b.fire(Object.freeze({files:p.map(r=>({oldUri:I.URI.revive(r.source),newUri:I.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:p.map(r=>I.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:p.map(r=>I.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent($){return this.m($,this.g)}getOnWillCreateFileEvent($){return this.m($,this.h)}getOnWillDeleteFileEvent($){return this.m($,this.i)}m($,p){return(r,c,s)=>{const i=function(a){r.call(c,a)};return i.extension=$,p.event(i,void 0,s)}}async $onWillRunFileOperation($,p,r,c){switch($){case 2:return await this.n(this.g,{files:p.map(s=>({oldUri:I.URI.revive(s.source),newUri:I.URI.revive(s.target)}))},r,c);case 1:return await this.n(this.i,{files:p.map(s=>I.URI.revive(s.target))},r,c);case 0:case 3:return await this.n(this.h,{files:p.map(s=>I.URI.revive(s.target))},r,c)}}async n($,p,r,c){const s=new Set,i=[];if(await $.fireAsync(p,c,async(a,u)=>{const t=Date.now(),f=await Promise.resolve(a);f instanceof m.$wL&&(i.push([u.extension,f]),s.add(u.extension.displayName??u.extension.identifier.value)),Date.now()-t>r&&this.k.warn("SLOW file-participant",u.extension.identifier)}),c.isCancellationRequested||i.length===0)return;const o={edits:[]};for(const[,a]of i){const{edits:u}=L.WorkspaceEdit.from(a,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(u)}return{edit:o,extensionNames:Array.from(s)}}}e.$shc=D}),define(Re[257],Ae([1,0,2,26,8,7,86,3,14,29,18,16,298,21,22,6,95,88,74,63,15,11,24,160]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r,c,s,i,o,a,u,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;class n{constructor(T,H){this.d=T,this.e=H}async provideDocumentSymbols(T,H){const J=this.d.getDocument(T),B=await this.e.provideDocumentSymbols(J,H);if(!(0,A.$Kb)(B))return B[0]instanceof R.$FL?B.map(I.DocumentSymbol.from):n.f(B)}static f(T){T=T.slice(0).sort((B,Z)=>{let _=B.location.range.start.compareTo(Z.location.range.start);return _===0&&(_=Z.location.range.end.compareTo(B.location.range.end)),_});const H=[],J=[];for(const B of T){const Z={name:B.name||"!!MISSING: name!!",kind:I.SymbolKind.from(B.kind),tags:B.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:B.containerName,range:I.Range.from(B.location.range),selectionRange:I.Range.from(B.location.range),children:[]};for(;;){if(J.length===0){J.push(Z),H.push(Z);break}const _=J[J.length-1];if(E.$Ws.containsRange(_.range,Z.range)&&!E.$Ws.equalsRange(_.range,Z.range)){_.children?.push(Z),J.push(Z);break}J.pop()}}return H}}class w{constructor(T,H,J,B,Z,_){this.f=T,this.g=H,this.h=J,this.j=B,this.k=Z,this.l=_,this.d=new i.$agc("CodeLens"),this.e=new Map}async provideCodeLenses(T,H){const J=this.f.getDocument(T),B=await this.h.provideCodeLenses(J,H);if(!B||H.isCancellationRequested)return;const Z=this.d.add(B),_=new r.$Sc;this.e.set(Z,_);const ke={cacheId:Z,lenses:[]};for(let Ne=0;Ne<B.length;Ne++)ke.lenses.push({cacheId:[Z,Ne],range:I.Range.from(B[Ne].range),command:this.g.toInternal(B[Ne].command,_)});return ke}async resolveCodeLens(T,H){const J=T.cacheId&&this.d.get(...T.cacheId);if(!J)return;let B;if(typeof this.h.resolveCodeLens!="function"||J.isResolved?B=J:B=await this.h.resolveCodeLens(J,H),B||(B=J),H.isCancellationRequested)return;const Z=T.cacheId&&this.e.get(T.cacheId[0]);if(Z){if(!B.command){const _=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,_),this.l.error(_);return}return T.command=this.g.toInternal(B.command,Z),T}}releaseCodeLenses(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}}function y(ye){return Array.isArray(ye)?ye.map(I.DefinitionLink.from):ye?[I.DefinitionLink.from(ye)]:[]}class d{constructor(T,H){this.d=T,this.e=H}async provideDefinition(T,H,J){const B=this.d.getDocument(T),Z=I.Position.to(H),_=await this.e.provideDefinition(B,Z,J);return y(_)}}class b{constructor(T,H){this.d=T,this.e=H}async provideDeclaration(T,H,J){const B=this.d.getDocument(T),Z=I.Position.to(H),_=await this.e.provideDeclaration(B,Z,J);return y(_)}}class P{constructor(T,H){this.d=T,this.e=H}async provideImplementation(T,H,J){const B=this.d.getDocument(T),Z=I.Position.to(H),_=await this.e.provideImplementation(B,Z,J);return y(_)}}class g{constructor(T,H){this.d=T,this.e=H}async provideTypeDefinition(T,H,J){const B=this.d.getDocument(T),Z=I.Position.to(H),_=await this.e.provideTypeDefinition(B,Z,J);return y(_)}}class v{constructor(T,H){this.d=T,this.e=H}async provideHover(T,H,J){const B=this.d.getDocument(T),Z=I.Position.to(H),_=await this.e.provideHover(B,Z,J);if(!(!_||(0,A.$Kb)(_.contents)))return _.range||(_.range=B.getWordRangeAtPosition(Z)),_.range||(_.range=new R.$oL(Z,Z)),I.Hover.from(_)}}class k{constructor(T,H){this.d=T,this.e=H}async provideEvaluatableExpression(T,H,J){const B=this.d.getDocument(T),Z=I.Position.to(H),_=await this.e.provideEvaluatableExpression(B,Z,J);if(_)return I.EvaluatableExpression.from(_)}}class F{constructor(T,H){this.d=T,this.e=H}async provideInlineValues(T,H,J,B){const Z=this.d.getDocument(T),_=await this.e.provideInlineValues(Z,I.Range.to(H),I.InlineValueContext.to(J),B);if(Array.isArray(_))return _.map(ke=>I.InlineValue.from(ke))}}class O{constructor(T,H){this.d=T,this.e=H}async provideDocumentHighlights(T,H,J){const B=this.d.getDocument(T),Z=I.Position.to(H),_=await this.e.provideDocumentHighlights(B,Z,J);if(Array.isArray(_))return _.map(I.DocumentHighlight.from)}}class G{constructor(T,H){this.d=T,this.e=H}async provideMultiDocumentHighlights(T,H,J,B){const Z=this.d.getDocument(T),_=J.map(We=>this.d.getDocument(We)),ke=I.Position.to(H),Ne=await this.e.provideMultiDocumentHighlights(Z,ke,_,B);if(Array.isArray(Ne))return Ne.map(I.MultiDocumentHighlight.from)}}class q{constructor(T,H){this.d=T,this.e=H}async provideLinkedEditingRanges(T,H,J){const B=this.d.getDocument(T),Z=I.Position.to(H),_=await this.e.provideLinkedEditingRanges(B,Z,J);if(_&&Array.isArray(_.ranges))return{ranges:(0,A.$Hb)(_.ranges.map(I.Range.from)),wordPattern:_.wordPattern}}}class U{constructor(T,H){this.d=T,this.e=H}async provideReferences(T,H,J,B){const Z=this.d.getDocument(T),_=I.Position.to(H),ke=await this.e.provideReferences(Z,_,J,B);if(Array.isArray(ke))return ke.map(I.location.from)}}class C{static{this.d=1e3}constructor(T,H,J,B,Z,_,ke){this.g=T,this.h=H,this.j=J,this.k=B,this.l=Z,this.m=_,this.n=ke,this.e=new i.$agc("CodeAction"),this.f=new Map}async provideCodeActions(T,H,J,B){const Z=this.g.getDocument(T),_=l.$Ys.isISelection(H)?I.Selection.to(H):I.Range.to(H),ke=[];for(const it of this.j.getDiagnostics(T))if(_.intersection(it.range)&&ke.push(it)>C.d)break;const Ne={diagnostics:ke,only:J.only?new R.$HL(J.only):void 0,triggerKind:I.CodeActionTriggerKind.to(J.trigger)},We=await this.k.provideCodeActions(Z,_,Ne,B);if(!(0,A.$Lb)(We)||B.isCancellationRequested)return;const He=this.e.add(We),Ye=new r.$Sc;this.f.set(He,Ye);const nt=[];for(let it=0;it<We.length;it++){const et=We[it];if(et)if(C.o(et))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,Ye)});else{Ne.only&&(et.kind?Ne.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const st=et.ranges??[];nt.push({cacheId:[He,it],title:et.title,command:et.command&&this.h.toInternal(et.command,Ye),diagnostics:et.diagnostics&&et.diagnostics.map(I.Diagnostic.from),edit:et.edit&&I.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,t.$KF)(this.m,"codeActionAI")?et.isAI:!1,ranges:(0,t.$KF)(this.m,"codeActionRanges")?(0,A.$Hb)(st.map(I.Range.from)):void 0,disabled:et.disabled?.reason})}}return{cacheId:He,actions:nt}}async resolveCodeAction(T,H){const[J,B]=T,Z=this.e.get(J,B);if(!Z||C.o(Z))return{};if(!this.k.resolveCodeAction)return{};const _=await this.k.resolveCodeAction(Z,H)??Z;let ke;_.edit&&(ke=I.WorkspaceEdit.from(_.edit,void 0));let Ne;if(_.command){const We=this.f.get(J);We&&(Ne=this.h.toInternal(_.command,We))}return{edit:ke,command:Ne}}releaseCodeActions(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}static o(T){return typeof T.command=="string"&&typeof T.title=="string"}}class N{static toInternalProviderId(T,H){return T+"."+H}constructor(T,H,J,B,Z){this.d=T,this.e=H,this.f=J,this.g=B,this.h=Z}async prepareDocumentPaste(T,H,J,B){if(!this.f.prepareDocumentPaste)return;const Z=this.e.getDocument(T),_=H.map(We=>I.Range.to(We)),ke=I.DataTransfer.toDataTransfer(J,()=>{throw new a.$$});if(await this.f.prepareDocumentPaste(Z,_,ke,B),B.isCancellationRequested)return;const Ne=Array.from(ke).filter(([,We])=>!(We instanceof R.$bM));return I.DataTransfer.from(Ne)}async providePasteEdits(T,H,J,B,Z){if(!this.f.provideDocumentPasteEdits)return;const _=this.e.getDocument(H),ke=J.map(He=>I.Range.to(He)),Ne=I.DataTransfer.toDataTransfer(B,async He=>(await this.d.$resolvePasteFileData(this.g,T,He)).buffer),We=await this.f.provideDocumentPasteEdits(_,ke,Ne,Z);if(We)return{label:We.label??(0,f.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(He=>"mimeType"in He?He:{providerId:N.toInternalProviderId(He.extensionId,He.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class W{constructor(T,H){this.d=T,this.e=H}async provideDocumentFormattingEdits(T,H,J){const B=this.d.getDocument(T),Z=await this.e.provideDocumentFormattingEdits(B,H,J);if(Array.isArray(Z))return Z.map(I.TextEdit.from)}}class se{constructor(T,H){this.d=T,this.e=H}async provideDocumentRangeFormattingEdits(T,H,J,B){const Z=this.d.getDocument(T),_=I.Range.to(H),ke=await this.e.provideDocumentRangeFormattingEdits(Z,_,J,B);if(Array.isArray(ke))return ke.map(I.TextEdit.from)}async provideDocumentRangesFormattingEdits(T,H,J,B){(0,D.$Tf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Z=this.d.getDocument(T),_=H.map(I.Range.to),ke=await this.e.provideDocumentRangesFormattingEdits(Z,_,J,B);if(Array.isArray(ke))return ke.map(I.TextEdit.from)}}class le{constructor(T,H){this.d=T,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(T,H,J,B,Z){const _=this.d.getDocument(T),ke=I.Position.to(H),Ne=await this.e.provideOnTypeFormattingEdits(_,ke,J,B,Z);if(Array.isArray(Ne))return Ne.map(I.TextEdit.from)}}class Ee{constructor(T,H){this.e=T,this.f=H,this.d=new i.$agc("WorkspaceSymbols")}async provideWorkspaceSymbols(T,H){const J=await this.e.provideWorkspaceSymbols(T,H);if(!(0,A.$Lb)(J))return{symbols:[]};const B=this.d.add(J),Z={cacheId:B,symbols:[]};for(let _=0;_<J.length;_++){const ke=J[_];if(!ke||!ke.name){this.f.warn("INVALID SymbolInformation",ke);continue}Z.symbols.push({...I.WorkspaceSymbol.from(ke),cacheId:[B,_]})}return Z}async resolveWorkspaceSymbol(T,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!T.cacheId)return T;const J=this.d.get(...T.cacheId);if(J){const B=await this.e.resolveWorkspaceSymbol(J,H);return B&&(0,M.$Bn)(T,I.WorkspaceSymbol.from(B),!0)}}releaseWorkspaceSymbols(T){this.d.delete(T)}}class De{static supportsResolving(T){return typeof T.prepareRename=="function"}constructor(T,H,J){this.d=T,this.e=H,this.f=J}async provideRenameEdits(T,H,J,B){const Z=this.d.getDocument(T),_=I.Position.to(H);try{const ke=await this.e.provideRenameEdits(Z,_,J,B);return ke?I.WorkspaceEdit.from(ke):void 0}catch(ke){const Ne=De.g(ke);return Ne?{rejectReason:Ne,edits:void 0}:Promise.reject(ke)}}async resolveRenameLocation(T,H,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const B=this.d.getDocument(T),Z=I.Position.to(H);try{const _=await this.e.prepareRename(B,Z,J);let ke,Ne;if(R.$oL.isRange(_)?(ke=_,Ne=B.getText(_)):(0,D.$Lf)(_)&&(ke=_.range,Ne=_.placeholder),!ke||!Ne)return;if(ke.start.line>Z.line||ke.end.line<Z.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ke),text:Ne}}catch(_){const ke=De.g(_);return ke?{rejectReason:ke,range:void 0,text:void 0}:Promise.reject(_)}}static g(T){return typeof T=="string"?T:T instanceof Error&&typeof T.message=="string"?T.message:void 0}}class ce{constructor(T,H){this.resultId=T,this.tokens=H}}class pe{constructor(T,H){this.f=T,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(T,H,J){const B=this.f.getDocument(T),Z=H!==0?this.d.get(H):null;let _=typeof Z?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(B,Z.resultId,J):await this.g.provideDocumentSemanticTokens(B,J);return Z&&this.d.delete(H),_?(_=pe.h(_),this.o(pe.n(Z,_),_)):null}async releaseDocumentSemanticColoring(T){this.d.delete(T)}static h(T){return pe.j(T)?pe.k(T)?T:new R.$EM(new Uint32Array(T.data),T.resultId):pe.l(T)?pe.m(T)?T:new R.$GM(T.edits.map(H=>new R.$FM(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),T.resultId):T}static j(T){return T&&!!T.data}static k(T){return T.data instanceof Uint32Array}static l(T){return T&&Array.isArray(T.edits)}static m(T){for(const H of T.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(T,H){if(!pe.j(H)||!T||!T.tokens)return H;const J=T.tokens,B=J.length,Z=H.data,_=Z.length;let ke=0;const Ne=Math.min(B,_);for(;ke<Ne&&J[ke]===Z[ke];)ke++;if(ke===B&&ke===_)return new R.$GM([],H.resultId);let We=0;const He=Ne-ke;for(;We<He&&J[B-We-1]===Z[_-We-1];)We++;return new R.$GM([{start:ke,deleteCount:B-ke-We,data:Z.subarray(ke,_-We)}],H.resultId)}o(T,H){if(pe.j(T)){const J=this.e++;return this.d.set(J,new ce(T.resultId,T.data)),(0,c.$U$)({id:J,type:"full",data:T.data})}if(pe.l(T)){const J=this.e++;return pe.j(H)?this.d.set(J,new ce(H.resultId,H.data)):this.d.set(J,new ce(T.resultId)),(0,c.$U$)({id:J,type:"delta",deltas:(T.edits||[]).map(B=>({start:B.start,deleteCount:B.deleteCount,data:B.data}))})}return null}}class oe{constructor(T,H){this.d=T,this.e=H}async provideDocumentRangeSemanticTokens(T,H,J){const B=this.d.getDocument(T),Z=await this.e.provideDocumentRangeSemanticTokens(B,I.Range.to(H),J);return Z?this.f(Z):null}f(T){return(0,c.$U$)({id:0,type:"full",data:T.data})}}class $e{static supportsResolving(T){return typeof T.resolveCompletionItem=="function"}constructor(T,H,J,B,Z){this.f=T,this.g=H,this.h=J,this.j=B,this.k=Z,this.d=new i.$agc("CompletionItem"),this.e=new Map}async provideCompletionItems(T,H,J,B){const Z=this.f.getDocument(T),_=I.Position.to(H),ke=Z.getWordRangeAtPosition(_)||new R.$oL(_,_),Ne=ke.with({end:_}),We=new o.$Sd,He=await this.h.provideCompletionItems(Z,_,B,I.CompletionContext.to(J));if(!He||B.isCancellationRequested)return;const Ye=Array.isArray(He)?new R.$UL(He):He,nt=$e.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),it=new r.$Sc;this.e.set(nt,it);const et=[],st={x:nt,b:et,a:{replace:I.Range.from(ke),insert:I.Range.from(Ne)},c:Ye.isIncomplete||void 0,d:We.elapsed()};for(let ct=0;ct<Ye.items.length;ct++){const Ue=Ye.items[ct],$t=this.l(Ue,[nt,ct],Ne,ke);et.push($t)}return st}async resolveCompletionItem(T,H){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...T);if(!J)return;const B=this.l(J,T),Z=await this.h.resolveCompletionItem(J,H);if(!Z)return;const _=this.l(Z,T);return(B.h!==_.h||B.i!==_.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(B.n!==_.n||B.o!==_.o||!(0,M.$Cn)(B.p,_.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...B,d:_.d,c:_.c,l:_.l,h:_.h,i:_.i,n:_.n,o:_.o,p:_.p}}releaseCompletionItems(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,H,J,B){const Z=this.e.get(H[0]);if(!Z)throw Error("DisposableStore is missing...");const _=this.g.toInternal(T.command,Z),ke={x:H,a:T.label,b:T.kind!==void 0?I.CompletionItemKind.from(T.kind):void 0,m:T.tags&&T.tags.map(I.CompletionItemTag.from),c:T.detail,d:typeof T.documentation>"u"?void 0:I.MarkdownString.fromStrict(T.documentation),e:T.sortText!==T.label?T.sortText:void 0,f:T.filterText!==T.label?T.filterText:void 0,g:T.preselect||void 0,i:T.keepWhitespace?1:0,k:T.commitCharacters?.join(""),l:T.additionalTextEdits&&T.additionalTextEdits.map(I.TextEdit.from),n:_?.$ident,o:_?.id,p:_?.$ident?void 0:_?.arguments};T.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ke.h=T.textEdit.newText):typeof T.insertText=="string"?ke.h=T.insertText:T.insertText instanceof R.$xL&&(ke.h=T.insertText.value,ke.i|=4);let Ne;return T.textEdit?Ne=T.textEdit.range:T.range&&(Ne=T.range),R.$oL.isRange(Ne)?ke.j=I.Range.from(Ne):Ne&&(!J?.isEqual(Ne.inserting)||!B?.isEqual(Ne.replacing))&&(ke.j={insert:I.Range.from(Ne.inserting),replace:I.Range.from(Ne.replacing)}),ke}}class ie{async provideInlineCompletions(T,H,J,B){}disposeCompletions(T){}handleDidShowCompletionItem(T,H,J){}handlePartialAccept(T,H,J){}}class x extends ie{constructor(T,H,J,B){super(),this.f=T,this.g=H,this.h=J,this.j=B,this.d=new V,this.e=(0,t.$KF)(this.f,"inlineCompletionsAdditions"),this.k={[L.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[L.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$KF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(T,H,J,B){const Z=this.g.getDocument(T),_=I.Position.to(H),ke=await this.h.provideInlineCompletionItems(Z,_,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:I.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},B);if(!ke||B.isCancellationRequested)return;const Ne=Array.isArray(ke)?ke:ke.items,We=this.e?Array.isArray(ke)?[]:ke.commands||[]:[],He=this.e&&!Array.isArray(ke)?ke.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:Ne}),items:Ne.map((it,et)=>{let st;it.command&&(Ye||(Ye=new r.$Sc),st=this.j.toInternal(it.command,Ye));const ct=it.insertText;return{insertText:typeof ct=="string"?ct:{snippet:ct.value},filterText:it.filterText,range:it.range?I.Range.from(it.range):void 0,command:st,idx:et,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:We.map(it=>(Ye||(Ye=new r.$Sc),this.j.toInternal(it,Ye))),suppressSuggestions:!1,enableForwardStability:He}}disposeCompletions(T){this.d.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,H,J){const B=this.d.get(T)?.items[H];B&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(B,J)}handlePartialAccept(T,H,J){const B=this.d.get(T)?.items[H];B&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(B,J)}}class V{constructor(){this.d=new Map,this.e=1}createReferenceId(T){const H=this.e++;return this.d.set(H,T),H}disposeReferenceId(T){const H=this.d.get(T);return this.d.delete(T),H}get(T){return this.d.get(T)}}class ne{constructor(T,H){this.e=T,this.f=H,this.d=new i.$agc("SignatureHelp")}async provideSignatureHelp(T,H,J,B){const Z=this.e.getDocument(T),_=I.Position.to(H),ke=this.g(J),Ne=await this.f.provideSignatureHelp(Z,_,B,ke);if(Ne){const We=this.d.add([Ne]);return{...I.SignatureHelp.from(Ne),id:We}}}g(T){let H;if(T.activeSignatureHelp){const J=I.SignatureHelp.to(T.activeSignatureHelp),B=this.d.get(T.activeSignatureHelp.id,0);B?(H=B,H.activeSignature=J.activeSignature,H.activeParameter=J.activeParameter):H=J}return{...T,activeSignatureHelp:H}}releaseSignatureHelp(T){this.d.delete(T)}}class Ie{constructor(T,H,J,B,Z){this.f=T,this.g=H,this.h=J,this.j=B,this.k=Z,this.d=new i.$agc("InlayHints"),this.e=new Map}async provideInlayHints(T,H,J){const B=this.f.getDocument(T),Z=I.Range.to(H),_=await this.h.provideInlayHints(B,Z,J);if(!Array.isArray(_)||_.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(H)}`);return}if(J.isCancellationRequested)return;const ke=this.d.add(_);this.e.set(ke,new r.$Sc);const Ne={hints:[],cacheId:ke};for(let We=0;We<_.length;We++)this.l(_[We],Z)&&Ne.hints.push(this.m(_[We],[ke,We]));return this.j.trace(`[InlayHints] ${Ne.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(H)}`),Ne}async resolveInlayHint(T,H){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...T);if(!J)return;const B=await this.h.resolveInlayHint(J,H);if(B&&this.l(B))return this.m(B,T)}releaseHints(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,H){return T.label.length===0||Array.isArray(T.label)&&T.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",T),!1):!(H&&!H.contains(T.position))}m(T,H){const J=this.e.get(H[0]);if(!J)throw Error("DisposableStore is missing...");const B={label:"",cacheId:H,tooltip:I.MarkdownString.fromStrict(T.tooltip),position:I.Position.from(T.position),textEdits:T.textEdits&&T.textEdits.map(I.TextEdit.from),kind:T.kind&&I.InlayHintKind.from(T.kind),paddingLeft:T.paddingLeft,paddingRight:T.paddingRight};if(typeof T.label=="string")B.label=T.label;else{const Z=[];B.label=Z;for(const _ of T.label){if(!_.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const ke={label:_.value,tooltip:I.MarkdownString.fromStrict(_.tooltip)};R.$yL.isLocation(_.location)&&(ke.location=I.location.from(_.location)),_.command&&(ke.command=this.g.toInternal(_.command,J)),Z.push(ke)}}return B}}class Me{constructor(T,H){this.e=T,this.f=H,this.d=new i.$agc("DocumentLink")}async provideLinks(T,H){const J=this.e.getDocument(T),B=await this.f.provideDocumentLinks(J,H);if(!(!Array.isArray(B)||B.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:B.filter(Me.g).map(I.DocumentLink.from)};{const Z=this.d.add(B),_={links:[],cacheId:Z};for(let ke=0;ke<B.length;ke++){if(!Me.g(B[ke]))continue;const Ne=I.DocumentLink.from(B[ke]);Ne.cacheId=[Z,ke],_.links.push(Ne)}return _}}}static g(T){return T.target&&T.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(T,H){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...T);if(!J)return;const B=await this.f.resolveDocumentLink(J,H);if(!(!B||!Me.g(B)))return I.DocumentLink.from(B)}releaseLinks(T){this.d.delete(T)}}class Le{constructor(T,H){this.d=T,this.e=H}async provideColors(T,H){const J=this.d.getDocument(T),B=await this.e.provideDocumentColors(J,H);return Array.isArray(B)?B.map(_=>({color:I.Color.from(_.color),range:I.Range.from(_.range)})):[]}async provideColorPresentations(T,H,J){const B=this.d.getDocument(T),Z=I.Range.to(H.range),_=I.Color.to(H.color),ke=await this.e.provideColorPresentations(_,{document:B,range:Z},J);if(Array.isArray(ke))return ke.map(I.ColorPresentation.from)}}class we{constructor(T,H){this.d=T,this.e=H}async provideFoldingRanges(T,H,J){const B=this.d.getDocument(T),Z=await this.e.provideFoldingRanges(B,H,J);if(Array.isArray(Z))return Z.map(I.FoldingRange.from)}}class ge{constructor(T,H,J){this.d=T,this.e=H,this.f=J}async provideSelectionRanges(T,H,J){const B=this.d.getDocument(T),Z=H.map(I.Position.to),_=await this.e.provideSelectionRanges(B,Z,J);if(!(0,A.$Lb)(_))return[];if(_.length!==Z.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ke=[];for(let Ne=0;Ne<Z.length;Ne++){const We=[];ke.push(We);let He=Z[Ne],Ye=_[Ne];for(;;){if(!Ye.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(We.push(I.SelectionRange.from(Ye)),!Ye.parent)break;He=Ye.range,Ye=Ye.parent}}return ke}}class K{constructor(T,H){this.f=T,this.g=H,this.d=new s.$AN(""),this.e=new Map}async prepareSession(T,H,J){const B=this.f.getDocument(T),Z=I.Position.to(H),_=await this.g.prepareCallHierarchy(B,Z,J);if(!_)return;const ke=this.d.nextId();return this.e.set(ke,new Map),Array.isArray(_)?_.map(Ne=>this.h(ke,Ne)):[this.h(ke,_)]}async provideCallsTo(T,H,J){const B=this.j(T,H);if(!B)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyIncomingCalls(B,J);if(Z)return Z.map(_=>({from:this.h(T,_.from),fromRanges:_.fromRanges.map(ke=>I.Range.from(ke))}))}async provideCallsFrom(T,H,J){const B=this.j(T,H);if(!B)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyOutgoingCalls(B,J);if(Z)return Z.map(_=>({to:this.h(T,_.to),fromRanges:_.fromRanges.map(ke=>I.Range.from(ke))}))}releaseSession(T){this.e.delete(T)}h(T,H){const J=this.e.get(T),B=I.CallHierarchyItem.from(H,T,J.size.toString(36));return J.set(B._itemId,H),B}j(T,H){return this.e.get(T)?.get(H)}}class ee{constructor(T,H){this.f=T,this.g=H,this.d=new s.$AN(""),this.e=new Map}async prepareSession(T,H,J){const B=this.f.getDocument(T),Z=I.Position.to(H),_=await this.g.prepareTypeHierarchy(B,Z,J);if(!_)return;const ke=this.d.nextId();return this.e.set(ke,new Map),Array.isArray(_)?_.map(Ne=>this.h(ke,Ne)):[this.h(ke,_)]}async provideSupertypes(T,H,J){const B=this.j(T,H);if(!B)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySupertypes(B,J);if(Z)return Z.map(_=>this.h(T,_))}async provideSubtypes(T,H,J){const B=this.j(T,H);if(!B)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySubtypes(B,J);if(Z)return Z.map(_=>this.h(T,_))}releaseSession(T){this.e.delete(T)}h(T,H){const J=this.e.get(T),B=I.TypeHierarchyItem.from(H,T,J.size.toString(36));return J.set(B._itemId,H),B}j(T,H){return this.e.get(T)?.get(H)}}class he{static toInternalProviderId(T,H){return T+"."+H}constructor(T,H,J,B,Z){this.d=T,this.e=H,this.f=J,this.g=B,this.h=Z}async provideDocumentOnDropEdits(T,H,J,B,Z){const _=this.e.getDocument(H),ke=I.Position.to(J),Ne=I.DataTransfer.toDataTransfer(B,async He=>(await this.d.$resolveDocumentOnDropFileData(this.g,T,He)).buffer),We=await this.f.provideDocumentDropEdits(_,ke,Ne,Z);if(We)return{label:We.label??(0,f.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(He=>"mimeType"in He?He:{providerId:he.toInternalProviderId(He.extensionId,He.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class fe{constructor(T,H){this.d=T,this.e=H}async provideMappedEdits(T,H,J,B){const Z=S.URI.revive(T),_=this.d.getDocument(Z),ke=J.documents.map(He=>He.map(Ye=>({uri:S.URI.revive(Ye.uri),version:Ye.version,ranges:Ye.ranges.map(nt=>I.Range.to(nt))}))),Ne={documents:ke,selections:ke[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(_,H,Ne,B);return We?I.WorkspaceEdit.from(We):null}}class Ce{constructor(T,H){this.adapter=T,this.extension=H}}class de{static{this.d=0}constructor(T,H,J,B,Z,_,ke,Ne){this.g=H,this.h=J,this.j=B,this.k=Z,this.l=_,this.m=ke,this.n=Ne,this.f=new Map,this.e=T.getProxy(m.$kL.MainThreadLanguageFeatures)}o(T,H){return I.DocumentSelector.from(T,this.g,H)}p(T){return new R.$mL(()=>{this.f.delete(T),this.e.$unregister(T)})}q(){return de.d++}async s(T,H,J,B,Z,_=!1){const ke=this.f.get(T);if(!ke||!(ke.adapter instanceof H))return B;const Ne=Date.now();_||this.l.trace(`[${ke.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const We=J(ke.adapter,ke.extension);return Promise.resolve(We).catch(He=>{(0,a.$4)(He)||(this.l.error(`[${ke.extension.identifier.value}] provider FAILED`),this.l.error(He),this.n.onExtensionError(ke.extension.identifier,He))}).finally(()=>{_||this.l.trace(`[${ke.extension.identifier.value}] provider DONE after ${Date.now()-Ne}ms`)}),$.CancellationToken.isCancellationToken(Z)?(0,u.$Wg)(We,Z):We}t(T,H){const J=this.q();return this.f.set(J,new Ce(T,H)),J}static u(T){return T.displayName||T.name}registerDocumentSymbolProvider(T,H,J,B){const Z=this.t(new n(this.h,J),T),_=B&&B.label||de.u(T);return this.e.$registerDocumentSymbolProvider(Z,this.o(H,T),_),this.p(Z)}$provideDocumentSymbols(T,H,J){return this.s(T,n,B=>B.provideDocumentSymbols(S.URI.revive(H),J),void 0,J)}registerCodeLensProvider(T,H,J){const B=this.q(),Z=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(B,new Ce(new w(this.h,this.j.converter,J,T,this.n,this.l),T)),this.e.$registerCodeLensSupport(B,this.o(H,T),Z);let _=this.p(B);if(Z!==void 0){const ke=J.onDidChangeCodeLenses(Ne=>this.e.$emitCodeLensEvent(Z));_=R.$mL.from(_,ke)}return _}$provideCodeLenses(T,H,J){return this.s(T,w,B=>B.provideCodeLenses(S.URI.revive(H),J),void 0,J)}$resolveCodeLens(T,H,J){return this.s(T,w,B=>B.resolveCodeLens(H,J),void 0,void 0)}$releaseCodeLenses(T,H){this.s(T,w,J=>Promise.resolve(J.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(T,H,J){const B=this.t(new d(this.h,J),T);return this.e.$registerDefinitionSupport(B,this.o(H,T)),this.p(B)}$provideDefinition(T,H,J,B){return this.s(T,d,Z=>Z.provideDefinition(S.URI.revive(H),J,B),[],B)}registerDeclarationProvider(T,H,J){const B=this.t(new b(this.h,J),T);return this.e.$registerDeclarationSupport(B,this.o(H,T)),this.p(B)}$provideDeclaration(T,H,J,B){return this.s(T,b,Z=>Z.provideDeclaration(S.URI.revive(H),J,B),[],B)}registerImplementationProvider(T,H,J){const B=this.t(new P(this.h,J),T);return this.e.$registerImplementationSupport(B,this.o(H,T)),this.p(B)}$provideImplementation(T,H,J,B){return this.s(T,P,Z=>Z.provideImplementation(S.URI.revive(H),J,B),[],B)}registerTypeDefinitionProvider(T,H,J){const B=this.t(new g(this.h,J),T);return this.e.$registerTypeDefinitionSupport(B,this.o(H,T)),this.p(B)}$provideTypeDefinition(T,H,J,B){return this.s(T,g,Z=>Z.provideTypeDefinition(S.URI.revive(H),J,B),[],B)}registerHoverProvider(T,H,J,B){const Z=this.t(new v(this.h,J),T);return this.e.$registerHoverProvider(Z,this.o(H,T)),this.p(Z)}$provideHover(T,H,J,B){return this.s(T,v,Z=>Z.provideHover(S.URI.revive(H),J,B),void 0,B)}registerEvaluatableExpressionProvider(T,H,J,B){const Z=this.t(new k(this.h,J),T);return this.e.$registerEvaluatableExpressionProvider(Z,this.o(H,T)),this.p(Z)}$provideEvaluatableExpression(T,H,J,B){return this.s(T,k,Z=>Z.provideEvaluatableExpression(S.URI.revive(H),J,B),void 0,B)}registerInlineValuesProvider(T,H,J,B){const Z=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,_=this.t(new F(this.h,J),T);this.e.$registerInlineValuesProvider(_,this.o(H,T),Z);let ke=this.p(_);if(Z!==void 0){const Ne=J.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Z));ke=R.$mL.from(ke,Ne)}return ke}$provideInlineValues(T,H,J,B,Z){return this.s(T,F,_=>_.provideInlineValues(S.URI.revive(H),J,B,Z),void 0,Z)}registerDocumentHighlightProvider(T,H,J){const B=this.t(new O(this.h,J),T);return this.e.$registerDocumentHighlightProvider(B,this.o(H,T)),this.p(B)}registerMultiDocumentHighlightProvider(T,H,J){const B=this.t(new G(this.h,J),T);return this.e.$registerMultiDocumentHighlightProvider(B,this.o(H,T)),this.p(B)}$provideDocumentHighlights(T,H,J,B){return this.s(T,O,Z=>Z.provideDocumentHighlights(S.URI.revive(H),J,B),void 0,B)}$provideMultiDocumentHighlights(T,H,J,B,Z){return this.s(T,G,_=>_.provideMultiDocumentHighlights(S.URI.revive(H),J,B.map(ke=>S.URI.revive(ke)),Z),void 0,Z)}registerLinkedEditingRangeProvider(T,H,J){const B=this.t(new q(this.h,J),T);return this.e.$registerLinkedEditingRangeProvider(B,this.o(H,T)),this.p(B)}$provideLinkedEditingRanges(T,H,J,B){return this.s(T,q,async Z=>{const _=await Z.provideLinkedEditingRanges(S.URI.revive(H),J,B);if(_)return{ranges:_.ranges,wordPattern:_.wordPattern?de.w(_.wordPattern):void 0}},void 0,B)}registerReferenceProvider(T,H,J){const B=this.t(new U(this.h,J),T);return this.e.$registerReferenceSupport(B,this.o(H,T)),this.p(B)}$provideReferences(T,H,J,B,Z){return this.s(T,U,_=>_.provideReferences(S.URI.revive(H),J,B,Z),void 0,Z)}registerCodeActionProvider(T,H,J,B){const Z=new r.$Sc,_=this.t(new C(this.h,this.j.converter,this.k,J,this.l,T,this.m),T);return this.e.$registerQuickFixSupport(_,this.o(H,T),{providedKinds:B?.providedCodeActionKinds?.map(ke=>ke.value),documentation:B?.documentation?.map(ke=>({kind:ke.kind.value,command:this.j.converter.toInternal(ke.command,Z)}))},de.u(T),!!J.resolveCodeAction),Z.add(this.p(_)),Z}$provideCodeActions(T,H,J,B,Z){return this.s(T,C,_=>_.provideCodeActions(S.URI.revive(H),J,B,Z),void 0,Z)}$resolveCodeAction(T,H,J){return this.s(T,C,B=>B.resolveCodeAction(H,J),{},void 0)}$releaseCodeActions(T,H){this.s(T,C,J=>Promise.resolve(J.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(T,H,J){const B=this.t(new W(this.h,J),T);return this.e.$registerDocumentFormattingSupport(B,this.o(H,T),T.identifier,T.displayName||T.name),this.p(B)}$provideDocumentFormattingEdits(T,H,J,B){return this.s(T,W,Z=>Z.provideDocumentFormattingEdits(S.URI.revive(H),J,B),void 0,B)}registerDocumentRangeFormattingEditProvider(T,H,J){const B=typeof J.provideDocumentRangesFormattingEdits=="function",Z=this.t(new se(this.h,J),T);return this.e.$registerRangeFormattingSupport(Z,this.o(H,T),T.identifier,T.displayName||T.name,B),this.p(Z)}$provideDocumentRangeFormattingEdits(T,H,J,B,Z){return this.s(T,se,_=>_.provideDocumentRangeFormattingEdits(S.URI.revive(H),J,B,Z),void 0,Z)}$provideDocumentRangesFormattingEdits(T,H,J,B,Z){return this.s(T,se,_=>_.provideDocumentRangesFormattingEdits(S.URI.revive(H),J,B,Z),void 0,Z)}registerOnTypeFormattingEditProvider(T,H,J,B){const Z=this.t(new le(this.h,J),T);return this.e.$registerOnTypeFormattingSupport(Z,this.o(H,T),B,T.identifier),this.p(Z)}$provideOnTypeFormattingEdits(T,H,J,B,Z,_){return this.s(T,le,ke=>ke.provideOnTypeFormattingEdits(S.URI.revive(H),J,B,Z,_),void 0,_)}registerWorkspaceSymbolProvider(T,H){const J=this.t(new Ee(H,this.l),T);return this.e.$registerNavigateTypeSupport(J,typeof H.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(T,H,J){return this.s(T,Ee,B=>B.provideWorkspaceSymbols(H,J),{symbols:[]},J)}$resolveWorkspaceSymbol(T,H,J){return this.s(T,Ee,B=>B.resolveWorkspaceSymbol(H,J),void 0,void 0)}$releaseWorkspaceSymbols(T,H){this.s(T,Ee,J=>J.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(T,H,J){const B=this.t(new De(this.h,J,this.l),T);return this.e.$registerRenameSupport(B,this.o(H,T),De.supportsResolving(J)),this.p(B)}$provideRenameEdits(T,H,J,B,Z){return this.s(T,De,_=>_.provideRenameEdits(S.URI.revive(H),J,B,Z),void 0,Z)}$resolveRenameLocation(T,H,J,B){return this.s(T,De,Z=>Z.resolveRenameLocation(S.URI.revive(H),J,B),void 0,B)}registerDocumentSemanticTokensProvider(T,H,J,B){const Z=this.t(new pe(this.h,J),T),_=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Z,this.o(H,T),B,_);let ke=this.p(Z);if(_){const Ne=J.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(_));ke=R.$mL.from(ke,Ne)}return ke}$provideDocumentSemanticTokens(T,H,J,B){return this.s(T,pe,Z=>Z.provideDocumentSemanticTokens(S.URI.revive(H),J,B),null,B)}$releaseDocumentSemanticTokens(T,H){this.s(T,pe,J=>J.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(T,H,J,B){const Z=this.t(new oe(this.h,J),T);return this.e.$registerDocumentRangeSemanticTokensProvider(Z,this.o(H,T),B),this.p(Z)}$provideDocumentRangeSemanticTokens(T,H,J,B){return this.s(T,oe,Z=>Z.provideDocumentRangeSemanticTokens(S.URI.revive(H),J,B),null,B)}registerCompletionItemProvider(T,H,J,B){const Z=this.t(new $e(this.h,this.j.converter,J,this.m,T),T);return this.e.$registerCompletionsProvider(Z,this.o(H,T),B,$e.supportsResolving(J),T.identifier),this.p(Z)}$provideCompletionItems(T,H,J,B,Z){return this.s(T,$e,_=>_.provideCompletionItems(S.URI.revive(H),J,B,Z),void 0,Z)}$resolveCompletionItem(T,H,J){return this.s(T,$e,B=>B.resolveCompletionItem(H,J),void 0,J)}$releaseCompletionItems(T,H){this.s(T,$e,J=>J.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(T,H,J,B){const Z=new x(T,this.h,J,this.j.converter),_=this.t(Z,T);return this.e.$registerInlineCompletionsSupport(_,this.o(H,T),Z.supportsHandleEvents,p.$nm.toKey(T.identifier.value),B?.yieldTo?.map(ke=>p.$nm.toKey(ke))||[]),this.p(_)}$provideInlineCompletions(T,H,J,B,Z){return this.s(T,ie,_=>_.provideInlineCompletions(S.URI.revive(H),J,B,Z),void 0,Z)}$handleInlineCompletionDidShow(T,H,J,B){this.s(T,ie,async Z=>{Z.handleDidShowCompletionItem(H,J,B)},void 0,void 0)}$handleInlineCompletionPartialAccept(T,H,J,B){this.s(T,ie,async Z=>{Z.handlePartialAccept(H,J,B)},void 0,void 0)}$freeInlineCompletionsList(T,H){this.s(T,ie,async J=>{J.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(T,H,J,B){const Z=Array.isArray(B)?{triggerCharacters:B,retriggerCharacters:[]}:B,_=this.t(new ne(this.h,J),T);return this.e.$registerSignatureHelpProvider(_,this.o(H,T),Z),this.p(_)}$provideSignatureHelp(T,H,J,B,Z){return this.s(T,ne,_=>_.provideSignatureHelp(S.URI.revive(H),J,B,Z),void 0,Z)}$releaseSignatureHelp(T,H){this.s(T,ne,J=>J.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(T,H,J){const B=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,Z=this.t(new Ie(this.h,this.j.converter,J,this.l,T),T);this.e.$registerInlayHintsProvider(Z,this.o(H,T),typeof J.resolveInlayHint=="function",B,de.u(T));let _=this.p(Z);if(B!==void 0){const ke=J.onDidChangeInlayHints(Ne=>this.e.$emitInlayHintsEvent(B));_=R.$mL.from(_,ke)}return _}$provideInlayHints(T,H,J,B){return this.s(T,Ie,Z=>Z.provideInlayHints(S.URI.revive(H),J,B),void 0,B)}$resolveInlayHint(T,H,J){return this.s(T,Ie,B=>B.resolveInlayHint(H,J),void 0,J)}$releaseInlayHints(T,H){this.s(T,Ie,J=>J.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(T,H,J){const B=this.t(new Me(this.h,J),T);return this.e.$registerDocumentLinkProvider(B,this.o(H,T),typeof J.resolveDocumentLink=="function"),this.p(B)}$provideDocumentLinks(T,H,J){return this.s(T,Me,B=>B.provideLinks(S.URI.revive(H),J),void 0,J,H.scheme==="output")}$resolveDocumentLink(T,H,J){return this.s(T,Me,B=>B.resolveLink(H,J),void 0,void 0,!0)}$releaseDocumentLinks(T,H){this.s(T,Me,J=>J.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(T,H,J){const B=this.t(new Le(this.h,J),T);return this.e.$registerDocumentColorProvider(B,this.o(H,T)),this.p(B)}$provideDocumentColors(T,H,J){return this.s(T,Le,B=>B.provideColors(S.URI.revive(H),J),[],J)}$provideColorPresentations(T,H,J,B){return this.s(T,Le,Z=>Z.provideColorPresentations(S.URI.revive(H),J,B),void 0,B)}registerFoldingRangeProvider(T,H,J){const B=this.q(),Z=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(B,new Ce(new we(this.h,J),T)),this.e.$registerFoldingRangeProvider(B,this.o(H,T),T.identifier,Z);let _=this.p(B);if(Z!==void 0){const ke=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Z));_=R.$mL.from(_,ke)}return _}$provideFoldingRanges(T,H,J,B){return this.s(T,we,Z=>Z.provideFoldingRanges(S.URI.revive(H),J,B),void 0,B)}registerSelectionRangeProvider(T,H,J){const B=this.t(new ge(this.h,J,this.l),T);return this.e.$registerSelectionRangeProvider(B,this.o(H,T)),this.p(B)}$provideSelectionRanges(T,H,J,B){return this.s(T,ge,Z=>Z.provideSelectionRanges(S.URI.revive(H),J,B),[],B)}registerCallHierarchyProvider(T,H,J){const B=this.t(new K(this.h,J),T);return this.e.$registerCallHierarchyProvider(B,this.o(H,T)),this.p(B)}$prepareCallHierarchy(T,H,J,B){return this.s(T,K,Z=>Promise.resolve(Z.prepareSession(S.URI.revive(H),J,B)),void 0,B)}$provideCallHierarchyIncomingCalls(T,H,J,B){return this.s(T,K,Z=>Z.provideCallsTo(H,J,B),void 0,B)}$provideCallHierarchyOutgoingCalls(T,H,J,B){return this.s(T,K,Z=>Z.provideCallsFrom(H,J,B),void 0,B)}$releaseCallHierarchy(T,H){this.s(T,K,J=>Promise.resolve(J.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(T,H,J){const B=this.t(new ee(this.h,J),T);return this.e.$registerTypeHierarchyProvider(B,this.o(H,T)),this.p(B)}$prepareTypeHierarchy(T,H,J,B){return this.s(T,ee,Z=>Promise.resolve(Z.prepareSession(S.URI.revive(H),J,B)),void 0,B)}$provideTypeHierarchySupertypes(T,H,J,B){return this.s(T,ee,Z=>Z.provideSupertypes(H,J,B),void 0,B)}$provideTypeHierarchySubtypes(T,H,J,B){return this.s(T,ee,Z=>Z.provideSubtypes(H,J,B),void 0,B)}$releaseTypeHierarchy(T,H){this.s(T,ee,J=>Promise.resolve(J.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(T,H,J,B){const Z=this.q();this.f.set(Z,new Ce(new he(this.e,this.h,J,Z,T),T));const _=(0,t.$KF)(T,"dropMetadata")&&B?he.toInternalProviderId(T.identifier.value,B.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Z,this.o(H,T),_,(0,t.$KF)(T,"dropMetadata")?B:void 0),this.p(Z)}$provideDocumentOnDropEdits(T,H,J,B,Z,_){return this.s(T,he,ke=>Promise.resolve(ke.provideDocumentOnDropEdits(H,S.URI.revive(J),B,Z,_)),void 0,void 0)}registerMappedEditsProvider(T,H,J){const B=this.t(new fe(this.h,J),T);return this.e.$registerMappedEditsProvider(B,this.o(H,T)),this.p(B)}$provideMappedEdits(T,H,J,B,Z){return this.s(T,fe,_=>Promise.resolve(_.provideMappedEdits(H,J,B,Z)),null,Z)}registerDocumentPasteEditProvider(T,H,J,B){const Z=this.q();this.f.set(Z,new Ce(new N(this.e,this.h,J,Z,T),T));const _=N.toInternalProviderId(T.identifier.value,B.id);return this.e.$registerPasteEditProvider(Z,this.o(H,T),_,{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,copyMimeTypes:B.copyMimeTypes,pasteMimeTypes:B.pasteMimeTypes}),this.p(Z)}$prepareDocumentPaste(T,H,J,B,Z){return this.s(T,N,_=>_.prepareDocumentPaste(S.URI.revive(H),J,B,Z),void 0,Z)}$providePasteEdits(T,H,J,B,Z,_){return this.s(T,N,ke=>ke.providePasteEdits(H,S.URI.revive(J),B,Z,_),void 0,_)}static w(T){return{pattern:T.source,flags:T.flags}}static y(T){return{decreaseIndentPattern:de.w(T.decreaseIndentPattern),increaseIndentPattern:de.w(T.increaseIndentPattern),indentNextLinePattern:T.indentNextLinePattern?de.w(T.indentNextLinePattern):void 0,unIndentedLinePattern:T.unIndentedLinePattern?de.w(T.unIndentedLinePattern):void 0}}static z(T){return{beforeText:de.w(T.beforeText),afterText:T.afterText?de.w(T.afterText):void 0,previousLineText:T.previousLineText?de.w(T.previousLineText):void 0,action:T.action}}static B(T){return T.map(de.z)}static C(T){return{open:T.open,close:T.close,notIn:T.notIn?T.notIn.map(H=>R.SyntaxTokenType.toString(H)):void 0}}static D(T){return T.map(de.C)}setLanguageConfiguration(T,H,J){const{wordPattern:B}=J;if(B&&(0,h.$Ze)(B))throw new Error(`Invalid language configuration: wordPattern '${B}' is not allowed to match the empty string.`);B?this.h.setWordDefinitionFor(H,B):this.h.setWordDefinitionFor(H,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",T,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",T,"Do not use.");const Z=this.q(),_={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?de.w(J.wordPattern):void 0,indentationRules:J.indentationRules?de.y(J.indentationRules):void 0,onEnterRules:J.onEnterRules?de.B(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?de.D(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Z,H,_),this.p(Z)}$setWordDefinitions(T){for(const H of T)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.$kgc=de}),define(Re[258],Ae([1,0,3,8,7,32,11,6,24]),function(me,e,S,M,I,R,L,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=void 0;class E{constructor(D,l,$,p){this.c=l,this.d=$,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(S.$kL.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,l){await this.a.$changeLanguage(D,l);const $=this.c.getDocumentData(D);if(!$)throw new Error(`document '${D.toString()}' NOT found`);return $.document}async tokenAtPosition(D,l){const $=D.version,p=M.Position.from(l),r=await this.a.$tokensAtPosition(D.uri,p),c={type:I.StandardTokenType.Other,range:D.getWordRangeAtPosition(l)??new I.$oL(l.line,l.character,l.line,l.character)};if(!r)return c;const s={range:M.Range.to(r.range),type:M.TokenType.to(r.type)};return!s.range.contains(l)||$!==D.version?c:s}createLanguageStatusItem(D,l,$){const p=this.f++,r=this.a,c=this.g,s=`${D.identifier.value}/${l}`;if(c.has(s))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);c.add(s);const i={selector:$,id:l,name:D.displayName??D.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let o;const a=new m.$Sc,u=()=>{if(o?.dispose(),!c.has(s)){console.warn(`LanguageStatusItem (${l}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}o=(0,L.$0g)(()=>{a.clear(),this.a.$setLanguageStatus(p,{id:s,name:i.name??D.displayName??D.name,source:D.displayName??D.name,selector:M.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===I.LanguageStatusSeverity.Error?R.default.Error:i.severity===I.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:i.command&&this.d.toInternal(i.command,a),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){a.dispose(),o?.dispose(),r.$removeLanguageStatus(p),c.delete(s)},get id(){return i.id},get name(){return i.name},set name(f){i.name=f,u()},get selector(){return i.selector},set selector(f){i.selector=f,u()},get text(){return i.text},set text(f){i.text=f,u()},set text2(f){(0,h.$LF)(D,"languageStatusText"),i.text=f,u()},get text2(){return(0,h.$LF)(D,"languageStatusText"),i.text},get detail(){return i.detail},set detail(f){i.detail=f,u()},get severity(){return i.severity},set severity(f){i.severity=f,u()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(f){i.accessibilityInformation=f,u()},get command(){return i.command},set command(f){i.command=f,u()},get busy(){return i.busy},set busy(f){i.busy=f,u()}};return u(),t}}e.$Jhc=E}),define(Re[259],Ae([1,0,12,2,8,7,83]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=e.$uhc=void 0;class m{constructor(D,l,$,p){this.start=D,this.deletedCount=l,this.deletedItems=$,this.items=p}asApiEvent(){return{range:new R.$LM(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class h{static asModelAddData(D,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,l,$){this.notebook=D,this.h=l,this.j=$,this.handle=$.handle,this.uri=M.URI.revive($.uri),this.cellKind=$.cellKind,this.a=$.outputs.map(I.NotebookCellOutput.to),this.e=$.internalMetadata??{},this.b=Object.freeze($.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to($.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const $={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return D.g},set mime(p){D.g=p},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze($)}return this.f}setOutputs(D){this.a=D.map(I.NotebookCellOutput.to)}setOutputItems(D,l,$){const p=$.map(I.NotebookCellOutputItem.to),r=this.a.find(c=>c.id===D);if(r&&(l||(r.items.length=0),r.items.push(...p),r.items.length>1&&r.items.every(c=>L.$nJ(c.mime)))){const c=new Map,s=[];r.items.forEach(i=>{let o;c.has(i.mime)?o=c.get(i.mime):(o=[],c.set(i.mime,o),s.push(i.mime)),o.push(i.data)}),r.items.length=0,s.forEach(i=>{const o=L.$oJ(c.get(i));r.items.push({mime:i,data:o.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$uhc=h;class E{static{this.a=0}constructor(D,l,$,p,r){this.k=D,this.l=l,this.m=$,this.uri=p,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,l={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===S.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt($){return $=D.n($),D.b[$].apiCell},getCells($){return($?D.p($):D.b).map(r=>r.apiCell)},save(){return D.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,l,$){this.g=D.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:$});const p={notebook:this.apiNotebook,metadata:$,cellChanges:[],contentChanges:[]},r=[];for(const s of D.rawEvents)s.kind===L.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,p.contentChanges):s.kind===L.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,p.contentChanges):s.kind===L.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===L.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===L.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),r.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),r.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const c=new Map;for(let s=0;s<r.length;s++){const i=r[s],o=c.get(i.cell);if(o===void 0){const a=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});c.set(i.cell,a-1)}else p.cellChanges[o]={...p.cellChanges[o],...i}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let l=D.start|0,$=D.end|0;return l<0&&(l=0),$>this.b.length&&($=this.b.length),D.with({start:l,end:$})}p(D){D=this.o(D);const l=[];for(let $=D.start;$<D.end;$++)l.push(this.b[$]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,l,$){if(this.j)return;const p=[],r=[],c=[];if(D.reverse().forEach(s=>{const o=s[2].map(t=>{const f=new h(this,this.l,t);return l||r.push(h.asModelAddData(this.apiNotebook,t)),f}),a=new m(s[0],s[1],[],o),u=this.b.splice(s[0],s[1],...o);for(const t of u)c.push(t.uri),a.deletedItems.push(t.apiCell);p.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:c}),$)for(const s of p)$.push(s.asApiEvent())}s(D,l,$,p){const r=this.b.splice(D,l);this.b.splice($,0,...r);const c=[new m(D,l,r.map(s=>s.apiCell),[]),new m($,0,[],r)];for(const s of c)p.push(s.asApiEvent())}t(D,l){this.b[D].setOutputs(l)}u(D,l,$,p){this.b[D].setOutputItems(l,$,p)}v(D,l){const $=this.b[D];$.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged($.uri,l)}w(D,l){const $=this.b[D];$.apiCell.mime=l}x(D,l){this.b[D].setMetadata(l)}y(D,l){this.b[D].setInternalMetadata(l)}getCellFromApiCell(D){return this.b.find(l=>l.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(l=>l.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$vhc=E}),define(Re[260],Ae([1,0,5,2,8,7]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;class L{constructor(h,E,A,D={timeout:1500,errors:3}){this.b=h,this.c=E,this.d=A,this.f=D,this.a=new S.$Yd}dispose(){}getOnWillSaveNotebookDocumentEvent(h){return(E,A,D)=>{const l=function(p){E.call(A,p)};return l.extension=h,this.a.event(l,void 0,D)}}async $participateInSave(h,E,A){const D=M.URI.revive(h),l=this.c.getNotebookDocument(D);if(!l)throw new Error("Unable to resolve notebook document");const $=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:I.TextDocumentSaveReason.to(E)},A,async(r,c)=>{const s=Date.now(),i=await await Promise.resolve(r);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!A.isCancellationRequested&&i&&(i instanceof R.$wL?$.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if($.length===0)return!0;const p={edits:[]};for(const r of $){const{edits:c}=I.WorkspaceEdit.from(r);p.edits=p.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit(p)}}e.$Lhc=L}),define(Re[109],Ae([1,0,15,8,7]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,h,E,A,D,l){this.id=m,this.f=h,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=A,this.c=l}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(h){this.selections=[h]},get selections(){return m.a},set selections(h){if(!Array.isArray(h)||!h.every(I.$LM.isNotebookRange))throw(0,S.$7)("selections");m.a=h,m.g(h)},get visibleRanges(){return m.b},revealRange(h,E){m.f.$tryRevealRange(m.id,M.NotebookRange.from(h),E??I.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(M.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$whc=R}),define(Re[261],Ae([1,0,5,13,8]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=void 0;let R=class{constructor(m,h){this.c=m,this.d=h,this.a=new S.$Wd,this.b=new S.$Wd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(m,h){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,h);const E=this.d.getEditorById(m);h.visibleRanges&&E._acceptVisibleRanges(h.visibleRanges.ranges.map(I.NotebookRange.to)),h.selections&&E._acceptSelections(h.selections.selections.map(I.NotebookRange.to)),h.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),h.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const h in m)this.d.getEditorById(h)._acceptViewColumn(I.ViewColumn.to(m[h]))}};e.$Nhc=R,e.$Nhc=R=Ke([Ve(0,M.$pj)],R)}),define(Re[262],Ae([1,0,5,3,109]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=void 0;class R{constructor(m,h){this.c=h,this.a=new Map,this.b=m.getProxy(M.$kL.MainThreadNotebookRenderers)}$postRendererMessage(m,h,E){const A=this.c.getEditorById(m);this.a.get(h)?.fire({editor:A.apiEditor,message:E})}createRendererMessaging(m,h){if(!m.contributes?.notebookRenderer?.some(A=>A.id===h))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${h})`);return{onDidReceiveMessage:(A,D,l)=>this.d(h).event(A,D,l),postMessage:(A,D)=>{I.$whc.apiEditorsToExtHost.has(A)&&([A,D]=[D,A]);const l=D&&I.$whc.apiEditorsToExtHost.get(D);return this.b.$postMessage(l?.id,h,A)}}}d(m){let h=this.a.get(m);return h||(h=new S.$Wd({onDidRemoveLastListener:()=>{h?.dispose(),this.a.delete(m)}}),this.a.set(m,h),h)}}e.$Qhc=R}),define(Re[263],Ae([1,0,8,99,21,67,15]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;class m{constructor(D){this.b=0,this.c=new Map,this.a=D}async withProgress(D,l,$){const p=this.b++,{title:r,location:c,cancellable:s}=l,i={label:D.displayName||D.name,id:D.identifier.value};return this.a.$startProgress(p,{location:S.ProgressLocation.from(c),title:r,source:i,cancellable:s},D.isUnderDevelopment?void 0:D.identifier.value).catch(L.$2),this.d(p,$,!!s)}d(D,l,$){let p;$&&(p=new I.$7d,this.c.set(D,p));const r=s=>{this.a.$progressEnd(s),this.c.delete(s),p?.dispose()};let c;try{c=l(new E(this.a,D),$&&p?p.token:I.CancellationToken.None)}catch(s){throw r(D),s}return c.then(s=>r(D),s=>r(D)),c}$acceptProgressCanceled(D){const l=this.c.get(D);l&&(l.cancel(),this.c.delete(D))}}e.$Uhc=m;function h(A,D){return A.message=D.message,typeof D.increment=="number"&&(typeof A.increment=="number"?A.increment+=D.increment:A.increment=D.increment),A}class E extends M.$xv{constructor(D,l){super($=>this.throttledReport($)),this.c=D,this.d=l}throttledReport(D){this.c.$progressReport(this.d,D)}}Ke([(0,R.$Bh)(100,(A,D)=>h(A,D),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Re[264],Ae([1,0,2,3,11,8]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0;class L{static{this.a=0}constructor(h,E){this.d=E,this.c=new Map,this.b=h.getProxy(M.$kL.MainThreadQuickDiff)}$provideOriginalResource(h,E,A){const D=S.URI.revive(E),l=this.c.get(h);return l?(0,I.$Zg)(()=>l.provideOriginalResource(D,A)).then($=>$||null):Promise.resolve(null)}registerQuickDiffProvider(h,E,A,D){const l=L.a++;return this.c.set(l,E),this.b.$registerQuickDiffProvider(l,R.DocumentSelector.from(h,this.d),A,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Vhc=L}),define(Re[265],Ae([1,0,21,5,6,3,2,7,15,18,32,40,24,8]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0;function p(r,c,s){const i=r.getProxy(R.$kL.MainThreadQuickOpen);class o{constructor(b,P){this.e=new Map,this.f=0,this.a=b,this.b=P}showQuickPick(b,P,g,v=S.CancellationToken.None){this.c=void 0;const k=Promise.resolve(P),F=++this.f,O=i.$show(F,{title:g?.title,placeHolder:g?.placeHolder,matchOnDescription:g?.matchOnDescription,matchOnDetail:g?.matchOnDetail,ignoreFocusLost:g?.ignoreFocusOut,canPickMany:g?.canPickMany},v),G={},q=O.then(()=>G);return Promise.race([q,k]).then(U=>{if(U===G)return;const C=(0,l.$KF)(b,"quickPickItemTooltip");return k.then(N=>{const W=[];for(let se=0;se<N.length;se++){const le=N[se];if(typeof le=="string")W.push({label:le,handle:se});else if(le.kind===m.QuickPickItemKind.Separator)W.push({type:"separator",label:le.label});else{le.tooltip&&!C&&console.warn(`Extension '${b.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`);const Ee=le.iconPath?n(le.iconPath):void 0;W.push({label:le.label,iconPath:Ee?.iconPath,iconClass:Ee?.iconClass,description:le.description,detail:le.detail,picked:le.picked,alwaysShow:le.alwaysShow,tooltip:C?$.MarkdownString.fromStrict(le.tooltip):void 0,handle:se})}}return g&&typeof g.onDidSelectItem=="function"&&(this.c=se=>{g.onDidSelectItem(N[se])}),i.$setItems(F,W),O.then(se=>{if(typeof se=="number")return N[se];if(Array.isArray(se))return se.map(le=>N[le])})})}).then(void 0,U=>{if(!(0,h.$4)(U))return i.$setError(F,U),Promise.reject(U)})}$onItemSelected(b){this.c?.(b)}showInput(b,P=S.CancellationToken.None){return this.d=b?.validateInput,i.$input(b,typeof this.d=="function",P).then(void 0,g=>{if(!(0,h.$4)(g))return Promise.reject(g)})}async $validateInput(b){if(!this.d)return;const P=await this.d(b);if(!P||typeof P=="string")return P;let g;switch(P.severity){case m.InputBoxValidationSeverity.Info:g=A.default.Info;break;case m.InputBoxValidationSeverity.Warning:g=A.default.Warning;break;case m.InputBoxValidationSeverity.Error:g=A.default.Error;break;default:g=P.message?A.default.Error:A.default.Ignore;break}return{content:P.message,severity:g}}async showWorkspaceFolderPick(b,P=S.CancellationToken.None){const g=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[b]);if(!g)return;const v=await this.a.getWorkspaceFolders2();if(v)return v.find(k=>k.uri.toString()===g.uri.toString())}createQuickPick(b){const P=new w(b,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}createInputBox(b){const P=new y(b,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}$onDidChangeValue(b,P){this.e.get(b)?._fireDidChangeValue(P)}$onDidAccept(b){this.e.get(b)?._fireDidAccept()}$onDidChangeActive(b,P){const g=this.e.get(b);g instanceof w&&g._fireDidChangeActive(P)}$onDidChangeSelection(b,P){const g=this.e.get(b);g instanceof w&&g._fireDidChangeSelection(P)}$onDidTriggerButton(b,P){this.e.get(b)?._fireDidTriggerButton(P)}$onDidTriggerItemButton(b,P,g){const v=this.e.get(b);v instanceof w&&v._fireDidTriggerItemButton(P,g)}$onDidHide(b){this.e.get(b)?._fireDidHide()}}class a{static{this.a=1}constructor(b,P){this.x=b,this.y=P,this._id=w.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Wd,this.q=new M.$Wd,this.r=new M.$Wd,this.s=new M.$Wd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(b){this.b=b,this.z({title:b})}get step(){return this.c}set step(b){this.c=b,this.z({step:b})}get totalSteps(){return this.d}set totalSteps(b){this.d=b,this.z({totalSteps:b})}get enabled(){return this.g}set enabled(b){this.g=b,this.z({enabled:b})}get busy(){return this.j}set busy(b){this.j=b,this.z({busy:b})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(b){this.k=b,this.z({ignoreFocusOut:b})}get value(){return this.l}set value(b){this.l=b,this.z({value:b})}get placeholder(){return this.m}set placeholder(b){this.m=b,this.z({placeholder:b})}get buttons(){return this.n}set buttons(b){this.n=b.slice(),this.o.clear(),b.forEach((P,g)=>{const v=P===m.$IM.Back?-1:g;this.o.set(v,P)}),this.z({buttons:b.map((P,g)=>({...n(P.iconPath),tooltip:P.tooltip,handle:P===m.$IM.Back?-1:g}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(b){this.l=b,this.q.fire(b)}_fireDidTriggerButton(b){const P=this.o.get(b);P&&this.r.fire(P)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(b){if(!this.v){for(const P of Object.keys(b)){const g=b[P];this.u[P]=g===void 0?null:g}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function u(d){if(d instanceof m.$hM)return{id:d.id};const b=f(d),P=t(d);return{dark:typeof b=="string"?L.URI.file(b):b,light:typeof P=="string"?L.URI.file(P):P}}function t(d){return typeof d=="object"&&"light"in d?d.light:d}function f(d){return typeof d=="object"&&"dark"in d?d.dark:d}function n(d){const b=u(d);let P,g;return"id"in b?g=D.ThemeIcon.asClassName(b):P=b,{iconPath:P,iconClass:g}}class w extends a{constructor(b,P){super(b.identifier,P),this.O=b,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Wd,this.L=[],this.M=new M.$Wd,this.N=new M.$Wd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(b){this.B=b.slice(),this.C.clear(),this.D.clear(),b.forEach((v,k)=>{this.C.set(k,v),this.D.set(v,k)});const P=(0,l.$KF)(this.O,"quickPickItemTooltip"),g=[];for(let v=0;v<b.length;v++){const k=b[v];if(k.kind===m.QuickPickItemKind.Separator)g.push({type:"separator",label:k.label});else{k.tooltip&&!P&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const F=k.iconPath?n(k.iconPath):void 0;g.push({handle:v,label:k.label,iconPath:F?.iconPath,iconClass:F?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:P?$.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((O,G)=>({...n(O.iconPath),tooltip:O.tooltip,handle:G}))})}}this.z({items:g})}get canSelectMany(){return this.E}set canSelectMany(b){this.E=b,this.z({canSelectMany:b})}get matchOnDescription(){return this.F}set matchOnDescription(b){this.F=b,this.z({matchOnDescription:b})}get matchOnDetail(){return this.G}set matchOnDetail(b){this.G=b,this.z({matchOnDetail:b})}get sortByLabel(){return this.H}set sortByLabel(b){this.H=b,this.z({sortByLabel:b})}get keepScrollPosition(){return this.I}set keepScrollPosition(b){this.I=b,this.z({keepScrollPosition:b})}get activeItems(){return this.J}set activeItems(b){this.J=b.filter(P=>this.D.has(P)),this.z({activeItems:this.J.map(P=>this.D.get(P))})}get selectedItems(){return this.L}set selectedItems(b){this.L=b.filter(P=>this.D.has(P)),this.z({selectedItems:this.L.map(P=>this.D.get(P))})}_fireDidChangeActive(b){const P=(0,E.$Hb)(b.map(g=>this.C.get(g)));this.J=P,this.K.fire(P)}_fireDidChangeSelection(b){const P=(0,E.$Hb)(b.map(g=>this.C.get(g)));this.L=P,this.M.fire(P)}_fireDidTriggerItemButton(b,P){const g=this.C.get(b);if(!g||!g.buttons||!g.buttons.length)return;const v=g.buttons[P];v&&this.N.fire({button:v,item:g})}}class y extends a{constructor(b,P){super(b.identifier,P),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(b){this.B=b,this.z({password:b})}get prompt(){return this.C}set prompt(b){this.C=b,this.z({prompt:b})}get valueSelection(){return this.D}set valueSelection(b){this.D=b,this.z({valueSelection:b})}get validationMessage(){return this.E}set validationMessage(b){this.E=b,b?typeof b=="string"?this.z({validationMessage:b,severity:A.default.Error}):this.z({validationMessage:b.message,severity:b.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new o(c,s)}e.$Whc=p}),define(Re[266],Ae([1,0,2,5,67,6,11,3,18,138,13,22,40,8,24,12,20]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r,c){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=e.$Xhc=void 0;function i(F){return F instanceof S.URI}function o(F,O){return F.scheme===r.Schemas.file&&O.scheme===r.Schemas.file&&c.$k?F.toString()===O.toString():F.toString().toLowerCase()===O.toString().toLowerCase()}function a(F){if(F)return typeof F.iconPath=="string"?S.URI.file(F.iconPath):S.URI.isUri(F.iconPath)||l.ThemeIcon.isThemeIcon(F.iconPath)?F.iconPath:void 0}function u(F){if(F.icon){if(S.URI.isUri(F.icon))return F.icon;if(l.ThemeIcon.isThemeIcon(F.icon))return F.icon;{const O=F.icon;return{light:O.light,dark:O.dark}}}else return}function t(F,O){if(!F.iconPath&&!O.iconPath)return 0;if(F.iconPath){if(!O.iconPath)return 1}else return-1;const G=typeof F.iconPath=="string"?F.iconPath:S.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id,q=typeof O.iconPath=="string"?O.iconPath:S.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,E.$Uq)(G,q)}function f(F,O){let G=0;if(F.strikeThrough!==O.strikeThrough)return F.strikeThrough?1:-1;if(F.faded!==O.faded)return F.faded?1:-1;if(F.tooltip!==O.tooltip)return(F.tooltip||"").localeCompare(O.tooltip||"");if(G=t(F,O),G!==0)return G;if(F.light&&O.light)G=t(F.light,O.light);else{if(F.light)return 1;if(O.light)return-1}if(G!==0)return G;if(F.dark&&O.dark)G=t(F.dark,O.dark);else{if(F.dark)return 1;if(O.dark)return-1}return G}function n(F,O){if(F.command!==O.command)return F.command<O.command?-1:1;if(F.title!==O.title)return F.title<O.title?-1:1;if(F.tooltip!==O.tooltip){if(F.tooltip!==void 0&&O.tooltip!==void 0)return F.tooltip<O.tooltip?-1:1;if(F.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(F.arguments===O.arguments)return 0;if(F.arguments)if(O.arguments){if(F.arguments.length!==O.arguments.length)return F.arguments.length-O.arguments.length}else return 1;else return-1;for(let G=0;G<F.arguments.length;G++){const q=F.arguments[G],U=O.arguments[G];if(q!==U&&!(i(q)&&i(U)&&o(q,U)))return q<U?-1:1}return 0}function w(F,O){let G=(0,E.$Uq)(F.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(G!==0)return G;if(F.command&&O.command)G=n(F.command,O.command);else{if(F.command)return 1;if(O.command)return-1}if(G!==0)return G;if(F.decorations&&O.decorations)G=f(F.decorations,O.decorations);else{if(F.decorations)return 1;if(O.decorations)return-1}if(F.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)G=(0,E.$Uq)(F.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(F.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(F.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)G=(0,E.$Uq)(F.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(F.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return G}function y(F,O){for(let G=0;G<F.length;G++)if(F[G]!==O[G])return!1;return!0}function d(F,O){return F.command===O.command&&F.title===O.title&&F.tooltip===O.tooltip&&(F.arguments&&O.arguments?y(F.arguments,O.arguments):F.arguments===O.arguments)}function b(F,O){return(0,h.$ub)(F,O,d)}class P{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,p.$LF)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,p.$LF)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,p.$LF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,G,q,U,C){this.k=O,this.l=U,this.m=C,this.d="",this.e=new M.$Wd,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=q}showValidationMessage(O,G){(0,p.$LF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,G)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$Xhc=P;class g{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,G,q,U,C,N,W){this.q=O,this.s=G,this.t=q,this.u=U,this.v=C,this.multiDiffEditorEnableViewChanges=N,this.w=W,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Wd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Wd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=g.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,G){const q=this.h.get(O);return q?(0,L.$Zg)(()=>this.s.executeCommand(q.command,...q.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(w),q=(0,h.$Db)(this.o,O,w).map(N=>{const W=N.toInsert.map(se=>{const le=this.e++;this.g.set(le,se);const Ee=se.resourceUri;let De;if(se.command)if(se.command.command==="vscode.open"||se.command.command==="vscode.diff"||se.command.command==="vscode.changes"){const ge=new R.$Sc;De=this.s.converter.toInternal(se.command,ge),this.j.set(le,ge)}else this.h.set(le,se.command);const ce=(0,p.$KF)(this.w,"scmMultiDiffEditor"),pe=ce?se.multiDiffEditorOriginalUri:void 0,oe=ce?se.multiFileDiffEditorModifiedUri:void 0,$e=a(se.decorations),ie=se.decorations&&a(se.decorations.light)||$e,x=se.decorations&&a(se.decorations.dark)||$e,V=[ie,x],ne=se.decorations&&se.decorations.tooltip||"",Ie=se.decorations&&!!se.decorations.strikeThrough,Me=se.decorations&&!!se.decorations.faded,Le=se.contextValue||"";return{rawResource:[le,Ee,V,ne,Ie,Me,Le,De,pe,oe],handle:le}});return{start:N.start,deleteCount:N.deleteCount,toInsert:W}}),U=q.map(({start:N,deleteCount:W,toInsert:se})=>[N,W,se.map(le=>le.rawResource)]),C=q.reverse();for(const{start:N,deleteCount:W,toInsert:se}of C){const le=se.map(De=>De.handle),Ee=this.n.splice(N,W,...le);for(const De of Ee)this.g.delete(De),this.h.delete(De),this.j.get(De)?.dispose(),this.j.delete(De)}return this.o=O,U}dispose(){this.l=!0,this.m.fire()}}class v{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let G;(0,p.$KF)(this.x,"quickDiffProvider")&&(G=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:G})}get historyProvider(){return(0,p.$LF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,p.$LF)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new R.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new R.$Sc,this.o=O;const G=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:G})}get actionButton(){return(0,p.$LF)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,p.$LF)(this.x,"scmActionButton"),this.p.value=new R.$Sc,this.q=O;const G=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(q=>q.map(U=>this.y.converter.toInternal(U,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:G??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.t&&O&&b(this.t,O))return;this.s.value=new R.$Sc,this.t=O;const G=(O||[]).map(q=>this.y.converter.toInternal(q,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:G})}get selected(){return this.u}constructor(O,G,q,U,C,N,W){this.x=O,this.y=U,this.z=C,this.A=N,this.B=W,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Uc,this.m=void 0,this.n=new R.$Uc,this.o=void 0,this.p=new R.$Uc,this.s=new R.$Uc,this.t=void 0,this.u=!1,this.v=new M.$Wd,this.onDidChangeSelection=this.v.event,this.w=v.d++,this.C=new Map,this.D=new Set,this.#e=q;const se=S.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${C}/scm${this.w}/input`,query:W?`rootUri=${encodeURIComponent(W.toString())}`:void 0});this.f=new P(O,G,this.#e,this.w,se),this.#e.$registerSourceControl(this.w,C,N,W,se)}createResourceGroup(O,G,q){const U=(0,p.$KF)(this.x,"scmMultiDiffEditor")&&q?.multiDiffEditorEnableViewChanges===!0,C=new g(this.#e,this.y,this.w,O,G,U,this.x),N=M.Event.once(C.onDidDispose)(()=>this.C.delete(C));return this.C.set(C,N),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const O=[],G=[];for(const[q,U]of this.C){U.dispose();const C=q.onDidUpdateResourceStates(()=>{this.D.add(q),this.eventuallyUpdateResourceStates()});M.Event.once(q.onDidDispose)(()=>{this.D.delete(q),C.dispose(),this.e.delete(q.handle),this.#e.$unregisterGroup(this.w,q.handle)}),O.push([q.handle,q.id,q.label,q.features,q.multiDiffEditorEnableViewChanges]);const N=q._takeResourceStateSnapshot();N.length>0&&G.push([q.handle,N]),this.e.set(q.handle,q)}this.#e.$registerGroups(this.w,O,G),this.C.clear()}eventuallyUpdateResourceStates(){const O=[];this.D.forEach(G=>{const q=G._takeResourceStateSnapshot();q.length!==0&&O.push([G.handle,q])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.D.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ke([(0,I.$Ah)(100)],v.prototype,"eventuallyAddResourceGroups",null),Ke([(0,I.$Ah)(100)],v.prototype,"eventuallyUpdateResourceStates",null);let k=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,G,q,U){this.l=G,this.m=q,this.n=U,this.g=new Map,this.h=new D.$pm,this.j=new M.$Wd,this.e=O.getProxy(m.$kL.MainThreadSCM),this.f=O.getProxy(m.$kL.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===3){const N=this.g.get(C.sourceControlHandle);if(!N)return C;const W=N.getResourceGroup(C.groupHandle);return W?W.getResourceState(C.handle):C}else if(C&&C.$mid===4){const N=this.g.get(C.sourceControlHandle);return N?N.getResourceGroup(C.groupHandle):C}else if(C&&C.$mid===5){const N=this.g.get(C.handle);return N||C}return C}})}createSourceControl(O,G,q,U){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,G,q,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const C=s.d++,N=new v(O,this.m,this.e,this.l,G,q,U);this.g.set(C,N);const W=this.h.get(O.identifier)||[];return W.push(N),this.h.set(O.identifier,W),N}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const G=this.h.get(O.identifier),q=G&&G[G.length-1];return q&&q.inputBox}$provideOriginalResource(O,G,q){const U=S.URI.revive(G);this.n.trace("ExtHostSCM#$provideOriginalResource",O,U.toString());const C=this.g.get(O);return!C||!C.quickDiffProvider||!C.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$Zg)(()=>C.quickDiffProvider.provideOriginalResource(U,q)).then(N=>N||null)}$onInputBoxValueChange(O,G){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const q=this.g.get(O);return q&&q.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(O,G,q,U){this.n.trace("ExtHostSCM#$executeResourceCommand",O,G,q);const C=this.g.get(O);if(!C)return Promise.resolve(void 0);const N=C.getResourceGroup(G);return N?N.$executeResourceCommand(q,U):Promise.resolve(void 0)}$validateInput(O,G,q){this.n.trace("ExtHostSCM#$validateInput",O);const U=this.g.get(O);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,L.$Zg)(()=>U.inputBox.validateInput(G,q)).then(C=>{if(!C)return Promise.resolve(void 0);const N=$.MarkdownString.fromStrict(C.message);return N?Promise.resolve([N,C.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,G,q,U){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,q,U)??void 0}async $provideHistoryItems(O,G,q,U){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(G,q,U))?.map(W=>({...W,icon:u(W)}))??void 0}async $provideHistoryItemSummary(O,G,q,U){const C=this.g.get(O)?.historyProvider;if(typeof C?.provideHistoryItemSummary!="function")return;const N=await C.provideHistoryItemSummary(G,q,U);return N?{...N,icon:u(N)}:void 0}async $provideHistoryItemChanges(O,G,q,U){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(G,q,U)??void 0}};e.$Yhc=k,e.$Yhc=k=s=Ke([Ve(3,A.$pj)],k)}),define(Re[267],Ae([1,0,3,8,2]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=void 0;class R{static{this.a=0}constructor(m,h){this.d=h,this.c=new Map,this.b=m.getProxy(S.$kL.MainThreadShare)}async $provideShare(m,h,E){return await this.c.get(m)?.provideShare({selection:M.Range.to(h.selection),resourceUri:I.URI.revive(h.resourceUri)},E)??void 0}registerShareProvider(m,h){const E=R.a++;return this.c.set(E,h),this.b.$registerShareProvider(E,M.DocumentSelector.from(m,this.d),h.id,h.label,h.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$Zhc=R}),define(Re[268],Ae([1,0,7,3,163,6,8,16]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=e.$2hc=void 0;class h{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new S.$iM("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.$iM("statusBarItem.warningForeground")]])}#e;#t;constructor(l,$,p,r,c,s=S.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new R.$Sc,this.#e=l,this.#t=$,c&&r){this.c=(0,S.$XL)(r.identifier,c);const o=p.get(this.c);o&&(s=o.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,i=o.priority,this.j=!0,this.name=o.name,this.text=o.text,this.tooltip=o.tooltip,this.command=o.command,this.accessibilityInformation=o.accessibilityInformation)}else this.c=String(h.a++);this.e=r,this.f=c,this.g=s,this.h=this.u(i)}u(l){if((0,m.$Nf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!h.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new R.$Sc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let $;this.m?$=this.m:$=(0,I.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=h.b.get(this.o.id));const r=L.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,$,this.k,r,this.r?.internal,p,this.o,this.g===S.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$2hc=h;class E{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const $={message:l};return this.b.unshift($),this.c(),new S.$mL(()=>{const p=this.b.indexOf($);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(l,$){this.e=new Map,this.a=l.getProxy(M.$kL.MainThreadStatusBar),this.b=$,this.c=new E(this)}$acceptStaticEntries(l){for(const $ of l)this.e.set($.entryId,$)}createStatusBarEntry(l,$,p,r){return new h(this.a,this.b,this.e,l,$,p,r)}setStatusBarMessage(l,$){const p=this.c.setMessage(l);let r;return typeof $=="number"?r=setTimeout(()=>p.dispose(),$):typeof $<"u"&&$.then(()=>p.dispose(),()=>p.dispose()),new S.$mL(()=>{p.dispose(),clearTimeout(r)})}}e.$3hc=A}),define(Re[110],Ae([1,0,29,103,49,75,59,8,2]),function(me,e,S,M,I,R,L,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KN=e.$JN=e.$IN=e.$HN=void 0;const E=(o,a,u,t)=>{let f=a;return{enumerable:!0,configurable:!1,get(){return f},set(n){if(!u(f,n)){const w=f;f=n,o.listener?.(t(n,w))}}}},A=(o,a)=>o===a,D={range:(o,a)=>o===a?!0:!o||!a?!1:o.isEqual(a),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(o,a)=>!(o.length!==a.length||o.some(u=>!a.find(t=>u.id===t.id)))},l=o=>a=>({op:4,update:o(a)}),$=(o,a)=>({range:(()=>{let u;const t=l(f=>({range:S.$Ws.lift(m.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return u},set(f){o.listener?.({op:6}),D.range(u,f)||(u=f,o.listener?.(t(f)))}}})(),label:E(o,a,D.label,l(u=>({label:u}))),description:E(o,void 0,D.description,l(u=>({description:u}))),sortText:E(o,void 0,D.sortText,l(u=>({sortText:u}))),canResolveChildren:E(o,!1,D.canResolveChildren,u=>({op:2,state:u})),busy:E(o,!1,D.busy,l(u=>({busy:u}))),error:E(o,void 0,D.error,l(u=>({error:m.MarkdownString.fromStrict(u)||null}))),tags:E(o,[],D.tags,(u,t)=>({op:1,new:u.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),p=o=>{const a=I.$cK.fromString(o.extId),u=new c(a.controllerId,a.localId,o.label,h.URI.revive(o.uri)||void 0);return u.range=m.Range.to(o.range||void 0),u.description=o.description||void 0,u.sortText=o.sortText||void 0,u.tags=o.tags.map(t=>m.TestTag.to({id:(0,L.$hK)(t).tagId})),u},r=o=>{let a;for(const u of o.tests){const t=p(u.item);(0,M.$rN)(t).parent=a,a=t}return a};e.$HN=r;class c{constructor(a,u,t,f){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const n=(0,M.$qN)(this,a);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof s?void 0:n.parent}},children:{value:(0,R.$pN)(n,M.$rN,c),enumerable:!0,writable:!1},...$(n,t)})}}e.$IN=c;class s extends c{constructor(a,u){super(a,a,u,void 0),this._isRoot=!0}}e.$JN=s;class i extends R.$lN{constructor(a,u,t){super({controllerId:a,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:M.$rN,getChildren:f=>f.children,root:new s(a,u),toITestItem:m.TestItem.from})}}e.$KN=i}),define(Re[31],Ae([1,0,16,7,8,26,3,18,13,52,29,91,2,6,4,17,110,23,50,41,63,57,60,33]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r,c,s,i,o,a,u,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.$QN=void 0;let n=class{#e;#t;#i;constructor(g,v,k){this.b=new Map,this.c=new Map,this.#e=g.getProxy(L.$kL.MainThreadCommands),this.d=v,this.#i=k,this.#t=g.getProxy(L.$kL.MainThreadTelemetry),this.converter=new w(this,F=>{const O=this.c.get(F);return O?.result===d.Void?O:void 0},v),this.f=[{processArgument(F){return(0,E.$Eh)(F)}},{processArgument(F){return(0,R.$An)(F,function(O){if(A.$Ws.isIRange(O))return I.Range.to(O);if(D.$Vs.isIPosition(O))return I.Position.to(O);if(A.$Ws.isIRange(O.range)&&l.URI.isUri(O.uri))return I.location.to(O);if(O instanceof s.$ke)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const v=this.registerCommand(!1,g.id,async(...k)=>{const F=g.args.map((G,q)=>{if(!G.validate(k[q]))throw new Error(`Invalid argument '${G.name}' when running '${g.id}', received: ${typeof k[q]=="object"?JSON.stringify(k[q],null,"	"):k[q]} `);return G.convert(k[q])}),O=await this.executeCommand(g.internalId,...F);return g.result.convert(O,k,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new M.$mL(()=>{v.dispose(),this.c.delete(g.id)})}registerCommand(g,v,k,F,O,G){if(this.d.trace("ExtHostCommands#registerCommand",v),!v.trim().length)throw new Error("invalid id");if(this.b.has(v))throw new Error(`command '${v}' already exists`);return this.b.set(v,{callback:k,thisArg:F,metadata:O,extension:G}),g&&this.#e.$registerCommand(v),new M.$mL(()=>{this.b.delete(v)&&g&&this.#e.$unregisterCommand(v)})}executeCommand(g,...v){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,v,!0)}async g(g,v,k){if(this.b.has(g))return this.#e.$fireCommandActivationEvent(g),this.h(g,v,!1);{let F=!1;const O=(0,R.$An)(v,function(G){if(G instanceof M.$nL)return I.Position.from(G);if(G instanceof M.$oL)return I.Range.from(G);if(G instanceof M.$yL)return I.location.from(G);if(M.$LM.isNotebookRange(G))return I.NotebookRange.from(G);if(G instanceof ArrayBuffer)return F=!0,s.$ke.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return F=!0,s.$ke.wrap(G);if(G instanceof s.$ke)return F=!0,G;if(!Array.isArray(G))return G});try{const G=await this.#e.$executeCommand(g,F?new i.$Vv(O):O,k);return(0,E.$Eh)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(g,v,!1);throw G}}}async h(g,v,k){const F=this.b.get(g);if(!F)throw new Error("Unknown command");const{callback:O,thisArg:G,metadata:q}=F;if(q?.args)for(let C=0;C<q.args.length;C++)try{(0,S.$1f)(v[C],q.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${q.args[C].name}' - ${q.args[C].description}`)}const U=a.$Sd.create();try{return await O.apply(G,v)}catch(C){if(g===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...v);N&&(g=N.command)}if(this.d.error(C,g,F.extension?.identifier),!k)throw C;if(F.extension?.identifier){const N=this.#i.onExtensionError(F.extension.identifier,C);this.d.trace("forwarded error to extension?",N,F.extension?.identifier)}throw new class extends Error{constructor(){super((0,o.$Si)(C)),this.id=g,this.source=F.extension?.displayName??F.extension?.name}}}finally{this.j(F,g,U.elapsed())}}j(g,v,k){g.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new u.$No(v),duration:k})}$executeContributedCommand(g,...v){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const k=this.b.get(g);return k?(v=v.map(F=>this.f.reduce((O,G)=>G.processArgument(O,k.extension?.identifier),F)),this.h(g,v,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),this.#e.$getCommands().then(v=>(g&&(v=v.filter(k=>k[0]!=="_")),v))}$getContributedCommandMetadata(){const g=Object.create(null);for(const[v,k]of this.b){const{metadata:F}=k;F&&(g[v]=F)}return Promise.resolve(g)}};e.$QN=n,e.$QN=n=Ke([Ve(0,r.$vN),Ve(1,h.$pj),Ve(2,t.$PN)],n),e.$RN=(0,p.$8h)("IExtHostCommands");class w{constructor(g,v,k){this.d=g,this.f=v,this.g=k,this.delegatingCommandId=`__vsc${(0,f.$rg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,v){if(!g)return;const k={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return k;const F=this.f(g.command);if(F)k.id=F.internalId,k.arguments=F.args.map((O,G)=>O.convert(g.arguments&&g.arguments[G]));else if((0,m.$Lb)(g.arguments)){const O=`${g.command} /${++this.c}`;this.b.set(O,g),v.add((0,$.$Rc)(()=>{this.b.delete(O),this.g.trace("CommandsConverter#DISPOSE",O)})),k.$ident=O,k.id=this.delegatingCommandId,k.arguments=[O],this.g.trace("CommandsConverter#CREATE",g.command,O)}return k}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const v=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],v?v.command:"MISSING"),v?this.d.executeCommand(v.command,...v.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.$SN=w;class y{static{this.Uri=new y("uri","Uri of a text document",g=>l.URI.isUri(g),g=>g)}static{this.Position=new y("position","A position in a text document",g=>M.$nL.isPosition(g),I.Position.from)}static{this.Range=new y("range","A range in a text document",g=>M.$oL.isRange(g),I.Range.from)}static{this.Selection=new y("selection","A selection in a text document",g=>M.$pL.isSelection(g),I.Selection.from)}static{this.Number=new y("number","",g=>typeof g=="number",g=>g)}static{this.String=new y("string","",g=>typeof g=="string",g=>g)}static{this.StringArray=y.Arr(y.String)}static Arr(g){return new y(`${g.name}_array`,`Array of ${g.name}, ${g.description}`,v=>Array.isArray(v)&&v.every(k=>g.validate(k)),v=>v.map(k=>g.convert(k)))}static{this.CallHierarchyItem=new y("item","A call hierarchy item",g=>g instanceof M.$JL,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new y("item","A type hierarchy item",g=>g instanceof M.$5M,I.TypeHierarchyItem.from)}static{this.TestItem=new y("testItem","A VS Code TestItem",g=>g instanceof c.$IN,I.TestItem.from)}constructor(g,v,k,F){this.name=g,this.description=v,this.validate=k,this.convert=F}optional(){return new y(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,v){return new y(g??this.name,v??this.description,this.validate,this.convert)}}e.$TN=y;class d{static{this.Void=new d("no result",g=>g)}constructor(g,v){this.description=g,this.convert=v}}e.$UN=d;class b{constructor(g,v,k,F,O){this.id=g,this.internalId=v,this.description=k,this.args=F,this.result=O}}e.$VN=b}),define(Re[269],Ae([1,0,18,12,2,86,95,35,31,8,7]),function(me,e,S,M,I,R,L,m,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;const D=[new h.$VN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[h.$TN.Uri,h.$TN.Position],new h.$UN("A promise that resolves to an array of DocumentHighlight-instances.",$(E.DocumentHighlight.to))),new h.$VN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[h.$TN.Uri],new h.$UN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,c)=>{if((0,S.$Kb)(r))return;class s extends A.$EL{static to(o){const a=new s(o.name,E.SymbolKind.to(o.kind),o.containerName||"",new A.$yL(c[0],E.Range.to(o.range)));return a.detail=o.detail,a.range=a.location.range,a.selectionRange=E.Range.to(o.selectionRange),a.children=o.children?o.children.map(s.to):[],a}}return r.map(s.to)})),new h.$VN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[h.$TN.Uri,new h.$TN("options","Formatting options",r=>!0,r=>r)],new h.$UN("A promise that resolves to an array of TextEdits.",$(E.TextEdit.to))),new h.$VN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[h.$TN.Uri,h.$TN.Range,new h.$TN("options","Formatting options",r=>!0,r=>r)],new h.$UN("A promise that resolves to an array of TextEdits.",$(E.TextEdit.to))),new h.$VN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[h.$TN.Uri,h.$TN.Position,new h.$TN("ch","Trigger character",r=>typeof r=="string",r=>r),new h.$TN("options","Formatting options",r=>!0,r=>r)],new h.$UN("A promise that resolves to an array of TextEdits.",$(E.TextEdit.to))),new h.$VN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[h.$TN.Uri,h.$TN.Position],new h.$UN("A promise that resolves to an array of Location or LocationLink instances.",p)),new h.$VN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[h.$TN.Uri,h.$TN.Position],new h.$UN("A promise that resolves to an array of Location or LocationLink instances.",p)),new h.$VN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[h.$TN.Uri,h.$TN.Position],new h.$UN("A promise that resolves to an array of Location or LocationLink instances.",p)),new h.$VN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[h.$TN.Uri,h.$TN.Position],new h.$UN("A promise that resolves to an array of Location or LocationLink instances.",p)),new h.$VN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[h.$TN.Uri,h.$TN.Position],new h.$UN("A promise that resolves to an array of Location-instances.",$(E.location.to))),new h.$VN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[h.$TN.Uri,h.$TN.Position],new h.$UN("A promise that resolves to an array of Hover-instances.",$(E.Hover.to))),new h.$VN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[h.$TN.Uri,new h.$TN("position","A position in a text document",r=>Array.isArray(r)&&r.every(c=>A.$nL.isPosition(c)),r=>r.map(E.Position.from))],new h.$UN("A promise that resolves to an array of ranges.",r=>r.map(c=>{let s;for(const i of c.reverse())s=new A.$IL(E.Range.to(i),s);return s}))),new h.$VN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[h.$TN.String.with("query","Search string")],new h.$UN("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(E.WorkspaceSymbol.to))),new h.$VN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[h.$TN.Uri,h.$TN.Position],new h.$UN("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(E.CallHierarchyItem.to))),new h.$VN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[h.$TN.CallHierarchyItem],new h.$UN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(E.CallHierarchyIncomingCall.to))),new h.$VN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[h.$TN.CallHierarchyItem],new h.$UN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(E.CallHierarchyOutgoingCall.to))),new h.$VN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[h.$TN.Uri,h.$TN.Position],new h.$UN("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:E.Range.to(r.range),placeholder:r.text}})),new h.$VN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[h.$TN.Uri,h.$TN.Position,h.$TN.String.with("newName","The new symbol name")],new h.$UN("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return E.WorkspaceEdit.to(r)}})),new h.$VN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[h.$TN.Uri,h.$TN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new h.$UN("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(E.DocumentLink.to))),new h.$VN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[h.$TN.Uri],new h.$UN("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new A.$CM(r.tokenTypes,r.tokenModifiers)})),new h.$VN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[h.$TN.Uri],new h.$UN("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const c=(0,L.$V$)(r);if(c.type==="full")return new A.$EM(c.data,void 0)})),new h.$VN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[h.$TN.Uri,h.$TN.Range.optional()],new h.$UN("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new A.$CM(r.tokenTypes,r.tokenModifiers)})),new h.$VN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[h.$TN.Uri,h.$TN.Range],new h.$UN("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const c=(0,L.$V$)(r);if(c.type==="full")return new A.$EM(c.data,void 0)})),new h.$VN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[h.$TN.Uri,h.$TN.Position,h.$TN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),h.$TN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new h.$UN("A promise that resolves to a CompletionList-instance.",(r,c,s)=>{if(!r)return new A.$UL([]);const i=r.suggestions.map(o=>E.CompletionItem.to(o,s));return new A.$UL(i,r.incomplete)})),new h.$VN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[h.$TN.Uri,h.$TN.Position,h.$TN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new h.$UN("A promise that resolves to SignatureHelp.",r=>{if(r)return E.SignatureHelp.to(r)})),new h.$VN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[h.$TN.Uri,h.$TN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new h.$UN("A promise that resolves to an array of CodeLens-instances.",(r,c,s)=>$(i=>new A.$ML(E.Range.to(i.range),i.command&&s.fromInternal(i.command)))(r))),new h.$VN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[h.$TN.Uri,new h.$TN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>A.$oL.isRange(r),r=>A.$pL.isSelection(r)?E.Selection.from(r):E.Range.from(r)),h.$TN.String.with("kind","Code action kind to return code actions for").optional(),h.$TN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new h.$UN("A promise that resolves to an array of Command-instances.",(r,c,s)=>$(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(i.command)}else{const o=new A.$GL(i.title,i.kind?new A.$HL(i.kind):void 0);return i.edit&&(o.edit=E.WorkspaceEdit.to(i.edit)),i.command&&(o.command=s.fromInternal(i.command)),o.isPreferred=i.isPreferred,o}})(r))),new h.$VN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[h.$TN.Uri],new h.$UN("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(c=>new A.$1L(E.Range.to(c.range),E.Color.to(c.color))):[])),new h.$VN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new h.$TN("color","The color to show and insert",r=>r instanceof A.$ZL,E.Color.from),new h.$TN("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:E.Range.from(r.range)}))],new h.$UN("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(E.ColorPresentation.to):[])),new h.$VN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[h.$TN.Uri,h.$TN.Range],new h.$UN("A promise that resolves to an array of Inlay objects",(r,c,s)=>r.map(E.InlayHint.to.bind(void 0,s)))),new h.$VN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[h.$TN.Uri],new h.$UN("A promise that resolves to an array of FoldingRange objects",(r,c)=>{if(r)return r.map(E.FoldingRange.to)})),new h.$VN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new h.$UN("A promise that resolves to an array of NotebookContentProvider static info objects.",$(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(c=>E.NotebookExclusiveDocumentPattern.to(c))})))),new h.$VN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[h.$TN.Uri,h.$TN.Range,new h.$TN("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof A.$oL,r=>E.InlineValueContext.from(r))],new h.$UN("A promise that resolves to an array of InlineValue objects",r=>r.map(E.InlineValue.to))),new h.$VN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new h.$TN("uriOrString","Uri-instance or string (only http/https)",r=>I.URI.isUri(r)||typeof r=="string"&&(0,M.$gg)(r,M.Schemas.http,M.Schemas.https),r=>r),new h.$TN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[E.ViewColumn.from(r),void 0]:[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)])).optional(),h.$TN.String.with("label","").optional()],h.$UN.Void),new h.$VN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[h.$TN.Uri.with("resource","Resource to open"),h.$TN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new h.$TN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[E.ViewColumn.from(r),void 0]:[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)])).optional()],h.$UN.Void),new h.$VN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[h.$TN.Uri.with("left","Left-hand side resource of the diff editor"),h.$TN.Uri.with("right","Right-hand side resource of the diff editor"),h.$TN.String.with("title","Human readable title for the diff editor").optional(),new h.$TN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[E.ViewColumn.from(r.viewColumn),E.TextEditorOpenOptions.from(r)]).optional()],h.$UN.Void),new h.$VN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[h.$TN.String.with("title","Human readable title for the changes editor"),new h.$TN("resourceList","List of resources to compare",r=>{for(const c of r){if(c.length!==3)return!1;const[s,i,o]=c;if(!I.URI.isUri(s)||!I.URI.isUri(i)&&i!==void 0&&i!==null||!I.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},r=>r)],h.$UN.Void),new h.$VN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[h.$TN.Uri,h.$TN.Position],new h.$UN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new h.$VN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[h.$TN.TypeHierarchyItem],new h.$UN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new h.$VN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[h.$TN.TypeHierarchyItem],new h.$UN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(E.TypeHierarchyItem.to))),new h.$VN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[h.$TN.TestItem],h.$UN.Void),new h.$VN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[h.$TN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],h.$UN.Void),new h.$VN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[h.$TN.String.with("name","The context key name"),new h.$TN("value","The context key value",()=>!0,r=>r)],h.$UN.Void),new h.$VN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[h.$TN.Uri,h.$TN.StringArray,new h.$TN("MappedEditsContext","Mapped Edits Context",r=>E.MappedEditsContext.is(r),r=>E.MappedEditsContext.from(r))],new h.$UN("A promise that resolves to a workspace edit or null",r=>r?E.WorkspaceEdit.to(r):null))];class l{static register(c){D.forEach(c.registerApiCommand,c),this.a(c)}static a(c){c.registerCommand(!1,"_validateWhenClauses",m.$7i)}}e.$lgc=l;function $(r){return c=>{if(Array.isArray(c))return c.map(r)}}function p(r){if(!Array.isArray(r))return;const c=[];for(const s of r)R.$It(s)?c.push(E.DefinitionLink.to(s)):c.push(E.location.to(s));return c}}),define(Re[270],Ae([1,0,6,2,3,8,7,31,11]),function(me,e,S,M,I,R,L,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=void 0;class E{static{this.a=0}constructor($,p){this.extension=$,this.provider=p,this.handle=E.a++}}class A{constructor($){this.session=$,this.responses=[]}}class D{static{this.a=0}constructor($,p,r,c){this.f=r,this.g=c,this.b=new Map,this.d=new Map,this.e=$.getProxy(I.$kL.MainThreadInlineChat),p.registerApiCommand(new m.$VN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$TN("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?R.Range.from(s.initialRange):void 0,initialSelection:L.$pL.isSelection(s.initialSelection)?R.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?R.Position.from(s.position):void 0}})],m.$UN.Void))}registerProvider($,p,r){const c=new E($,p);return this.b.set(c.handle,c),this.e.$registerInteractiveEditorProvider(c.handle,r?.label??$.displayName??$.name,$.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function",typeof p.provideFollowups=="function",r?.supportReportIssue??!1),(0,S.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(c.handle),this.b.delete(c.handle)})}async $prepareSession($,p,r,c){const s=this.b.get($);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(M.URI.revive(p)),o=R.Selection.to(r),a=await s.provider.prepareInteractiveEditorSession({document:i,selection:o},c);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const u=D.a++;return this.d.set(u,new A(a)),{id:u,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:R.Range.from(a.wholeRange),message:a.message}}async $provideResponse($,p,r,c){const s=this.b.get($);if(!s)return;const i=this.d.get(p.id);if(!i)return;const o={prompt:r.prompt,selection:R.Selection.to(r.selection),wholeRange:R.Range.to(r.wholeRange),attempt:r.attempt,live:r.live,previewDocument:this.f.getDocument(M.URI.revive(r.previewDocument)),withIntentDetection:r.withIntentDetection};let a=!1;const u={report:async P=>{if(!r.live&&P.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||c.isCancellationRequested||await this.e.$handleProgressChunk(r.requestId,{message:P.message,edits:P.edits?.map(R.TextEdit.from),editsShouldBeInstant:P.editsShouldBeInstant,slashCommand:P.slashCommand?.command,markdownFragment:L.$NL.isMarkdownString(P.content)?P.content.value:P.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(i.session,o,u,c));let f;try{f=await(0,h.$Vg)(t,c)}finally{a=!0}if(!f)return;const n=i.responses.push(f)-1,w={wholeRange:R.Range.from(f.wholeRange),placeholder:f.placeholder};if(!D.h(f))return{...w,id:n,type:"editorEdit",message:R.MarkdownString.from(f.contents),edits:[]};const{edits:y,contents:d}=f,b=d!==void 0?R.MarkdownString.from(d):void 0;return y instanceof L.$wL?{...w,id:n,type:"bulkEdit",edits:R.WorkspaceEdit.from(y),message:b}:{...w,id:n,type:"editorEdit",edits:y.map(R.TextEdit.from),message:b}}async $provideFollowups($,p,r,c){const s=this.b.get($),i=this.d.get(p),o=i?.responses[r];if(s&&o&&s.provider.provideFollowups){const a=Promise.resolve(s.provider.provideFollowups(i.session,o,c));return(await(0,h.$Vg)(a,c))?.map(R.ChatFollowup.from)}}$handleFeedback($,p,r,c){const s=this.b.get($),i=this.d.get(p),o=i?.responses[r];if(s&&o){const a=R.InteractiveEditorResponseFeedbackKind.to(c);s.provider.handleInteractiveEditorResponseFeedback?.(i.session,o,a)}}$releaseSession($,p){}static h($){return typeof $=="object"&&typeof $.edits=="object"}}e.$thc=D}),define(Re[271],Ae([1,0,2,31]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=void 0;class I{constructor(L,m,h,E,A){this.a=m,this.b=h,this.c=E;const D=new M.$VN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$TN("showOptions","Show Options",l=>!0,l=>l),new M.$TN("resource","Interactive resource Uri",l=>!0,l=>l),new M.$TN("controllerId","Notebook controller Id",l=>!0,l=>l),new M.$TN("title","Interactive editor title",l=>!0,l=>l)],new M.$UN("Notebook and input URI",l=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const $=this.a.getEditorById(l.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",$.id),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri),notebookEditor:$.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(L,m,h,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:h,uri:L,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(S.URI.revive(E))?.apiNotebook}]})}$willRemoveInteractiveDocument(L,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$Ghc=I}),define(Re[272],Ae([1,0,18,11,21,5,6,28,2,22,13,3,31,8,7,76,209,24,50,210]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r,c,s,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=e.$Ohc=void 0;let a=class{constructor(b,P,g,v,k){this.m=P,this.n=g,this.o=v,this.q=k,this.b=new m.$Ac,this.c=new m.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$Wd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=b.getProxy(D.$kL.MainThreadNotebookKernels);const F=new l.$VN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$TN("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const G=this.n.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:G}}else if(O&&"notebookEditor"in O){const G=this.n.getIdByEditor(O.notebookEditor);if(G===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:G}}return O})],l.$UN.Void);this.o.registerApiCommand(F)}createNotebookController(b,P,g,v,k,F){for(const $e of this.j.values())if($e.controller.id===P&&E.$nm.equals(b.identifier,$e.extensionId))throw new Error(`notebook controller with id '${P}' ALREADY exist`);const O=this.k++,G=this;this.q.trace(`NotebookController[${O}], CREATED by ${b.identifier.value}, ${P}`);const q=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${b.identifier}'`);let U=!1;const C=new R.$Wd,N=new R.$Wd,W={id:y(b.identifier,P),notebookType:g,extensionId:b.identifier,extensionLocation:b.extensionLocation,label:v||b.identifier.value,preloads:F?F.map($.NotebookRendererScript.from):[]};let se=k??q,le,Ee;this.a.$addKernel(O,W).catch($e=>{console.log($e),U=!0});let De=0;const ce=()=>{if(U)return;const $e=++De;Promise.resolve().then(()=>{$e===De&&this.a.$updateKernel(O,W)})},pe=new m.$Ac,oe={get id(){return P},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:C.event,get label(){return W.label},set label($e){W.label=$e??b.displayName??b.name,ce()},get detail(){return W.detail??""},set detail($e){W.detail=$e,ce()},get description(){return W.description??""},set description($e){W.description=$e,ce()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages($e){W.supportedLanguages=$e,ce()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder($e){W.supportsExecutionOrder=$e,ce()},get rendererScripts(){return W.preloads?W.preloads.map($.NotebookRendererScript.to):[]},get executeHandler(){return se},set executeHandler($e){se=$e??q},get interruptHandler(){return le},set interruptHandler($e){le=$e,W.supportsInterrupt=!!$e,ce()},set variableProvider($e){(0,s.$LF)(b,"notebookVariableProvider"),Ee=$e,W.hasVariableProvider=!!$e,$e?.onDidChangeVariables(ie=>G.a.$variablesUpdated(ie.uri)),ce()},get variableProvider(){return Ee},createNotebookCellExecution($e){if(U)throw new Error("notebook controller is DISPOSED");if(!pe.has($e.notebook.uri))throw G.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.notebook.uri.toString()}`);return G._createNotebookCellExecution($e,y(b.identifier,this.id))},createNotebookExecution($e){if((0,s.$LF)(b,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!pe.has($e.uri))throw G.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.uri.toString()}`);return G._createNotebookExecution($e,y(b.identifier,this.id))},dispose:()=>{U||(this.q.trace(`NotebookController[${O}], DISPOSED`),U=!0,this.j.delete(O),C.dispose(),N.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity($e,ie){ie===p.NotebookControllerAffinity2.Hidden&&(0,s.$LF)(b,"notebookControllerAffinityHidden"),G.a.$updateNotebookPriority(O,$e.uri,ie)},onDidReceiveMessage:N.event,postMessage($e,ie){return(0,s.$LF)(b,"notebookMessaging"),G.a.$postMessage(O,ie&&G.n.getIdByEditor(ie),$e)},asWebviewUri($e){return(0,s.$LF)(b,"notebookMessaging"),(0,r.$xwb)($e,G.m.remote)}};return this.j.set(O,{extensionId:b.identifier,controller:oe,onDidReceiveMessage:N,onDidChangeSelection:C,associatedNotebooks:pe}),oe}getIdByController(b){for(const[P,g]of this.j)if(g.controller===b)return y(g.extensionId,b.id);return null}createNotebookControllerDetectionTask(b,P){const g=this.g++,v=this;this.q.trace(`NotebookControllerDetectionTask[${g}], CREATED by ${b.identifier.value}`),this.a.$addKernelDetectionTask(g,P);const k={dispose:()=>{this.f.delete(g),v.a.$removeKernelDetectionTask(g)}};return this.f.set(g,k),k}registerKernelSourceActionProvider(b,P,g){const v=this.i++,k=typeof g.onDidChangeNotebookKernelSourceActions=="function"?v:void 0,F=this;this.h.set(v,g),this.q.trace(`NotebookKernelSourceActionProvider[${v}], CREATED by ${b.identifier.value}`),this.a.$addKernelSourceActionProvider(v,v,P);let O;return k!==void 0&&(O=g.onDidChangeNotebookKernelSourceActions(G=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(v),F.a.$removeKernelSourceActionProvider(v,v),O?.dispose()}}}async $provideKernelSourceActions(b,P){const g=this.h.get(b);if(g){const v=new L.$Sc;return(await g.provideNotebookKernelSourceActions(P)??[]).map(F=>$.NotebookKernelSourceAction.from(F,this.o.converter,v))}return[]}$acceptNotebookAssociation(b,P,g){const v=this.j.get(b);if(v){const k=this.n.getNotebookDocument(h.URI.revive(P));g?v.associatedNotebooks.set(k.uri,!0):v.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${b}] ASSOCIATE notebook`,k.uri.toString(),g),v.onDidChangeSelection.fire({selected:g,notebook:k.apiNotebook})}}async $executeCells(b,P,g){const v=this.j.get(b);if(!v)return;const k=this.n.getNotebookDocument(h.URI.revive(P)),F=[];for(const O of g){const G=k.getCell(O);G&&F.push(G.apiCell)}try{this.q.trace(`NotebookController[${b}] EXECUTE cells`,k.uri.toString(),F.length),await v.controller.executeHandler.call(v.controller,F,k.apiNotebook,v.controller)}catch(O){this.q.error(`NotebookController[${b}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(b,P,g){const v=this.j.get(b);if(!v)return;const k=this.n.getNotebookDocument(h.URI.revive(P));if(v.controller.interruptHandler)await v.controller.interruptHandler.call(v.controller,k.apiNotebook);else for(const F of g){const O=k.getCell(F);O&&this.b.get(O.uri)?.cancel()}if(v.controller.interruptHandler){const F=this.c.get(k.uri);g.length&&Array.isArray(F)&&F.length&&F.forEach(O=>O.dispose())}}async $provideVariables(b,P,g,v,k,F,O){const G=this.j.get(b);if(!G)return;const q=this.n.getNotebookDocument(h.URI.revive(g)),U=G.controller.variableProvider;if(!U)return;let C;if(v!==void 0){if(C=this.s[v],!C)return}else this.s={};const N=k==="named"?p.NotebookVariablesRequestKind.Named:p.NotebookVariablesRequestKind.Indexed,W=U.provideVariables(q.apiNotebook,C,N,F,O);let se=0;for await(const le of W){if(O.isCancellationRequested)return;const Ee={id:this.r++,name:le.variable.name,value:le.variable.value,type:le.variable.type,hasNamedChildren:le.hasNamedChildren,indexedChildrenCount:le.indexedChildrenCount};if(this.s[Ee.id]=le.variable,this.a.$receiveVariable(P,Ee),se++>=o.$Jfb)return}}$acceptKernelMessageFromRenderer(b,P,g){const v=this.j.get(b);if(!v)return;const k=this.n.getEditorById(P);v.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:g}))}$cellExecutionChanged(b,P,g){const k=this.n.getNotebookDocument(h.URI.revive(b)).getCell(P);if(k){const F=g?$.NotebookCellExecutionState.to(g):p.NotebookCellExecutionState.Idle;F!==void 0&&this.l.fire({cell:k.apiCell,state:F})}}_createNotebookCellExecution(b,P){if(b.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this.n.getNotebookDocument(b.notebook.uri).getCellFromApiCell(b);if(!v)throw new Error("invalid cell");if(this.b.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const k=new t(P,v,this.a);this.b.set(v.uri,k);const F=k.onDidChangeState(()=>{k.state===u.Resolved&&(k.dispose(),F.dispose(),this.b.delete(v.uri))});return k.asApiObject()}_createNotebookExecution(b,P){const g=this.n.getNotebookDocument(b.uri),v=b.getCells().find(O=>{const G=g.getCellFromApiCell(O);return G&&this.b.has(G.uri)});if(v)throw new Error(`duplicate cell execution for ${v.document.uri}`);if(this.c.has(g.uri))throw new Error(`duplicate notebook execution for ${g.uri}`);const k=new n(P,g,this.a),F=k.onDidChangeState(()=>{k.state===f.Resolved&&(k.dispose(),F.dispose(),this.c.delete(g.uri))});return this.c.set(g.uri,[k,F]),k.asApiObject()}};e.$Ohc=a,e.$Ohc=a=Ke([Ve(4,A.$pj)],a);var u;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(u||(u={}));class t extends L.$Tc{static{this.a=0}get state(){return this.f}constructor(b,P,g){super(),this.m=P,this.n=g,this.b=t.a++,this.c=new R.$Wd,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new I.$7d),this.h=new w(10,v=>this.s(v)),this.j=P.internalMetadata.executionOrder,this.n.$createExecution(this.b,b,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(b){await this.h.addItem(b)}async s(b){const P=Array.isArray(b)?b:[b];return this.n.$updateExecution(this.b,new i.$Vv(P))}t(){if(this.f===u.Init)throw new Error("Must call start before modifying cell output");if(this.f===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(b){let P=this.m;if(b&&(P=this.m.notebook.getCellFromApiCell(b)),!P)throw new Error("INVALID cell");return P.handle}y(b){return b.map(P=>{const g=p.$PM.ensureUniqueMimeTypes(P.items,!0);return g===P.items?$.NotebookCellOutput.from(P):$.NotebookCellOutput.from({items:g,id:P.id,metadata:P.metadata})})}async z(b,P,g){const v=this.w(P),k=this.y((0,S.$3b)(b));return this.r({editType:c.CellExecutionUpdateType.Output,cellHandle:v,append:g,outputs:k})}async C(b,P,g){return b=p.$PM.ensureUniqueMimeTypes((0,S.$3b)(b),!0),this.r({editType:c.CellExecutionUpdateType.OutputItems,items:b.map($.NotebookCellOutputItem.from),outputId:P.id,append:g})}asApiObject(){const b=this;return Object.freeze({get token(){return b.g.token},get cell(){return b.m.apiCell},get executionOrder(){return b.j},set executionOrder(g){b.j=g,b.s([{editType:c.CellExecutionUpdateType.ExecutionState,executionOrder:b.j}])},start(g){if(b.f===u.Resolved||b.f===u.Started)throw new Error("Cannot call start again");b.f=u.Started,b.c.fire(),b.s({editType:c.CellExecutionUpdateType.ExecutionState,runStartTime:g})},end(g,v){if(b.f===u.Resolved)throw new Error("Cannot call resolve twice");b.f=u.Resolved,b.c.fire(),b.h.flush(),b.n.$completeExecution(b.b,new i.$Vv({runEndTime:v,lastRunSuccess:g}))},clearOutput(g){return b.t(),b.z([],g,!1)},appendOutput(g,v){return b.t(),b.z(g,v,!0)},replaceOutput(g,v){return b.t(),b.z(g,v,!1)},appendOutputItems(g,v){return b.t(),b.C(g,v,!0)},replaceOutputItems(g,v){return b.t(),b.C(g,v,!1)}})}}var f;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(f||(f={}));class n extends L.$Tc{static{this.a=0}get state(){return this.f}constructor(b,P,g){super(),this.h=P,this.j=g,this.b=n.a++,this.c=new R.$Wd,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new I.$7d),this.j.$createNotebookExecution(this.b,b,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===f.Resolved||this.f===f.Started)throw new Error("Cannot call start again");this.f=f.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===f.Resolved)throw new Error("Cannot call resolve twice");this.f=f.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class w{constructor(b,P){this.f=b,this.g=P,this.a=[],this.b=Date.now()}addItem(b){return this.a.push(b),this.c||(this.c=new M.$sh,this.b=Date.now(),(0,M.$9g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const b=this.c;this.c=void 0;const P=this.a;return this.a=[],this.g(P).finally(()=>b.complete())}}function y(d,b){return`${d.value}/${b}`}e.$Phc=y}),define(Re[65],Ae([1,0,5,3,4,2,17,6,7,165,15,193,21,33,194,40,11,8,31]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r,c,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=e.$3gc=e.$2gc=e.$1gc=void 0,e.$1gc=(0,I.$8h)("IExtHostTerminalService");class o{constructor(g,v,k,F){this.l=g,this._id=v,this.m=k,this.n=F,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(G=>this.f=G);const O=this;this.value={get name(){return O.n||""},get processId(){return O.b},get creationOptions(){return O.m},get exitStatus(){return O.h},get state(){return O.j},get selection(){return O.k},sendText(G,q=!0){O.q(),O.l.$sendText(O._id,G,q)},show(G){O.q(),O.l.$show(O._id,G)},hide(){O.q(),O.l.$hide(O._id)},dispose(){O.a||(O.a=!0,O.l.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(g,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??v?.cwd??void 0,env:g.env??void 0,icon:y(g.iconPath)??void 0,color:r.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,isFeatureTerminal:v?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:v?.useShellEnvironment??void 0,location:v?.location||this.o(g.location,v?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,v,k,F,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:F,color:r.ThemeColor.isThemeColor(O)?O.id:void 0,location:v?.location||this.o(g,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(g,v){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&v?{parentTerminal:v}:"viewColumn"in g?{viewColumn:s.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(g){this.n=g}setExitStatus(g,v){this.h=Object.freeze({code:g,reason:v})}setDimensions(g,v){return g===this.d&&v===this.g||g===0||v===0?!1:(this.d=g,this.g=v,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(g){this.k=g}_setProcessId(g){this.f?(this.f(g),this.f=void 0):this.b.then(v=>{v!==g&&(this.b=Promise.resolve(g))})}}e.$2gc=o;class a{get onProcessReady(){return this.b.event}constructor(g){this.g=g,this.id=0,this.shouldPersist=!1,this.a=new S.$Wd,this.onProcessData=this.a.event,this.b=new S.$Wd,this.d=new S.$Wd,this.onDidChangeProperty=this.d.event,this.f=new S.$Wd,this.onProcessExit=this.f.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,v){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${v}`)}async start(){}shutdown(){this.g.close()}input(g){this.g.handleInput?.(g)}resize(g,v){this.g.setDimensions?.({columns:g,rows:v})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this.g.onDidWrite(v=>this.a.fire(v)),this.g.onDidClose?.((v=void 0)=>{this.f.fire(v===void 0?void 0:v)}),this.g.onDidOverrideDimensions?.(v=>{v&&this.d.fire({type:"overrideDimensions",value:{cols:v.columns,rows:v.rows}})}),this.g.onDidChangeName?.(v=>{this.d.fire({type:"title",value:v})}),this.g.open(g||void 0),g&&this.g.setDimensions?.(g),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,t=class extends m.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(g=>g.value)}constructor(g,v,k){super(),this.Q=v,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new S.$Wd,this.onDidCloseTerminal=this.H.event,this.I=new S.$Wd,this.onDidOpenTerminal=this.I.event,this.J=new S.$Wd,this.onDidChangeActiveTerminal=this.J.event,this.L=new S.$Wd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new S.$Wd,this.onDidChangeTerminalState=this.M.event,this.N=new S.$Wd,this.onDidChangeShell=this.N.event,this.O=new S.$Wd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new S.$Wd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(M.$kL.MainThreadTerminalService),this.y=new p.$Hsb(this.a.$sendProcessData),this.a.$registerProcessSupport(g),this.Q.registerArgumentProcessor({processArgument:F=>{const O=G=>{const q=G;return this.W(q.instanceId)?.value};switch(F?.$mid){case 15:return O(F);default:{if(Array.isArray(F))for(let G=0;G<F.length&&F[G].$mid===15;G++)F[G]=O(F[G]);return F}}}}),this.B({dispose:()=>{for(const[F,O]of this.g)O.shutdown(!0)}})}getDefaultShell(g){return(g?this.u:this.s)?.path||""}getDefaultShellArgs(g){return(g?this.u:this.s)?.args||[]}createExtensionTerminal(g,v){const k=new o(this.a,(0,$.$rg)(),g,g.name),F=new a(g.pty);return k.createExtensionTerminal(g.location,v,this.R(g,v).resolvedExtHostIdentifier,y(g.iconPath),d(g.color)).then(O=>{const G=this.S(O,F);this.h[O]=G}),this.f.push(k),k.value}R(g,v){if(v=v||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const k=g.location.parentTerminal;if(k){const F=this.f.find(O=>O.value===k);F&&(v.resolvedExtHostIdentifier=F._id)}}else g.location&&typeof g.location!="object"?v.location=g.location:v.location&&typeof v.location=="object"&&"splitActiveTerminal"in v.location&&(v.location={splitActiveTerminal:!0});return v}attachPtyToTerminal(g,v){if(!this.W(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const F=new a(v),O=this.S(g,F);this.h[g]=O}async $acceptActiveTerminalChanged(g){const v=this.b;if(g===null){this.b=void 0,v!==this.b&&this.J.fire(this.b);return}const k=this.W(g);k&&(this.b=k,v!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(g,v){const k=this.W(g);k&&this.O.fire({terminal:k.value,data:v})}async $acceptTerminalDimensions(g,v,k){const F=this.W(g);F&&F.setDimensions(v,k)&&this.L.fire({terminal:F.value,dimensions:F.value.dimensions})}async $acceptDidExecuteCommand(g,v){const k=this.W(g);k&&this.P.fire({terminal:k.value,...v})}async $acceptTerminalMaximumDimensions(g,v,k){this.g.get(g)?.resize(v,k)}async $acceptTerminalTitleChange(g,v){const k=this.W(g);k&&(k.name=v)}async $acceptTerminalClosed(g,v,k){const F=this.Y(this.f,g);if(F!==null){const O=this.f.splice(F,1)[0];O.setExitStatus(v,k),this.H.fire(O.value)}}$acceptTerminalOpened(g,v,k,F){if(v){const q=this.Y(this.f,v);if(q!==null){this.f[q]._id=g,this.I.fire(this.terminals[q]),this.f[q].isOpen=!0;return}}const O={name:F.name,shellPath:F.executable,shellArgs:F.args,cwd:typeof F.cwd=="string"?F.cwd:R.URI.revive(F.cwd),env:F.env,hideFromUser:F.hideFromUser},G=new o(this.a,g,O,k);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(g,v){this.W(g)?._setProcessId(v)}async $startExtensionTerminal(g,v){const k=this.W(g);if(!k)return{message:(0,E.localize)(0,null,g)};k.isOpen||await new Promise(O=>{const G=this.onDidOpenTerminal(async q=>{q===k.value&&(G.dispose(),O())})});const F=this.g.get(g);F?F.startSendingEvents(v):this.j[g]={initialDimensions:v}}S(g,v){const k=new m.$Sc;k.add(v.onProcessReady(O=>this.a.$sendProcessReady(g,O.pid,O.cwd,O.windowsPty))),k.add(v.onDidChangeProperty(O=>this.a.$sendProcessProperty(g,O))),this.y.startBuffering(g,v.onProcessData),k.add(v.onProcessExit(O=>this.U(g,O))),this.g.set(g,v);const F=this.j[g];return F&&v instanceof a&&(v.startSendingEvents(F.initialDimensions),delete this.j[g]),k}$acceptProcessAckDataEvent(g,v){this.g.get(g)?.acknowledgeDataEvent(v)}$acceptProcessInput(g,v){this.g.get(g)?.input(v)}$acceptTerminalInteraction(g){const v=this.W(g);v?.setInteractedWith()&&this.M.fire(v.value)}$acceptTerminalSelection(g,v){this.W(g)?.setSelection(v)}$acceptProcessResize(g,v,k){try{this.g.get(g)?.resize(v,k)}catch(F){if(F.code!=="EPIPE"&&F.code!=="ERR_IPC_CHANNEL_CLOSED")throw F}}$acceptProcessShutdown(g,v){this.g.get(g)?.shutdown(v)}$acceptProcessRequestInitialCwd(g){this.g.get(g)?.getInitialCwd().then(v=>this.a.$sendProcessProperty(g,{type:"initialCwd",value:v}))}$acceptProcessRequestCwd(g){this.g.get(g)?.getCwd().then(v=>this.a.$sendProcessProperty(g,{type:"cwd",value:v}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this.z.add(g),this.z.size===1&&this.a.$startLinkProvider(),new h.$mL(()=>{this.z.delete(g),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(g,v,k){if(this.C.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this.C.set(v,k),this.a.$registerProfileProvider(v,g.identifier.value),new h.$mL(()=>{this.C.delete(v),this.a.$unregisterProfileProvider(v)})}registerTerminalQuickFixProvider(g,v,k){if(this.D.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this.D.set(g,k),this.a.$registerQuickFixProvider(g,v),new h.$mL(()=>{this.D.delete(g),this.a.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,v){const k=new l.$7d().token;if(k.isCancellationRequested)return;const F=this.D.get(g);if(!F)return;const O=await F.provideTerminalQuickFixes(v,k);if(O===null||Array.isArray(O)&&O.length===0)return;const G=new m.$Sc;if(this.w.value=G,!Array.isArray(O))return O?s.TerminalQuickFix.from(O,this.Q.converter,G):void 0;const q=[];for(const U of O){const C=s.TerminalQuickFix.from(U,this.Q.converter,G);C&&q.push(C)}return q}async $createContributedProfileTerminal(g,v){const k=new l.$7d().token;let F=await this.C.get(g)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(F&&!("options"in F)&&(F={options:F}),!F||!("options"in F))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in F.options){this.createExtensionTerminal(F.options,v);return}this.createTerminalFromOptions(F.options,v)}}async $provideLinks(g,v){const k=this.W(g);if(!k)return[];this.F.delete(g),this.G.get(g)?.dispose(!0);const O=new l.$7d;this.G.set(g,O);const G=[],q={terminal:k.value,line:v},U=[];for(const W of this.z)U.push(c.Promises.withAsyncBody(async se=>{O.token.onCancellationRequested(()=>se({provider:W,links:[]}));const le=await W.provideTerminalLinks(q,O.token)||[];O.token.isCancellationRequested||se({provider:W,links:le})}));const C=await Promise.all(U);if(O.token.isCancellationRequested)return[];const N=new Map;for(const W of C)W&&W.links.length>0&&G.push(...W.links.map(se=>{const le={id:u++,startIndex:se.startIndex,length:se.length,label:se.tooltip};return N.set(le.id,{provider:W.provider,link:se}),le}));return this.F.set(g,N),G}$activateLink(g,v){const k=this.F.get(g)?.get(v);k&&k.provider.handleTerminalLink(k.link)}U(g,v){this.y.stopBuffering(g),this.g.delete(g),delete this.j[g];const k=this.h[g];k&&(k.dispose(),delete this.h[g]),this.a.$sendProcessExit(g,v)}W(g){return this.X(this.f,g)}X(g,v){const k=this.Y(g,v);return k!==null?g[k]:null}Y(g,v){const k=g.findIndex(F=>F._id===v);return k===-1?null:k}getEnvironmentVariableCollection(g){let v=this.n.get(g.identifier.value);return v||(v=new f,this.$(g.identifier.value,v)),v.getScopedEnvironmentVariableCollection(void 0)}Z(g,v){const k=(0,D.$Or)(v.map),F=(0,D.$Pr)(v.descriptionMap);this.a.$setEnvironmentVariableCollection(g,v.persistent,k.length===0?void 0:k,F)}$initEnvironmentVariableCollections(g){g.forEach(v=>{const k=v[0],F=new f(v[1]);this.$(k,F)})}$acceptDefaultProfile(g,v){const k=this.s;this.s=g,this.u=v,k?.path!==g.path&&this.N.fire(g.path)}$(g,v){this.n.set(g,v),v.onDidChangeCollection(()=>{this.Z(g,v)})}};e.$3gc=t,e.$3gc=t=Ke([Ve(1,i.$RN),Ve(2,L.$vN)],t);class f{get persistent(){return this.b}set persistent(g){this.b=g,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(g){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new S.$Wd,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const v=this.h(g);let k=this.a.get(v);return k||(k=new n(this,g),this.a.set(v,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(g,v,k,F){this.f(g,{value:v,type:h.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:F})}append(g,v,k,F){this.f(g,{value:v,type:h.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:F})}prepend(g,v,k,F){this.f(g,{value:v,type:h.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:F})}f(g,v){if(v.options&&v.options.applyAtProcessCreation===!1&&!v.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(g,v.scope),F=this.map.get(k),O=v.options?{applyAtProcessCreation:v.options.applyAtProcessCreation??!1,applyAtShellIntegration:v.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!F||F.value!==v.value||F.type!==v.type||F.options?.applyAtProcessCreation!==O.applyAtProcessCreation||F.options?.applyAtShellIntegration!==O.applyAtShellIntegration||F.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index){const G=this.g(g,v.scope),q={variable:g,...v,options:O};this.map.set(G,q),this.d.fire()}}get(g,v){const k=this.g(g,v),F=this.map.get(k);return F?b(F):void 0}g(g,v){const k=this.h(v);return k.length?`${g}:::${k}`:g}h(g){return this.j(g?.workspaceFolder)??""}j(g){return g?g.uri.toString():void 0}getVariableMap(g){const v=new Map;for(const[k,F]of this.map)this.h(F.scope)===this.h(g)&&v.set(F.variable,b(F));return v}delete(g,v){const k=this.g(g,v);this.map.delete(k),this.d.fire()}clear(g){if(g?.workspaceFolder){for(const[v,k]of this.map)k.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(v);this.k(g)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(g,v){const k=this.h(v),F=this.descriptionMap.get(k);if(!F||F.description!==g){let O;typeof g=="string"?O=g:O=g?.value.split(`

`)[0];const G={description:O,scope:v};this.descriptionMap.set(k,G),this.d.fire()}}getDescription(g){const v=this.h(g);return this.descriptionMap.get(v)?.description}k(g){const v=this.h(g);this.descriptionMap.delete(v)}}class n{get persistent(){return this.b.persistent}set persistent(g){this.b.persistent=g}get onDidChangeCollection(){return this.a&&this.a.event}constructor(g,v){this.b=g,this.d=v,this.a=new S.$Wd}getScoped(g){return this.b.getScopedEnvironmentVariableCollection(g)}replace(g,v,k){this.b.replace(g,v,k,this.d)}append(g,v,k){this.b.append(g,v,k,this.d)}prepend(g,v,k){this.b.prepend(g,v,k,this.d)}get(g){return this.b.get(g,this.d)}forEach(g,v){this.b.getVariableMap(this.d).forEach((k,F)=>g.call(v,F,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(g){this.b.delete(g,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(g){this.b.setDescription(g,this.d)}get description(){return this.b.getDescription(this.d)}}let w=class extends t{constructor(g,v){super(!1,g,v)}createTerminal(g,v,k){throw new A.$_}createTerminalFromOptions(g,v){throw new A.$_}};e.$4gc=w,e.$4gc=w=Ke([Ve(0,i.$RN),Ve(1,L.$vN)],w);function y(P){if(!(!P||typeof P=="string"))return"id"in P?{id:P.id,color:P.color}:P}function d(P){return r.ThemeColor.isThemeColor(P)?P:void 0}function b(P){const g={...P};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Re[273],Ae([1,0,11,23,21,5,244,97,6,26,16,33,13,3,17,110,8,7,49,75,59,24]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r,c,s,i,o,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=e.$9hc=e.$8hc=e.$7hc=void 0;let t=class extends h.$Tc{constructor(U,C,N,W){super(),this.w=W,this.f=this.B(new R.$Wd),this.g=new Map,this.s=this.B(new R.$Wd),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy($.$kL.MainThreadTesting),this.m=new k(this.h),this.j=new y(this.h,C),N.registerArgumentProcessor({processArgument:se=>{switch(se?.$mid){case 16:{const le=se,Ee=le.tests[le.tests.length-1].item.extId;return this.g.get(i.$cK.root(Ee))?.collection.tree.get(Ee)?.actual??(0,r.$HN)(se)}case 18:{const{extId:le,message:Ee}=se;return{test:this.g.get(i.$cK.root(le))?.collection.tree.get(le)?.actual,message:c.TestMessage.to(Ee)}}default:return se}}}),N.registerCommand(!1,"testing.getExplorerSelection",async()=>{const se=await N.executeCommand("_testing.getExplorerSelection"),le=Ee=>{const De=this.g.get(i.$cK.root(Ee));if(De)return i.$cK.isRoot(Ee)?De.controller:De.collection.tree.get(Ee)?.actual};return{include:se?.include.map(le).filter(A.$Rf)||[],exclude:se?.exclude.map(le).filter(A.$Rf)||[]}})}createTestController(U,C,N,W){if(this.g.has(C))throw new Error(`Attempt to insert a duplicate controller with ID "${C}"`);const se=new h.$Sc,le=se.add(new r.$KN(C,N,this.w));le.root.label=N;const Ee=new Map,De=new Set,ce=this.h,pe={items:le.root.children,get label(){return N},set label($e){N=$e,le.root.label=$e,ce.$updateController(C,{label:N})},get refreshHandler(){return W},set refreshHandler($e){W=$e,ce.$updateController(C,{canRefresh:!!$e})},get id(){return C},createRunProfile:($e,ie,x,V,ne,Ie)=>{let Me=(0,m.$Vi)($e);for(;Ee.has(Me);)Me++;return new O(this.h,Ee,De,this.s.event,C,Me,$e,ie,x,V,ne,Ie)},createTestItem($e,ie,x){return new r.$IN(C,$e,ie,x)},createTestRun:($e,ie,x=!0)=>this.j.createTestRun(U,C,le,$e,ie,x),invalidateTestResults:$e=>{if($e===void 0)this.h.$markTestRetired(void 0);else{const ie=$e instanceof Array?$e:[$e];this.h.$markTestRetired(ie.map(x=>i.$cK.fromExtHostTestItem(x,C).toString()))}},set resolveHandler($e){le.resolveHandler=$e},get resolveHandler(){return le.resolveHandler},dispose:()=>{se.dispose()}};ce.$registerTestController(C,N,!!W),se.add((0,h.$Rc)(()=>ce.$unregisterTestController(C)));const oe={controller:pe,collection:le,profiles:Ee,extension:U,activeProfiles:De};return this.g.set(C,oe),se.add((0,h.$Rc)(()=>this.g.delete(C))),se.add(le.onDidGenerateDiff($e=>ce.$publishDiff(C,$e.map(a.TestsDiffOp.serialize)))),pe}createTestObserver(){return this.m.checkout()}async runTests(U,C=I.CancellationToken.None){const N=d(U);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const W=this.g.get(N.controllerId);if(!W)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(se=>i.$cK.fromExtHostTestItem(se,W.collection.root.id).toString())??[W.collection.root.id],profileGroup:G[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:U.exclude?.map(se=>se.id)},C)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $provideFileCoverage(U,C,N){return await this.j.getCoverageReport(U,C)?.provideFileCoverage(N)??[]}async $resolveFileCoverage(U,C,N,W){return await this.j.getCoverageReport(U,C)?.resolveFileCoverage(N,W)??[]}$configureRunProfile(U,C){this.g.get(U)?.profiles.get(C)?.configureHandler?.()}$setDefaultRunProfiles(U){const C=new Map;for(const[N,W]of Object.entries(U)){const se=this.g.get(N);if(!se)continue;const le=new Map,Ee=W.filter(ce=>!se.activeProfiles.has(ce)),De=[...se.activeProfiles].filter(ce=>!W.includes(ce));for(const ce of Ee)le.set(ce,!0),se.activeProfiles.add(ce);for(const ce of De)le.set(ce,!1),se.activeProfiles.delete(ce);le.size&&C.set(N,le)}this.s.fire(C)}async $refreshTests(U,C){await this.g.get(U)?.controller.refreshHandler?.(C)}$publishTestResults(U){this.results=Object.freeze(U.map(C=>(0,E.$zn)(c.TestResults.to(C))).concat(this.results).sort((C,N)=>N.completedAt-C.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,C){const N=this.g.get(i.$cK.fromString(U).controllerId)?.collection;N&&(await N.expand(U,C<0?1/0:C),N.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(C=>a.TestsDiffOp.deserialize({asCanonicalUri:N=>N},C)))}async $runControllerTests(U,C){return Promise.all(U.map(N=>this.y(N,!1,C)))}async $startContinuousRun(U,C){const N=new I.$7d(C),W=await Promise.all(U.map(se=>this.y(se,!0,N.token)));return!C.isCancellationRequested&&!W.some(se=>se.error)&&await new Promise(se=>C.onCancellationRequested(se)),N.dispose(!0),W}async y(U,C,N){const W=this.g.get(U.controllerId);if(!W)return{};const{collection:se,profiles:le,extension:Ee}=W,De=le.get(U.profileId);if(!De)return{};const ce=U.testIds.map(ie=>se.tree.get(ie)).filter(A.$Rf),pe=U.excludeExtIds.map(ie=>W.collection.tree.get(ie)).filter(A.$Rf).filter(ie=>ce.some(x=>x.fullId.compare(ie.fullId)===2));if(!ce.length)return{};const oe=new s.$WM(ce.some(ie=>ie.actual instanceof r.$JN)?void 0:ce.map(ie=>ie.actual),pe.map(ie=>ie.actual),De,C),$e=(0,a.$eK)(U)&&this.j.prepareForMainThreadTestRun(oe,b.fromInternal(U,W.collection),Ee,N);try{return await De.runHandler(oe,N),{}}catch(ie){return{error:String(ie)}}finally{$e&&($e.hasRunningTasks&&!N.isCancellationRequested&&await R.Event.toPromise($e.onEnd),$e.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$7hc=t,e.$7hc=t=Ke([Ve(0,p.$vN),Ve(1,l.$pj)],t);const f=1e4;var n;(function(q){q[q.Running=0]="Running",q[q.Cancelling=1]="Cancelling",q[q.Ended=2]="Ended"})(n||(n={}));class w extends h.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(U,C,N,W,se){super(),this.s=U,this.w=C,this.y=N,this.z=W,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new R.$Wd),this.m=this.B(new R.$Wd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new I.$7d(se));const le=this.B(new S.$hh(()=>this.C(),f));this.B(this.h.token.onCancellationRequested(()=>le.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(U){const C=this.s.id,N=this.s.controllerId,W=(0,D.$rg)(),se=this.y,le=this.m;let Ee;const De=$e=>(ie,...x)=>{if(pe){this.z.warn(`Setting the state of test "${ie.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ie)&&(this.F(ie),$e(ie,...x))},ce=($e,ie)=>{const x=ie instanceof Array?ie.map(c.TestMessage.from):[c.TestMessage.from(ie)];if($e.uri&&$e.range){const V={range:c.Range.from($e.range),uri:$e.uri};for(const ne of x)ne.location=ne.location||V}this.w.$appendTestMessagesInRun(C,W,i.$cK.fromExtHostTestItem($e,N).toString(),x)};let pe=!1;const oe={isPersisted:this.s.isPersisted,token:this.h.token,name:U,get coverageProvider(){return Ee?.provider},set coverageProvider($e){(0,u.$LF)(se,"testCoverage"),Ee=$e&&new P($e),le.fire({taskId:W,runId:C,coverage:Ee})},enqueued:De($e=>{this.w.$updateTestStateInRun(C,W,i.$cK.fromExtHostTestItem($e,N).toString(),1)}),skipped:De($e=>{this.w.$updateTestStateInRun(C,W,i.$cK.fromExtHostTestItem($e,N).toString(),5)}),started:De($e=>{this.w.$updateTestStateInRun(C,W,i.$cK.fromExtHostTestItem($e,N).toString(),2)}),errored:De(($e,ie,x)=>{ce($e,ie),this.w.$updateTestStateInRun(C,W,i.$cK.fromExtHostTestItem($e,N).toString(),6,x)}),failed:De(($e,ie,x)=>{ce($e,ie),this.w.$updateTestStateInRun(C,W,i.$cK.fromExtHostTestItem($e,N).toString(),4,x)}),passed:De(($e,ie)=>{this.w.$updateTestStateInRun(C,W,i.$cK.fromExtHostTestItem($e,this.s.controllerId).toString(),3,ie)}),appendOutput:($e,ie,x)=>{pe||(x&&(this.s.isIncluded(x)?this.F(x):x=void 0),this.w.$appendOutputToRun(C,W,M.$ke.fromString($e),ie&&c.location.from(ie),x&&i.$cK.fromExtHostTestItem(x,N).toString()))},end:()=>{pe||(pe=!0,this.w.$finishedTestRunTask(C,W),this.f.delete(W),this.f.size||this.D())}};return this.f.set(W,{run:oe}),this.w.$startedTestRunTask(C,{id:W,name:U,running:!0}),oe}C(){for(const{run:U}of this.f.values())U.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(U){if(!(U instanceof r.$IN))throw new o.$nN(U.id);if(this.g.has(i.$cK.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const C=[],N=this.s.colllection.root;for(;;){const W=c.TestItem.from(U);if(C.unshift(W),this.g.has(W.extId)||(this.g.add(W.extId),U===N))break;U=U.parent||N}this.w.$addTestsToRun(this.s.controllerId,this.s.id,C)}dispose(){this.D(),super.dispose()}}class y{get trackers(){return this.c.values()}constructor(U,C){this.g=U,this.h=C,this.c=new Map,this.f=[]}getCoverageReport(U,C){return this.f.find(N=>N.runId===U)?.coverage.get(C)}prepareForMainThreadTestRun(U,C,N,W){return this.j(U,C,N,W)}cancelRunById(U){for(const C of this.c.values())if(C.id===U){C.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,C,N,W,se,le){const Ee=this.c.get(W);if(Ee)return Ee.createRun(se);const De=b.fromPublic(C,N,W,le),ce=d(W);this.g.$startedExtensionTestRun({controllerId:C,continuous:!!W.continuous,profile:ce&&{group:G[ce.kind],id:ce.profileId},exclude:W.exclude?.map(oe=>i.$cK.fromExtHostTestItem(oe,N.root.id).toString())??[],id:De.id,include:W.include?.map(oe=>i.$cK.fromExtHostTestItem(oe,N.root.id).toString())??[N.root.id],persist:le});const pe=this.j(W,De,U);return R.Event.once(pe.onEnd)(()=>{this.g.$finishedExtensionTestRun(De.id),pe.dispose()}),pe.createRun(se)}j(U,C,N,W){const se=new w(C,this.g,N,this.h,W);this.c.set(U,se);let le;const Ee=se.onDidCoverage(({runId:De,taskId:ce,coverage:pe})=>{le||(le={runId:De,coverage:new Map},this.f.unshift(le),this.f.length>a.$jK&&this.f.pop()),le.coverage.set(ce,pe),this.g.$signalCoverageAvailable(De,ce,!!pe)});return R.Event.once(se.onEnd)(()=>{this.c.delete(U),Ee.dispose()}),se}}e.$8hc=y;const d=q=>{if(q.profile){if(!(q.profile instanceof O))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return q.profile}};class b{static fromPublic(U,C,N,W){return new b(U,(0,D.$rg)(),N.include?.map(se=>i.$cK.fromExtHostTestItem(se,U).toString())??[U],N.exclude?.map(se=>i.$cK.fromExtHostTestItem(se,U).toString())??[],W,C)}static fromInternal(U,C){return new b(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,C)}constructor(U,C,N,W,se,le){this.controllerId=U,this.id=C,this.isPersisted=se,this.colllection=le,this.c=N.map(Ee=>Ee+"\0"),this.f=W.map(Ee=>Ee+"\0")}isIncluded(U){const C=i.$cK.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const N of this.f)if(C===N||C.startsWith(N))return!1;for(const N of this.c)if(C===N||C.startsWith(N))return!0;return!1}}e.$9hc=b;class P{constructor(U){this.provider=U}async provideFileCoverage(U){this.c||(this.c=(async()=>this.provider.provideFileCoverage(U))());try{return(await this.c)?.map(c.TestCoverage.fromFile)??[]}catch(C){throw this.c=void 0,C}}async resolveFileCoverage(U,C){const N=await this.c;let W=N?.[U];return!this.provider||!N||!W?[]:(W.detailedCoverage||(W=N[U]=await this.provider.resolveFileCoverage?.(W,C)??W),W.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class g{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,c.TestItem.toPlain(U.item)),this.c.has(U)||this.f.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.f.delete(U);const C=i.$cK.parentId(U.item.extId);if(C&&this.h.has(C.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{c:U,f:C,g:N}=this;return{get added(){return[...U].map(W=>W.revived)},get updated(){return[...C].map(W=>W.revived)},get removed(){return[...N].map(W=>W.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class v extends a.$kK{constructor(){super(...arguments),this.s=new R.$Wd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}w(U,C){return{...U,revived:c.TestItem.toPlain(U.item),depth:C?C.depth+1:0,children:new Set}}v(){return new g(this.s)}}class k{constructor(U){this.f=U}checkout(){this.c||(this.c=this.g());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(C=>C.revived)},dispose:(0,L.$db)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}g(){const U=new v({asCanonicalUri:C=>C});return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}const F=(q,U,C,N)=>{C?Object.assign(C,N):U.$updateTestRunConfig(q.controllerId,q.profileId,N)};class O{#e;#t;#i;#n;#s;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,F(this,this.#e,this.#n,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,F(this,this.#e,this.#n,{supportsContinuousRun:U}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(U){U!==this.isDefault&&(U?this.#t.add(this.profileId):this.#t.delete(this.profileId),F(this,this.#e,this.#n,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,F(this,this.#e,this.#n,{tag:U?c.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,F(this,this.#e,this.#n,{hasConfigurationHandler:!!U}))}get onDidChangeDefault(){return R.Event.chain(this.#i,U=>U.map(C=>C.get(this.controllerId)?.get(this.profileId)).filter(A.$Rf))}constructor(U,C,N,W,se,le,Ee,De,ce,pe=!1,oe=void 0,$e=!1){this.controllerId=se,this.profileId=le,this.f=Ee,this.kind=De,this.runHandler=ce,this._tag=oe,this.g=$e,this.#e=U,this.#s=C,this.#t=N,this.#i=W,C.set(le,this);const ie=G[De];if(typeof ie!="number")throw new Error(`Unknown TestRunProfile.group ${De}`);pe&&N.add(le),this.#n={profileId:le,controllerId:se,tag:oe?c.TestTag.namespace(this.controllerId,oe.id):null,label:Ee,group:ie,isDefault:pe,hasConfigurationHandler:!1,supportsContinuousRun:$e},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$0hc=O;const G={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(Re[111],Ae([1,0,54,15,88,8,7]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=e.$DN=e.$CN=void 0;class m{static{this.c=new I.$AN("TextEditorDecorationType")}constructor(l,$,p){const r=m.c.nextId();l.$registerTextEditorDecorationType($.identifier,r,R.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:r,dispose(){l.$removeTextEditorDecorationType(r)}})}}e.$CN=m;class h{constructor(l,$){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=$.undoStopBefore,this.f=$.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,$){this.k();let p=null;if(l instanceof L.$nL)p=new L.$oL(l,l);else if(l instanceof L.$oL)p=l;else throw new Error("Unrecognized location");this.l(p,$,!1)}insert(l,$){this.k(),this.l(new L.$oL(l,l),$,!0)}delete(l){this.k();let $=null;if(l instanceof L.$oL)$=l;else throw new Error("Unrecognized location");this.l($,null,!0)}l(l,$,p){const r=this.c.validateRange(l);this.g.push({range:r,text:$,forceMoveMarkers:p})}setEndOfLine(l){if(this.k(),l!==L.EndOfLine.LF&&l!==L.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=l}}class E{constructor(l,$,p,r){this.c=l,this.d=$,this._accept(p),this.e=r;const c=this;this.value={get tabSize(){return c.f},set tabSize(s){c.n(s)},get indentSize(){return c.g},set indentSize(s){c.p(s)},get insertSpaces(){return c.j},set insertSpaces(s){c.s(s)},get cursorStyle(){return c.k},set cursorStyle(s){c.t(s)},get lineNumbers(){return c.l},set lineNumbers(s){c.u(s)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const $=Math.floor(l);return $>0?$:null}if(typeof l=="string"){const $=parseInt(l,10);return isNaN($)?null:$>0?$:null}return null}n(l){const $=this.m(l);if($!==null){if(typeof $=="number"){if(this.f===$)return;this.f=$}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:$}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const $=Math.floor(l);return $>0?$:null}if(typeof l=="string"){const $=parseInt(l,10);return isNaN($)?null:$>0?$:null}return null}p(l){const $=this.o(l);if($!==null){if(typeof $=="number"){if(this.h===$)return;this.g=$,this.h=$}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:$}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const $=this.q(l);if(typeof $=="boolean"){if(this.j===$)return;this.j=$}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:$}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(l)})))}assign(l){const $={};let p=!1;if(typeof l.tabSize<"u"){const r=this.m(l.tabSize);r==="auto"?(p=!0,$.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,p=!0,$.tabSize=r)}if(typeof l.indentSize<"u"){const r=this.o(l.indentSize);r==="tabSize"?(p=!0,$.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,p=!0,$.indentSize=r)}if(typeof l.insertSpaces<"u"){const r=this.q(l.insertSpaces);r==="auto"?(p=!0,$.insertSpaces=r):this.j!==r&&(this.j=r,p=!0,$.insertSpaces=r)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,p=!0,$.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,p=!0,$.lineNumbers=R.TextEditorLineNumbersStyle.from(l.lineNumbers)),p&&this.v("setOptions",this.c.$trySetOptions(this.d,$))}v(l,$){$.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(p)})}}e.$DN=E;class A{constructor(l,$,p,r,c,s,i,o){this.id=l,this.j=$,this.k=p,this.g=!1,this.h=new Set,this.c=c,this.d=new E(this.j,this.id,s,p),this.e=i,this.f=o;const a=this;this.value=Object.freeze({get document(){return r.value},set document(u){throw new M.$9("document")},get selection(){return a.c&&a.c[0]},set selection(u){if(!(u instanceof L.$pL))throw(0,M.$7)("selection");a.c=[u],a.l()},get selections(){return a.c},set selections(u){if(!Array.isArray(u)||u.some(t=>!(t instanceof L.$pL)))throw(0,M.$7)("selections");a.c=u,a.l()},get visibleRanges(){return a.e},set visibleRanges(u){throw new M.$9("visibleRanges")},get options(){return a.d.value},set options(u){a.g||a.d.assign(u)},get viewColumn(){return a.f},set viewColumn(u){throw new M.$9("viewColumn")},edit(u,t={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new h(r.value,t);return u(f),a.m(f)},insertSnippet(u,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!t||Array.isArray(t)&&t.length===0)n=a.c.map(w=>R.Range.from(w));else if(t instanceof L.$nL){const{lineNumber:w,column:y}=R.Position.from(t);n=[{startLineNumber:w,startColumn:y,endLineNumber:w,endColumn:y}]}else if(t instanceof L.$oL)n=[R.Range.from(t)];else{n=[];for(const w of t)if(w instanceof L.$oL)n.push(R.Range.from(w));else{const{lineNumber:y,column:d}=R.Position.from(w);n.push({startLineNumber:y,startColumn:d,endLineNumber:y,endColumn:d})}}return $.$tryInsertSnippet(l,r.value.version,u.value,n,f)},setDecorations(u,t){const f=t.length===0;f&&!a.h.has(u.key)||(f?a.h.delete(u.key):a.h.add(u.key),a.n(()=>{if(R.$sN(t))return $.$trySetDecorations(l,u.key,R.$tN(t));{const n=new Array(4*t.length);for(let w=0,y=t.length;w<y;w++){const d=t[w];n[4*w]=d.start.line+1,n[4*w+1]=d.start.character+1,n[4*w+2]=d.end.line+1,n[4*w+3]=d.end.character+1}return $.$trySetDecorationsFast(l,u.key,n)}}))},revealRange(u,t){a.n(()=>$.$tryRevealRange(l,R.Range.from(u),t||L.TextEditorRevealType.Default))},show(u){$.$tryShowEditor(l,R.ViewColumn.from(u))},hide(){$.$tryHideEditor(l)}})}dispose(){(0,S.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,S.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,S.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,S.ok)(!this.g),this.f=l}_acceptSelections(l){(0,S.ok)(!this.g),this.c=l}async l(){const l=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const $=l.finalize();if($.edits.length===0&&!$.setEndOfLine)return Promise.resolve(!0);const p=$.edits.map(c=>c.range);p.sort((c,s)=>c.end.line===s.end.line?c.end.character===s.end.character?c.start.line===s.start.line?c.start.character-s.start.character:c.start.line-s.start.line:c.end.character-s.end.character:c.end.line-s.end.line);for(let c=0,s=p.length-1;c<s;c++){const i=p[c].end;if(p[c+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=$.edits.map(c=>({range:R.Range.from(c.range),text:c.text,forceMoveMarkers:c.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,$.documentVersionId,r,{setEndOfLine:typeof $.setEndOfLine=="number"?R.EndOfLine.from($.setEndOfLine):void 0,undoStopBefore:$.undoStopBefore,undoStopAfter:$.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,$=>($ instanceof Error&&$.name==="DISPOSED"||this.k.warn($),null))}}e.$EN=A}),define(Re[66],Ae([1,0,54,5,6,2,4,3,108,17,111,8,13,28,12,68,39]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GN=e.$FN=void 0;class s{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(a,u){this.h=a,this.i=u,this.a=null,this.b=new Map,this.c=new $.$Ac,this.d=new M.$Wd,this.e=new M.$Wd,this.f=new M.$Wd,this.g=new M.$Wd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const u=[],t=[],f=[];if(a.removedDocuments)for(const n of a.removedDocuments){const w=R.URI.revive(n),y=this.c.get(w);y?.unref()&&(this.c.delete(w),u.push(y.value))}if(a.addedDocuments)for(const n of a.addedDocuments){const w=R.URI.revive(n.uri);let y=this.c.get(w);if(y&&w.scheme!==p.Schemas.vscodeNotebookCell&&w.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${w} already exists!'`);y||(y=new s(new h.$yN(this.h.getProxy(m.$kL.MainThreadDocuments),w,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this.c.set(w,y),t.push(y.value)),y.ref()}if(a.removedEditors)for(const n of a.removedEditors){const w=this.b.get(n);this.b.delete(n),w&&f.push(w)}if(a.addedEditors)for(const n of a.addedEditors){const w=R.URI.revive(n.documentUri);S.ok(this.c.has(w),`document '${w}' does not exist`),S.ok(!this.b.has(n.id),`editor '${n.id}' already exists!`);const y=this.c.get(w).value,d=new A.$EN(n.id,this.h.getProxy(m.$kL.MainThreadTextEditors),this.i,new c.$V(()=>y.document),n.selections.map(D.Selection.to),n.options,n.visibleRanges.map(b=>D.Range.to(b)),typeof n.editorPosition=="number"?D.ViewColumn.to(n.editorPosition):void 0);this.b.set(n.id,d)}a.newActiveEditor!==void 0&&(S.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,I.$Oc)(u),(0,I.$Oc)(f),a.removedDocuments&&this.e.fire(u),a.addedDocuments&&this.d.fire(t),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(n=>n.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return r.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const u=this.b.get(this.a);return a?u:u?.value}allEditors(){return[...this.b.values()]}};e.$FN=i,e.$FN=i=Ke([Ve(0,E.$vN),Ve(1,l.$pj)],i),e.$GN=(0,L.$8h)("IExtHostDocumentsAndEditors")}),define(Re[274],Ae([1,0,18,5,3,111,8,7]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;class h{constructor(A,D){this.i=D,this.a=new M.$Wd,this.b=new M.$Wd,this.c=new M.$Wd,this.d=new M.$Wd,this.f=new M.$Wd,this.g=new M.$Wd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(I.$kL.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const D=this.i.allEditors();return A?D:D.map(l=>l.value)}async showTextDocument(A,D,l){let $;typeof D=="number"?$={position:L.ViewColumn.from(D),preserveFocus:l}:typeof D=="object"?$={position:L.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?L.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:$={preserveFocus:!1};const p=await this.h.$tryShowTextDocument(A.uri,$),r=p&&this.i.getEditor(p);if(r)return r.value;throw p?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,D){return new R.$CN(this.h,A,D).value}$acceptEditorPropertiesChanged(A,D){const l=this.i.getEditor(A);if(!l)throw new Error("unknown text editor");if(D.options&&l._acceptOptions(D.options),D.selections){const $=D.selections.selections.map(L.Selection.to);l._acceptSelections($)}if(D.visibleRanges){const $=S.$Hb(D.visibleRanges.map(L.Range.to));l._acceptVisibleRanges($)}if(D.options&&this.b.fire({textEditor:l.value,options:{...D.options,lineNumbers:L.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const $=m.TextEditorSelectionChangeKind.fromValue(D.selections.source),p=D.selections.selections.map(L.Selection.to);this.a.fire({textEditor:l.value,selections:p,kind:$})}if(D.visibleRanges){const $=S.$Hb(D.visibleRanges.map(L.Range.to));this.c.fire({textEditor:l.value,visibleRanges:$})}}$acceptEditorPositionData(A){for(const D in A){const l=this.i.getEditor(D);if(!l)throw new Error("Unknown text editor");const $=L.ViewColumn.to(A[D]);l.value.viewColumn!==$&&(l._acceptViewColumn($),this.d.fire({textEditor:l.value,viewColumn:$}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$tgc=h}),define(Re[275],Ae([1,0,2,4,3,6,7,8,22,16]),function(me,e,S,M,I,R,L,m,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=e.$_hc=void 0,e.$_hc=(0,M.$8h)("IExtHostTimeline");class A{constructor($,p){this.b=new Map,this.c=new Map,this.a=$.getProxy(I.$kL.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(r,c)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&h.$nm.equals(c,this.b.get(r.source)?.extension)){const s=r.uri===void 0?void 0:S.URI.revive(r.uri);return this.c.get(r.source)?.get(D(s))?.get(r.handle)}else return;return r}})}async $getTimeline($,p,r,c){return this.b.get($)?.provider.provideTimeline(S.URI.revive(p),r,c)}registerTimelineProvider($,p,r,c){const s=new R.$Sc,i=this.d(p.id,c,s).bind(this);let o;p.onDidChange&&(o=p.onDidChange(u=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...u,id:p.id}),this));const a=this.c;return this.f({...p,scheme:$,onDidChange:void 0,async provideTimeline(u,t,f){t?.resetCache&&(s.clear(),a.get(p.id)?.clear());const n=await p.provideTimeline(u,t,f);if(n==null)return;const w=i(u,t);return{...n,source:p.id,items:n.items.map(w)}},dispose(){for(const u of a.values())u.get(p.id)?.clear();o?.dispose(),s.dispose()}},r)}d($,p,r){return(c,s)=>{let i;if(s?.cacheResults){let o=this.c.get($);o===void 0&&(o=new Map,this.c.set($,o));const a=D(c);i=o.get(a),i===void 0&&(i=new Map,o.set(a,i))}return o=>{const{iconPath:a,...u}=o,t=`${$}|${o.id??o.timestamp}`;i?.set(t,o);let f,n,w;o.iconPath&&(a instanceof L.$hM?w={id:a.id,color:a.color}:S.URI.isUri(a)?(f=a,n=a):{light:f,dark:n}=a);let y;return L.$NL.isMarkdownString(u.tooltip)?y=m.MarkdownString.from(u.tooltip):(0,E.$Jf)(u.tooltip)?y=u.tooltip:L.$NL.isMarkdownString(u.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=m.MarkdownString.from(u.detail)):(0,E.$Jf)(u.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=u.detail),{...u,id:u.id??void 0,handle:t,source:$,command:o.command?p.toInternal(o.command,r):void 0,icon:f,iconDark:n,themeIcon:w,tooltip:y,accessibilityInformation:o.accessibilityInformation}}}}f($,p){if(this.b.get($.id))throw new Error(`Timeline Provider ${$.id} already exists.`);return this.a.$registerTimelineProvider({id:$.id,label:$.label,scheme:$.scheme}),this.b.set($.id,{provider:$,extension:p}),(0,R.$Rc)(()=>{for(const c of this.c.values())c.get($.id)?.clear();this.b.delete($.id),this.a.$unregisterTimelineProvider($.id),$.dispose()})}}e.$aic=A;function D(l){return l?.toString()}}),define(Re[276],Ae([1,0,166,25,2,5,6,204,11,7,16,18,8,46,21,132,24]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=void 0;function s(a,u){if((0,A.$Jf)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let t;return Array.isArray(a.highlights)&&(t=a.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:a.label,highlights:t}}}class i extends L.$Tc{constructor(u,t,f){super(),this.f=u,this.g=t,this.h=f,this.a=new Map,this.b=new r.$L8;function n(w){return w&&w.$treeViewId&&(w.$treeItemHandle||w.$selectedTreeItems||w.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:w=>n(w)?this.r(w):Array.isArray(w)&&w.length>0?w.map(y=>n(y)?this.r(y):y):w})}registerTreeDataProvider(u,t,f){const n=this.createTreeView(u,{treeDataProvider:t},f);return{dispose:()=>n.dispose()}}createTreeView(u,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=t.dragAndDropController?.dropMimeTypes??[],w=t.dragAndDropController?.dragMimeTypes??[],y=!!t.dragAndDropController?.handleDrag,d=!!t.dragAndDropController?.handleDrop,b=this.m(u,t,f),P={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:n,dragMimeTypes:w,hasHandleDrag:y,hasHandleDrop:d,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},g=this.f.$registerTreeViewDataProvider(u,P),v={get onDidCollapseElement(){return b.onDidCollapseElement},get onDidExpandElement(){return b.onDidExpandElement},get selection(){return b.selectedElements},get onDidChangeSelection(){return b.onDidChangeSelection},get activeItem(){return(0,c.$LF)(f,"treeViewActiveItem"),b.focusedElement},get onDidChangeActiveItem(){return(0,c.$LF)(f,"treeViewActiveItem"),b.onDidChangeActiveItem},get visible(){return b.visible},get onDidChangeVisibility(){return b.onDidChangeVisibility},get onDidChangeCheckboxState(){return b.onDidChangeCheckboxState},get message(){return b.message},set message(k){(0,$.$lk)(k)&&(0,c.$LF)(f,"treeViewMarkdownMessage"),b.message=k},get title(){return b.title},set title(k){b.title=k},get description(){return b.description},set description(k){b.description=k},get badge(){return b.badge},set badge(k){k!==void 0&&E.ViewBadge.isViewBadge(k)?b.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(b.badge=void 0)},reveal:(k,F)=>b.reveal(k,F),dispose:async()=>{await g,this.a.delete(u),b.dispose()}};return this.B(v),v}$getChildren(u,t){const f=this.a.get(u);return f?f.getChildren(t):Promise.reject(new m.$eF(u))}async $handleDrop(u,t,f,n,w,y,d,b){const P=this.a.get(u);if(!P)return Promise.reject(new m.$eF(u));const g=l.DataTransfer.toDataTransfer(f,async v=>(await this.f.$resolveDropFileData(u,t,v)).buffer);return d===u&&b&&await this.j(g,P,b,w,y),P.onDrop(g,n,w)}async j(u,t,f,n,w){const y=this.b.removeDragOperationTransfer(w);if(y)(await y)?.forEach((d,b)=>{d&&u.set(b,d)});else if(w&&t.handleDrag){const d=t.handleDrag(f,u,n);this.b.addDragOperationTransfer(w,d),await d}return u}async $handleDrag(u,t,f,n){const w=this.a.get(u);if(!w)return Promise.reject(new m.$eF(u));const y=await this.j(new E.$eM,w,t,n,f);if(!(!y||n.isCancellationRequested))return l.DataTransfer.from(y)}async $hasResolve(u){const t=this.a.get(u);if(!t)throw new m.$eF(u);return t.hasResolve}$resolve(u,t,f){const n=this.a.get(u);if(!n)throw new m.$eF(u);return n.resolveTreeItem(t,f)}$setExpanded(u,t,f){const n=this.a.get(u);if(!n)throw new m.$eF(u);n.setExpanded(t,f)}$setSelectionAndFocus(u,t,f){const n=this.a.get(u);if(!n)throw new m.$eF(u);n.setSelectionAndFocus(t,f)}$setVisible(u,t){const f=this.a.get(u);if(!f){if(!t)return;throw new m.$eF(u)}f.setVisible(t)}$changeCheckboxState(u,t){const f=this.a.get(u);if(!f)throw new m.$eF(u);f.setCheckboxState(t)}m(u,t,f){const n=this.B(new o(u,t,this.f,this.g.converter,this.h,f));return this.a.set(u,n),n}r(u){const t=this.a.get(u.$treeViewId);return t&&"$treeItemHandle"in u?t.getExtensionElement(u.$treeItemHandle):t&&"$focusedTreeItem"in u&&u.$focusedTreeItem?t.focusedElement:null}}e.$bic=i;class o extends L.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(u=>this.getExtensionElement(u)).filter(u=>!(0,A.$Sf)(u))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(u,t,f,n,w,y){if(super(),this.I=u,this.J=f,this.L=n,this.M=w,this.N=y,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$Wd),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$Wd),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$Wd),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$Wd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$Wd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$Wd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$Wd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$7d,y.contributes&&y.contributes.views)for(const g in y.contributes.views)for(const v of y.contributes.views[g])v.id===u&&(this.P=v.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(g=>this.F.fire({message:!1,element:g})));let d,b;const P=R.Event.debounce(this.F.event,(g,v)=>(g||(g={message:!1,elements:[]}),v.element!==!1&&(d||(d=new Promise(k=>b=k),this.G=this.G.then(()=>d)),Array.isArray(v.element)?g.elements.push(...v.element):g.elements.push(v.element)),v.message&&(g.message=!0),g),200,!0);this.B(P(({message:g,elements:v})=>{v.length&&(this.H=this.H.then(()=>{const k=b;return d=null,this.$(v).then(()=>k())})),g&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(u){const t=u?this.getExtensionElement(u):void 0;if(u&&!t)return this.M.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let f=this.X(u);return f||(f=await this.Y(t)),f?f.map(n=>n.item):void 0}getExtensionElement(u){return this.j.get(u)}reveal(u,t){t=t||{select:!0,focus:!1};const f=(0,A.$Sf)(t.select)?!0:t.select,n=(0,A.$Sf)(t.focus)?!1:t.focus,w=(0,A.$Sf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.G.then(()=>this.S(u)).then(y=>this.W(u,y[y.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:y.map(b=>b.item)},{select:f,focus:n,expand:w})),y=>this.M.error(y)):this.J.$reveal(this.I,void 0,{select:f,focus:n,expand:w})}get message(){return this.O}set message(u){this.O=u,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(u){this.P=u,this.J.$setTitle(this.I,u,this.Q)}get description(){return this.Q}set description(u){this.Q=u,this.J.$setTitle(this.I,this.P,u)}get badge(){return this.R}set badge(u){this.R?.value===u?.value&&this.R?.tooltip===u?.tooltip||(this.R=l.ViewBadge.from(u),this.J.$setBadge(this.I,u))}setExpanded(u,t){const f=this.getExtensionElement(u);f&&(t?this.u.fire(Object.freeze({element:f})):this.w.fire(Object.freeze({element:f})))}setSelectionAndFocus(u,t){const f=!(0,D.$ub)(this.s,u);this.s=u;const n=this.t!==t;this.t=t,f&&this.y.fire(Object.freeze({selection:this.selectedElements})),n&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(u){u!==this.r&&(this.r=u,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(u){const t=(await Promise.all(u.map(async f=>{const n=this.getExtensionElement(f.treeItemHandle);return n?{extensionItem:n,treeItem:await this.f.getTreeItem(n),newState:f.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(u,t,f){const n=[];for(const w of u){const y=this.getExtensionElement(w);y&&n.push(y)}if(!(!this.g?.handleDrag||n.length===0))return await this.g.handleDrag(n,t,f),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(u,t,f){const n=t?this.getExtensionElement(t):void 0;if(!(!n&&t||!this.g?.handleDrop))return(0,h.$Zg)(()=>this.g?.handleDrop?this.g.handleDrop(n,u,f):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(u,t){if(!this.f.resolveTreeItem)return;const f=this.j.get(u);if(f){const n=this.m.get(f);if(n){const w=await this.f.resolveTreeItem(n.extensionItem,f,t)??n.extensionItem;return this.hb(w),n.item.tooltip=this.eb(w.tooltip),n.item.command=this.fb(n.disposableStore,w.command),n.item}}}S(u){return this.U(u).then(t=>t?this.S(t).then(f=>this.W(t,f[f.length-1]).then(n=>(f.push(n),f))):Promise.resolve([]))}U(u){const t=this.m.get(u);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,h.$Zg)(()=>this.f.getParent(u))}W(u,t){const f=this.m.get(u);return f?Promise.resolve(f):(0,h.$Zg)(()=>this.f.getTreeItem(u)).then(n=>this.kb(u,n,t,!0)).then(n=>this.getChildren(t?t.item.handle:void 0).then(()=>{const w=this.getExtensionElement(n);if(w){const y=this.m.get(w);if(y)return Promise.resolve(y)}throw new Error(`Cannot resolve tree item for element ${n} from extension ${this.N.identifier.value}`)}))}X(u){if(u){let t;if(typeof u=="string"){const f=this.getExtensionElement(u);t=f?this.m.get(f):void 0}else t=u;return t&&t.children||void 0}return this.h}async Y(u){this.rb(u);const t=new p.$7d(this.Z.token);try{const f=u?this.m.get(u):void 0,n=await this.f.getChildren(u);if(t.token.isCancellationRequested)return;const w=(0,D.$Hb)(n||[]),y=await Promise.all((0,D.$Hb)(w).map(b=>this.f.getTreeItem(b)));if(t.token.isCancellationRequested)return;const d=y.map((b,P)=>b?this.db(w[P],b,f):null);return(0,D.$Hb)(d)}finally{t.dispose()}}$(u){if(u.some(f=>!f))return this.Z.dispose(!0),this.Z=new p.$7d,this.tb(),this.J.$refresh(this.I);{const f=this.ab(u);if(f.length)return this.bb(f)}return Promise.resolve(void 0)}ab(u){const t=new Set,f=u.map(w=>this.m.get(w));for(const w of f)if(w&&!t.has(w.item.handle)){let y=w;for(;y&&y.parent&&f.findIndex(d=>y&&y.parent&&d&&d.item.handle===y.parent.item.handle)===-1;){const d=this.j.get(y.parent.item.handle);y=d?this.m.get(d):void 0}y&&!y.parent&&t.add(w.item.handle)}const n=[];return t.forEach(w=>{const y=this.j.get(w);if(y){const d=this.m.get(y);d&&(!d.parent||!t.has(d.parent.item.handle))&&n.push(w)}}),n}bb(u){const t={};return Promise.all(u.map(f=>this.cb(f).then(n=>{n&&(t[f]=n.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(u){const t=this.getExtensionElement(u);if(t){const f=this.m.get(t);if(f)return this.rb(t),(0,h.$Zg)(()=>this.f.getTreeItem(t)).then(n=>{if(n){const w=this.ib(t,n,f.parent);return this.pb(t,w,f,f.parent),f.dispose(),w}return null})}return Promise.resolve(null)}db(u,t,f){const n=this.ib(u,t,f);if(t.id&&this.j.has(n.item.handle))throw new Error((0,S.localize)(0,null,t.id));return this.ob(u,n),this.qb(n,f),n}eb(u){return E.$NL.isMarkdownString(u)?l.MarkdownString.from(u):u}fb(u,t){return t?{...this.L.toInternal(t,u),originalId:t.command}:void 0}gb(u){if(u.checkboxState===void 0)return;let t,f,n;return typeof u.checkboxState=="number"?t=u.checkboxState:(t=u.checkboxState.state,f=u.checkboxState.tooltip,n=u.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:n}}hb(u){if(!E.$_L.isTreeItem(u,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(u,t,f){this.hb(t);const n=this.B(new L.$Sc),w=this.kb(u,t,f),y=this.lb(t);return{item:{handle:w,parentHandle:f?f.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(n,t.command),contextValue:t.contextValue,icon:y,iconDark:this.mb(t)||y,themeIcon:this.jb(t),collapsibleState:(0,A.$Sf)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:f,children:void 0,disposableStore:n,dispose(){n.dispose()}}}jb(u){return u.iconPath instanceof E.$hM?u.iconPath:void 0}kb(u,{id:t,label:f,resourceUri:n},w,y){if(t)return`${o.b}/${t}`;const d=s(f,this.N),b=w?w.item.handle:o.a;let P=d?d.label:n?(0,M.$Fg)(n):"";P=P.indexOf("/")!==-1?P.replace("/","//"):P;const g=this.m.has(u)?this.m.get(u).item.handle:void 0,v=this.X(w)||[];let k,F=0;do{if(k=`${b}/${F}:${P}`,y||!this.j.has(k)||g===k)break;F++}while(F<=v.length);return k}lb(u){if(u.iconPath&&!(u.iconPath instanceof E.$hM))return typeof u.iconPath=="string"||I.URI.isUri(u.iconPath)?this.nb(u.iconPath):this.nb(u.iconPath.light)}mb(u){if(u.iconPath&&!(u.iconPath instanceof E.$hM)&&u.iconPath.dark)return this.nb(u.iconPath.dark)}nb(u){return I.URI.isUri(u)?u:I.URI.file(u)}ob(u,t){this.j.set(t.item.handle,u),this.m.set(u,t)}pb(u,t,f,n){this.j.delete(t.item.handle),this.m.delete(u),t.item.handle!==f.item.handle&&this.j.delete(f.item.handle),this.ob(u,t);const w=this.X(n)||[],y=w.filter(d=>d.item.handle===f.item.handle)[0];y&&w.splice(w.indexOf(y),1,t)}qb(u,t){t?(t.children||(t.children=[]),t.children.push(u)):(this.h||(this.h=[]),this.h.push(u))}rb(u){if(u){const t=this.m.get(u);if(t){if(t.children)for(const f of t.children){const n=this.j.get(f.item.handle);n&&this.sb(n)}t.children=void 0}}else this.tb()}sb(u){const t=this.m.get(u);if(t){if(t.children)for(const f of t.children){const n=this.j.get(f.item.handle);n&&this.sb(n)}this.m.delete(u),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(u=>u.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Re[277],Ae([1,0,5,6,2,33,8,61,3,7]),function(me,e,S,M,I,R,L,m,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;class A extends M.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(p,r,c,s){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new S.$Wd),this.onDidDispose=this.#d.event,this.#h=this.B(new S.$Wd),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=r,this.#n=c,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(p){this.c(),this.#r!==p&&(this.#r=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#a}set iconPath(p){this.c(),this.#a!==p&&(this.#a=p,this.#t.$setIconPath(this.#e,I.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(p){this.#l||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#u=p.active,this.#c=p.visible,this.#o=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:L.ViewColumn.from(p),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class D extends M.$Tc{static c(){return(0,R.$rg)()}constructor(p,r,c){super(),this.j=r,this.m=c,this.g=new Map,this.h=new Map,this.f=p.getProxy(h.$kL.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,r,c,s,i={}){const o=typeof s=="object"?s.viewColumn:s,a={viewColumn:L.ViewColumn.from(o),preserveFocus:typeof s=="object"&&!!s.preserveFocus},u=(0,m.$Igc)(p),t=D.c();this.f.$createWebviewPanel((0,m.$Kgc)(p),t,r,{title:c,panelOptions:l(i),webviewOptions:(0,m.$Lgc)(p,this.m,i),serializeBuffersForPostMessage:u},a);const f=this.j.createNewWebview(t,i,p);return this.createNewWebviewPanel(t,r,c,o,i,f,!0)}$onDidChangeWebviewPanelViewStates(p){const r=Object.keys(p);r.sort((c,s)=>{const i=p[c],o=p[s];return i.active?1:o.active?-1:+i.visible-+o.visible});for(const c of r){const s=this.getWebviewPanel(c);if(!s)continue;const i=p[c];s._updateViewState({active:i.active,visible:i.visible,viewColumn:L.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,r,c){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:c,extension:p}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,m.$Igc)(p)}),new E.$mL(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(p,r,c,s){const i=this.h.get(r);if(!i)throw new Error(`No serializer found for '${r}'`);const{serializer:o,extension:a}=i,u=this.j.createNewWebview(p,c.webviewOptions,a),t=this.createNewWebviewPanel(p,r,c.title,s,c.panelOptions,u,c.active);await o.deserializeWebviewPanel(t,c.state)}createNewWebviewPanel(p,r,c,s,i,o,a){const u=new A(p,this.f,o,{viewType:r,title:c,viewColumn:s,panelOptions:i,active:a});return this.g.set(p,u),u}getWebviewPanel(p){return this.g.get(p)}}e.$Mgc=D;function l($){return{enableFindWidget:$.enableFindWidget,retainContextWhenHidden:$.retainContextWhenHidden}}}),define(Re[278],Ae([1,0,5,6,61,8,3,7]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=void 0;class h extends M.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(D,l,$,p,r,c){super(),this.#s=!1,this.#u=this.B(new S.$Wd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new S.$Wd),this.onDidDispose=this.#l.event,this.#i=$,this.#a=p,this.#e=D,this.#t=l,this.#n=r,this.#r=c}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(D){this.a(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#o}set description(D){this.a(),this.#o!==D&&(this.#o=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(D){D===this.#r||this.#s||(this.#r=D,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(D){this.a(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(D,l){this.d=l,this.b=new Map,this.c=new Map,this.a=D.getProxy(L.$kL.MainThreadWebviewViews)}registerWebviewViewProvider(D,l,$,p){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:$,extension:D}),this.a.$registerWebviewViewProvider((0,I.$Kgc)(D),l,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$Igc)(D)}),new m.$mL(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(D,l,$,p,r){const c=this.b.get(l);if(!c)throw new Error(`No view provider found for '${l}'`);const{provider:s,extension:i}=c,o=this.d.createNewWebview(D,{},i),a=new h(D,this.a,l,$,o,!0);this.c.set(D,a),await s.resolveWebviewView(a,{state:p},r)}async $onDidChangeWebviewViewVisibility(D,l){this.e(D)._setVisible(l)}async $disposeWebviewView(D){const l=this.e(D);this.c.delete(D),l.dispose(),this.d.deleteWebview(D)}e(D){const l=this.c.get(D);if(!l)throw new Error("No webview found");return l}}e.$eic=E}),define(Re[279],Ae([1,0,5,30,35,4]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GK=e.$FK=e.OutputChannelUpdateMode=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=void 0,e.$vK="text/x-code-output",e.$wK="output",e.$xK="Log",e.$yK="text/x-code-log-output",e.$zK="log",e.$AK="workbench.panel.output",e.$BK=new I.$mj("inOutput",!1),e.$CK=new I.$mj("activeLogOutput",!1),e.$DK=new I.$mj("outputView.scrollLock",!1),e.$EK=(0,R.$8h)("outputService");var L;(function(h){h[h.Append=1]="Append",h[h.Replace=2]="Replace",h[h.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$FK={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new S.$Wd,this.onDidRegisterChannel=this.b.event,this.c=new S.$Wd,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(A=>E.push(A)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}M.$Kn.add(e.$FK.OutputChannels,new m),e.$GK=new I.$mj("activeOutputChannel","")}),define(Re[112],Ae([1,0,3,4,17,22,13,279,62,27,43,136,23,16,42,5,6]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=e.$Rhc=void 0;class s extends L.$vj{get disposed(){return this.n}constructor(u,t,f,n,w){super(),this.id=u,this.name=t,this.r=f,this.s=n,this.extension=w,this.m=0,this.n=!1,this.visible=!1,this.setLevel(f.getLevel()),this.B(f.onDidChangeLogLevel(y=>this.setLevel(y)))}get logLevel(){return this.getLevel()}appendLine(u){this.append(u+`
`)}append(u){this.info(u)}clear(){const u=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,u)}replace(u){const t=this.m;this.info(u),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(u,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof u=="boolean"?u:t))}hide(){this.s.$close(this.id)}g(u,t){this.m+=l.$ke.fromString(t).byteLength,(0,L.log)(this.r,u,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends s{appendLine(u){this.append(u)}}let o=class{constructor(u,t,f,n,w,y){this.i=t,this.j=f,this.k=n,this.l=w,this.m=y,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=u.getProxy(S.$kL.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,D.$zm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.h=u;for(const[t,f]of this.g)f.visible=t===this.h}createOutputChannel(u,t,f){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");const n=typeof t=="object"&&t.log,w=(0,$.$Jf)(t)?t:void 0;if((0,$.$Jf)(w)&&!w.trim())throw new Error("illegal argument `languageId`. must not be empty");let y;const d=this.i.environment.extensionLogLevel?.find(([P])=>R.$nm.equals(f.identifier,P))?.[1];d&&(y=(0,L.$Fj)(d));const b=n?this.o(u,y,f):this.n(u,w,f);return b.then(P=>{this.g.set(P.id,P),P.visible=P.id===this.h}),n?this.r(u,y??this.m.getLevel(),b):this.q(u,b)}async n(u,t,f){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const n=await this.c,w=this.k.extUri.joinPath(n,`${this.f++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),y=this.l.createLogger(w,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(u,w,t,f.identifier.value);return new s(d,u,y,this.a,f)}async o(u,t,f){const n=await this.p(f),w=u.replace(/[\\/:\*\?"<>\|]/g,""),y=this.k.extUri.joinPath(n,`${w}.log`),d=`${f.identifier.value}.${w}`,b=this.l.createLogger(y,{id:d,name:u,logLevel:t,extensionId:f.identifier.value});return new i(d,u,b,this.a,f)}p(u){let t=this.d.get(u.identifier.value);if(!t){const f=this.k.extUri.joinPath(this.i.logsLocation,u.identifier.value);this.d.set(u.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(f)}catch(n){if((0,p.$Ik)(n)!==p.FileSystemProviderErrorCode.FileExists)throw n}return f})())}return t}q(u,t){let f=!1;const n=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return u},append(w){n(),t.then(y=>y.append(w))},appendLine(w){n(),t.then(y=>y.appendLine(w))},clear(){n(),t.then(w=>w.clear())},replace(w){n(),t.then(y=>y.replace(w))},show(w,y){n(),t.then(d=>d.show(w,y))},hide(){n(),t.then(w=>w.hide())},dispose(){f=!0,t.then(w=>w.dispose())}}}r(u,t,f){const n=new c.$Sc,w=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},y=n.add(new r.$Wd);function d(b){t=b,y.fire(b)}return f.then(b=>{n.add(b),b.logLevel!==t&&d(b.logLevel),n.add(b.onDidChangeLogLevel(P=>d(P)))}),{...this.q(u,f),get logLevel(){return t},onDidChangeLogLevel:y.event,trace(b,...P){w(),f.then(g=>g.trace(b,...P))},debug(b,...P){w(),f.then(g=>g.debug(b,...P))},info(b,...P){w(),f.then(g=>g.info(b,...P))},warn(b,...P){w(),f.then(g=>g.warn(b,...P))},error(b,...P){w(),f.then(g=>g.error(b,...P))},dispose(){n.dispose()}}}};e.$Rhc=o,e.$Rhc=o=Ke([Ve(0,I.$vN),Ve(1,E.$LN),Ve(2,h.$Egc),Ve(3,A.$egc),Ve(4,L.$qj),Ve(5,L.$pj)],o),e.$Shc=(0,M.$8h)("IExtHostOutputService")}),define(Re[113],Ae([1,0,4,11]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=void 0,e.$Om=(0,S.$8h)("remoteAgentService"),e.$Pm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let R=1/0;for(let m=0;m<this.maxSampleCount;m++){const h=await I.getRoundTripTime();if(h===void 0)return;R=Math.min(R,h/2),await(0,M.$9g)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(R):L=this.initial.reduce((m,h)=>m+h,0)/this.initial.length,this.lastMeasurement={initial:L,current:R,average:this.average.reduce((m,h)=>m+h,0)/this.average.length,high:typeof L>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>L*this.highLatencyMultiple},this.lastMeasurement}}}),define(Re[280],Ae([1,0,169,55,30,48,47,6,5,113,20,26,11]),function(me,e,S,M,I,R,L,m,h,E,A,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=void 0,e.$4H=Object.freeze({id:"application",order:100,title:(0,S.localize)(0,null),type:"object"}),e.$5H=Object.freeze({id:"workbench",order:7,title:(0,S.localize)(1,null),type:"object"}),e.$6H=Object.freeze({id:"security",scope:1,title:(0,S.localize)(2,null),type:"object",order:7}),e.$7H=Object.freeze({id:"problems",title:(0,S.localize)(3,null),type:"object",order:101}),e.$8H={ConfigurationMigration:"base.contributions.configuration.migration"};class ${constructor(){this.migrations=[],this.a=new h.$Wd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const p=new $;I.$Kn.add(e.$8H.ConfigurationMigration,p);let r=class extends m.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,o){super(),this.a=i,this.b=o,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const u of a.added)await this.f(u,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(i){await this.f(void 0,i);for(const o of this.b.getWorkspace().folders)await this.f(o,i)}async f(i,o){await Promise.all([o.map(a=>this.g(a,i?.uri))])}async g(i,o){const a=this.a.inspect(i.key,{resource:o}),u=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of u){const n=a[t];if(!n)continue;const w=[];if(n.value!==void 0){const y=await this.h(i,t,n.value,o,void 0);for(const d of y??[])w.push([d,[]])}for(const{identifiers:y,value:d}of n.overrides??[])if(d!==void 0){const b=await this.h(i,t,d,o,y);for(const P of b??[])w.push([P,y])}w.length&&await Promise.allSettled(w.map(async([[y,d],b])=>this.a.updateValue(y,d.value,{resource:o,overrideIdentifiers:b},f)))}}async h(i,o,a,u,t){const f=w=>{const d=this.a.inspect(w,{resource:u})[o];if(d)return t?d.overrides?.find(({identifiers:b})=>(0,D.$Cn)(b,t))?.value:d.value},n=await i.migrateFn(a,f);return Array.isArray(n)?n:[[i.key,n]]}};e.$9H=r,e.$9H=r=Ke([Ve(0,L.$Bi),Ve(1,R.$ei)],r);let c=class extends m.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new l.$sh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==1)return;I.$Kn.as(M.$Pn.Configuration).registerConfiguration({...e.$6H,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,S.localize)(4,null)},default:[],markdownDescription:(0,S.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,S.localize)(6,null),scope:2}}})}};e.$0H=c,e.$0H=c=Ke([Ve(0,E.$Om)],c)}),define(Re[281],Ae([1,0,34,12,19,25,177,280,55,4,30]),function(me,e,S,M,I,R,L,m,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndb=e.$Mdb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Ldb=e.$Kdb=void 0,e.$Kdb=(0,E.$8h)("editorResolverService"),e.$Ldb="workbench.editorAssociations";const D=A.$Kn.as(h.$Pn.Configuration),l={...m.$5H,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(l);var $;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})($||(e.RegisteredEditorPriority=$={}));var p;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(p||(e.ResolvedStatus=p={}));function r(s){switch(s){case $.exclusive:return 5;case $.default:return 4;case $.builtin:return 3;case $.option:default:return 1}}e.$Mdb=r;function c(s,i){if(new Set([M.Schemas.extension,M.Schemas.webviewPanel,M.Schemas.vscodeWorkspaceTrust,M.Schemas.vscodeSettings]).has(i.scheme))return!1;const u=typeof s=="string"&&s.indexOf(I.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,R.$Fg)(i);return S.$Nj(typeof s=="string"?s.toLowerCase():s,u.toLowerCase())}e.$Ndb=c}),define(Re[282],Ae([1,0,45,12,19,20,25,2,4,198,48,216,113]),function(me,e,S,M,I,R,L,m,h,E,A,D,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$ZK=e.$YK=void 0,e.$YK=(0,h.$8h)("pathService");let p=$=class{constructor(c,s,i,o){this.d=c,this.e=s,this.f=i,this.g=o,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??c})()}hasValidBasename(c,s,i){return typeof s=="string"||typeof s>"u"?this.a.then(o=>this.h(c,o,s)):this.h(c,s,i)}h(c,s,i){return c.scheme===M.Schemas.file||c.scheme===M.Schemas.vscodeRemote?(0,S.$7f)(i??(0,L.$Fg)(c),s===1):!0}get defaultUriScheme(){return $.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(c,s){if(c.remoteAuthority)return M.Schemas.vscodeRemote;const i=(0,E.$VK)(s.getWorkspace());if(i)return i;const o=s.getWorkspace().folders[0];if(o)return o.uri.scheme;const a=s.getWorkspace().configuration;return a?a.scheme:M.Schemas.file}userHome(c){return c?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(c=>c===1?I.$fc:I.$gc)}async fileURI(c){let s="";if(await this.a===1&&(c=c.replace(/\\/g,"/")),c[0]==="/"&&c[1]==="/"){const o=c.indexOf("/",2);o===-1?(s=c.substring(2),c="/"):(s=c.substring(2,o),c=c.substring(o)||"/")}return m.URI.from({scheme:M.Schemas.file,authority:s,path:c,query:"",fragment:""})}};e.$ZK=p,e.$ZK=p=$=Ke([Ve(1,l.$Om),Ve(2,D.$HK),Ve(3,A.$ei)],p)}),define(Re[114],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$AJ=e.$zJ=void 0;class S{constructor(L,m){this.line=L,this.character=m}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,m){return new S(0,0)}with(L){return new S(0,0)}}e.$zJ=S;class M{constructor(L,m,h,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new S(L,m),this.end=new S(h,E)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new M(0,0,0,0)}with(L){return new M(0,0,0,0)}}e.$AJ=M;var I;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Re[44],Ae([1,0,18,34,26,45,14,4,19,15,114,11]),function(me,e,S,M,I,R,L,m,h,E,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.SearchErrorCode=e.$PJ=e.$OJ=e.SearchSortOrder=e.ViewMode=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.SearchCompletionExitCode=e.$JJ=e.$IJ=e.$HJ=e.QueryType=e.SearchProviderType=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$BJ="workbench.view.search",e.$CJ="workbench.panel.search",e.$DJ="workbench.view.search",e.$EJ="search-result",e.$FJ="search.exclude";const l="\u27EA ",$=" characters skipped \u27EB",p=(l.length+$.length+5)*2;e.$GJ=(0,m.$8h)("searchService");var r;(function(ce){ce[ce.file=0]="file",ce[ce.text=1]="text"})(r||(e.SearchProviderType=r={}));var c;(function(ce){ce[ce.File=1]="File",ce[ce.Text=2]="Text"})(c||(e.QueryType=c={}));function s(ce){return!!ce.preview}e.$HJ=s;function i(ce){return!!ce.resource}e.$IJ=i;function o(ce){return!!ce.message}e.$JJ=o;var a;(function(ce){ce[ce.Normal=0]="Normal",ce[ce.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class u{constructor(pe){this.resource=pe,this.results=[]}}e.$KJ=u;class t{constructor(pe,oe,$e,ie){this.ranges=oe,this.webviewIndex=ie;const x=Array.isArray(oe)?oe:[oe];if($e&&$e.matchLines===1&&f(x)){pe=(0,L.$Cf)(pe,$e.matchLines);let V="",ne=0,Ie=0;const Me=Math.floor($e.charsPerLine/5),Le=[];for(const we of x){const ge=Math.max(we.startColumn-Me,0),K=we.startColumn+$e.charsPerLine;if(ge>Ie+Me+p){const ee=l+(ge-Ie)+$;V+=ee+pe.slice(ge,K),ne+=ge-(Ie+ee.length)}else V+=pe.slice(Ie,K);Le.push(new w(0,we.startColumn-ne,we.endColumn-ne)),Ie=K}this.preview={text:V,matches:Array.isArray(this.ranges)?Le:Le[0]}}else{const V=Array.isArray(oe)?oe[0].startLineNumber:oe.startLineNumber;this.preview={text:pe,matches:(0,S.$2b)(oe,ne=>new n(ne.startLineNumber-V,ne.startColumn,ne.endLineNumber-V,ne.endColumn))}}}}e.$LJ=t;function f(ce){const pe=ce[0].startLineNumber;for(const oe of ce)if(oe.startLineNumber!==pe||oe.endLineNumber!==pe)return!1;return!0}class n{constructor(pe,oe,$e,ie){this.startLineNumber=pe,this.startColumn=oe,this.endLineNumber=$e,this.endColumn=ie}}e.$MJ=n;class w extends n{constructor(pe,oe,$e){super(pe,oe,pe,$e)}}e.$NJ=w;var y;(function(ce){ce.List="list",ce.Tree="tree"})(y||(e.ViewMode=y={}));var d;(function(ce){ce.Default="default",ce.FileNames="fileNames",ce.Type="type",ce.Modified="modified",ce.CountDescending="countDescending",ce.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function b(ce,pe=!0){const oe=ce&&ce.files&&ce.files.exclude,$e=pe&&ce&&ce.search&&ce.search.exclude;if(!oe&&!$e)return;if(!oe||!$e)return oe||$e;let ie=Object.create(null);return ie=I.$Bn(ie,I.$yn(oe)),ie=I.$Bn(ie,I.$yn($e),!0),ie}e.$OJ=b;function P(ce,pe){return ce.excludePattern&&M.$Nj(ce.excludePattern,pe)?!1:ce.includePattern||ce.usingSearchPaths?ce.includePattern&&M.$Nj(ce.includePattern,pe)?!0:ce.usingSearchPaths?!!ce.folderQueries&&ce.folderQueries.some(oe=>{const $e=oe.folder.fsPath;if(R.$9f(pe,$e)){const ie=h.$lc($e,pe);return!oe.includePattern||!!M.$Nj(oe.includePattern,ie)}else return!1}):!1:!0}e.$PJ=P;var g;(function(ce){ce[ce.unknownEncoding=1]="unknownEncoding",ce[ce.regexParseError=2]="regexParseError",ce[ce.globParseError=3]="globParseError",ce[ce.invalidLiteral=4]="invalidLiteral",ce[ce.rgProcessError=5]="rgProcessError",ce[ce.other=6]="other",ce[ce.canceled=7]="canceled"})(g||(e.SearchErrorCode=g={}));class v extends Error{constructor(pe,oe){super(pe),this.code=oe}}e.$QJ=v;function k(ce){const pe=ce.message;if((0,E.$4)(ce))return new v(pe,g.canceled);try{const oe=JSON.parse(pe);return new v(oe.message,oe.code)}catch{return new v(pe,g.other)}}e.$RJ=k;function F(ce){const pe={message:ce.message,code:ce.code};return new Error(JSON.stringify(pe))}e.$SJ=F;function O(ce){return ce.type==="error"?!0:ce.type==="success"}e.$TJ=O;function G(ce){return ce.type==="success"}e.$UJ=G;function q(ce){return!!ce.path}e.$VJ=q;function U(ce,pe){const oe=ce.searchPath?ce.searchPath:ce.relativePath;return(0,L.$zf)(oe,pe)}e.$WJ=U;class C{constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$XJ=C;function N(ce,pe){const oe={...ce||{},...pe||{}};return Object.keys(oe).filter($e=>{const ie=oe[$e];return typeof ie=="boolean"&&ie})}e.$YJ=N;class W{constructor(pe,oe){this.c=null,this.a={...pe.excludePattern||{},...oe.excludePattern||{}},this.b=M.$Oj(this.a);let $e=pe.includePattern;oe.includePattern&&($e?$e={...$e,...oe.includePattern}:$e=oe.includePattern),$e&&(this.c=M.$Oj($e))}matchesExcludesSync(pe,oe,$e){return!!(this.b&&this.b(pe,oe,$e))}includedInQuerySync(pe,oe,$e){return!(this.b&&this.b(pe,oe,$e)||this.c&&!this.c(pe,oe,$e))}includedInQuery(pe,oe,$e){const ie=this.b(pe,oe,$e),x=()=>this.c?!!this.c(pe,oe,$e):!0;return(0,D.$Tg)(ie)?ie.then(V=>V?!1:x()):x()}hasSiblingExcludeClauses(){return se(this.a)}}e.$ZJ=W;function se(ce){for(const pe in ce)if(typeof ce[pe]!="boolean")return!0;return!1}function le(ce){if(!ce)return;let pe;return oe=>(pe||(pe=(ce()||Promise.resolve([])).then($e=>$e?De($e):{})),pe.then($e=>!!$e[oe]))}e.$1J=le;function Ee(ce){if(!ce)return;let pe;return oe=>{if(!pe){const $e=ce();pe=$e?De($e):{}}return!!pe[oe]}}e.$2J=Ee;function De(ce){const pe={};for(const oe of ce)pe[oe]=!0;return pe}}),define(Re[36],Ae([1,0,18,11,21,5,6,51,12,122,25,14,2,168,4,13,187,48,43,27,17,8,7,58,44,3,52]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r,c,s,i,o,a,u,t,f,n,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=e.$ygc=void 0;function d(G,q,U){return new A.$xg(C=>v(C,U)).isEqual(G,q)}function b(G,q,U){return d(G.uri,q.uri,U)?0:(0,D.$6e)(G.uri.toString(),q.uri.toString())}function P(G,q,U){return G.index!==q.index?G.index<q.index?-1:1:d(G.uri,q.uri,U)?(0,D.$6e)(G.name,q.name):(0,D.$6e)(G.uri.toString(),q.uri.toString())}function g(G,q,U,C){const N=G.slice(0).sort((se,le)=>U(se,le,C)),W=q.slice(0).sort((se,le)=>U(se,le,C));return(0,S.$Eb)(N,W,(se,le)=>U(se,le,C))}function v(G,q){const U=q.getCapabilities(G.scheme);return!(U&&U&1024)}class k extends s.$oi{static toExtHostWorkspace(q,U,C,N){if(!q)return{workspace:null,added:[],removed:[]};const{id:W,name:se,folders:le,configuration:Ee,transient:De,isUntitled:ce}=q,pe=[],oe=U;U?le.forEach((V,ne)=>{const Ie=l.URI.revive(V.uri),Me=k.o(C||U,Ie,N);Me?(Me.name=V.name,Me.index=V.index,pe.push(Me)):pe.push({uri:Ie,name:V.name,index:ne})}):pe.push(...le.map(({uri:V,name:ne,index:Ie})=>({uri:l.URI.revive(V),name:ne,index:Ie}))),pe.sort((V,ne)=>V.index<ne.index?-1:1);const $e=new k(W,se,pe,!!De,Ee?l.URI.revive(Ee):null,!!ce,V=>v(V,N)),{added:ie,removed:x}=g(oe?oe.workspaceFolders:[],$e.workspaceFolders,b,N);return{workspace:$e,added:ie,removed:x}}static o(q,U,C){for(let N=0;N<q.folders.length;N++){const W=q.workspaceFolders[N];if(d(W.uri,U,C))return W}}constructor(q,U,C,N,W,se,le){super(q,C.map(Ee=>new s.$pi(Ee)),N,W,le),this.t=U,this.u=se,this.q=[],this.s=m.$bi.forUris(le),C.forEach(Ee=>{this.q.push(Ee),this.s.set(Ee.uri,Ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(q,U){return U&&this.s.get(q)&&(q=(0,A.$Hg)(q)),this.s.findSubstr(q)}resolveWorkspaceFolder(q){return this.s.get(q)}}let F=class{constructor(q,U,C,N,W){this.c=new R.$Wd,this.onDidChangeWorkspace=this.c.event,this.g=new R.$Wd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.$Yd,this.B=new Map,this.h=N,this.s=C,this.t=W,this.j=new E.$$l,this.k=new M.$7g,this.o=q.getProxy(w.$kL.MainThreadWorkspace),this.q=q.getProxy(w.$kL.MainThreadMessageService);const se=U.workspace;this.l=se?new k(se.id,se.name,[],!!se.transient,se.configuration?l.URI.revive(se.configuration):null,!!se.isUntitled,le=>v(le,C)):void 0}$initializeWorkspace(q,U){this.v=U,this.$acceptWorkspaceData(q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:h.Schemas.untitled,path:(0,A.$Fg)((0,A.$Hg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(q,U,C,...N){const W=[];if(Array.isArray(N)&&N.forEach(ce=>{l.URI.isUri(ce.uri)&&!W.some(pe=>d(pe.uri,ce.uri,this.s))&&W.push({uri:ce.uri,name:ce.name||(0,A.$Eg)(ce.uri)})}),this.n||[U,C].some(ce=>typeof ce!="number"||ce<0)||C===0&&W.length===0)return!1;const se=this.x?this.x.workspaceFolders:[];if(U+C>se.length)return!1;const le=se.slice(0);le.splice(U,C,...W.map(ce=>({uri:ce.uri,name:ce.name||(0,A.$Eg)(ce.uri),index:void 0})));for(let ce=0;ce<le.length;ce++){const pe=le[ce];if(le.some((oe,$e)=>$e!==ce&&d(pe.uri,oe.uri,this.s)))return!1}le.forEach((ce,pe)=>ce.index=pe);const{added:Ee,removed:De}=g(se,le,P,this.s);if(Ee.length===0&&De.length===0)return!1;if(this.o){const ce=q.displayName||q.name;this.o.$updateWorkspaceFolders(ce,U,C,W).then(void 0,pe=>{this.n=void 0;const oe={source:{identifier:q.identifier,label:q.displayName||q.name}};this.q.$showMessage(c.Severity.Error,(0,$.localize)(0,null,ce,pe.toString()),oe,[])})}return this.y(le),!0}getWorkspaceFolder(q,U){if(this.x)return this.x.getWorkspaceFolder(q,U)}async getWorkspaceFolder2(q,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(q,U)}async resolveWorkspaceFolder(q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(q)}getPath(){if(!this.x)return;const{folders:q}=this.x;if(q.length!==0)return q[0].uri.fsPath}getRelativePath(q,U){let C,N="";if(typeof q=="string"?(C=l.URI.file(q),N=q):typeof q<"u"&&(C=q,N=q.fsPath),!C)return N;const W=this.getWorkspaceFolder(C,!0);if(!W)return N;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let se=(0,A.$Kg)(W.uri,C);return U&&W.name&&(se=`${W.name}/${se}`),se}y(q){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(q){const{workspace:U,added:C,removed:N}=k.toExtHostWorkspace(q,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:C,removed:N}))}findFiles(q,U,C,N,W=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let se;if(U===null?se=!1:U&&(typeof U=="string"?se=U:se=U.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:le,folder:Ee}=O(u.GlobPattern.from(q));return this.o.$startFileSearch(le??null,Ee??null,se??null,C??null,W).then(De=>Array.isArray(De)?De.map(ce=>l.URI.revive(ce)):[])}async findTextInFiles(q,U,C,N,W=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const se=this.j.getNext(),le=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:Ee,folder:De}=O(u.GlobPattern.from(U.include)),ce=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,pe={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:le,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:Ee,excludePattern:ce},oe=!1;if(this.u[se]=$e=>{if(oe)return;const ie=l.URI.revive($e.resource);$e.results.forEach(x=>{const V=(0,y.$Eh)(x);(0,n.$HJ)(V)?C({uri:ie,preview:{text:V.preview.text,matches:(0,S.$2b)(V.preview.matches,ne=>new t.$oL(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,S.$2b)(V.ranges,ne=>new t.$oL(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):C({uri:ie,text:V.text,lineNumber:V.lineNumber})})},W.isCancellationRequested)return{};try{const $e=await this.o.$startTextSearch(q,De??null,pe,se,W);return delete this.u[se],$e||{}}catch($e){throw delete this.u[se],$e}}$handleTextSearchResult(q,U){this.u[U]?.(q)}async save(q){const U=await this.o.$save(q,{saveAs:!1});return l.URI.revive(U)}async saveAs(q){const U=await this.o.$save(q,{saveAs:!0});return l.URI.revive(U)}saveAll(q){return this.o.$saveAll(q)}resolveProxy(q){return this.o.$resolveProxy(q)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(q){return this.o.$requestWorkspaceTrust(q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(q,U){if(this.w.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.w.set(q,U);const C=this.t.transformOutgoingScheme(q),N=this.z++;return this.o.$registerEditSessionIdentityProvider(N,C),(0,L.$Rc)(()=>{this.w.delete(q),this.o.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(q,U){this.h.info("Getting edit session identifier for workspaceFolder",q);const C=await this.resolveWorkspaceFolder(l.URI.revive(q));if(!C){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",C);const N=this.w.get(C.uri.scheme);if(this.h.info(`Provider for scheme ${C.uri.scheme} is defined: `,!!N),!N)return;const W=await N.provideEditSessionIdentity(C,U);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(q,U,C,N){this.h.info("Getting edit session identifier for workspaceFolder",q);const W=await this.resolveWorkspaceFolder(l.URI.revive(q));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const se=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!se),!se)return;const le=await se.provideEditSessionIdentityMatch?.(U,C,N);if(this.h.info("Provider returned edit session identifier match result: ",le),!!le)return le}getOnWillCreateEditSessionIdentityEvent(q){return(U,C,N)=>{const W=function(le){U.call(C,le)};return W.extension=q,this.A.event(W,void 0,N)}}async $onWillCreateEditSessionIdentity(q,U,C){const N=await this.resolveWorkspaceFolder(l.URI.revive(q));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:N},U,async(W,se)=>{const le=Date.now();await Promise.resolve(W),Date.now()-le>C&&this.h.warn("SLOW edit session create-participant",se.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(q,U){if(this.B.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.B.set(q,U);const C=this.t.transformOutgoingScheme(q),N=this.z++;return this.o.$registerCanonicalUriProvider(N,C),(0,L.$Rc)(()=>{this.B.delete(q),this.o.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(q,U,C){const N=this.B.get(q.scheme);if(!N)return;const W=await N.provideCanonicalUri?.(l.URI.revive(q),U,C);if(W)return W}async $provideCanonicalUri(q,U,C){return this.provideCanonicalUri(l.URI.revive(q),{targetScheme:U},C)}};e.$ygc=F,e.$ygc=F=Ke([Ve(0,a.$vN),Ve(1,o.$LN),Ve(2,i.$egc),Ve(3,r.$pj),Ve(4,f.$wgc)],F),e.$zgc=(0,p.$8h)("IExtHostWorkspace");function O(G){let q,U;return G&&(typeof G=="string"?q=G:(q=G.pattern,U=l.URI.revive(G.baseUri))),{includePattern:q,folder:U}}}),define(Re[37],Ae([1,0,26,5,36,3,7,189,55,16,11,4,17,13,2]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=e.$Bgc=e.$Agc=void 0;function r(f,n){if(n){const w=n.split(".");let y=f;for(let d=0;y&&d<w.length;d++)y=y[w[d]];return y}}function c(f){return f instanceof p.URI}function s(f){return f&&f.uri instanceof p.URI&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function o(f){return f&&f.uri instanceof p.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function a(f){if(c(f))return{resource:f};if(s(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(i(f))return{overrideIdentifier:f.languageId};if(o(f))return{resource:f.uri};if(f===null)return{resource:null}}let u=class{constructor(n,w,y){this.a=n.getProxy(R.$kL.MainThreadConfiguration),this.c=w,this.b=y,this.d=new A.$7g,this.e=null}getConfigProvider(){return this.d.wait().then(n=>this.e)}$initializeConfiguration(n){this.e=new t(this.a,this.c,n,this.b),this.d.open()}$acceptConfigurationChanged(n,w){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(n,w))}};e.$Agc=u,e.$Agc=u=Ke([Ve(0,l.$vN),Ve(1,I.$zgc),Ve(2,$.$pj)],u);class t{constructor(n,w,y,d){this.a=new M.$Wd,this.b=n,this.f=d,this.c=w,this.e=m.$9n.parse(y),this.d=this.k(y.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(n,w){const y={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$9n.parse(n),this.d=this.k(n.configurationScopes),this.a.fire(this.j(w,y))}getConfiguration(n,w,y){const d=a(w)||{},b=this.g(n?r(this.e.getValue(void 0,d,this.c.workspace),n):this.e.getValue(void 0,d,this.c.workspace));n&&this.h(n,d,y?.identifier);function P(v){if(v==null)return null;if(typeof v=="boolean")return v?2:5;switch(v){case L.ConfigurationTarget.Global:return 2;case L.ConfigurationTarget.Workspace:return 5;case L.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(v){return typeof r(b,v)<"u"},get:(v,k)=>{this.h(n?`${n}.${v}`:v,d,y?.identifier);let F=r(b,v);if(typeof F>"u")F=k;else{let O;const G=(q,U)=>{if((0,E.$Lf)(q)){let C;const N=()=>{O=O||(0,S.$yn)(b),C=C||r(O,U)};return new Proxy(q,{get:(W,se)=>{if(typeof se=="string"&&se.toLowerCase()==="tojson")return N(),()=>C;if(O)return C=C||r(O,U),C[se];const le=W[se];return typeof se=="string"?G(le,`${U}.${se}`):le},set:(W,se,le)=>(N(),C&&(C[se]=le),!0),deleteProperty:(W,se)=>(N(),C&&delete C[se],!0),defineProperty:(W,se,le)=>(N(),C&&Object.defineProperty(C,se,le),!0)})}return Array.isArray(q)?(0,S.$yn)(q):q};F=G(F,v)}return F},update:(v,k,F,O)=>{v=n?`${n}.${v}`:v;const G=P(F);return k!==void 0?this.b.$updateConfigurationOption(G,v,k,d,O):this.b.$removeConfigurationOption(G,v,d,O)},inspect:v=>{v=n?`${n}.${v}`:v;const k=this.e.inspect(v,d,this.c.workspace);if(k)return{key:v,defaultValue:(0,S.$yn)(k.policy?.value??k.default?.value),globalValue:(0,S.$yn)(k.user?.value??k.application?.value),workspaceValue:(0,S.$yn)(k.workspace?.value),workspaceFolderValue:(0,S.$yn)(k.workspaceFolder?.value),defaultLanguageValue:(0,S.$yn)(k.default?.override),globalLanguageValue:(0,S.$yn)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,S.$yn)(k.workspace?.override),workspaceFolderLanguageValue:(0,S.$yn)(k.workspaceFolder?.override),languageIds:(0,S.$yn)(k.overrideIdentifiers)}}};return typeof b=="object"&&(0,S.$Bn)(g,b,!1),Object.freeze(g)}g(n){const w=y=>(0,E.$Lf)(y)?new Proxy(y,{get:(d,b)=>w(d[b]),set:(d,b,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(d,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(d,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return w(n)}h(n,w,y){const d=h.$Zn.test(n)?4:this.d.get(n),b=y?`[${y.value}] `:"";if(d===4){typeof w?.resource>"u"&&this.f.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){w?.resource&&this.f.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(n,w){const y=new m.$$n(n,w,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,b)=>y.affectsConfiguration(d,a(b))})}k(n){return n.reduce((w,y)=>(w.set(y[0],y[1]),w),new Map)}}e.$Bgc=t,e.$Cgc=(0,D.$8h)("IExtHostConfiguration")}),define(Re[115],Ae([1,0,2,11,5,3,7,36,66,37,21,65,17,27,4,12,20,13,78,221,15]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r,c,s,i,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=e.$5hc=e.$4hc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var u;(function(G){function q(C){if(C!=null)return C}G.from=q;function U(C){if(C!=null)return C}G.to=U})(u||(u={}));var t;(function(G){function q(C){if(C!=null)return C}G.from=q;function U(C){if(C!=null)return C}G.to=U})(t||(t={}));var f;(function(G){function q(C){if(C!=null)return C}G.from=q;function U(C){if(C!=null)return C}G.to=U})(f||(f={}));var n;(function(G){function q(N){if(N){const W=N;return W&&!!W.process}else return!1}G.is=q;function U(N){if(N==null)return;const W={process:N.process,args:N.args};return N.options&&(W.options=f.from(N.options)),W}G.from=U;function C(N){if(N!=null)return new L.$8L(N.process,N.args,N.options)}G.to=C})(n||(n={}));var w;(function(G){function q(C){if(C!=null)return C}G.from=q;function U(C){if(C!=null)return C}G.to=U})(w||(w={}));var y;(function(G){function q(N){if(N){const W=N;return W&&(!!W.commandLine||!!W.command)}else return!1}G.is=q;function U(N){if(N==null)return;const W={};return N.commandLine!==void 0?W.commandLine=N.commandLine:(W.command=N.command,W.args=N.args),N.options&&(W.options=w.from(N.options)),W}G.from=U;function C(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new L.$9L(N.commandLine,N.options):new L.$9L(N.command,N.args?N.args:[],N.options)}G.to=C})(y||(y={}));var d;(function(G){function q(N){if(N){const W=N;return W&&W.customExecution==="customExecution"}else return!1}G.is=q;function U(N){return{customExecution:"customExecution"}}G.from=U;function C(N,W){return W.get(N)}G.to=C})(d||(e.CustomExecutionDTO=d={}));var b;(function(G){function q(U,C){let N;return U.scope!==void 0&&typeof U.scope!="number"?N=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===L.TaskScope.Workspace&&C&&C.workspaceFile?N=C.workspaceFile:N=o.$DG),{id:U._id,workspaceFolder:N}}G.from=q})(b||(e.TaskHandleDTO=b={}));var P;(function(G){function q(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}G.from=q})(P||(P={}));var g;(function(G){function q(N,W){if(N==null)return[];const se=[];for(const le of N){const Ee=U(le,W);Ee&&se.push(Ee)}return se}G.fromMany=q;function U(N,W){if(N==null)return;let se;N.execution instanceof L.$8L?se=n.from(N.execution):N.execution instanceof L.$9L?se=y.from(N.execution):N.execution&&N.execution instanceof L.$0L&&(se=d.from(N.execution));const le=u.from(N.definition);let Ee;return N.scope?typeof N.scope=="number"?Ee=N.scope:Ee=N.scope.uri:Ee=L.TaskScope.Workspace,!le||!Ee?void 0:{_id:N._id,definition:le,name:N.name,source:{extensionId:W.identifier.value,label:N.source,scope:Ee},execution:se,isBackground:N.isBackground,group:P.from(N.group),presentationOptions:t.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}G.from=U;async function C(N,W,se){if(N==null)return;let le;n.is(N.execution)?le=n.to(N.execution):y.is(N.execution)?le=y.to(N.execution):d.is(N.execution)&&(le=d.to(N._id,se));const Ee=u.to(N.definition);let De;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?De=N.source.scope:De=await W.resolveWorkspaceFolder(S.URI.revive(N.source.scope)):De=L.TaskScope.Workspace),!Ee||!De)return;const ce=new L.$$L(Ee,De,N.name,N.source.label,le,N.problemMatchers);return N.isBackground!==void 0&&(ce.isBackground=N.isBackground),N.group!==void 0&&(ce.group=L.$7L.from(N.group._id),ce.group&&N.group.isDefault&&(ce.group=new L.$7L(ce.group.id,ce.group.label),N.group.isDefault===!0&&(ce.group.isDefault=N.group.isDefault))),N.presentationOptions&&(ce.presentationOptions=t.to(N.presentationOptions)),N._id&&(ce._id=N._id),N.detail&&(ce.detail=N.detail),ce}G.to=C})(g||(e.TaskDTO=g={}));var v;(function(G){function q(C){return C}G.from=q;function U(C){if(C)return Object.assign(Object.create(null),C)}G.to=U})(v||(v={}));class k{#e;constructor(q,U,C){this._id=U,this.a=C,this.#e=q}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}let F=class{constructor(q,U,C,N,W,se,le,Ee){this.q=new I.$Wd,this.r=new I.$Wd,this.s=new I.$Wd,this.u=new I.$Wd,this.a=q.getProxy(R.$kL.MainThreadTask),this.b=C,this.c=N,this.d=W,this.e=se,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=le,this.g=Ee,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(q,U,C){if(!C)return new L.$mL(()=>{});const N=this.x();return this.j.set(N,{type:U,provider:C,extension:q}),this.a.$registerTaskProvider(N,U),new L.$mL(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(q,U){this.a.$registerTaskSystem(q,U)}fetchTasks(q){return this.a.$fetchTasks(v.from(q)).then(async U=>{const C=[];for(const N of U){const W=await g.to(N,this.b,this.m);W&&C.push(W)}return C})}get taskExecutions(){const q=[];return this.k.forEach(U=>q.push(U)),q}terminateTask(q){if(!(q instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(q._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(q,U,C){const N=this.m.get(q.id);N&&(this.o.set(q.id,N),this.e.attachPtyToTerminal(U,await N.callback(C))),this.p=q.id,this.q.fire({execution:await this.z(q)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(q){if(!this.l.has(q.id))return;const U=await this.z(q);this.l.delete(q.id),this.k.delete(q.id),this.B(q),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(q){const U=await this.z(q.id);this.s.fire({execution:U,processId:q.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(q){const U=await this.z(q.id);this.u.fire({execution:U,exitCode:q.exitCode})}$provideTasks(q,U){const C=this.j.get(q);if(!C)return Promise.reject(new Error("no handler found"));const N=[],W=(0,M.$Zg)(()=>C.provider.provideTasks(A.CancellationToken.None)).then(se=>this.v(U,N,C,se));return new Promise(se=>{W.then(le=>{Promise.all(N).then(()=>{se(le)})})})}async $resolveTask(q,U){const C=this.j.get(q);if(!C)return Promise.reject(new Error("no handler found"));if(U.definition.type!==C.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${C.type}].`);const N=await g.to(U,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const W=await C.provider.resolveTask(N,A.CancellationToken.None);if(!W)return;this.A(W,C);const se=g.from(W,C.extension);if(!se)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(se.execution)&&await this.y(se,W,!0),await this.w(se)}x(){return this.h++}async y(q,U,C){const N=await this.a.$createTaskId(q);!C&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,U.execution)),this.m.set(N,U.execution)}async z(q,U){if(typeof q=="string"){const W=this.l.get(q);if(!W)throw new a.$bb("Unexpected: The specified task is missing an execution");return W}const C=this.l.get(q.id);if(C)return C;let N;return U?N=Promise.resolve(new k(this,q.id,U)):N=g.to(q.task,this.b,this.m).then(W=>{if(!W)throw new a.$bb("Unexpected: Task does not exist.");return new k(this,q.id,W)}),this.l.set(q.id,N),N.then(W=>(this.k.set(q.id,W),W))}A(q,U){q._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}B(q){this.o.get(q.id)&&this.o.delete(q.id),this.n.has(q.id)&&this.p!==q.id&&(this.m.delete(q.id),this.n.delete(q.id));const C=this.n.values();let N=C.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=C.next()}};e.$4hc=F,e.$4hc=F=Ke([Ve(0,l.$vN),Ve(1,$.$LN),Ve(2,m.$zgc),Ve(3,h.$GN),Ve(4,E.$Cgc),Ve(5,D.$1gc),Ve(6,s.$pj),Ve(7,i.$hgc)],F);let O=class extends F{constructor(q,U,C,N,W,se,le,Ee){super(q,U,C,N,W,se,le,Ee),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:c.$h(0)})}async executeTask(q,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const C=g.from(U,q);if(C===void 0)throw new Error("Task is not valid");if(d.is(C.execution))await this.y(C,U,!1);else throw new a.$_;const N=await this.z(await this.a.$getTaskExecution(C),U);return this.a.$executeTask(C).catch(W=>{throw new Error(W)}),N}v(q,U,C,N){const W=[];if(N)for(const se of N){if(this.A(se,C),!se.definition||!q[se.definition.type]){const Ee=se.source?se.source:"No task source";this.f.warn(`The task [${Ee}, ${se.name}] uses an undefined task type. The task will be ignored in the future.`)}const le=g.from(se,C.extension);le&&d.is(le.execution)?(W.push(le),U.push(this.y(le,se,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:C.extension}}async w(q){if(d.is(q.execution))return q;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(q,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,U,C){}};e.$5hc=O,e.$5hc=O=Ke([Ve(0,l.$vN),Ve(1,$.$LN),Ve(2,m.$zgc),Ve(3,h.$GN),Ve(4,E.$Cgc),Ve(5,D.$1gc),Ve(6,s.$pj),Ve(7,i.$hgc)],O),e.$6hc=(0,p.$8h)("IExtHostTask")}),define(Re[283],Ae([1,0,44,29]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.$9J=e.$8J=void 0;function I(L){return"cellResults"in L}e.$8J=I,e.$9J="rawCell#";function R(L,m){let h=-1;const E=[];let A=[];return L.forEach(l=>{l.range.startLineNumber!==h&&A.length>0&&(E.push([...A]),A=[]),A.push(l),h=l.range.endLineNumber}),A.length>0&&E.push([...A]),E.map(l=>{const $=[],p=l[0].range.startLineNumber,r=l[l.length-1].range.endLineNumber;for(let c=p;c<=r;c++)$.push(m.getLineContent(c));return new S.$LJ($.join(`
`)+`
`,l.map(c=>new M.$Ws(c.range.startLineNumber-1,c.range.startColumn-1,c.range.endLineNumber-1,c.range.endColumn-1)))})}e.$0J=R}),define(Re[284],Ae([1,0,162,23,5,6,28,14,16,2,42,74,3,31,8,7,50,259,109,26,12,211,283,281]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r,c,s,i,o,a,u,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=void 0;class n{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(y=>y.apiEditor)}constructor(y,d,b,P,g,v){this.q=b,this.r=P,this.s=g,this.t=v,this.f=new Map,this.g=new L.$Ac,this.h=new Map,this.j=new I.$Wd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$Wd,this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$Wd,this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$Wd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$agc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=y.getProxy(l.$kL.MainThreadNotebook),this.c=y.getProxy(l.$kL.MainThreadNotebookDocuments),this.d=y.getProxy(l.$kL.MainThreadNotebookEditors),this.i=d.converter,d.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const F=k.notebookEditor?.notebookUri,O=k.cell.handle,q=this.g.get(F)?.getCell(O);if(q)return q.apiCell}if(k&&k.$mid===14){const F=k.uri,O=this.g.get(F);if(O)return O.apiNotebook}return k}}),n.B(d)}getEditorById(y){const d=this.h.get(y);if(!d)throw new Error(`unknown text editor: ${y}. known editors: ${[...this.h.keys()]} `);return d}getIdByEditor(y){for(const[d,b]of this.h)if(b.apiEditor===y)return d}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(y,d){const b=this.g.get(y);if(!b&&!d)throw new Error(`NO notebook document for '${y}'`);return b}static u(y,d){if(!d)return;const b=d.filenamePattern.map(P=>p.NotebookExclusiveDocumentPattern.from(P)).filter(P=>P!==void 0);if(d.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:y.identifier,providerDisplayName:y.displayName||y.name,displayName:d.displayName,filenamePattern:b,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(y,d,b){const P=n.a++,g=typeof b.onDidChangeCellStatusBarItems=="function"?n.a++:void 0;this.f.set(P,b),this.b.$registerNotebookCellStatusBarItemProvider(P,g,d);let v;return g!==void 0&&(v=b.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(g))),new r.$mL(()=>{this.f.delete(P),this.b.$unregisterNotebookCellStatusBarItemProvider(P,g),v?.dispose()})}async createNotebookDocument(y){const d=await this.c.$tryCreateNotebook({viewType:y.viewType,content:y.content&&p.NotebookData.from(y.content)});return E.URI.revive(d)}async openNotebookDocument(y){const d=this.g.get(y);if(d)return d.apiNotebook;const b=await this.c.$tryOpenNotebook(y),P=this.g.get(E.URI.revive(b));return(0,h.$Uf)(P?.apiNotebook)}async showNotebookDocument(y,d){E.URI.isUri(y)&&(y=await this.openNotebookDocument(y));let b;typeof d=="object"?b={position:p.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(p.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:b={preserveFocus:!1};const P=await this.d.$tryShowNotebookDocument(y.uri,y.notebookType,b),g=P&&this.h.get(P)?.apiEditor;if(g)return g;throw P?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(y,d,b,P){const g=this.f.get(y),v=E.URI.revive(d),k=this.g.get(v);if(!k||!g)return;const F=k.getCellFromIndex(b);if(!F)return;const O=await g.provideCellStatusBarItems(F.apiCell,P);if(!O)return;const G=new R.$Sc,q=this.p.add([G]),C=(Array.isArray(O)?O:[O]).map(N=>p.NotebookStatusBarItem.from(N,this.i,G));return{cacheId:q,items:C}}$releaseNotebookCellStatusBarItems(y){this.p.delete(y)}registerNotebookSerializer(y,d,b,P,g){if((0,m.$Ke)(d))throw new Error("viewType cannot be empty or just whitespace");const v=this.w++;return this.x.set(v,{viewType:d,serializer:b,options:P}),this.b.$registerNotebookSerializer(v,{id:y.identifier,location:y.extensionLocation},d,p.NotebookDocumentContentOptions.from(P),n.u(y,g)),(0,R.$Rc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(y,d,b){const P=this.x.get(y);if(!P)throw new Error("NO serializer found");const g=await P.serializer.deserializeNotebook(d.buffer,b);return new c.$Vv(p.NotebookData.from(g))}async $notebookToData(y,d,b){const P=this.x.get(y);if(!P)throw new Error("NO serializer found");const g=await P.serializer.serializeNotebook(p.NotebookData.to(d.value),b);return M.$ke.wrap(g)}async $saveNotebook(y,d,b,P,g){const v=E.URI.revive(d),k=this.x.get(y);if(!k)throw new Error("NO serializer found");const F=this.g.get(v);if(!F)throw new Error("Document NOT found");if(F.versionId!==b)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new A.$Nk((0,S.localize)(0,null,this.z(v)),6);await this.y(v,P);const O={metadata:(0,o.$Gn)(F.apiNotebook.metadata,N=>!(k.options?.transientDocumentMetadata??{})[N]),cells:[]};for(const N of F.apiNotebook.getCells()){const W=new r.$MM(N.kind,N.document.getText(),N.document.languageId,N.mime,k.options?.transientOutputs?[]:[...N.outputs],N.metadata,N.executionSummary);W.metadata=(0,o.$Gn)(N.metadata,se=>!(k.options?.transientCellMetadata??{})[se]),O.cells.push(W)}const G=await k.serializer.serializeNotebook(O,g);await this.s.value.writeFile(v,G);const q=this.s.getFileSystemProviderExtUri(v.scheme),U=await this.s.value.stat(v);return{name:q.basename(v),isFile:(U.type&A.FileType.File)!==0,isDirectory:(U.type&A.FileType.Directory)!==0,isSymbolicLink:(U.type&A.FileType.SymbolicLink)!==0,mtime:U.mtime,ctime:U.ctime,size:U.size,readonly:!!((U.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((U.permissions??0)&A.FilePermission.Locked),etag:A.$Yk({mtime:U.mtime,size:U.size}),children:void 0}}async $searchInNotebooks(y,d,b,P,g){const v=this.x.get(y)?.serializer;if(!v)return{limitHit:!1,results:[]};const k=new L.$Bc;await(async(U,C,N)=>{await Promise.all(U.map(async W=>await Promise.all(W.filenamePatterns.map(se=>{const le={_reason:N._reason,folderQueries:N.folderQueries,includePattern:N.includePattern,excludePattern:N.excludePattern,maxResults:N.maxResults,type:1,filePattern:se};return this.t.doInternalFileSearchWithCustomCallback(le,C,Ee=>{Ee.forEach(De=>{k.has(De)||P.some(pe=>W.isFromSettings&&!pe.isFromSettings?!1:pe.filenamePatterns.some(oe=>(0,f.$Ndb)(oe,De)))||k.add(De)})})}))))})(b,g,d);const O=new L.$Ac;let G=!1;const q=Array.from(k).map(async U=>{const C=[];try{if(g.isCancellationRequested)return;if(d.maxResults&&[...O.values()].reduce((le,Ee)=>le+Ee.cellResults.length,0)>d.maxResults){G=!0;return}const N=[],W=this.g.get(U);if(W)W.apiNotebook.getCells().forEach(Ee=>N.push({input:Ee.document.getText(),outputs:Ee.outputs.flatMap(De=>De.items.map(ce=>ce.data.toString()))}));else{const le=await this.s.value.readFile(U),Ee=M.$ke.fromString(le.toString()),De=await v.deserializeNotebook(Ee.buffer,g);if(g.isCancellationRequested)return;p.NotebookData.from(De).cells.forEach(pe=>N.push({input:pe.source,outputs:pe.outputs.flatMap(oe=>oe.items.map($e=>$e.valueBytes.toString()))}))}if(g.isCancellationRequested)return;N.forEach((le,Ee)=>{const De=d.contentPattern.pattern,ce=new u.$PRb(le.input,void 0,le.outputs),pe=ce.findInInputs(De),oe=ce.findInOutputs(De),$e=oe.flatMap(ie=>(0,t.$0J)(ie.matches,ie.textBuffer)).map((ie,x)=>(ie.webviewIndex=x,ie));if(pe.length>0||oe.length>0){const ie={index:Ee,contentResults:(0,t.$0J)(pe,ce.inputTextBuffer),webviewResults:$e};C.push(ie)}});const se={resource:U,cellResults:C};O.set(U,se);return}catch{return}});return await Promise.all(q),{limitHit:G,results:[...O.values()]}}async y(y,d){const b=await this.s.value.stat(y);if(typeof d?.mtime=="number"&&typeof d.etag=="string"&&d.etag!==A.$Xk&&typeof b.mtime=="number"&&typeof b.size=="number"&&d.mtime<b.mtime&&d.etag!==A.$Yk({mtime:d.mtime,size:b.size}))throw new A.$Nk((0,S.localize)(1,null),3,d)}z(y){return y.scheme===a.Schemas.file?y.fsPath:y.toString()}A(y,d,b){if(this.h.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const P=new i.$whc(d,this.d,y,b.visibleRanges.map(p.NotebookRange.to),b.selections.map(p.NotebookRange.to),typeof b.viewColumn=="number"?p.ViewColumn.to(b.viewColumn):void 0);this.h.set(d,P)}$acceptDocumentAndEditorsDelta(y){if(y.value.removedDocuments)for(const b of y.value.removedDocuments){const P=E.URI.revive(b),g=this.g.get(P);g&&(g.dispose(),this.g.delete(P),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire(g.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===P.toString()&&this.h.delete(v.id)}if(y.value.addedDocuments){const b=[];for(const P of y.value.addedDocuments){const g=E.URI.revive(P.uri);if(this.g.has(g))throw new Error(`adding EXISTING notebook ${g} `);const v=new s.$vhc(this.c,this.q,this.r,g,P);b.push(...P.cells.map(k=>s.$uhc.asModelAddData(v.apiNotebook,k))),this.g.get(g)?.dispose(),this.g.set(g,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this.m.fire(v.apiNotebook)}}if(y.value.addedEditors)for(const b of y.value.addedEditors){if(this.h.has(b.id))return;const P=E.URI.revive(b.documentUri),g=this.g.get(P);g&&this.A(g,b.id,b)}const d=[];if(y.value.removedEditors)for(const b of y.value.removedEditors){const P=this.h.get(b);P&&(this.h.delete(b),this.k?.id===P.id&&(this.k=void 0),d.push(P))}if(y.value.visibleEditors){this.l=y.value.visibleEditors.map(P=>this.h.get(P)).filter(P=>!!P);const b=new Set;this.l.forEach(P=>b.add(P.id));for(const P of this.h.values()){const g=b.has(P.id);P._acceptVisibility(g)}this.l=[...this.h.values()].map(P=>P).filter(P=>P.visible),this.o.fire(this.visibleNotebookEditors)}y.value.newActiveEditor===null?this.k=void 0:y.value.newActiveEditor&&(this.h.get(y.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${y.value.newActiveEditor}`),this.k=this.h.get(y.value.newActiveEditor)),y.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(y){const d=$.$TN.String.with("notebookType","A notebook type"),b=new $.$VN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[d,new $.$TN("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>M.$ke.wrap(g))],new $.$UN("Notebook Data",g=>p.NotebookData.to(g.value))),P=new $.$VN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[d,new $.$TN("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new c.$Vv(p.NotebookData.from(g)))],new $.$UN("Bytes",g=>g.buffer));y.registerApiCommand(b),y.registerApiCommand(P)}}e.$Fhc=n}),define(Re[285],Ae([1,0,19,21,41,34,25,63,44]),function(me,e,S,M,I,R,L,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=void 0;class E{constructor(l,$,p){this.k=l,this.l=$,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&R.$Oj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&R.$Oj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const $=this.k.folderQueries||[];return new Promise((p,r)=>{const c=s=>{this.f++,l(s)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const i=s.toString(),o=S.$nc(i);this.j&&this.j(i,o)||this.v(c,{base:s,basename:o})}),Promise.all($.map(s=>this.p(s,c))).then(s=>{p({limitHit:this.e,stats:s[0]||void 0})},s=>{r(new Error((0,I.$Si)(s)))})})}async p(l,$){const p=new M.$7d,r=this.q(l),c=this.r(),s=new h.$ZJ(this.k,l),i=!s.hasSiblingExcludeClauses();let o;try{this.h.add(p),o=m.$Sd.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,p.token),u=o.elapsed(),t=m.$Sd.create();return this.g&&!this.e||(a&&a.forEach(f=>{const n=S.$gc.relative(l.folder.path,f.path);if(i){const w=S.$nc(f.path);this.v($,{base:l.folder,relativePath:n,basename:w});return}this.s(c,l.folder,n,$)}),this.g&&!this.e)?null:(this.u(c,s,$),{providerTime:u,postProcessTime:t.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(l){const $=(0,h.$YJ)(this.k.includePattern,l.includePattern),p=(0,h.$YJ)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:p,includes:$,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},$,p,r){if(p===this.a){const s=S.$nc(this.a);this.v(r,{base:$,relativePath:this.a,basename:s})}function c(s){const i=S.$nc(s),o=S.$mc(s);let a=l[o];a||(a=l[o]=[],c(o)),a.push({base:$,relativePath:s,basename:i})}c(p)}u({rootEntries:l,pathToEntries:$},p,r){const c=this,s=this.a;function i(o){const a=(0,h.$2J)(()=>o.map(u=>u.basename));for(let u=0,t=o.length;u<t;u++){const f=o[u],{relativePath:n,basename:w}=f;if(p.matchesExcludesSync(n,w,s!==w?a:void 0))continue;const y=$[n];if(y)i(y);else{if(n===s)continue;c.v(r,f)}if(c.e)break}}i(l)}v(l,$){(!this.b||$.relativePath&&this.b($.relativePath,$.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l($))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,$,p,r){const c=this.c(l.cacheKey),s=new E(l,$,c&&c.token);let i=0;const o=a=>{i+=a.length,p(a.map(u=>this.d(u)))};return this.e(s,A.a,o,r).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:a.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new M.$7d),this.b.get(l)}d(l){return l.relativePath?{resource:L.$Ig(l.base,l.relativePath)}:{resource:l.base}}e(l,$,p,r){const c=r.onCancellationRequested(()=>{l.cancel()}),s=o=>{o&&(i.push(o),$>0&&i.length>=$&&(p(i),i=[]))};let i=[];return l.search(s).then(o=>(i.length&&p(i),c.dispose(),o),o=>(i.length&&p(i),c.dispose(),Promise.reject(o)))}}e.$xhc=A}),define(Re[286],Ae([1,0,18,254,34,94,28,12,19,25,14,16,2,93,179,47,13,48,104,282,44]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r,c,s,i,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2K=e.$1K=void 0;let u=class{constructor(v,k,F,O,G){this.a=v,this.b=k,this.c=F,this.d=O,this.e=G}text(v,k,F={}){v=this.f(v,F);const O=this.a.getValue(),G=k&&k.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(k?.map(s.$qi),F),type:2,contentPattern:v,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:O.search.usePCRE2||G||!1,beforeContext:F.beforeContext,afterContext:F.afterContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}f(v,k){const F=this.a.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const O={...v,wordSeparators:F.editor.wordSeparators};return this.j(v,k)&&(O.isCaseSensitive=!0),this.k(v)&&(O.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),O}file(v,k={}){return{...this.h(v,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}g(v,k){return v?(v=Array.isArray(v)?v.map(y):y(v),k?this.parseSearchPaths(v):{pattern:f(...Array.isArray(v)?v:[v])}):{}}h(v=[],k={}){const F=this.g(k.includePattern,k.expandPatterns),O=this.g(k.excludePattern,k.expandPatterns),G=v.length>1,q=(F.searchPaths&&F.searchPaths.length?F.searchPaths.map(N=>this.q(N,k,O)):v.map(N=>this.r(N,k,O,G))).filter(N=>!!N),U={_reason:k._reason,folderQueries:q,usingSearchPaths:!!(F.searchPaths&&F.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:O.pattern,includePattern:F.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const N=S.$Hb(S.$Rb(this.c.groups.map(le=>le.editors.map(Ee=>Ee.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const W=N.filter(le=>(0,a.$PJ)(U,le.fsPath)),se=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(se)),{...U,...se}}const C=k.extraFileResources&&k.extraFileResources.filter(N=>(0,a.$PJ)(U,N.fsPath));return U.extraFileResources=C&&C.length?C:void 0,U}i(v){const k=[],F=new L.$Ac,O={};let G=!1;return v.forEach(q=>{if(q.scheme===m.Schemas.walkThrough)return;if((0,E.$Mg)(q)){const C=this.b.getWorkspaceFolder(q)?.uri??q.with({path:h.$mc(q.fsPath)});let N=F.get(C);N||(G=!0,N={folder:C,includePattern:{}},k.push(N),F.set(C,N));const W=h.$lc(C.fsPath,q.fsPath);(0,D.$Uf)(N.includePattern)[W.replace(/\\/g,"/")]=!0}else q.fsPath&&(G=!0,O[q.fsPath]=!0)}),{folderQueries:k,includePattern:O,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}j(v,k){if(k.isSmartCase){if(v.isRegExp){if(A.$Af(v.pattern,!0))return!0}else if(A.$Af(v.pattern))return!0}return!!v.isCaseSensitive}k(v){return v.isMultiline||v.isRegExp&&(0,$.$6B)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const k=se=>h.$ic(se)||/^\.\.?([\/\\]|$)/.test(se),O=(Array.isArray(v)?v:n(v)).map(se=>{const le=this.e.resolvedUserHome;return le?(0,R.$1v)(se,le.scheme===m.Schemas.file?le.fsPath:le.path):se}),G=M.$K(O,se=>k(se)?"searchPaths":"exprSegments"),q=(G.exprSegments||[]).map(se=>A.$Ve(se,"/")).map(se=>A.$Ve(se,"\\")).map(se=>(se[0]==="."&&(se="*"+se),w(se))),U={},C=this.m(G.searchPaths||[]);C&&C.length&&(U.searchPaths=C);const N=S.$Rb(q),W=f(...N);return W&&(U.pattern=W),U}l(v,k){return k.disregardExcludeSettings?void 0:(0,a.$OJ)(v,!k.disregardSearchExcludeSettings)}m(v){if(!v||!v.length)return[];const k=v.flatMap(O=>{let{pathPortion:G,globPortion:q}=t(O);return q&&(q=d(q)),this.n(G).flatMap(C=>this.o(C,q))}),F=new Map;return k.forEach(O=>{const G=O.searchPath.toString(),q=F.get(G);q?O.pattern&&(q.pattern=q.pattern||{},q.pattern[O.pattern]=!0):F.set(G,{searchPath:O.searchPath,pattern:O.pattern?f(O.pattern):void 0})}),Array.from(F.values())}n(v){if(h.$ic(v)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==m.Schemas.file?[{searchPath:k[0].uri.with({path:v})}]:[{searchPath:l.URI.file(h.$hc(v))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(v=y(v),v.startsWith("../")||v===".."){const O=h.$gc.resolve(k.path,v);return[{searchPath:k.with({path:O})}]}const F=d(v);return[{searchPath:k,pattern:F}]}else{if(v==="./"||v===".\\")return[];{const k=v.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(G=>{const q=k.match(new RegExp(`^${A.$Pe(G.name)}(?:/(.*)|$)`));return q?{match:q,folder:G}:null}).filter(D.$Rf);if(O.length)return O.map(G=>{const q=G.match[1];return{searchPath:G.folder.uri,pattern:q&&d(q)}});{const G=v.match(/\.[\/\\](.+)[\/\\]?/),q=G?G[1]:v,U=p.localize(0,null,q);throw new Error(U)}}}}o(v,k){const F=v.pattern&&k?`${v.pattern}/${k}`:v.pattern||k,O=[{searchPath:v.searchPath,pattern:F}];return F&&!F.endsWith("**")&&O.push({searchPath:v.searchPath,pattern:F+"/**"}),O}q(v,k,F){const O=this.r((0,s.$qi)(v.searchPath),k,F,!1);return O?{...O,includePattern:v.pattern}:null}r(v,k,F,O){let G;const q=l.URI.isUri(v)?v:v.uri;if(F.searchPaths){const se=F.searchPaths.filter(le=>(0,E.$Bg)(le.searchPath,q))[0];if(se&&!se.pattern)return null;se&&(G=se.pattern)}const U=this.a.getValue({resource:q}),N={...this.l(U,k)||{},...G||{}},W=l.URI.isUri(v)?(0,E.$Fg)(v):v.name;return{folder:q,folderName:O?W:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!U.search.followSymlinks}}};e.$1K=u,e.$1K=u=Ke([Ve(0,r.$Bi),Ve(1,s.$ei),Ve(2,i.$aD),Ve(3,c.$pj),Ve(4,o.$YK)],u);function t(g){const v=g.match(/[\*\{\}\(\)\[\]\?]/);if(v){const k=v.index,F=g.substr(0,k).match(/[/|\\][^/\\]*$/);if(F){let O=g.substr(0,F.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:g.substr((F.index||0)+1)}}}return{pathPortion:g}}function f(...g){return g.length?g.reduce((v,k)=>(v[k]=!0,v),Object.create(null)):void 0}function n(g){return I.$Mj(g,",").map(v=>v.trim()).filter(v=>!!v.length)}function w(g){return[`**/${g}/**`,`**/${g}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function y(g){return g.replace(/\\/g,"/")}function d(g){return y(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function b(g){return g.replace(/([?*[\]])/g,"[$1]")}function P(g,v){g=S.$Mb(g,O=>O.toString());const k=[],F=v.getWorkspace();return g&&g.forEach(O=>{let G;if(v.getWorkbenchState()===2)G=(0,E.$Kg)(F.folders[0].uri,O),G&&G!=="."&&(G="./"+G);else{const q=v.getWorkspaceFolder(O);if(q){const U=q.name;if(F.folders.filter(N=>N.name===U).length===1){const N=(0,E.$Kg)(q.uri,O);N===""?G=`./${q.name}`:G=`./${q.name}/${N}`}else G=O.fsPath}}G&&k.push(b(G))}),k}e.$2K=P}),define(Re[287],Ae([1,0,25,2,21,15,4,286,44,48,11]),function(me,e,S,M,I,R,L,m,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$otb=e.$ntb=void 0;const D=7e3;function l(c,s){const i=s.activationEvents;if(!i)return Promise.resolve(void 0);const o=[],a=[];for(const y of i)if(/^workspaceContains:/.test(y)){const d=y.substr(18);d.indexOf("*")>=0||d.indexOf("?")>=0||c.forceUsingSearch?a.push(d):o.push(d)}if(o.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:u,resolve:t}=(0,A.$1g)(),f=y=>t({activationEvent:y}),n=Promise.all(o.map(y=>$(c,y,f))).then(()=>{}),w=p(c,s.identifier,a,f);return Promise.all([n,w]).then(()=>{t(void 0)}),u}e.$ntb=l;async function $(c,s,i){for(const o of c.folders)if(await c.exists(S.$Ig(M.URI.revive(o),s))){i(`workspaceContains:${s}`);return}}async function p(c,s,i,o){if(i.length===0)return Promise.resolve(void 0);const a=new I.$7d,u=c.checkExists(c.folders,i,a.token),t=setTimeout(async()=>{a.cancel(),c.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},D);let f=!1;try{f=await u}catch(n){R.$4(n)||R.$1(n)}a.dispose(),clearTimeout(t),f&&o(`workspaceContains:${i.join(",")}`)}function r(c,s,i,o){const a=c.get(L.$7h),u=c.get(h.$GJ),f=a.createInstance(m.$1K).file(s.map(n=>(0,E.$qi)(M.URI.revive(n))),{_reason:"checkExists",includePattern:i,exists:!0});return u.fileSearch(f,o).then(n=>!!n.limitHit,n=>R.$4(n)?!1:Promise.reject(n))}e.$otb=r}),define(Re[38],Ae([1,0,159,19,87,25,11,6,51,2,13,3,37,217,82,36,24,105,15,22,23,200,7,100,4,27,84,17,71,85,65,5,287,81,202,12,79,63,20,80]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r,c,s,i,o,a,u,t,f,n,w,y,d,b,P,g,v,k,F,O,G,q,U,C,N){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=e.$chc=e.$bhc=e.$ahc=e.$_gc=void 0,e.$_gc=(0,n.$8h)("IHostUtils");let se=W=class extends m.$Tc{constructor(x,V,ne,Ie,Me,Le,we,ge,K,ee,he,fe){super(),this.X=fe,this.a=this.B(new v.$Wd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=V,this.g=ne,this.f=we,this.j=Ie,this.m=Me,this.s=Le,this.t=K,this.u=ee,this.w=he,this.y=this.g.getProxy(D.$kL.MainThreadWorkspace),this.z=this.g.getProxy(D.$kL.MainThreadTelemetry),this.C=this.g.getProxy(D.$kL.MainThreadExtensionService),this.D=new L.$7g,this.F=new L.$7g,this.G=new L.$7g,this.H=new L.$7g,this.I=new $e(this.f.extensions.activationEvents),this.L=new s.$f8b(this.I,this.f.extensions.allExtensions);const Ce=new o.$om(this.f.extensions.myExtensions);this.J=new s.$f8b(this.I,pe(this.L,Ce)),C.$t&&(this.s.info(`Creating extension host with the following global extensions: ${De(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${De(this.J)}`)),this.M=new p.$Wgc(this.g,this.s),this.N=new F.$5gc(this.g),this.O=ge,this.h=x.createChild(new b.$6h([p.$Xgc,this.M],[F.$6gc,this.N])),this.P=this.B(new $.$Vgc(this.J,this.L,{onExtensionActivationError:(de,ye,T)=>{this.C.$onExtensionActivationError(de,i.$3(ye),T)},actualActivateExtension:async(de,ye)=>{if(s.$f8b.isHostExtension(de,this.J,this.L))return await this.C.$activateExtension(de,ye),new $.$Ugc;const T=this.J.getExtensionDescription(de);return this.db(T,ye)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(x){i.$1(x)}}async Y(){this.O.onWillDeactivateAll();let x=[];try{x=this.J.getAllExtensionDescriptions().map(Me=>Me.identifier).filter(Me=>this.isActivated(Me)).map(Me=>this.cb(Me))}catch{}await Promise.all(x)}terminate(x,V=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${x}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(Ie=>{this.s.error(Ie)}),this.g.dispose();const ne=this.Y();Promise.race([(0,L.$9g)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(x){return this.G.isOpen()?this.P.isActivated(x):!1}async getExtension(x){const V=await this.C.$getExtension(x);return V&&{...V,identifier:new o.$nm(V.identifier.value),extensionLocation:E.URI.revive(V.extensionLocation)}}Z(x,V){return this.P.activateByEvent(x,V)}$(x,V){return this.P.activateById(x,V)}activateByIdWithErrors(x,V){return this.$(x,V).then(()=>{const ne=this.P.getActivatedExtension(x);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(x=>this.J)}getExtensionExports(x){if(this.G.isOpen())return this.P.getActivatedExtension(x).exports;try{return this.P.getActivatedExtension(x).exports}catch{return null}}async ab(x){if(x.scheme===G.Schemas.file&&this.c.fsRealpath){const V=await this.c.fsRealpath(x.fsPath);return E.URI.file(V)}return x}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(x=>new oe(x))),this.Q}async bb(x){const V=h.$bi.forUris(ne=>R.$zg.ignorePathCasing(ne));return await Promise.all(x.map(async ne=>{if(this.ub(ne)){const Ie=await this.ab(ne.extensionLocation);V.set(Ie,ne)}})),V}cb(x){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(x))return V;const ne=this.P.getActivatedExtension(x);if(!ne)return V;try{typeof ne.module.deactivate=="function"&&(V=Promise.resolve(ne.module.deactivate()).then(void 0,Ie=>(this.s.error(Ie),Promise.resolve(void 0))))}catch(Ie){this.s.error(`An error occurred when deactivating the extension '${x.value}':`),this.s.error(Ie)}try{(0,m.$Oc)(ne.subscriptions)}catch(Ie){this.s.error(`An error occurred when deactivating the subscriptions for extension '${x.value}':`),this.s.error(Ie)}return V}async db(x,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(x.identifier):await this.C.$onWillActivateExtension(x.identifier),this.fb(x,V).then(ne=>{const Ie=ne.activationTimes;return this.C.$onDidActivateExtension(x.identifier,Ie.codeLoadingTime,Ie.activateCallTime,Ie.activateResolvedTime,V),this.eb(x,V,"success",Ie),ne},ne=>{throw this.eb(x,V,"failure"),ne})}eb(x,V,ne,Ie){const Me=Ee(x,V);this.z.$publicLog2("extensionActivationTimes",{...Me,...Ie||{},outcome:ne})}fb(x,V){const ne=Ee(x,V);this.z.$publicLog2("activatePlugin",ne);const Ie=this.ub(x);if(!Ie)return Promise.resolve(new $.$Tgc($.$Qgc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${x.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${x.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const Me=new $.$Rgc(V.startup);return Promise.all([this.vb(x,(0,R.$Ig)(x.extensionLocation,Ie),Me),this.gb(x)]).then(Le=>(I.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),W.hb(this.s,x.identifier,Le[0],Le[1],Me))).then(Le=>(I.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),Le))}gb(x){const V=new u.$Zgc(x,this.M),ne=new u.$Ygc(x.identifier.value,!1,this.M),Ie=new O.$7gc(x,this.N),Me=x.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Le=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([V.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const we=this;let ge,K;const ee=(0,c.$KF)(x,"ipc")?this.f.messagePorts?.get(o.$nm.toKey(x.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:ne,secrets:Ie,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(he){return M.$jc(x.extensionLocation.fsPath,he)},get storagePath(){return we.O.workspaceValue(x)?.fsPath},get globalStoragePath(){return we.O.globalValue(x).fsPath},get logPath(){return M.$jc(we.f.logsLocation.fsPath,x.identifier.value)},get logUri(){return E.URI.joinPath(we.f.logsLocation,x.identifier.value)},get storageUri(){return we.O.workspaceValue(x)},get globalStorageUri(){return we.O.globalValue(x)},get extensionMode(){return Me},get extension(){return ge===void 0&&(ge=new ce(we,x.identifier,x,Le,!1)),ge},get extensionRuntime(){return(0,c.$LF)(x,"extensionRuntime"),we.extensionRuntime},get environmentVariableCollection(){return we.u.getEnvironmentVariableCollection(x)},get messagePassingProtocol(){if(!K){if(!ee)return;const he=v.Event.buffer(v.Event.fromDOMEventEmitter(ee,"message",fe=>fe.data));ee.start(),K={onDidReceiveMessage:he,postMessage:ee.postMessage.bind(ee)}}return K}})})}static hb(x,V,ne,Ie,Me){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(x,V,ne,Ie,Me).then(Le=>new $.$Sgc(!1,null,Me.build(),ne,Le,Ie.subscriptions))}static ib(x,V,ne,Ie,Me){if(typeof ne.activate=="function")try{Me.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Le=typeof global=="object"?global:self,we=ne.activate.apply(Le,[Ie]);return Me.activateCallStop(),Me.activateResolveStart(),Promise.resolve(we).then(ge=>(Me.activateResolveStop(),ge))}catch(Le){return Promise.reject(Le)}else return Promise.resolve(ne)}jb(x,V){this.$(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:V}).then(void 0,ne=>{this.s.error(ne)})}kb(x,V=0){const Ie=Date.now();(0,C.$B)(()=>{for(let Me=V;Me<x.length;Me+=1){const Le=x[Me];for(const we of Le.activationEvents??[])if(we==="onStartupFinished")if(Date.now()-Ie>50){this.kb(x,Me);break}else this.jb(Le,we)}})}lb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(x=>{const V=x.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(V)this.kb(ne);else for(const Ie of ne)if(Ie.activationEvents)for(const Me of Ie.activationEvents)Me==="onStartupFinished"&&this.jb(Ie,Me)})}mb(){const x=this.Z("*",!0).then(void 0,Le=>{this.s.error(Le)});this.B(this.j.onDidChangeWorkspace(Le=>this.nb(Le.added)));const V=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(V),Ie=this.pb(),Me=Promise.all([Ie,x,ne]).then(()=>{});return Promise.race([Me,(0,L.$9g)(1e4)]).then(()=>{this.lb()}),Me}nb(x){return x.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.ob(x,V))).then(()=>{})}async ob(x,V){if(this.isActivated(V.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,Ie={logService:this.s,folders:x.map(Le=>Le.uri),forceUsingSearch:ne||!this.c.fsExists,exists:Le=>this.c.fsExists(Le.fsPath),checkExists:(Le,we,ge)=>this.y.$checkExists(Le,we,ge)},Me=await(0,k.$ntb)(Ie,V);if(Me)return this.$(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Me.activationEvent}).then(void 0,Le=>this.s.error(Le))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(x){throw console.error(x),x}}async qb(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:V}=this.f.environment;if(!x||!V)throw new Error(S.localize(0,null));const ne=await this.vb(null,V,new $.$Rgc(!1));if(!ne||typeof ne.run!="function")throw new Error(S.localize(1,null,V.toString()));return new Promise((Ie,Me)=>{const Le=(K,ee)=>{K?(C.$t&&this.s.error("Test runner called back with error",K),Me(K)):(C.$t&&(ee?this.s.info(`Test runner called back with ${ee} failures.`):this.s.info("Test runner called back with successful outcome.")),Ie(typeof ee=="number"&&ee>0?1:0))},we=(0,R.$wg)(V),ge=ne.run(we,Le);ge&&ge.then&&ge.then(()=>{C.$t&&this.s.info("Test runner finished successfully."),Ie(0)}).catch(K=>{C.$t&&this.s.error("Test runner finished with error",K),Me(K instanceof Error&&K.stack?K.stack:String(K))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$9g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(x,V){return this.R[x]=V,(0,m.$Rc)(()=>{delete this.R[x]})}async getRemoteExecServer(x){const{resolver:V}=await this.sb(x);return V?.resolveExecServer?.(x,{resolveAttempt:0})}async sb(x){const V=x.indexOf("+");if(V===-1)throw new t.$sL("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=x.substr(0,V);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(x,V){const ne=U.$Sd.create(!1),Ie=()=>`[resolveAuthority(${(0,f.$bl)(x)},${V})][${ne.elapsed()}ms] `,Me=J=>this.s.info(`${Ie()}${J}`),Le=J=>this.s.warn(`${Ie()}${J}`),we=(J,B=void 0)=>this.s.error(`${Ie()}${J}`,B),ge=J=>{if(J instanceof t.$sL)return{type:"error",error:{code:J._code,message:J._message,detail:J._detail}};throw J},K=async J=>{Me(`activating resolver for ${J}...`);const{resolver:B,authorityPrefix:Z}=await this.sb(J);if(!B)throw we(`no resolver for ${Z}`),new t.$sL(`No remote extension installed to resolve ${Z}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:B,authorityPrefix:Z,remoteAuthority:J}},ee=x.split(/@|%40/g).reverse();Me(`activating remote resolvers ${ee.join(" -> ")}`);let he;try{he=await Promise.all(ee.map(K)).catch(async J=>{if(!(J instanceof t.$sL)||J._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw J;return Le(`resolving nested authorities failed: ${J.message}`),[await K(x)]})}catch(J){return ge(J)}const fe=new L.$gh;fe.cancelAndSet(()=>Me("waiting..."),1e3);let Ce,de;for(const[J,{authorityPrefix:B,resolver:Z,remoteAuthority:_}]of he.entries())try{if(J===he.length-1)Me("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${B}`),Ce=await Z.resolve(_,{resolveAttempt:V,execServer:de}),I.mark(`code/extHost/didResolveAuthorityOK/${B}`),Me("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Z,t.$rL.isManagedResolvedAuthority(Ce)?Ce:void 0));else{if(Me(`invoking resolveExecServer() for ${_}`),I.mark(`code/extHost/willResolveExecServer/${B}`),de=await Z.resolveExecServer?.(_,{resolveAttempt:V,execServer:de}),!de)throw new t.$sL(`Exec server was not available for ${_}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${B}`)}}catch(ke){return I.mark(`code/extHost/didResolveAuthorityError/${B}`),we("returned an error",ke),fe.dispose(),ge(ke)}fe.dispose();const ye={environmentTunnels:Ce.environmentTunnels,features:Ce.tunnelFeatures?{elevation:Ce.tunnelFeatures.elevation,privacyOptions:Ce.tunnelFeatures.privacyOptions,protocol:Ce.tunnelFeatures.protocol===void 0?!0:Ce.tunnelFeatures.protocol}:void 0},T={extensionHostEnv:Ce.extensionHostEnv,isTrusted:Ce.isTrusted,authenticationSession:Ce.authenticationSessionForInitializingExtensions?{id:Ce.authenticationSessionForInitializingExtensions.id,providerId:Ce.authenticationSessionForInitializingExtensions.providerId}:void 0};Me(`returned ${t.$rL.isManagedResolvedAuthority(Ce)?"managed authority":`${Ce.host}:${Ce.port}`}`);let H;if(t.$rL.isManagedResolvedAuthority(Ce)){const J=V;this.X.setFactory(J,Ce.makeConnection),H={authority:x,connectTo:new f.$$k(J),connectionToken:Ce.connectionToken}}else H={authority:x,connectTo:new f.$_k(Ce.host,Ce.port),connectionToken:Ce.connectionToken};return{type:"ok",value:{authority:H,options:T,tunnelInformation:ye}}}async $getCanonicalURI(x,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,f.$bl)(x)})`);const{resolver:ne}=await this.sb(x);if(!ne)return null;const Ie=E.URI.revive(V);if(typeof ne.getCanonicalURI>"u")return Ie;const Me=await(0,L.$Zg)(()=>ne.getCanonicalURI(Ie));return Me||Ie}$startExtensionHost(x){x.toAdd.forEach(Ie=>Ie.extensionLocation=E.URI.revive(Ie.extensionLocation));const{globalRegistry:V,myExtensions:ne}=le(this.I,this.L,this.J,x);return this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$startExtensionHost: global extensions: ${De(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${De(this.J)}`)),this.rb()}$activateByEvent(x,V){return V===1?this.D.wait().then(ne=>this.Z(x,!1)):this.G.wait().then(ne=>this.Z(x,!1))}async $activate(x,V){return await this.G.wait(),this.J.getExtensionDescription(x)?(await this.$(x,V),!0):!1}async $deltaExtensions(x){x.toAdd.forEach(Le=>Le.extensionLocation=E.URI.revive(Le.extensionLocation));const{globalRegistry:V,myExtensions:ne}=le(this.I,this.L,this.J,x),Ie=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ie),this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$deltaExtensions: global extensions: ${De(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${De(this.J)}`)),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){const V=a.$ke.alloc(x),ne=Math.random()%256;for(let Ie=0;Ie<x;Ie++)V.writeUInt8(ne,Ie);return V}async $updateRemoteConnectionData(x){this.W=x,this.a.fire()}};e.$ahc=se,e.$ahc=se=W=Ke([Ve(0,n.$7h),Ve(1,e.$_gc),Ve(2,d.$vN),Ve(3,r.$zgc),Ve(4,l.$Cgc),Ve(5,A.$pj),Ve(6,w.$LN),Ve(7,y.$Fgc),Ve(8,P.$qzb),Ve(9,g.$1gc),Ve(10,q.$9gc),Ve(11,N.$0gc)],se);function le(ie,x,V,ne){ie.addActivationEvents(ne.addActivationEvents);const Ie=new s.$f8b(ie,x.getAllExtensionDescriptions());Ie.deltaExtensions(ne.toAdd,ne.toRemove);const Me=new o.$om(V.getAllExtensionDescriptions().map(we=>we.identifier));for(const we of ne.myToRemove)Me.delete(we);for(const we of ne.myToAdd)Me.add(we);const Le=pe(Ie,Me);return{globalRegistry:Ie,myExtensions:Le}}function Ee(ie,x){return{id:ie.identifier.value,name:ie.name,extensionVersion:ie.version,publisherDisplayName:ie.publisher,activationEvents:ie.activationEvents?ie.activationEvents.join(","):null,isBuiltin:ie.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}function De(ie){return ie.getAllExtensionDescriptions().map(x=>x.identifier.value).join(",")}e.$bhc=(0,n.$8h)("IExtHostExtensionService");class ce{#e;#t;#i;constructor(x,V,ne,Ie,Me){this.#e=x,this.#t=V,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=M.$hc((0,R.$wg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Ie,this.isFromDifferentExtensionHost=Me}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$chc=ce;function pe(ie,x){return ie.getAllExtensionDescriptions().filter(V=>x.has(V.identifier))}class oe{constructor(x){this.a=x}setSearchTree(x){this.a=x}findSubstr(x){return this.a.findSubstr(x)}forEach(x){return this.a.forEach(x)}}e.$dhc=oe;class $e{constructor(x){this.a=new o.$pm,this.addActivationEvents(x)}readActivationEvents(x){return this.a.get(x.identifier)??[]}addActivationEvents(x){for(const V of Object.keys(x))this.a.set(V,x[V])}}}),define(Re[288],Ae([1,0,87,2,3,37,24,22,17,27,4,38,13,14]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=void 0;let r=class{constructor(a,u,t,f,n,w,y){this.c=a,this.d=u,this.e=t,this.f=f,this.g=n,this.h=w,this.i=y,this.a=new Map,this.b=[]}async install(){this.j(),S.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const u=await this.g.getExtensionPathIndex();this.register(new s(this.c,u,this.d,a,this.i)),this.register(this.e.createInstance(c)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,u,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const u of a.nodeModuleName)this.a.set(u,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(u=>a.alternativeModuleName(u))}};e.$lic=r,e.$lic=r=Ke([Ve(2,A.$7h),Ve(3,R.$Cgc),Ve(4,D.$bhc),Ve(5,E.$LN),Ve(6,l.$pj)],r);let c=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&p.a.size){const u=(0,$.$Pe)(this.c(a.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${u}/${n}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const u=this.b.exec(this.c(a));if(!u)return;const[,t,f,n]=u,w=p.a.get(f);if(w!==void 0)return console.warn(`${f} as been renamed to ${w}, please update your imports`),t+w+n}c(a){return a.replace(/\\/g,"/")}};c=p=Ke([Ve(0,E.$LN)],c);class s{constructor(a,u,t,f,n){this.c=a,this.d=u,this.e=t,this.f=f,this.g=n,this.nodeModuleName="vscode",this.a=new m.$pm}load(a,u){const t=this.d.findSubstr(u);if(t){let f=this.a.get(t.identifier);return f||(f=this.c(t,this.e,this.f),this.a.set(t.identifier,f)),f}if(!this.b){let f="";this.d.forEach((n,w)=>f+=`	${w} -> ${n.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${u}. These are the extension path mappings: 
${f}`),this.b=this.c(L.$FF,this.e,this.f)}return this.b}}let i=class{constructor(a,u,t){this.e=a,this.f=u,this.nodeModuleName=["open","opn"],this.d=t.getProxy(I.$kL.MainThreadTelemetry);const f=t.getProxy(I.$kL.MainThreadWindow);this.c=(n,w)=>{const y=M.URI.parse(n);return w?this.g(n,w):y.scheme==="http"||y.scheme==="https"?f.$openUri(y,n,{allowTunneling:!0}):y.scheme==="mailto"||y.scheme===this.f?f.$openUri(y,n,{}):this.g(n,w)}}load(a,u,t){const f=this.e.findSubstr(u);return f&&(this.a=f.identifier.value,this.h()),this.b=t(a),this.c}g(a,u){return this.i(),this.b(a,u)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Ke([Ve(2,h.$vN)],i)}),define(Re[116],Ae([1,0,39,6,19,73,4,66,64,38,7,36,214,37]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=e.$ehc=void 0,e.$ehc=(0,L.$8h)("IExtHostVariableResolverProvider");class p extends l.$wO{constructor(s,i,o,a,u,t,f){function n(){if(o){const w=o.activeEditor();if(w)return w.document.uri;const y=a.tabGroups.all.find(d=>d.isActive)?.activeTab;if(y!==void 0){if(y.input instanceof A.$7M||y.input instanceof A.$_M)return y.input.modified;if(y.input instanceof A.$6M||y.input instanceof A.$$M||y.input instanceof A.$9M)return y.input.uri}}}super({getFolderUri:w=>{const y=t.folders.filter(d=>d.name===w);if(y&&y.length>0)return y[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(w,y)=>u.getConfiguration(void 0,w).get(y),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const w=n();if(w)return I.$hc(w.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const w=n();if(w){const y=i.getWorkspaceFolder(w);if(y)return I.$hc(y.uri.fsPath)}}},getSelectedText:()=>{if(o){const w=o.activeEditor();if(w&&!w.selection.isEmpty)return w.document.getText(w.selection)}},getLineNumber:()=>{if(o){const w=o.activeEditor();if(w)return String(w.selection.end.line+1)}},getExtension:w=>s.getExtension(w)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(R.env))}}let r=class extends M.$Tc{constructor(s,i,o,a,u){super(),this.b=s,this.c=i,this.g=o,this.h=a,this.j=u,this.a=new S.$V(async()=>{const t=await this.h.getConfigProvider(),n={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async w=>{n.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,t,n,this.m())})}getResolver(){return this.a.value}m(){}};e.$fhc=r,e.$fhc=r=Ke([Ve(0,E.$bhc),Ve(1,D.$zgc),Ve(2,m.$GN),Ve(3,$.$Cgc),Ve(4,h.$Ogc)],r)}),define(Re[117],Ae([1,0,11,5,2,22,4,3,64,38,17,7,36,206,208,37,116,6,40,31]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r,c,s,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=e.$jhc=e.$ihc=e.$hhc=e.$ghc=void 0,e.$ghc=(0,L.$8h)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q?.api}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.w.value}constructor(d,b,P,g,v,k,F){this.I=b,this.J=P,this.K=g,this.L=v,this.M=k,this.N=F,this.l=new Map,this.E=new Map,this.G=new Map,this.H=0,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.C=new Map,this.D=new Map,this.m=new M.$Wd,this.n=new M.$Wd,this.o=new M.$Wd,this.u=new M.$Wd,this.k=d.getProxy(m.$kL.MainThreadDebugService),this.z=new M.$Wd,this.B=new M.$Wd,this.w=new t(this.k),this.y=new Map,this.J.getExtensionRegistry().then(O=>{O.onDidChange(G=>{this.O(O)}),this.O(O)})}asDebugSourceUri(d,b){const P=d;if(typeof P.sourceReference=="number"&&P.sourceReference>0){let g=`debug:${encodeURIComponent(P.path||"")}`,v="?";return b&&(g+=`${v}session=${encodeURIComponent(b.id)}`,v="&"),g+=`${v}ref=${P.sourceReference}`,I.URI.parse(g)}else{if(P.path)return I.URI.file(P.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}O(d){const b=[];for(const P of d.getAllExtensionDescriptions())if(P.contributes){const g=P.contributes.debuggers;if(g&&g.length>0)for(const v of g)(0,p.$gG)(v)&&b.push(v.type)}this.k.$registerDebugTypes(b)}get stackFrameFocus(){return this.A}get onDidChangeStackFrameFocus(){return this.B.event}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){const d=[];return this.y.forEach(b=>d.push(b)),d}async $resolveDebugVisualizer(d,b){const P=this.G.get(d);if(!P)throw new Error(`No debug visualizer found with id '${d}'`);let{v:g,provider:v}=P;if(g.visualization||(g=await v.resolveDebugVisualization?.(g,b)||g,P.v=g),!g.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${v}'`);return this.db(g.visualization)}async $executeDebugVisualizerCommand(d){const b=this.G.get(d);if(!b)throw new Error(`No debug visualizer found with id '${d}'`);const P=b.v.visualization;P&&"command"in P&&this.N.executeCommand(P.command,...P.arguments||[])}async $provideDebugVisualizers(d,b,P,g){const v=this.l.get(P.sessionId),k=this.cb(d,b),F=this.E.get(k);if(!v||!F)return[];const O=await F.provideDebugVisualization({session:v.api,variable:P.variable,containerId:P.containerId,frameId:P.frameId,threadId:P.threadId},g);return O?O.map(G=>{const q=++this.H;this.G.set(q,{v:G,provider:F});const U=G.iconPath?this.eb(G.iconPath):void 0;return{id:q,name:G.name,iconClass:U?.iconClass,iconPath:U?.iconPath,visualization:this.db(G.visualization)}}):[]}$disposeDebugVisualizers(d){for(const b of d)this.G.delete(b)}registerDebugVisualizationProvider(d,b,P){if(!d.contributes?.debugVisualizers?.some(k=>k.id===b))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${b})`);const g=R.$nm.toKey(d.identifier),v=this.cb(g,b);if(this.E.has(v))throw new Error(`A debug visualization provider with id '${b}' is already registered`);return this.E.set(v,P),this.k.$registerDebugVisualizer(g,b),(0,s.$Rc)(()=>{this.k.$unregisterDebugVisualizer(g,b),this.E.delete(b)})}addBreakpoints(d){const b=d.filter(v=>{const k=v.id;return this.y.has(k)?!1:(this.y.set(k,v),!0)});this.$(b,[],[]);const P=[],g=new Map;for(const v of b)if(v instanceof D.$mM){let k=g.get(v.location.uri.toString());k||(k={type:"sourceMulti",uri:v.location.uri,lines:[]},g.set(v.location.uri.toString(),k),P.push(k)),k.lines.push({id:v.id,enabled:v.enabled,condition:v.condition,hitCondition:v.hitCondition,logMessage:v.logMessage,line:v.location.range.start.line,character:v.location.range.start.character})}else v instanceof D.$nM&&P.push({type:"function",id:v.id,enabled:v.enabled,hitCondition:v.hitCondition,logMessage:v.logMessage,condition:v.condition,functionName:v.functionName});return this.k.$registerBreakpoints(P)}removeBreakpoints(d){const b=d.filter(k=>this.y.delete(k.id));this.$([],b,[]);const P=b.filter(k=>k instanceof D.$mM).map(k=>k.id),g=b.filter(k=>k instanceof D.$nM).map(k=>k.id),v=b.filter(k=>k instanceof D.$oM).map(k=>k.id);return this.k.$unregisterBreakpoints(P,g,v)}startDebugging(d,b,P){return this.k.$startDebugging(d?d.uri:void 0,b,{parentSessionID:P.parentSession?P.parentSession.id:void 0,lifecycleManagedByParent:P.lifecycleManagedByParent,repl:P.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:P.noDebug,compact:P.compact,suppressSaveBeforeStart:P.suppressSaveBeforeStart,suppressDebugStatusbar:P.suppressDebugStatusbar??P.debugUI?.simple,suppressDebugToolbar:P.suppressDebugToolbar??P.debugUI?.simple,suppressDebugView:P.suppressDebugView??P.debugUI?.simple})}stopDebugging(d){return this.k.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,b,P){if(!b)return new D.$mL(()=>{});const g=this.d++;return this.f.push({type:d,handle:g,provider:b}),this.k.$registerDebugConfigurationProvider(d,P,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,g),new D.$mL(()=>{this.f=this.f.filter(v=>v.provider!==b),this.k.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(d,b,P){if(!P)return new D.$mL(()=>{});if(!this.W(d,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.S(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this.g++;return this.h.push({type:b,handle:g,factory:P}),this.k.$registerDebugAdapterDescriptorFactory(b,g),new D.$mL(()=>{this.h=this.h.filter(v=>v.factory!==P),this.k.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(d,b){if(!b)return new D.$mL(()=>{});const P=this.i++;return this.j.push({type:d,handle:P,factory:b}),new D.$mL(()=>{this.j=this.j.filter(g=>g.factory!==b)})}async $runInTerminal(d,b){return Promise.resolve(void 0)}async $substituteVariables(d,b){let P;const g=await this.bb(d);return g&&(P={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.M.getResolver()).resolveAnyAsync(P,b)}P(d,b){if(d.type==="implementation")return new n(d.implementation)}Q(){}async $startDASession(d,b){const P=this,g=await this.ab(b);return this.Y(this.S(g.type),g).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const k=this.R(v),F=this.P(k,g);if(!F)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const O=F;return this.C.set(d,O),this.X(g).then(G=>(G&&this.D.set(d,G),O.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const U=q,C={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this.F||(this.F=this.Q());try{if(this.F){const N=await this.F.sign(U.arguments.value);C.body={signature:N},O.sendResponse(C)}else throw new Error("no signer")}catch(N){C.success=!1,C.message=N.message,O.sendResponse(C)}}else G&&G.onDidSendMessage&&G.onDidSendMessage(q),q=(0,p.$lG)(q,!0),P.k.$acceptDAMessage(d,q)}),O.onError(q=>{G&&G.onError&&G.onError(q),this.k.$acceptDAError(d,q.name,q.message,q.stack)}),O.onExit(q=>{G&&G.onExit&&G.onExit(q??void 0,void 0),this.k.$acceptDAExit(d,q??void 0,void 0)}),G&&G.onWillStartSession&&G.onWillStartSession(),O.startSession()))})}$sendDAMessage(d,b){b=(0,p.$kG)(b,!1);const P=this.D.get(d);P&&P.onWillReceiveMessage&&P.onWillReceiveMessage(b),this.C.get(d)?.sendMessage(b)}$stopDASession(d){const b=this.D.get(d);this.D.delete(d),b&&b.onWillStopSession&&b.onWillStopSession();const P=this.C.get(d);return this.C.delete(d),P?P.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const b=[],P=[],g=[];if(d.added)for(const v of d.added){const k=v.id;if(k&&!this.y.has(k)){let F;if(v.type==="function")F=new D.$nM(v.functionName,v.enabled,v.condition,v.hitCondition,v.logMessage);else if(v.type==="data")F=new D.$oM(v.label,v.dataId,v.canPersist,v.enabled,v.hitCondition,v.condition,v.logMessage);else{const O=I.URI.revive(v.uri);F=new D.$mM(new D.$yL(O,new D.$nL(v.line,v.character)),v.enabled,v.condition,v.hitCondition,v.logMessage)}(0,D.$kM)(F,k),this.y.set(k,F),b.push(F)}}if(d.removed)for(const v of d.removed){const k=this.y.get(v);k&&(this.y.delete(v),P.push(k))}if(d.changed){for(const v of d.changed)if(v.id){const k=this.y.get(v.id);if(k){if(k instanceof D.$nM&&v.type==="function"){const F=k;F.enabled=v.enabled,F.condition=v.condition,F.hitCondition=v.hitCondition,F.logMessage=v.logMessage,F.functionName=v.functionName}else if(k instanceof D.$mM&&v.type==="source"){const F=k;F.enabled=v.enabled,F.condition=v.condition,F.hitCondition=v.hitCondition,F.logMessage=v.logMessage,F.location=new D.$yL(I.URI.revive(v.uri),new D.$nL(v.line,v.character))}g.push(k)}}}this.$(b,P,g)}async $acceptStackFrameFocus(d){let b;const P=d.sessionId?await this.ab(d.sessionId):void 0;if(!P)throw new Error("no DebugSession found for debug focus context");d.kind==="thread"?b=new D.$uM(P.api,d.threadId):b=new D.$tM(P.api,d.threadId,d.frameId),this.A=b,this.B.fire(this.A)}$provideDebugConfigurations(d,b,P){return(0,S.$Zg)(async()=>{const g=this.V(d);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const v=await this.bb(b);return g.provideDebugConfigurations(v,P)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(d,b,P,g){return(0,S.$Zg)(async()=>{const v=this.V(d);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.bb(b);return v.resolveDebugConfiguration(k,P,g)})}$resolveDebugConfigurationWithSubstitutedVariables(d,b,P,g){return(0,S.$Zg)(async()=>{const v=this.V(d);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.bb(b);return v.resolveDebugConfigurationWithSubstitutedVariables(k,P,g)})}async $provideDebugAdapter(d,b){const P=this.U(d);if(!P)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.ab(b);return this.Y(P,g).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.R(v)})}async $acceptDebugSessionStarted(d){const b=await this.ab(d);this.m.fire(b.api)}async $acceptDebugSessionTerminated(d){const b=await this.ab(d);b&&(this.n.fire(b.api),this.l.delete(b.id))}async $acceptDebugSessionActiveChanged(d){this.q=d?await this.ab(d):void 0,this.o.fire(this.q?.api)}async $acceptDebugSessionNameChanged(d,b){(await this.ab(d))?._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(d,b){const g={session:(await this.ab(d)).api,event:b.event,body:b.body};this.u.fire(g)}R(d){if(d instanceof D.$pM)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof D.$qM)return{type:"server",port:d.port,host:d.host};if(d instanceof D.$rM)return{type:"pipeServer",path:d.path};if(d instanceof D.$sM)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}S(d){const b=this.h.filter(P=>P.type===d);if(b.length>0)return b[0].factory}U(d){const b=this.h.filter(P=>P.handle===d);if(b.length>0)return b[0].factory}V(d){const b=this.f.filter(P=>P.handle===d);if(b.length>0)return b[0].provider}W(d,b){if(d.contributes){const P=d.contributes.debuggers;if(P&&P.length>0){for(const g of P)if(g.label&&g.type&&g.type===b)return!0}}return!1}X(d){const P=d.configuration.type,g=this.j.filter(v=>v.type===P||v.type==="*").map(v=>(0,S.$Zg)(()=>v.factory.createDebugAdapterTracker(d.api)).then(k=>k,k=>null));return Promise.race([Promise.all(g).then(v=>{const k=v.filter(F=>!!F);if(k.length>0)return new f(k)}),new Promise(v=>setTimeout(()=>v(void 0),1e3))]).catch(v=>{})}async Y(d,b){const P=b.configuration.debugServer;if(typeof P=="number")return Promise.resolve(new D.$qM(P));if(d){const v=await this.J.getExtensionRegistry();return(0,S.$Zg)(()=>d.createDebugAdapterDescriptor(b.api,this.Z(b,v))).then(k=>{if(k)return k})}const g=await this.J.getExtensionRegistry();return Promise.resolve(this.Z(b,g))}Z(d,b){}$(d,b,P){(d.length>0||b.length>0||P.length>0)&&this.z.fire(Object.freeze({added:d,removed:b,changed:P}))}async ab(d){if(d)if(typeof d=="string"){const b=this.l.get(d);if(b)return b}else{let b=this.l.get(d.id);if(!b){const P=await this.bb(d.folderUri),g=d.parent?this.l.get(d.parent):void 0;b=new u(this.k,d.id,d.type,d.name,P,d.configuration,g?.api),this.l.set(b.id,b),this.k.$sessionCached(b.id)}return b}throw new Error("cannot find session")}bb(d){if(d){const b=I.URI.revive(d);return this.I.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}cb(d,b){return`${d}\0${b}`}db(d){if(d){if("title"in d&&"command"in d)return{type:0};throw new Error("Unsupported debug visualization type")}}eb(d){const b=this.fb(d);let P,g;return"id"in b?g=i.ThemeIcon.asClassName(b):P=b,{iconPath:P,iconClass:g}}fb(d){if(d instanceof D.$hM)return{id:d.id};const b=typeof d=="object"&&"dark"in d?d.dark:d,P=typeof d=="object"&&"light"in d?d.light:d;return{dark:typeof b=="string"?I.URI.file(b):b,light:typeof P=="string"?I.URI.file(P):P}}};e.$hhc=a,e.$hhc=a=Ke([Ve(0,A.$vN),Ve(1,l.$zgc),Ve(2,E.$bhc),Ve(3,r.$Cgc),Ve(4,h.$Ogc),Ve(5,c.$ehc),Ve(6,o.$RN)],a);class u{constructor(d,b,P,g,v,k,F){this.f=d,this.g=b,this.h=P,this.i=g,this.j=v,this.k=k,this.l=F}get api(){const d=this;return this.d??=Object.freeze({id:d.g,type:d.h,get name(){return d.i},set name(b){d.i=b,d.f.$setDebugSessionName(d.g,b)},parentSession:d.l,workspaceFolder:d.j,configuration:d.k,customRequest(b,P){return d.f.$customDebugAdapterRequest(d.g,b,P)},getDebugProtocolBreakpoint(b){return d.f.$getDebugProtocolBreakpoint(d.g,b.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(d){this.i=d}get configuration(){return this.k}}e.$ihc=u;class t{constructor(d){this.value=Object.freeze({append(b){d.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.$jhc=t;class f{constructor(d){this.d=d}onWillStartSession(){this.d.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.d.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.d.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(d):void 0)}onWillStopSession(){this.d.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.d.forEach(b=>b.onError?b.onError(d):void 0)}onExit(d,b){this.d.forEach(P=>P.onExit?P.onExit(d,b):void 0)}}class n extends $.$imb{constructor(d){super(),this.h=d,d.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.h.handleMessage(d)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let w=class extends a{constructor(d,b,P,g,v,k,F){super(d,b,P,g,v,k,F)}};e.$khc=w,e.$khc=w=Ke([Ve(0,A.$vN),Ve(1,l.$zgc),Ve(2,E.$bhc),Ve(3,r.$Cgc),Ve(4,h.$Ogc),Ve(5,c.$ehc),Ve(6,o.$RN)],w)}),define(Re[289],Ae([1,0,15,87,2,3,235,13,53,71,27,184,17,58,38,60]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=e.$mic=void 0;class c{static async installEarlyHandler(o){Error.stackTraceLimit=100;const a=o.get(m.$pj),t=o.get(l.$vN).getProxy(R.$kL.MainThreadErrors);S.setUnexpectedErrorHandler(f=>{a.error(f);const n=S.$3(f);t.$onUnexpectedError(n)})}static async installFullHandler(o){const a=o.get(m.$pj),u=o.get(l.$vN),t=o.get(p.$bhc),f=o.get(r.$PN),n=u.getProxy(R.$kL.MainThreadExtensionService),w=u.getProxy(R.$kL.MainThreadErrors),y=await t.getExtensionPathIndex(),d=new WeakMap;function b(v,k){if(d.has(v))return d.get(v).stack;let F="",O,G;for(const U of k)F+=`
	at ${U.toString()}`,G=U.getFileName(),!O&&G&&(O=y.findSubstr(I.URI.file(G)));const q=`${v.name||"Error"}: ${v.message||""}${F}`;return d.set(v,{extensionIdentifier:O?.identifier,stack:q}),q}const P=Symbol("prepareStackTrace wrapped");let g=b;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return g},set(v){if(v===b||!v||v[P]){g=v||b;return}g=function(k,F){return b(k,F),v.call(Error,k,F)},Object.assign(g,{[P]:!0})}}),S.setUnexpectedErrorHandler(v=>{a.error(v);const k=S.$3(v),F=d.get(v);if(!F?.extensionIdentifier){w.$onUnexpectedError(k);return}n.$onExtensionRuntimeError(F.extensionIdentifier,k);const O=f.onExtensionError(F.extensionIdentifier,v);a.trace("forwarded error to extension?",O,F)})}}e.$mic=c;class s{constructor(o,a,u,t,f){this.a=u,this.b=new L.$n8b(o,null,t),a=s.e(a,this.b);const n=new E.$6h(...(0,h.$2r)());n.set(A.$LN,{_serviceBrand:void 0,...a,messagePorts:f}),n.set(l.$vN,new l.$wN(this.b)),n.set($.$wgc,new $.$xgc(t)),n.set(p.$_gc,u);const w=new D.$Gq(n,!0);w.invokeFunction(c.installEarlyHandler),this.d=w.invokeFunction(y=>y.get(m.$pj)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=w.invokeFunction(y=>y.get(p.$bhc)),this.c.initialize(),w.invokeFunction(c.installFullHandler)}async asBrowserUri(o){const a=this.b.getProxy(R.$kL.MainThreadExtensionService);return I.URI.revive(await a.$asBrowserUri(o))}terminate(o){this.c.terminate(o)}static e(o,a){o.extensions.allExtensions.forEach(t=>{t.extensionLocation=I.URI.revive(a.transformIncomingURIs(t.extensionLocation))}),o.environment.appRoot=I.URI.revive(a.transformIncomingURIs(o.environment.appRoot));const u=o.environment.extensionDevelopmentLocationURI;return u&&(o.environment.extensionDevelopmentLocationURI=u.map(t=>I.URI.revive(a.transformIncomingURIs(t)))),o.environment.extensionTestsLocationURI=I.URI.revive(a.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=I.URI.revive(a.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=I.URI.revive(a.transformIncomingURIs(o.environment.workspaceStorageHome)),o.environment.extensionTelemetryLogResource=I.URI.revive(a.transformIncomingURIs(o.environment.extensionTelemetryLogResource)),o.nlsBaseUrl=I.URI.revive(a.transformIncomingURIs(o.nlsBaseUrl)),o.logsLocation=I.URI.revive(a.transformIncomingURIs(o.logsLocation)),o.workspace=a.transformIncomingURIs(o.workspace),o}}e.$nic=s}),define(Re[290],Ae([1,0,18,11,21,41,12,19,25,2,44]),function(me,e,S,M,I,R,L,m,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=e.$Ahc=e.$zhc=e.$yhc=void 0;class D{constructor(i,o,a,u){this.d=i,this.e=o,this.f=a,this.g=u,this.a=null,this.b=!1,this.c=0}search(i,o){const a=this.d.folderQueries||[],u=new I.$7d(o);return new Promise((t,f)=>{this.a=new $(i);let n=!1;const w=(y,d)=>{if(!n&&!this.b){const b=this.h(y);r(y)&&typeof this.d.maxResults=="number"&&this.c+b>this.d.maxResults&&(this.b=!0,n=!0,u.cancel(),y=this.j(y,this.d.maxResults-this.c));const P=this.h(y);this.c+=P,(P>0||!r(y))&&this.a.add(y,d)}};Promise.all(a.map((y,d)=>this.k(y,b=>w(b,d),u.token))).then(y=>{u.dispose(),this.a.flush();const d=y.some(b=>!!b&&!!b.limitHit);t({limitHit:this.b||d,messages:(0,S.$Rb)(y.map(b=>b?.message?Array.isArray(b.message)?b.message:[b.message]:[])),stats:{type:this.g}})},y=>{u.dispose();const d=(0,R.$Si)(y);f(new Error(d))})})}h(i){return r(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,o){const a=Array.isArray(i.ranges)?i.ranges:[i.ranges],u=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:a.slice(0,o),preview:{matches:u.slice(0,o),text:i.preview.text},uri:i.uri}}async k(i,o,a){const u=new A.$ZJ(this.d,i),t=[],f={report:y=>{if(!this.l(y))return;const d=i.folder.scheme===L.Schemas.file?(0,A.$1J)(()=>this.f.readdir(h.$Hg(y.uri))):void 0,b=h.$Kg(i.folder,y.uri);if(b){const P=u.includedInQuery(b,m.$nc(b),d);(0,M.$Tg)(P)?t.push(P.then(g=>{g&&o(y)})):P&&o(y)}}},n=this.n(i),w=await this.e.provideTextSearchResults(l(this.d.contentPattern),n,f,a);return t.length&&await Promise.all(t),w}l(i){if(r(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const o=(0,A.$YJ)(this.d.includePattern,i.includePattern),a=(0,A.$YJ)(this.d.excludePattern,i.excludePattern),u={folder:E.URI.from(i.folder),excludes:a,includes:o,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return u.usePCRE2=this.d.usePCRE2,u}}e.$yhc=D;function l(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class ${constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new c(512,o=>this.g(o))}add(i,o){this.d&&(this.b!==o||!h.$Bg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=o,this.d={resource:i.uri,results:[]}),this.d.results.push(p(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$zhc=$;function p(s){return r(s)?{preview:{matches:(0,S.$2b)(s.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:s.preview.text},ranges:(0,S.$2b)(s.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function r(s){return!!s.preview}e.$Ahc=r;class c{static{this.a=4e3}static{this.b=50}constructor(i,o){this.g=i,this.h=o,this.c=0,this.d=[],this.e=0}addItem(i,o){i&&this.j(i,o)}addItems(i,o){i&&this.k(i,o)}j(i,o){this.d.push(i),this.e+=o,this.l()}k(i,o){this.d=this.d.concat(i),this.e+=o,this.l()}l(){this.c<c.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},c.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Bhc=c}),define(Re[118],Ae([1,0,6,3,4,285,17,58,13,2,290]),function(me,e,S,M,I,R,L,m,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=e.$Dhc=e.$Chc=void 0,e.$Chc=(0,I.$8h)("IExtHostSearch");let D=class{constructor(r,c,s){this.k=r,this.l=c,this.n=s,this.c=this.k.getProxy(M.$kL.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.$xhc}o(r){return this.l.transformOutgoingScheme(r)}registerTextSearchProvider(r,c){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const s=this.d++;return this.e.set(s,c),this.c.$registerTextSearchProvider(s,this.o(r)),(0,S.$Rc)(()=>{this.g.delete(r),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(r,c){if(this.i.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.i.add(r);const s=this.d++;return this.h.set(s,c),this.c.$registerFileSearchProvider(s,this.o(r)),(0,S.$Rc)(()=>{this.i.delete(r),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(r,c,s,i){const o=l(s),a=this.h.get(r);if(a)return this.j.fileSearch(o,a,u=>{this.c.$handleFileMatch(r,c,u.map(t=>t.resource))},i);throw new Error("unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,c,s){return{messages:[]}}$clearCache(r){return this.j.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,c,s,i){const o=this.e.get(r);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${r}`);const a=l(s);return this.q(a,o).search(t=>this.c.$handleTextMatch(r,c,t),i)}$enableExtensionHostSearch(){}q(r,c){return new A.$yhc(r,c,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$Dhc=D,e.$Dhc=D=Ke([Ve(0,L.$vN),Ve(1,m.$wgc),Ve(2,h.$pj)],D);function l(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map($),extraFileResources:p.extraFileResources&&p.extraFileResources.map(r=>E.URI.revive(r))}}e.$Ehc=l;function $(p){return{...p,folder:E.URI.revive(p.folder)}}}),define(Re[291],Ae([1,0,21,15,5,6,12,32,2,146,142,130,92,22,42,13,56,57,197,3,238,269,78,239,245,223,246,247,248,224,212,31,249,37,250,117,107,251,226,240,252,253,66,64,241,38,255,62,256,43,27,270,271,242,227,257,258,79,80,229,284,260,201,261,272,262,112,230,263,264,265,17,266,118,81,267,231,268,82,84,115,60,65,273,274,243,275,276,85,8,7,232,58,233,61,277,278,106,36,207,77,24,114]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r,c,s,i,o,a,u,t,f,n,w,y,d,b,P,g,v,k,F,O,G,q,U,C,N,W,se,le,Ee,De,ce,pe,oe,$e,ie,x,V,ne,Ie,Me,Le,we,ge,K,ee,he,fe,Ce,de,ye,T,H,J,B,Z,_,ke,Ne,We,He,Ye,nt,it,et,st,ct,Ue,$t,Y,X,ve,Be,Qe,tt,ot,Fe,Wt,Mt,xt,Nt,Et,Yt,Ot,ii,Qt,Vt,Xe,Xt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hic=void 0;function _t(lt){const pt=lt.get(x.$LN),qt=lt.get(ie.$egc),ei=lt.get(oe.$Egc),kt=lt.get(ce.$bhc),dt=lt.get(ii.$zgc),Pt=lt.get(Ue.$PN),si=lt.get(F.$Cgc),Lt=lt.get(Mt.$wgc),qe=lt.get(ke.$vN),Tt=lt.get(et.$Xgc),zt=lt.get(st.$Fgc),ti=lt.get(r.$qj),ft=lt.get(r.$pj),Rt=lt.get(tt.$qzb),Ct=lt.get(t.$hgc),Ut=lt.get(Ot.$gic),Ht=lt.get(He.$6gc),jt=lt.get(Ee.$Ogc),It=lt.get(K.$0gc);qe.set(o.$lL.ExtHostFileSystemInfo,qt),qe.set(o.$lL.ExtHostLogLevelServiceShape,ti),qe.set(o.$lL.ExtHostWorkspace,dt),qe.set(o.$lL.ExtHostConfiguration,si),qe.set(o.$lL.ExtHostExtensionService,kt),qe.set(o.$lL.ExtHostStorage,Tt),qe.set(o.$lL.ExtHostTunnelService,Rt),qe.set(o.$lL.ExtHostWindow,Ut),qe.set(o.$lL.ExtHostSecretState,Ht),qe.set(o.$lL.ExtHostTelemetry,Pt),qe.set(o.$lL.ExtHostEditorTabs,jt),qe.set(o.$lL.ExtHostManagedSockets,It);const Kt=qe.set(o.$lL.ExtHostDecorations,lt.get(q.$mhc)),yt=qe.set(o.$lL.ExtHostDocumentsAndEditors,lt.get(le.$GN)),wt=qe.set(o.$lL.ExtHostCommands,lt.get(v.$RN)),Dt=qe.set(o.$lL.ExtHostTerminalService,lt.get($t.$1gc)),be=qe.set(o.$lL.ExtHostDebugService,lt.get(G.$ghc)),Te=qe.set(o.$lL.ExtHostSearch,lt.get(We.$Chc)),ae=qe.set(o.$lL.ExtHostTask,lt.get(ct.$6hc)),Q=qe.set(o.$lL.ExtHostOutputService,lt.get(H.$Shc)),Pe=qe.set(o.$lL.ExtHostLocalization,lt.get(ge.$9gc)),je=qe.set(o.$lL.ExtHostUrls,new xt.$dic(qe)),Ze=qe.set(o.$lL.ExtHostDocuments,new se.$cgc(qe,yt)),Je=qe.set(o.$lL.ExtHostDocumentContentProviders,new N.$ohc(qe,yt,ft)),at=qe.set(o.$lL.ExtHostDocumentSaveParticipant,new W.$phc(ft,Ze,qe.getProxy(o.$kL.MainThreadBulkEdits))),mt=qe.set(o.$lL.ExtHostNotebook,new he.$Fhc(qe,wt,yt,Ze,ei,Te)),Ft=qe.set(o.$lL.ExtHostNotebookDocuments,new Ce.$Mhc(mt)),Gt=qe.set(o.$lL.ExtHostNotebookEditors,new de.$Nhc(ft,mt)),St=qe.set(o.$lL.ExtHostNotebookKernels,new ye.$Ohc(qe,pt,mt,wt,ft)),Jt=qe.set(o.$lL.ExtHostNotebookRenderers,new T.$Qhc(qe,mt)),Ci=qe.set(o.$lL.ExtHostNotebookDocumentSaveParticipant,new fe.$Lhc(ft,mt,qe.getProxy(o.$kL.MainThreadBulkEdits))),Bt=qe.set(o.$lL.ExtHostEditors,new X.$tgc(qe,yt)),bi=qe.set(o.$lL.ExtHostTreeViews,new Qe.$bic(qe.getProxy(o.$kL.MainThreadTreeViews),wt,ft)),Pi=qe.set(o.$lL.ExtHostEditorInsets,new g.$ugc(qe.getProxy(o.$kL.MainThreadEditorInsets),Bt,pt.remote)),gi=qe.set(o.$lL.ExtHostDiagnostics,new U.$ggc(qe,ft,qt,yt)),mi=qe.set(o.$lL.ExtHostLanguages,new we.$Jhc(qe,Ze,wt.converter,Lt)),ht=qe.set(o.$lL.ExtHostLanguageFeatures,new Le.$kgc(qe,Lt,Ze,wt,gi,ft,Ct,Pt)),Qi=qe.set(o.$lL.ExtHostFileSystem,new pe.$rhc(qe,ht)),oi=qe.set(o.$lL.ExtHostFileSystemEventService,new $e.$shc(qe,ft,yt)),hi=qe.set(o.$lL.ExtHostQuickOpen,(0,_.$Whc)(qe,dt,wt)),wi=qe.set(o.$lL.ExtHostSCM,new Ne.$Yhc(qe,wt,Ze,ft)),Li=qe.set(o.$lL.ExtHostQuickDiff,new Z.$Vhc(qe,Lt)),Zi=qe.set(o.$lL.ExtHostShare,new Ye.$Zhc(qe,Lt)),Ri=qe.set(o.$lL.ExtHostComments,(0,k.$vgc)(qe,wt,Ze)),yi=qe.set(o.$lL.ExtHostProgress,new B.$Uhc(qe.getProxy(o.$kL.MainThreadProgress))),Yi=qe.set(o.$lL.ExtHostLabelService,new Me.$Ihc(qe)),Ai=qe.set(o.$lL.ExtHostTheming,new ve.$$hc(qe)),$i=qe.set(o.$lL.ExtHostAuthentication,new f.$mgc(qe)),Xi=qe.set(o.$lL.ExtHostTimeline,new Be.$aic(qe,wt)),Ei=qe.set(o.$lL.ExtHostWebviews,new Nt.$Jgc(qe,pt.remote,dt,ft,Ct)),Mi=qe.set(o.$lL.ExtHostWebviewPanels,new Et.$Mgc(qe,Ei,dt)),ln=qe.set(o.$lL.ExtHostCustomEditors,new O.$Ngc(qe,Ze,zt,Ei,Mi)),Ti=qe.set(o.$lL.ExtHostWebviewViews,new Yt.$eic(qe,Ei)),di=qe.set(o.$lL.ExtHostTesting,new Y.$7hc(qe,ft,wt,yt)),hn=qe.set(o.$lL.ExtHostUriOpeners,new Wt.$cic(qe)),dn=qe.set(o.$lL.ExtHostProfileContentHandlers,new J.$Thc(qe));qe.set(o.$lL.ExtHostInteractive,new ne.$Ghc(qe,mt,yt,wt,ft));const xi=qe.set(o.$lL.ExtHostInlineChat,new V.$thc(qe,wt,Ze,ft)),Fi=qe.set(o.$lL.ExtHostChatProvider,new d.$pgc(qe,ft)),Ni=qe.set(o.$lL.ExtHostChatAgents2,new y.$qgc(qe,Fi,ft)),_i=qe.set(o.$lL.ExtHostChatVariables,new b.$rgc(qe)),ki=qe.set(o.$lL.ExtHostChat,new w.$ogc(qe)),Oi=qe.set(o.$lL.ExtHostAiRelatedInformation,new a.$bgc(qe)),fn=qe.set(o.$lL.ExtHostAiEmbeddingVector,new De.$qhc(qe)),Di=qe.set(o.$lL.ExtHostIssueReporter,new Ie.$Hhc(qe)),zi=qe.set(o.$lL.ExtHostStatusBar,new it.$3hc(qe,wt.converter)),ui=qe.set(o.$lL.ExtHostSpeech,new nt.$1hc(qe)),Si=Object.values(o.$lL);qe.assertRegistered(Si);const gn=new n.$ngc(qe,yt),ni=new P.$sgc(qe),pi=new ee.$Khc(qe,ft),Ui=new C.$nhc(qe);return u.$lgc.register(wt),function(ze,ai,ji){function _e(te){return(ue,Oe,rt)=>{const bt=te(At=>{try{ue.call(Oe,At)}catch(Ki){M.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${Ki.toString()}`,{cause:Ki})),Pt.onExtensionError(ze.identifier,Ki)}});return rt?.push(bt),bt}}const vt=function(){let te=!ze.isUnderDevelopment;function ue(){te||(ft.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Oe(rt){if(Array.isArray(rt))rt.forEach(Oe);else if(typeof rt=="string")ue();else{const bt=rt;typeof bt.scheme>"u"&&ue(),typeof bt.exclusive=="boolean"&&(0,Xe.$LF)(ze,"documentFiltersExclusive")}return rt}}(),en={getSession(te,ue,Oe){return $i.getSession(ze,te,ue,Oe)},getSessions(te,ue){return(0,Xe.$LF)(ze,"authGetSessions"),$i.getSessions(ze,te,ue)},async hasSession(te,ue){return(0,Xe.$LF)(ze,"authSession"),!!await $i.getSession(ze,te,ue,{silent:!0})},get onDidChangeSessions(){return _e($i.onDidChangeSessions)},registerAuthenticationProvider(te,ue,Oe,rt){return $i.registerAuthenticationProvider(te,ue,Oe,rt)}},mn={registerCommand(te,ue,Oe){return wt.registerCommand(!0,te,ue,Oe,void 0,ze)},registerTextEditorCommand(te,ue,Oe){return wt.registerCommand(!0,te,(...rt)=>{const bt=Bt.getActiveTextEditor();if(!bt){ft.warn("Cannot execute "+te+" because there is no active text editor.");return}return bt.edit(At=>{ue.apply(Oe,[bt,At,...rt])}).then(At=>{At||ft.warn("Edits from command "+te+" were not applied.")},At=>{ft.warn("An error occurred while running command "+te,At)})},void 0,void 0,ze)},registerDiffInformationCommand:(te,ue,Oe)=>((0,Xe.$LF)(ze,"diffCommand"),wt.registerCommand(!0,te,async(...rt)=>{const bt=yt.activeEditor(!0);if(!bt){ft.warn("Cannot execute "+te+" because there is no active text editor.");return}const At=await Bt.getDiffInformation(bt.id);ue.apply(Oe,[At,...rt])},void 0,void 0,ze)),executeCommand(te,...ue){return wt.executeCommand(te,...ue)},getCommands(te=!1){return wt.getCommands(te)}},tn={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return ni.value},get shell(){return Dt.getDefaultShell(!1)},get onDidChangeShell(){return _e(Dt.onDidChangeShell)},get isTelemetryEnabled(){return Pt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return _e(Pt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$LF)(ze,"telemetry"),Pt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$LF)(ze,"telemetry"),_e(Pt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Ue.$ON)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,ue){return Ue.$NN.validateSender(te),Pt.instantiateLogger(ze,te,ue)},openExternal(te,ue){return Ut.openUri(te,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===pt.environment.appUriScheme)return je.createAppUri(te);try{return await Ut.asExternalUri(te,{allowTunneling:!!pt.remote.authority})}catch(ue){if((0,L.$fg)(te,L.Schemas.http)||(0,L.$fg)(te,L.Schemas.https))return te;throw ue}},get remoteName(){return(0,c.$dl)(pt.remote.authority)},get remoteAuthority(){return(0,Xe.$LF)(ze,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return _e(ft.onDidChangeLogLevel)},registerIssueUriRequestHandler(te){return(0,Xe.$LF)(ze,"handleIssueUri"),Di.registerIssueUriRequestHandler(ze,te)},registerIssueDataProvider(te){return(0,Xe.$LF)(ze,"handleIssueUri"),Di.registerIssueDataProvider(ze,te)},get appQuality(){return(0,Xe.$LF)(ze,"resolvers"),pt.quality},get appCommit(){return(0,Xe.$LF)(ze,"resolvers"),pt.commit}};pt.environment.extensionTestsLocationURI||Object.freeze(tn);const nn={createTestController(te,ue,Oe){return di.createTestController(ze,te,ue,Oe)},createTestObserver(){return(0,Xe.$LF)(ze,"testObserver"),di.createTestObserver()},runTests(te){return(0,Xe.$LF)(ze,"testObserver"),di.runTests(te)},get onDidChangeTestResults(){return(0,Xe.$LF)(ze,"testObserver"),_e(di.onResultsChanged)},get testResults(){return(0,Xe.$LF)(ze,"testObserver"),di.results}},vi=pt.remote.isRemote?Fe.ExtensionKind.Workspace:Fe.ExtensionKind.UI,rn={getExtension(te,ue){(0,Xe.$KF)(ze,"extensionsAny")||(ue=!1);const Oe=ai.mine.getExtensionDescription(te);if(Oe)return new ce.$chc(kt,ze.identifier,Oe,vi,!1);if(ue){const rt=ai.all.getExtensionDescription(te);if(rt)return new ce.$chc(kt,ze.identifier,rt,vi,!0)}},get all(){const te=[];for(const ue of ai.mine.getAllExtensionDescriptions())te.push(new ce.$chc(kt,ze.identifier,ue,vi,!1));return te},get allAcrossExtensionHosts(){(0,Xe.$LF)(ze,"extensionsAny");const te=new $.$om(ai.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ue=[];for(const Oe of ai.all.getAllExtensionDescriptions()){const rt=!te.has(Oe.identifier);ue.push(new ce.$chc(kt,ze.identifier,Oe,vi,rt))}return ue},get onDidChange(){return(0,Xe.$KF)(ze,"extensionsAny")?_e(I.Event.any(ai.mine.onDidChange,ai.all.onDidChange)):_e(ai.mine.onDidChange)}},sn={createDiagnosticCollection(te){return gi.createDiagnosticCollection(ze.identifier,te)},get onDidChangeDiagnostics(){return _e(gi.onDidChangeDiagnostics)},getDiagnostics:te=>gi.getDiagnostics(te),getLanguages(){return mi.getLanguages()},setTextDocumentLanguage(te,ue){return mi.changeLanguage(te.uri,ue)},match(te,ue){const Oe=Ze.getDocumentData(ue.uri)?.notebook;return(0,A.$Dt)(ot.LanguageSelector.from(te),ue.uri,ue.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(te,ue,Oe){return ht.registerCodeActionProvider(ze,vt(te),ue,Oe)},registerDocumentPasteEditProvider(te,ue,Oe){return(0,Xe.$LF)(ze,"documentPaste"),ht.registerDocumentPasteEditProvider(ze,vt(te),ue,Oe)},registerCodeLensProvider(te,ue){return ht.registerCodeLensProvider(ze,vt(te),ue)},registerDefinitionProvider(te,ue){return ht.registerDefinitionProvider(ze,vt(te),ue)},registerDeclarationProvider(te,ue){return ht.registerDeclarationProvider(ze,vt(te),ue)},registerImplementationProvider(te,ue){return ht.registerImplementationProvider(ze,vt(te),ue)},registerTypeDefinitionProvider(te,ue){return ht.registerTypeDefinitionProvider(ze,vt(te),ue)},registerHoverProvider(te,ue){return ht.registerHoverProvider(ze,vt(te),ue,ze.identifier)},registerEvaluatableExpressionProvider(te,ue){return ht.registerEvaluatableExpressionProvider(ze,vt(te),ue,ze.identifier)},registerInlineValuesProvider(te,ue){return ht.registerInlineValuesProvider(ze,vt(te),ue,ze.identifier)},registerDocumentHighlightProvider(te,ue){return ht.registerDocumentHighlightProvider(ze,vt(te),ue)},registerMultiDocumentHighlightProvider(te,ue){return ht.registerMultiDocumentHighlightProvider(ze,vt(te),ue)},registerLinkedEditingRangeProvider(te,ue){return ht.registerLinkedEditingRangeProvider(ze,vt(te),ue)},registerReferenceProvider(te,ue){return ht.registerReferenceProvider(ze,vt(te),ue)},registerRenameProvider(te,ue){return ht.registerRenameProvider(ze,vt(te),ue)},registerDocumentSymbolProvider(te,ue,Oe){return ht.registerDocumentSymbolProvider(ze,vt(te),ue,Oe)},registerWorkspaceSymbolProvider(te){return ht.registerWorkspaceSymbolProvider(ze,te)},registerDocumentFormattingEditProvider(te,ue){return ht.registerDocumentFormattingEditProvider(ze,vt(te),ue)},registerDocumentRangeFormattingEditProvider(te,ue){return ht.registerDocumentRangeFormattingEditProvider(ze,vt(te),ue)},registerOnTypeFormattingEditProvider(te,ue,Oe,...rt){return ht.registerOnTypeFormattingEditProvider(ze,vt(te),ue,[Oe].concat(rt))},registerDocumentSemanticTokensProvider(te,ue,Oe){return ht.registerDocumentSemanticTokensProvider(ze,vt(te),ue,Oe)},registerDocumentRangeSemanticTokensProvider(te,ue,Oe){return ht.registerDocumentRangeSemanticTokensProvider(ze,vt(te),ue,Oe)},registerSignatureHelpProvider(te,ue,Oe,...rt){return typeof Oe=="object"?ht.registerSignatureHelpProvider(ze,vt(te),ue,Oe):ht.registerSignatureHelpProvider(ze,vt(te),ue,typeof Oe>"u"?[]:[Oe,...rt])},registerCompletionItemProvider(te,ue,...Oe){return ht.registerCompletionItemProvider(ze,vt(te),ue,Oe)},registerInlineCompletionItemProvider(te,ue,Oe){return ue.handleDidShowCompletionItem&&(0,Xe.$LF)(ze,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$LF)(ze,"inlineCompletionsAdditions"),Oe&&(0,Xe.$LF)(ze,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(ze,vt(te),ue,Oe)},registerDocumentLinkProvider(te,ue){return ht.registerDocumentLinkProvider(ze,vt(te),ue)},registerColorProvider(te,ue){return ht.registerColorProvider(ze,vt(te),ue)},registerFoldingRangeProvider(te,ue){return ht.registerFoldingRangeProvider(ze,vt(te),ue)},registerSelectionRangeProvider(te,ue){return ht.registerSelectionRangeProvider(ze,te,ue)},registerCallHierarchyProvider(te,ue){return ht.registerCallHierarchyProvider(ze,te,ue)},registerTypeHierarchyProvider(te,ue){return ht.registerTypeHierarchyProvider(ze,te,ue)},setLanguageConfiguration:(te,ue)=>ht.setLanguageConfiguration(ze,te,ue),getTokenInformationAtPosition(te,ue){return(0,Xe.$LF)(ze,"tokenInformation"),mi.tokenAtPosition(te,ue)},registerInlayHintsProvider(te,ue){return ht.registerInlayHintsProvider(ze,te,ue)},createLanguageStatusItem(te,ue){return mi.createLanguageStatusItem(ze,te,ue)},registerDocumentDropEditProvider(te,ue,Oe){return ht.registerDocumentOnDropEditProvider(ze,te,ue,(0,Xe.$KF)(ze,"dropMetadata")?Oe:void 0)}},on={get activeTextEditor(){return Bt.getActiveTextEditor()},get visibleTextEditors(){return Bt.getVisibleTextEditors()},get activeTerminal(){return Dt.activeTerminal},get terminals(){return Dt.terminals},async showTextDocument(te,ue,Oe){h.URI.isUri(te)&&te.scheme===L.Schemas.vscodeRemote&&!te.authority&&Ct.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const rt=await(h.URI.isUri(te)?Promise.resolve(an.openTextDocument(te)):Promise.resolve(te));return Bt.showTextDocument(rt,ue,Oe)},createTextEditorDecorationType(te){return Bt.createTextEditorDecorationType(ze,te)},onDidChangeActiveTextEditor(te,ue,Oe){return _e(Bt.onDidChangeActiveTextEditor)(te,ue,Oe)},onDidChangeVisibleTextEditors(te,ue,Oe){return _e(Bt.onDidChangeVisibleTextEditors)(te,ue,Oe)},onDidChangeTextEditorSelection(te,ue,Oe){return _e(Bt.onDidChangeTextEditorSelection)(te,ue,Oe)},onDidChangeTextEditorOptions(te,ue,Oe){return _e(Bt.onDidChangeTextEditorOptions)(te,ue,Oe)},onDidChangeTextEditorVisibleRanges(te,ue,Oe){return _e(Bt.onDidChangeTextEditorVisibleRanges)(te,ue,Oe)},onDidChangeTextEditorViewColumn(te,ue,Oe){return _e(Bt.onDidChangeTextEditorViewColumn)(te,ue,Oe)},onDidCloseTerminal(te,ue,Oe){return _e(Dt.onDidCloseTerminal)(te,ue,Oe)},onDidOpenTerminal(te,ue,Oe){return _e(Dt.onDidOpenTerminal)(te,ue,Oe)},onDidChangeActiveTerminal(te,ue,Oe){return _e(Dt.onDidChangeActiveTerminal)(te,ue,Oe)},onDidChangeTerminalDimensions(te,ue,Oe){return(0,Xe.$LF)(ze,"terminalDimensions"),_e(Dt.onDidChangeTerminalDimensions)(te,ue,Oe)},onDidChangeTerminalState(te,ue,Oe){return _e(Dt.onDidChangeTerminalState)(te,ue,Oe)},onDidWriteTerminalData(te,ue,Oe){return(0,Xe.$LF)(ze,"terminalDataWriteEvent"),_e(Dt.onDidWriteTerminalData)(te,ue,Oe)},onDidExecuteTerminalCommand(te,ue,Oe){return(0,Xe.$LF)(ze,"terminalExecuteCommandEvent"),_e(Dt.onDidExecuteTerminalCommand)(te,ue,Oe)},get state(){return Ut.getState(ze)},onDidChangeWindowState(te,ue,Oe){return _e(Ut.onDidChangeWindowState)(te,ue,Oe)},showInformationMessage(te,...ue){return pi.showMessage(ze,m.default.Info,te,ue[0],ue.slice(1))},showWarningMessage(te,...ue){return pi.showMessage(ze,m.default.Warning,te,ue[0],ue.slice(1))},showErrorMessage(te,...ue){return pi.showMessage(ze,m.default.Error,te,ue[0],ue.slice(1))},showQuickPick(te,ue,Oe){return hi.showQuickPick(ze,te,ue,Oe)},showWorkspaceFolderPick(te){return hi.showWorkspaceFolderPick(te)},showInputBox(te,ue){return hi.showInput(te,ue)},showOpenDialog(te){return Ui.showOpenDialog(ze,te)},showSaveDialog(te){return Ui.showSaveDialog(te)},createStatusBarItem(te,ue,Oe){let rt,bt,At;return typeof te=="string"?(rt=te,bt=ue,At=Oe):(bt=te,At=ue),zi.createStatusBarEntry(ze,rt,bt,At)},setStatusBarMessage(te,ue){return zi.setStatusBarMessage(te,ue)},withScmProgress(te){return Ct.report("window.withScmProgress",ze,"Use 'withProgress' instead."),yi.withProgress(ze,{location:Fe.ProgressLocation.SourceControl},(ue,Oe)=>te({report(rt){}}))},withProgress(te,ue){return yi.withProgress(ze,te,ue)},createOutputChannel(te,ue){return Q.createOutputChannel(te,ue,ze)},createWebviewPanel(te,ue,Oe,rt){return Mi.createWebviewPanel(ze,te,ue,Oe,rt)},createWebviewTextEditorInset(te,ue,Oe,rt){return(0,Xe.$LF)(ze,"editorInsets"),Pi.createWebviewEditorInset(te,ue,Oe,rt,ze)},createTerminal(te,ue,Oe){return typeof te=="object"?"pty"in te?Dt.createExtensionTerminal(te):Dt.createTerminalFromOptions(te):Dt.createTerminal(te,ue,Oe)},registerTerminalLinkProvider(te){return Dt.registerLinkProvider(te)},registerTerminalProfileProvider(te,ue){return Dt.registerProfileProvider(ze,te,ue)},registerTerminalQuickFixProvider(te,ue){return(0,Xe.$LF)(ze,"terminalQuickFixProvider"),Dt.registerTerminalQuickFixProvider(te,ze.identifier.value,ue)},registerTreeDataProvider(te,ue){return bi.registerTreeDataProvider(te,ue,ze)},createTreeView(te,ue){return bi.createTreeView(te,ue,ze)},registerWebviewPanelSerializer:(te,ue)=>Mi.registerWebviewPanelSerializer(ze,te,ue),registerCustomEditorProvider:(te,ue,Oe={})=>ln.registerCustomEditorProvider(ze,te,ue,Oe),registerFileDecorationProvider(te){return Kt.registerFileDecorationProvider(te,ze)},registerUriHandler(te){return je.registerUriHandler(ze,te)},createQuickPick(){return hi.createQuickPick(ze)},createInputBox(){return hi.createInputBox(ze)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(te,ue,Oe){return _e(Ai.onDidChangeActiveColorTheme)(te,ue,Oe)},registerWebviewViewProvider(te,ue,Oe){return Ti.registerWebviewViewProvider(ze,te,ue,Oe?.webviewOptions)},get activeNotebookEditor(){return mt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,ue,Oe){return _e(mt.onDidChangeActiveNotebookEditor)(te,ue,Oe)},get visibleNotebookEditors(){return mt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return _e(mt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(te,ue,Oe){return _e(Gt.onDidChangeNotebookEditorSelection)(te,ue,Oe)},onDidChangeNotebookEditorVisibleRanges(te,ue,Oe){return _e(Gt.onDidChangeNotebookEditorVisibleRanges)(te,ue,Oe)},showNotebookDocument(te,ue){return mt.showNotebookDocument(te,ue)},registerExternalUriOpener(te,ue,Oe){return(0,Xe.$LF)(ze,"externalUriOpener"),hn.registerExternalUriOpener(ze.identifier,te,ue,Oe)},registerProfileContentHandler(te,ue){return(0,Xe.$LF)(ze,"profileContentHandlers"),dn.registerProfileContentHandler(ze,te,ue)},registerQuickDiffProvider(te,ue,Oe,rt){return(0,Xe.$LF)(ze,"quickDiffProvider"),Li.registerQuickDiffProvider(vt(te),ue,Oe,rt)},get tabGroups(){return jt.tabGroups},registerShareProvider(te,ue){return(0,Xe.$LF)(ze,"shareProvider"),Zi.registerShareProvider(vt(te),ue)}},an={get rootPath(){return Ct.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(te){throw new M.$9("rootPath")},getWorkspaceFolder(te){return dt.getWorkspaceFolder(te)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(te){throw new M.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(te){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(te,ue,...Oe)=>dt.updateWorkspaceFolders(ze,te,ue||0,...Oe),onDidChangeWorkspaceFolders:function(te,ue,Oe){return _e(dt.onDidChangeWorkspace)(te,ue,Oe)},asRelativePath:(te,ue)=>dt.getRelativePath(te,ue),findFiles:(te,ue,Oe,rt)=>dt.findFiles(te,ue,Oe,ze.identifier,rt),findTextInFiles:(te,ue,Oe,rt)=>{(0,Xe.$LF)(ze,"findTextInFiles");let bt,At;return typeof ue=="object"?(bt=ue,At=Oe):(bt={},At=ue,rt=Oe),dt.findTextInFiles(te,bt||{},At,ze.identifier,rt)},save:te=>dt.save(te),saveAs:te=>dt.saveAs(te),saveAll:te=>dt.saveAll(te),applyEdit(te,ue){return gn.applyWorkspaceEdit(te,ze,ue)},createFileSystemWatcher:(te,ue,Oe,rt)=>{let bt;return typeof ue=="boolean"?bt={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!rt,correlate:!1}:ue&&((0,Xe.$LF)(ze,"createFileSystemWatcher"),bt={...ue,correlate:!0}),oi.createFileSystemWatcher(dt,ze,te,bt)},get textDocuments(){return Ze.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new M.$9("textDocuments")},openTextDocument(te){let ue;const Oe=te;if(typeof te=="string")ue=Promise.resolve(h.URI.file(te));else if(h.URI.isUri(te))ue=Promise.resolve(te);else if(!Oe||typeof Oe=="object")ue=Ze.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(rt=>(rt.scheme===L.Schemas.vscodeRemote&&!rt.authority&&Ct.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),Ze.ensureDocumentData(rt).then(bt=>bt.document)))},onDidOpenTextDocument:(te,ue,Oe)=>_e(Ze.onDidAddDocument)(te,ue,Oe),onDidCloseTextDocument:(te,ue,Oe)=>_e(Ze.onDidRemoveDocument)(te,ue,Oe),onDidChangeTextDocument:(te,ue,Oe)=>_e(Ze.onDidChangeDocument)(te,ue,Oe),onDidSaveTextDocument:(te,ue,Oe)=>_e(Ze.onDidSaveDocument)(te,ue,Oe),onWillSaveTextDocument:(te,ue,Oe)=>_e(at.getOnWillSaveTextDocumentEvent(ze))(te,ue,Oe),get notebookDocuments(){return mt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,ue){let Oe;if(h.URI.isUri(te))Oe=te,await mt.openNotebookDocument(te);else if(typeof te=="string")Oe=h.URI.revive(await mt.createNotebookDocument({viewType:te,content:ue}));else throw new Error("Invalid arguments");return mt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(te,ue,Oe){return _e(Ft.onDidSaveNotebookDocument)(te,ue,Oe)},onDidChangeNotebookDocument(te,ue,Oe){return _e(Ft.onDidChangeNotebookDocument)(te,ue,Oe)},onWillSaveNotebookDocument(te,ue,Oe){return _e(Ci.getOnWillSaveNotebookDocumentEvent(ze))(te,ue,Oe)},get onDidOpenNotebookDocument(){return _e(mt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return _e(mt.onDidCloseNotebookDocument)},registerNotebookSerializer(te,ue,Oe,rt){return mt.registerNotebookSerializer(ze,te,ue,Oe,(0,Xe.$KF)(ze,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,ue,Oe)=>_e(ji.onDidChangeConfiguration)(te,ue,Oe),getConfiguration(te,ue){return ue=arguments.length===1?void 0:ue,ji.getConfiguration(te,ue,ze)},registerTextDocumentContentProvider(te,ue){return Je.registerTextDocumentContentProvider(te,ue)},registerTaskProvider:(te,ue)=>(Ct.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),ae.registerTaskProvider(ze,te,ue)),registerFileSystemProvider(te,ue,Oe){return(0,R.$Qc)(Qi.registerFileSystemProvider(ze,te,ue,Oe),ei.addFileSystemProvider(te,ue,Oe))},get fs(){return ei.value},registerFileSearchProvider:(te,ue)=>((0,Xe.$LF)(ze,"fileSearchProvider"),Te.registerFileSearchProvider(te,ue)),registerTextSearchProvider:(te,ue)=>((0,Xe.$LF)(ze,"textSearchProvider"),Te.registerTextSearchProvider(te,ue)),registerRemoteAuthorityResolver:(te,ue)=>((0,Xe.$LF)(ze,"resolvers"),kt.registerRemoteAuthorityResolver(te,ue)),registerResourceLabelFormatter:te=>((0,Xe.$LF)(ze,"resolvers"),Yi.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Xe.$LF)(ze,"resolvers"),kt.getRemoteExecServer(te)),onDidCreateFiles:(te,ue,Oe)=>_e(oi.onDidCreateFile)(te,ue,Oe),onDidDeleteFiles:(te,ue,Oe)=>_e(oi.onDidDeleteFile)(te,ue,Oe),onDidRenameFiles:(te,ue,Oe)=>_e(oi.onDidRenameFile)(te,ue,Oe),onWillCreateFiles:(te,ue,Oe)=>_e(oi.getOnWillCreateFileEvent(ze))(te,ue,Oe),onWillDeleteFiles:(te,ue,Oe)=>_e(oi.getOnWillDeleteFileEvent(ze))(te,ue,Oe),onWillRenameFiles:(te,ue,Oe)=>_e(oi.getOnWillRenameFileEvent(ze))(te,ue,Oe),openTunnel:te=>((0,Xe.$LF)(ze,"tunnels"),Rt.openTunnel(ze,te).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Xe.$LF)(ze,"tunnels"),Rt.getTunnels()},onDidChangeTunnels:(te,ue,Oe)=>((0,Xe.$LF)(ze,"tunnels"),_e(Rt.onDidChangeTunnels)(te,ue,Oe)),registerPortAttributesProvider:(te,ue)=>((0,Xe.$LF)(ze,"portsAttributes"),Rt.registerPortsAttributesProvider(te,ue)),registerTunnelProvider:(te,ue)=>((0,Xe.$LF)(ze,"tunnelFactory"),Rt.registerTunnelProvider(te,ue)),registerTimelineProvider:(te,ue)=>((0,Xe.$LF)(ze,"timeline"),Xi.registerTimelineProvider(te,ue,ze.identifier,wt.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:te=>((0,Xe.$LF)(ze,"workspaceTrust"),dt.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,ue,Oe)=>_e(dt.onDidGrantWorkspaceTrust)(te,ue,Oe),registerEditSessionIdentityProvider:(te,ue)=>((0,Xe.$LF)(ze,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(te,ue)),onWillCreateEditSessionIdentity:(te,ue,Oe)=>((0,Xe.$LF)(ze,"editSessionIdentityProvider"),_e(dt.getOnWillCreateEditSessionIdentityEvent(ze))(te,ue,Oe)),registerCanonicalUriProvider:(te,ue)=>((0,Xe.$LF)(ze,"canonicalUriProvider"),dt.registerCanonicalUriProvider(te,ue)),getCanonicalUri:(te,ue,Oe)=>((0,Xe.$LF)(ze,"canonicalUriProvider"),dt.provideCanonicalUri(te,ue,Oe))},$n={get inputBox(){return Ct.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),wi.getLastInputBox(ze)},createSourceControl(te,ue,Oe){return wi.createSourceControl(ze,te,ue,Oe)}},cn={createCommentController(te,ue){return Ri.createCommentController(ze,te,ue)}},un={get activeDebugSession(){return be.activeDebugSession},get activeDebugConsole(){return be.activeDebugConsole},get breakpoints(){return be.breakpoints},get stackFrameFocus(){return be.stackFrameFocus},registerDebugVisualizationProvider(te,ue){return(0,Xe.$LF)(ze,"debugVisualization"),be.registerDebugVisualizationProvider(ze,te,ue)},onDidStartDebugSession(te,ue,Oe){return _e(be.onDidStartDebugSession)(te,ue,Oe)},onDidTerminateDebugSession(te,ue,Oe){return _e(be.onDidTerminateDebugSession)(te,ue,Oe)},onDidChangeActiveDebugSession(te,ue,Oe){return _e(be.onDidChangeActiveDebugSession)(te,ue,Oe)},onDidReceiveDebugSessionCustomEvent(te,ue,Oe){return _e(be.onDidReceiveDebugSessionCustomEvent)(te,ue,Oe)},onDidChangeBreakpoints(te,ue,Oe){return _e(be.onDidChangeBreakpoints)(te,ue,Oe)},onDidChangeStackFrameFocus(te,ue,Oe){return(0,Xe.$LF)(ze,"debugFocus"),_e(be.onDidChangeStackFrameFocus)(te,ue,Oe)},registerDebugConfigurationProvider(te,ue,Oe){return be.registerDebugConfigurationProvider(te,ue,Oe||Qt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,ue){return be.registerDebugAdapterDescriptorFactory(ze,te,ue)},registerDebugAdapterTrackerFactory(te,ue){return be.registerDebugAdapterTrackerFactory(te,ue)},startDebugging(te,ue,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?be.startDebugging(te,ue,{parentSession:Oe}):be.startDebugging(te,ue,Oe||{})},stopDebugging(te){return be.stopDebugging(te)},addBreakpoints(te){return be.addBreakpoints(te)},removeBreakpoints(te){return be.removeBreakpoints(te)},asDebugSourceUri(te,ue){return be.asDebugSourceUri(te,ue)}},Bi={registerTaskProvider:(te,ue)=>ae.registerTaskProvider(ze,te,ue),fetchTasks:te=>ae.fetchTasks(te),executeTask:te=>ae.executeTask(ze,te),get taskExecutions(){return ae.taskExecutions},onDidStartTask:(te,ue,Oe)=>_e(ae.onDidStartTask)(te,ue,Oe),onDidEndTask:(te,ue,Oe)=>_e(ae.onDidEndTask)(te,ue,Oe),onDidStartTaskProcess:(te,ue,Oe)=>_e(ae.onDidStartTaskProcess)(te,ue,Oe),onDidEndTaskProcess:(te,ue,Oe)=>_e(ae.onDidEndTaskProcess)(te,ue,Oe)},Wi={createNotebookController(te,ue,Oe,rt,bt){return St.createNotebookController(ze,te,ue,Oe,rt,(0,Xe.$KF)(ze,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(te,ue)=>mt.registerNotebookCellStatusBarItemProvider(ze,te,ue),createRendererMessaging(te){return Jt.createRendererMessaging(ze,te)},createNotebookControllerDetectionTask(te){return(0,Xe.$LF)(ze,"notebookKernelSource"),St.createNotebookControllerDetectionTask(ze,te)},registerKernelSourceActionProvider(te,ue){return(0,Xe.$LF)(ze,"notebookKernelSource"),St.registerKernelSourceActionProvider(ze,te,ue)},onDidChangeNotebookCellExecutionState(te,ue,Oe){return(0,Xe.$LF)(ze,"notebookCellExecutionState"),_e(St.onDidChangeNotebookCellExecutionState)(te,ue,Oe)}},Vi={t(...te){if(typeof te[0]=="string"){const ue=te.shift(),Oe=!te||typeof te[0]!="object"?te:te[0];return Pe.getMessage(ze.identifier.value,{message:ue,args:Oe})}return Pe.getMessage(ze.identifier.value,te[0])},get bundle(){return Pe.getBundle(ze.identifier.value)},get uri(){return Pe.getBundleUri(ze.identifier.value)}},Ii={_version:1,registerInteractiveEditorSessionProvider(te,ue){return(0,Xe.$LF)(ze,"interactive"),xi.registerProvider(ze,te,ue)},registerInteractiveSessionProvider(te,ue){return(0,Xe.$LF)(ze,"interactive"),ki.registerChatProvider(ze,te,ue)},sendInteractiveRequestToProvider(te,ue){return(0,Xe.$LF)(ze,"interactive"),ki.sendInteractiveRequestToProvider(te,ue)},transferChatSession(te,ue){return(0,Xe.$LF)(ze,"interactive"),ki.transferChatSession(te,ue)}},qi={getRelatedInformation(te,ue){return(0,Xe.$LF)(ze,"aiRelatedInformation"),Oi.getRelatedInformation(ze,te,ue)},registerRelatedInformationProvider(te,ue){return(0,Xe.$LF)(ze,"aiRelatedInformation"),Oi.registerRelatedInformationProvider(ze,te,ue)},registerEmbeddingVectorProvider(te,ue){return(0,Xe.$LF)(ze,"aiRelatedInformation"),fn.registerEmbeddingVectorProvider(ze,te,ue)}},Hi={registerChatResponseProvider(te,ue,Oe){return(0,Xe.$LF)(ze,"chatProvider"),Fi.registerProvider(ze.identifier,te,ue,Oe)},requestChatAccess(te){return(0,Xe.$LF)(ze,"chatRequestAccess"),Fi.requestChatResponseProvider(ze.identifier,te)},registerVariable(te,ue,Oe){return(0,Xe.$LF)(ze,"chatAgents2"),_i.registerVariableResolver(ze,te,ue,Oe)},registerMappedEditsProvider(te,ue){return(0,Xe.$LF)(ze,"mappedEditsProvider"),ht.registerMappedEditsProvider(ze,te,ue)},createChatAgent(te,ue){return(0,Xe.$LF)(ze,"chatAgents2"),Ni.createChatAgent(ze,te,ue)}},pn={registerSpeechProvider(te,ue){return(0,Xe.$LF)(ze,"speech"),ui.registerProvider(ze.identifier,te,ue)}};return{version:pt.version,ai:qi,authentication:en,commands:mn,comments:cn,chat:Hi,debug:un,env:tn,extensions:rn,interactive:Ii,l10n:Vi,languages:sn,notebooks:Wi,scm:$n,speech:pn,tasks:Bi,tests:nn,window:on,workspace:an,Breakpoint:Fe.$lM,TerminalOutputAnchor:Fe.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Fe.ChatAgentResultFeedbackKind,ChatMessage:Fe.$eN,ChatMessageRole:Fe.ChatMessageRole,ChatVariableLevel:Fe.ChatVariableLevel,ChatAgentCompletionItem:Fe.$dN,CallHierarchyIncomingCall:Fe.$KL,CallHierarchyItem:Fe.$JL,CallHierarchyOutgoingCall:Fe.$LL,CancellationError:M.$5,CancellationTokenSource:S.$7d,CandidatePortSource:o.CandidatePortSource,CodeAction:Fe.$GL,CodeActionKind:Fe.$HL,CodeActionTriggerKind:Fe.CodeActionTriggerKind,CodeLens:Fe.$ML,Color:Fe.$ZL,ColorInformation:Fe.$1L,ColorPresentation:Fe.$2L,ColorThemeKind:Fe.ColorThemeKind,CommentMode:Fe.CommentMode,CommentState:Fe.CommentState,CommentThreadCollapsibleState:Fe.CommentThreadCollapsibleState,CommentThreadState:Fe.CommentThreadState,CompletionItem:Fe.$TL,CompletionItemKind:Fe.CompletionItemKind,CompletionItemTag:Fe.CompletionItemTag,CompletionList:Fe.$UL,CompletionTriggerKind:Fe.CompletionTriggerKind,ConfigurationTarget:Fe.ConfigurationTarget,CustomExecution:Fe.$0L,DebugAdapterExecutable:Fe.$pM,DebugAdapterInlineImplementation:Fe.$sM,DebugAdapterNamedPipeServer:Fe.$rM,DebugAdapterServer:Fe.$qM,DebugConfigurationProviderTriggerKind:Qt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Fe.DebugConsoleMode,DebugVisualization:Fe.$HM,DecorationRangeBehavior:Fe.DecorationRangeBehavior,Diagnostic:Fe.$AL,DiagnosticRelatedInformation:Fe.$zL,DiagnosticSeverity:Fe.DiagnosticSeverity,DiagnosticTag:Fe.DiagnosticTag,Disposable:Fe.$mL,DocumentHighlight:Fe.$CL,DocumentHighlightKind:Fe.DocumentHighlightKind,MultiDocumentHighlight:Fe.$DL,DocumentLink:Fe.$YL,DocumentSymbol:Fe.$FL,EndOfLine:Fe.EndOfLine,EnvironmentVariableMutatorType:Fe.EnvironmentVariableMutatorType,EvaluatableExpression:Fe.$vM,InlineValueText:Fe.$wM,InlineValueVariableLookup:Fe.$xM,InlineValueEvaluatableExpression:Fe.$yM,InlineCompletionTriggerKind:Fe.InlineCompletionTriggerKind,EventEmitter:I.$Wd,ExtensionKind:Fe.ExtensionKind,ExtensionMode:Fe.ExtensionMode,ExternalUriOpenerPriority:Fe.ExternalUriOpenerPriority,FileChangeType:Fe.FileChangeType,FileDecoration:Fe.$JM,FileDecoration2:Fe.$JM,FileSystemError:Fe.$AM,FileType:p.FileType,FilePermission:p.FilePermission,FoldingRange:Fe.$BM,FoldingRangeKind:Fe.FoldingRangeKind,FunctionBreakpoint:Fe.$nM,InlineCompletionItem:Fe.$VL,InlineCompletionList:Fe.$WL,Hover:Fe.$BL,IndentAction:D.IndentAction,Location:Fe.$yL,MarkdownString:Fe.$NL,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Fe.$OL,PortAutoForwardAction:Fe.PortAutoForwardAction,Position:Fe.$nL,ProcessExecution:Fe.$8L,ProgressLocation:Fe.ProgressLocation,QuickInputButtons:Fe.$IM,Range:Fe.$oL,RelativePattern:Fe.$jM,Selection:Fe.$pL,SelectionRange:Fe.$IL,SemanticTokens:Fe.$EM,SemanticTokensBuilder:Fe.$DM,SemanticTokensEdit:Fe.$FM,SemanticTokensEdits:Fe.$GM,SemanticTokensLegend:Fe.$CM,ShellExecution:Fe.$9L,ShellQuoting:Fe.ShellQuoting,SignatureHelp:Fe.$QL,SignatureHelpTriggerKind:Fe.SignatureHelpTriggerKind,SignatureInformation:Fe.$PL,SnippetString:Fe.$xL,SourceBreakpoint:Fe.$mM,StandardTokenType:Fe.StandardTokenType,StatusBarAlignment:Fe.StatusBarAlignment,SymbolInformation:Fe.$EL,SymbolKind:Fe.SymbolKind,SymbolTag:Fe.SymbolTag,Task:Fe.$$L,TaskGroup:Fe.$7L,TaskPanelKind:Fe.TaskPanelKind,TaskRevealKind:Fe.TaskRevealKind,TaskScope:Fe.TaskScope,TerminalLink:Fe.$3L,TerminalQuickFixTerminalCommand:Fe.$5L,TerminalQuickFixOpener:Fe.$4L,TerminalLocation:Fe.TerminalLocation,TerminalProfile:Fe.$6L,TerminalExitReason:Fe.TerminalExitReason,TextDocumentSaveReason:Fe.TextDocumentSaveReason,TextEdit:Fe.$tL,SnippetTextEdit:Fe.$vL,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:Fe.TextEditorLineNumbersStyle,TextEditorRevealType:Fe.TextEditorRevealType,TextEditorSelectionChangeKind:Fe.TextEditorSelectionChangeKind,SyntaxTokenType:Fe.SyntaxTokenType,TextDocumentChangeReason:Fe.TextDocumentChangeReason,ThemeColor:Fe.$iM,ThemeIcon:Fe.$hM,TreeItem:Fe.$_L,TreeItemCheckboxState:Fe.TreeItemCheckboxState,TreeItemCollapsibleState:Fe.TreeItemCollapsibleState,TypeHierarchyItem:Fe.$5M,UIKind:Vt.UIKind,Uri:h.URI,ViewColumn:Fe.ViewColumn,WorkspaceEdit:Fe.$wL,DocumentDropEdit:Fe.$fM,DocumentPasteEdit:Fe.$gM,InlayHint:Fe.$SL,InlayHintLabelPart:Fe.$RL,InlayHintKind:Fe.InlayHintKind,RemoteAuthorityResolverError:Fe.$sL,ResolvedAuthority:Fe.$qL,ManagedResolvedAuthority:Fe.$rL,SourceControlInputBoxValidationType:Fe.SourceControlInputBoxValidationType,ExtensionRuntime:Fe.ExtensionRuntime,TimelineItem:Fe.$TM,NotebookRange:Fe.$LM,NotebookCellKind:Fe.NotebookCellKind,NotebookCellExecutionState:Fe.NotebookCellExecutionState,NotebookCellData:Fe.$MM,NotebookData:Fe.$NM,NotebookRendererScript:Fe.$RM,NotebookCellStatusBarAlignment:Fe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Fe.NotebookEditorRevealType,NotebookCellOutput:Fe.$PM,NotebookCellOutputItem:Fe.$OM,NotebookCellStatusBarItem:Fe.$QM,NotebookControllerAffinity:Fe.NotebookControllerAffinity,NotebookControllerAffinity2:Fe.NotebookControllerAffinity2,NotebookEdit:Fe.$uL,NotebookKernelSourceAction:Fe.$SM,NotebookVariablesRequestKind:Fe.NotebookVariablesRequestKind,PortAttributes:Fe.$VM,LinkedEditingRanges:Fe.$UM,TestResultState:Fe.TestResultState,TestRunRequest:Fe.$WM,TestMessage:Fe.$XM,TestMessage2:Fe.$XM,TestTag:Fe.$YM,TestRunProfileKind:Fe.TestRunProfileKind,TextSearchCompleteMessageType:Xt.TextSearchCompleteMessageType,DataTransfer:Fe.$eM,DataTransferItem:Fe.$aM,CoveredCount:Fe.$ZM,FileCoverage:Fe.$1M,StatementCoverage:Fe.$2M,BranchCoverage:Fe.$3M,FunctionCoverage:Fe.$4M,WorkspaceTrustState:Fe.WorkspaceTrustState,LanguageStatusSeverity:Fe.LanguageStatusSeverity,QuickPickItemKind:Fe.QuickPickItemKind,InputBoxValidationSeverity:Fe.InputBoxValidationSeverity,TabInputText:Fe.$6M,TabInputTextDiff:Fe.$7M,TabInputTextMerge:Fe.$8M,TabInputCustom:Fe.$9M,TabInputNotebook:Fe.$$M,TabInputNotebookDiff:Fe.$_M,TabInputWebview:Fe.$0M,TabInputTerminal:Fe.$aN,TabInputInteractiveWindow:Fe.$bN,TabInputChat:Fe.$cN,TelemetryTrustedValue:s.$No,LogLevel:r.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Fe.InteractiveSessionVoteDirection,ChatAgentCopyKind:Fe.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Fe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Fe.$tM,ThreadFocus:Fe.$uM,RelatedInformationType:Fe.RelatedInformationType,SpeechToTextStatus:Fe.SpeechToTextStatus,KeywordRecognitionStatus:Fe.KeywordRecognitionStatus,ChatResponseTextPart:Fe.$fN,ChatResponseMarkdownPart:Fe.$gN,ChatResponseFilesPart:Fe.$hN,ChatResponseAnchorPart:Fe.$iN,ChatResponseProgressPart:Fe.$jN,ChatResponseReferencePart:Fe.$kN}}}e.$hic=_t}),define(Re[292],Ae([1,0,53,112,36,107,37,31,66,65,115,117,118,82,85,78,106,62,43,81,60,64,228,13,116,79,80]),function(me,e,S,M,I,R,L,m,h,E,A,D,l,$,p,r,c,s,i,o,a,u,t,f,n,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.$1r)(w.$9gc,w.$8gc,1),(0,S.$1r)(f.$qj,t.$iic,1),(0,S.$1r)(r.$hgc,r.$igc,1),(0,S.$1r)(m.$RN,m.$QN,0),(0,S.$1r)(L.$Cgc,L.$Agc,0),(0,S.$1r)(s.$Egc,s.$Dgc,0),(0,S.$1r)(D.$ghc,D.$khc,0),(0,S.$1r)(R.$mhc,R.$lhc,0),(0,S.$1r)(h.$GN,h.$FN,0),(0,S.$1r)(y.$0gc,y.$$gc,0),(0,S.$1r)(i.$egc,i.$dgc,0),(0,S.$1r)(M.$Shc,M.$Rhc,1),(0,S.$1r)(l.$Chc,l.$Dhc,0),(0,S.$1r)($.$Xgc,$.$Wgc,0),(0,S.$1r)(A.$6hc,A.$5hc,0),(0,S.$1r)(E.$1gc,E.$4gc,0),(0,S.$1r)(p.$qzb,p.$rzb,0),(0,S.$1r)(c.$gic,c.$fic,0),(0,S.$1r)(I.$zgc,I.$ygc,0),(0,S.$1r)(o.$6gc,o.$5gc,0),(0,S.$1r)(a.$PN,a.$MN,0),(0,S.$1r)(u.$Ogc,u.$Pgc,0),(0,S.$1r)(n.$ehc,n.$fhc,0)}),define(Re[293],Ae([1,0,291,38,2,288,7,11,234]),function(me,e,S,M,I,R,L,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=void 0;class E extends R.$lic{j(){}getModule($,p){for(const r of this.b){const c=r($);if(c){$=c;break}}if(this.a.has($))return this.a.get($).load($,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends M.$ahc{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(h.$skc);const $=this.h.invokeFunction(S.$hic);this.r=this.h.createInstance(E,$,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub($){return $.browser}async vb($,p,r){p=p.with({path:D(p.path,".js")});const c=$?.identifier.value;c&&performance.mark(`code/extHost/willFetchExtensionCode/${c}`);const s=I.URI.revive(await this.C.$asBrowserUri(p)),i=await fetch(s.toString(!0));if(c&&performance.mark(`code/extHost/didFetchExtensionCode/${c}`),i.status!==200)throw new Error(i.statusText);const o=await i.text(),a=`${p.toString(!0)}#vscode-extension`,u=`${o}
//# sourceURL=${a}`;let t;try{t=new Function("module","exports","require",u)}catch(y){throw console.error(c?`Loading code for extension ${c} failed: ${y.message}`:`Loading code failed: ${y.message}`),console.error(`${p.toString(!0)}${typeof y.line=="number"?` line ${y.line}`:""}${typeof y.column=="number"?` column ${y.column}`:""}`),console.error(y),y}$&&await this.w.initializeLocalizedMessages($);const f={},n={exports:f},w=y=>{const d=this.r.getModule(y,p);if(d===void 0)throw new Error(`Cannot load module '${y}'`);return d};try{return r.codeLoadingStart(),c&&performance.mark(`code/extHost/willLoadExtensionCode/${c}`),t(n,f,w),n.exports!==f?n.exports:f}finally{c&&performance.mark(`code/extHost/didLoadExtensionCode/${c}`),r.codeLoadingStop()}}async $setRemoteEnvironment($){}async zb($=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+$;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,m.$9g)(10)}}e.$tkc=A;function D(l,$){return l.endsWith($)?l:l+$}}),define(Re[294],Ae([1,0,70,53,13,38,199,84,293]),function(me,e,S,M,I,R,L,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$1r)(I.$pj,new S.$5h(L.$kic,[!0],!0)),(0,M.$1r)(R.$bhc,h.$tkc,0),(0,M.$1r)(m.$Fgc,m.$Ggc,0)}),define(Re[299],Ae([1,0,23,5,77,289,236,19,87,12,2,292,294]),function(me,e,S,M,I,R,L,m,h,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function $(t){return/^(file|vscode-remote):/i.test(t)}const p=fetch.bind(self);function r(t){self.fetch=async function(f,n){return f instanceof Request||$(String(f))&&(f=(await t(A.URI.parse(String(f)))).toString(!0)),p(f,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(f,n,w,y,d){(async()=>($(n.toString())&&(n=(await t(A.URI.parse(n.toString()))).toString(!0)),super.open(f,n,w??!0,y,d)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(f,n){if(/^file:/i.test(f.toString()))f=E.$pg.uriToBrowserUri(A.URI.parse(f.toString())).toString(!0);else if(/^vscode-remote:/i.test(f.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const y=`(${function(g){function v(O){return typeof O=="string"||O instanceof URL?String(O).replace(/^file:\/\//i,"vscode-file://vscode-app"):O}const k=fetch.bind(self);self.fetch=function(O,G){return O instanceof Request?k(O,G):k(v(O),G)},self.XMLHttpRequest=class extends XMLHttpRequest{open(O,G,q,U,C){return super.open(O,v(G),q??!0,U,C)}};const F=importScripts.bind(self);self.importScripts=(...O)=>{F(...O.map(v))},F(g)}.toString()}('${f}'))`;n=n||{},n.name=`${name} -> ${n.name||m.$nc(f.toString())}`;const d=new Blob([y],{type:"application/javascript"}),b=URL.createObjectURL(d);return new t(b,n)}}else self.Worker=class extends L.$ukc{constructor(t,f){super(l,t,{name:m.$nc(t.toString()),...f})}};const c=new class{constructor(){this.pid=void 0}exit(t){D()}};class s{constructor(){const f=new MessageChannel,n=new M.$Wd;let w=!1;l(f.port2,[f.port2]),f.port1.onmessage=y=>{const{data:d}=y;if(!(d instanceof ArrayBuffer)){console.warn("UNKNOWN data received",d);return}const b=S.$ke.wrap(new Uint8Array(d,0,d.byteLength));if((0,I.$wm)(b,2)){w=!0,o("received terminate message from renderer");return}n.fire(b)},this.protocol={onMessage:n.event,send:y=>{if(!w){const d=y.buffer.buffer.slice(y.buffer.byteOffset,y.buffer.byteOffset+y.buffer.byteLength);f.port1.postMessage(d,[d])}}}}}function i(t){return new Promise(f=>{const n=t.onMessage(w=>{n.dispose();const y=JSON.parse(w.toString());t.send((0,I.$vm)(0)),f({protocol:t,initData:y})});t.send((0,I.$vm)(1))})}let o=t=>D();function a(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function u(){h.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(f){a(f)&&i(t.protocol).then(n=>{h.mark("code/extHost/didWaitForInitData");const w=new R.$nic(n.protocol,n.initData,c,null,f.data);r(y=>w.asBrowserUri(y)),o=y=>w.terminate(y)})}}}e.create=u})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9db1b0571e119289a2264971bdac75793965e063/core/vs/workbench/api/worker/extensionHostWorker.js.map
